;***************************************************************************
;*                                                                         *
;*     Z80 DisAssembler for the Amiga computer.   V1.0c    L.Davison '94   *
;*                                                                         *
;***************************************************************************

; Disassembly list of Micron1.bin

; ports used ...

KBD_R:	EQU	00h		; key matrix read port
KBD_W:	EQU	02h		; key matrix write port
LCD_D:	EQU	03h		; LCD data port
Port_04:	EQU	04h		; IRQ hardware mask
					; .... ...0 = keyboard interrupt enable
					; .... ..0. = RTC interrupt enable
					; .... .0.. = IR port interrupt enable
					; .... 0... = main battery interrupt enable
					; ...0 .... = backup battery interrupt enable
Port_05:	EQU	05h		; interrupt flag byte
					; .... ...1 = keyboard interrupt
					; .... ..1. = RTC interrupt
					; .... .1.. = IR port interrupt ??
					; .... 1... = main battery interrupt
					; ...1 .... = backup battery interrupt
Port_07:	EQU	07h		;
					; .... ...x
					; .... ..x.
RTC_A:	EQU	08h		; RTC address port
LCD_C:	EQU	23h		; LCD command port
RTC_D:	EQU	28h		; RTC data port
Port_2A:	EQU	2Ah		;
					; .... ...x
					; .... ..x.
					; ...x ....
					; ..x. ....
Port_2B:	EQU	2Bh		; .... xxxx = beep tone
					; .... 0000 = off
					; .... 0001 = 0.25mS = 4.000kHz
					; .... 0010 = 0.50mS = 2.000kHz
					; .... 0011 = 0.75mS = 1.333kHz
					; .... 0100 = 1.00mS = 1.000kHz
					; .... 0101 = 1.25mS = 0.800kHz
					; .... 0110 = 1.50mS = 0.667kHz
					; .... 0111 = 1.75mS = 0.571kHz
					; .... 1000 = 2.00mS = 0.500kHz
					; .... 1001 = 2.25mS = 0.444kHz
					; .... 1010 = 2.50mS = 0.400kHz
					; .... 1011 = 2.75mS = 0.364kHz
					; .... 1100 = 3.00mS = 0.333kHz
					; .... 1101 = 3.25mS = 0.308kHz
					; .... 1110 = 3.50mS = 0.286kHz
					; .... 1111 = 3.75mS = 0.267kHz
Port_2C:	EQU	2Ch		;
					; .... ...x V24_ADAPTER IR port clock
					; .... ..x. V24_ADAPTER IR port data
					; ...1 .... = backlight on
					; ..xx ..xx
Port_2D:	EQU	2Dh		;
					; .... ...x
					; .... ..x.
Port_33:	EQU	33h		;
Port_46:	EQU	46h		; LCD contrast port
MEM_P:	EQU	47h		; memory page
Port_48:	EQU	48h		;
					; .... ...x
					; .... ..x.
Port_49:	EQU	49h		;
					; .... ...x
					; .... ..x.
Port_4A:	EQU	4Ah		; end IR port output
					; .... ...x
					; .... ..x.
					; ...x ....
					; ..x. ....
					; .x.. ....
					; x... ....
Port_4B:	EQU	4Bh		; IR port status byte
					; .... ...1 RX buffer full
					; ...x ....
					; .x.. ....
					; 1... .... TX buffer empty
Port_4C:	EQU	4Ch		;
					; .... ...x
					; x... ....
Port_4D:	EQU	4Dh		; IR transmit byte
Port_4E:	EQU	4Eh		; IR receive byte
Port_4F:	EQU	4Fh		;
					; .... ...x
					; .... ..x.
					; .... .x..
					; .... x...
					; ...x ....

; memory used ...

LAB_D681	EQU	D681h

LAB_D770	EQU	D770h
LAB_D771	EQU	D771h
LAB_D772	EQU	D772h
LAB_D774	EQU	D774h
LAB_D825	EQU	D825h		; re-mapped address
LAB_D828	EQU	D828h		; re-mapped address
LAB_D82F	EQU	D82Fh		; re-mapped address
LAB_DC91	EQU	DC91h		; re-mapped address
LAB_DC94	EQU	DC94h		; re-mapped address
LAB_DC97	EQU	DC97h		; re-mapped address
LAB_DF74	EQU	DF74h		; does signed HL = DE MOD HL
LAB_DF81	EQU	DF81h		; do HL = ABS(DE) MOD ABS(HL), DE = ABS(DE)/ABS(HL)
					; (LAB_7ABC)

LAB_E06A	EQU	E06Ah		; does signed CP DE,HL. returns HL=1 if HL<=DE
LAB_E06B	EQU	E06Bh
LAB_E0C7	EQU	E0C7h		; re-mapped address
LAB_E0CC	EQU	E0CCh		; re-mapped address

LAB_E100	EQU	E100h
LAB_E102	EQU	E102h
LAB_E104	EQU	E104h

LAB_E22D	EQU	E22Dh		; current function # ??
LAB_E23B	EQU	E23Bh		; null term message ??
LAB_E2F8	EQU	E2F8h
LAB_E36F	EQU	E36Fh		; page call stack pointer
LAB_E370	EQU	E370h		; here to LAB_E3B0 is the page call stack
					;
					;
LAB_E3B1	EQU	E3B1h		; 4 byte result, LL byte (#_1)
LAB_E3B4	EQU	E3B4h		; 4 byte result, HH byte
LAB_E3B9	EQU	E3B9h		; 4 byte opperand (#_2)
LAB_E3BB	EQU	E3BBh
LAB_E3BD	EQU	E3BDh
LAB_E3C1	EQU	E3C1h
LAB_E3C2	EQU	E3C2h
LAB_E3C4	EQU	E3C4h
LAB_E446	EQU	E446h
LAB_E448	EQU	E448h
LAB_E44A	EQU	E44Ah
LAB_E44C	EQU	E44Ch
LAB_E44E	EQU	E44Eh
LAB_E450	EQU	E450h
LAB_E451	EQU	E451h
LAB_E452	EQU	E452h
LAB_E453	EQU	E453h
LAB_E455	EQU	E455h
LAB_E456	EQU	E456h
LAB_E457	EQU	E457h
LAB_E459	EQU	E459h

LAB_E480	EQU	E480h
LAB_E484	EQU	E484h
LAB_E488	EQU	E488h
LAB_E48A	EQU	E48Ah
LAB_E48C	EQU	E48Ch
LAB_E48D	EQU	E48Dh
LAB_E48F	EQU	E48Fh
LAB_E512	EQU	E512h
LAB_E514	EQU	E514h
LAB_E516	EQU	E516h
LAB_E518	EQU	E518h
LAB_E519	EQU	E519h
LAB_E51A	EQU	E51Ah
LAB_E51B	EQU	E51Bh
LAB_E51D	EQU	E51Dh
LAB_E51F	EQU	E51Fh
LAB_E520	EQU	E520h
LAB_E521	EQU	E521h
LAB_E523	EQU	E523h
LAB_E525	EQU	E525h
LAB_E527	EQU	E527h
LAB_E528	EQU	E528h
LAB_E52A	EQU	E52Ah
LAB_E52C	EQU	E52Ch
LAB_E52E	EQU	E52Eh

LAB_E530	EQU	E530h			; 8Ah long area
LAB_E534	EQU	E534h
LAB_E536	EQU	E536h
LAB_E538	EQU	E538h

LAB_E5BA	EQU	E5BAh			; 8Ah long area
LAB_E5BC	EQU	E5BCh
LAB_E5BE	EQU	E5BEh
LAB_E5BF	EQU	E5BFh
LAB_E5C0	EQU	E5C0h
LAB_E5C2	EQU	E5C2h
LAB_E5C4	EQU	E5C4h
LAB_E644	EQU	E644h
LAB_E646	EQU	E646h
LAB_E648	EQU	E648h
LAB_E649	EQU	E649h
LAB_E64A	EQU	E64Ah
LAB_E64C	EQU	E64Ch
LAB_E64E	EQU	E64Eh
LAB_E650	EQU	E650h
LAB_E651	EQU	E651h
LAB_E652	EQU	E652h
LAB_E653	EQU	E653h
LAB_E654	EQU	E654h
LAB_E655	EQU	E655h
LAB_E656	EQU	E656h
LAB_E658	EQU	E658h
LAB_E65A	EQU	E65Ah
LAB_E65C	EQU	E65Ch
LAB_E65D	EQU	E65Dh
LAB_E65E	EQU	E65Eh
LAB_E65F	EQU	E65Fh
LAB_E660	EQU	E660h
LAB_E661	EQU	E661h
LAB_E662	EQU	E662h
LAB_E664	EQU	E664h
LAB_E666	EQU	E666h
LAB_E667	EQU	E667h
LAB_E668	EQU	E668h
LAB_E669	EQU	E669h
LAB_E66B	EQU	E66Bh
LAB_E66D	EQU	E66Dh
LAB_E66F	EQU	E66Fh
LAB_E671	EQU	E671h
LAB_E673	EQU	E673h
LAB_E675	EQU	E675h
LAB_E677	EQU	E677h
LAB_E679	EQU	E679h
LAB_E67B	EQU	E67Bh
LAB_E67D	EQU	E67Dh
LAB_E67F	EQU	E67Fh
LAB_E681	EQU	E681h
LAB_E683	EQU	E683h
LAB_E685	EQU	E685h
LAB_E687	EQU	E687h
LAB_E689	EQU	E689h
LAB_E68D	EQU	E68Dh
LAB_E68F	EQU	E68Fh
LAB_E691	EQU	E691h		; (byte) +00h century
					; (byte) +01h year
					; (byte) +02h month
					; (byte) +03h day of month
					; (byte) +04h hours
					; (byte) +05h minutes
LAB_E697	EQU	E697h		; (byte) +06h seconds
					; (byte) +07h day of week
LAB_E699	EQU	E699h		; RTC last read seconds count
LAB_E69A	EQU	E69Ah		; RTC last saved seconds count
LAB_E69B	EQU	E69Bh		; EExxh table pointer
LAB_E69D	EQU	E69Dh		; console status byte
LAB_E69F	EQU	E69Fh		; ?? buffer (offset 00-09)
LAB_E6A9	EQU	E6A9h		; ?? pointer offset
LAB_E6AB	EQU	E6ABh
LAB_E6AC	EQU	E6ACh
LAB_E6AD	EQU	E6ADh
LAB_E6AE	EQU	E6AEh
LAB_E6AF	EQU	E6AFh

LAB_E6B1	EQU	E6B1h		;
LAB_E6B2	EQU	E6B2h		;
					; BDOS date/time registers
					; buffer is ...
LAB_E6B4	EQU	E6B4h		; (byte) +00h century
LAB_E6B5	EQU	E6B5h		; (byte) +01h year
LAB_E6B6	EQU	E6B6h		; (byte) +02h month
LAB_E6B7	EQU	E6B7h		; (byte) +03h day of month
LAB_E6B8	EQU	E6B8h		; (byte) +04h hours
LAB_E6B9	EQU	E6B9h		; (byte) +05h minutes
					; (byte) +06h seconds
					; (byte) +07h day of week

LAB_E6BC	EQU	E6BCh		;
LAB_E6BE	EQU	E6BEh		;
LAB_E6C0	EQU	E6C0h		;
LAB_E6C2	EQU	E6C2h		;
LAB_E6C4	EQU	E6C4h		;
LAB_E6CC	EQU	E6CCh		;
LAB_E6CD	EQU	E6CDh		;
LAB_E6CF	EQU	E6CFh		;
LAB_E6D0	EQU	E6D0h		;
LAB_E6D8	EQU	E6D8h		;
LAB_E6D9	EQU	E6D9h		;
LAB_E6E1	EQU	E6E1h		;
LAB_E6E2	EQU	E6E2h		;
LAB_E6E4	EQU	E6E4h		;
LAB_E6E6	EQU	E6E6h		;
LAB_E6E8	EQU	E6E8h		;
LAB_E6EE	EQU	E6EEh		;
LAB_E6EF	EQU	E6EFh		;
LAB_E6F7	EQU	E6F7h		;
LAB_E6F8	EQU	E6F8h		;
LAB_E6FA	EQU	E6FAh		;
LAB_E6FC	EQU	E6FCh		;
LAB_E6FD	EQU	E6FDh		; timeout delay seconds
LAB_E6FF	EQU	E6FFh		;
LAB_E701	EQU	E701h		;
LAB_E703	EQU	E703h		;

LAB_E8E2	EQU	E8E2h		; base of 4*29h buffers
LAB_E986	EQU	E986h		; end+1 of 4*29h buffers
LAB_E98A	EQU	E98Ah		; pointer to 4*29h buffers

LAB_EA4B	EQU	EA4Bh		; (byte) cursor Y position
LAB_EA4C	EQU	EA4Ch		; (byte) cursor X position

LAB_EC8A	EQU	EC8Ah		; (word) 00E5h
LAB_EC8C	EQU	EC8Ch		; (word) FF1Ah

LAB_EF88	EQU	EF88h		;

LAB_F118	EQU	F118h		; send BELL character to console
LAB_F11C	EQU	F11Ch		; clear screen area
LAB_F120	EQU	F120h		; set cursor blink on/off
LAB_F138	EQU	F138h		; does nothing
LAB_F13C	EQU	F13Ch		; set cursor on/off
LAB_F140	EQU	F140h		; re-mapped address
LAB_F14C	EQU	F14Ch		; set cursor x,y
LAB_F180	EQU	F180h		; BDOS function handler
LAB_F1A3	EQU	F1A3h		; re-mapped address
LAB_F1C6	EQU	F1C6h		; re-mapped address
LAB_F1EF	EQU	F1EFh		; re-mapped address
LAB_F206	EQU	F206h		; re-mapped address
LAB_F2C4	EQU	F2C4h		; re-mapped address
LAB_F382	EQU	F382h		; re-mapped address
LAB_F4C6	EQU	F4C6h		; copy sector BC to/from (HL) ??
					; if Cb=0=from (read) else Cb=1=to (write)
LAB_F54E	EQU	F54Eh		; re-mapped address
LAB_F558	EQU	F558h		; re-mapped address
LAB_F5E1	EQU	F5E1h		; re-mapped address
LAB_F5EA	EQU	F5EAh		; re-mapped address
LAB_F5ED	EQU	F5EDh		; re-mapped address
LAB_F5EE	EQU	F5EEh
LAB_F5F0	EQU	F5F0h		; re-mapped address
LAB_F5F3	EQU	F5F3h		; IRQ routine address
LAB_F5F6	EQU	F5F6h		; NMI routine address
LAB_F780	EQU	F780h		; ?? (byte)
KBD_Buff	EQU	F782h		; KBD_W buffer
LAB_F784	EQU	F784h		; Port_04 buffer,	interrupt enables (39h)
LAB_F785	EQU	F785h		; Port_05 copy,	interupt flags (00h)
LAB_F786	EQU	F786h		; Port_07 buffer (39h)
LAB_F78B	EQU	F78Bh		; Port_2A buffer (00h)
LAB_F78D	EQU	F78Dh		; Port_2C buffer (00h)
LAB_F791	EQU	F791h		; Port_47 buffer,	current memory page
LAB_F792	EQU	F792h		; Port_48 buffer
LAB_F794	EQU	F794h		; Port_4A buffer,	end IR port output
LAB_F796	EQU	F796h		; Port_4C buffer
LAB_F797	EQU	F797h		; Port_4D buffer,	IR transmit byte
LAB_F799	EQU	F799h		;
LAB_F81C	EQU	F81Ch		; setup status
LAB_F81D	EQU	F81Dh		; HLP pressed flag byte (not used!)
LAB_F81E	EQU	F81Eh		; ?? (word) (0002h)
LAB_F820	EQU	F820h		; ?? (word) (0008h)
LAB_F822	EQU	F822h		; ?? (byte) (03h)
LAB_F823	EQU	F823h		; ?? (word) (00BEh)
LAB_F825	EQU	F825h		; ?? (byte) (3Fh)
LAB_F826	EQU	F826h		; ?? (word) (003Fh)
LAB_F828	EQU	F828h		; ?? (word) (0007h)
LAB_F82A	EQU	F82Ah		; ?? (byte) (06h)
LAB_F82C	EQU	F82Ch		; ?? (word) (0002h)
LAB_F82E	EQU	F82Eh		; 80h byte area
					; (03h,00h then 00h until F8ADh)
					; ...
LAB_F8AE	EQU	F8AEh		; # of RAM banks (06h)
LAB_F8AF	EQU	F8AFh		; first RAM bank # ?? (byte) (03h)
LAB_F8B0	EQU	F8B0h		; ?? (word) RDOS 1st sector offset ?? (0100h)
LAB_F8B2	EQU	F8B2h		; (word) sectors in last page				[00FEh]
LAB_F8B4	EQU	F8B4h		; (word) total sectors in RAMdisk			[05F4h]
LAB_F8B6	EQU	F8B6h		; (word) last mem page size ??			[8000h]
LAB_F8B8	EQU	F8B8h		; 80h byte area
					; filled with EAh
					; ...
LAB_F938	EQU	F938h		; (word) (0002h)
LAB_F93A	EQU	F93Ah		; (word) (0000h)
LAB_F93C	EQU	F93Ch		; (byte) (00h)
LAB_F93D	EQU	F93Dh		; (byte) (00h)
LAB_F93E	EQU	F93Eh		; (byte) (06h)
LAB_F93F	EQU	F93Fh		; (word) (06C0h)
LAB_F941	EQU	F941h		; (byte) (BEh)
LAB_F942	EQU	F942h		; buffer to LAB_F94D
					; buffer is ...
					; (byte) ??
					; ...
LAB_F94E	EQU	F94Eh		;
LAB_F950	EQU	F950h		;
LAB_F951	EQU	F951h		;
LAB_F952	EQU	F952h		;
LAB_F953	EQU	F953h		;
LAB_F954	EQU	F954h		; next ?? out pointer (F95Eh)
LAB_F956	EQU	F956h		; next ?? in pointer  (F95Eh)
LAB_F95C	EQU	F95Ch		; byte buffer
					; ....
LAB_F978	EQU	F978h		; (word) (FE83h)
LAB_F97A	EQU	F97Ah		; (byte)
LAB_F97B	EQU	F97Bh		; (byte) (04h)
					; .... ...x
					; .... .x..
LAB_F97C	EQU	F97Ch		; (byte) (80h)
LAB_F97E	EQU	F97Eh		; (byte) error code ? (7Eh)
LAB_F980	EQU	F980h		; (word) seems to be always 0006h
LAB_F982	EQU	F982h		; (word) seems to be always 0000h
LAB_F984	EQU	F984h		; (word) seems to be always 0000h
LAB_F98C	EQU	F98Ch		; (word) seems to be always 0007h
LAB_F990	EQU	F990h		;
LAB_F994	EQU	F994h		; (word)
LAB_F996	EQU	F996h		; (byte)
LAB_F998	EQU	F998h		;
LAB_F999	EQU	F999h		;
LAB_F9A2	EQU	F9A2h		; RTC register buffer, 8 bytes
					; buffer is ...
					; (byte) +00h century
					; (byte) +01h year
					; (byte) +02h month
					; (byte) +03h day of month
					; (byte) +04h hours
					; (byte) +05h minutes
					; (byte) +06h seconds
					; (byte) +07h day of week

LAB_F9AA	EQU	F9AAh		;
LAB_F9AB	EQU	F9ABh		;
LAB_F9AC	EQU	F9ACh		; (word) long count
LAB_F9AE	EQU	F9AEh		; (word) ??3 countdown time
LAB_F9B0	EQU	F9B0h		; (word)
LAB_F9B2	EQU	F9B2h		; default ??3 countdown time (0005h)
LAB_F9B4	EQU	F9B4h		;
LAB_FBB5	EQU	FBB5h		;
LAB_FBB6	EQU	FBB6h		;
LAB_FBB7	EQU	FBB7h		;
LAB_FBB9	EQU	FBB9h		;
LAB_FBBB	EQU	FBBBh		;
LAB_FBBC	EQU	FBBCh		;
LAB_FBBD	EQU	FBBDh		;
LAB_FBBF	EQU	FBBFh		; (byte)
LAB_FBC0	EQU	FBC0h		; (byte) (D7h)
LAB_FBC1	EQU	FBC1h		; (byte) (02h)
LAB_FBC2	EQU	FBC2h		; (word) vector to ?? (1567h)
LAB_FBC4	EQU	FBC4h		; (byte) (00h)
LAB_FBC5	EQU	FBC5h		; (00h)
LAB_FBC6	EQU	FBC6h		; (byte) current disk ?? (00h)
LAB_FBC7	EQU	FBC7h		; beep duration (01h)
LAB_FBC8	EQU	FBC8h		; beep tone (07h)
LAB_FBC9	EQU	FBC9h		; interrupt flag byte (00h)
					; xxxx xxx1 = 
					; xxxx xx1x = RTC alarm happened
					; xxxx x1xx = key press happened
					; xxxx 1xxx = RTC timebase happened
LAB_FBCA	EQU	FBCAh		; interrupt flag mask byte (07h)
LAB_FBCB	EQU	FBCBh		; (00h)
LAB_FBCC	EQU	FBCCh		; (word) ?? count
LAB_FBCE	EQU	FBCEh		; (word) go to sleep count
LAB_FBD0	EQU	FBD0h		; (word) sleep mode stack pointer buffer (F816h)
LAB_FBD2	EQU	FBD2h		; (word) temp stack buffer ?? (2C04h)
LAB_FBD4	EQU	FBD4h		; (03h)
LAB_FBD5	EQU	FBD5h		; (00h) ??
LAB_FBD6	EQU	FBD6h		; (word) go to sleep default count (0F00h)
LAB_FBD8	EQU	FBD8h		; (04h)
LAB_FBDA	EQU	FBDAh		; (word) key table base address (1B58h)
LAB_FBDC	EQU	FBDCh		; cursor blink flag (0/1 = blink/no blink)
LAB_FBDD	EQU	FBDDh		; key mode byte
LAB_FBDE	EQU	FBDEh		; matrix scan result
LAB_FBDF	EQU	FBDFh		; (word) key repeat timer count (1/32nd second)
LAB_FBE5	EQU	FBE5h		; (byte) key repeat n count
LAB_FBE6	EQU	FBE6h		; (byte) key repeat max count
LAB_FBE7	EQU	FBE7h		; decoded matrix scan byte
LAB_FBE8	EQU	FBE8h		; key buffer start
LAB_FBED	EQU	FBEDh		; key buffer end
LAB_FBEE	EQU	FBEEh		; key buffer next in
LAB_FBF0	EQU	FBF0h		; key buffer next out
LAB_FBF2	EQU	FBF2h
					; display attributes area
LAB_FBF3	EQU	FBF3h		; escape mode flag ?? (00h)
LAB_FBF4	EQU	FBF4h		; cursor y position (06h)
LAB_FBF5	EQU	FBF5h		; cursor x position (01h)
LAB_FBF6	EQU	FBF6h		; escape X mode flag ?? (FFh)
LAB_FBF7	EQU	FBF7h		; escape Y mode flag ?? (00h)
LAB_FBF8	EQU	FBF8h		; (7Eh)
LAB_FBF9	EQU	FBF9h		; (00h)
LAB_FBFA	EQU	FBFAh		; (00h)
					; display attributes buffer area
LAB_FBFB	EQU	FBFBh		; (00h)
LAB_FBFC	EQU	FBFCh		; cursor y position (00h)
LAB_FBFD	EQU	FBFDh		; cursor x position (00h)
LAB_FBFE	EQU	FBFEh		; (00h)
LAB_FBFF	EQU	FBFFh		; (00h)
LAB_FC00	EQU	FC00h		; (00h)
LAB_FC01	EQU	FC01h		; (00h)
LAB_FC03	EQU	FC03h		; (byte) (00h)
LAB_FC04	EQU	FC04h		; (00h)

LAB_FC05	EQU	FC05h		; LCD contrast byte (70h)
LAB_FC06	EQU	FC06h		; display buffer 1 (A0h bytes)
LAB_FCA6	EQU	FCA6h		; display buffer 2 (A0h bytes)
LAB_FD46	EQU	FD46h		;
LAB_FD47	EQU	FD47h		;
LAB_FD4A	EQU	FD4Ah		;
LAB_FD4B	EQU	FD4Bh		; saved date
LAB_FD4C	EQU	FD4Ch		; saved month
LAB_FD4D	EQU	FD4Dh		; (word)
LAB_FD4F	EQU	FD4Fh		;
LAB_FD50	EQU	FD50h		; RTC time/date buffer (to FD59)
					; buffer is ...
					; (byte) +00h seconds
					; (byte) +01h seconds alarm
					; (byte) +02h minutes
					; (byte) +03h minutes alarm
					; (byte) +04h hours
					; (byte) +05h hours alarm
LAB_FD56	EQU	FD56h		; (byte) +06h day of week
LAB_FD57	EQU	FD57h		; (byte) +07h day of month
					; (byte) +08h month
					; (byte) +09h year

LAB_FD5B	EQU	FD5Bh		; RTC service table position
LAB_FD5C	EQU	FD5Ch		; timer countdown table (to LAB_FD83)
					; 10d entries are ...
					; (word) count pointer
					; (word) routine vector

LAB_FD84	EQU	FD84h		; interrupt vector table
					; 01h
					; LAB_18F0		; scan keyboard matrix ??
					; 02
					; LAB_2206		; check RTC interrupt flags
					; 04
					; LAB_31B6		; IR port interrupt routine ??
					; 08
					; LAB_2365		; main battery warning ??
					; 10
					; LAB_2365		; backup battery warning ??
LAB_FD93	EQU	FD93h		; 00			; setup later
LAB_FD94	EQU	FD94h		; LAB_0000		; setup later
					; 80			; end marker
LAB_FD97	EQU	FD97h		; (word) compare date/month (300 second count)
LAB_FD99	EQU	FD99h		; (word) restore LCD display (5 second count)
LAB_FD9B	EQU	FD9Bh		; RTC date copy
LAB_FD9C	EQU	FD9Ch		; RTC month copy
LAB_FD9D	EQU	FD9Dh		; ?? date
LAB_FD9E	EQU	FD9Eh		; ?? month
LAB_FD9F	EQU	FD9Fh		; (word) 60 second timebase
LAB_FDA1	EQU	FDA1h		;
LAB_FDA2	EQU	FDA2h		; (byte) main battery terminal count flag
LAB_FDA3	EQU	FDA3h		; main battery fail flag/count
LAB_FDA4	EQU	FDA4h		; (word) main battery fail (400 second count)
LAB_FDA6	EQU	FDA6h		; (word)
LAB_FDA8	EQU	FDA8h		; RTC test interrupt count word
LAB_FDAB	EQU	FDABh		; ROM 0 checksum (ACF8h)
LAB_FDAD	EQU	FDADh		; ROM 1 checksum (2E12h)
LAB_FDAF	EQU	FDAFh		; port 48h/49h status flag (00h)
LAB_FDB0	EQU	FDB0h		; upper 32k RAM error byte (00h)
LAB_FDB1	EQU	FDB1h		; (FFh)
LAB_FDB2	EQU	FDB2h		; bank select status flags (00h)
LAB_FDB3	EQU	FDB3h		; ROM 0 test result (00h)
LAB_FDB4	EQU	FDB4h		; ROM 1 test result (00h)
LAB_FDB5	EQU	FDB5h		; clock test status flags (00h)
LAB_FDB6	EQU	FDB6h		; powerdown test status flags (00h)
LAB_FDB7	EQU	FDB7h		; (FFh)
LAB_FDB8	EQU	FDB8h		; (00h)
LAB_FDB9	EQU	FDB9h		; (00h)
LAB_FDBA	EQU	FDBAh		; (F57Eh)
LAB_FDBD	EQU	FDBDh		;
LAB_FDBE	EQU	FDBEh		;
LAB_FDBF	EQU	FDBFh		; ?? countdown time (seconds)
LAB_FDC0	EQU	FDC0h		;
LAB_FDC1	EQU	FDC1h		; (word) ?? count
LAB_FDC5	EQU	FDC5h		;
LAB_FDC7	EQU	FDC7h		;
LAB_FDC9	EQU	FDC9h		;
LAB_FDCA	EQU	FDCAh		;
LAB_FDCB	EQU	FDCBh		;
LAB_FDCE	EQU	FDCEh		; (word) ??1 countdown timer
LAB_FDD2	EQU	FDD2h		;
LAB_FDD4	EQU	FDD4h		; receive block expected ?? byte
LAB_FDD5	EQU	FDD5h		;
LAB_FDD6	EQU	FDD6h		;
LAB_FDD7	EQU	FDD7h		;
LAB_FDD8	EQU	FDD8h		; default ??1 countdown time
LAB_FDDC	EQU	FDDCh		; (LAB_FE32) (LAB_FE0E) (FE0Eh)

LAB_FDE4	EQU	FDE4h		; 6 byte header for IR receive
LAB_FDE6	EQU	FDE6h		;
LAB_FDE7	EQU	FDE7h		;

LAB_FDEC	EQU	FDECh		; IR tx table pointer (FDDEh)
LAB_FDEE	EQU	FDEEh		;
LAB_FDF0	EQU	FDF0h		;
LAB_FDF2	EQU	FDF2h		;
LAB_FE10	EQU	FE10h		;
LAB_FE14	EQU	FE14h		;
LAB_FE32	EQU	FE32h		; (0009h)
LAB_FE34	EQU	FE34h		; (FE3Ah)
LAB_FE36	EQU	FE36h		; (0000h)
LAB_FE3C	EQU	FE3Ch		;

LAB_FEA3	EQU	FEA3h		; (13h)
LAB_FEA4	EQU	FEA4h		; (byte) (00h)
LAB_FEA5	EQU	FEA5h		; (word) BEEP counter
LAB_FEA6	EQU	FEA6h		; (01h)
LAB_FEA7	EQU	FEA7h		; first RAM bank # (02h)
LAB_FEA8	EQU	FEA8h		; last RAM bank # (09h)
LAB_FEA9	EQU	FEA9h		; (byte) (08h)
LAB_FEAA	EQU	FEAAh		; (byte) (08h)
LAB_FEAB	EQU	FEABh		; contig RAM size KB (word) (0100h)
LAB_FEAD	EQU	FEADh		; full RAM size KB (word) (0100h)
LAB_FEAF	EQU	FEAFh		; upper 32k RAM test result byte (FFh)
LAB_FEB0	EQU	FEB0h		; start of lower RAM page test result bytes
LAB_FEB1	EQU	FEB1h		;
LAB_FEF6	EQU	FEF6h		;
LAB_FEF8	EQU	FEF8h		;
LAB_FEF9	EQU	FEF9h		;
LAB_FEFA	EQU	FEFAh		;
LAB_FEFC	EQU	FEFCh		; error number (06h)
LAB_FEFD	EQU	FEFDh		; error type (00h)
LAB_FEFE	EQU	FEFEh		; temp memory page buffer
LAB_FEFF	EQU	FEFFh		; 80h byte buffer (to LAB_FF7E inclusive)
					; buffer is ...
					; ...
LAB_FF7F	EQU	FF7Fh		; FCB buffer (to LAB_FFA2 inclusive)
					; buffer is ...
					; (byte) DR
					; (byte) 08h bytes F1 ... F8 text
					; (byte) 03h bytes T1 ... T3 text
					; (byte) EX
					; (byte) 02h bytes S1, S2 (reserved)
					; (byte) RC
					; (byte) 10h bytes AL
					; (byte) CR
					; (byte) 03h bytes R0... R2
					; ...

; The bytes in it have the following meanings: 

; FCB+00h DR - Drive. 0 for default, 1-16 for A-P. In DOSPLUS,
;              bit 7 can be set to indicate that the operation should work with
;              subdirectories rather than files.
           
; FCB+01h Fn - Filename, 7-bit ASCII. The top bits of the filename bytes
;              (usually referred to as F1' to F8') have the following
;              meanings:
;                F1'-F4' - User-defined attributes. Any program can use
;                          them in any way it likes. The filename in the
;                          disc directory has the corresponding bits set.
;                F5'-F8' - Interface attributes. They modify the 
;                          behaviour of various BDOS functions or 
;                          indicate error conditions. In the directory
;                          these bits are always zero.
; FCB+09h Tn - Filetype, 7-bit ASCII. T1' to T3' have the following
;              meanings:
;                T1' - Read-Only. 
;                T2' - System (hidden). System files in user 0 can be
;                      opened from other user areas.
;                T3' - Archive. Set if the file has not been changed
;                      since it was last copied.
; FCB+0Ch EX - Set this to 0 when opening a file and then leave it to
;              CP/M. You can rewind a file by setting EX, RC, S2 and CR to 0.
; FCB+0Dh S1 - Reserved.   
; FCB+0Eh S2 - Reserved.
; FCB+0Fh RC - Set this to 0 when opening a file and then leave it to
;              CP/M.
; FCB+10h AL - Image of the second half of the directory entry,
;              containing the file's allocation (which disc blocks it
;              owns).
; FCB+20h CR - Current record within extent. It is usually best to set 
;              this to 0 immediately after a file has been opened and 
;              then ignore it.
; FCB+21h Rn - Random access record number (not CP/M 1). A 16-bit 
;              value in CP/M 2 (with R2 used for overflow).

LAB_FFA3	EQU	FFA3h		; (word) DMA address
LAB_FFA5	EQU	FFA5h		; (word) FCB pointer for current file
LAB_FFA8	EQU	FFA8h		; interrupts setup ?? flag (00h)

; start of code

	ORG	0000h
LAB_0000
	DB	C3h			; JP opcode
LAB_0001
	DW	LAB_0103		; default jump address
LAB_0003
	NOP				;0003:	00
	NOP				;0004:	00
LAB_0005
	DB	C3h			; JP opcode
LAB_0006
	DW	LAB_F180		; default jump address (BDOS function handler)

LAB_0008
	JP	LAB_F5E1		;0008:	C3E1F5

	ORG	0010h

; call banked subroutine

LAB_0010
	POP	HL			; pop return address
	LD	E,(HL)		; get next byte after RST (page #)
	LD	A,(LAB_F791)	; get current memory page
	CP	E			; compare with byte
	JP	NZ,LAB_D74B		; jump if not the same page (LAB_70FA)

	INC	HL			; else point to routine address
	LD	A,(HL)		; get subroutine address low byte
	INC	HL			; increment pointer
	LD	H,(HL)		; get subroutine address high byte
	LD	L,A			; copy subroutine address low byte to L
	JP	(HL)			; go do subroutine

	ORG	0020h

LAB_0020
	JP	LAB_F5EA		;0020:	C3EAF5

	ORG	0028h

LAB_0028
	JP	LAB_F5ED		;0028:	C3EDF5 (LAB_3B0A)

	ORG	0030h

LAB_0030
	JP	LAB_F5F0		;0030:	C3F0F5

	ORG	0038h

; IRQ entry point

LAB_0038
	JP	LAB_F5F3		; jump to IRQ routine in RAM

	ORG	0040h

LAB_0040
	LD	A,#00h		; clear A
	OUT	(MEM_P),A		; reset memory page
	JP	LAB_3BAA		; copies block to RAM then executes it

	ORG	0066h

; NMI vector

LAB_0066
	JP	LAB_F5F6	; jump to RAM (LAB_3B13)

	ORG	0080h

LAB_0080
	JP	LAB_2189		; save DE & HL in RTC interrupt table
					; return carry set if not saved
	JP	LAB_168F	;0083:	C38F16
LAB_0086
	RET				;

LAB_0087
	EI			;0087:	FB

LAB_0088
	DB	00h,00h,00h,00h,00h,00h,00h,00h
LAB_0090
	JP	LAB_3277	;0090:	C37732
LAB_0093
	JP	LAB_2ED3	;0093:	C3D32E
LAB_0096
	JP	LAB_2EAB	;0096:	C3AB2E
LAB_0099
	JP	LAB_2F1A	;0099:	C31A2F
LAB_009C
	JP	LAB_00A1	;009C:	C3A100
LAB_009F
	RET				;

LAB_00A0
	DB	FDh,C9h		;00A0:	FDC9

	ORG	0100h

LAB_0100
	JP	LAB_014B		;0100:	C34B01

; reset enters here...

LAB_0103
	JP	LAB_014B		;0103:	C34B01
LAB_0106
	JP	LAB_F2F8		;0106:	C3F8F2 (LAB_3815) error # 03h
LAB_0109
	JP	LAB_F303		;0109:	C303F3 (LAB_3820) error # 06h
LAB_010C
	JP	LAB_F30E		;010C:	C30EF3 (LAB_382B) error # 09h
LAB_010F
	JP	LAB_F280		;010F:	C380F2 (LAB_379D) error # 0Ch
LAB_0112
	JP	LAB_F285		;0112:	C385F2 (LAB_37A2) error # 0Fh
LAB_0115
	JP	LAB_F28A		;0115:	C38AF2 (LAB_37A7) error # 12h
LAB_0118
	JP	LAB_F28F		;0118:	C38FF2 (LAB_37AC) error # 15h
LAB_011B
	JP	LAB_F294		;011B:	C394F2 (LAB_37B1) error # 18h
LAB_011E
	JP	LAB_F299		;011E:	C399F2 (LAB_37B6) error # 1Bh
LAB_0121
	JP	LAB_F29E		;0121:	C39EF2 (LAB_37BB) error # 1Eh
LAB_0124
	JP	LAB_F319		;0124:	C319F3 (LAB_3836) error # 21h
LAB_0127
	JP	LAB_F2A3		;0127:	C3A3F2 (LAB_37C0) error # 24h
LAB_012A
	JP	LAB_F2A8		;012A:	C3A8F2 (LAB_37C5) error # 27h
LAB_012D
	JP	LAB_F2AD		;012D:	C3ADF2 (LAB_37CA) error # 2Ah
LAB_0130
	JP	LAB_F2B2		;0130:	C3B2F2 (LAB_37CF) error # 2Dh
LAB_0133
	JP	LAB_F34A		;0133:	C34AF3 (LAB_3867) error # 30h
LAB_0136
	JP	LAB_F355		;0136:	C355F3 (LAB_3872) error # 33h
LAB_0139
	JP	LAB_F32F		;0139:	C32FF3 (LAB_384C) error # 36h
LAB_013C
	JP	LAB_F33F		;013C:	C33FF3 (LAB_385C) error # 39h
LAB_013F
	JP	LAB_F41B		; set memory page A & enable interrupts (LAB_3938)
LAB_0142
	JP	LAB_F324		;0142:	C324F3 (LAB_3841) error # 3Fh
LAB_0145
	JP	LAB_F360		;0145:	C360F3 (LAB_387D) error # 42h
LAB_0148
	JP	LAB_F36B		;0148:	C36BF3 (LAB_3888) error # 45h

; reset eventually gets here ...

LAB_014B
	DI				; disable interrupts
	LD	HL,(LAB_FBD0)	; get sleep mode stack value
	LD	SP,HL			; set stack
	IM	1			; set interrupt mode 1

	LD	A,#20h		; set byte
	OUT	(Port_2A),A		; set initial Port_2A value ??

	LD	BC,0FA0h		; short delay
LAB_0159
	NOP				; loop pad byte
	DEC	BC			; count down
	LD	A,B			; get high byte
	OR	C			; or in low byte
	JR	NZ,LAB_0159		; loop if not zero

	LD	A,#00h		; clear A (could XOR A!)
	LD	(LAB_F81D),A	; clear HLP pressed flag byte
	XOR	A			; clear A again !!
	LD	(LAB_F791),A	; clear current memory page

	IN	A,(Port_49)		;0168:	DB49
	AND	#01h			; mask 0000 000x
	JR	Z,LAB_01A6		; jump if bit not set

	IN	A,(Port_49)		;016E:	DB49
	AND	#02h			; mask 0000 00x0
	JP	NZ,LAB_17A5		; jump if bit set

; port 49 was xxxx xx01 at startup (cold start ??)

LAB_0175
	LD	SP,LAB_F81A		; set the stack
	CALL	LAB_1EEC		; initialise display buffers
	LD	A,#FDh		; pattern 1111 1101
	OUT	(KBD_W),A		; out to key matrix
	IN	A,(KBD_R)		; in from key matrix
	AND	#3Fh			; mask 00xx xxxx
	JP	NZ,LAB_0198		; jump if key pressed

	LD	A,#02h		; pattern 0000 0010
	OUT	(KBD_W),A		; out to key matrix
	IN	A,(KBD_R)		; in from key matrix
	AND	#3Fh			; mask 00xx xxxx
	CP	#1Ch			; 'H', 'L' & 'P' pressed
	JP	NZ,LAB_0198		; jump if not

	LD	A,#FFh		; set value
	LD	(LAB_F81D),A	; save HLP pressed flag byte (never used!)

LAB_0198
	LD	A,(LAB_F780)	;0198:	3A80F7
	OUT	(KBD_W),A		; out to key matrix
	DI				; disable interrupts
	LD	A,(LAB_F81C)	; get setup status
	CP	#55h			; have we done this allready ?
	JP	Z,LAB_024D		; jump if so

; port 49 was xxxx xxx0 at startup or setup not done

LAB_01A6
	LD	SP,LAB_F81A		; set the stack
	XOR	A			; clear A
	LD	(LAB_FBD5),A	; clear sleep count ??
	LD	(LAB_F81C),A	; clear setup status
	DI				; disable interrupts
	IN	A,(Port_05)		; clear interrupt flag byte
	LD	A,#FFh		; turn everything off
	OUT	(Port_04),A		; disable all interrupts
	LD	A,#00h		; clear A (could XOR A or INC A!)
	OUT	(Port_2B),A		; tone off

LAB_01BB
	JP	LAB_2530		; go test upper 32k RAM
					; comes back here ...
LAB_01BE
	JR	NC,LAB_01D0		; jump if all tests passed

	LD	A,#FFh		; else ..
	LD	(LAB_FDB0),A	; set upper 32k RAM error byte (allready done this!)
	LD	A,D			; get test result byte
	AND	#08h			; mask top 8k result only
	JR	NZ,LAB_01D0		; jump if top 8k O.K.

	LD	A,#0Bh		; set for low tone
	OUT	(Port_2B),A		; tone on
	JR	LAB_01BB		; continuous loop

					; upper 32k RAM test passed (or at least top 8k)
LAB_01D0
	XOR	A			; clear A
	LD	(LAB_FDB0),A	; clear upper 32k RAM error byte
	LD	SP,F81Ah		; set stack into top 8k
	LD	A,#00h		; clear A
	LD	(LAB_FEA4),A	;01D9:	32A4FE
	LD	A,#70h		; set  LCD contrast
	LD	(LAB_FC05),A	; save LCD contrast byte
	CALL	LAB_1EEC		; initialise display buffers
	LD	HL,LAB_2A70		; points to 'TESTING...'
	CALL	LAB_2A83		; display message at HL.
	CALL	LAB_24F2		; self test #1 ?? result in status flags
	CALL	LAB_0318		; copy block at (35E8) to block from (F180) to F234
					; (RAM test routines.)
	CALL	LAB_267A		; test the RAM
	CALL	LAB_24F2		; self test #1 ?? result in status flags
	CALL	LAB_271F		; test & get RAM configuration
	CALL	LAB_280F		; go do ROM checks
	CALL	LAB_2ABC		; clear display & home cursor (preserves registers) 
	CALL	LAB_317B		; setup pointers & clear FE43-FE82
	CALL	LAB_348A		; setup ports 4F,4A & 2C (and buffers)
	CALL	LAB_3220		; copy blocks to FE93 & FE83
	CALL	LAB_2828		; test clock
	XOR	A			; clear A
	LD	(LAB_FFA8),A	; clear interrupts setup ?? flag
	LD	A,(LAB_FDB5)	; get clock test status flags
	CP	#00h			; compare with 00h
	JR	NZ,LAB_0219		; jump if errors

	CALL	LAB_289E		; do powerdown test ?? (needs working clock)
LAB_0219
	LD	A,#07h		; set tone
	OUT	(Port_2B),A		; out to Port_2B
	LD	A,#01h		; set delay length
	CALL	LAB_35DC		; delay of 100d*A*????
	LD	A,#00h		; tone off
	OUT	(Port_2B),A		; out to Port_2B
	CALL	LAB_317B		; setup pointers & clear FE43-FE82
	CALL	LAB_348A		; setup ports 4F,4A & 2C (and buffers)
	CALL	LAB_3220		; copy blocks to FE93 & FE83
	CALL	LAB_156E		; setup something ??
	LD	A,#55h		; RAM allready setup flag ??
	LD	(LAB_F81C),A	; save setup status
	DI				; disable interrupts
	IN	A,(Port_05)		; clear interrupt flag byte
	LD	A,#FFh		; turn everything off
	OUT	(Port_04),A		; disable all interrupts
	CALL	LAB_02FE		; copy block 369Dh - 36A9h to F180h - F68Ch
	CALL	LAB_059D		; setup RAM page/size variables ??
	CALL	LAB_F425		; BIOS setup page zero, pages 40h to 01h (LAB_3942)
	CALL	LAB_2C94		; setup LAB_FDB8/9/A/B
	CALL	LAB_2084		; clear FD5C-(+27h) and set default RTC

; warm start, without RAM test from here

; BDOS function 0 - system reset

LAB_024D
	LD	SP,LAB_F81A		; set stack (again)
	LD	A,#20h		; set value
	LD	(LAB_F78B),A	; save Port_2A buffer
	OUT	(Port_2A),A		; out to Port_2A
	LD	A,#70h		; set LCD contrast
	LD	(LAB_FC05),A	; save LCD contrast byte
	XOR	A			; clear A
	LD	(LAB_FBD5),A	; clear sleep count ??
	LD	(LAB_FC03),A	;0260:	3203FC
	LD	(LAB_FDA3),A	; clear main battery fail flag/count
	LD	(LAB_FDA2),A	; clear main battery terminal count flag
	LD	(LAB_FFA8),A	; clear interrupts setup ?? flag
	CALL	LAB_1EEC		; initialise display buffers
	LD	HL,LAB_1B58		; key table base address
	LD	(LAB_FBDA),HL	; reset key table base address pointer
	LD	B,#0Ch		; set RTC address 0Ch
	CALL	LAB_22E2		; read A from RTC port (B) (clear interrupt flag byte)
	CALL	LAB_229E		; enable PIE (RTC)
	LD	E,#00h		; sets count to 0F00h
	CALL	LAB_1877		; set ?? countdown default ?? (range 04h to FFh else 0Fh)
	CALL	LAB_2ABC		; clear display & home cursor (preserves registers) 
	CALL	LAB_1897		; set up keyboard parameters & buffer
	CALL	LAB_0DDB		; reset ?? in/out pointers
	CALL	LAB_0323		;028B:	CD2303
	CALL	LAB_22E9		; enable all IRQs & setup interrupt table
	LD	A,(LAB_F81D)	; get HLP pressed flag byte
	CP	#FFh			; was it active ?
	CALL	Z,LAB_3513		; if so clear it ! (just does XOR A)
	CALL	LAB_2468		; compare clock date/month with stored date/month ??
	CALL	LAB_1F32		; just does RET
	CALL	LAB_1EA8		; set cursor off & blink ??

LAB_02A2
	LD	HL,LAB_29B1		; point to 'PARCOM 1000'
	CALL	LAB_2AA1		; output string until 00h
	CALL	LAB_2A92		; output [CR][LF]
	CALL	LAB_2A92		; output [CR][LF]
	LD	HL,LAB_2A7B		; points to 'RAM:   '
	CALL	LAB_2AA1		; output string until 00h
	LD	HL,(LAB_FEAB)	; get contig RAM size (KB)
	CALL	LAB_2AE8		; output HL as decimal string
	LD	HL,LAB_2A4B		; point to ' K.B.'
	CALL	LAB_2AA1		; output string until 00h
	CALL	LAB_2A92		; output [CR][LF]
	CALL	LAB_2A92		; output [CR][LF]
	LD	HL,LAB_014E		; point to 'DIPOSB Ver 228'
	CALL	LAB_2AA1		; output string until 00h
	CALL	LAB_2A92		; output [CR][LF]
	CALL	LAB_2A92		; output [CR][LF]
	LD	HL,LAB_2A5C		; points to 'To Continue Press>>'
	CALL	LAB_2AA1		; output string until 00h

LAB_02D8
	CALL	LAB_F303		; BIOS function - console in (LAB_3820)
	CP	#11h			; compare with 'TOP' key
	JP	Z,LAB_0040		; jump if 'TOP' key

	CP	#12h			; compare with 'BOT' key
	JP	NZ,LAB_02ED		; jump if not 'BOT' key

	CALL	LAB_035C		; display unit stats (RAM etc.)
	CALL	LAB_2ABC		; clear display & home cursor (preserves registers) 
	JR	LAB_02A2		; loop

LAB_02ED
	CP	#0Dh			; compare with [CR]
	JR	Z,LAB_02F8		; jump if [CR]

	CP	#01h			; compare with 'NO' key
	JP	Z,LAB_01A6		; jump if 'NO' key (do retest)

	JR	LAB_02D8		; loop

LAB_02F8
	CALL	LAB_2ABC		; clear display & home cursor (preserves registers) 
	JP	LAB_3BAA		; copies block to RAM then executes it

; copy block 369Dh - 3BA9h to block F180h - F68Ch

LAB_02FE
	LD	DE,00B5h		; size of first block
	LD	HL,LAB_35E8		; point to code block
	ADD	HL,DE			; calculate source address
	LD	DE,LAB_F180		; destination address
	LD	BC,F68Dh		; termination address +1

; copy block from (HL) to (DE) to BC-1

LAB_030B
	LD	A,(HL)		; get byte from source
	LD	(DE),A		; copy to destination
	INC	HL			; increment source pointer
	INC	DE			; increment destination pointer
	LD	A,E			; get destination low byte
	CP	C			; compare with terminator low byte
	JR	NZ,LAB_030B		; loop if not equal
	LD	A,D			; get destination high byte
	CP	B			; compare with terminator high byte
	JR	NZ,LAB_030B		; loop if not equal
	RET				;

; copy block starting at 35E8h to block from F180h to F234h

LAB_0318
	LD	DE,LAB_F180		; destination address
	LD	HL,LAB_35E8		; source address
	LD	BC,F235h		; termination address +1
	JR	LAB_030B		; go copy block

LAB_0323
	CALL	LAB_0746		;0323:	CD4607
	XOR	A			; clear A
	LD	(LAB_FDCA),A	;0327:	32CAFD
	LD	E,#00h		;032A:	1E00
	CALL	LAB_15A4		; save E to (0003h) in pages 40h-00h & LAB_FBC5
	LD	E,#00h		;032F:	1E00
	CALL	LAB_15B3		; save E (E<10h) to (0004h) in pages 40h-00h & LAB_FBC6
					; A = 00 = done, A = FF = failed
	LD	HL,0080h		; set default source pointer
	LD	A,(LAB_FEB1)	;0337:	3AB1FE
	AND	#0Fh			; mask 0000 xxxx
	JR	NZ,LAB_0341		;033C:	2003

	LD	HL,LAB_FEFF		; set default DMA address
LAB_0341
	LD	(LAB_FFA3),HL	; save default DMA address
	LD	A,#07h		; set default beep tone
	LD	(LAB_FBC8),A	; save beep tone
	LD	A,#01h		; set default beep duration
	LD	(LAB_FBC7),A	; save beep duration
	LD	HL,0000h		; clear HL
	LD	(LAB_FDBD),HL	;0351:	22BDFD
	LD	(LAB_FEFC),HL	; clear error number & type
	LD	A,#03h		;0357:	3E03
	OUT	(Port_48),A		;0359:	D348
	RET				;

; display unit stats (RAM etc.)

LAB_035C
	LD	HL,LAB_0419		; point to message 1Bh,'K',1Bh,'HDIPOSB Ver 228'
	CALL	LAB_2AA1		; output string until 00h
	CALL	LAB_2A92		; output [CR][LF]
	LD	HL,LAB_2A23		; point to'First Ram Bank '
	CALL	LAB_2AA1		; output string until 00h
	LD	A,(LAB_FEA7)	; get first RAM bank #
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	CALL	LAB_2AE8		; output HL as decimal string
	CALL	LAB_2A92		; output [CR][LF]
	LD	HL,LAB_2A3F		; point to 'Contig Ram:'
	CALL	LAB_2AA1		; output string until 00h
	LD	HL,(LAB_FEAB)	; get contig RAM size (KB)
	CALL	LAB_2AE8		; output HL as decimal string
	LD	HL,LAB_2A4B		; point to ' K.B.'
	CALL	LAB_2AA1		; output string until 00h
	CALL	LAB_2A92		; output [CR][LF]
	LD	HL,LAB_2A33		; point to 'Full Ram:  '
	CALL	LAB_2AA1		; output string until 00h
	LD	HL,(LAB_FEAD)	; get full RAM size (KB)
	CALL	LAB_2AE8		; output HL as decimal string
	LD	HL,LAB_2A4B		; point to ' K.B.'
	CALL	LAB_2AA1		; output string until 00h
	CALL	LAB_2A92		; output [CR][LF]
	LD	A,(LAB_FDB3)	; get ROM 0 test result
	LD	HL,LAB_29EF		; points to 'ROM 0 CS: '
	LD	DE,(LAB_FDAB)	; get ROM 0 checksum
	CALL	LAB_290A		; HL is header, DE is checksum No. A is error code
	LD	A,(LAB_FDB4)	; get ROM 1 test result
	LD	HL,LAB_29FA		; points to 'ROM 1 CS: '
	LD	DE,(LAB_FDAD)	; get ROM 1 checksum
	CALL	LAB_290A		; HL is header, DE is checksum No. A is error code
	CALL	LAB_2A92		; output [CR][LF]
	LD	HL,LAB_2A5C		; points to 'To Continue Press>>'
	CALL	LAB_2AA1		; output string until 00h
	JP	LAB_0407		;

LAB_03C7
	LD	HL,LAB_0419		; point to message 1Bh,'K',1Bh,'HDIPOSB Ver 228'
	CALL	LAB_2AA1		; output string until 00h
	CALL	LAB_2A92		; output [CR][LF]
	LD	HL,LAB_29D1		; point to 'status flags  '
	LD	A,(LAB_FDAF)	; get port 48h/49h status flag
	CALL	LAB_2919		; output (HL) message and then test result message
	LD	HL,LAB_29E0		; point to 'Bank select   '
	LD	A,(LAB_FDB2)	; get bank select flags result
	CALL	LAB_2919		; output (HL) message and then test result message
	LD	A,(LAB_FDB5)	; get clock test status flags
	LD	HL,LAB_2A05		; point to 'Clock test    '
	CALL	LAB_2919		; output (HL) message and then test result message
	LD	A,(LAB_FDB5)	; get clock test status flags
	OR	A			; set the flags
	JP	NZ,LAB_03FB		; jump if clock error

	LD	A,(LAB_FDB6)	; get powerdown test status flags
	LD	HL,LAB_2A14		; point to 'Powerdown test'
	CALL	LAB_2919		; output (HL) message and then test result message
LAB_03FB
	CALL	LAB_2A92		; output [CR][LF]
	CALL	LAB_2A92		; output [CR][LF]
	LD	HL,LAB_2A5C		; points to 'To Continue Press>>'
	CALL	LAB_2AA1		; output string until 00h

LAB_0407
	CALL	LAB_F303		; BIOS function - console in (LAB_3820)
	CP	#0Dh			; compare with [CR]
	RET	Z			; exit if [CR]

	CP	#01h			; compare with 'NO' key
	JP	Z,LAB_035C		; jump if 'NO' key
					; display unit stats (RAM etc.)

	CP	#06h			; compare with 'YES' key
	JP	Z,LAB_03C7		; go do other screen if 'YES' key presed
	JR	LAB_0407		; loop

LAB_0419
	DB	1Bh,'K',1Bh,'H'
LAB_014E
	DB	'DIPOSB Ver 228',00h

LAB_042D
	PUSH	DE			; save FCB pointer
	LD	HL,0021h		; offset to random access record #
	ADD	HL,DE			; add FCB pointer
	LD	E,(HL)		; get random access record # low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get random access record # high byte
	LD	HL,(LAB_F826)	;0435:	2A26F8
	LD	A,(LAB_F82A)	;0438:	3A2AF8
	CALL	LAB_04AF		; HL = (HL AND DE), DE>>A
	POP	HL			; get FCB pointer
	PUSH	HL			; save FCB pointer
	PUSH	DE			;0440:	D5
	LD	DE,0020h		; offset to CR byte
	ADD	HL,DE			; add to FCB pointer
	LD	(HL),C		; save CR byte
	POP	DE			;0446:	D1
	LD	HL,0020h		;0447:	212000
	EX	DE,HL			;044A:	EB
	CALL	LAB_0502		; set carry if DE>HL
	LD	A,#06h		;044E:	3E06
	POP	DE			;0450:	D1
	CCF				;0451:	3F
	RET	C			;0452:	D8
	PUSH	HL			;0453:	E5
	POP	BC			;0454:	C1
	LD	HL,000Ch		;0455:	210C00
	ADD	HL,DE			;0458:	19
	LD	A,C			;0459:	79
	CP	(HL)			;045A:	BE
	RET	Z			;045B:	C8

LAB_045C
	PUSH	DE			;045C:	D5
	PUSH	HL			;045D:	E5
	PUSH	BC			;045E:	C5
	SCF				;045F:	37
	CALL	LAB_06C1		;0460:	CDC106
	POP	BC			;0463:	C1
	POP	HL			;0464:	E1
	POP	DE			;0465:	D1
	LD	A,#FFh		;0466:	3EFF
	RET	C			;0468:	D8
	LD	(HL),C		;0469:	71
	AND	A			;046A:	A7
	RET				;

LAB_046C
	EX	DE,HL			; swap FCB pointer to HL
	PUSH	HL			; save FCB pointer
	LD	E,A			; copy CR byte
	LD	D,#00h		; clear high byte
	LD	HL,(LAB_F828)	;0471:	2A28F8
	LD	A,(LAB_F822)	;0474:	3A22F8
	CALL	LAB_04AF		; HL = (HL AND DE), DE>>A
	POP	HL			; restore FCB pointer
	ADD	HL,DE			;047B:	19
	ADD	HL,DE			;047C:	19
	LD	DE,0010h		;047D:	111000
	ADD	HL,DE			;0480:	19
	LD	E,(HL)		;0481:	5E
	INC	HL			;0482:	23
	LD	D,(HL)		;0483:	56
	DEC	HL			;0484:	2B
	LD	A,D			;0485:	7A
	OR	E			;0486:	B3
	RET				;

; do CP (LAB_F825),+(CR)

LAB_0488
	PUSH	DE			; save FCB pointer
	LD	HL,0020h		; offset to CR byte
	ADD	HL,DE			; add FCB pointer
	INC	(HL)			; increment CR byte
	LD	A,(LAB_F825)	; get ??
	CP	(HL)			; compare with CR byte
	POP	DE			; restore FCB pointer
	RET				;

; do CP (CR),(RC)

LAB_0494
	LD	HL,0020h		; offset to CR byte
	ADD	HL,DE			; add FCB pointer
	LD	A,(HL)		; get CR byte
	LD	HL,000Fh		; offset to RC byte
	ADD	HL,DE			; add FCB pointer
	CP	(HL)			; compare
	RET				;

; do DE<<A. RST 28h if overflow

LAB_049F
	LD	B,A			; copy rotate count
LAB_04A0
	LD	A,E			; get E
	AND	A			; set the flags (clear carry)
	RLA				; rotate left (*2)
	LD	E,A			; save E
	LD	A,D			; get D
	RLA				; rotate left (*2)
	LD	D,A			; save D
	JR	NC,LAB_04AC		; jump if no overflow

	LD	C,#00h		;04A9:	0E00
	RST	28h			; process error code, error code is in A

LAB_04AC
	DJNZ	LAB_04A0		; loop until all done
	RET				;

; HL = (HL AND DE), DE>>A

LAB_04AF
	PUSH	AF			; save AF
	LD	A,D			; copy D
	AND	H			; AND H
	LD	B,A			; save to B
	LD	A,E			; copy E
	AND	L			; AND L
	LD	C,A			; save to C
	POP	AF			; restore AF
	PUSH	BC			; save result
	CALL	LAB_04BD		; does DE>>A
	POP	HL			; restore result
	RET				; 

; does DE>>A

LAB_04BD
	LD	B,A			; copy rotate count
LAB_04BE
	LD	A,D			; get high byte
	AND	A			; set flags (clear carry)
	RRA				; >>
	LD	D,A			; save high byte
	LD	A,E			; get low byte
	RRA				; >>
	LD	E,A			; save low byte
	DJNZ	LAB_04BE		; loop until all done
	RET				;

; calculate C=mem page, HL=sector

LAB_04C8
	LD	A,(LAB_F8AF)	; get first mem page #
	LD	C,A			; copy to C
	CALL	LAB_04F4		; HL = HL-sectors in last page
	JR	C,LAB_04DE		; if carry call add sectors/page to HL & exit

	INC	C			; increment page #
LAB_04D2
	CALL	LAB_04E2		; does HL = HL-sectors/page
	JR	C,LAB_04DA		; if -ve add it back & exit

	INC	C			; else increment page #
	JR	LAB_04D2		; loop

LAB_04DA
	CALL	LAB_04EB		; does HL = HL+sectors/page
	RET				;

; call add sectors in last page to HL

LAB_04DE
	CALL	LAB_04FC		; add sectors in last page to HL
	RET				;

; does HL = HL-sectors/page

LAB_04E2
	LD	A,L			; copy L
	SUB	#FEh			; sub FEh
	LD	L,A			; save to L
	LD	A,H			; copy H
	SBC	A,#00h		; sub carry
	LD	H,A			; save to H
	RET				;

; does HL = HL+sectors/page

LAB_04EB
	LD	A,L			; copy L
	ADD	A,#FEh		; add FEh
	LD	L,A			; save to L
	LD	A,H			; get H
	ADC	A,#00h		; add carry
	LD	H,A			; save to H
	RET				;

; HL = HL-sectors in last page

LAB_04F4
	XOR	A			; clear A and carry
	LD	DE,(LAB_F8B2)	; get sectors in last page
	SBC	HL,DE			; subtract from HL
	RET				;

; add sectors in last page to HL

LAB_04FC
	LD	DE,(LAB_F8B2)	; get sectors in last page
	ADD	HL,DE			; add to HL
	RET				;

; set carry if DE>HL

LAB_0502
	LD	A,H			; get H
	CP	D			; compare with D
	RET	C			; return if D>H
	RET	NZ			; return if D<>H
	LD	A,L			; else get L
	CP	E			; compare with E
	RET				;

LAB_0509
	LD	(LAB_F823),HL	;0509:	2223F8
	EX	DE,HL		;050C:	EB
	LD	(LAB_F81E),HL	;050D:	221EF8
	LD	(LAB_F822),A	;0510:	3222F8
	LD	DE,0001h	;0513:	110100
	CALL	LAB_049F		; do DE<<A. RST 28h if overflow
	EX	DE,HL		;0519:	EB
	LD	(LAB_F820),HL	;051A:	2220F8
	LD	A,(LAB_F822)	;051D:	3A22F8
	CALL	LAB_0594		; HL = (2^A)-1
	LD	(LAB_F828),HL	;0523:	2228F8
	LD	A,(LAB_F822)	;0526:	3A22F8
	ADD	A,#03h		;0529:	C603
	LD	(LAB_F82A),A	;052B:	322AF8
	CALL	LAB_0594		; HL = (2^A)-1
	LD	(LAB_F826),HL	;0531:	2226F8
	LD	A,L		;0534:	7D
	LD	(LAB_F825),A	;0535:	3225F8
	CALL	LAB_0540		; fill 80h bytes from F82Eh with 00h
	CALL	LAB_0555		; set (LAB_F81E) bits in ???
	JR	LAB_0563		; fill 80h bytes from F8B8h with E5h,
					; then copy it in RAM (LAB_F81E) times

; fill 80h bytes from F82Eh with 00h

LAB_0540
	LD	HL,LAB_F82E		; pointer
	LD	BC,0080h		; 80h (128d) bytes to clear

LAB_0546
	LD	(HL),#00h		; clear byte
	DEC	BC			; decrement count
	INC	HL			; increment pointer
	LD	A,B			; get count high byte
	OR	C			; OR count low byte
	JR	NZ,LAB_0546		; loop if not all done

	LD	HL,0000h		; clear HL
	LD	(LAB_F82C),HL	;0551:	222CF8
	RET				;

; set (LAB_F81E) bits in ???

LAB_0555
	LD	HL,(LAB_F81E)	;0555:	2A1EF8
LAB_0558
	PUSH	HL			; push count
	CALL	LAB_0795		; test (LAB_F823)>(LAB_F82C) if so find next bit
					; not set and set it
	POP	HL			; restore count
	DEC	HL			; decrement count
	LD	A,H			; set the flags
	OR	L			;
	JR	NZ,LAB_0558		; loop if not zero

	RET				;

; fill 80h bytes from F8B8h with E5h,
; then copy it in RAM (LAB_F81E) times

LAB_0563
	LD	HL,LAB_F8B8		; set pointer to 80h byte area
	LD	BC,0080h		; set count
LAB_0569
	LD	(HL),#E5h		; fill byte
	INC	HL			; point to next
	DEC	BC			; decrement count
	LD	A,B			; get count high byte
	OR	C			; OR with low byte
	JR	NZ,LAB_0569		; loop if not all done

	LD	HL,(LAB_F81E)	; get block count ??
	LD	DE,0000h		; starting from 0000h
LAB_0577
	PUSH	HL			; save block count  ??
	LD	HL,(LAB_F820)	; get count (in low byte)
	PUSH	HL			; copy from HL ..
	POP	BC			; .. to BC
LAB_057D
	PUSH	BC			; save count
	PUSH	DE			; save DE (=0000h)
	DEC	BC		;057F:	0B
	LD	HL,LAB_F8B8		; set source pointer to 80h byte area
	SCF				; flag write sector
	CALL	LAB_F4C6		; copy sector BC to/from (HL) ??
					; if Cb=0=from (read) else Cb=1=to (write)
	POP	DE			; restore DE (=0000h)
	POP	BC			; restore count
	DEC	C			; decrement count
	JR	NZ,LAB_057D		; loop until all done

	POP	HL			; restore block count ??
	INC	DE			; increment done count
	CALL	LAB_0502		; set carry if DE>HL
	JR	NZ,LAB_0577		; loop if not all done

	RET				;

; HL = (2^A)-1

LAB_0594
	LD	DE,0001h	;0594:	110100
	CALL	LAB_049F		; do DE<<A. RST 28h if overflow
	DEC	DE		;059A:	1B
	EX	DE,HL		;059B:	EB
	RET				;

; just does CALL LAB_05A1

LAB_059D
	CALL	LAB_05A1		;
	RET				;

LAB_05A1
	LD	HL,0100h		; set page offset to first sector ??
	LD	(LAB_F8B0),HL	; save RDOS 1st sector offset ??
	LD	HL,8000h		; set last mem page size ??
	LD	(LAB_F8B6),HL	; save last mem page size ??
	LD	A,(LAB_FEA7)	; get first RAM bank #
	LD	(LAB_F8AF),A	; save it
	LD	B,A			; copy it
	LD	A,(LAB_FEA8)	; get last RAM bank #
	SUB	B			; subtract first RAM bank
	LD	(LAB_F8AE),A	; save # of RAM banks
	CALL	LAB_05D2		; sets total sectors in RAMdisk & sectors
					; in last page from HL & A ??
	CALL	LAB_0600		; A = (# of RAM banks-1) * something
	LD	A,B			; get remainder ??
	LD	(LAB_F822),A	;05C2:	3222F8
	CALL	LAB_0617		;05C5:	CD1706
	LD	A,(LAB_F822)	;05C8:	3A22F8
	LD	DE,0002h		;05CB:	110200
	CALL	LAB_0509		;05CE:	CD0905
	RET				;

; sets total sectors in RAMdisk & sectors
; in last page from HL & A ??

LAB_05D2
	PUSH	HL			; save last page size ??
	LD	DE,00FEh		; RDOS blocks/page ??
	LD	HL,0000h		; clear total
	LD	B,A			; copy # of RAM banks
	DEC	B			; # of RAM banks -1
	JR	Z,LAB_05E0		; jump if count was 1

LAB_05DD
	ADD	HL,DE			; add RDOS blocks/page ??
	DJNZ	LAB_05DD		; loop until done

					; HL now contains RDOS blocks/page*(# of RAM banks-1)
LAB_05E0
	POP	BC			; restore last page size
	CALL	LAB_05ED		; DE = (BC-0100h)>>7 (sectors in last page)
	ADD	HL,DE			; add to total sectors
	LD	(LAB_F8B4),HL	; save total sectors in RAMdisk
	EX	DE,HL			; swap sectors in last page to HL
	LD	(LAB_F8B2),HL	; save sectors in last page
	RET				;

; DE = (BC-0100h)>>7

LAB_05ED
	LD	DE,0100h		; 0100h to subtract
	LD	A,C			; get low byte
	SUB	E			; - 00h ?
	LD	E,A			; save it to E
	LD	A,B			; get high byte
	SBC	A,D			; -01h ?
	LD	D,A			; save it to D
	LD	B,#07h		; shift right 7 times
LAB_05F8
	XOR	A			; clear A (also clears Carry)
	SRL	D			; DE = DE\2
	RR	E			;
	DJNZ	LAB_05F8		; loop until done

	RET				;

; A= (# of RAM banks-1) * something

LAB_0600
	XOR	A			; why? (!)
	LD	A,(LAB_F8AE)	; get # of RAM banks
	DEC	A			; -1
	SLA	A			; *2
	SLA	A			; *4
	SLA	A			; *8
	LD	B,#05h		;060B:	0605
	LD	C,#03h		;060D:	0E03
LAB_060F
	SLA	A			; *16,*32,*64
	RET	C			; exit if overflow

	DEC	B		;0612:	05
	DEC	C		;0613:	0D
	JR	NZ,LAB_060F		; loop until C=0
	RET				;

LAB_0617
	LD	HL,(LAB_F8B4)	; get total sectors in RAMdisk
	EX	DE,HL		;061A:	EB
	CALL	LAB_04AF	; HL = (HL AND DE), DE>>A
	EX	DE,HL		;061E:	EB
	LD	(LAB_F823),HL	;061F:	2223F8
	RET				;

; create file ??

LAB_0623
	PUSH	DE			; save FCB pointer
	CALL	LAB_06EC		; clear word @ (LAB_F938), (LAB_F93A) & byte @ (LAB_F93C)
	XOR	A		;0627:	AF
	CALL	LAB_06DC	;0628:	CDDC06
	LD	HL,LAB_F8B8		; set pointer to 80h byte area

LAB_062E
	LD	A,(HL)		;062E:	7E
	CP	#E5h		;062F:	FEE5
	JR	Z,LAB_063A	;0631:	2807

	CALL	LAB_06FA	;0633:	CDFA06
	JR	NC,LAB_062E		; loop if ??

	POP	DE			; restore FCB pointe
	RET				;

LAB_063A
	PUSH	HL			; save HL
	LD	B,#20h		; 20h bytes to clear
LAB_063D
	LD	(HL),#00h		; clear byte
	INC	HL			; point to next
	DJNZ	LAB_063D		; loop until all clear

	POP	HL			; restore HL
	POP	DE			; restore FCB pointe
	PUSH	HL		;0644:	E5
	PUSH	DE			; save FCB pointer
	EX	DE,HL		;0646:	EB
	INC	HL		;0647:	23
	INC	DE		;0648:	13
	LD	BC,000Ch		; 0Ch bytes to copy
	LDIR				; copy block
	SCF			;064E:	37
	CALL	LAB_06DC	;064F:	CDDC06
	POP	DE			; restore FCB pointe
	POP	HL		;0653:	E1
	INC	HL		;0654:	23
	INC	DE		;0655:	13
	LD	BC,001Fh		; 1Fh bytes to copy
	LDIR				; copy block
	XOR	A			; clear A
	RET				;

; find file ??

LAB_065D
	PUSH	DE			; save FCB pointer
	CALL	LAB_06EC		; clear word @ (LAB_F938), (LAB_F93A) & byte @
					; (LAB_F93C)
	XOR	A			; clear A (allready done)
	CALL	LAB_06DC	;0662:	CDDC06
	LD	HL,LAB_F8B8		; set pointer to 80h byte area
	POP	DE			; restore  FCB pointer

LAB_0669
	LD	A,(HL)		; get byte from 80h byte area
	CP	#E5h			; compare with E5h
	JR	Z,LAB_0685		; jump if =

	PUSH	HL			; save pointer
	PUSH	DE			; save FCB pointer
	LD	B,#0Ch		;0670:	060C

LAB_0672
	INC	DE			; increment FCB pointer
	INC	HL			; increment 80h byte area pointer
	EX	DE,HL			; swap them
	LD	A,(HL)		; get byte from 80h byte area
	CP	#3Fh			; compare with "?"
	EX	DE,HL			; swap pointers back
	JR	Z,LAB_067E		; jump if character is "?"

	CP	(HL)			; else compare with filename character
	JR	NZ,LAB_0680		; jump if no match

LAB_067E
	DJNZ	LAB_0672	;067E:	10F2

LAB_0680
	POP	DE			; restore FCB pointer
	POP	HL			; restore pointer
	SCF				; set carry
	CCF				; complement carry
	RET	Z			; return if no match

					; gets here if filename match
LAB_0685
	PUSH	DE			; save FCB pointer
	CALL	LAB_06FA	;0686:	CDFA06
	POP	DE			; restore FCB pointer
	JR	NC,LAB_0669	;068A:	30DD

	RET				;

; convert filename in FCB to upper case ASCII
;
; Format a file name. On return, (A)=0 is an unambiguous
; name was specified, (A) =1 ia an ambiguous name was
; specified and (A) =FFh is an error. Enter with DE equal
; to the position of the name.

LAB_068D
	LD	B,#0Bh		; 0Bh bytes to do
	XOR	A			; clear A
	LD	(LAB_F93D),A	; clear '?' flag
	EX	DE,HL			; swap FCB pointer to HL

LAB_0694
	INC	HL			; increment pointer
	LD	A,(HL)		; get byte
	AND	#7Fh			; mask 0xxx xxxx
	CP	#20h			; compare with ' '
	JR	C,LAB_06BE		; jump if <' ' (non printing chr)

	CP	#7Bh			; compare with '{'
	JR	NC,LAB_06BE		; jump if >'z' (non printing chr)

	CP	#61h			; compare with 'a'
	JR	C,LAB_06A9		; jump if <'a'

	SUB	#20h			; convert to upper case
	LD	(HL),A		; save back
	JR	LAB_06B3		; go decrement & loop

LAB_06A9
	LD	(HL),A		; save back
	CP	#'?'			; compare with '?'
	JR	NZ,LAB_06B3		; go decrement & loop if not '?'

	LD	A,#FFh		; set '?' flag
	LD	(LAB_F93D),A	; save it

LAB_06B3
	DJNZ	LAB_0694		; loop until all done

	LD	A,(LAB_F93D)	; get '?' flag back
	AND	A			; set the flags
	LD	A,#00h		; clear A (don't change flags)
	RET	Z			; return if '?' flag clear

	INC	A			; else make A=01h
	RET				;

					; was non printing chr so ..
LAB_06BE
	LD	A,#FFh		; flag error in filename
	RET				;

LAB_06C1
	PUSH	AF			; save AF
	PUSH	DE			; save FCB pointer
	CALL	LAB_065D		; find file ??
	POP	DE			; restore FCB pointer
	POP	BC			; restore AF?
	RET	C			; exit if file not found

	PUSH	BC			; copy BC
	POP	AF			; to AF
	PUSH	AF			; and save AF
	JR	NC,LAB_06CF	;06CC:	3001

	EX	DE,HL		;06CE:	EB
LAB_06CF
	INC	HL		;06CF:	23
	INC	DE			;06D0:	13
	LD	BC,001Fh		; 1Fh bytes to copy
	LDIR				; copy block
	POP	AF			; restore AF
	CALL	C,LAB_06DC	;06D7:	DCDC06

	XOR	A			; clear A
	RET				;

LAB_06DC
	LD	HL,(LAB_F938)	;06DC:	2A38F9
	EX	DE,HL		;06DF:	EB
	LD	HL,(LAB_F93A)	;06E0:	2A3AF9
	PUSH	HL		;06E3:	E5
	POP	BC		;06E4:	C1
	LD	HL,LAB_F8B8		; set pointer to 80h byte area
	CALL	LAB_F4C6		; copy sector BC to/from (HL) ??
					; if Cb=0=from (read) else Cb=1=to (write)
	RET				;

; clear word @ (LAB_F938), (LAB_F93A) & byte @ (LAB_F93C)

LAB_06EC
	LD	HL,0000h	;06EC:	210000
	LD	(LAB_F938),HL	;06EF:	2238F9
	LD	(LAB_F93A),HL	;06F2:	223AF9
	XOR	A		;06F5:	AF
	LD	(LAB_F93C),A	;06F6:	323CF9
	RET				;

LAB_06FA
	LD	A,(LAB_F93C)	;06FA:	3A3CF9
	INC	A		;06FD:	3C
	LD	(LAB_F93C),A	;06FE:	323CF9
	CP	#04h		;0701:	FE04
	JR	NZ,LAB_0733	;0703:	202E
	XOR	A		;0705:	AF
	LD	(LAB_F93C),A	;0706:	323CF9
	LD	HL,(LAB_F820)	;0709:	2A20F8
	EX	DE,HL		;070C:	EB
	LD	HL,(LAB_F93A)	;070D:	2A3AF9
	INC	HL		;0710:	23
	LD	(LAB_F93A),HL	;0711:	223AF9
	CALL	LAB_0502		; set carry if DE>HL
	JR	C,LAB_072F	;0717:	3816
	LD	HL,0000h	;0719:	210000
	LD	(LAB_F93A),HL	;071C:	223AF9
	LD	HL,(LAB_F81E)	;071F:	2A1EF8
	EX	DE,HL		;0722:	EB
	LD	HL,(LAB_F938)	;0723:	2A38F9
	INC	HL		;0726:	23
	LD	(LAB_F938),HL	;0727:	2238F9
	CALL	LAB_0502	; set carry if DE>HL
	CCF			;072D:	3F
	RET	C		;072E:	D8

LAB_072F
	XOR	A		;072F:	AF
	CALL	LAB_06DC	;0730:	CDDC06

LAB_0733
	LD	A,(LAB_F93C)	;0733:	3A3CF9
	LD	HL,LAB_F8B8		; set pointer to 80h byte area
	LD	DE,0020h	;0739:	112000

LAB_073C
	AND	A		;073C:	A7
	RET	Z		;073D:	C8
	ADD	HL,DE		;073E:	19
	DEC	A		;073F:	3D
	JR	LAB_073C	;0740:	18FA

LAB_0742
	CALL	LAB_0746	;0742:	CD4607
	RET				;

LAB_0746
	CALL	LAB_0540		; fill 80h bytes from F82Eh with 00h
	CALL	LAB_0555		; set (LAB_F81E) bits in ???
	CALL	LAB_06EC		; clear word @ (LAB_F938), (LAB_F93A) & byte @ (LAB_F93C)
	CALL	LAB_06DC	;074F:	CDDC06
	LD	HL,LAB_F8B8		; set pointer to 80h byte area
LAB_0755
	LD	A,#E5h		;0755:	3EE5
	CP	(HL)		;0757:	BE
	JR	NZ,LAB_0761	;0758:	2007

LAB_075A
	CALL	LAB_06FA	;075A:	CDFA06
	JR	C,LAB_0783	;075D:	3824
	JR	LAB_0755	;075F:	18F4

LAB_0761
	LD	DE,0010h	;0761:	111000
	ADD	HL,DE		;0764:	19
	LD	B,#08h		;0765:	0608

LAB_0767
	PUSH	HL		;0767:	E5
	PUSH	BC		;0768:	C5
	LD	E,(HL)		;0769:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;076B:	56
	LD	A,D		;076C:	7A
	OR	E		;076D:	B3
	JR	Z,LAB_077A	;076E:	280A
	CALL	LAB_078A	; do CP (LAB_F823),DE
	JR	C,LAB_0785	;0773:	3810
	CALL	LAB_07F6	;0775:	CDF607
	JR	C,LAB_0785	;0778:	380B

LAB_077A
	POP	BC		;077A:	C1
	POP	HL		;077B:	E1
	INC	HL		;077C:	23
	INC	HL		;077D:	23
	DEC	B		;077E:	05
	JR	NZ,LAB_0767	;077F:	20E6
	JR	LAB_075A	;0781:	18D7

LAB_0783
	XOR	A		;0783:	AF
	RET				;

LAB_0785
	POP	BC		;0785:	C1
	POP	HL		;0786:	E1
	LD	A,#FFh		;0787:	3EFF
	RET				;

; do CP (LAB_F823),DE

LAB_078A
	PUSH	HL			; save HL
	LD	HL,LAB_F823		; set pointer
	LD	A,(HL)		; get low byte (LAB_F823)
	SUB	E			; subtract DE low byte
	INC	HL			; point to high byte
	LD	A,(HL)		; get high byte (LAB_F823)
	SBC	A,D			; subtract DE high byte
	POP	HL			; restore HL
	RET				;

; test (LAB_F823)>(LAB_F82C) if so find next bit not set and set it 

LAB_0795
	LD	HL,(LAB_F823)	;0795:	2A23F8
	EX	DE,HL			; swap into DE
	LD	HL,(LAB_F82C)	;0799:	2A2CF8
	CALL	LAB_0502		; set carry if DE>HL
	CCF				; complement carry
	RET	C			; return if DE<=HL

					; was DE>HL
	INC	HL			; increment ??
	LD	(LAB_F82C),HL	; save it
	LD	BC,0080h		; do 80h bytes
	LD	DE,0000h		; clear tally
	LD	HL,LAB_F823		; set pointer

					; count sequential bit=1 from LAB_F823 on.
LAB_07AE
	LD	A,(HL)		; get byte
	CP	#FFh			; compare with FFh
	JR	NZ,LAB_07BC		; jump if not FFh

	INC	HL			; next byte
	INC	DE			; keep score ??
	DEC	BC			; decrement count
	LD	A,B			; get count high byte
	OR	C			; OR low byte
	JR	NZ,LAB_07AE		; loop if not all done

	SCF				; set carry, all bytes =FFh
	RET				;

					; byte was not FFh
LAB_07BC
	PUSH	DE			; save score ??
	LD	B,#00h		; clear bit #

LAB_07BF
	RRA				; rotate byte
	INC	B			; increment bit #
	JR	C,LAB_07BF		; loop until bit=0

	SCF				; make bit=1
	LD	D,B			; save bit #

LAB_07C5
	RLA				; rotate back
	DJNZ	LAB_07C5		; loop until all done

	LD	(HL),A		; save back to memory (with new bit set)
	LD	L,D			; save bit #
	LD	H,B			; clear high byte (B=00h)
	POP	DE			; get score ?? back
	LD	A,#03h		; set shift count
	PUSH	HL			; save bit #
	CALL	LAB_049F		; do DE<<A. RST 28h if overflow
	POP	HL			; restore bit #
	ADD	HL,DE			; add to byte*8 count
	DEC	HL			; -1
	EX	DE,HL			; copy to DE
	RET				;

LAB_07D7
	LD	A,#03h		;07D7:	3E03
	LD	HL,0007h	;07D9:	210700
	CALL	LAB_04AF	; HL = (HL AND DE), DE>>A
	LD	HL,LAB_F823	;07DF:	212EF8
	ADD	HL,DE		;07E2:	19
	INC	C		;07E3:	0C
	XOR	A		;07E4:	AF
	LD	A,#FFh		;07E5:	3EFF

LAB_07E7
	RLA			;07E7:	17
	DEC	C		;07E8:	0D
	JR	NZ,LAB_07E7	;07E9:	20FC
	AND	(HL)		;07EB:	A6
	LD	(HL),A		;07EC:	77
	LD	HL,(LAB_F82C)	;07ED:	2A2CF8
	DEC	HL		;07F0:	2B
	LD	(LAB_F82C),HL	;07F1:	222CF8
	XOR	A		;07F4:	AF
	RET				;

LAB_07F6
	LD	A,#03h		;07F6:	3E03
	LD	HL,0007h	;07F8:	210700
	CALL	LAB_04AF	; HL = (HL AND DE), DE>>A
	LD	HL,LAB_F823	;07FE:	212EF8
	ADD	HL,DE		;0801:	19
	INC	C		;0802:	0C
	XOR	A		;0803:	AF
	SCF			;0804:	37

LAB_0805
	RLA			;0805:	17
	DEC	C		;0806:	0D
	JR	NZ,LAB_0805	;0807:	20FC
	LD	B,A		;0809:	47
	AND	(HL)		;080A:	A6
	JR	NZ,LAB_0819	;080B:	200C
	LD	A,B		;080D:	78
	OR	(HL)		;080E:	B6
	LD	(HL),A		;080F:	77
	LD	HL,(LAB_F82C)	;0810:	2A2CF8
	INC	HL		;0813:	23
	LD	(LAB_F82C),HL	;0814:	222CF8
	XOR	A		;0817:	AF
	RET				;

LAB_0819
	SCF			;0819:	37
	RET				;

; save BC & DE @ HL++++

LAB_081B
	LD	(HL),C		; save C
	INC	HL			; increment pointer
	LD	(HL),B		; save B
	INC	HL			; increment pointer
	LD	(HL),E		; save E
	INC	HL			; increment pointer
	LD	(HL),D		; save D
	INC	HL			; increment pointer
	RET				;

; get byte from LAB_FE93+first copied byte
; return C=1 and error # FDh if out of range

LAB_0824
	PUSH	DE			; save copied FCB pointer
	LD	HL,0000h		; clear offset
	ADD	HL,DE			; point to copied FCB
	LD	A,(HL)		; get drive #
	CP	#00h			; compare with 00h (could OR A here!)
	JR	NZ,LAB_0832		; jump if not zero

	LD	A,(LAB_FBC6)	; get current drive #
	INC	A			; increment it
LAB_0832
	DEC	A			; decrement drive #
	CALL	LAB_3205		; if A<10h return HL=LAB_FE93+A, else return A=FDh C=1
	POP	DE			; restore copied FCB pointer
	LD	A,(HL)		; get byte from LAB_FE93 table
	RET				;

LAB_0839
	LD	(LAB_F93E),A	;0839:	323EF9
	EX	DE,HL		;083C:	EB
	LD	(LAB_F93F),HL	;083D:	223FF9
	LD	A,#01h		;0840:	3E01
	RET				;

; BDOS function 22 - create file
;
; DE=address of FCB. Returns error codes in BA and HL. 
; Creates the file specified. Returns A=FFh if the directory is full. 
; If the file exists already, then the default action is to return to the command 
; prompt.

LAB_0843
	CALL	LAB_F4EB		; copy FCB to FCB_buffer, LAB_FF7F (LAB_3A08)
	CALL	LAB_0824		; get byte from LAB_FE93+first copied byte
					; return C=1 and error # FDh if out of range
	CP	#00h			; was it null byte (could OR A)
	JR	NZ,LAB_086E		; jump if not

	PUSH	DE			; save FCB pointer
	CALL	LAB_068D		; convert filename in FCB to upper case ASCII
	POP	DE			; restore FCB pointer
	AND	A			; check result
	JR	NZ,LAB_0874		; jump if error or ambiguous name found

	PUSH	DE			; save FCB pointer
	CALL	LAB_065D		; find file ??
	POP	DE			; restore FCB pointer
	JR	NC,LAB_0874		; if file found flag failed & exit

	PUSH	DE			; save FCB pointer
	LD	HL,000Ch		; offset to EX
	ADD	HL,DE			; add FCB
	LD	(HL),#00h		; clear EX
	CALL	LAB_0623		; create file ??
	POP	DE			; restore FCB pointer
	JR	C,LAB_0874		; if ?? flag failed & exit

	CALL	LAB_F501		; copy FCB_buffer, LAB_FF7F, to FCB (LAB_3A1E)
	XOR	A			; flag ok
	RET				;

LAB_086E
	LD	A,#27h		; byte was 7Fh, 72h or 73h
	CALL	LAB_09CA	;0870:	CDCA09
	RET				;

LAB_0874
	LD	A,#FFh		; flag failed
	RET				;

; BDOS function 15 - open file
;
; DE=FCB address. Returns error codes in BA and HL. 
; This function opens a file to read or read/write. 
; The FCB should have its DR, Fn and Tn fields filled in, and the four fields EX, 
; S1, S2 and RC set to zero. Note that CR should normally be reset to zero if
; sequential access is to be used. 
; 
; On return from this function, A is 0FFh for error, or 0-3 for success. Some 
; versions always return zero; others return 0-3 to indicate 
; that an image of the directory entry is to be found at (80h+20h*A). 

LAB_0877
	CALL	LAB_F4EB		; copy FCB to FCB_buffer, LAB_FF7F (LAB_3A08)
	CALL	LAB_0824		; get byte from LAB_FE93+first copied byte
					; return C=1 and error # FDh if out of range
	CP	#00h			; was it null byte (could OR A)
	JR	NZ,LAB_0894		; jump if not

	PUSH	DE			; save FCB pointer
	CALL	LAB_068D		; convert filename in FCB to upper case ASCII
	POP	DE			; restore FCB pointer
	INC	A			; increment result
	JR	Z,LAB_089A		; branch if error

	XOR	A			; clear A
	CALL	LAB_06C1	;088A:	CDC106
	JR	C,LAB_089A		; if ?? flag failed and exit

	CALL	LAB_F501		; copy FCB_buffer, LAB_FF7F, to FCB (LAB_3A1E)
	XOR	A			; flag ok
	RET				;

LAB_0894
	LD	A,#20h		; byte was 7Fh, 72h or 73h
	CALL	LAB_09CA	;0896:	CDCA09
	RET				;

LAB_089A
	LD	A,#FFh		; flag failed
	RET				;

; BDOS function 16 - close file
;
; DE=FCB address. Returns error codes in BA and HL. 
; This function closes a file, and writes any pending data. This function should 
; always be used when a file has been written to. 
; On return from this function, A is 0FFh for error, or 0-3 for success. Some 
; versions always return zero; others return 0-3 to indicate that an image of the 
; directory entry is to be found at (80h+20h*A). 

LAB_089D
	CALL	LAB_F4EB		; copy FCB to FCB_buffer, LAB_FF7F (LAB_3A08)
	CALL	LAB_0824		; get byte from LAB_FE93+first copied byte
					; return C=1 and error # FDh if out of range
	CP	#00h			; was it null byte (could OR A)
	JR	NZ,LAB_08B7		; jump if not

	PUSH	DE			; save pointer
	CALL	LAB_068D		; convert filename in FCB to upper case ASCII
	POP	DE			; restore pointer
	AND	A			; set the flags
	JR	NZ,LAB_08BD		; jump if error or ambiguous filename

	SCF			;08AF:	37
	CALL	LAB_06C1	;08B0:	CDC106
	JR	C,LAB_08BD		; if ?? flag failed and exit

	XOR	A			; flag ok
	RET				;

LAB_08B7
	LD	A,#21h		; byte was 7Fh, 72h or 73h
	CALL	LAB_09CA	;08B9:	CDCA09
	RET				;

LAB_08BD
	LD	A,#FFh		; flag failed
	RET				;

; BDOS function 19 - delete file
;
; DE=address of FCB. Returns error codes in BA and HL. 
; Deletes all directory entries matching the specified filename. The name can 
; contain ? marks. Returns A=0FFh if error, otherwise 0-3 . 

LAB_08C0
	CALL	LAB_F4EB		; copy FCB to FCB_buffer, LAB_FF7F (LAB_3A08)
	CALL	LAB_0824		; get byte from LAB_FE93+first copied byte
					; return C=1 and error # FDh if out of range
	CP	#00h			; was it null byte (could OR A)
	JR	NZ,LAB_090A		; jump if not

	PUSH	DE			; save FCB pointer
	CALL	LAB_068D		; convert filename in FCB to upper case ASCII
	POP	DE			; restore CB pointer
	INC	A			; increment result
	LD	A,#FFh		; flag failed
	RET	Z			; exit if error

					; no error in filename
	LD	HL,000Ch		; offset to EX
	ADD	HL,DE			; add FCB pointer
	LD	(HL),#3Fh		; set EX byte
	PUSH	DE			; save FCB pointer
	CALL	LAB_065D		; find file ??
	POP	DE			; restore FCB pointer
	LD	A,#FFh		; flag failed
	RET	C			; exit if file not found

LAB_08E1
	PUSH	DE			; save FCB pointer
	LD	(HL),#E5h	;08E2:	36E5
	LD	DE,0010h	;08E4:	111000
	ADD	HL,DE		;08E7:	19
	LD	B,#08h		;08E8:	0608
LAB_08EA
	LD	E,(HL)		;08EA:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;08EC:	56
	INC	HL			; increment pointer
	LD	A,E			; copy low byte
	OR	D			; OR high byte
	JR	Z,LAB_08F9		; do next if = 0000h

	PUSH	HL		;08F2:	E5
	PUSH	BC		;08F3:	C5
	CALL	LAB_07D7	;08F4:	CDD707
	POP	BC		;08F7:	C1
	POP	HL		;08F8:	E1

LAB_08F9
	DJNZ	LAB_08EA		; loop until all 8 done

	SCF			;08FB:	37
	CALL	LAB_06DC	;08FC:	CDDC06
	POP	DE			; restore pointer
	PUSH	DE			; save pointer (could lose both lines)
	CALL	LAB_0685	;0901:	CD8506
	POP	DE			; restore pointer
	JR	NC,LAB_08E1	;0905:	30DA

	LD	A,#00h		; flag ok
	RET				;

LAB_090A
	LD	A,#24h		; byte was 7Fh, 72h or 73h
	CALL	LAB_09CA	;090C:	CDCA09
	RET				;

; BDOS function 23 - Rename file
;
; DE=address of FCB. Returns error codes in BA and HL. 
; Renames the file specified to the new name, stored at FCB+16. This function 
; cannot rename across drives so the "drive" bytes of both filenames should be 
; identical. Returns A=0-3 if successful; A=0FFh if error. 

LAB_0910
	CALL	LAB_F4EB		; copy FCB to FCB_buffer, LAB_FF7F (LAB_3A08)
	CALL	LAB_0824		; get byte from LAB_FE93+first copied byte
					; return C=1 and error # FDh if out of range
	PUSH	DE			; save FCB pointer
	PUSH	AF			; save byte
	LD	HL,0010h		; offset to new file name
	ADD	HL,DE			; add FCB pointer
	EX	DE,HL			; swap to DE
	CALL	LAB_0824		; get byte from LAB_FE93+first copied byte
					; return C=1 and error # FDh if out of range
	POP	BC			; restore byte
	CP	B			; compare with new
	JR	NZ,LAB_0968		; jump if <> (different drives)

					; files on the sam edrive
	CP	#00h			; was it (default drive) null ? (could OR A)
	JR	NZ,LAB_0961		; jump if not

	PUSH	DE			; save rename FCB pointer
	CALL	LAB_068D		; convert filename in FCB to upper case ASCII
	POP	DE			; restore rename FCB pointer
	CP	#00h			; compare with ok (could just OR A)
	JR	NZ,LAB_0968		; jump if error or '?' found in filename

	CALL	LAB_0976		; go do search first
	CP	#FFh			; was there an error ?
	JR	NZ,LAB_0968		; jump if not (file exists!)

	POP	DE			; restore original FCB pointer
	PUSH	DE			; save FCB pointer
	CALL	LAB_068D		; convert filename in FCB to upper case ASCII
	CP	#00h			; compare with ok (could just OR A)
	JR	NZ,LAB_0968		; jump if error or '?' found in filename

	POP	DE			; restore FCB pointer
	PUSH	DE			; save FCB pointer
	CALL	LAB_0976		; go do search first
	CP	#FFh			; was there an error ?
	JR	Z,LAB_0968		; jump if so

					; file found
LAB_094A
	LD	(LAB_F941),A	; save directory image #
	POP	DE			; restore FCB pointer
	PUSH	DE			; save FCB pointer
	CALL	LAB_0AE2		; copy new name from FCB+10h to LAB_F8B9+(A*20h)
					; then copy 80h bytes to/from block ??
	CALL	LAB_0976		; go do search first
	CP	#FFh			; was there an error ?
	JR	NZ,LAB_094A		; loop if not

	POP	DE			; restore FCB pointer
	CALL	LAB_F501		; copy FCB_buffer, LAB_FF7F, to FCB (LAB_3A1E)
	LD	A,(LAB_F941)	;095D:	3A41F9
	RET				;

LAB_0961
	POP	DE			; restore FCB pointer
	LD	A,#28h		;0962:	3E28
	CALL	LAB_09CA	;0964:	CDCA09
	RET				;

LAB_0968
	POP	DE			; restore FCB pointer
	LD	A,#FFh		; flag failed
	RET				;

; BDOS function 17 - search first
;
; DE=address of FCB. Returns error codes in BA and HL. 
; Search for the first occurrence of the specified file; the filename should be 
; stored in the supplied FCB. The filename can include ? marks, which match 
; anything on disc. If the first byte of the FCB is ?, then any directory entry 
; (including disc labels, date stamps etc.) will match. The EX byte is also 
; checked; normally it should be set to zero, but if it is set to ? then all 
; suitable extents are matched. 
; Returns A=0FFh if error, or A=0-3 if successful. The value returned can be used
; to calculate the address of a memory image of the directory entry; it is to be
; found at DMA+A*32.

LAB_096C
	CALL	LAB_F4EB		; copy FCB to FCB_buffer, LAB_FF7F (LAB_3A08)
	CALL	LAB_0824		; get byte from LAB_FE93+first copied byte
					; return C=1 and error # FDh if out of range
	CP	#00h			; was it null byte (could OR A)
	JR	NZ,LAB_099D		; jump if not

LAB_0976
	PUSH	DE			; save FCB pointer
	CALL	LAB_068D		; convert filename in FCB to upper case ASCII
	POP	DE			; restore FCB pointer
	CP	#FFh			; compare with error
	JR	Z,LAB_099A		; jump if error (could RET Z)

	LD	HL,000Ch		; offset to EX
	ADD	HL,DE			; add FCB pointer
	LD	A,(HL)		; get EX byte
	PUSH	HL			; save EX pointer
	PUSH	AF			; save EX byte
	LD	(HL),#3Fh		; put '?' in
	CALL	LAB_065D		; find file ??
LAB_098B
	JR	C,LAB_0997		; error exit if file not found

	POP	AF			; restore EX byte
	POP	HL			; restore EX pointer
	LD	(HL),A		; put EX byte back
	CALL	LAB_F535		; copy 80h bytes from LAB_F8B8 to DMA address, page
					; (LAB_FEFE) (LAB_3A52)
	LD	A,(LAB_F93C)	;0993:	3A3CF9
	RET				;

LAB_0997
	POP	AF			; restore EX byte
	POP	HL			; restore EX pointer
	LD	(HL),A		; put EX byte back

LAB_099A
	LD	A,#FFh		; flag failed
	RET				;

LAB_099D
	LD	A,#22h		; byte was 7Fh, 72h or 73h
	CALL	LAB_09CA	;099F:	CDCA09
	RET				;

; BDOS function 18 - search for next
;
; DE=address of FCB. Returns error codes in BA and HL. 
; This function should only be executed immediately after function 17 or another 
; invocation of function 18. No other disc access functions should have been used. 
;
; Function 18 behaves exactly as number 17, but finds the next occurrence of the 
; specified file after the one returned last time. The FCB parameter is not 
; documented, but Jim Lopushinsky states in LD301.DOC: 
;   In none of the official Programmer's Guides for any version of CP/M does it 
;   say that an FCB is required for Search Next (function 18). However, if the FCB 
;   passed to Search First contains an unambiguous file reference (i.e. no 
;   question marks), then the Search Next function requires an FCB passed in reg 
;   DE (for CP/M-80).

LAB_09A3
	CALL	LAB_F4EB		; copy FCB to FCB_buffer, LAB_FF7F (LAB_3A08)
	CALL	LAB_0824		; get byte from LAB_FE93+first copied byte
					; return C=1 and error # FDh if out of range
	CP	#00h			; was it null byte (could OR A)
	JR	NZ,LAB_09C4		; jump if not

	PUSH	DE			; save FCB pointer
	CALL	LAB_068D		; convert filename in FCB to upper case ASCII
	POP	DE			; restore FCB pointer
	CP	#FFh			; compare with error
	JR	Z,LAB_099A		; jump if error (could RET Z)

	LD	HL,000Ch		; offset to EX byte
	ADD	HL,DE			; add FCB pointer
	LD	A,(HL)		; get EX byte
	PUSH	HL			; save EX pointer
	PUSH	AF			; save EX byte
	LD	(HL),#3Fh		; set EX byte to '?'
	CALL	LAB_0685	;09BF:	CD8506
	JR	LAB_098B	;09C2:	18C7

LAB_09C4
	LD	A,#23h		; byte was 7Fh, 72h or 73h
	CALL	LAB_09CA		; (don't need these two lines!)
	RET				; ...!

LAB_09CA
	CALL	LAB_09D8		; fill block LAB_F942 to LAB_F94D with 00h
	LD	(LAB_F942),A	; save byte (20h to 2Ah excluding 28h?)
	CALL	LAB_09F5	;09D0:	CDF509
	RET	C		;09D3:	D8

	CALL	LAB_09E4	;09D4:	CDE409
	RET				;

; fill block LAB_F942 to LAB_F94D with 00h

LAB_09D8
	LD	B,#0Ch		; 0Ch (12d) bytes to do
	LD	HL,LAB_F942		; pointer to start of block

LAB_09DD
	LD	(HL),#00h		; clear byte
	INC	HL			; next byte
	DEC	B			; decrement count
	JR	NZ,LAB_09DD		; loop if not all done (could DJNZ instead!)
	RET				;

LAB_09E4
	CALL	LAB_0ABC	;09E4:	CDBC0A
	CP	#FFh		;09E7:	FEFF
	JR	Z,LAB_09F4	;09E9:	2809
	LD	(LAB_F93C),A	;09EB:	323CF9
	CALL	LAB_F501		; copy FCB_buffer, LAB_FF7F, to FCB (LAB_3A1E)
	LD	A,(LAB_F93C)	;09F1:	3A3CF9
LAB_09F4
	RET				;

LAB_09F5
	CALL	LAB_0A6D		; ?? then setup count & pointer @ LAB_FDEE & LAB_FE12
	RET	C			; exit if error

	PUSH	DE		;09F9:	D5
	CALL	LAB_0AA5		; save 0024h & BC @ HL++++
	LD	(HL),#00h		; save end marker low byte
	INC	HL			; increment pointer
	LD	(HL),#00h		; save end marker high byte
	POP	HL		;0A02:	E1
	CALL	LAB_0AA5		; save 0024h & BC @ HL++++
	LD	DE,LAB_F8B8		; set pointer to 80h byte area
	CALL	LAB_0AB0		; save 0080h & DE & end marker @ HL+++++
	RET				;

LAB_0A0D
	CALL	LAB_0A6D	;0A0D:	CD6D0A
	RET	C			; exit if error

	PUSH	DE		;0A11:	D5
	CALL	LAB_0AA5		; save 0024h & BC @ HL++++
	LD	(HL),#00h		; save end marker low byte
	INC	HL			; increment pointer
	LD	(HL),#00h		; save end marker high byte
	POP	HL		;0A1A:	E1
	CALL	LAB_0AA5		; save 0024h & BC @ HL++++
	XOR	A			; clear A
	LD	(HL),A		; save end marker low byte
	INC	HL			; increment pointer
	LD	(HL),#00h		; save end marker high byte (why not LD (HL),A again!)
	RET				;

LAB_0A24
	CALL	LAB_0A6D	;0A24:	CD6D0A
	RET	C			; exit if error

	PUSH	DE		;0A28:	D5
	CALL	LAB_0AA5		; save 0024h & BC @ HL++++
	PUSH	BC		;0A2C:	C5
	EX	DE,HL		;0A2D:	EB
	LD	HL,(LAB_F94E)	; get pointer
	EX	DE,HL			; swap to DE
	CALL	LAB_0AB0		; save 0080h & DE & end marker @ HL+++++
	POP	BC		;0A35:	C1
	POP	HL		;0A36:	E1
	CALL	LAB_0AA5		; save 0024h & BC @ HL++++
	XOR	A			; clear A
	LD	(HL),A		; save end marker low byte
	INC	HL			; increment pointer
	LD	(HL),#00h		; save end marker high byte (why not LD (HL),A again!)
	RET				;

LAB_0A40
	CALL	LAB_0A6D	;0A40:	CD6D0A
	RET	C			; exit if error

	PUSH	DE		;0A44:	D5
	CALL	LAB_0AA5		; save 0024h & BC @ HL++++
	LD	(HL),#00h		; save end marker low byte
	INC	HL			; increment pointer
	LD	(HL),#00h		; save end marker high byte
	POP	HL		;0A4D:	E1
	CALL	LAB_0AA5		; save 0024h & BC @ HL++++
	EX	DE,HL		;0A51:	EB
	LD	HL,(LAB_F94E)	; get pointer
	EX	DE,HL			; swap pointer to DE
	CALL	LAB_0AB0		; save 0080h & DE & end marker @ HL+++++
	RET				;

LAB_0A5A
	CALL	LAB_0A6D	;0A5A:	CD6D0A
	RET	C			; exit if error

	PUSH	DE		;0A5E:	D5
	LD	(HL),#00h	;0A5F:	3600
	INC	HL			; increment pointer
	LD	(HL),#00h	;0A62:	3600
	POP	HL		;0A64:	E1
	LD	HL,(LAB_F94E)	; get pointer
	EX	DE,HL			; swap pointer to DE
	CALL	LAB_0AB0		; save 0080h & DE & end marker @ HL+++++
	RET				;

; ?? then setup count & pointer @ LAB_FDEE & LAB_FE12

LAB_0A6D
	PUSH	DE		;0A6D:	D5
	LD	DE,LAB_F942		; pointer to buffer
	CALL	LAB_2EAB	;0A71:	CDAB2E
					; if no error returns ..
					; HL = LAB_FDEE
					; DE = LAB_FE12
	JR	C,LAB_0A97		; jump if there was an error

	POP	BC		;0A76:	C1
	PUSH	DE		;0A77:	D5
	LD	DE,0006h		; set count ??
	CALL	LAB_0AA0		; save count @ HL++
	LD	DE,LAB_F942		; set pointer ??
	CALL	LAB_0AA0		; save pointer @ HL++
	POP	DE		;0A84:	D1
	EX	DE,HL		;0A85:	EB
	PUSH	DE		;0A86:	D5
	LD	DE,0006h		; set count ??
	CALL	LAB_0AA0		; save count @ HL++
	LD	DE,LAB_F948		; set pointer ??
	CALL	LAB_0AA0		; save pointer @ HL++
	POP	DE		;0A93:	D1
	EX	DE,HL		;0A94:	EB
	XOR	A			; flag no error
	RET				;

LAB_0A97
	RST	28h			; process error code, error code is in A
	JR	C,LAB_0A9D		; jump if retry requested

	POP	BC		;0A9A:	C1
	SCF				; flag error
	RET				;

LAB_0A9D
	POP	DE		;0A9D:	D1
	JR	LAB_0A6D		; go try again

; save DE @ HL++

LAB_0AA0
	LD	(HL),E		; save E
	INC	HL			; increment pointer
	LD	(HL),D		; save D
	INC	HL			; increment pointer
	RET				;

; save 0024h & BC @ HL++++

LAB_0AA5
	LD	E,C			; copy C
	LD	D,B			; copy B
	PUSH	BC			; save BC
	LD	BC,0024h		; set count = 0024h
	CALL	LAB_081B		; save count & DE @ HL++++
	POP	BC			; restore BC
	RET				;

; save 0080h & DE & end marker @ HL+++++

LAB_0AB0
	LD	BC,0080h		; set count = 0080h
	CALL	LAB_081B		; save count & DE @ HL++++
	XOR	A			; clear A
	LD	(HL),A		; save end marker low byte
	INC	HL			; increment pointer
	LD	(HL),#00h		; save end marker high byte (why not LD (HL),A again!)
	RET				;

LAB_0ABC
	LD	HL,LAB_0839		; set vector
	CALL	LAB_2F1A	;0ABF:	CD1A2F
	JR	C,LAB_0ADE		; jump if error

	LD	C,#0Bh		; set mask to xxxx 1x11
	LD	HL,0040h		; set count
	CALL	LAB_168F	;0AC9:	CD8F16
	LD	B,A		;0ACC:	47
	AND	#01h			; mask 0000 000x
	LD	A,#EEh		; error EEh ??
	JR	Z,LAB_0ADE	;0AD1:	280B

	LD	A,(LAB_F93E)	;0AD3:	3A3EF9
	CP	#FFh		;0AD6:	FEFF
	RET	Z		;0AD8:	C8

	CP	#DFh		;0AD9:	FEDF
	JR	C,LAB_0ADE	;0ADB:	3801
	RET				;

LAB_0ADE
	RST	28h			; process error code, error code is in A
	JR	C,LAB_0ABC		; jump if retry requested ??

	RET				;

; copy new name from FCB+10h to LAB_F8B9+(A*20h)
; then copy 80h bytes to/from block ??

LAB_0AE2
	PUSH	DE			; save FCB pointer
	LD	HL,0010h		; offset to allocation image
	ADD	HL,DE			; add FCB pointer to offset
	EX	DE,HL			; swap FCB pointer+offset to DE
	PUSH	DE			; save FCB pointer+offset
	LD	HL,LAB_F8B8		; set pointer to 80h byte area
	LD	DE,0020h		; set image # offset
LAB_0AEF
	CP	#00h			; count = 0? (could OR A)
	JR	Z,LAB_0AF7		; jump if done

	ADD	HL,DE			; else add image # offset to pointer
	DEC	A			; decrement count
	JR	LAB_0AEF		; loop

LAB_0AF7
	POP	DE			; restore FCB pointer+offset
	INC	DE			; increment it
	INC	HL			; increment directory image pointer
	LD	B,#0Bh		; 11 bytes to do
LAB_0AFC
	LD	A,(DE)		; get byte
	LD	(HL),A		; copy byte
	INC	DE			; increment source
	INC	HL			; increment destination
	DEC	B			; decrement count
	JR	NZ,LAB_0AFC		; loop until all done

	SCF				; set carry
	CALL	LAB_06DC	;0B04:	CDDC06
	POP	DE			; restore FCB pointer
	RET				;

; BDOS function 21 - write next record
;
; DE=address of FCB. Returns error codes in BA and HL. 
; Write a record (normally 128 bytes, but can be a multiple of 128 bytes) to be 
; found at previously specified DMA address. Values returned in A are: 
;   0		OK, 
;   1		directory full, 
;   2		disk full, 
;   9		invalid FCB, 
;   10	media changed, 
;   FFh	hardware error. 

LAB_0B09
	CALL	LAB_F4EB		; copy FCB to FCB_buffer, LAB_FF7F (LAB_3A08)
	CALL	LAB_0824		; get byte from LAB_FE93+first copied byte
					; return C=1 and error # FDh if out of range
	CP	#00h			; was it null byte
	JR	NZ,LAB_0B86		; jump if not

	CALL	LAB_0494		; do CP (CR),(RC)
	JR	C,LAB_0B1A	;0B16:	3802

	JR	NZ,LAB_0B83		; if ?? flag directory full and exit

LAB_0B1A
	PUSH	DE			; save FCB pointer
	CALL	LAB_046C	;0B1B:	CD6C04
	PUSH	BC			;0B1E:	C5
	JR	NZ,LAB_0B2B	;0B1F:	200A

	PUSH	HL		;0B21:	E5
	CALL	LAB_0795		; test (LAB_F823)>(LAB_F82C) if so find next bit
					; not set and set it
	POP	HL		;0B25:	E1
	JR	C,LAB_0B7E		; if ?? go flag disk full & exit

	LD	(HL),E		;0B28:	73
	INC	HL			; increment pointer
	LD	(HL),D		;0B2A:	72

LAB_0B2B
	PUSH	DE		;0B2B:	D5
	CALL	LAB_F510		; copy 128 byte block from DMA address, page (LAB_FEFE) to
					; LAB_FEFF (LAB_3A2D)
	POP	DE		;0B2F:	D1
	POP	BC		;0B30:	C1
	SCF				; flag write sector
	CALL	LAB_F4C6		; copy sector BC to/from (HL) ??
					; if Cb=0=from (read) else Cb=1=to (write)
	POP	DE			; restore FCB pointer
	CALL	LAB_0494		; do CP (CR),(RC)
	PUSH	DE			; save FCB pointer
	JR	C,LAB_0B3E	;0B3A:	3802

	INC	A		;0B3C:	3C
	LD	(HL),A		;0B3D:	77
LAB_0B3E
	CALL	LAB_0488		; do CP (LAB_F825),+(CR)
	POP	DE			; restore FCB pointer
	JR	NC,LAB_0B79	;0B42:	3035

	PUSH	DE			; save FCB pointer
	SCF			;0B45:	37
	CALL	LAB_06C1	;0B46:	CDC106
	POP	DE			; restore FCB pointer
	LD	A,#01h		;0B4A:	3E01
	RET	C		;0B4C:	D8

	PUSH	DE			; save FCB pointer (not needed)
	LD	HL,000Ch		; offset to EX byte
	ADD	HL,DE			; add FCB pointer
	POP	DE			; restore FCB pointer (not needed)
	INC	(HL)			; increment EX byte
	LD	A,(HL)		; get EX byte
	CP	#20h			; compare with 20h
	JR	C,LAB_0B5D		; jump if <20h

	LD	A,#FFh		; set error FFh
	RST	28h			; process error code, error code is in A
	RET				;

LAB_0B5D
	PUSH	DE			; save FCB pointer
	XOR	A			; clear A
	CALL	LAB_06C1	;0B5F:	CDC106
	POP	DE			; restore FCB pointer
	JR	C,LAB_0B6F	;0B63:	380A

LAB_0B65
	PUSH	DE			; save FCB pointer (not needed)
	LD	HL,0020h		; offset to CR byte
	ADD	HL,DE			; add FCB pointer
	POP	DE			; restore FCB pointer (not needed)
	LD	(HL),#00h		; clear CR byte
	JR	LAB_0B79	;0B6D:	180A

LAB_0B6F
	PUSH	DE			; save FCB pointer
	CALL	LAB_0623		; create file ??
	POP	DE			; restore FCB pointer
	JR	NC,LAB_0B65	;0B74:	30EF

	LD	A,#01h		; flag directory full
	RET				;

LAB_0B79
	CALL	LAB_F501		; copy FCB_buffer, LAB_FF7F, to FCB (LAB_3A1E)
	XOR	A			; clear A
	RET				;

LAB_0B7E
	POP	BC		;0B7E:	C1
	POP	DE		;0B7F:	D1
	LD	A,#02h		; flag disk full
	RET				;

LAB_0B83
	LD	A,#01h		; flag directory full
	RET				;

LAB_0B86
	CALL	LAB_0C96	;0B86:	CD960C
	LD	A,#26h		; byte was 7Fh, 72h or 73h
	CALL	LAB_0C9F	;0B8B:	CD9F0C
	RET				;

; BDOS function 20 - read next record
;
; DE=address of FCB. Returns error codes in BA and HL. 
; 
; Load a record at the previously specified DMA address. Values returned in A are: 
;   0		OK, 
;   1		end of file, 
;   9		invalid FCB, 
;   10	media changed, 
;   FFh	hardware error. 

LAB_0B8F
	CALL	LAB_F4EB		; copy FCB to FCB_buffer, LAB_FF7F (LAB_3A08)
	CALL	LAB_0824		; get byte from LAB_FE93+first copied byte
					; return C=1 and error # FDh if out of range
	CP	#00h			; was it null byte (could OR A)
	JR	NZ,LAB_0BED		; jump if not

	CALL	LAB_0494		; do CP (CR),(RC)
	JR	NC,LAB_0BEA		; jump if CR byte > RC byte [EOF]

					; wasn't [EOF] so ..
	PUSH	DE			; save FCB pointer
	CALL	LAB_046C	;0B9F:	CD6C04
	JR	Z,LAB_0BE9		; if ??, restore FCB pointer, flag [EOF] & exit

	PUSH	DE		;0BA4:	D5
	PUSH	BC		;0BA5:	C5
	CALL	LAB_F543		; return Cb=1, HL=LAB_FEFF if DMA address >7FFFh (LAB_3A60)
	POP	BC		;0BA9:	C1
	POP	DE		;0BAA:	D1
	XOR	A			; flag read sector
	CALL	LAB_F4C6		; copy sector BC to/from (HL) ??
					; if Cb=0=from (read) else Cb=1=to (write)
	POP	DE			; restore FCB pointer
	PUSH	DE			; save FCB pointer (not needed, done in routine)
	CALL	LAB_0488		; do CP (LAB_F825),+(CR)
	POP	DE			; restore FCB pointer (not needed, done in routine)
	JR	NC,LAB_0BE1	;0BB5:	302A

	PUSH	DE			; save FCB pointer
	SCF			;0BB8:	37
	CALL	LAB_06C1	;0BB9:	CDC106
	POP	DE			; restore FCB pointer
	LD	A,#03h		;0BBD:	3E03
	RET	C		;0BBF:	D8

	PUSH	DE			; save FCB pointer
	LD	HL,000Ch		; offset to EX byte
	ADD	HL,DE			; add FCB pointer
	POP	DE			; restore FCB pointer
	INC	(HL)			; increment EX byte
	LD	A,(HL)		; get EX byte
	CP	#20h			;0BC8:	FE20
	JR	C,LAB_0BD0	;0BCA:	3804

	LD	A,#FFh		; bugger! hardware error!?
	RST	28h			; process error code, error code is in A
	RET				;

LAB_0BD0
	PUSH	DE			; save FCB pointer
	XOR	A		;0BD1:	AF
	CALL	LAB_06C1	;0BD2:	CDC106
	POP	DE		;0BD5:	D1
	LD	A,#01h		; flag [EOF]
	RET	C		;0BD8:	D8

	PUSH	DE			; save FCB pointer
	LD	HL,0020h		; offset to CR byte
	ADD	HL,DE			; add FCB pointer
	POP	DE			; restore FCB pointer
	LD	(HL),#00h		; clear CR byte

LAB_0BE1
	CALL	LAB_F523		; copy 128 byte block from LAB_FEFF, page (LAB_FEFE) to
					; DMA address (LAB_3A40)
	CALL	LAB_F501		; copy FCB_buffer, LAB_FF7F, to FCB (LAB_3A1E)
	XOR	A			; flag ok
	RET				;

LAB_0BE9
	POP	DE			; restore FCB pointer

LAB_0BEA
	LD	A,#01h		; flag [EOF]
	RET				;

LAB_0BED
	LD	A,#25h		; byte was 7Fh, 72h or 73h
	CALL	LAB_0CA7	;0BEF:	CDA70C
	RET				;

; BDOS function 34 - Random access write record
;
; DE=FCB address. Returns error codes in BA and HL. 
; Write the record specified in the random record count area of the FCB, at the 
; DMA address. The pointers in the FCB will be updated so that the next record to 
; write using the sequential I/O calls will be the record just written. Error 
; numbers returned are: 
;   0		OK 
;   2		Disc full 
;   3		Cannot close extent 
;   5		Directory full 
;   6		Record number out of range 
;   9		Invalid FCB 
;   10	Media changed 
; If the record indicated is beyond the end of the file, the record will be 
; written and the file may contain a gap; attempting to read this gap may give 
; "reading unwritten data" errors, or nonsense. 

LAB_0BF3
	CALL	LAB_F4EB		; copy FCB to FCB_buffer, LAB_FF7F (LAB_3A08)
	CALL	LAB_0824		; get byte from LAB_FE93+first copied byte
					; return C=1 and error # FDh if out of range
	CP	#00h			; was it null byte (could OR A)
	JR	NZ,LAB_0C47		; jump if not

	PUSH	DE			; save FCB pointer
	CALL	LAB_042D	;0BFE:	CD2D04
	POP	DE			; restore FCB pointer
	RET	C		;0C02:	D8

	JR	Z,LAB_0C15	;0C03:	2810

	PUSH	DE			; save FCB pointer
	XOR	A		;0C06:	AF
	CALL	LAB_06C1	;0C07:	CDC106
	POP	DE			; restore FCB pointer
	JR	NC,LAB_0C15	;0C0B:	3008
	PUSH	DE			; save FCB pointer
	CALL	LAB_0623		; create file ??
	POP	DE			; restore FCB pointer
	LD	A,#05h		;0C12:	3E05
	RET	C		;0C14:	D8

LAB_0C15
	PUSH	DE			; save FCB pointer
	CALL	LAB_0494		; do CP (CR),(RC)
	CALL	LAB_046C	;0C19:	CD6C04
	JR	NZ,LAB_0C2E	;0C1C:	2010
	PUSH	HL		;0C1E:	E5
	PUSH	BC		;0C1F:	C5
	CALL	LAB_0795		; test (LAB_F823)>(LAB_F82C) if so find next bit
					; not set and set it
	POP	BC		;0C23:	C1
	POP	HL		;0C24:	E1
	JR	NC,LAB_0C2B	;0C25:	3004
	POP	DE			; restore FCB pointer
	LD	A,#02h		;0C28:	3E02
	RET	C		;0C2A:	D8

LAB_0C2B
	LD	(HL),E		;0C2B:	73
	INC	HL			; increment pointer
	LD	(HL),D		;0C2D:	72

LAB_0C2E
	POP	HL		;0C2E:	E1
	PUSH	DE		;0C2F:	D5
	EX	DE,HL		;0C30:	EB
	CALL	LAB_0494		; do CP (CR),(RC)
	JR	C,LAB_0C38	;0C34:	3802
	INC	A		;0C36:	3C
	LD	(HL),A		;0C37:	77

LAB_0C38
	PUSH	BC		;0C38:	C5
	CALL	LAB_F510		; copy 128 byte block from DMA address, page (LAB_FEFE) to
					; LAB_FEFF (LAB_3A2D)
	POP	BC		;0C3C:	C1
	POP	DE		;0C3D:	D1
	SCF				; flag write sector
	CALL	LAB_F4C6		; copy sector BC to/from (HL) ??
					; if Cb=0=from (read) else Cb=1=to (write)
	CALL	LAB_F501		; copy FCB_buffer, LAB_FF7F, to FCB (LAB_3A1E)
	XOR	A		;0C45:	AF
	RET				;

LAB_0C47
	CALL	LAB_0C96	;0C47:	CD960C
	LD	A,#2Ah		; byte was 7Fh, 72h or 73h
	CALL	LAB_0C9F	;0C4C:	CD9F0C
	RET				;

; BDOS function 33 - Random access read record
;
; DE=FCB address. Returns error codes in BA and HL. 
; Read the record specified in the random record count area of the FCB, at the DMA 
; address. The pointers in the FCB will be updated so that the next record to read 
; using the sequential I/O calls will be the record just read. Error numbers 
; returned are: 
;   0		OK 
;   1		Reading unwritten data 
;   4		Reading unwritten extent (a 16k portion of file does not exist) 
;   6		Record number out of range 
;   9		Invalid FCB 
;   10	Media changed 

LAB_0C50
	CALL	LAB_F4EB		; copy FCB to FCB_buffer, LAB_FF7F (LAB_3A08)
	CALL	LAB_0824		; get byte from LAB_FE93+first copied byte
					; return C=1 and error # FDh if out of range
	CP	#00h			; was it null byte (could OR A)
	JR	NZ,LAB_0C8D		; jump if not

	PUSH	DE			; save FCB pointer
	CALL	LAB_042D	;0C5B:	CD2D04
	POP	DE			; restore FCB pointer
	RET	C		;0C5F:	D8

	JR	Z,LAB_0C6F	;0C60:	280D

	PUSH	DE			; save FCB pointer
	CALL	LAB_06C1	;0C63:	CDC106
	POP	DE			; restore FCB pointer
	LD	A,#04h		;0C67:	3E04
	RET	C		;0C69:	D8

	PUSH	DE			; save FCB pointer
	CALL	LAB_F501		; copy FCB_buffer, LAB_FF7F, to FCB (LAB_3A1E)
	POP	DE			; restore FCB pointer

LAB_0C6F
	CALL	LAB_0494		; do CP (CR),(RC)
	JR	C,LAB_0C77	;0C72:	3803

	LD	A,#01h		; flag reading unwritten data
	RET				;

LAB_0C77
	CALL	LAB_046C	;0C77:	CD6C04
	LD	A,#01h		; flag reading unwritten data
	RET	Z		;0C7C:	C8

	PUSH	DE			; save FCB pointer
	PUSH	BC		;0C7E:	C5
	CALL	LAB_F543		; return Cb=1, HL=LAB_FEFF if DMA address >7FFFh (LAB_3A60)
	POP	BC		;0C82:	C1
	POP	DE			; restore FCB pointer
	XOR	A			; flag read sector
	CALL	LAB_F4C6		; copy sector BC to/from (HL) ??
					; if Cb=0=from (read) else Cb=1=to (write)
	CALL	LAB_F523		; copy 128 byte block from LAB_FEFF, page (LAB_FEFE) to
					; DMA address (LAB_3A40)
	XOR	A		;0C8B:	AF
	RET				;

LAB_0C8D
	LD	A,#29h		; byte was 7Fh, 72h or 73h
	CALL	LAB_0CA7	;0C8F:	CDA70C
	CALL	LAB_09E4	;0C92:	CDE409
	RET				;

LAB_0C96
	PUSH	DE		;0C96:	D5
	CALL	LAB_F510		; copy 128 byte block from DMA address, page (LAB_FEFE) to
					; LAB_FEFF (LAB_3A2D)
	LD	(LAB_F94E),HL	;0C9A:	224EF9
	POP	DE		;0C9D:	D1
	RET				;

LAB_0C9F
	CALL	LAB_0A24	;0C9F:	CD240A
	RET	C		;0CA2:	D8
	CALL	LAB_09E4	;0CA3:	CDE409
	RET				;

LAB_0CA7
	CALL	LAB_0A40	;0CA7:	CD400A
	RET	C		;0CAA:	D8
	CALL	LAB_09E4	;0CAB:	CDE409
	PUSH	AF		;0CAE:	F5
	CALL	LAB_F523		; copy 128 byte block from LAB_FEFF, page (LAB_FEFE) to
					; DMA address (LAB_3A40)
	POP	AF		;0CB2:	F1
	RET				;

; BDOS function 36 - Update random access pointer
;
; DE=FCB address. 
; Set the random record count bytes of the FCB to the number of the last record 
; read/written by the sequential I/O calls. 

LAB_0CB4
	CALL	LAB_F4EB		; copy FCB to FCB_buffer, LAB_FF7F (LAB_3A08)
	CALL	LAB_0824		; get byte from LAB_FE93+first copied byte
					; return C=1 and error # FDh if out of range
	CP	#00h			; was it null byte (could OR A)
	JR	NZ,LAB_0CE6		; jump if not

	PUSH	DE		;0CBE:	D5
	LD	HL,000Ch	;0CBF:	210C00
	ADD	HL,DE		;0CC2:	19
	LD	E,(HL)		;0CC3:	5E
	LD	D,#00h		; clear high byte
	LD	A,(LAB_F82A)	;0CC6:	3A2AF8
	CALL	LAB_049F		; do DE<<A. RST 28h if overflow
	POP	HL		;0CCC:	E1
	PUSH	HL		;0CCD:	E5
	LD	BC,0020h	;0CCE:	012000
	ADD	HL,BC		;0CD1:	09
	LD	L,(HL)		;0CD2:	6E
	LD	H,#00h		;0CD3:	2600
	ADD	HL,DE		;0CD5:	19
	EX	DE,HL		;0CD6:	EB
	POP	HL		;0CD7:	E1
	LD	BC,0021h	;0CD8:	012100
	ADD	HL,BC		;0CDB:	09
	LD	(HL),E		;0CDC:	73
	INC	HL			; increment pointer
	LD	(HL),D		;0CDE:	72
	INC	HL			; increment pointer
	LD	(HL),#00h	;0CE0:	3600
	CALL	LAB_F501		; copy FCB_buffer, LAB_FF7F, to FCB (LAB_3A1E)
	RET				;

LAB_0CE6
	LD	A,#29h		; byte was 7Fh, 72h or 73h
	CALL	LAB_0D71	;0CE8:	CD710D
	RET				;

; BDOS function 26 - Set DMA address
;
; DE=address. 
; Set the Direct Memory Access address; a pointer to where CP/M should read or 
; write data. Initially used for the transfer of 128-byte records between memory 
; and disc, but over the years has gained many more functions. 

LAB_0CEC
	EX	DE,HL			; swap DMA address to HL
	LD	(LAB_FFA3),HL	; save it
	RET				;

; BDOS function 35 - Compute file size
;
; DE=FCB address. Returns error codes in BA and HL. 
; Set the random record count bytes of the FCB to the number of 128-byte records 
; in the file. Returns A=0FFh if error (file not found); otherwise A=0.

LAB_0CF1
	CALL	LAB_F4EB		; copy FCB to FCB_buffer, LAB_FF7F (LAB_3A08)
	CALL	LAB_0824		; get byte from LAB_FE93+first copied byte
					; return C=1 and error # FDh if out of range
	CP	#00h			; was it null byte (could OR A)
	JR	NZ,LAB_0D6B		; jump if not

	LD	HL,000Ch		; offset to EX byte
	ADD	HL,DE			; add FCB pointer
	LD	A,(HL)		; get EX byte
	LD	(LAB_F952),A	; save old EX byte
	LD	(HL),#3Fh		; set EX byte to "?" character
	XOR	A		;0D05:	AF
	LD	(LAB_F950),A	;0D06:	3250F9
	PUSH	DE			; save FCB pointer
	CALL	LAB_065D		; find file ??
	POP	DE			; restore FCB pointer
	JR	NC,LAB_0D1B		; jump if file found

	LD	HL,000Ch		; offset to EX byte
	ADD	HL,DE			; add FCB pointer
	LD	A,(LAB_F952)	; get old EX byte
	LD	(HL),A		; restore it
	LD	A,#FFh		; flag error
	RET	C			; return (c always set here)

					; file found
LAB_0D1B
	PUSH	DE			; save FCB pointer
	PUSH	HL		;0D1C:	E5
	LD	HL,000Ch		; offset to EX byte
	ADD	HL,DE			; add FCB pointer
	LD	A,(LAB_F950)	;0D21:	3A50F9
	LD	B,A		;0D24:	47
	LD	A,(HL)		;0D25:	7E
	CP	B		;0D26:	B8
	POP	HL		;0D27:	E1
	JR	C,LAB_0D35	;0D28:	380B

	LD	(LAB_F950),A	;0D2A:	3250F9
	LD	DE,000Fh	;0D2D:	110F00
	ADD	HL,DE		;0D30:	19
	LD	A,(HL)		;0D31:	7E
	LD	(LAB_F951),A	;0D32:	3251F9

LAB_0D35
	POP	DE			; restore FCB pointer
	PUSH	DE			; save FCB pointer
	CALL	LAB_0685	;0D37:	CD8506
	POP	DE			; restore FCB pointer
	JR	NC,LAB_0D1B	;0D3B:	30DE

	PUSH	DE			; save FCB pointer
	LD	A,(LAB_F950)	;0D3E:	3A50F9
	LD	E,A		;0D41:	5F
	LD	D,#00h		;0D42:	1600
	LD	A,(LAB_F82A)	;0D44:	3A2AF8
	CALL	LAB_049F		; do DE<<A. RST 28h if overflow
	LD	A,(LAB_F951)	;0D4A:	3A51F9
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	ADD	HL,DE		;0D50:	19
	PUSH	HL		;0D51:	E5
	POP	BC		;0D52:	C1
	POP	DE			; restore FCB pointer
	LD	HL,000Ch		; offset to EX byte
	ADD	HL,DE			; add FCB pointer
	LD	A,(LAB_F952)	; get old EX byte
	LD	(HL),A		; restore it
	LD	HL,0021h	;0D5C:	212100
	ADD	HL,DE			; add FCB pointer
	LD	(HL),C		;0D60:	71
	INC	HL			; increment pointer
	LD	(HL),B		;0D62:	70
	XOR	A		;0D63:	AF
	INC	HL		;0D64:	23
	LD	(HL),A		;0D65:	77
	CALL	LAB_F501		; copy FCB_buffer, LAB_FF7F, to FCB (LAB_3A1E)
	XOR	A			; flak ok
	RET				;

LAB_0D6B
	LD	A,#2Bh		; byte was 7Fh, 72h or 73h
	CALL	LAB_0D71	;0D6D:	CD710D
	RET				;

LAB_0D71
	CALL	LAB_0A0D	;0D71:	CD0D0A
	RET	C		;0D74:	D8

	CALL	LAB_09E4	;0D75:	CDE409
	RET				;

LAB_0D79
	CALL	LAB_0C96	;0D79:	CD960C
	LD	A,E			; copy drive #
	CP	#00h			; compare with default marker
	JR	NZ,LAB_0D84		; skip get current drive if not 0

	LD	A,(LAB_FBC6)	; get current drive #

LAB_0D84
	CALL	LAB_3205		; if A<10h return HL=LAB_FE93+A, else return A=FDh C=1
	LD	A,(HL)		;0D87:	7E
	CP	#00h		;0D88:	FE00
	JR	NZ,LAB_0DAC	;0D8A:	2020

	LD	HL,(LAB_F82C)	;0D8C:	2A2CF8
	EX	DE,HL		;0D8F:	EB
	LD	HL,(LAB_F823)	;0D90:	2A23F8
	LD	A,L		;0D93:	7D
	SUB	E		;0D94:	93
	LD	E,A		;0D95:	5F
	LD	A,H		;0D96:	7C
	SBC	A,D		;0D97:	9A
	LD	D,A		;0D98:	57
	LD	HL,(LAB_F94E)	;0D99:	2A4EF9
	PUSH	HL		;0D9C:	E5
	LD	(HL),E		;0D9D:	73
	INC	HL			; increment pointer
	LD	(HL),D		;0D9F:	72
	INC	HL			; increment pointer
	LD	(HL),#00h	;0DA1:	3600
	POP	HL		;0DA3:	E1
	CALL	LAB_0DBF		; add DE to (HL) (LAB_F820)-1 times
	CALL	LAB_F523		; copy 128 byte block from LAB_FEFF, page (LAB_FEFE) to
					; DMA address (LAB_3A40)
	XOR	A		;0DAA:	AF
	RET				;

LAB_0DAC
	LD	A,#2Ch		;0DAC:	3E2C
	CALL	LAB_0DB7	;0DAE:	CDB70D
	PUSH	AF		;0DB1:	F5
	CALL	LAB_F523		; copy 128 byte block from LAB_FEFF, page (LAB_FEFE) to
					; DMA address (LAB_3A40)
	POP	AF		;0DB5:	F1
	RET				;

LAB_0DB7
	CALL	LAB_0A5A	;0DB7:	CD5A0A
	RET	C		;0DBA:	D8
	CALL	LAB_09E4	;0DBB:	CDE409
	RET				;

; add DE to (HL) (LAB_F820)-1 times

LAB_0DBF
	LD	A,(LAB_F820)	;0DBF:	3A20F8
	LD	B,A		;0DC2:	47

LAB_0DC3
	DEC	B		;0DC3:	05
	JR	Z,LAB_0DD6	;0DC4:	2810
	PUSH	HL		;0DC6:	E5
	LD	A,(HL)		;0DC7:	7E
	ADD	A,E		;0DC8:	83
	LD	(HL),A		;0DC9:	77
	INC	HL			; increment pointer
	LD	A,(HL)		;0DCB:	7E
	ADC	A,D		;0DCC:	8A
	LD	(HL),A		;0DCD:	77
	INC	HL			; increment pointer
	LD	A,(HL)		;0DCF:	7E
	ADC	A,#00h		;0DD0:	CE00
	LD	(HL),A		;0DD2:	77
	POP	HL		;0DD3:	E1
	JR	LAB_0DC3	;0DD4:	18ED

LAB_0DD6
	RET	NC		;0DD6:	D0
	LD	A,#00h		;0DD7:	3E00
	RST	28h			; process error code, error code is in A
	RET				;

; reset ?? in/out pointers

LAB_0DDB
	LD	HL,LAB_F95E		; set pointer
	LD	(LAB_F954),HL	; set next ?? out pointer
	LD	(LAB_F956),HL	; set next ?? in pointer
	XOR	A			; clear A
	LD	(LAB_FBC9),A	; clear interrupt flag byte
	RET				;

; BDOS function 1 - console input
;
; returns A=L=character

LAB_0DE9
	CALL	LAB_0E00		; get character from console
	LD	(LAB_F953),A	; save character for out
	LD	(LAB_F97E),A	; save character for display
	LD	A,(LAB_F97C)	; get display on flag ??
	CP	#80h			; display on ?
	JR	NZ,LAB_0DFC		; jump if not
	CALL	LAB_0FA8		; get (LAB_F97E)& do display_2 chr ???

LAB_0DFC
	LD	A,(LAB_F953)	; restore character
	RET				;

; error # 06h return address ??
; get character from console

LAB_0E00
	CALL	LAB_106F		; gets alarm byte & checks alarm flag, returns NZ if
					; no alarm ??
	RET	NZ			; return if there was no alarm ??

	LD	A,#03h		;0E04:	3E03
	LD	(LAB_FBD4),A	;0E06:	32D4FB
	CALL	LAB_0EC8	;0E09:	CDC80E
	LD	C,#00h		;0E0C:	0E00
	AND	#80h			; mask x000 0000
	JR	Z,LAB_0E14	;0E10:	2802
	LD	C,#04h		;0E12:	0E04

LAB_0E14
	LD	A,(LAB_F97C)	;0E14:	3A7CF9
	AND	#7Fh			; mask 0xxx xxxx
	JR	Z,LAB_0E1F	;0E19:	2804

	LD	A,#01h		;0E1B:	3E01
	OR	C		;0E1D:	B1
	LD	C,A		;0E1E:	4F

LAB_0E1F
	LD	A,C		;0E1F:	79
	LD	(LAB_F97B),A	;0E20:	327BF9
	LD	A,(LAB_F97C)	;0E23:	3A7CF9
	AND	#7Fh			; mask 0xxx xxxx
	JR	Z,LAB_0E5D	;0E28:	2833

	LD	HL,(LAB_F954)	; get next ?? out pointer
	LD	DE,(LAB_F956)	; get next ?? in pointer
	SBC	HL,DE			; subtract in from out
	JR	Z,LAB_0E5D		; jump if the same

	LD	A,(LAB_F998)	;0E35:	3A98F9
	OR	A		;0E38:	B7
	JP	Z,LAB_0E43		; get byte from ?? and increment out pointer

	LD	B,A			; save character
	XOR	A			; clear A
	LD	(LAB_F998),A	;0E3E:	3298F9
	LD	A,B			; restore character
	RET				;

; get byte from ?? and increment out pointer

LAB_0E43
	LD	HL,(LAB_F954)	; get next ?? out pointer
	LD	A,(HL)		; get byte
	INC	HL			; increment ?? next out
	LD	(LAB_F954),HL	; save next ?? out pointer
	LD	DE,(LAB_F956)	; get next ?? in pointer
	SBC	HL,DE			; subtract from ?? next out
	RET	NZ			; return if not equal

	LD	HL,LAB_F95E		; else reset ?? in/out
	LD	(LAB_F954),HL	; set next ?? out pointer
	LD	(LAB_F956),HL	; set next ?? in pointer
	JR	LAB_0EC7		; does RET (RET here would be better!)

LAB_0E5D
	LD	A,(LAB_F97B)	;0E5D:	3A7BF9
	AND	#04h			; mask 0000 0x00
	JR	Z,LAB_0E69	;0E62:	2805

	CALL	LAB_18C0		; get key from buffer, returns Z=true if no key
	JR	NZ,LAB_0EC7		; does RET (RET NZ here would be better!)

LAB_0E69
	LD	A,(LAB_F97B)	;0E69:	3A7BF9
	AND	#01h			; mask 0000 000x
	JR	Z,LAB_0EA5	;0E6E:	2835

LAB_0E70
	CALL	LAB_0EE4	;0E70:	CDE40E
	JR	C,LAB_0EE0		; set error # FFh, flag error & RET ??

	LD	B,A		;0E75:	47
	AND	#04h			; mask 0000 0x00
	JR	NZ,LAB_0E9C	;0E78:	2022
	LD	A,B		;0E7A:	78
	AND	#02h			; mask 0000 00x0
	JR	NZ,LAB_0EB6	;0E7D:	2037
	LD	HL,LAB_F958	;0E7F:	2158F9
	LD	A,(HL)		;0E82:	7E
	OR	A		;0E83:	B7
	JR	NZ,LAB_0ED9	;0E84:	2053

	LD	HL,LAB_F95E		; reset pointer
	LD	(LAB_F954),HL	; set next ?? out pointer
	LD	DE,(LAB_F95C)	; get ?? buffer size ??
	LD	A,E			; copy low byte
	LD	(LAB_F998),A	; save ?? buffer size byte ??
	ADD	HL,DE			; add size ?? to pointer
	LD	(LAB_F956),HL	; set next ?? in pointer
	LD	A,#1Bh		;0E98:	3E1B
	JR	LAB_0EC7		; does RET (RET here would be better!)

LAB_0E9C
	CALL	LAB_2ED3	;0E9C:	CDD32E
	NOP			;0E9F:	00
	CALL	LAB_18C0		; get key from buffer, returns Z=true if no key
	JR	LAB_0EC7		; does RET (RET here would be better!)

LAB_0EA5
	LD	A,(LAB_F97B)	;0EA5:	3A7BF9
	LD	C,A		;0EA8:	4F
	CALL	LAB_168F	;0EA9:	CD8F16
	LD	B,A		;0EAC:	47
	AND	#04h			; mask 0000 0x00
	JR	Z,LAB_0EB6	;0EAF:	2805
	CALL	LAB_18C0		; get key from buffer, returns Z=true if no key
	JR	LAB_0EC7		; does RET (RET here would be better!)

LAB_0EB6
	LD	A,B		;0EB6:	78
	AND	#02h			; mask 0000 00x0
	JR	Z,LAB_0EBF		; get byte from LAB_FDC9 and zero source

	LD	A,#1Eh		; else set byte = 1Eh
	JR	LAB_0EC7		; does RET (RET here would be better!)

; get byte from LAB_FDC9 and zero source

LAB_0EBF
	LD	HL,LAB_FDC9		; set pointer
	DI				; disable interrupts
	LD	A,(HL)		; get byte
	LD	(HL),#00h		; zero byte
	EI				; enable interrupts
LAB_0EC7
	RET				;

LAB_0EC8
	LD	A,(LAB_FBC5)	;0EC8:	3AC5FB
	AND	#03h			; mask 0000 00xx
	INC	A			; +1 (1 to 4)
	CALL	LAB_31FF		; if A<10h return HL=base+A, else return A=FDh C=1
					; where if Cb=1 base=LAB_FE83 else base=LAB_FE93, A=A-41h
	LD	A,(HL)		;0ED1:	7E
	LD	(LAB_F97C),A	;0ED2:	327CF9
	LD	(LAB_F978),HL	;0ED5:	2278F9
	RET				;

LAB_0ED9
	LD	HL,LAB_F958	;0ED9:	2158F9
	LD	A,(HL)		;0EDC:	7E
	RST	28h			; process error code, error code is in A
	JR	C,LAB_0E70	;0EDE:	3890

; set error # FFh, flag error & RET ??

LAB_0EE0
	LD	A,#FFh		; set error # ??
	SCF				; flag error ??
	RET				;

LAB_0EE4
	LD	HL,LAB_0FBF		; source pointer
	LD	DE,LAB_F990		; destination pointer
	LD	C,#06h		; 06h bytes to copy
	LD	B,#00h		; ( could do LD BC,0006h!)
	LDIR				; copy block
	LD	HL,(LAB_F978)	;0EF0:	2A78F9
	LD	DE,LAB_F990	;0EF3:	1190F9

LAB_0EF6
	CALL	LAB_2EAB	;0EF6:	CDAB2E
					; if no error returns ..
					; HL = LAB_FDEE
					; DE = LAB_FE12
	JR	C,LAB_0EF6		; jump if there was an error

	LD	(HL),#06h		; save count low byte
	INC	HL			; increment pointer
	LD	(HL),#00h		; save count high byte
	INC	HL			; increment pointer
	LD	BC,LAB_F990		; set pointer
	LD	(HL),C		; save pointer low byte
	INC	HL			; increment pointer
	LD	(HL),B		; save pointer high byte
	INC	HL			; increment pointer
	LD	(HL),#00h		; save end marker low byte
	INC	HL			; increment pointer
	LD	(HL),#00h		; save end marker high byte
	EX	DE,HL		;0F0D:	EB
	LD	(HL),#20h		; save count low byte
	INC	HL			; increment pointer
	LD	(HL),#00h		; save count high byte
	INC	HL			; increment pointer
	LD	DE,LAB_F958		; set pointer
	LD	(HL),E		; save pointer low byte
	INC	HL			; increment pointer
	LD	(HL),D		; save pointer high byte
	INC	HL			; increment pointer
	LD	(HL),#00h		; save end marker low byte
	INC	HL			; increment pointer
	LD	(HL),#00h		; save end marker high byte

LAB_0F20
	LD	HL,LAB_0FA4		; set vector
	CALL	LAB_2F1A	;0F23:	CD1A2F
	JR	NC,LAB_0F2E		; jump if no error

	LD	C,A			; copy error code
	RST	28h			; process error code, error code is in A
	JR	C,LAB_0F20		; jump if retry requested

	SCF				; else just flag error & exit
	RET				;

LAB_0F2E
	LD	A,(LAB_F97B)	;0F2E:	3A7BF9
	LD	C,A		;0F31:	4F
	CALL	LAB_168F	;0F32:	CD8F16
	RET				;

; BDOS function 2 - console output

; E = ASCII character

LAB_0F36
	LD	C,E			; copy to C

; error # 09h return address ??

LAB_0F37
	LD	A,C			; copy to A
	LD	(LAB_F97E),A	; save output character
	CALL	LAB_0EC8	;0F3B:	CDC80E
	AND	#80h			; mask x000 0000
	CALL	NZ,LAB_0FA8		; get (LAB_F97E)& do display_2 chr ???
	LD	A,(LAB_F97C)	;0F43:	3A7CF9
	AND	#7Fh			; mask 0xxx xxxx
	JR	Z,LAB_0F5C		; exit if zero (could RET Z here!)

	LD	A,(LAB_F97C)	;0F4A:	3A7CF9
	AND	#0Ch			; mask 0000 xx00
	CP	#08h		;0F4F:	FE08
	JR	Z,LAB_0F5C		; exit if zero (could RET Z here!)

	LD	A,(LAB_F97E)	;0F53:	3A7EF9
	CALL	LAB_0F5D	;0F56:	CD5D0F
	RET	NC		;0F59:	D0
	LD	A,#FFh		;0F5A:	3EFF

LAB_0F5C
	RET				;

LAB_0F5D
	LD	HL,LAB_F990		; set pointer to ??
	LD	A,#45h		; set byte 'E'
	LD	(HL),A		; save byte
	LD	DE,0004h		; offset
	ADD	HL,DE			; add to pointer
	LD	(HL),#01h		; save byte
	INC	HL			; increment pointer
	LD	(HL),#00h		; save byte
	LD	HL,(LAB_F978)	;0F6C:	2A78F9
	LD	DE,LAB_F990		; set pointer to ??

LAB_0F72
	CALL	LAB_2EAB	;0F72:	CDAB2E
					; if no error returns ..
					; HL = LAB_FDEE
					; DE = LAB_FE12
	JR	C,LAB_0F72		; jump if there was an error

	PUSH	DE			; save DE
	LD	DE,LAB_0FAF		; set source pointer
	EX	DE,HL			; swap to correct register
	LD	BC,000Ah		; 0Ah bytes to copy
	LDIR				; copy block

	POP	DE			; restore DE
	LD	HL,LAB_0FB9		; source pointer
	LD	BC,0006h		; 06h bytes to copy
	LDIR				; copy block

LAB_0F8A
	LD	HL,LAB_0FA4		; set vector
	CALL	LAB_2F1A	;0F8D:	CD1A2F
	JR	NC,LAB_0F98		; jump if no error

	LD	C,A			; else copy error code
	RST	28h			; process error code, error code is in A
	JR	C,LAB_0F8A		; jump if retry requested ??

	SCF				; else just flag error
	RET				;

LAB_0F98
	LD	C,#01h		;0F98:	0E01
	CALL	LAB_168F	;0F9A:	CD8F16
	LD	A,(LAB_F97A)	;0F9D:	3A7AF9
	OR	A		;0FA0:	B7
	RET	Z		;0FA1:	C8
	SCF			;0FA2:	37
	RET				;

LAB_0FA4
	LD	(LAB_F97A),A	;0FA4:	327AF9
	RET				;

; get (LAB_F97E)& do display_2 chr ???

LAB_0FA8
	LD	A,(LAB_F97E)	;0FA8:	3A7EF9
	CALL	LAB_1BEB		; display_2 chr ???
	RET				;

; block copied to LAB_FDEE

LAB_0FAF
	LD	B,#00h	;0FAF:	0600
	SUB	B		;0FB1:	90
	LD	SP,HL		;0FB2:	F9
	LD	BC,7E00h	;0FB3:	01007E
	LD	SP,HL		;0FB6:	F9
	NOP			;0FB7:	00
	NOP			;0FB8:	00

; block copied to LAB_FE12

LAB_0FB9
	LD	B,#00h	;0FB9:	0600
	ADD	A,H		;0FBB:	84
	LD	SP,HL		;0FBC:	F9
	NOP			;0FBD:	00
	NOP			;0FBE:	00

; block copied to LAB_F990

LAB_0FBF
	LD	B,H		;0FBF:	44
	NOP			;0FC0:	00
	NOP			;0FC1:	00
	NOP			;0FC2:	00
	LD	BC,3A00h	;0FC3:	0100

; get key if (LAB_FBC9 AND 2=0, else get FFh
;
; BDOS function 11 - get console status
;
; returns A = 0 if no characters waiting, else returns A <> 0

LAB_0FC5
	LD	A,(LAB_FBC9)	; get console status byte
	AND	#02h			; mask 0000 00x0
	JR	NZ,LAB_0FD3		;0FCA:	2007

	LD	HL,(LAB_FBF0)	; get key buffer next out
	LD	A,(HL)		; get key
	OR	A			; set the flags
	JR	Z,LAB_0FD5		; jump if no character waiting (RET Z here!)

LAB_0FD3
	LD	A,#FFh		; flag character is waiting
LAB_0FD5
	RET				;

; BDOS function 6 - direct console I/O
;
; returns value (if any) in A
;
; E = code
; 0FFh Return a character without echoing if one is waiting; zero if none available 
; 
; Values of E not supported on a particular system will output the character. 

LAB_0FD6
	LD	A,E			; get call code
	CP	#FFh			; comapre with FFh
	JR	Z,LAB_0FDE		; jump if get character

	JP	LAB_0F36		; else do console output

; BDOS direct console input

LAB_0FDE
	CALL	LAB_106F		; gets alarm byte & checks alarm flag, returns NZ if alarm
	RET	NZ			; returns if there was an alarm

	CALL	LAB_0EC8	;0FE2:	CDC80E
	AND	#80h			; mask x000 0000
	JR	Z,LAB_0FEF	;0FE7:	2806

	CALL	LAB_18C0		; get key from buffer, returns Z=true if no key
	OR	A			; set the flags
	JR	NZ,LAB_1014		; go RET if key (RET NZ would be better!) 

					; was no key from buffer so do this ...
LAB_0FEF
	LD	HL,(LAB_F954)	; get next ?? out pointer
	LD	DE,(LAB_F956)	; get next ?? in pointer
	SBC	HL,DE			; subtract in from out
	JP	Z,LAB_0EBF		; if in = out get byte from LAB_FDC9 RET'n

	LD	HL,(LAB_F954)	; get next ?? out pointer
	LD	A,(HL)		; get byte from buffer
	INC	HL			; increment pointer
	LD	(LAB_F954),HL	; save next ?? out pointer
	LD	DE,(LAB_F956)	; get next ?? in pointer
	SBC	HL,DE			; subtract in from out
	JR	NZ,LAB_1014		; exit if in <> out (RET NZ here would be better!)

	LD	HL,LAB_F95E		; reset pointers
	LD	(LAB_F954),HL	; set next ?? out pointer
	LD	(LAB_F956),HL	; set next ?? in pointer
LAB_1014
	RET				;

; BDOS function 5 - printer (lister) output
;
; E = ASCII character

LAB_1015
	LD	A,E		;1015:	7B
	LD	(LAB_F97E),A	;1016:	327EF9
	LD	HL,0007h	;1019:	210700
	LD	(LAB_F98C),HL	;101C:	228CF9
	LD	A,#45h		;101F:	3E45
	LD	(LAB_F990),A	;1021:	3290F9
	LD	HL,0001h	;1024:	210100
	LD	(LAB_F994),HL	;1027:	2294F9
	LD	A,(LAB_F97E)	;102A:	3A7EF9
	LD	(LAB_F996),A	;102D:	3296F9
	LD	HL,0006h	;1030:	210600
	LD	(LAB_F980),HL	;1033:	2280F9
	LD	HL,0000h	;1036:	210000
	LD	(LAB_F982),HL	;1039:	2282F9
	LD	(LAB_F984),HL	;103C:	2284F9
	LD	C,#0Ah		;103F:	0E0A
	LD	B,#00h		;1041:	0600
	LD	HL,LAB_F980	;1043:	2180F9
	LD	DE,LAB_F98C	;1046:	118CF9
	LD	A,(LAB_FBC5)	;1049:	3AC5FB
	AND	#C0h			; mask xx00 0000
	OR	A			; set the flags (allready done by AND ?)
	JR	Z,LAB_1062		; get (LAB_F97E)& do display_2 chr ???

	RLCA			;1051:	07
	RLCA			;1052:	07
	ADD	A,#0Dh		;1053:	C60D
	CALL	LAB_2E02	;1055:	CD022E
LAB_1058
	LD	A,(LAB_F982)	;1058:	3A82F9
	OR	A		;105B:	B7
	JR	Z,LAB_1058	;105C:	28FA
	LD	A,(LAB_F984)	;105E:	3A84F9
	RET				;

; get (LAB_F97E)& do display_2 chr ???

LAB_1062
	LD	A,(LAB_F97E)	;1062:	3A7EF9
	CALL	LAB_1BEB		; display_2 chr ???
	RET				;

LAB_1069
	JP	P,LAB_106C	;1069:	F26C10
LAB_106C
	LD	A,#FEh		;106C:	3EFE
	RST	28h			; process error code, error code is in A

; gets alarm byte & checks alarm flag, returns NZ if alarm

LAB_106F
	LD	A,(LAB_FBC9)	; get interrupt flag byte
	LD	B,A			; copy it
	AND	#02h			; did RTC alarm happen
	RET	Z			; return if not

	LD	A,B			; get interrupt flag byte
	AND	#FDh			; clear RTC alarm flag, mask xxxx xx0x
	LD	(LAB_FBC9),A	; save interrupt flag byte
	LD	A,#1Eh		;107C:	3E1E
	OR	A			; set flags
	RET				;

; BDOS function 3 - AUX (reader) input
;
; restrns A=L=character

LAB_1080
	CALL	LAB_110C	;1080:	CD0C11
	LD	A,(LAB_F999)	;1083:	3A99F9
	CP	#80h		;1086:	FE80
	JP	Z,LAB_10FE		; get key (waits for valid ??)

	LD	A,#01h		;108B:	3E01
	LD	(LAB_F97B),A	;108D:	327BF9
	XOR	A		;1090:	AF
	LD	HL,(LAB_F954)	; get next ?? out pointer
	LD	DE,(LAB_F956)	; get next ?? in pointer
	SBC	HL,DE			; subtract in from out
	JP	Z,LAB_10B4		; jump if in = out

	LD	A,(LAB_F998)	;109D:	3A98F9
	OR	A		;10A0:	B7
	JP	Z,LAB_10AB	;10A1:	CAAB10
	LD	B,A		;10A4:	47
	XOR	A		;10A5:	AF
	LD	(LAB_F998),A	;10A6:	3298F9
	LD	A,B		;10A9:	78
	RET				;

LAB_10AB
	LD	HL,(LAB_F954)	; get next ?? out pointer
	LD	A,(HL)		;10AE:	7E
	INC	HL		;10AF:	23
	LD	(LAB_F954),HL	; save next ?? out pointer
	RET				;

LAB_10B4
	CALL	LAB_0EE4	;10B4:	CDE40E
	RET	C		;10B7:	D8
	AND	#01h		; mask 0000 000x
	JP	Z,LAB_1120		; set carry & RET

	LD	DE,(LAB_F95C)	; get ?? size
	LD	A,E			; copy low byte
	LD	(LAB_F998),A	; save ?? size byte ??
	LD	HL,LAB_F95E		; reset pointer
	LD	(LAB_F954),HL	; set next ?? out pointer
	ADD	HL,DE			; add size ??
	LD	(LAB_F956),HL	; save next ?? in pointer
	LD	A,#1Bh		;10CF:	3E1B
	RET				;

; BDOS function 4 - AUX (puncher) output
;
; E = ASCII character

LAB_10D2
	LD	A,E		;10D2:	7B
	LD	(LAB_F97E),A	;10D3:	327EF9
	LD	A,(LAB_FBC5)	;10D6:	3AC5FB
	RRA				; /2
	RRA				; /4
	RRA				; /8
	RRA				; /16
	AND	#1Fh			; carry & top nibble, mask 000x xxxx
	CALL	LAB_31FF		; if A<10h return HL=base+A, else return A=FDh C=1
					; where if Cb=1 base=LAB_FE83 else base=LAB_FE93, A=A-41h
	LD	A,(HL)		; get the byte
	LD	(LAB_F97C),A	;10E3:	327CF9
	LD	(LAB_F978),HL	;10E6:	2278F9
	CP	#80h		;10E9:	FE80
	JP	Z,LAB_10F5		; get (LAB_F97E)& do display_2 chr ??? & clear A
	LD	A,(LAB_F97E)	;10EE:	3A7EF9
	CALL	LAB_0F5D	;10F1:	CD5D0F
	RET				;

; get (LAB_F97E)& do display_2 chr ??? & clear A

LAB_10F5
	LD	A,(LAB_F97E)	;10F5:	3A7EF9
	CALL	LAB_1BEB		; display_2 chr ???
	XOR	A			; clear A
	RET				;

LAB_10FD
	RET				;

; get key (waits for valid ??)

LAB_10FE
	CALL	LAB_18C0		; get key from buffer, returns Z=true if no key
	RET	NZ			; return if key

	LD	A,#04h		;1102:	3E04
	LD	C,A		;1104:	4F
	CALL	LAB_168F	;1105:	CD8F16
	CALL	LAB_18C0		; get key from buffer
	RET				;

LAB_110C
	LD	A,(LAB_FBC5)	;110C:	3AC5FB
	RRA				; /2
	RRA				; /4
	ADD	A,#05h		;1111:	C605
	AND	#1Fh			; mask 000x xxxx
	CALL	LAB_31FF		; if A<10h return HL=base+A, else return A=FDh C=1
					; where if Cb=1 base=LAB_FE83 else base=LAB_FE93, A=A-41h
	LD	A,(HL)		;1118:	7E
	LD	(LAB_F999),A	;1119:	3299F9
	LD	(LAB_F978),HL	;111C:	2278F9
	RET				;

; set carry & RET

LAB_1120
	SCF				; set carry
	RET				;

; set restart count to 16*E

LAB_1122
	EX	DE,HL			; DE to HL
	LD	H,#00h		; clear high byte
	ADD	HL,HL			; *2
	ADD	HL,HL			; *4
	ADD	HL,HL			; *8
	ADD	HL,HL			; *16
	CALL	LAB_21EC		; set restart count (time in HL)
	RET				;

; set alarm if DE<>0

LAB_112D
	EX	DE,HL			; swap DE to HL
	LD	A,H			; check source address<>0
	OR	L			; ..
	JR	Z,LAB_113A		; jump if null

	LD	DE,LAB_F99A		; set destination
	PUSH	DE			; save destination
	CALL	LAB_115F		; copy 8 bytes
	POP	HL			; restore destination
LAB_113A
	CALL	LAB_2131		; set alarm (HL<>0) or disable alarm (HL=0)
	RET				;

; read RTC & copy time/date to (DE)

LAB_113E
	PUSH	DE			; save destination
	LD	HL,LAB_F9A2		; set pointer
	CALL	LAB_20E8		; copy RTC time/date to buffer @ HL
	LD	BC,0008h		; 8 bytes to copy
	LD	HL,LAB_F9A2		; set source
	POP	DE			; restore destination
	CALL	LAB_F498		; copy block to memory page (LAB_FEFE)
					; reset afterwards (LAB_39B5)
	RET				;

; copy block from (DE) & setup RTC

LAB_1150
	EX	DE,HL			; source to HL
	LD	DE,LAB_F9A2		; set destination
	PUSH	DE			; save destination
	CALL	LAB_115F		; copy 8 bytes
	POP	HL			; get pointer to date/time table
	CALL	LAB_20AF		; set RTC mode & time/date from +(HL)
	XOR	A			; clear A
	RET				;

LAB_115E
	RET				;

LAB_115F
	LD	BC,0008h		; 8 bytes to copy
	CALL	LAB_F498		; copy block to memory page (LAB_FEFE)
					; reset afterwards (LAB_39B5)
	RET				;

; get console input, character returned in A

LAB_1166
	PUSH	HL			; save HL
	PUSH	DE			; save DE
	PUSH	BC			; save BC
	CALL	LAB_0E00		; get character from console
	POP	BC			; restore BC
	POP	DE			; restore DE
	POP	HL			; restore HL
	RET				;

; do console output, ASCII character in E

LAB_1170
	PUSH	HL			; save HL
	PUSH	DE			; save DE
	PUSH	BC			; save BC
	LD	C,E			; copy character to C
	CALL	LAB_0F37		; output character to console
	POP	BC			; restore BC
	POP	DE			; restore DE
	POP	HL			; restore HL
	RET				;

; BDOS function 10 - buffered console input
;
; DE = buffer address (or zero)
; buffer address+0 = buffer length
;
; returns DE = bytes in buffer

LAB_117B
	PUSH	BC			; save BC
	EX	DE,HL			; swap buffer address to HL
	CALL	LAB_F48C		; get byte (HL) from page (LAB_FEFE) (LAB_39A9)
	LD	D,A			; copy byte
	INC	HL			; increment buffer pointer
	LD	C,#00h		; clear character count
	PUSH	HL			; save buffer pointer
	INC	HL			; increment buffer pointer
	LD	A,D			; get buffer length
	OR	A			; set the flags
	LD	A,#FFh		; set A = -1
	JP	Z,LAB_11F2		; jump if buffer length was zero

	DEC	D			; decrement length (count  0 to #)
LAB_118E
	CALL	LAB_1166		; get console input ??
	CP	#FFh		;1191:	FEFF
	JP	Z,LAB_11F2	;1193:	CAF211

	CP	#0Dh			; was it [CR] ?
	JP	Z,LAB_11E4		; jump if [CR]

	CP	#7Fh			; was it delete ?
	JP	Z,LAB_11BE		; jump if was delete

	CP	#1Bh			; was it [ESC]
	JP	Z,LAB_11CD		; jump if was [ESC]

	LD	E,A			; else copy input byte to A
	CALL	LAB_F47D		; do LD (HL),A in page (LAB_FEFE) (LAB_399A)
	LD	A,C			; get # of characters in buffer
	CP	D			; compare with length
	JP	NZ,LAB_11B6		; jump if not full

LAB_11AE
	LD	E,#07h		; else output character = [BELL]
	CALL	LAB_1170		; do console output
	JP	LAB_118E		; go get next character

LAB_11B6
	CALL	LAB_1170		; do console output
	INC	HL			; increment buffer pointer
	INC	C			; increment character count
	JP	LAB_118E		; go get next character

					; character was delete
LAB_11BE
	LD	A,C			; get character count
	OR	A			; set the flags
	JP	Z,LAB_11AE		; if empty buffer do [BELL] and back to input loop

	DEC	HL			; decrement buffer pointer
	DEC	C			; decrement character count
	LD	E,#7Fh		; output character = [BACKSPACE]
	CALL	LAB_1170		; do console output
	JP	LAB_118E		; go get next character


					; key was [ESC]
LAB_11CD
	CALL	LAB_1166		; do console input
	LD	B,A			; copy byte
	OR	A			; set the flags
	JP	Z,LAB_11E4		; exit if null

					; was [ESC]+key
LAB_11D5
	CALL	LAB_1166		; do console input
	CALL	LAB_F47D		; do LD (HL),A in page (LAB_FEFE) (LAB_399A)
	LD	A,C			; get character count
	CP	D			; compare with max
	JP	Z,LAB_11E2		; jump if buffer full

	INC	HL			; increment pointer
	INC	C			; increment count
LAB_11E2
	DJNZ	LAB_11D5		; loop until +key bytes input

					; character was [CR}
LAB_11E4
	LD	E,#0Dh		; set byte [CR]
	LD	A,E			; copy byte
	CALL	LAB_F47D		; do LD (HL),A in page (LAB_FEFE) (LAB_399A)
	CALL	LAB_1170		; do console output
	LD	E,#0Ah		; set byte [LF]
	INC	C			; increment character count
	LD	A,#00h		; not used !!
LAB_11F2
	POP	HL			; restore buffer pointer to start
	LD	A,C			; copy character count
	CALL	LAB_F47D		; do LD (HL),A in page (LAB_FEFE) (LAB_399A)
	DEC	HL			; pointer -1
	EX	DE,HL			; copy to DE
	POP	BC			; restore BC
	RET				;

; display '$' terminated string from (DE)page (LAB_FEFE),
; return '$' address in HL

; BDOS function 9 - print string
;
; DE = address of string, string is terminated with "$"

LAB_11FB
	PUSH	DE			; save DE
	EX	DE,HL			; copy to HL
LAB_11FD
	CALL	LAB_F48C		; get byte (HL) from page (LAB_FEFE) (LAB_39A9)
	CP	#24h			; compare with '$'
	JP	Z,LAB_120D		; exit if found

	LD	E,A			; copy byte to E
	CALL	LAB_1170		; display (_2) chr
	INC	HL			; increment index
	JP	LAB_11FD		; loop

LAB_120D
	POP	DE			; restore DE
	RET				;

LAB_120F
	DI			;120F:	F3
	XOR	A		;1210:	AF
	LD	(LAB_FBB6),A	;1211:	32B6FB
	LD	(LAB_F9AA),A	;1214:	32AAF9
	LD	(LAB_F9AB),A	;1217:	32ABF9
	CALL	LAB_14DE		; do RTC timebase vector
	CALL	LAB_F54E		; enable interrupts if interrupts setup ?? flag <> 0
					; (LAB_3A6B) (could JP here!)
	RET				;

LAB_1221
	LD	(LAB_FBB7),DE	;1221:	ED53B7FB
	LD	(LAB_F9AA),A	;1225:	32AAF9 this is 2Bh or 2Ah
	PUSH	AF			; save A
	LD	A,(LAB_F78D)	; get Port_2C buffer
	AND	#DFh			; mask xx0x xxxx
	LD	(LAB_F78D),A	; save Port_2C buffer
	OUT	(Port_2C),A		; out to port
	LD	A,(LAB_F78B)	; get Port_2A buffer
	AND	#FDh			; mask xxxx xx0x
	LD	(LAB_F78B),A	; save Port_2A buffer
	OUT	(Port_2A),A		; out to Port_2A
	POP	AF			; restore A
	CP	#2Ah			; was it 2Ah ?
	JR	NZ,LAB_124C		; jump if not

					; A = 2Ah code
	LD	A,(LAB_F78B)	; get Port_2A buffer
	OR	#02h			; set bit xxxx xx1x
	LD	(LAB_F78B),A	; save Port_2A buffer
	OUT	(Port_2A),A		; out to Port_2A
LAB_124C
	LD	A,(HL)		;124C:	7E
	CP	#02h		;124D:	FE02
	JP	Z,LAB_12C4		; loop until <> 02h

	LD	A,(LAB_FDD7)	;1252:	3AD7FD
	OR	A		;1255:	B7
	JP	NZ,LAB_12C4		; loop while <> 00h

	LD	A,#01h		;1259:	3E01
	LD	(LAB_FBB6),A	;125B:	32B6FB
	LD	B,#06h		; 6 bytes to clear
	XOR	A			; clear A
LAB_1261
	LD	(DE),A		; clear byte
	INC	DE			; point to next byte
	DJNZ	LAB_1261		; loop if not all done

	XOR	A			; clear A (again ??)
	LD	(LAB_FBB5),A	;1266:	32B5FB
	LD	A,(LAB_F9AA)	;1269:	3AAAF9
	CP	#2Ah		;126C:	FE2A
	JR	NZ,LAB_127A	;126E:	200A

	LD	HL,LAB_12DD		; set vector for 20h interrupt
	CALL	LAB_138E		; setup table & ports
	LD	E,#01h		;1276:	1E01
	JR	LAB_12AB	;1278:	1831

LAB_127A
	DI				; disable interrupts
	LD	A,(LAB_F78D)	; get Port_2C buffer
	AND	#FDh			; mask xxxx xx0x V24_ADAPTER IR port data = 0
	LD	(LAB_F78D),A	; save Port_2C buffer
	OUT	(Port_2C),A		; out to Port_2C
	LD	A,#01h		; count of 1
	CALL	LAB_35CE		; delay of A*????
	LD	A,(LAB_F78D)	; get Port_2C buffer
	OR	#02h			; set xxxx xx1x V24_ADAPTER IR port data = 1
	LD	(LAB_F78D),A	; save Port_2C buffer
	OUT	(Port_2C),A		; out to Port_2C
	LD	A,#02h		; loop count
	CALL	LAB_1563		; short delay, loop A times

	IN	A,(Port_2D)		; get port 2D byte
	AND	#01h			; mask 0000 000x
	LD	E,#00h		;129D:	1E00
	JR	NZ,LAB_12AB		; jump if bit was set

	LD	E,#01h		;12A1:	1E01
	IN	A,(Port_2D)		; get port 2D byte
	AND	#02h			; mask 0000 00x0
	JR	NZ,LAB_12AB		; jump if bit set

	LD	E,#02h		;12A9:	1E02
LAB_12AB
	CALL	LAB_F54E		; enable interrupts if interrupts setup ?? flag <> 0
					; (LAB_3A6B)
	LD	A,E		;12AE:	7B
	LD	(LAB_F9AB),A	;12AF:	32ABF9
	OR	A		;12B2:	B7
	JP	Z,LAB_13A3	;12B3:	CAA313
	LD	(LAB_FBCB),A	;12B6:	32CBFB
	CP	#01h		;12B9:	FE01
	JP	Z,LAB_12DD	;12BB:	CADD12
	CALL	LAB_14FF	;12BE:	CDFF14
	JP	LAB_138B		; go setup xx1x xxxx interupt & return

LAB_12C4
	LD	A,(LAB_FBB6)	;12C4:	3AB6FB
	OR	A		;12C7:	B7
	RET	Z		;12C8:	C8

	LD	HL,LAB_F9AE		; point to ??3 count
	CALL	LAB_21BA		; search table for HL (count pointer), clear if found
					; else return carry set
	LD	HL,(LAB_FBB7)	;12CF:	2AB7FB
	LD	(HL),#00h	;12D2:	3600
	INC	HL			; increment pointer
	LD	(HL),#01h	;12D5:	3601
	LD	DE,0006h	;12D7:	110600
	JP	LAB_14A3	;12DA:	C3A314

; xx1x xxxx interrupt routine

LAB_12DD
	LD	A,(LAB_FBBF)	;12DD:	3ABFFB
	OR	A		;12E0:	B7
	CALL	NZ,LAB_14FF	;12E1:	C4FF14
	LD	DE,0001h		; set count
	CALL	LAB_135C		; go set vector & count for RTC timebase
	XOR	A		;12EA:	AF
	RET				;

; RTC timebase vector

LAB_12EC
	LD	A,(LAB_FBB6)	;12EC:	3AB6FB
	OR	A		;12EF:	B7
	RET	Z		;12F0:	C8
	LD	A,(LAB_FBBF)	;12F1:	3ABFFB
	CPL			;12F4:	2F
	AND	#01h		; mask 0000 000x
	LD	HL,LAB_FBD8		; point to byte
	OR	(HL)		;12FA:	B6
	LD	(HL),#00h	;12FB:	3600
	JR	Z,LAB_1317	;12FD:	2818
	CALL	LAB_14FF	;12FF:	CDFF14
	IN	A,(Port_2D)		;1302:	DB2D
	AND	#01h			; mask 0000 000x
	LD	(LAB_FBC4),A	;1306:	32C4FB
	JR	Z,LAB_1325	;1309:	281A
LAB_130B
	CALL	LAB_14DE		; do RTC timebase vector
	LD	DE,(LAB_F9B2)	; get ??3 default count
	CALL	LAB_135C		; go set vector & count for RTC timebase
	XOR	A			; clear A
	RET				;

LAB_1317
	IN	A,(Port_2D)		;1317:	DB2D
	AND	#01h			; mask 0000 000x
	LD	(LAB_FBC4),A	;131B:	32C4FB
	JR	Z,LAB_1329	;131E:	2809

	LD	DE,0005h		; set count
	JR	LAB_135C		; go set vector & count for RTC timebase

LAB_1325
	CALL	LAB_14C8		; get count @ LAB_F9B0  setup countdown for ??
	DI				; disable interrupts
LAB_1329
	CALL	LAB_35C9		; tone off
LAB_132C
	LD	D,#F8h		; do this bit F8h times
LAB_132E
	IN	A,(Port_2D)		;132E:	DB2D
	AND	#01h			; mask 0000 000x
	JR	NZ,LAB_1382		; jump if set

	CALL	LAB_1A42		; set buffer & all KBD lines, in (KBD_R)
	JR	NZ,LAB_1353		; jump if key pressed

	LD	B,#05h		; short delay
LAB_133B
	DJNZ	LAB_133B		; loop

	DEC	D			; decrement count
	JR	NZ,LAB_132E		; loop if not time up

	LD	HL,(LAB_F9AC)	; get long count
	DEC	HL			; decrement it
	LD	(LAB_F9AC),HL	; save it back
	LD	A,H			; set the flags
	OR	L			;
	JR	NZ,LAB_132C		; loop if not time up

	CALL	LAB_14B0	;134B:	CDB014
	CALL	LAB_14DE		; do RTC timebase vector
	JR	LAB_1379	;1351:	1826

					; key was pressed
LAB_1353
	CALL	LAB_14B0	;1353:	CDB014
	CALL	LAB_14C8		; get count @ LAB_F9B0  setup countdown for ??
	LD	DE,0005h		; set count (1/13th sec)
LAB_135C
	LD	HL,LAB_12EC		; set vector
LAB_135F
	LD	(LAB_F9AE),DE	; save ??3 count
	LD	DE,LAB_F9AE		; set count pointer
	CALL	LAB_2189		; save DE & HL in RTC interrupt table
					; return carry set if not saved
	CALL	LAB_F54E		; enable interrupts if interrupts setup ?? flag <> 0
					; (LAB_3A6B)
	RET				;

; RTC timebase vector

LAB_136D
	CALL	LAB_14FF	;136D:	CDFF14
	IN	A,(Port_2D)		;1370:	DB2D
	AND	#01h			; mask 0000 000x
	JR	NZ,LAB_130B	;1374:	2095
	CALL	LAB_14DE	;1376:	CDDE14
LAB_1379
	LD	DE,(LAB_F9B2)	; get ??3 default count
	LD	HL,LAB_136D		; set vector
	JR	LAB_135F		; go set it up

LAB_1382
	CALL	LAB_13B8	;1382:	CDB813
	RET	NC		;1385:	D0

	CALL	LAB_14C8		; get count @ LAB_F9B0  setup countdown for ??
	JR	LAB_1317	;1389:	188C

LAB_138B
	LD	HL,LAB_13B8		; set vector for 20h interrupt
LAB_138E
	DI				; disable interrupts
	CALL	LAB_2349		; set 20h interrupt & save HL as interrupt vector
	DI				; disable interrupts (allready done!)
	PUSH	AF			; save A
	LD	A,(LAB_F784)	; get Port_04 buffer
	AND	#DFh			; mask xx0x xxxx
	LD	(LAB_F784),A	; save Port_04 buffer
	OUT	(Port_04),A		; out to Port_04
	CALL	LAB_F54E		; enable interrupts if interrupts setup ?? flag <> 0
					; (LAB_3A6B)
	POP	AF			; restore A
	RET				;

LAB_13A3
	LD	A,#EEh		;13A3:	3EEE
	LD	(LAB_FBB5),A	;13A5:	32B5FB
	LD	HL,(LAB_FBB7)	;13A8:	2AB7FB
	LD	(HL),A		;13AB:	77
	XOR	A		;13AC:	AF
	LD	(LAB_FBCB),A	;13AD:	32CBFB
	LD	DE,FFFFh	;13B0:	11FFFF
	JP	LAB_14A3	;13B3:	C3A314

LAB_13B6
	SCF			;13B6:	37
	RET				;

; xx1x xxxx interrupt routine

LAB_13B8
	CALL	LAB_35C9		; tone off
	LD	(LAB_FBBD),SP	;13BB:	ED73BDFB
LAB_13BF
	LD	SP,FBB5h	;13BF:	31B5FB
	LD	HL,0000h	;13C2:	210000
	XOR	A		;13C5:	AF
	LD	(LAB_FBB5),A	;13C6:	32B5FB
	LD	C,#04h		;13C9:	0E04
LAB_13CB
	IN	A,(Port_2D)		;13CB:	DB2D
	AND	#01h			; mask 0000 000x
	JR	NZ,LAB_13DF	;13CF:	200E
	INC	HL		;13D1:	23
	LD	A,H			; set the flags
	OR	L			;
	JR	NZ,LAB_13CB	;13D4:	20F5

	DEC	C		;13D6:	0D
	JR	NZ,LAB_13CB	;13D7:	20F2
	LD	SP,(LAB_FBBD)	;13D9:	ED7BBDFB
	SCF			;13DD:	37
	RET				;

LAB_13DF
	LD	D,#18h		;13DF:	1618
	LD	B,#01h		;13E1:	0601
	LD	C,#00h		;13E3:	0E00
LAB_13E5
	LD	HL,0001h	;13E5:	210100
LAB_13E8
	INC	HL		;13E8:	23
	LD	A,H		;13E9:	7C
	CP	D		;13EA:	BA
	JR	Z,LAB_1404	;13EB:	2817
	IN	A,(Port_2D)		;13ED:	DB2D
	AND	#01h			; mask 0000 000x
	CP	B		;13F1:	B8
	JR	Z,LAB_13E8	;13F2:	28F4
	LD	B,A		;13F4:	47
	LD	A,H		;13F5:	7C
	OR	A		;13F6:	B7
	JR	NZ,LAB_13FE	;13F7:	2005
	LD	A,L		;13F9:	7D
	SUB	#08h		;13FA:	D608
	JR	C,LAB_13BF	;13FC:	38C1
LAB_13FE
	INC	C		;13FE:	0C
	JR	Z,LAB_1404	;13FF:	2803
	PUSH	HL		;1401:	E5
	JR	LAB_13E5	;1402:	18E1

LAB_1404
	LD	SP,(LAB_FBBD)	;1404:	ED7BBDFB
	LD	A,C		;1408:	79
	LD	(LAB_F9B4),A	;1409:	32B4F9
	CP	#09h		;140C:	FE09
	RET	C		;140E:	D8
	CP	#80h		;140F:	FE80
	JR	C,LAB_1415	;1411:	3802

; reverse order of (part of) block F9B5 to FBB4

	LD	A,#80h		; count
LAB_1415
	LD	IX,F9B5h	; first block
	LD	IY,FBB3h	; second block
LAB_141D
	LD	C,(IX+#00h)	; get BC from ..
	LD	B,(IX+#01h)	; .. first block
	LD	E,(IY+#00h)	; get DE from ..
	LD	D,(IY+#01h)	; .. second block
	LD	(IX+#00h),E	; save DE to ..
	LD	(IX+#01h),D	; .. first block
	LD	(IY+#00h),C	; save BC to ..
	LD	(IY+#01h),B	; .. second block
	INC	IX		; increment first ..
	INC	IX		; .. block pointer
	DEC	IY		; decrement second ..
	DEC	IY		; .. block pointer
	DEC	A		; decrement count
	JR	NZ,LAB_141D	; loop until all done

	LD	HL,LAB_F9B5	;1440:	21B5F9
	LD	(LAB_FBB9),HL	;1443:	22B9FB
	LD	A,(LAB_F9B4)	;1446:	3AB4F9
	LD	(LAB_FBBB),A	;1449:	32BBFB
	XOR	A		;144C:	AF
	LD	(LAB_FBBC),A	;144D:	32BCFB
	LD	HL,LAB_FBB9	;1450:	21B9FB
	PUSH	HL		;1453:	E5
	LD	HL,LAB_1468	;1454:	216814
	PUSH	HL		;1457:	E5
	LD	HL,(LAB_FBC2)	;1458:	2AC2FB
	BIT	7,H		;145B:	CB7C
	JR	Z,LAB_1464	;145D:	2805
	LD	A,(HL)		;145F:	7E
	CP	#D7h		;1460:	FED7
	JR	Z,LAB_1467	;1462:	2803
LAB_1464
	LD	HL,LAB_FBC0	;1464:	21C0FB
LAB_1467
	JP	(HL)		;1467:	E9
LAB_1468
	POP	HL		;1468:	E1
	LD	HL,(LAB_FBBB)	;1469:	2ABBFB
	LD	A,H			; set the flags
	OR	L			;
	JR	Z,LAB_14DC	;146E:	286C

	LD	A,(LAB_FBB5)	;1470:	3AB5FB
	LD	HL,(LAB_FBB7)	;1473:	2AB7FB
	LD	(HL),A		;1476:	77
	OR	A		;1477:	B7
	JR	NZ,LAB_14DC	;1478:	2062

	INC	HL		;147A:	23
	INC	HL		;147B:	23
	INC	HL		;147C:	23
	INC	HL		;147D:	23
	LD	BC,(LAB_FBBB)	;147E:	ED4BBBFB
	LD	(HL),C		;1482:	71
	INC	HL			; increment pointer
	LD	(HL),B		;1484:	70
	INC	HL		;1485:	23
	LD	DE,(LAB_FBB9)	;1486:	ED5BB9FB
	EX	DE,HL		;148A:	EB
	LDIR			;copy block
	XOR	A		;148D:	AF
	LD	HL,(LAB_FBBB)	;148E:	2ABBFB
	LD	DE,0006h	;1491:	110600
	ADD	HL,DE		;1494:	19
	EX	DE,HL		;1495:	EB
	LD	A,(LAB_F784)	; get Port_04 buffer
	OR	#20h			; set xx1x xxxx
	LD	(LAB_F784),A	; save Port_04 buffer
	OUT	(Port_04),A		; out to Port_04
	CALL	LAB_14C8		; get count @ LAB_F9B0  setup countdown for ??
LAB_14A3
	CALL	LAB_30BD	;14A3:	CDBD30
	XOR	A		;14A6:	AF
	LD	(LAB_FBB6),A	;14A7:	32B6FB
	LD	A,(LAB_F9AB)	;14AA:	3AABF9
	CP	#02h		;14AD:	FE02
	RET	Z		;

LAB_14B0
	DI				; disable interrupts
	LD	HL,(LAB_FBCE)	; get go to sleep count
	LD	DE,(LAB_F9AC)	; get long count
	ADD	HL,DE		;14B8:	19
	LD	DE,(LAB_F9B0)	;14B9:	ED5BB0F9
	OR	A			; clear carry ??
	SBC	HL,DE		;14BE:	ED52
	LD	(LAB_FBCE),HL	; save new go to sleep count
	CALL	C,LAB_1721	;14C3:	DC2117
	XOR	A		;14C6:	AF
	RET				;

; get count @ LAB_F9B0  setup countdown for ??

LAB_14C8
	PUSH	DE			; save DE
	PUSH	HL			; save HL
	LD	HL,(LAB_F9B0)	; get count
	LD	(LAB_F9AC),HL	; save long count
	LD	HL,LAB_14DE		; set vector
	LD	DE,LAB_F9AC		; set long count pointer
	CALL	LAB_2189		; save DE & HL in RTC interrupt table
					; return carry set if not saved
	POP	HL			; restore HL
	POP	DE			; restore DE
	RET				;

LAB_14DC
	SCF			;14DC:	37
	RET				;

; RTC timebase vector

LAB_14DE
	LD	A,(LAB_F78D)	; get Port_2C buffer
	AND	#FDh			; mask xxxx xx0x V24_ADAPTER IR port data = 0
	LD	(LAB_F78D),A	; save Port_2C buffer
	OUT	(Port_2C),A		; out to Port_2C
	LD	A,(LAB_F78B)	; get Port_2A buffer
	OR	#10h			; set  xxx1 xxxx
	AND	#FEh			; mask xxxx xxx0
	LD	(LAB_F78B),A	; save Port_2A buffer
	OUT	(Port_2A),A		; out to Port_2A
	XOR	A			; clear A
	LD	(LAB_FBBF),A	;14F5:	32BFFB
	LD	HL,LAB_F9AC		; set pointer to long count
	CALL	LAB_21BA		; search table for HL (count pointer), clear if found
					; else return carry set
	RET				;

LAB_14FF
	DI				; disable interrupts
	LD	A,(LAB_F9AA)	;1500:	3AAAF9
	CP	#2Ah		;1503:	FE2A
	JR	Z,LAB_1537	;1505:	2830

	LD	A,(LAB_F78D)	; get Port_2C buffer
	OR	#02h			; set xxxx xx1x V24_ADAPTER IR port data = 1
	LD	(LAB_F78D),A	; save Port_2C buffer
	OUT	(Port_2C),A		; out to Port_2C
	LD	A,(LAB_F78D)	; get Port_2C buffer
	OR	#01h			; set xxxx xxx1 V24_ADAPTER IR port clock = 1
	LD	(LAB_F78D),A	; save Port_2C buffer
	OUT	(Port_2C),A		; out to Port_2C
	LD	B,#83h		; count for short delay
LAB_151D
	DEC	B			; decrement count
	JR	NZ,LAB_151D		; loop if not all done

	LD	A,(LAB_F78D)	; get Port_2C buffer
	AND	#FEh			; mask xxxx xxx0 V24_ADAPTER IR port clock = 0
	LD	(LAB_F78D),A	; save Port_2C buffer
	OUT	(Port_2C),A		; out to Port_2C
	CALL	LAB_F54E		; enable interrupts if interrupts setup ?? flag <> 0
					; (LAB_3A6B)
	LD	A,#28h		; delay count
	CALL	LAB_35CE		; delay of A*????
	LD	HL,0014h		; set ??3 default count
	JR	LAB_155A		; go save & exit

LAB_1537
	LD	A,(LAB_F78B)	; get Port_2A buffer
	OR	#01h			; set  xxxx xxx1
	AND	#EFh			; mask xxx0 xxxx
	LD	(LAB_F78B),A	; save Port_2A buffer
	OUT	(Port_2A),A		; out to Port_2A
	LD	A,#07h		; multiplier of 7
	CALL	LAB_35CE		; delay of A*????
	LD	A,(LAB_F78B)	; get Port_2A buffer
	OR	#10h			; set  xxx1 xxxx
	LD	(LAB_F78B),A	; save Port_2A buffer
	OUT	(Port_2A),A		; out to Port_2A
	LD	A,#01h		; multiplier of 1
	CALL	LAB_35CE		; delay of A*????
	LD	HL,0005h		; set ??3 default count
LAB_155A
	LD	(LAB_F9B2),HL	; save ??3 default count
	LD	A,#01h		;155D:	3E01
	LD	(LAB_FBBF),A	;155F:	32BFFB
	RET				;

; short delay, loop A times

LAB_1563
	DEC	A			; decrement count
	JR	NZ,LAB_1563		; loop until zero
	RET				;

; clear LAB_FBBB/C (& HL)

LAB_1567
	LD	HL,0000h		; clear word
	LD	(LAB_FBBB),HL	; save word
	RET				;

; setup something ??

LAB_156E
	LD	HL,LAB_1567		; point to "clear LAB_FBBB/C (& HL)" routine
	LD	(LAB_FBC2),HL	; set vector
	XOR	A			; clear A
	LD	(LAB_FBB6),A	;1575:	32B6FB
	LD	(LAB_FBC4),A	;1578:	32C4FB
	LD	A,#D7h		;157B:	3ED7
	LD	(LAB_FBC0),A	;157D:	32C0FB
	LD	A,(LAB_FEA7)	; get first RAM bank #
	LD	(LAB_FBC1),A	;1583:	32C1FB
	RET				;

; error # 45h return address ??

LAB_1587
	LD	(LAB_FBC2),DE	; set ?? vector
	LD	A,(LAB_FEFE)	; get buffered memory page
	LD	(LAB_FBC1),A	;158E:	32C1FB
	LD	A,#D7h		;1591:	3ED7
	LD	(LAB_FBC0),A	;1593:	32C0FB
	ADD	HL,HL			; *2
	ADD	HL,HL			; *4
	ADD	HL,HL			; *8
	ADD	HL,HL			; *16
	ADD	HL,HL			; *32
	ADD	HL,HL			; *64
	LD	(LAB_F9B0),HL	;159C:	22B0F9
	RET				;

; get A from (LAB_FBC5)

LAB_15A0
	LD	A,(LAB_FBC5)	;15A0:	3AC5FB
	RET				;

; save E to (0003h) in pages 40h-00h & LAB_FBC5

LAB_15A4
	LD	A,E		;15A4:	7B
	LD	(LAB_FBC5),A	;15A5:	32C5FB
	LD	HL,0003h		; set pointer
	CALL	LAB_F46D		; save E to (HL) in pages 40h-00h (LAB_398A)
	RET				;

; get A from (LAB_FBC6) current disk

; BDOS function 25 - Return current drive
;
; Returns drive in A. Returns currently selected drive. 0 => A:, 1 => B: etc. 

LAB_15AF
	LD	A,(LAB_FBC6)	; get current drive #
	RET				;

; save E (E<10h) to (0004h) in pages 40h-00h & LAB_FBC6
; A = 00 = done, A = FF = failed

; BDOS function 14 - select disk
;
; E = drive number. Returns L=A=0 or 0FFh. 
; The drive number passed to this routine is 0 for A:, 1 for B: up to 15 for P:. 
; Sets the currently selected drive to the drive in A; logs in the disc. Returns 0
; if successful or 0FFh if error.

LAB_15B3
	LD	A,E			; copy drive #
	CP	#10h			; compare with max +1
	JR	NC,LAB_15C4		; jump if >= max +1

	LD	(LAB_FBC6),A	; save new drive #
	LD	HL,0004h		; set pointer
	CALL	LAB_F46D		; save E to (HL) in pages 40h-00h (LAB_398A)
	LD	A,#00h		; flag success
	RET				;

LAB_15C4
	LD	A,#FFh		; flag fail
	RET				;

; BDOS function 12 - get version number
;
; returns version number in HL

LAB_15C7
	LD	HL,0023h		; set HL =
					; 0xxx = CPU - 8080
					; x0xx = OS - CP/M
					; xx2x = Version - 2
					; xxx3 = Revision - 3
	RET				;

; set beep #E from table @ LAB_15E0

LAB_15CB
	LD	A,E			; get #
	CP	#05h			; compare with 5
	RET	NC			; exit if A=>5

	LD	HL,LAB_15E0		; point to table start
	LD	D,#00h		; clear high byte
	ADD	HL,DE			; add # to pointer
	ADD	HL,DE			; add # to pointer (2 bytes per)
	LD	A,(HL)		; get beep tone
	LD	(LAB_FBC8),A	; save beep tone
	INC	HL			; point to beep duration
	LD	A,(HL)		; get beep duration
	LD	(LAB_FBC7),A	; save beep duration
	RET				;

					; table of beeps
LAB_15E0
	DB	0Bh,01h		; low short tone
	DB	0Bh,04h		; low long tone
	DB	03h,01h		; high short tone
	DB	03h,04h		; high long tone
	DB	07h,01h		; mid short tone

; error # 21h return address ?? reset DMA address ??
; save BC to (LAB_FFA3)

LAB_15EA
	PUSH	BC			; copy BC ..
	POP	HL			; .. to HL
	LD	(LAB_FFA3),HL	; save it
	RET				;

; error # 3Fh return address ??

LAB_15F0
	OR	A			; set flags
	JR	Z,LAB_166F		; jump if # was 0

	DEC	A			; -1
	JR	Z,LAB_160A		; jump if # was 1

	DEC	A			; -2
	JR	Z,LAB_166A		; jump if # was 2

					; A was not 0, 1 or 2
	EX	DE,HL		;15F9:	EB
	LD	A,(LAB_FEA7)	; get first RAM bank #
	LD	(HL),A		;15FD:	77
	INC	HL		;15FE:	23
	LD	A,(LAB_FEA8)	; get last RAM bank #
	DEC	A		;1602:	3D
	LD	(HL),A		;1603:	77
	INC	HL		;1604:	23
	LD	A,(LAB_FEFE)	; get buffered memory page
	LD	(HL),A		;1608:	77
	RET				;

; # was =1

LAB_160A
	PUSH	DE			; copy pointer ..
	POP	IX			; .. to IX
	LD	A,(IX+#06h)		; get ??+6 byte
	LD	(LAB_F8AF),A	; save first mem page #
	LD	B,A		;1613:	47
	LD	A,(LAB_FEA8)	; get last RAM bank #
	SUB	B		;1617:	90
	LD	(LAB_F8AE),A	;1618:	32AEF8
	LD	A,(IX+#02h)	;161B:	DD7E02
	LD	(LAB_F81E),A	;161E:	321EF8
	LD	A,(IX+#03h)	;1621:	DD7E03
	LD	(LAB_F822),A	;1624:	3222F8
	LD	A,(IX+#04h)	;1627:	DD7E04
	LD	L,A		;162A:	6F
	LD	A,(IX+#05h)	;162B:	DD7E05
	LD	H,A		;162E:	67
	LD	(LAB_F8B6),HL	; save last mem page size ??
	LD	A,(IX+#00h)	;1632:	DD7E00
	LD	E,A		;1635:	5F
	LD	A,(IX+#01h)	;1636:	DD7E01
	LD	D,A		;1639:	57
	OR	E		;163A:	B3
	JR	NZ,LAB_164B	;163B:	200E

	LD	A,(LAB_F8AE)	; get# of RAM banks
	CALL	LAB_05D2		; sets total sectors in RAMdisk & sectors
					; in last page from HL & A ??
	LD	A,(LAB_F822)	;1643:	3A22F8
	CALL	LAB_0617	;1646:	CD1706
	JR	LAB_1658	;1649:	180D

LAB_164B
	LD	(LAB_F823),DE	;164B:	ED5323F8
	PUSH	HL		;164F:	E5
	POP	BC		;1650:	C1
	CALL	LAB_05ED	; DE = (BC-0100h)>>7
	LD	(LAB_F8B2),DE	; save sectors in last page
LAB_1658
	LD	A,(LAB_F822)	;1658:	3A22F8
	LD	HL,(LAB_F823)	;165B:	2A23F8
	LD	DE,(LAB_F81E)	;165E:	ED5B1EF8
	PUSH	IX		;1662:	DDE5
	CALL	LAB_0509	;1664:	CD0905
	POP	DE		;1667:	D1
	JR	LAB_166F	;1668:	1805

; # was =2

LAB_166A
	PUSH	DE		;166A:	D5
	CALL	LAB_05A1	;166B:	CDA105
	POP	DE		;166E:	D1

; # was =0

LAB_166F
	EX	DE,HL		;166F:	EB
	LD	DE,(LAB_F823)	;1670:	ED5B23F8
	LD	(HL),E		;1674:	73
	INC	HL			; increment pointer
	LD	(HL),D		;1676:	72
	INC	HL		;1677:	23
	LD	A,(LAB_F81E)	;1678:	3A1EF8
	LD	(HL),A		;167B:	77
	INC	HL		;167C:	23
	LD	A,(LAB_F822)	;167D:	3A22F8
	LD	(HL),A		;1680:	77
	INC	HL		;1681:	23
	LD	DE,(LAB_F8B6)	; get last mem page size ??
	LD	(HL),E		;1686:	73
	INC	HL			; increment pointer
	LD	(HL),D		;1688:	72
	INC	HL		;1689:	23
	LD	A,(LAB_F8AF)	; get first mem page #
	LD	(HL),A		;168D:	77
	RET				;

LAB_168F
	LD	A,(LAB_FBD4)	;168F:	3AD4FB
	OR	C		;1692:	B1
	LD	(LAB_FBCA),A	; save interrupt flag mask byte ??
	LD	B,A			; copy it
	LD	A,(LAB_FBC9)	; get interrupt flag byte
	AND	#F7h			; clear RTC timebase flag, mask xxxx 0xxx
	LD	(LAB_FBC9),A	; save interrupt flag byte
	AND	B			; and with mask byte
	JR	NZ,LAB_16E0		; was valid interrupt so get first bit & RET

	LD	A,B			; else copy mask byte
	AND	#08h			; check timebase enable bit, mask 0000 x000
	JR	Z,LAB_16B4		; jump if timebase not set

					; set RTC timebase vector
	LD	DE,LAB_1708		; set vector
	LD	(LAB_FBCC),HL	; save count
	LD	HL,LAB_FBCC		; set count pointer
	EX	DE,HL			; swap so right way round
	CALL	LAB_2189		; save DE & HL in RTC interrupt table
					; return carry set if not saved
LAB_16B4
	LD	HL,(LAB_FBD6)	; get go to sleep default count
	LD	(LAB_FBCE),HL	; save go to sleep countdown time
	LD	HL,LAB_1711		; set vector (go to sleep)
	LD	DE,LAB_FBCE		; set count pointer (go to sleep count)
	CALL	LAB_2189		; save DE & HL in RTC interrupt table
					; return carry set if not saved
LAB_16C3
	EI				; enable interrupts
	LD	A,#01h		; set value
	LD	(LAB_FFA8),A	; save interrupts setup ?? flag

	HALT				; stop

	LD	A,(LAB_FBCA)	; get interrupt flag mask byte ??
	LD	B,A			; copy it
	LD	A,(LAB_FBC9)	; get interrupt flag byte
	AND	B			; AND with mask ??
	JR	NZ,LAB_16E0		; was valid interrupt so get first bit & RET

	LD	A,(LAB_FBF2)	;16D4:	3AF2FB
	OR	A		;16D7:	B7
	JR	Z,LAB_16C3	;16D8:	28E9
	XOR	A		;16DA:	AF
	LD	(LAB_FBF2),A	;16DB:	32F2FB
	JR	LAB_16B4		; loop forever

; was valid interrupt so get first bit

LAB_16E0
	LD	HL,LAB_FBCE		; set pointer to go to sleep count
	CALL	LAB_21BA		; search table for HL (count pointer), clear if found
					; else return carry set
	XOR	A			; clear A
	LD	(LAB_FBD4),A	;16E7:	32D4FB
	LD	C,#01h		; set mask for first bit
	LD	A,(LAB_FBC9)	; get interrupt flag byte
	LD	B,A			; copy it
LAB_16F0
	LD	A,(LAB_FBCA)	; get interrupt flag mask byte ??
	AND	B			; AND with interrupt flag byte
	AND	C			; AND with mask
	JR	NZ,LAB_16FC		; jump if it's this bit

	SLA	C			; shift to next bit
	JP	NC,LAB_16F0		; go do next bit

LAB_16FC
	LD	B,A			; copy interrupt bit
	CPL				; invert it
	LD	C,A			; copy inverse byte
	LD	A,(LAB_FBC9)	; get interrupt flag byte
	AND	C			; clear bit found
	LD	(LAB_FBC9),A	; save interrupt flag byte
	LD	A,B			; get interrupt bit back
	RET				;

; RTC timebase vector
; set RTC timebase happened flag

LAB_1708
	LD	A,(LAB_FBC9)	; get interrupt flag byte
	OR	#08h			; set RTC timebase flag, set xxxx 1xxx
	LD	(LAB_FBC9),A	; save interrupt flag byte
	RET				;

; RTC timebase vector

LAB_1711
	LD	A,(KBD_Buff)	; get KBD_W buffer
	PUSH	AF			; save it
	XOR	A			; clear A
	LD	(KBD_Buff),A	; clear KBD_W buffer
	CALL	LAB_1721	;1719:	CD2117
	POP	AF			; restore KBD_W buffer
	LD	(KBD_Buff),A	; save KBD_W buffer
	RET				;

; go to sleep code

LAB_1721
	DI				; disable interrupts
	PUSH	AF			; save A
	LD	A,#01h		; set A
	LD	(LAB_FBD5),A	; set sleep count ??
	POP	AF			; restore A
	PUSH	AF			; save A
	PUSH	AF			; save A
	PUSH	AF			; save A
	PUSH	AF			; save A
	PUSH	BC			; save BC
	PUSH	DE			; save DE
	PUSH	HL			; save HL
	PUSH	IX			; save IX
	PUSH	IY			; save IY
	EX	AF,AF'		; swap AF,AF'
	EXX				; swap alternate register set
	PUSH	AF			; save AF'
	PUSH	BC			; save BC'
	PUSH	DE			; save DE'
	PUSH	HL			; save HL'
	PUSH	IX			; save IX
	PUSH	IY			; save IY
	LD	(LAB_FBD0),SP	; save sleep mode stack value
	LD	A,(LAB_FC03)	;1742:	3A03FC
	OR	A			; set the flags
	JR	NZ,LAB_1753		; skip block copy if not zero

	LD	HL,LAB_FBF3		; set source pointer to display attributes area
	LD	DE,LAB_FBFB		; set dest pointer to display attributes buffer area
	LD	BC,0008h		; 08h bytes to copy
	LDIR				; copy block
LAB_1753
	LD	A,#02h		; set A
	LD	(LAB_FBD5),A	; set sleep count ??

; go to sleep loop

LAB_1758
	XOR	A			; clear A
	OUT	(KBD_W),A		; out to key matrix
	LD	A,(KBD_Buff)	; get KBD_W buffer
	AND	#40h			; mask 0x00 0000
	JR	NZ,LAB_1766		; jump if shutdown bit set

	LD	A,#3Fh		; turn all key rows on
	JR	LAB_1768		; go output it

LAB_1766
	LD	A,#48h		; else set rows x1xx 1xxx
LAB_1768
	LD	(KBD_Buff),A	; save KBD_W buffer
	OUT	(KBD_W),A		; out to key matrix
	JR	NZ,LAB_1779		; jump if shutdown bit was set ??

	LD	A,(LAB_FBCB)	;176F:	3ACBFB
	OR	A			; set the flags
	JR	NZ,LAB_177D	;1773:	2008

	LD	A,#F8h		; value if shutdown bit not set ?? & (LAB_FBCB)=0
					; enable keyboard, RTC & IR port interrupts
	JR	LAB_177F		; go set port 4

LAB_1779
	LD	A,#FAh		; value if shutdown bit was set ??
					; enable keyboard & IR port interrupts
	JR	LAB_177F		; go set port 4

LAB_177D
	LD	A,#D8h		; value if shutdown bit not set ?? & (LAB_FBCB)<>0
					; enable keyboard, RTC, IR port & ?? interrupts
LAB_177F
	OUT	(Port_04),A		; set hardware interrupt mask
	LD	A,(LAB_F78D)	; get Port_2C buffer
	AND	#20h			; set xx1x xxxx
	OUT	(Port_2C),A		; out to Port_2C
	LD	A,(LAB_F792)	; get Port_48 buffer
	OR	#03h			; set xxxx xx11
	OUT	(Port_48),A		; out to Port
	CALL	LAB_2295		; disable PIE (RTC)
	NOP				;

; forever loop

LAB_1793
	IN	A,(Port_05)		; clear interrupt flag byte
	LD	A,#03h		; value for port_07
	PUSH	AF			; save A
	LD	A,(LAB_F78B)	; get Port_2A buffer
	AND	#DFh			; mask xx0x xxxx
	OUT	(Port_2A),A		; out to Port_2A
	POP	AF			; restore A
	OUT	(Port_07),A		; value out to Port_07
	NOP				;
	JR	LAB_1793		; loop forever ??

; port 49 was xxxx xx1x at startup

LAB_17A5
	IN	A,(Port_05)		; get interrupt flag byte
	AND	#02h			; only RTC interrupt, mask 0000 00x0
	JR	NZ,LAB_17AE		; jump if (not)? RTC interrupt

	CALL	LAB_222E		; RTC alarm interrupt service routine
LAB_17AE
	LD	A,(LAB_F786)	; get Port_07 buffer
	AND	#FEh			; mask xxxx xxx0
	LD	(LAB_F786),A	; save Port_07 buffer
	OUT	(Port_07),A		; out to Port_07
	LD	A,(LAB_FDB7);17B8:	3AB7FD
	OR	A		;17BB:	B7
	JP	Z,LAB_1872		; call initialise LCD display & RET

LAB_17BF
	LD	A,(KBD_Buff)	; get KBD_W buffer
	AND	#40h			; mask 0x00 0000
	JR	NZ,LAB_17D0		; jump if shutdown bit set ??

	LD	A,#FFh		;17C6:	3EFF
	LD	(LAB_FBDD),A	; set key mode
	LD	A,#01h		;17CB:	3E01
	LD	(LAB_FBD8),A	;17CD:	32D8FB
LAB_17D0
	LD	A,(LAB_F791)	; get current memory page
	OUT	(MEM_P),A		; set memory page
	LD	A,(KBD_Buff)	; get KBD_W buffer
	AND	#3Fh			; mask 00xx xxxx
	LD	(KBD_Buff),A	; save KBD_W buffer
	OUT	(KBD_W),A		; out to key matrix
	LD	A,(LAB_F78D)	; get Port_2C buffer
	AND	#EFh			; backlight off mask xxx0 xxxx
	LD	(LAB_F78D),A	; save Port_2C buffer
	OUT	(Port_2C),A		; out to Port_2C
	LD	A,(LAB_F784)	; get Port_04 buffer
	AND	#E7h			; enable battery interrupts, mask xxx0 0xxx
	LD	(LAB_F784),A	; save Port_04 buffer
	OUT	(Port_04),A		; out to Port_04
	LD	A,(LAB_F78B)	; get Port_2A buffer
	OR	#20h			; set xx1x xxxx
	LD	(LAB_F78B),A	; save Port_2A buffer
	OUT	(Port_2A),A		; out to Port_2A
	LD	B,#0Ch		; set RTC address port 0Ch
	LD	C,#RTC_A		; set RTC address
	OUT	(C),B			; set port
	IN	A,(RTC_D)		; get RTC data
	CALL	LAB_229E		; enable PIE (RTC)
	LD	A,#01h		;1808:	3E01
	LD	(LAB_FBF2),A	;180A:	32F2FB
	LD	A,#50h		; multiplier of 50h (80d)
	CALL	LAB_35CE		; delay of A*????
	CALL	LAB_1F33		; initialise LCD display

	LD	A,(LAB_FC03)	;1815:	3A03FC
	PUSH	AF		;1818:	F5
	LD	A,(LAB_FC04)	;1819:	3A04FC
	PUSH	AF		;181C:	F5
	CALL	LAB_1E27		; restore LDC display from buffer
	POP	AF		;1820:	F1
	LD	(LAB_FC04),A	;1821:	3204FC
	POP	AF		;1824:	F1
	LD	(LAB_FC03),A	;1825:	3203FC

	LD	HL,000Ah	;1828:	210A00
	LD	(LAB_FD99),HL	;182B:	2299FD
	LD	HL,000Fh	;182E:	210F00
	LD	(LAB_FD97),HL	;1831:	2297FD
	CALL	LAB_2468		; compare clock date/month with stored date/month ??

	LD	HL,(LAB_FBD0)	; get sleep mode stack value
	LD	BC,FFE8h		; -18h
	ADD	HL,BC			; add to pointer
	LD	SP,HL			; set the stack ??
	LD	DE,(LAB_FBD0)	; get sleep mode stack value
	EX	DE,HL			; pointer is source, stack is destination
	LD	BC,0018h		; 18h bytes to copy
	LDIR				; copy block

	LD	C,#06h		; offset for 3 dummy PUSH AFs
	ADD	HL,BC			; add to effective stack
	LD	(LAB_FBD2),HL	; save for now
	POP	IY			; restore IY'
	POP	IX			; restore IX'
	POP	HL			; restore HL'
	POP	DE			; restore DE'
	POP	BC			; restore BC'
	POP	AF			; restore AF'
	EXX				; exchange register sets
	EX	AF,AF'		; exchange accumulators
	POP	IY			; restore IY
	POP	IX			; restore IX
	POP	HL			; restore HL
	POP	DE			; restore DE
	POP	BC			; restore BC
	POP	AF			; restore AF
	LD	SP,(LAB_FBD2)	; set stack
	PUSH	AF			; save A
	LD	A,#00h		; clear A (could XOR A!)
	LD	(LAB_FBD5),A	; clear sleep count ??
	POP	AF			; restore A
	IM	1			; set interrupt mode 1
	CALL	LAB_F54E		; enable interrupts if interrupts setup ?? flag <> 0
					; (LAB_3A6B)
	RET				;

; call initialise LCD display

LAB_1872
	CALL	LAB_1F33		; initialise LCD display
	RET				;
LAB_1876
	RET				;

; set ?? countdown default ?? (range 04h to FFh else 0Fh)

LAB_1877
	LD	A,E			; copy ??
	CP	#04h			; compare with 04h
	JR	NC,LAB_187E		; jump if >= 04h

	LD	E,#0Fh		; else load with 0Fh
LAB_187E
	LD	HL,LAB_FBD7		; set pointer
	LD	A,(HL)		; get old byte
	LD	(HL),E		; save new byte
	DEC	HL			; decrement ! pointer
	LD	(HL),#00h		; clear byte
	RET				;

LAB_1887
	RET				;

; set HL = FFFFh

; BDOS function 24 - Return bitmap of logged-in drives
;
; Returns bitmap in HL. 
; Bit 7 of H corresponds to P: while bit 0 of L corresponds to A:. A bit is set if 
; the corresponding drive is logged in.
;
; this appears to default to all drives logged

LAB_1888
	LD	HL,FFFFh	;1888:	21FFFF
	RET				;

; BDOS function 27 - Return address of allocation map
;
; Returns address in HL. 
; Return the address of the allocation bitmap (which blocks are used and which are 
; free) in HL. 
; The format of the bitmap is a sequence of bytes, with bit 7 of the byte representing
; the lowest-numbered block on disc, and counting starting at block 0 (the directory).
; A bit is set if the corresponding block is in use. 

; this is also ....

; BDOS function 29 - Return bitmap of read-only drives
;
; Returns bitmap in HL. 
; Bit 7 of H corresponds to P: while bit 0 of L corresponds to A:. A bit is set if 
; the corresponding drive is set to read-only in software. 
;
; it appears no drives are R/O on the micronic

LAB_188C
	LD	HL,0000h	;188C:	210000
	RET				;

; BDOS function 32 - get/set user number
;
; E=number. If E=0FFh, returns number in A. 
; Set current user number. E should be 0-15, or 255 to retrieve the current user 
; number into A. Some versions can use user areas 16-31, but these should be 
; avoided for compatibility reasons. 

LAB_1890
	LD	A,#00h		;1890:	3E00
	RET				;

; do RST 28h error handling

LAB_1893
	LD	C,#FEh		;1893:	0EFE
	RST	28h			; process error code, error code is in A
	RET				;

; set up keyboard parameters & buffer

LAB_1897
	XOR	A			; clear A
	LD	(LAB_FBE5),A	; clear key repeat count
	LD	(LAB_FBDD),A	; set key mode
	LD	A,#01h		; cursor off, blink on (chr blink)
	LD	(LAB_FBDC),A	; set cursor blink flag
	CALL	LAB_1FB6		; set cursor mode
	LD	A,#15h		; set max to 15h (2/3 second)
	LD	(LAB_FBE6),A	; save key repeat max count
	CALL	LAB_1A77		; set buffer & all KBD lines
	LD	HL,LAB_FBE8		; set key buffer start
	LD	(LAB_FBEE),HL	; save key buffer next in
	LD	(LAB_FBF0),HL	; save key buffer next out
	LD	C,#06h		; 6 bytes to clear
LAB_18B9
	LD	(HL),#00h		; clear byte
	INC	HL			; increment pointer
	DEC	C			; decrement count
	JR	NZ,LAB_18B9		; loop if not all done
	RET				;

; get key from buffer, returns Z=true if no key.

LAB_18C0
	DI				; disable interrupts
	LD	HL,(LAB_FBF0)	; get key buffer next out
	LD	A,(HL)		; get key
	OR	A			; set the flags
	JR	Z,LAB_18E6		; jump if null

	LD	(HL),#00h		; clear buffer byte
	PUSH	AF			; save key
	LD	A,(LAB_FBC9)	; get interrupt flag byte
	AND	#FBh			; clear key press flag, mask xxxx x0xx
	LD	(LAB_FBC9),A	; save interrupt flag byte
	CALL	LAB_1B44		; increment pointer, wrap round if needed
	LD	(LAB_FBF0),HL	; save key buffer next out
	LD	A,(HL)		; get next key
	OR	A			; set the flags
	JR	Z,LAB_18E5		; jump if empty

	LD	A,(LAB_FBC9)	; get interrupt flag byte
	OR	#04h			; set key press bit, set xxxx x1xx
	LD	(LAB_FBC9),A	; save interrupt flag byte
LAB_18E5
	POP	AF			; restore key
LAB_18E6
	CALL	LAB_F54E		; enable interrupts if interrupts setup ?? flag <> 0
					; (LAB_3A6B)
	CP	#CDh			; was key CDh ?
	JP	Z,LAB_3513		; just does XOR A (make it 32h if it was ??!)
	OR	A			; set the flags
	RET				;

; scan matrix ...

;	(02)
;	   ___________________________________________________
;	 D0		|	|  R \|  O \|  K \|  G \|  C \|  ^ \|
;			|	| 4   | 7   | ua  |REFER|CHNGE| v   |
;	   _________|_____|_____|_____|_____|_____|_____|_____|
;	 D1		|	|  S \|  P \|  L \|  H \|  D \|  A \|
;			|	| 5   | 8   | da  |HELP |DEL  |STWDL|
;	   _________|_____|_____|_____|_____|_____|_____|_____|
;	 D2		|	|  T \|  Q \|  M \|  I \|  E \|  B \|
;			|	| 6   | 9   | .   |INSRT| F1  |LIGHT|
;	   _________|_____|_____|_____|_____|_____|_____|_____|
;	 D3		|	| END\|DEPT\|  N \|  J \|  F \|  @ \|
;			|	|TOP  |/POS | Z   | ? Y |F2 X |	|
;	   _________|_____|_____|_____|_____|_____|_____|_____|
;	 D4		|	|	|	|ENTR\|  W \|  V \|  U \|
;			|	|	|	|BOT  | 3   | 2   | 1   |
;	   _________|_____|_____|_____|_____|_____|_____|_____|
;	 D5		|	|	|	| YES\| NO \|SPCE\|  < \|
;			|	|	|	|     |     | Q   |     |
;	   _________|_____|_____|_____|_____|_____|_____|_____|
;	 D6		|	|	|	|	|	|	|	|
;			|	|	|	|	|	|	|	|
;	   _________|_____|_____|_____|_____|_____|_____|_____|
;	 D7		|	|	|	|	|	|	|	|
;			|	|	|	|	|	|	|	|
;			|	|	|	|	|	|	|	|
;		(00)	D7	D6	D5	D4	D3	D2	D1	D0

LAB_18F0
	CALL	LAB_1AF2		; change key mode (FFh->0->1->2->3->0)
	CALL	LAB_1A42		; set buffer & all KBD lines, in (KBD_R)
	JP	Z,LAB_199D		; if key set buffer & all KBD lines, clear A & exit

					; else if key was pressed
	LD	A,#08h		; set scan for @ key
	CALL	LAB_1A44		; KBD out & buffer A, in (KBD_R)
	AND	#01h			; mask all but @ key
	JP	NZ,LAB_19C0		; was @ key so jump

	LD	A,#01h		; set scan for ^ key (shift up/down)
	CALL	LAB_1A44		; KBD out & buffer A, in (KBD_R)
	AND	#01h			; mask all but ^ key
	JP	NZ,LAB_19A2		; was ^ key so toggle cursor blink mode & ??

	LD	B,#06h		; 6 (row/col)s to do
	LD	D,#01h		; set first bit
LAB_1911
	LD	A,D			; get scan (row/col)
	CALL	LAB_1A44		; KBD out & buffer A, in (KBD_R)
	AND	#3Fh			; mask return (allready done is SUB!!)
	JR	NZ,LAB_1921		; find which (col/row) if not 0
	DEC	B			; else decrement (row/col) count
	JP	Z,LAB_199D		; set buffer & all KBD lines, clear A & exit
					; set matrix bits ?? clear result & exit
	SLA	D			; set bit for next (row/col)
	JR	LAB_1911		; go do next

; detected a bit set, so we got here....

LAB_1921
	LD	E,A			; save returned scan (col) byte
	LD	A,D			; get scan (row) byte
	LD	D,E			; save returned scan (col) byte
	CALL	LAB_1A52		; scan (row) for first bit = 1
	LD	C,A			; save (row) result
	LD	A,D			; restore returned scan (col) byte
	CALL	LAB_1A52		; scan (col) for first bit = 1
	SLA	A			; result *2
	LD	D,A			; copy it
	SLA	A			; result *4
	ADD	A,D			; result *6
	ADD	A,C			; add (row) #
	LD	(LAB_FBDE),A	; save scan result
	LD	HL,(LAB_FBDA)	; get key table base address pointer
	LD	DE,0024h		; offset to next table
	LD	A,(LAB_FBDC)	; get cursor blink flag
	OR	A			; set the flags
	JR	Z,LAB_1944		; jump if not set

	ADC	HL,DE			; else add offset to 2nd key table
LAB_1944
	LD	A,(LAB_FBDD)	; get key mode
	CP	#02h			; is it 02h?
	JR	NZ,LAB_1957		; jump if not
					; key mode was 02h
	LD	HL,(LAB_FBDA)	; get key table base address pointer
	ADC	HL,DE			; add offset to 2nd table
	ADC	HL,DE			; add offset to 3rd table
	LD	A,#03h		; set new key mode
	LD	(LAB_FBDD),A	; set key mode
LAB_1957
	LD	A,(LAB_FBDE)	; get scan result back
	LD	C,A			; copy it
	LD	B,#00h		; clear high byte
	ADD	HL,BC			; add to pointer ??
	LD	A,(HL)		; get byte from table ??
	OR	A			; set the flags
	JR	Z,LAB_199D		; set buffer & all KBD lines, clear A & exit

	LD	(LAB_FBE7),A	; else save decoded matrix scan byte
	LD	A,(LAB_FBC9)	; get interrupt flag byte
	OR	#04h			; set key press bit, set xxxx x1xx
	LD	(LAB_FBC9),A	; save interrupt flag byte
	CALL	LAB_1A81		; clear buffer & all KBD lines
	CALL	LAB_1B2E		; set bit 1 of Port_04
	CALL	LAB_1A96		; set countdown for @ key ??
	LD	HL,(LAB_FBEE)	; get key buffer next in
	LD	DE,(LAB_FBF0)	; get key buffer next out
	XOR	A			; clear A (and carry)
	SBC	HL,DE			; subtract out from in
	JR	NZ,LAB_198F		; jump if different

	LD	HL,(LAB_FBF0)	; get key buffer next out
	LD	A,(HL)		; get byte
	OR	A			; set the flags
	JR	Z,LAB_198F		; jump if zero

	CALL	LAB_1B44		; increment pointer, wrap round if needed
	LD	(LAB_FBF0),HL	; save key buffer next out
LAB_198F
	LD	A,(LAB_FBE7)	; get decoded byte back ??
	LD	HL,(LAB_FBEE)	; get key buffer next in
	LD	(HL),A		; save key ??
	CALL	LAB_1B44		; increment pointer, wrap round if needed
	LD	(LAB_FBEE),HL	; save key buffer next in
	RET				;

; set buffer & all KBD lines, clear A

LAB_199D
	CALL	LAB_1A77		; set buffer & all KBD lines
	XOR	A			; clear result
	RET				;

; toggle cursor blink mode & ??

LAB_19A2
	LD	A,(LAB_FBDC)	; get cursor blink flag
	CPL				; complement it
	AND	#01h			; clear other bits
	LD	(LAB_FBDC),A	; save blink flag back
	JR	Z,LAB_19B2		; if zero set cursor on

	CALL	LAB_1E81		; else set cursor off
	JR	LAB_19B5	;19B0:	1803

LAB_19B2
	CALL	LAB_1E6F		; set cursor on
LAB_19B5
	CALL	LAB_1B2E		; set bit 1 of Port_04
	CALL	LAB_1A96		; set countdown for @ key ??
	CALL	LAB_1A81		; clear buffer & all KBD lines
	XOR	A			; clear result
	RET				;

; detected @ key pressed

LAB_19C0
	LD	A,#01h		;19C0:	3E01
	LD	(LAB_FBF2),A	;19C2:	32F2FB
	LD	HL,(LAB_19E0-2)	; point to @ key table -2
LAB_19C8
	INC	HL			; increment pointer
	INC	HL			; increment pointer
	LD	A,(HL)		; get OUT byte from table
	CP	#FFh			; compare with FFh
	JR	Z,LAB_1A29		; jump if table end

	INC	HL			; point to result byte
	LD	B,(HL)		; get expected result
	INC	HL			; point to routine vector
	CALL	LAB_1A44		; KBD out & buffer A, in (KBD_R)
	AND	#3Fh			; (already done by routine!)
	CP	B			; compare with expected
	JR	NZ,LAB_19C8		; loop if not a match

	LD	A,#FFh		;19DA:	3EFF
	LD	(LAB_FBDD),A	; set key mode
	JP	(HL)			; go jump to jump code

LAB_19E0
	DB	08h,21h		; OUT 08h, expect 21h
	JR	LAB_19F1		; go do [@ TOP] raise LCD view angle
	DB	10h,08h		; OUT 10h, expect 08h
	JR	LAB_19F6		; go do [@ BOT] lower LCD view angle
	DB	01h,01h		; OUT 01h, expect 01h
	JR	LAB_19FB		; go do [@ ^] shutdown
	DB	04h,01h		; OUT 04h, expect 10h
	JR	LAB_1A0A		; go do [@ B] backlight on/off
	DB	FFh

; raise LCD view angle

LAB_19F1
	CALL	LAB_1D4A	; double decrement LCD contrast
	JR	LAB_19B5	;19F4:	18BF

; lower LCD view angle

LAB_19F6
	CALL	LAB_1D60	; double increment LCD contrast
	JR	LAB_19B5	;19F9:	18BA

; shutdown device

LAB_19FB
	CALL	LAB_1A42		; set buffer & all KBD lines, in (KBD_R)
	JR	NZ,LAB_19FB		; wait until keys released

	LD	A,#40h		; set sleep value
	LD	(KBD_Buff),A	; save KBD_W buffer
	CALL	LAB_1721	;1A05:	CD2117
	JR	LAB_19B5	;1A08:	18AB

; turns backlight on/off

; could have been ....

;	LD	A,(LAB_F78D)	; get lamp on/off byte again
;	XOR	A,#10h		; toggle lamp bit XOR xxxB xxxx
;	LD	(LAB_F78D),A	; save lamp on/off byte
;	OUT	(Port_2C),A		; out to port
;	JR	LAB_19B5		; jump

LAB_1A0A
	LD	A,(LAB_F78D)	; get lamp on/off byte
	AND	#10h			; mask all but lamp bit
	JR	NZ,LAB_1A1D		; jump if allready on

	LD	A,(LAB_F78D)	; get lamp on/off byte again
	OR	#10h			; set lamp bit
	LD	(LAB_F78D),A	; save lamp on/off byte
	OUT	(Port_2C),A		; out to port
	JR	LAB_19B5	;1A1B:	1898

LAB_1A1D
	LD	A,(LAB_F78D)	; get lamp on/off byte again
	AND	#EFh			; clear lamp bit
	LD	(LAB_F78D),A	; save lamp on/off byte
	OUT	(Port_2C),A		; out to port
	JR	LAB_19B5	;1A27:	188C

LAB_1A29
	CALL	LAB_1B21		; returns ZERO if only the @ key was pressed
	JR	Z,LAB_1A33		; jump if only @ key

	LD	A,#FFh		;1A2E:	3EFF
	LD	(LAB_FBDD),A	; set key mode
LAB_1A33
	LD	A,(LAB_FBDD)	; get key mode
	CP	#FFh			; is it FFh?
	JR	Z,LAB_1A3F		; jump if so

	LD	A,#01h		; else set mode 01h
	LD	(LAB_FBDD),A	; save key mode
LAB_1A3F
	JP	LAB_199D		; set buffer & all KBD lines, clear A & exit

; set buffer & all KBD lines, in (KBD_R)

LAB_1A42
	LD	A,#3Fh		; set output value

; KBD out & buffer A, in (KBD_R)

LAB_1A44
	LD	(KBD_Buff),A	; save KBD_W buffer
	OUT	(KBD_W),A		; out to port
	PUSH	HL			; wait a bit ..
	POP	HL			; ..
	PUSH	HL			; ..
	POP	HL			; ..
	IN	A,(KBD_R)		; in from key matrix
	AND	#3Fh			; mask byte mask 00xx xxxx
	RET				;

; search A (bits 0-5) for a 1. return position of first bit=1 in A.
; returns carry set if more than 1 bit=1

LAB_1A52
	PUSH	BC			; save BC
	PUSH	DE			; save DE
	LD	BC,0000h		; clear bit=1 count & bit #
	LD	D,#00h		; clear result
LAB_1A59
	RRA				; bit 0 to carry
	JR	NC,LAB_1A5E		; jump if was 0

	LD	D,C			; else copy bit # to result
	INC	B			; increment bit=1 count
LAB_1A5E
	LD	E,A			; save byte
	LD	A,C			; get bit #
	INC	A			; increment bit #
	CP	#06h			; at end yet ?
	JR	Z,LAB_1A69		; jump if so

	LD	C,A			; else save bit # back
	LD	A,E			; restore byte
	JR	LAB_1A59		; go do next bit #

LAB_1A69
	XOR	A			; clear A & flags
	LD	A,B			; get bit=1 count
	OR	A			; set flags
	JR	Z,LAB_1A73		; exit if 0 (o.k. no bits=1)
	CP	#01h			; compare with 1
	JR	Z,LAB_1A73		; exit if 1 (o.k. 1 bit=1)
	SCF				; else set carry (>1 bit=1)
LAB_1A73
	LD	A,D			; copy result to A
	POP	DE			; restore DE
	POP	BC			; restore BC
	RET				;

; set buffer & all KBD lines

LAB_1A77
	LD	C,#KBD_W		; set key matrix write port
	LD	A,#3Fh		; 3Fh to send
	LD	(KBD_Buff),A	; save KBD_W buffer
	OUT	(C),A			; out to matrix
	RET				;

; clear buffer & all KBD lines

LAB_1A81
	LD	C,#KBD_W		; set key matrix write port
	LD	A,#00h		; clear A
	LD	(KBD_Buff),A	; clear KBD_W buffer
	OUT	(C),A			; clear key matrix bits
	RET				;

; error # 42h return address ??
; (re)set key table pointer (A=0)

LAB_1A8B
	OR	A			; set the flags
	JR	NZ,LAB_1A91		; jump if not null
	LD	DE,LAB_1B58		; else reset key table pointer
LAB_1A91
	LD	(LAB_FBDA),DE	; save key table base address pointer
	RET				;

; set countdown for key repeat

LAB_1A96
	LD	HL,0002h		; set count (1/32nd sec)
	LD	(LAB_FBDF),HL	; save key repeat timer count
	LD	HL,LAB_1AA6		; set vector
	LD	DE,LAB_FBDF		; set count pointer
	CALL	LAB_2189		; save DE & HL in RTC interrupt table
					; return carry set if not saved
	RET				;

; key repeat vector

LAB_1AA6
	CALL	LAB_1B21		; returns ZERO if only the @ key was pressed
	JR	Z,LAB_1ABF		; only @ key so jump

	LD	A,(LAB_FBE5)	; get key repeat count
	INC	A			; increment it
	LD	B,A			; copy it
	LD	A,(LAB_FBE6)	; get key repeat max count
	CP	B			; compare with count
	JR	Z,LAB_1AD3		; jump if there

	LD	A,B			; else get key repeat count back
	LD	(LAB_FBE5),A	; and save it
	CALL	LAB_1A96		; reset countdown for key repeat
	JR	LAB_1B1A		; clear matrix & set (04h) bit 1 (that code could be here!)

; here if only @ key

LAB_1ABF
	CALL	LAB_1AF2		; change key mode (FFh->0->1->2->3->0)
	LD	A,#15h		; set key repeat max count
	LD	(LAB_FBE6),A	; save key repeat max count
	LD	A,#00h		; clear A (could XOR A!)
	LD	(LAB_FBE5),A	; clear key repeat count
	CALL	LAB_1A77		; set buffer & all KBD lines
	CALL	LAB_1B39		; clear bit 1 of port (04)
	RET				;

; have reached (any key) countdown

LAB_1AD3
	LD	A,#04h		; set new key repeat max count
	LD	(LAB_FBE6),A	; save it (1/8th second)
	LD	A,#00h		; clear A
	LD	(LAB_FBE5),A	; clear key repeat count
	LD	A,(LAB_FBDD)	; get key mode
	CP	#03h			; is it 03h?
	CALL	Z,LAB_1AEC		; if so set key mode 02h
	CALL	LAB_1A77		; set buffer & all KBD lines
	CALL	LAB_1B39		; clear bit 1 of port (04)
	RET				;

; set key mode 02h

LAB_1AEC
	LD	A,#02h		; set key mode 02h
	LD	(LAB_FBDD),A	; save key mode
	RET				;

; change key mode (FFh->0->1->2->3->0)

LAB_1AF2
	LD	A,#08h		; @ key row
	CALL	LAB_1A44		; KBD out & buffer A, in (KBD_R)
	AND	#01h			; mask @ key
	RET	NZ			; return if @ key down

	LD	A,(LAB_FBDD)	; get key mode
	CP	#FFh			; if it FFh?
	JR	NZ,LAB_1B05		; jump if not

	XOR	A			; else clear key mode
	LD	(LAB_FBDD),A	; save key mode
LAB_1B05
	LD	A,(LAB_FBDD)	; get key mode
	CP	#01h			; is it 01h?
	JR	NZ,LAB_1B12		; jump if not

	LD	A,#02h		; else make it 02h (INC A is 1 byte less)
	LD	(LAB_FBDD),A	; save key mode
	RET				;

LAB_1B12
	CP	#03h			; is mode 03h?
	RET	NZ			; return if not
	XOR	A			; else clear key mode
	LD	(LAB_FBDD),A	; save key mode
	RET				;

; clear matrix & set Port_04 bit 1

LAB_1B1A
	CALL	LAB_1A81		; clear buffer & all KBD lines
	CALL	LAB_1B2E		; set bit 1 of port (04)
	RET				;

; returns ZERO if only the @ key was pressed

LAB_1B21
	LD	A,#F7h		; all roes except @ row
	CALL	LAB_1A44		; KBD out & buffer A, in (KBD_R)
	JR	NZ,LAB_1B2D		; RET if other keys pressed (could have done RET NZ!)
	CALL	LAB_1A42		; set buffer & all KBD lines, in (KBD_R)
	AND	#FEh			; mask out @ key
LAB_1B2D
	RET				;

; set bit 1 of Port_04

LAB_1B2E
	LD	A,(LAB_F784)	; get Port_04 buffer
	OR	#01h			; set bit 1
	LD	(LAB_F784),A	; save Port_04 buffer
	OUT	(Port_04),A		; out to Port_04
	RET				;

; clear bit 1 of Port_04

LAB_1B39
	LD	A,(LAB_F784)	; get Port_04 buffer
	AND	#FEh			; clear bit 1
	LD	(LAB_F784),A	; save Port_04 buffer
	OUT	(Port_04),A		; out ot Port_04
	RET				;

; increment pointer, wrap round if needed

LAB_1B44
	LD	DE,1+LAB_FBED	; 1 byte past the end
	LD	BC,LAB_FBE8		; the start
	INC	HL			; increment pointer
	PUSH	HL			; save it
	XOR	A			; clear A (and carry)
	SBC	HL,DE			; sub end+1 from pointer
	JR	NZ,LAB_1B56		; jump if not past end

	LD	H,B			; else load pointer
	LD	L,C			; with start
	POP	DE			; and dump increment
	JR	LAB_1B57		; (RET here would be better!)

LAB_1B56
	POP	HL			; restore increment
LAB_1B57
	RET				;

LAB_1B58				; key matrix alpha1
	DB	00h,'A','B',00h,'U',7Fh
	DB	'C','D','E','F','V',' '
	DB	'G','H','I','J','W',01h
	DB	'K','L','M','N',0Dh,06h
	DB	'O','P','Q',D0h,00h,00h
	DB	'R','S','T',14h,00h,00h
LAB_1B7C				; key matrix numeric
	DB	00h,'(',')',00h,'1',7Fh
	DB	EDh,'%','#','&','2','0'
	DB	'+','/',',','?','3',01h
	DB	'-','*','.',DBh,0Dh,06h
	DB	'7','8','9',D0h,00h,00h
	DB	'4','5','6',14h,00h,00h
LAB_1BA0				; key matrix alpha2
	DB	00h,00h,00h,00h,00h,1Ah
	DB	00h,00h,00h,'X',00h,00h
	DB	00h,00h,00h,'Y',00h,0Ch
	DB	00h,00h,00h,'Z',12h,0Bh
	DB	00h,00h,00h,00h,00h,00h
	DB	00h,00h,00h,11h,00h,00h

; display chr ???

LAB_1BC4
	PUSH	AF			; save chr
	LD	A,(LAB_FC04)	;1BC5:	3A04FC
	AND	#04h			; mask 0000 0x00
	JR	NZ,LAB_1BE3	;1BCA:	2017
	LD	A,#06h		;1BCC:	3E06
	LD	(LAB_FC04),A	;1BCE:	3204FC
	LD	HL,LAB_FBF3		; set source pointer to display attributes area
	LD	DE,LAB_FBFB		; set dest pointer to display attributes buffer area
	LD	BC,0008h		; 08h bytes to copy
	LDIR				; copy block
	XOR	A			; clear A
	LD	(LAB_FBF3),A	; clear escape mode flag ??
	LD	(LAB_FBFA),A	;1BE0:	32FAFB
LAB_1BE3
	LD	A,#01h		;1BE3:	3E01
	LD	(LAB_FC03),A	;1BE5:	3203FC
	POP	AF			; restore chr
	JR	LAB_1BF9		;

LAB_1BEB
	PUSH	AF			; save chr
LAB_1BEC
	LD	A,(LAB_FC04)	;1BEC:	3A04FC
	AND	#06h			; mask 0000 0xx0
	JR	NZ,LAB_1BEC		; loop until ??

	LD	A,#01h		;1BF3:	3E01
	LD	(LAB_FC04),A	;1BF5:	3204FC
	POP	AF			; restore chr
LAB_1BF9
	LD	(LAB_FBF8),A	; save the character
	LD	A,(LAB_FBF3)	; get escape mode flag ??
	OR	A			; set the flags
	LD	A,(LAB_FBF8)	; get the character back
	LD	B,A		;1C03:	47
	JR	NZ,LAB_1C30		; jump if escape mode ??

	LD	HL,LAB_201C		; set pointer to chr table
	LD	IX,LAB_202C		; set pointer to jump table -2
LAB_1C0D
	LD	A,(HL)		; get character from table
	CP	#FFh			; end of table?
	JR	Z,LAB_1C21		; jump if so
	INC	HL			; else point to next character
	INC	IX			; point to this routine
	INC	IX			; (2 bytes per vector)
	CP	B			; is this the character?
	JR	NZ,LAB_1C0D		; go do next if not

	LD	L,(IX+#00h)		; else get vector low byte
	LD	H,(IX+#01h)		; get vector high byte
	JP	(HL)			; go do character

LAB_1C21
	LD	A,(LAB_FBF8)	;1C21:	3AF8FB
	CALL	LAB_1F79		; byte out to LCD
	CALL	LAB_1DCF		; put byte(s) into display?? buffers
	CALL	LAB_1DB3		; cursor right
	JP	LAB_1D8E		; get D from buffer1 @ x,y
					; get E from buffer2 @ x,y (also mask ??)

LAB_1C30
	XOR	A			; clear A
	LD	(LAB_FBF3),A	; clear escape mode flag ??
	LD	A,(LAB_FBF6)	; get [ESC] X mode flag
	OR	A			; set the flags
	JR	NZ,LAB_1C74		; if [ESC] X mode go do set x

	LD	A,(LAB_FBF7)	; get [ESC] Y mode flag
	OR	A			; set the flags
	JR	NZ,LAB_1C87		; if [ESC] Y mode go do set y

	LD	HL,LAB_2050		; set pointer to chr table
	LD	IX,LAB_2060		; set pointer to jump table -2
LAB_1C47
	LD	A,(HL)		; get character from table
	CP	#FFh			; end of table?
	JR	Z,LAB_1C5B		; jump if so
	INC	HL			; else point to next character
	INC	IX			; point to this routine
	INC	IX			; (2 bytes per vector)
	CP	B			; is this the character?
	JR	NZ,LAB_1C47		; go do next if not

	LD	L,(IX+#00h)		; else get vector low byte
	LD	H,(IX+#01h)		; get vector high byte
	JP	(HL)			; go do character

LAB_1C5B
	JP	LAB_1D8E		; get D from buffer1 @ x,y
					; get E from buffer2 @ x,y (also mask ??)
; was [ESC] X

LAB_1C5E
	LD	A,#FFh		; set escape mode ??
	LD	(LAB_FBF3),A	; save escape mode flag ??
	LD	(LAB_FBF6),A	; set [ESC] X mode flag ??
	JP	LAB_1D8E		; get D from buffer1 @ x,y
					; get E from buffer2 @ x,y (also mask ??)
; was [ESC] Y

LAB_1C69
	LD	A,#FFh		; set escape mode ??
	LD	(LAB_FBF3),A	; save escape mode flag ??
	LD	(LAB_FBF7),A	; set [ESC] Y mode flag ??
	JP	LAB_1D8E		; get D from buffer1 @ x,y
					; get E from buffer2 @ x,y (also mask ??)
; is [ESC] X mode

LAB_1C74
	LD	A,(LAB_FBF8)	; get character back
	LD	C,#14h		; line length
	CALL	LAB_1DFA		; if B>C returns A=C else returns A=B-1
	JR	C,LAB_1C9A		; skip set X if out of range

	LD	(LAB_FBF5),A	; save x position
	CALL	LAB_1F82		; set LCD cursor address
	JP	LAB_1D8E		; get D from buffer1 @ x,y
					; get E from buffer2 @ x,y (also mask ??)

LAB_1C87
	LD	A,(LAB_FBF8)	; get character back
	LD	C,#08h		; # of lines
	CALL	LAB_1DFA		; if B>C returns A=C else returns A=B-1
	JR	C,LAB_1C9A		; skip set Y if out of range

	LD	(LAB_FBF4),A	; save y position
	CALL	LAB_1F82		; set LCD cursor address
	JP	LAB_1D8E		; get D from buffer1 @ x,y
					; get E from buffer2 @ x,y (also mask ??)

LAB_1C9A
	LD	A,#CFh		;1C9A:	3ECF
	SCF			;1C9C:	37
	JP	LAB_1D8E		; get D from buffer1 @ x,y
					; get E from buffer2 @ x,y (also mask ??)

; [ESC]

LAB_1CA0
	LD	A,#FFh		; set A
	LD	(LAB_FBF3),A	; save escape mode flag
	XOR	A			; clear A
	LD	(LAB_FBF6),A	; clear [ESC] X mode flag
	LD	(LAB_FBF7),A	; clear [ESC] Y mode flag
	JP	LAB_1D8E		; get D from buffer1 @ x,y
					; get E from buffer2 @ x,y (also mask ??)

; [CR]

LAB_1CAF
	XOR	A			; clear A
	LD	(LAB_FBF5),A	; clear x position
	CALL	LAB_1F82		; set LCD cursor address
	JP	LAB_1D8E		; get D from buffer1 @ x,y
					; get E from buffer2 @ x,y (also mask ??)

; [LF]

LAB_1CB9
	LD	A,(LAB_FBF4)	; get y position
	INC	A			; do linefeed
	CP	#08h			; wrapped round?
	JR	NZ,LAB_1CC2		; jump if not
	XOR	A			; else wrap round to top
LAB_1CC2
	LD	(LAB_FBF4),A	; save y position
	CALL	LAB_1F82		; set LCD cursor address
	JP	LAB_1D8E		; get D from buffer1 @ x,y
					; get E from buffer2 @ x,y (also mask ??)

; [CSR_UP]

LAB_1CCB
	CALL	LAB_1E0F		; move cursor up
	CALL	LAB_1F82		; set LCD cursor address
	JP	LAB_1D8E		; get D from buffer1 @ x,y
					; get E from buffer2 @ x,y (also mask ??)

; [CSR_RT]

LAB_1CD4
	LD	A,(LAB_FBF5)	; get x position
	INC	A			; do cursor right
	CP	#14h			; wrapped round?
	JR	NZ,LAB_1CDD		; jump if not
	XOR	A			; else wrap round to left
LAB_1CDD
	LD	(LAB_FBF5),A	; save x position
	CALL	LAB_1F82		; set LCD cursor address
	JP	LAB_1D8E		; get D from buffer1 @ x,y
					; get E from buffer2 @ x,y (also mask ??)

; [CSR_LT]

LAB_1CE6
	CALL	LAB_1E01		; move cursor left
	CALL	LAB_1F82		; set LCD cursor address
	JP	LAB_1D8E		; get D from buffer1 @ x,y
					; get E from buffer2 @ x,y (also mask ??)

; [BS]

LAB_1CEF
	CALL	LAB_1E1D		; [BACKSPACE] cursor
	JP	LAB_1D8E		; get D from buffer1 @ x,y
					; get E from buffer2 @ x,y (also mask ??)

; [DEL]

LAB_1CF5
	CALL	LAB_1E1D		; [BACKSPACE] cursor
	LD	A,#20h		; load A with ' 
	LD	(LAB_FBF8),A	; save in chr?? buffer
	CALL	LAB_1F79		; byte out to LCD
	CALL	LAB_1DCF		; put byte(s) into display?? buffers
	CALL	LAB_1DB3		; cursor right
	CALL	LAB_1E1D		; [BACKSPACE] cursor
	JP	LAB_1D8E		; get D from buffer1 @ x,y
					; get E from buffer2 @ x,y (also mask ??)

; [TAB]

LAB_1D0C
	LD	A,(LAB_FBF5)	; get x position

; the next bit would be better as ...

;	ADD	#08h			; add TAB size
;	AND	#F8h			; truncate extra bits

LAB_1D0F
	INC	A			; +1
	LD	B,A			; copy it
	AND	#07h			; mask low 3 bits
	LD	A,B			; get x position back
	JR	NZ,LAB_1D0F		; loop if not TAB stop

	DEC	A			; correct from (1-8) to (0-7)
	LD	(LAB_FBF5),A	; save x position
	LD	A,B			; get x position back
	CP	#14h			; compare with end of line
	JP	M,LAB_1D23		; jump if not at end

	CALL	LAB_1DB3		; else cursor right
LAB_1D23
	CALL	LAB_1F82		; set LCD cursor address
	JP	LAB_1D8E		; get D from buffer1 @ x,y
					; get E from buffer2 @ x,y (also mask ??)
; was [ESC] H
; home cursor

LAB_1D29
	CALL	LAB_1E64		; home cursor
	JR	LAB_1D8E		; get D from buffer1 @ x,y
					; get E from buffer2 @ x,y (also mask ??)
; was [ESC] K
; clear display & home cursor

LAB_1D2E
	CALL	LAB_1FF4		; clear display & home cursor
	JR	LAB_1D8E		; get D from buffer1 @ x,y
					; get E from buffer2 @ x,y (also mask ??)

; was [ESC] U

LAB_1D33
	LD	A,(LAB_FBFA)	;1D33:	3AFAFB
	PUSH	AF		;1D36:	F5
	LD	A,D		;1D37:	7A
	LD	(LAB_FBFA),A	;1D38:	32FAFB
	LD	A,E		;1D3B:	7B
	CALL	LAB_1F79		; byte out to LCD
	POP	AF		;1D3F:	F1
	LD	(LAB_FBFA),A	;1D40:	32FAFB
	JR	LAB_1D8E		; get D from buffer1 @ x,y
					; get E from buffer2 @ x,y (also mask ??)

; was [ESC] +
; call double decrement LCD contrast

LAB_1D45
	CALL	LAB_1D4A		; double decrement LCD contrast
	JR	LAB_1D8E		; get D from buffer1 @ x,y
					; get E from buffer2 @ x,y (also mask ??)

; double decrement LCD contrast

LAB_1D4A
	LD	A,(LAB_FC05)	; get LCD contrast byte
	OR	A			; set the flags
	JR	Z,LAB_1D54		; jump if reached min

	DEC	A			; decrement LCD contrast byte
	JR	Z,LAB_1D54		; jump if reached min

	DEC	A			; decrement LCD contrast byte
LAB_1D54
	LD	(LAB_FC05),A	; save LCD contrast byte
	CALL	LAB_1FD4		; LCD contrast byte out to port (Port_46)
	RET				;

; was [ESC] -
; call double increment LCD contrast

LAB_1D5B
	CALL	LAB_1D60		; double increment LCD contrast
	JR	LAB_1D8E		; get D from buffer1 @ x,y
					; get E from buffer2 @ x,y (also mask ??)

; double increment LCD contrast

LAB_1D60
	LD	A,(LAB_FC05)	; get LCD contrast byte
	INC	A			; increment LCD contrast byte
	JR	Z,LAB_1D6E		; jump if passed max

	INC	A			; increment LCD contrast byte
	JR	Z,LAB_1D6E		; jump if passed max

	LD	(LAB_FC05),A	; save LCD contrast byte
	JR	LAB_1D73		; out to port & RET
LAB_1D6E
	LD	A,#FFh		; set max (could DEC A here!)
	LD	(LAB_FC05),A	; save LCD contrast byte
LAB_1D73
	CALL	LAB_1FD4		; LCD contrast byte out to port (Port_46)
	RET				;

; was [ESC] S
; toggle cursor mode ??

LAB_1D77
	LD	A,(LAB_FBDC)	; get cursor blink flag
	OR	A			; set the flags
	JR	NZ,LAB_1D82		; jump if off ??

	CALL	LAB_1EA8		; set cursor off & blink ??
	JR	LAB_1D8E		; get D from buffer1 @ x,y
					; get E from buffer2 @ x,y (also mask ??)

LAB_1D82
	CALL	LAB_1E9F		; set cursor on & no blink ??
	JR	LAB_1D8E		; get D from buffer1 @ x,y
					; get E from buffer2 @ x,y (also mask ??)

; [BELL]

LAB_1D87
	LD	A,#05h		; (does nothing, A is loaded in 1st routine!)
	CALL	LAB_3562		; do (LAB_FBC8) tone for (LAB_FBC7)*6 ticks
	JR	LAB_1D8E		; (don`t need this. we`re allready there!)

; get D from buffer1 @ x,y, get E from buffer2 @ x,y (also mask ??)

LAB_1D8E
	LD	A,(LAB_FBF4)	; get y position
	LD	C,A			; copy it
	LD	B,#00h		; clear high byte
	LD	HL,LAB_2014		; point to line start table
	ADD	HL,BC			; add y position
	LD	A,(LAB_FBF5)	; get x position
	ADD	A,(HL)		; add line start
	LD	C,A			; copy result
	LD	B,#00h		; clear high byte
	LD	HL,LAB_FC06		; point to display buffer1
	ADD	HL,BC			; add cursor position
	LD	D,(HL)		; get byte
	LD	HL,LAB_FCA6		; point to display buffer2
	ADD	HL,BC			; add cursor position
	LD	E,(HL)		; get byte
	LD	A,(LAB_FC04)	;1DA9:	3A04FC
	AND	#06h			; mask 0000 0xx0
	LD	(LAB_FC04),A	;1DAE:	3204FC
	XOR	A			; clear A
	RET				;

; cursor right

LAB_1DB3
	LD	HL,LAB_FBF5		; point to x position
	INC	(HL)			; +1
	LD	A,(HL)		; get x position
	CP	#14h			; wrapped round?
	JP	M,LAB_1DCB		; jump if not (JP M,LAB_1F82 is better !)

	LD	(HL),#00h		; else zero x position
	LD	HL,LAB_FBF4		; point to y position
	INC	(HL)			; +1
	LD	A,(HL)		; get y position
	CP	#08h			; wrapped round?
	JP	M,LAB_1DCB		; jump if not (JP M,LAB_1F82 is better !)

	LD	(HL),#00h		; else zero y position
LAB_1DCB
	CALL	LAB_1F82		; set LCD cursor address
	RET				;

; put byte(s) into display?? buffers

LAB_1DCF
	LD	A,(LAB_FC03)	; get ##
	OR	A			; set the flags
	RET	NZ			; exit if off ??

	LD	A,(LAB_FBF4)	; get y position
	LD	B,A			; copy it
	OR	A			; set the flags
	LD	A,(LAB_FBF5)	; get x position
	JR	Z,LAB_1DE2		; jump if y??=0
LAB_1DDE
	ADD	A,#14h		; add 14h (20d) for each line ??
	DJNZ	LAB_1DDE		; loop until all done
LAB_1DE2
	LD	B,A			; copy offset from display?? start
	LD	HL,LAB_FC06		; get buffer1 start
	LD	E,A			; copy offset from display?? start
	LD	D,#00h		; clear high byte
	ADD	HL,DE			; add to start
	LD	A,(LAB_FBF8)	; get byte from char?? buffer
	LD	(HL),A		; save to display?? buffer
	LD	HL,LAB_FCA6		; get buffer2 start
	LD	E,B			; copy offset from display?? start
	LD	D,#00h		; clear high byte
	ADD	HL,DE			; add to start
	LD	A,(LAB_FBFA)	; get byte from char?? buffer
	LD	(HL),A		; save to display buffer
	RET				;

; if B>C returns A=C else returns A=B-1

LAB_1DFA
	LD	A,C			; copy C
	CP	B			; compare with B
	RET	C			; return if B>C

	LD	A,B			; else copy B
	SUB	#01h			; -1 (why not DEC A !)
	RET				;

; move cursor left

LAB_1E01
	LD	A,(LAB_FBF5)	; get x position
	DEC	A			; left one
	CP	#FFh			; wrapped round?
	JR	NZ,LAB_1E0B		; jump if not
	LD	A,#13h		; else set row=13h (20d column display)
LAB_1E0B
	LD	(LAB_FBF5),A	; save new column #
	RET				;

; move cursor up

LAB_1E0F
	LD	A,(LAB_FBF4)	; get y position
	DEC	A			; up one
	CP	#FFh			; wrapped round?
	JR	NZ,LAB_1E19		; jump if not
	LD	A,#07h		; else set line=7 (8 line display)
LAB_1E19
	LD	(LAB_FBF4),A	; save new line #
	RET				;

; [BACKSPACE] cursor

LAB_1E1D
	CALL	LAB_1E01		; move cursor left
	CALL	Z,LAB_1E0F		; if wrapped round then move cursor up 
	CALL	LAB_1F82		; set LCD cursor address
	RET				;

; restore LDC display from buffer

LAB_1E27
	LD	A,#01h		;1E27:	3E01
	LD	(LAB_FC03),A	;1E29:	3203FC
	CALL	LAB_1E64		; home cursor
	LD	B,#A0h		; A0h (160d) bytes to copy
	LD	HL,LAB_FC06		; buffer address??
	LD	DE,00A0h	;1E34:	11A000
LAB_1E37
	PUSH	DE		; save
	PUSH	HL			; save buffer pointer
	PUSH	BC			; save count
	LD	A,(HL)		; get byte from buffer
	CALL	LAB_1F79		; byte out to LCD
	CALL	LAB_1DB3		; cursor right
	POP	BC			; retsore count
	POP	HL			; restore buffer pointer
	POP	DE		; restore
	INC	HL			; increment buffer pointer
	DJNZ	LAB_1E37		; loop until all done

	LD	HL,LAB_FBFB		; set source pointer to display attributes buffer area
	LD	DE,LAB_FBF3		; set dest pointer to display attributes area
	LD	BC,0008h		; 08h bytes to copy
	LDIR				; copy block
	XOR	A			; clear A
	LD	(LAB_FC03),A	; clear escape mode flag ??
	LD	(LAB_FC04),A	;1E56:	3204FC
	LD	A,(LAB_FBF9)	; get cursor mode??
	CALL	LAB_1FB6		; set cursor mode (blink/on)
	CALL	LAB_1F82		; set LCD cursor address
	RET				;

LAB_1E63
	RET				;

; home cursor

LAB_1E64
	XOR	A			; clear A
	LD	(LAB_FBF5),A	; clear x (column) position
	LD	(LAB_FBF4),A	; clear y (row) position
	CALL	LAB_1F82		; set LCD cursor address
	RET				;

; set cursor on

LAB_1E6F
	LD	A,(LAB_FBF9)	; get cursor mode
	OR	#02h			; set cursor on
	LD	(LAB_FBF9),A	; save cursor mode
	BIT	0,A			; is cursor blink on?
	RET	Z			; return if not
	CALL	LAB_1FB6		; else set cursor mode
	CALL	LAB_1E93	;1E7D:	CD931E
	RET				;

; set cursor off

LAB_1E81
	LD	A,(LAB_FBF9)	; get cursor mode
	AND	#FDh			; clear cursor on
	LD	(LAB_FBF9),A	; save cursor mode
	BIT	0,A			; is cursor blink on?
	RET	Z			; return if not
	CALL	LAB_1FB6		; else set cursor mode
	CALL	LAB_1E93	;1E8F:	CD931E
	RET				;

LAB_1E93
	LD	A,(LAB_FC03)	;1E93:	3A03FC
	OR	A		;1E96:	B7
	RET	NZ		;1E97:	C0
	LD	A,(LAB_FBF9)	; get cursor mode??
	LD	(LAB_FC01),A	;1E9B:	3201FC
	RET				;

; set cursor on & no blink ??

LAB_1E9F
	CALL	LAB_1E6F		; set cursor on
	LD	A,#00h		; clear A
	LD	(LAB_FBDC),A	; clear cursor blink flag
	RET				;

; set cursor off & blink ??

LAB_1EA8
	CALL	LAB_1E81		; set cursor off
	LD	A,#01h		; set bit
	LD	(LAB_FBDC),A	; set cursor blink flag
	RET				;

; clear LCD display

LAB_1EB1
	CALL	LAB_1EDD		; LCD home cursor
	LD	D,#A0h		; 160 chrs to do
	LD	A,#20h		; set A to ' '
LAB_1EB8
	CALL	LAB_1F79		; byte out to LCD
	DEC	D			; decrement count
	JR	NZ,LAB_1EB8		; loop if not all done
	CALL	LAB_1EDD		; LCD home cursor
	RET				;

; home cursor & set read mode

LAB_1EC2
	CALL	LAB_1EDD		; LCD home cursor
	LD	A,#0Dh		; LCD read display data
	OUT	(LCD_C),A		; out to LCD command port
	RET				;

; byte out to LCD (preserves BC)

LAB_1ECA
	PUSH	BC			; save BC
	CALL	LAB_1F79		; byte out to LCD
	POP	BC			; restore BC
	RET				;

LAB_1ED0
	LD	A,#0Dh		; [CR]
	OUT	(LCD_D),A		; out to LCD data port
	LD	A,#01h		;1ED4:	3E01
	CALL	LAB_35CE		; delay of A*????
	IN	A,(Port_33)		;1ED9:	DB33
	RET				;

LAB_1EDC
	RET				;

; LCD home cursor

LAB_1EDD
	LD	A,#0Ah		; LCD Cursor low byte
	LD	B,#00h		; zero it
	CALL	LAB_1F6D		; set LCD mode A and out data B
	LD	A,#0Bh		; LCD cursor high byte
	LD	B,#00h		; zero it
	CALL	LAB_1F6D		; set LCD mode A and out data B
	RET				;

; initialise display buffers

LAB_1EEC
	LD	A,#08h		; set # of display lines ??
	LD	(LAB_FD46),A	; save # of display lines ??
	LD	A,#A0h		; set display buffer size ??
	LD	(LAB_FD47),A	; save display buffer size ??
	LD	A,#64h		; short delay
	CALL	LAB_35CE		; delay of A*????
	XOR	A			; clear A
	LD	HL,LAB_FBF3		; set pointer to display attributes area
	LD	B,#12h		; 12h (18d) bytes to clear (area & buffer & ?? & ??)
LAB_1F01
	LD	(HL),A		; clear byte
	INC	HL			; point to next
	DJNZ	LAB_1F01		; loop until all cleared

	LD	A,#01h		; cursor on, no blink
	LD	(LAB_FBF9),A	; set cursor mode
	LD	(LAB_FC01),A	;1F0A:	3201FC

	LD	B,#A0h		; A0h (160d) bytes to set
	LD	HL,LAB_FC06		; load pointer
	LD	A,#' '		; byte is ' '
LAB_1F14
	LD	(HL),A		; save byte
	INC	HL			; point to next
	DJNZ	LAB_1F14		; loop until all set

	LD	B,#A0h		; A0h (160d) bytes to set
	LD	HL,LAB_FCA6		; load pointer (HL is allready FCA6h!!)
	XOR	A			; clear A
LAB_1F1E
	LD	(HL),A		; clear byte
	INC	HL			; point to next
	DJNZ	LAB_1F1E		; loop until all cleared

	CALL	LAB_1F33		; initialise LCD display
	CALL	LAB_1FF4		; clear display & home cursor
	LD	A,(LAB_FC05)	; get LCD contrast byte (the next routine does this!)
	CALL	LAB_1FD4		; LCD contrast byte out to port (Port_46)
	CALL	LAB_1E81		; set cursor off
	RET				;

LAB_1F32
	RET				;

; initialise LCD display

LAB_1F33
	LD	A,#00h		; LCD mode control ??
	LD	B,#3Ch		; display on, master, cursor blink, cursor on
	CALL	LAB_1F6D		; set LCD mode A and out data B
	LD	A,#01h		; LCD character pitch ??
	LD	B,#75h		; set 8H x 6H char pitch
	CALL	LAB_1F6D		; set LCD mode A and out data B
	LD	A,#02h		; LCD # of characters
	LD	B,#13h		; set display to 20d chr lines
	CALL	LAB_1F6D		; set LCD mode A and out data B
	LD	A,#03h		; LCD # of time divisions
	LD	B,#3Fh		; enable whole display
	CALL	LAB_1F6D		; set LCD mode A and out data B
	LD	A,#04h		; LCD set cursor position
	LD	B,#07h		; make cursor an underline bar
	CALL	LAB_1F6D		; set LCD mode A and out data B
	LD	A,#08h		; LCD display start low byte
	LD	B,#00h		; set start to 0000h
	CALL	LAB_1F6D		; set LCD mode A and out data B
	LD	A,#09h		; LCD display start high byte
	CALL	LAB_1F6D		; set LCD mode A and out data B
	LD	A,#0Ah		; LCD set cursor low address
	CALL	LAB_1F6D		; set LCD mode A and out data B
	LD	A,#0Bh		; LCD set cursor high address
	CALL	LAB_1F6D		; set LCD mode A and out data B
	RET				;

; set LCD mode A and out data B

LAB_1F6D
	PUSH	HL			; err ??
	POP	HL			; hmmm ??
	OUT	(LCD_C),A		; A out to LCD command port
	LD	DE,0000h		; duh !!?
	LD	C,#LCD_D		; LCD data port
	OUT	(C),B			; B out to LCD data port
	RET				;

; byte out to LCD

LAB_1F79
	LD	C,#LCD_C		; LCD command port 23
	LD	B,#0Ch		; LCD write display data
	OUT	(C),B			; set display write mode
	OUT	(LCD_D),A		; write byte 28
	RET				;

; set LCD cursor address

LAB_1F82
	LD	A,(LAB_FBF4)	; get y position
	LD	C,A			; copy it
	LD	B,#00h		; clear high byte
	LD	HL,LAB_2014		; point to line start table
	ADD	HL,BC			; add y position
	LD	A,(LAB_FBF5)	; get x position
	ADD	A,(HL)		; add line start
	LD	B,A			; save cursor address
	LD	A,#0Ah		; LCD set cursor low address
	OUT	(LCD_C),A		; out to LCD command port
	LD	A,B			; copy low address back
	OUT	(LCD_D),A		; set cursor low address
	LD	A,#0Bh		; LCD set cursor high address
	OUT	(LCD_C),A		; out to LCD command port
	LD	A,#00h		; clear high address
	OUT	(LCD_D),A		; set cursor high address
	LD	A,(LAB_FC03)	;1FA0:	3A03FC
	OR	A			; set the flags
	RET				;

; was [ESC] C
; invert cursor blink

LAB_1FA5
	LD	A,(LAB_FBF9)	; get cursor mode
	XOR	#01h			; invert cursor blink
	LD	(LAB_FBF9),A	; save cursor mode
	LD	(LAB_FC01),A	;1FAD:	3201FC
	CALL	LAB_1FB6		; set cursor mode (blink/on)
	JP	LAB_1D8E		; get D from buffer1 @ x,y
					; get E from buffer2 @ x,y (also mask ??)

; set cursor mode (blink/on)
; control bits are bit0 = blink, bit1 = on/off

LAB_1FB6
	CP	#02h		;1FB6:	FE02
	JR	NZ,LAB_1FBB	;1FB8:	2001
	XOR	A		;1FBA:	AF
LAB_1FBB
	LD	B,A			; copy mode byte
	XOR	A			; clear byte
	SLA	B			; B<<1
	OR	B			; OR with mode byte
	AND	#04h			; mask bit 1 of mode byte
	SLA	B			; B<<1
	SLA	B			; B<<1
	OR	B			; OR with mode byte
	AND	#0Ch			; mask cursor blink & cursor enable bits
	LD	B,A			; copy it
	LD	A,#30h		; display on, display master
	OR	B			; or in cursor bits
	LD	B,A			; copy to mode data
	LD	A,#00h		; LCD mode control
	CALL	LAB_1F6D		; set LCD mode A and out data B
	RET				;

; LCD contrast byte out to port (Port_46)

LAB_1FD4
	LD	A,(LAB_FC05)	; get LCD contrast byte
	LD	C,#Port_46		; set C = LCD contrast port
	OUT	(C),A			; out to port
	RET				;

; was [ESC] V

LAB_1FDC
	JP	LAB_1D8E		; get D from buffer1 @ x,y
					; get E from buffer2 @ x,y (also mask ??)
; was [ESC] W
; was [ESC] I
; just does RET

LAB_1FDF
	RET				;

; was [ESC] (

LAB_1FE0
	JP	LAB_1D8E		; get D from buffer1 @ x,y
					; get E from buffer2 @ x,y (also mask ??)
; was [ESC] )

LAB_1FE3
	JP	LAB_1D8E		; get D from buffer1 @ x,y
					; get E from buffer2 @ x,y (also mask ??)
; was [ESC] R
; set cursor on

LAB_1FE6
	LD	A,(LAB_FBF9)	; get cursor mode
	OR	#01h			; set cursor on
	LD	(LAB_FBF9),A	; save cursor mode
	CALL	LAB_1EA8		; set cursor off & blink
	JP	LAB_1D8E		; get D from buffer1 @ x,y
					; get E from buffer2 @ x,y (also mask ??)

; clear display & home cursor

LAB_1FF4
	CALL	LAB_1E64		; home cursor
	LD	C,#A0h		; A0h (160d) ** to do
LAB_1FF9
	PUSH	BC			; save count
	LD	A,#20h		; character is ' '
	LD	(LAB_FBF8),A	;1FFC:	32F8FB
	CALL	LAB_1F79		; byte out to LCD
	LD	A,(LAB_FC03)	;2002:	3A03FC
	OR	A			; set the flags
	CALL	Z,LAB_1DCF		; put byte(s) into display?? buffers
	CALL	LAB_1DB3		; cursor right
	POP	BC			; restore count
	DEC	C			; decrement count
	JR	NZ,LAB_1FF9		; loop if not all done
	CALL	LAB_1E64		; home cursor
	RET				;

LAB_2014
	DB	00h,14h,28h,3Ch,50h,64h,78h,8Ch	; line start offsets

LAB 201C
	DB	1Bh,0Dh,0Ah,0Ch,01h,06h,07h,09h	; character codes for
	DB	0Bh,08h,7Fh,1Ah,1Ch,1Dh,1Eh,1Fh	; jump table below
	DB	00h,FFh					;

LAB_202E
	DW	LAB_1CA0		; [ESC]
	DW	LAB_1CAF		; [CR]
	DW	LAB_1CB9		; [LF]
	DW	LAB_1CCB		; [CSR_UP]
	DW	LAB_1CE6		; [CSR_LT]
	DW	LAB_1CD4		; [CSR_RT]
	DW	LAB_1D87		; [BELL]
	DW	LAB_1D0C		; [TAB]
	DW	LAB_1CB9		; [LF]
	DW	LAB_1CEF		; [BS]
	DW	LAB_1CF5		; [DEL]
	DW	LAB_1D8E		; get D from buffer1 @ x,y
					; get E from buffer2 @ x,y (also mask ??)
	DW	LAB_1D8E		; get D from buffer1 @ x,y
					; get E from buffer2 @ x,y (also mask ??)
	DW	LAB_1D8E		; get D from buffer1 @ x,y
					; get E from buffer2 @ x,y (also mask ??)
	DW	LAB_1D8E		; get D from buffer1 @ x,y
					; get E from buffer2 @ x,y (also mask ??)
	DW	LAB_1D8E		; get D from buffer1 @ x,y
					; get E from buffer2 @ x,y (also mask ??)
	DW	LAB_1D8E		; get D from buffer1 @ x,y
					; get E from buffer2 @ x,y (also mask ??)

LAB_2050				; character codes for jump table below
	DB	'XYHKCV+-()RSWUIA'
LAB_2060
	DB	'B',FFh

LAB_2062
	DW	LAB_1C5E		; [ESC] "X" set cursor X position
	DW	LAB_1C69		; [ESC] "Y" set cursor Y position
	DW	LAB_1D29		; [ESC] "H" home cursor
	DW	LAB_1D2E		; [ESC] "K" clear display & home cursor
	DW	LAB_1FA5		; [ESC] "C" invert cursor blink
	DW	LAB_1FDC		; [ESC] "V"
	DW	LAB_1D45		; [ESC] "+" call double decrement LCD contrast
	DW	LAB_1D5B		; [ESC] "-" call double increment LCD contrast
	DW	LAB_1FE0		; [ESC] "("
	DW	LAB_1FE3		; [ESC] ")"
	DW	LAB_1FE6		; [ESC] "R" set cursor on
	DW	LAB_1D77		; [ESC] "S" toggle cursor mode ??
	DW	LAB_1FDF		; [ESC] "W" null
	DW	LAB_1D33		; [ESC] "U"
	DW	LAB_1FDF		; [ESC] "I" null
	DW	LAB_1E9F		; [ESC] "A" set cursor on & no blink ??
	DW	LAB_1EA8		; [ESC] "B" set cursor off & blink ??

; clear FD5C-FD83 and set default RTC

LAB_2084
	LD	HL,LAB_FD5C		; point to block
	XOR	A			; clear A
	LD	C,#28h		; 28h (40d) bytes to do
LAB_208A
	LD	(HL),A		; clear byte
	INC	HL			; next byte
	DEC	C			; decrement count
	JR	NZ,LAB_208A		; loop if not all done

; default setup RTC

LAB_208F
	LD	A,#46h		; set PIE, binary data, 24hr mode
	LD	B,#0Bh		; set RTC address 0Bh
	CALL	LAB_22DB		; write A to RTC port (B)
	LD	HL,LAB_20A7		; date/time table for RTC
	CALL	LAB_20AF		; set RTC mode & time/date from +(HL)
	LD	B,#0Ch		; set RTC address 0Ch
	CALL	LAB_22E2		; read A from RTC port (B)
	LD	A,#13h		; default century is 19
	LD	(LAB_FD4A),A	; save century
	RET				;

; default time/date for RTC

LAB_20A7
	DB	13h			; century (19d)
	DB	54h			; year (84d)
	DB	01h			; month (Jan)
	DB	01h			; date (first)
	DB	00h			; hour
	DB	00h			; minutes
	DB	00h			; seconds
	DB	00h			; day (Monday??)

; set RTC mode & time/date from +(HL)

LAB_20AF
	DI				; disable interrupts
	LD	B,#0Bh		; set RTC address 0Bh
	CALL	LAB_22E2		; read A from RTC port (B)
	OR	#80h			; set SET bit
	CALL	LAB_22DB		; write A to RTC port (B)
	LD	A,#7Ah		; set divider mode 7 & 64Hz timebase
	LD	B,#0Ah		; set RTC address 0Ah
	CALL	LAB_22DB		; write A to RTC port (B)
	CALL	LAB_22AB		; set RTC time/date from +(HL)
	LD	A,#2Ah		; set divider mode 2 & 64Hz timebase
	LD	B,#0Ah		; set RTC address 0Ah
	CALL	LAB_22DB		; write A to RTC port (B)
	LD	B,#0Bh		; set RTC address 0Bh
	CALL	LAB_22E2		; read A from RTC port (B)
	AND	#7Fh			; clear SET bit, mask 0xxx xxxx
	CALL	LAB_22DB		; write A to RTC port (B)
	CALL	LAB_F54E		; enable interrupts if interrupts setup ?? flag <> 0
					; (LAB_3A6B)
	RET				;

; set clock for BCD mode, 12hr mode & 64Hz timebase

LAB_20D9
	LD	A,#40h		; set PIE, BCD & 12hr mode
	LD	B,#0Bh		; set RTC address 0Bh
	CALL	LAB_22DB		; write A to RTC port (B)
	LD	A,#26h		; set divider mode 2 & rate mode Ah
	LD	B,#0Ah		; set RTC address 0Ah
	CALL	LAB_22DB		; write A to RTC port (B)
	RET				;

; copy RTC time/date to buffer @ HL

LAB_20E8
	PUSH	HL			; save time/date buffer pointer
	CALL	LAB_20F0		; read RTC time into buffer @ LAB_FD50
	POP	HL			; restore time/date buffer pointer
	JP	LAB_210E		; go copy time/date to (HL)+

; read RTC time into buffer @ LAB_FD50

LAB_20F0
	LD	HL,LAB_FD50		; set pointer
	LD	C,#RTC_D		; don`t know why this is here!
LAB_20F5
	LD	B,#0Ah		; set RTC address 0Ah
	CALL	LAB_22E2		; read A from RTC port (B)
	AND	#80h			; test UIP bit
	JR	NZ,LAB_20F5		; loop until RTC update complete

	XOR	A			; clear RTC address
	DI				; disable interrupts
LAB_2100
	LD	C,#RTC_D		; set RTC_D port address
	OUT	(RTC_A),A		; set RTC address
	IN	B,(C)			; get RTC data
	LD	(HL),B		; save at pointer
	INC	HL			; increment pointer
	INC	A			; increment RTC address
	CP	#0Ah			; compare with 0Ah
	JR	NZ,LAB_2100		; loop if not all done
	RET				;

LAB_210E
	CALL	LAB_F54E		; enable interrupts if interrupts setup ?? flag <> 0
					; (LAB_3A6B)
	LD	DE,0007h		; set count
	ADD	HL,DE			; also offset to buffer
	LD	A,(LAB_FD56)	; get day of week (1=sunday)
	LD	(HL),A		; save it
	EX	DE,HL			; count to HL, pointer to DE
	DEC	DE			; decrement pointer (seconds)
	LD	HL,LAB_FD50		; point to RTC buffer
	LD	B,#03h		; 3 bytes to copy
LAB_2120
	LD	A,(HL)		; get byte from RTC buffer
	LD	(DE),A		; copy byte to date/time buffer
	DEC	DE			; decrement date/time buffer pointer
	INC	HL			; increment RTC buffer pointer
	INC	HL			; increment RTC buffer pointer
	DJNZ	LAB_2120		; loop until secs, mins & hours done

	INC	HL			; point to day of month
	CALL	LAB_228C		; copy dd/mm/yy from RTC buffer to date/time buffer
	EX	DE,HL			; swap pointers (HL is time/date buffer pointer)
	LD	A,(LAB_FD4A)	;212C:	3A4AFD
	LD	(HL),A		;212F:	77
	RET				;

; set alarm (HL<>0) or disable alarm (HL=0)

LAB_2131
	LD	B,#0Ah		; set RTC address 0Ah
	CALL	LAB_22E2		; read A from RTC port (A)
	AND	#80h			; mask UIP bit
	JR	NZ,LAB_2131		; loop until update complete

	DI				; disable interrupts
	LD	A,H			; get pointer high byte
	OR	L			; or with low byte
	JP	Z,LAB_217B		; if=0 then disable alarm interrupt & return

	LD	B,#0Bh		; set RTC address 0Bh
	CALL	LAB_22E2		; read A from RTC port (B)
	OR	#80h			; set SET bit
	CALL	LAB_22DB		; write A to RTC port (B)

	INC	HL			; increment pointer
	INC	HL			; increment pointer
	LD	A,(HL)		; get month
	LD	(LAB_FD4C),A	; save month
	INC	HL			; increment pointer
	LD	A,(HL)		; get date
	LD	(LAB_FD4B),A	; save date
	INC	HL			; increment pointer
	LD	D,#03h		; 3 registers to load
	LD	B,#05h		; set RTC address 05h (hours alarm)
LAB_215A
	LD	A,(HL)		; get hours/minutes/seconds
	CALL	LAB_22DB		; write A to RTC port (B)
	INC	HL			; point to next byte
	DEC	B			; point to next alarm register
	DEC	B			; (every other register)
	DEC	D			; decrement count
	JR	NZ,LAB_215A		; loop until alarm bytes all done
	LD	A,#2Ah		; set divide and rate (64Hz timebase)
	LD	B,#0Ah		; set RTC address 0Ah
	CALL	LAB_22DB		; write A to RTC port (A)
	LD	B,#0Bh		; set RTC address 0Bh
	CALL	LAB_22E2		; read A from RTC port (B)
	OR	#20h			; set AIE    mask xx1x xxxx
	AND	#7Fh			; clear SET, mask 0xxx xxxx
	CALL	LAB_22DB		; write A to RTC port (B)
	CALL	LAB_F54E		; enable interrupts if interrupts setup ?? flag <> 0
					; (LAB_3A6B)
	RET				;

; disable alarm interrupt

LAB_217B
	LD	B,#0Bh		; set RTC address 0Bh
	CALL	LAB_22E2		; read A from RTC port (B)
	AND	#DFh			; clear AIE bit
	CALL	LAB_22DB		; write A to RTC port (B)
	CALL	LAB_F54E		; enable interrupts if interrupts setup ?? flag <> 0
					; (LAB_3A6B)
	RET				;

; save DE & HL in RTC interrupt table
; return carry set if not saved

LAB_2189
	PUSH	HL			; save vector
	PUSH	DE			; save count pointer
	EX	DE,HL			; swap vector & count pointer
	CALL	LAB_21BA		; search table for HL (count pointer), clear if found
					; else return carry set
	DI				; disable interrupts
	LD	HL,LAB_FD5C		; point to table
	LD	C,#0Ah		; 0Ah (10d) entries to test
LAB_2195
	LD	A,(HL)		; get low byte
	INC	HL			; point to high byte
	OR	(HL)			; OR with high byte
	JR	Z,LAB_21A3		; jump if null

	DEC	C			; decrement count
	JR	Z,LAB_21AF		; jump if all done

	LD	DE,0003h		; four (3+1) bytes per entry
	ADD	HL,DE			; add offset
	JR	LAB_2195		; loop

					; found null entry so insert new
LAB_21A3
	DEC	HL			; decrement pointer (point to low byte)
	POP	DE			; restore count pointer
	LD	(HL),E		; save count pointer low byte
	INC	HL			; increment pointer
	LD	(HL),D		; save count pointer high byte
	INC	HL			; increment pointer
	POP	DE			; restore vector
	LD	(HL),E		; save vector low byte
	INC	HL			; increment pointer
	LD	(HL),D		; save vector high byte
	JR	LAB_21B6		; enable interrupts & RET

					; no null entry found
LAB_21AF
	POP	DE			; restore count pointer
	POP	HL			; restore vector
	CALL	LAB_F54E		; enable interrupts if interrupts setup ?? flag <> 0
					; (LAB_3A6B)
	SCF				; flag error
	RET				;

					; new value entered
LAB_21B6
	CALL	LAB_F54E		; enable interrupts if interrupts setup ?? flag <> 0
					; (LAB_3A6B)
	RET				;

; search table for HL (count pointer), clear if found else return carry set

LAB_21BA
	DI				; disable interrupts
	EX	DE,HL			; swap count pointer & vector (back)
	LD	IX,LAB_FD5C		; set pointer to table
	LD	C,#00h		; clear loop count
LAB_21C2
	LD	L,(IX+#00h)		; get low byte
	LD	H,(IX+#01h)		; get high byte
	XOR	A			; clear A (& flags)
	SBC	HL,DE			; compare loaded with vector
	JR	Z,LAB_21DD		; jump if =

	INC	IX			; point to next entry
	INC	IX			; ..
	INC	IX			; ..
	INC	IX			; ..
	INC	C			; increment loop count
	LD	A,C			; copy it
	CP	#0Ah			; compare with 0Ah (10d, max entries)
	JR	Z,LAB_21E7		; exit if all done

	JR	LAB_21C2		; else loop

LAB_21DD
	LD	(IX+#00h),A		; clear entry low
	LD	(IX+#01h),A		; clear entry high
	CALL	LAB_F54E		; enable interrupts if interrupts setup ?? flag <> 0
					; (LAB_3A6B)
	RET				;

LAB_21E7
	CALL	LAB_F54E		; enable interrupts if interrupts setup ?? flag <> 0
					; (LAB_3A6B)
	SCF				; set not found
	RET				;

; set restart count (time in HL)

LAB_21EC
	EX	DE,HL			; time into DE
	LD	HL,LAB_FD4D		; point to count word
	LD	(HL),E		; save count low byte
	INC	HL			; increment pointer
	LD	(HL),D		; save count high word
	LD	DE,LAB_FD4D		; set count pointer
	LD	HL,LAB_0000		; set (null) vector
	CALL	LAB_2189		; save DE & HL in RTC interrupt table
					; return carry set if not saved
	RET	C			; return if error

LAB_21FD
	HALT				; go to sleep

					; will restart here
	LD	HL,(LAB_FD4D)	; point to count
	LD	A,H			; set the flags
	OR	L			;
	RET	Z			; return if = 0000h
	JR	LAB_21FD		; go back to sleep

; check RTC interrupt flags

LAB_2206
	LD	B,#0Ch		; set RTC address 0Ch
	CALL	LAB_22E2		; read A from RTC port (B)
	LD	D,A			; copy result (interrupt flags)
	LD	B,#0Bh		; set RTC address 0Bh
	CALL	LAB_22E2		; read A from RTC port (B)
	OR	#80h			; set bit
	AND	D			; masks non enabled interrupts
	LD	(LAB_FD4F),A	; save result
	AND	#80h			; was there an RTC interrupt
	JR	NZ,LAB_221C		; jump if so (RET Z would be better!)
	RET				;

LAB_221C
	LD	A,(LAB_FD4F)	; get flag result back
	AND	#40h			; was there a timebase interrupt
	CALL	NZ,LAB_224C		; if so go do timebase routine
	LD	A,(LAB_FD4F)	; get flag result back
	AND	#20h			; was it an alarm interrupt
	CALL	NZ,LAB_222E		; if so go do alarm routine
	JR	LAB_2206		; go again to ensure no outstanding interrupts

; RTC alarm interrupt service routine

LAB_222E
	CALL	LAB_223B		; returns Z=1 if LAB_FD4B/C = date/month
	RET	NZ			; exit if not correct date

	LD	A,(LAB_FBC9)	; else get interrupt flag byte
	OR	#02h			; set RTC alarm flag, set xxxx xx1x
	LD	(LAB_FBC9),A	; save interrupt flag byte
	RET				;

; returns Z=1 if LAB_FD4B/C = date/month

LAB_223B
	CALL	LAB_20F0		; read RTC time into buffer @ FD50h
	LD	HL,LAB_FD57		; point to date
	LD	A,(LAB_FD4B)	; get saved date
	CP	(HL)			; compare with date
	RET	NZ			; exit if not equal
	INC	HL			; point to month
	LD	A,(LAB_FD4C)	; get saved month
	CP	(HL)			; compare with month
	RET				;

; RTC timebase interrupt service routine

LAB_224C
	LD	HL,LAB_FD5C		; point to table
	XOR	A			; clear A
LAB_2250
	LD	(LAB_FD5B),A	; clear table position
	LD	E,(HL)		; get first word low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get first word high byte
	LD	A,D			; copy high byte
	OR	E			; OR with low byte
	JR	Z,LAB_2268		; jump if no pointer

					; pointer is any non zero word, so service it
	EX	DE,HL			; swap count pointer to HL
	LD	C,(HL)		; get count low byte
	INC	HL			; increment pointer
	LD	B,(HL)		; get count high byte
	DEC	BC			; -1
	LD	(HL),B		; save count high byte back
	DEC	HL			; decrement pointer
	LD	(HL),C		; save count low byte back
	LD	A,C			; copy low byte
	OR	B			; OR with high byte
	EX	DE,HL			; swap table pointer back to HL
	CALL	Z,LAB_2275		; jump if count = 0000h

LAB_2268
	LD	DE,0003h		; offset to next word pair
	ADD	HL,DE			; add to table pointer
	LD	A,(LAB_FD5B)	; get table position
	INC	A			; increment it
	CP	#0Ah			; compare with 10d
	JR	NZ,LAB_2250		; loop until all done

	RET				;

; count reached zero ..

LAB_2275
	DEC	HL			; point to count pointer low byte
	LD	(HL),#00h		; clear it
	INC	HL			; point to count pointer high byte
	LD	(HL),#00h		; clear it
	INC	HL			; point to vector
	LD	E,(HL)		; get vector low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get vector high byte
	LD	A,E			; copy vector low byte
	OR	D			; OR with vector high byte
	JR	Z,LAB_2289		; jump if null

	LD	HL,LAB_2289		; else save return adddress
	PUSH	HL			; push on stack
	EX	DE,HL			; swap vector to HL
	JP	(HL)			; go do it

LAB_2289
	POP	HL		;2289:	E1
	RET				;

LAB_228B
	RET				;

; copy date, month & year from RTC buffer to date/time buffer

LAB_228C
	LD	B,#03h		; 3 bytes to copy
LAB_228E
	LD	A,(HL)		; get byte
	LD	(DE),A		; save byte
	INC	HL			; increment RTC buffer pointer
	DEC	DE			; decrement date/time buffer pointer
	DJNZ	LAB_228E		; loop if date, month & year not all done
	RET				;

; disable periodic interrupt (timebase) (RTC)

LAB_2295
	LD	B,#0Bh		; set RTC address 0Bh
	CALL	LAB_22E2		; read A from RTC port (B)
	AND	#BFh			; mask PIE bit ( could RES A,7!)
	JR	LAB_22A5		; go write it

; enable periodic interrupt (timebase) (RTC)

LAB_229E
	LD	B,#0Bh		; set RTC address 0Bh
	CALL	LAB_22E2		; read A from RTC port (B)
	OR	#40h			; set PIE bit (could SET A,7!)
LAB_22A5
	LD	B,#0Bh		; set RTC address 0Bh
	CALL	LAB_22DB		; write A to RTC port (B)
	RET				;

; set RTC time/date from +(HL)

LAB_22AB
	INC	HL			; increment pointer
	LD	A,(HL)		; get year
	LD	B,#09h		; set RTC address 09h (year)
	CALL	LAB_22DB		; write A to RTC port (B)
	INC	HL			; increment pointer
	LD	A,(HL)		; get month
	DEC	B			; set RTC address 08h (month)
	CALL	LAB_22DB		; write A to RTC port (B)
	INC	HL			; increment pointer
	LD	A,(HL)		; get date
	DEC	B			; set RTC address 07h (date)
	CALL	LAB_22DB		; write A to RTC port (B)
	INC	HL			; increment pointer
	LD	A,(HL)		; get hours
	LD	B,#04h		; set RTC address 04h (hours)
	CALL	LAB_22DB		; write A to RTC port (B)
	INC	HL			; increment pointer
	LD	A,(HL)		; get minutes
	LD	B,#02h		; set RTC address 02h (minutes)
	CALL	LAB_22DB		; write A to RTC port (B)
	INC	HL			; increment pointer
	LD	A,(HL)		; get seconds
	LD	B,#00h		; set RTC address 00h (seconds)
	CALL	LAB_22DB		; write A to RTC port (B)
	INC	HL			; increment pointer
	LD	A,(HL)		; get day
	LD	B,#06h		; set RTC address 06h (day)
	CALL	LAB_22DB		; write A to RTC port (B)
	RET				;

; write A to RTC port (B)

LAB_22DB
	LD	C,#RTC_A		; set RTC address port
	OUT	(C),B			; set RTC address
	OUT	(RTC_D),A		; A out to RTC
	RET				;

; read A from RTC port (B)

LAB_22E2
	LD	C,#RTC_A		; set RTC address port
	OUT	(C),B			; set RTC address
	IN	A,(RTC_D)		; A in from RTC
	RET				;

; enable all IRQs & setup interrupt table

LAB_22E9
	LD	A,#1Fh		; set IRQ hardware mask ??
LAB_22EB
	DI				; disable interrupts
	IM	1			; set mode 1
	CPL				; complement A (1=enable)
	LD	(LAB_F784),A	; set Port_04 (interrupt mask) buffer
	OUT	(Port_04),A		; out to Port_04
	LD	A,#01h		; set value
	LD	(LAB_FFA8),A	; save interrupts setup ?? flag
	LD	HL,LAB_2352		; source address
	LD	DE,LAB_FD84		; destiantion address
	LD	BC,0013h		; 0013h (19d) bytes to copy
	LDIR				; copy block
	EI				; enable interrupts
	RET				;

; enable RTC IRQ & setup interrupt table

LAB_2306
	LD	A,#02h		; set RTC IRQ hardware unmask
	JR	LAB_22EB		; IRQ hardware unmask & copy what interrupt table ??

; main IRQ service routine

LAB_230A
	IN	A,(05h)		; get interrupt flag byte
	LD	(LAB_F785),A	; save interrupt flag byte
	CPL				; complement it
	AND	#08h			; check main battery status, mask 0000 x000
	JR	NZ,LAB_231B		; jump if main battery interrupt

	XOR	A			; clear A
	LD	(LAB_FDA2),A	; clear main battery terminal count flag
	LD	(LAB_FDA3),A	; clear main battery fail flag/count
LAB_231B
	LD	A,(LAB_F785)	; get interrupt flag byte copy
	LD	B,A			; copy it
	LD	A,(LAB_F784)	; get interrupt enable ?? buffer
	OR	B			; OR with interrupt flags (0=interrupt=not masked)
	CPL				; invert bit sense (1=unmasked interrupt)
	LD	B,A			; copy result
	LD	DE,LAB_FD84		; point to copied what interrupt table
LAB_2328
	LD	A,(DE)		; get byte from table
	CP	#80h			; compare with 80h (end marker)
	JP	Z,LAB_2338		; exit if end (RET Z would be better!)

	AND	B			; AND with interrupt result byte (interrupt AND mask)
	CALL	NZ,LAB_2339		; go execute routine if matching bit found
	INC	DE			; three bytes per entry
	INC	DE			;
	INC	DE			;
	JP	LAB_2328		; go do next

LAB_2338
	RET				; (not needed if JP Z to here is changed!)

; found matching bit

LAB_2339
	PUSH	BC			; save BC
	PUSH	DE			; save pointer
	INC	DE			; increment pointer
	EX	DE,HL			; copy to HL
	LD	E,(HL)		; do LD DE,(HL)
	INC	HL			; (load vector)
	LD	D,(HL)		; ...
	LD	HL,LAB_2346		; set return address
	PUSH	HL			; push return address
	EX	DE,HL			; get vector back
	JP	(HL)			; CALL (HL)

; routine will return here

LAB_2346
	POP	DE			; restore pointer
	POP	BC			; restore BC
	RET				;

; set 20h interrupt & save HL as interrupt vector

LAB_2349
	LD	A,#20h		; set interrupt type byte byte
	LD	(LAB_FD93),A	; save byte
	LD	(LAB_FD94),HL	; save interrupt table vector
	RET				;

; what interrupt table, copied to LAB_FD84

LAB_2352
	DB	01
	DW	LAB_18F0		; scan keyboard matrix ??
	DB	02
	DW	LAB_2206		; check RTC interrupt flags
	DB	04
	DW	LAB_31B6		; IR port interrupt routine ??
	DB	08
	DW	LAB_2365		; main battery warning ??
	DB	10
	DW	LAB_2365		; backup battery warning ??
	DB	00
	DW	LAB_0000		; this never happens !
	DB	80			; end marker

LAB_2365
	LD	A,(LAB_F785)	; get interrupt flag byte copy
	CPL				; invert it
	LD	(LAB_FDA1),A	; save warnings flags
	CALL	LAB_241B		; check battery warning flags ??
	LD	HL,0003h		; set count
	LD	(LAB_FDA6),HL	; save count
	LD	HL,LAB_2387		; set vector
	LD	DE,LAB_FDA6		; set count pointer
	CALL	LAB_2189		; save DE & HL in RTC interrupt table
					; return carry set if not saved
	LD	A,(LAB_FC04)	;237E:	3A04FC
	OR	#02h			; set xxx xx1x
	LD	(LAB_FC04),A	;2383:	3204FC
	RET				;

; RTC timebase vector

LAB_2387
	LD	A,(LAB_F785)	; get interrupt flag byte copy
	CPL				; complement it
	LD	(LAB_FDA1),A	; save warnings flags
	AND	#18h			; mask battery errors
	JP	NZ,LAB_23A7		; jump if errors (use JR??)

	LD	A,(LAB_FC04)	;2393:	3A04FC
	AND	#05h			; mask 0000 0x0x
	LD	(LAB_FC04),A	;2398:	3204FC
	LD	A,(LAB_F784)	; get Port_04 buffer
	AND	#E7h			; enable battery interrupts, mask xxx0 0xxx
	LD	(LAB_F784),A	; save Port_04 buffer
	OUT	(Port_04),A		; out to Port_04
	JR	LAB_23F9		; jumps to a RET (could just RET here!)

; display battery warnings

LAB_23A7
	LD	HL,LAB_24BB		; points to 1Bh,'H',1Bh,'KWARNING:'0Dh
	CALL	LAB_240C		; display message until 00h
	LD	A,(LAB_FDA1)	; get warnings flags
	AND	#08h			; mask main battery bit
	JR	Z,LAB_23BD		; jump if not set

	LD	HL,LAB_24CA		; points to 'MAIN BATTERY LOW'
	CALL	LAB_240C		; display message until 00h
	CALL	LAB_242B	;23BA:	CD2B24
LAB_23BD
	LD	A,(LAB_FDA1)	; get warnings flags
	AND	#10h			; mask backup battery bit
	JR	Z,LAB_23D8		; jump if not set

	LD	A,(LAB_F786)	; get Port_07 buffer
	OR	#02h			; set xxxx xx1x
	LD	(LAB_F786),A	; save Port_07 buffer
	OUT	(Port_07),A		; out to Port_07
	LD	HL,LAB_24DD		; points to 'BACKUP BATTERY LOW'
	CALL	LAB_240C		; display message until 00h
	XOR	A			; clear A
	LD	(LAB_FD9D),A	; clear ?? date
LAB_23D8
	LD	HL,0140h		; set count (5 seconds)
	LD	(LAB_FD99),HL	; save count
	LD	HL,LAB_23FA		; set restore LCD display vector
	LD	DE,LAB_FD99		; set count pointer
	CALL	LAB_2189		; save DE & HL in RTC interrupt table
					; return carry set if not saved
	LD	HL,4B00h		; set count (300 seconds)
	LD	(LAB_FD97),HL	; save count
	LD	HL,LAB_23FE		; set vector
	LD	DE,LAB_FD97		; set count pointer
	CALL	LAB_2189		; save DE & HL in RTC interrupt table
					; return carry set if not saved
	CALL	LAB_3581		; setup chain fo double beep (using RTC)
LAB_23F9
	RET				;

; restore LCD display vector (5 second count)

LAB_23FA
	CALL	LAB_1E27		; restore LDC display from buffer
	RET				;

; compare date/month vector (300 second count)

LAB_23FE
	LD	A,(LAB_F784)	; get Port_04 buffer
	AND	#E7h			; mask xxx0 0xxx
	LD	(LAB_F784),A	; save Port_04 buffer
	OUT	(Port_04),A		; out to Port_04
	CALL	LAB_2468		; compare clock date/month with stored date/month ??
	RET				;

; display message until 00h

LAB_240C
	LD	A,(HL)		; get byte from message
	CP	#00h			; is it last byte
	JR	Z,LAB_241A		; if so exit (could RET Z here!)
	PUSH	HL			; save pointer
	CALL	LAB_1BC4		; display chr
	POP	HL			; restore pointer
	INC	HL			; increment pointer
	JP	LAB_240C		; loop
LAB_241A
	RET				;

; check battery warning flags ??

LAB_241B
	LD	A,(LAB_FDA1)	; get warnings flags
	AND	#18h			; mask battery errors
	LD	B,A			; copy result
	LD	A,(LAB_F784)	; get Port_04 buffer
	OR	B			; disable battery interrupts
	LD	(LAB_F784),A	; save Port_04 buffer
	OUT	(Port_04),A		; out to Port_04
	RET				;

; setup main battery fail warnings

LAB_242B
	LD	A,(LAB_FDA3)	; get main battery fail flag/count
	OR	A			; set the flags
	RET	NZ			; return if allready set

	LD	A,#12h		; set main battery fail flag/count
	LD	(LAB_FDA3),A	; save main battery fail flag/count
LAB_2435
	LD	HL,6400h		; set count (400 seconds)
	LD	(LAB_FDA4),HL	; save count
	LD	HL,LAB_2445		; set vector
	LD	DE,LAB_FDA4		; set count pointer
	CALL	LAB_2189		; save DE & HL in RTC interrupt table
					; return carry set if not saved
	RET				;

; main battery fail vector (400 second count)

LAB_2445
	LD	A,(LAB_F785)	; get interrupt flag byte copy
	CPL				; invert it
	AND	#08h			; check main battery, mask 0000 x000
	JR	Z,LAB_2463		; jump if not main battery

					; was main battery
	LD	A,(LAB_FDA3)	; get main battery fail flag/count
	DEC	A			; decrement it
	JR	Z,LAB_245A		; go set terminal count if = 0

	LD	(LAB_FDA3),A	; save main battery fail flag/count
	CALL	LAB_2435		; setup interrupt again
	RET				;

; set main battery fail flag/count terminal count

LAB_245A
	LD	A,#FFh		; set value
	LD	(LAB_FDA2),A	; set main battery terminal count flag
	LD	(LAB_FDA3),A	; set main battery fail flag/count
	RET				;

LAB_2463
	XOR	A			; clear A
	LD	(LAB_FDA3),A	; clear main battery fail flag/count
	RET				;

; compare clock date/month with stored date/month

LAB_2468
	LD	C,#RTC_D		; point to RTC data port
	LD	A,#07h		; RTC address 07h (date)
	OUT	(RTC_A),A		; set RTC address
	IN	A,(C)			; get date
	LD	(LAB_FD9B),A	; save date
	LD	A,#08h		; RTC address 08h (month)
	OUT	(RTC_A),A		; set RTC address
	IN	A,(C)			; get month
	LD	(LAB_FD9C),A	; save month
	LD	HL,(LAB_FD9B)	; get date/month
	LD	DE,(LAB_FD9D)	; get ?? date/month
	XOR	A			; clear A (and flags)
	SBC	HL,DE			; compare RTC date/month with ?? date/month

; (if I do a RET	Z here it saves the next two lines!)

	JR	NZ,LAB_2489		; if not the same then jump

	RET				; else return

					; insert 60 second count into timer
LAB_2489
	LD	HL,0F00h		; set count (60 seconds)
	LD	(LAB_FD9F),HL	; save count
	LD	DE,LAB_FD9F		; set count pointer
	LD	HL,LAB_24B0		; set vector
	CALL	LAB_2189		; save DE & HL in RTC interrupt table
					; return carry set if not saved
	RET	C			; exit if not set

	LD	A,(LAB_FD9B)	; get RTC date copy
	LD	(LAB_FD9D),A	; save ?? date
	LD	A,(LAB_FD9C)	; get RTC month copy
	LD	(LAB_FD9E),A	; save ?? month
	LD	A,(LAB_F786)	; get Port_07 buffer
	AND	#FDh			; mask xxxx xx0x
	LD	(LAB_F786),A	; save Port_07 buffer
	OUT	(Port_07),A		; set port 07
	RET				;

; RTC 60 second timebase vector

LAB_24B0
	LD	A,(LAB_F786)	; get port 07 buffer
	OR	#02h			; set xxxx xx1x
	LD	(LAB_F786),A	; save port 07 buffer
	OUT	(Port_07),A		; set port 07
	RET				;

LAB_24BB:
	DB	1Bh,'H',1Bh,'K'
LAB_24BF
	DB	'WARNING:'0Dh,0Ah,00h
LAB_24CA:
	DB	'MAIN BATTERY LOW',0Dh,0Ah,00h
LAB_24DD:
	DB	'BACKUP BATTERY LOW',0Dh,0Ah,00h

; self test routine #1 ?? result in status flags

LAB_24F2
	IN	A,(Port_49)		; read port
	PUSH	AF			; save result

	LD	A,#00h		; clear A (could XOR A here!)
	OUT	(Port_48),A		; out to port
	IN	A,(Port_49)		; read port
	AND	#03h			; mask 0000 00xx
	JR	NZ,LAB_2527		; set error ?? save flag & exit

					; set 00h, read 00h
	LD	A,#01h		; next value (could INC A here!)
	OUT	(Port_48),A		; out to port
	IN	A,(Port_49)		; read port
	AND	#03h			; mask 0000 00xx
	CP	#01h			; compare with expected
	JR	NZ,LAB_2527		; set error ?? save flag & exit

					; set 01h, read 01h
	LD	A,#02h		; next value (could INC A here!)
	OUT	(Port_48),A		; out to port
	IN	A,(Port_49)		; read port
	AND	#03h			; mask 0000 00xx
	CP	#02h			; compare with expected
	JR	NZ,LAB_2527		; set error ?? save flag & exit

					; set 02h, read 02h
	LD	A,#03h		; next value (could INC A here!)
	OUT	(Port_48),A		; out to port
	IN	A,(Port_49)		; read port
	AND	#03h			; mask 0000 00xx
	CP	#03h			; compare with expected
	JR	NZ,LAB_2527		; set error ?? save flag & exit

					; set 03h, read 03h
	LD	A,#00h		; clear flag (could XOR A here!)
	JR	LAB_2529		; save flag & exit

LAB_2527
	LD	A,#FFh		; set error ?? flag
LAB_2529
	LD	(LAB_FDAF),A	; save port 48h/49h status flag
	POP	AF			; get original port setting
	OUT	(Port_48),A		; reset port
	RET				;

; test upper 32k RAM

LAB_2530
	LD	B,#04h		; 4 blocks to do
LAB_2532
	LD	L,B			; copy block count
	LD	DE,0000h		; clear result & test count bytes
	LD	H,#01h		; set this block flag
	EXX				; swap reg pairs
LAB_2539
	LD	HL,8000h		; start address
	LD	DE,2000h		; block size
LAB_253F
	LD	BC,55AAh		; test pattern
	JP	LAB_25C1		; go test RAM

LAB_2545
	LD	A,B			; get high byte of test pattern
	CP	#55h			; is it 55h
	JP	NZ,LAB_25FD		; jump if not (done this bit allready)

	LD	BC,AA55h		; swap pattern bits
	JP	LAB_25C1		; go test RAM again

LAB_2551
	EXX				; swap reg pairs
	LD	A,E			; get test O.K. count
	CP	#04h			; compare with no. of tests
	JR	NZ,LAB_255A		; jump if not all done

	LD	A,D			; get result byte
	OR	H			; or in block flag
	LD	D,A			; save result byte

					; the first four tests set the first four bits of
					; D if they all passed ok.
LAB_255A
	SLA	H			; flag to next bit
	LD	E,#00h		; clear test count
	DEC	B			; decrement blocks to do count
	EXX				; swap reg pairs
	JR	Z,LAB_2568		; jump if we`ve done all the blocks

	LD	DE,2000h		; else reset byte count
	ADD	HL,DE			; add it to the start address (next block)
	JR	LAB_253F		; and go do it all again

					; all the blocks are done
LAB_2568
	EXX				; swap reg pairs
	LD	A,L			; get block count (first go)
	LD	B,L			; set block count (next go)
	EXX				; swap reg pairs
	LD	B,A			; set block count
	LD	HL,8000h		; reset address
	LD	DE,2000h		; reset byte count
	LD	A,#10h		; set test byte
LAB_2575
	LD	(HL),A		; save test byte
	RLCA				; rotate left
	ADD	HL,DE			; next block
	DEC	B			; decrement count
	JR	NZ,LAB_2575		; loop until all blocks done

	LD	HL,8000h		; reset address
	LD	DE,2000h		; reset byte count (it`s not changed!)
	LD	A,#10h		; set test byte
	LD	C,A			; save it
LAB_2584
	CP	(HL)			; compare with memory byte
	JR	NZ,LAB_258B		; jump if error

	EXX				; swap reg pairs
	OR	D			; or with previous results
	LD	D,A			; save it back
	EXX				; swap reg pairs

					; these tests set the second four bits of D if they
					; are passed ok.
LAB_258B
	EXX				; swap reg pairs
	DEC	B			; decrement block count
	EXX				; swap reg pairs
	JR	Z,LAB_2596		; jump if all done

	LD	A,C			; get test byte back
	RLCA				; shift bit
	LD	C,A			; save it back
	ADD	HL,DE			; next block
	JR	LAB_2584		; go do next block

LAB_2596				; all done
	EXX				; swap reg pairs
	LD	A,D			; get test result byte
	LD	(LAB_FEAF),A	; save it
	LD	B,A			; copy it
	RLCA				; <<1
	RLCA				; <<2
	RLCA				; <<3
	RLCA				; <<4
	AND	B			; combine results for block & bank tests
	AND	#0Fh			; clear upper nibble
	LD	B,L			; get block count back
LAB_25A4
	RRCA				; A>>1
	JR	NC,LAB_25B4		; jump if block failed

	DEC	B			; decrement count
	JR	NZ,LAB_25A4		; loop until all done

	LD	A,#00h		; clear A
	LD	(LAB_FDB0),A	; clear upper 32k RAM error byte
	SCF				; set carry
	CCF				; clear carry
	JP	LAB_01BE		; exit

LAB_25B4
	LD	A,D			; get test result byte
	LD	(LAB_FEAF),A	; save it (done this allready!)
	LD	A,#FFh		; set flag
	LD	(LAB_FDB0),A	; set upper 32k RAM error byte
	SCF				; set carry
	JP	LAB_01BE		; exit

					; first fill the block with the test pattern
LAB_25C1
	LD	(HL),C		; save test pattern low byte
	INC	HL			; point to next byte
	DEC	DE			; decrement count
	LD	A,D			; get count high
	OR	E			; OR count low
	JR	Z,LAB_25CF		; exit if done (only for odd # byte count!)
	LD	(HL),B		; save test pattern high byte
	INC	HL			; point to next byte
	DEC	DE			; decrement count
	LD	A,D			; get count high
	OR	E			; OR count low
	JR	NZ,LAB_25C1		; loop if not all done

LAB_25CF
	LD	DE,E000h		; -2000h
	ADD	HL,DE			; makes HL=8000h again
	LD	DE,2000h		; byte count
LAB_25D6
	LD	A,(HL)		; get memory word low byte
	CP	C			; compare with test pattern low byte
	JR	NZ,LAB_25ED		; exit if error
	INC	HL			; point to next byte
	DEC	DE			; decrement count
	LD	A,D			; get count high
	OR	E			; OR count low
	JR	Z,LAB_25EA		; exit if done (only for odd # byte count!)
	LD	A,(HL)		; get memory word high byte
	CP	B			; compare with test pattern high byte
	JR	NZ,LAB_25ED		; exit if error
	INC	HL			; point to next byte
	DEC	DE			; decrement count
	LD	A,D			; get count high
	OR	E			; OR count low
	JR	NZ,LAB_25D6		; loop if not all done

					; there was no error
LAB_25EA
	EXX				; swap reg pairs
	INC	E			; increment E
	EXX				; swap reg pairs
LAB_25ED
	EXX				; swap reg pairs
	LD	A,H			; copy H
	EXX				; swap reg pairs
	LD	DE,2000h		; block size
	LD	HL,8000h		; start address
LAB_25F6
	RRCA				; rotate flag to carry
	JP	C,LAB_2545		; loop if set

	ADD	HL,DE			; next block
	JR	LAB_25F6		; go check block flag again

					; fill block with test pattern
LAB_25FD
	LD	(HL),H		; save test pattern high byte
	INC	HL			; increment pointer
	DEC	DE			; decrement count
	LD	A,D			; get count high byte
	OR	E			; OR count low byte
	JR	Z,LAB_260B		; jump if all done (odd count only!)

	LD	(HL),L		; save test pattern low byte
	INC	HL			; increment pointer
	DEC	DE			; decrement count
	LD	A,D			; get count high byte
	OR	E			; OR count low byte
	JR	NZ,LAB_25FD		; loop if not all done

LAB_260B
	LD	DE,E000h		; -2000h
	ADD	HL,DE			; reset start address
	LD	DE,2000h		; reset count
LAB_2612
	LD	A,(HL)		; get memory high byte
	CP	H			; compare with test pattern high byte
	JR	NZ,LAB_2629		; jump if error

	INC	HL			; increment pointer
	DEC	DE			; decrement count
	LD	A,D			; get count high byte
	OR	E			; OR count low byte
	JR	Z,LAB_2626		; jump if all done (odd count only!)

	LD	A,(HL)		; get memory low byte
	CP	L			; compare with test pattern low byte
	JR	NZ,LAB_2629		; jump if error

	INC	HL			; increment pointer
	DEC	DE			; decrement count
	LD	A,D			; get count high byte
	OR	E			; OR count low byte
	JR	NZ,LAB_2612		; loop if not all done

					; there was no error
LAB_2626
	EXX				; swap reg pairs
	INC	E			; increment E
	EXX				; swap reg pairs
LAB_2629
	EXX				; swap reg pairs
	LD	A,H			; copy H
	EXX				; swap reg pairs
	LD	DE,2000h		; reset byte count
	LD	HL,8000h		; reset start address
LAB_2632
	RRCA				; rotate flag byte
	JR	C,LAB_2638		; jump if bit set

	ADD	HL,DE			; next block
	JR	LAB_2632		; check block flag again

					; complement block
LAB_2638
	LD	A,H			; get test pattern high byte
	CPL				; complement it
	LD	(HL),A		; save test pattern high byte
	INC	HL			; increment pointer
	DEC	DE			; decrement count
	LD	A,D			; get count high byte
	OR	E			; OR count low byte
	JR	Z,LAB_264A		; jump if all done (odd count only!)

	LD	A,L			; get test pattern low byte
	CPL				; complement it
	LD	(HL),A		; save test pattern low byte
	INC	HL			; increment pointer
	DEC	DE			; decrement count
	LD	A,D			; get count high byte
	OR	E			; OR count low byte
	JR	NZ,LAB_2638		; loop if not all done

LAB_264A
	LD	DE,E000h		; -2000h
	ADD	HL,DE			; reset start address
	LD	DE,2000h		; reset count
LAB_2651
	LD	A,(HL)		; get memory high byte
	CPL				; complement it
	CP	H			; compare with test pattern high byte
	JR	NZ,LAB_266A		; jump if error

	INC	HL			; increment pointer
	DEC	DE			; decrement count
	LD	A,D			; get count high byte
	OR	E			; OR count low byte
	JR	Z,LAB_2667		; jump if all done (odd count only!)

	LD	A,(HL)		; get memory low byte
	CPL				; complement it
	CP	L			; compare with test pattern low byte
	JR	NZ,LAB_266A		; jump if error

	INC	HL			; increment pointer
	DEC	DE			; decrement count
	LD	A,D			; get count high byte
	OR	E			; OR count low byte
	JR	NZ,LAB_2651		; loop if not all done

LAB_2667				; there was no error
	EXX				; swap reg pairs
	INC	E			; increment E
	EXX				; swap reg pairs
LAB_266A
	EXX				; swap reg pairs
	LD	A,H			; copy H
	EXX				; swap reg pairs
	LD	DE,2000h		; reset byte count
	LD	HL,8000h		; reset start address
LAB_2673
	RRCA				; rotate flag byte
	JP	C,LAB_2551		; jump if bit set

	ADD	HL,DE			; next block
	JR	LAB_2673		; go check block flag again

LAB_267A
	LD	B,#01h		; page 01
	LD	A,B			; start with page 01
	LD	C,#01h		; and the flag is 00000001
	LD	HL,LAB_FEB0		; RAM test result ??
	LD	(HL),#00h		; says RAM page 01=BAD ??
	EXX				; swap register pairs
	LD	HL,0000h		; start address
	LD	DE,2000h		; block size (D*256)-HL
LAB_268B
	LD	BC,55AAh		; test pattern
	PUSH	AF			; save page
	PUSH	HL			; save start address
	CALL	LAB_F180		; test ram at page A, address HL, length ((D*256)-HL)
					; Z flag set if OK
	JP	NZ,LAB_26B4		; jump if error

	POP	HL			; restore start address
	POP	AF			; restore page
	PUSH	AF			; save page
	PUSH	HL			; save start address
	LD	BC,AA55h		; inverse pattern now
	CALL	LAB_F180		; test ram at page A, address HL, length ((D*256)-HL)
					; Z flag set if OK
	JR	NZ,LAB_26B4		; jump if error

	POP	HL			; restore start address
	POP	AF			; restore page
	PUSH	AF			; save page
	PUSH	HL			; save start address
	CALL	LAB_F1A3		; test ram at page A, address HL, length ((D*256)-HL)
					; Z flag set if OK
	JR	NZ,LAB_26B4		; jump if error

	POP	HL			; restore start address
	POP	AF			; restore page
	CALL	LAB_F1C6		; test ram at page A, address HL, length ((D*256)-HL)
					; Z flag set if OK
	JR	NZ,LAB_26B6		; jump if error
	JR	LAB_26B9		; else jump

; RAM error gets you here (last test goes to LAB_26B6)

LAB_26B4
	POP	HL			; dump start address
	POP	AF			; dump page
LAB_26B6
	EXX				; swap register pairs back
	JR	LAB_46BD		; test failed so skip setting the ok flag for this page

; no RAM error gets you here ...

LAB_26B9
	EXX				; swap register pairs back
	LD	A,(HL)		; get RAM page ok flags back ??
	OR	C			; OR in OK result
	LD	(HL),A		; save it

; eventually, good or bad, we get here

LAB_26BD
	LD	A,C			; save page flag
	RLCA				; shift falg up one (00000010 , 00000100 etc.)
	LD	C,A			; save it back to C
	CP	#10h			; compare with 10h
	JR	NZ,LAB_26D9		; jump if not there yet

	LD	C,#01h		; done last so reset flag bit
	INC	B			; next page
	LD	A,B			; copy it to A
	CP	#41h			; at end yet ??
	JR	Z,LAB_26E3		; jump if so

	INC	HL			; else point to next RAM block ok flag byte
	LD	(HL),#00h		; and clear the flags
	EXX				; swap the register pairs
	LD	HL,0000h		; start address is zero
	LD	DE,2000h		; end address is 2000h
	JP	LAB_268B		; go do next block

LAB_26D9
	LD	A,B			; get page back
	EXX				; swap the register pairs
	LD	HL,2000h		; this time start is 2000h
	ADD	HL,DE			; and end is 4000h
	EX	DE,HL			; get the right word in the right register pair
	JP	LAB_268B		; go do next block

LAB_26E3
	LD	HL,LAB_FEB0		; point to first RAM block OK flag byte
	LD	B,#3Fh		; # flag bytes to test
	LD	E,#00h		;26E8:	1E00
LAB_26EA
	LD	A,#0Fh		; all RAM in page OK byte
	CP	(HL)			; was it ?
	JR	Z,LAB_26FD		; jump if it was

	LD	A,E		;26EF:	7B
	CP	#00h		;26F0:	FE00
	JR	Z,LAB_26F6	;26F2:	2802
	LD	E,#02h		;26F4:	1E02
LAB_26F6
	INC	HL		;26F6:	23
	DJNZ	LAB_26EA	;26F7:	10F1
	LD	A,#00h		;26F9:	3E00
	JR	LAB_270C	;26FB:	180F
LAB_26FD
	LD	A,E		;26FD:	7B
	CP	#00h		;26FE:	FE00
	JR	NZ,LAB_2706	;2700:	2004
	LD	E,#01h		;2702:	1E01
	JR	LAB_26F6	;2704:	18F0
LAB_2706
	CP	#02h		;2706:	FE02
	JR	NZ,LAB_26F6	;2708:	20EC
	LD	A,#FFh		;270A:	3EFF
LAB_270C
	LD	(LAB_FDB1),A	;270C:	32B1FD
	RET				;

; returns HL = E*0020h

LAB_2710
	LD	BC,0020h		; step size
	LD	HL,0000h		; start at 0000h
	LD	A,E			; get count
	CP	#00h			; compare with 00h (could do OR A here!)
	RET	Z			; exit if zero
LAB_271A
	ADD	HL,BC			; add 0020h
	DEC	E			; decrement count
	JR	NZ,LAB_271A		; loop until all done
	RET				;

; test & get RAM configuration

LAB_271F
	CALL	LAB_2740		; page test RAM, setup
	CALL	LAB_275C		; page test RAM, test
	CALL	LAB_2797		; check test results
	LD	A,(LAB_FEAA)	;2728:	3AAAFE
	LD	E,A			; copy to E
	CALL	LAB_2710		; returns HL = E*0020h
	LD	(LAB_FEAD),HL	; save full RAM size (KB)
	LD	A,(LAB_FEA9)	;2732:	3AA9FE
	LD	E,A			; copy to E
	CALL	LAB_2710		; returns HL = E*0020h
	LD	(LAB_FEAB),HL	; set contig RAM size (KB)
	LD	A,(LAB_FDB2)	; get bank select status flags
	RET				;

; page test RAM, setup

LAB_2740
	LD	C,#40h		; start @ page 40h (3Fh after decrement)
	CALL	LAB_2803		; check if page 1, if so exit. else decrement page
					; copy to A and setup B and HL
LAB_2745
	PUSH	AF			; save test byte
	CALL	LAB_F1FB		; save byte A at (HL) on page C
					; (copied routine from LAB_3663) ??
	POP	AF			; restore test byte
	ADD	A,#40h		; next test byte
	SLA	B			; << flag to next bit
	JR	C,LAB_2756		; if not end, go do next page

	LD	DE,2000h		; block size
	ADD	HL,DE			; setup HL for next block
	JR	LAB_2745		; go do next

LAB_2756
	CALL	LAB_2803		; check if page 1, if so exit. else decrement page
					; copy to A and setup B and HL
	RET	Z			; exit if all done
	JR	LAB_2745		; else go do next

; page test RAM, test

LAB_275C
	LD	C,#00h		; sart page 00 (01 after increment)
	LD	DE,LAB_FEB0		; point to first page test result byte
	CALL	LAB_27F7		; check if page 40h, if so exit. else increment page
					; copy to A and setup B and HL
LAB_2764
	PUSH	AF			; save test byte
	PUSH	BC			; save page bit
	LD	B,A			; copy test byte
	CALL	LAB_F1EF		; get byte A from (HL) on page C
	CP	B			; compare with test byte
	JR	NZ,LAB_2780		; jump if there was an error

	CPL				; complement test byte
	LD	B,A			; copy complemented byte
	CALL	LAB_F1FB		; save byte A at (HL) on page C
	CALL	LAB_F1EF		; get byte A from (HL) on page C
	CP	B			; compare with test byte
	JR	NZ,LAB_2780		; jump if there was an error

	POP	BC			; restore page bit
	JR	NZ,LAB_2781		; jump if there was an error (will never jump!)
	LD	A,(DE)		; get page test result byte
	OR	B			; OR in this page good
	LD	(DE),A		; save page test result byte
	JR	LAB_2781		; go do next

LAB_2780
	POP	BC			; restore page bit
LAB_2781
	POP	AF			; restore test byte
	ADD	A,#40h		; next test byte
	SLA	B			; next page bit
	JR	C,LAB_2790		; jump if all done

	PUSH	DE			; save result byte pointer
	LD	DE,2000h		; offset to next block
	ADD	HL,DE			; add to mem pointer
	POP	DE			; restore result byte pointer
	JR	LAB_2764		; go test next block

LAB_2790
	INC	DE			; next page result byte
	CALL	LAB_27F7		; check if page 40h, if so exit. else increment page
					; copy to A and setup B and HL
	RET	Z			; exit if all done
	JR	LAB_2764		; else go do next page

LAB_2797
	LD	C,#40h	;2797:	0E40
	LD	HL,LAB_FEAF		; get upper 32k RAM test result byte pointer
	LD	E,#00h	;279C:	1E00
	LD	D,#00h	;279E:	1600
LAB_27A0
	LD	A,(HL)		; get upper 32k RAM test result byte
	AND	#0Fh			; mask lower nibble
	LD	B,A			; copy it
	LD	A,(HL)		; get upper 32k RAM test result byte
	RLCA				; swap nibbles
	RLCA				;
	RLCA				;
	RLCA				;
	AND	#0Fh			; mask lower nibble
	AND	B			; and with lower nibble copy
	CP	#0Fh			; compare with all ok?
	JR	NZ,LAB_27D2		; jump if error

	LD	A,E		;27B0:	7B
	CP	#01h		;27B1:	FE01
	JR	NZ,LAB_27BB	;27B3:	2006
	LD	A,#40h		;27B5:	3E40
	SUB	C		;27B7:	91
	LD	(LAB_FEA7),A	; save first RAM bank #
LAB_27BB
	INC	E		;27BB:	1C
	LD	A,D		;27BC:	7A
	AND	#80h		;27BD:	E680
	JR	NZ,LAB_27C2	;27BF:	2001
	INC	D		;27C1:	14
LAB_27C2
	INC	HL		;27C2:	23
	DEC	C		;27C3:	0D
	JR	Z,LAB_27C8	;27C4:	2802
	JR	LAB_27A0	;27C6:	18D8
LAB_27C8
	LD	A,D		;27C8:	7A
	AND	#7Fh		;27C9:	E67F
	CP	E		;27CB:	BB
	JR	NZ,LAB_27E7	;27CC:	2019
	LD	A,#00h		;27CE:	3E00
	JR	LAB_27E9		; go save results & exit

; was error in page test results

LAB_27D2
	LD	A,D		;27D2:	7A
	CP	#01h		;27D3:	FE01
	JR	Z,LAB_27C2	;27D5:	28EB

	AND	#80h		;27D7:	E680
	JR	NZ,LAB_27C2	;27D9:	20E7

	LD	A,#40h		;27DB:	3E40
	SUB	C		;27DD:	91
	LD	(LAB_FEA8),A	;27DE:	32A8FE
	LD	A,D		;27E1:	7A
	OR	#80h		;27E2:	F680
	LD	D,A		;27E4:	57
	JR	LAB_27C2	;27E5:	18DB

LAB_27E7
	LD	A,#FFh		;27E7:	3EFF
LAB_27E9
	LD	(LAB_FDB2),A	; save bank select status flags
	LD	A,E		;27EC:	7B
	LD	(LAB_FEAA),A	;27ED:	32AAFE
	LD	A,D		;27F0:	7A
	AND	#7Fh		;27F1:	E67F
	LD	(LAB_FEA9),A	;27F3:	32A9FE
	RET				;

; check if page 40h, if so exit. else increment page, copy to A and setup B and HL

LAB_27F7
	LD	A,#40h		;27F7:	3E40
	CP	C		;27F9:	B9
	RET	Z		;27FA:	C8
	INC	C		;27FB:	0C
	LD	A,C		;27FC:	79
	LD	B,#10h		;27FD:	0610
	LD	HL,0000h	;27FF:	210000
	RET				;

; check if page 1, if so exit. else decrement page, copy to A and setup B and HL

LAB_2803
	LD	A,#01h		;2803:	3E01
	CP	C		;2805:	B9
	RET	Z		;2806:	C8
	DEC	C		;2807:	0D
	LD	A,C		;2808:	79
	LD	B,#10h		;2809:	0610
	LD	HL,0000h	;280B:	210000
	RET				;

; go do ROM checks

LAB_280F
	LD	A,#00h		; page 00h
	CALL	LAB_F206		; do ROM checksum. page # in A
	LD	(LAB_FDB3),A	; save ROM 0 test result
	LD	(LAB_FDAB),DE	; save ROM 0 checksum
	LD	A,#01h		; page 01h
	CALL	LAB_F206		; do ROM checksum. page # in A
	LD	(LAB_FDB4),A	; save ROM 1 test result
	LD	(LAB_FDAD),DE	; save ROM 1 checksum
	RET				;

; test clock

LAB_2828
	LD	DE,LAB_2877		; IRQ vector to LAB_2877
	CALL	LAB_2893		; save JP DE @ IRQ routine address
	LD	HL,0082h		; set test count
	LD	(LAB_FDA8),HL	; save test count
	LD	D,#26h		; not used anywhere ??
	CALL	LAB_20D9		; set clock for BCD mode, 12hr mode & 64Hz timebase
	CALL	LAB_288A		; clear main and RTC interrupt flags
	CALL	LAB_2306		; enable RTC IRQ & setup interrupt table

	LD	BC,0000h		; inner loop delay count
	LD	D,#02h		; outer loop delay count

LAB_2844
	INC	BC			; [6]	increment count
	LD	A,B			; [4]	get high byte
	OR	C			; [4]	or with low byte
	JP	NZ,LAB_2844		; [12]loop until BC=0
					; [7]

	DEC	D			; [4]	decrement loop count
	JP	NZ,LAB_2844		; [12]loop until D=0
					; [7] total of 4194333 cycles

; gets here after loop timeout or (LAB_FDA8) RTC interrupts

LAB_284E
	DI				; interrupts off
	LD	A,#FFh		; set mask byte
	OUT	(Port_04),A		; disable all interrupts
	LD	A,#02h		; compare byte
	CP	D			; compare with outer loop count
	JR	NZ,LAB_286C		; jump if <> 02h (way too slow)

	LD	DE,4502h		; set lower limit
	CALL	LAB_2872		; subtract BC from DE, sets carry flag
	JR	NC,LAB_286C		; failed, clock running too fast

	LD	DE,4C46h		; set upper limit
	CALL	LAB_2872		; subtract BC from DE, sets carry flag
	JR	C,LAB_286C		; failed, clock running too slowly

	LD	A,#00h		; else set passed
	JR	LAB_286E		; set flags & exit

LAB_286C
	LD	A,#FFh		; set failed
LAB_286E
	LD	(LAB_FDB5),A	; save clock test status flags
	RET				;

; subtract BC from DE, sets carry flag

LAB_2872
	LD	A,E			; copy E
	SUB	C			; subtract C
	LD	A,D			; copy D
	SBC	A,B			; subtract B
	RET				;

; clock test IRQ routine

LAB_2877
	DI				; disable interrupts
	LD	A,(LAB_FDA8)	; get test interrupt count
	DEC	A			; decrement it
	LD	(LAB_FDA8),A	; save test interrupt count
	JR	Z,LAB_2886		; exit if count =0

	CALL	LAB_288A		; clear main and RTC interrupt flags
	EI				; enable interrupts
	RET				;

					; done test clock interrupt count
LAB_2886
	POP	IX			; dump interrupt return address
	JR	LAB_284E		; go analyse test result

; clear main and RTC interrupt flags

LAB_288A
	IN	A,(Port_05)		; clear interrupt flags
	LD	A,#0Ch		; set RTC address port 0Ch
	OUT	(RTC_A),A		; set RTC address
	IN	A,(RTC_D)		; get RTC data (get & clear interrupt flags)
	RET				;

; save JP DE @ IRQ routine address

LAB_2893
	LD	HL,LAB_F5F3		; point to IRQ routine address
	LD	A,#C3h		; HEX for JP
	LD	(HL),A		; save it
	INC	HL			; point to next byte
	LD	(HL),E		; save low byte of JP address
	INC	HL			; point to next byte
	LD	(HL),D		; save high byte of JP address
	RET				;

; do powerdown test ??

LAB_289E
	LD	A,#00h		; clear A (could XOR A here!)
	LD	(LAB_FDB7),A	;28A0:	32B7FD
	LD	(LAB_FDB6),A	; clear powerdown test status flags
	LD	A,(LAB_F792)	; get Port_48 buffer
	OR	#01h			; set xxxx xxx1
	LD	(LAB_F792),A	; save Port_48 buffer
	OUT	(Port_48),A		; out to Port_48
	LD	A,(LAB_F792)	; get Port_48 buffer
	OR	#02h			; set xxxx xx1x
	LD	(LAB_F792),A	; save Port_48 buffer
	OUT	(Port_48),A		; out to Port_48
	LD	DE,LAB_2903		; make routine @ LAB_2903 IRQ routine
	CALL	LAB_2893		; save JP DE @ IRQ routine address
	LD	D,#2Fh		; not used anywhere ??
	CALL	LAB_20D9		; set clock for BCD mode, 12hr mode & 64Hz timebase
	CALL	LAB_288A		; clear main and RTC interrupt flags
	CALL	LAB_2306		; enable RTC IRQ & setup interrupt table
	LD	A,#00h		; clear A
LAB_28CD
	JR	NC,LAB_28CD		; wait for interrupt to set carry flag

	LD	A,#FFh		; set Port_04
	LD	(LAB_F784),A	; save Port_04 buffer
	CALL	LAB_28EC		; save SP and disable interrupts
	DI				; disable interrupts (again!)
	LD	A,#FFh		; set mask byte
	OUT	(Port_04),A		; disable all interrupts (again!)
	LD	A,(LAB_F792)	; get Port_48 buffer
	AND	#FEh			; mask xxxx xxx0
	LD	(LAB_F792),A	; save Port_48 buffer
	OUT	(Port_48),A		; out to Port_48
	LD	A,#FFh		;28E6:	3EFF
	LD	(LAB_FDB7),A	;28E8:	32B7FD
	RET				;

; save SP and disable interrupts

LAB_28EC
	LD	(LAB_FBD0),SP	; save stack pointer
	LD	A,#01h		; set value for Port_07
	OUT	(Port_07),A		; out to Port_07
	NOP				;
	NOP				;
	NOP				;
	NOP				;
	DI				; disable interrupts
	LD	A,#FFh		;28F9:	3EFF
	OUT	(Port_04),A		; disable all interrupts
	LD	A,#FFh		;28FD:	3EFF
	LD	(LAB_FDB6),A	; save powerdown test status flags
	RET				;

LAB_2903
	DI				; disable interrupts
	CALL	LAB_288A		; clear main and RTC interrupt flags
	SCF				; set carry
	EI				; enable interrupts
	RET				;

; HL is header, DE is checksum No. A is error code

LAB_290A
	PUSH	AF			; save error code
	PUSH	DE			; save checksum
	CALL	LAB_2AD0		; clear current line ??
	CALL	LAB_2AA1		; output string until 00h
	POP	HL			; restore checksum
	CALL	LAB_2B02		; output HL as hex word
	POP	AF			; restore error code
	JR	LAB_2923		; message 'PASS', 'TIMEOUT' or 'FAIL'
					; if A=00h,80h or other. Then RET

; output (HL) message and then test result message

LAB_2919
	PUSH	AF			; save error code
	CALL	LAB_2AD0		; clear current line ??
	CALL	LAB_2AA1		; output string until 00h
	POP	AF			; restore error code
	JR	LAB_2923		; message 'PASS', 'TIMEOUT' or 'FAIL' if A=00h,80h or other
					; (don`t need this line !)

; message 'PASS', 'TIMEOUT' or 'FAIL' if A=00h,80h or other

LAB_2923
	LD	HL,LAB_29BD		; point to 'PASS'
	CP	#00h			; compare with 00h (could do OR A!)
	JR	Z,LAB_2934		; was a pass so jump
	LD	HL,LAB_29C9		; else point to 'TIMEOUT'
	CP	#80h			; compare with 80h
	JR	Z,LAB_2934		; jump if was timeout
	LD	HL,LAB_29C3		; else point to 'FAIL'
LAB_2934
	CALL	LAB_2AA1		; output string until 00h
	CALL	LAB_2A92		; output [CR][LF]
	RET				;

; convert HL to string @ HL

LAB_293B
	LD	IX,29A7h		; pint to 10,000d
	LD	IY,FEF0h		; point to output buffer start
	LD	(IY+#00h),#30h	; make first digit = '0'
	LD	B,#04h		; 4 digits + units remainder to do
	CALL	LAB_2962		; convert HL to string at (IY)
	LD	IY,FEF0h		; point to start of buffer
	LD	B,#04h		; 4 digits to check
	LD	A,#30h		; make A = '0'
LAB_2954
	CP	(IY+#00h)		; is digit = '0'
	JR	NZ,LAB_295E		; if not then exit loop
	INC	IY			; else point to next digit
	DEC	B			; decrement digit count
	JR	NZ,LAB_2954		; if not all done go do next digit (could DJNZ here)
LAB_295E
	PUSH	IY			; copy IY ..
	POP	HL			; ... to HL
	RET				;

; convert HL to string at (IY)

LAB_2962
	CALL	LAB_2989		; subtract (IX) from HL
	JR	C,LAB_296C		; jump if result -ve

	INC	(IY+#00h)		; else increment digit
	JR	LAB_2962		; loop

LAB_296C
	CALL	LAB_2998		; add (IX) back to HL
	INC	IY			; point to next digit
	INC	IX			; point to next multiplier
	INC	IX			; (2 bytes per multiplier)
	LD	(IY+#00h),#30h	; make next digit = '0'
	DEC	B			; decrement digits to do
	JR	NZ,LAB_2962		; loop of not last digit
	LD	A,L			; else get remainder
	ADD	A,#30h		; add '0'
	LD	(IY+#00h),A		; and save it it
	INC	IY			; increment pointer
	LD	(IY+#00h),#00h	; and terminate string
	RET				;

; subtract (IX) from HL

LAB_2989
	LD	A,L			; get low byte of number
	SUB	(IX+#00h)		; subtract low byte of multiplier
	LD	L,A			; save it back
	INC	IX			; point to high byte of multiplier
	LD	A,H			; get high byte of number
	SBC	A,(IX+#00h)		; subtract high byte of multiplier
					; (use ,(IX+#01h) to save the INC & DEC IX!)
	LD	H,A			; save it back
	DEC	IX			; point to low byte of multiplier
	RET				;

; add (IX) to HL

LAB_2998
	LD	A,L			; get low byte of number
	ADD	A,(IX+#00h)		; add low byte of multiplier
	LD	L,A			; save it back
	INC	IX			; point to high byte of multiplier
	LD	A,H			; get high byte of number
	ADC	A,(IX+#00h)		; add high byte of multiplier
					; (use ,(IX+#01h) to save the INC & DEC IX!)
	LD	H,A			; save it back
	DEC	IX			; point to low byte of multiplier
	RET				;

; binary to decimal conversion tables

LAB_29A7
	DW	2710h		; 10,000d
	DW	03E8h		; 1,000d
	DW	0064h		; 100d
	DW	000Ah		; 10d

LAB_29AF
	DB	01h,00h
LAB_29B1
	DB	'PARCOM 1000',00h
LAB_29BD
	DB	'PASS',00h
LAB_29C3
	DB	'FAIL',00h
LAB_29C9
	DB	'TIMEOUT',00h
LAB_29D1
	DB	'status flags  ',00h
LAB_29E0
	DB	'Bank select   ',00h
LAB_29EF
	DB	'ROM 0 CS: ',00h
LAB_29FA
	DB	'ROM 1 CS: ',00h
LAB_2A05
	DB	'Clock test    ',00h
LAB_2A14
	DB	'Powerdown test',00h
LAB_2A23
	DB	'First Ram Bank ',00h
LAB_2A33
	DB	'Full Ram:  ',00h
LAB_2A3F
	DB	'Contig Ram:',00h
LAB_2A4B
	DB	' K.B.',00h
LAB_2A51
	DB	'Continue? ',00h
LAB_2A5C
	DB	'To Continue Press>>',00h
LAB_2A70
	DB	'TESTING...',00h
LAB_2A7B
	DB	'RAM:   ',00h

; display message at HL. null byte terminates output.

LAB_2A83
	LD	A,(HL)		; get byte
	OR	A			; set the flags
	JP	Z,LAB_2A91		; exit if zero (could RET Z here!)
	PUSH	HL			; save HL
	CALL	LAB_1BEB		; display_2 chr ???
	POP	HL			; restore HL
	INC	HL			; next byte
	JP	LAB_2A83		; loop (could JR LAB_2A83 here!)
LAB_2A91
	RET				; won`t need this if I RET Z!

; output [CR][LF]

LAB_2A92
	LD	A,#0Dh		; [CR]
	CALL	LAB_3515		; chr out and buffer check ??
	LD	A,#0Ah		; [LF]
LAB_2A99
	CALL	LAB_3515		; chr out and buffer check ??
	XOR	A			; clear A
	LD	(LAB_FEA3),A	; clear ## ??
	RET				;

; output string until 00h

LAB_2AA1
	LD	A,(HL)		; get byte
	AND	A			; set the flags
LAB_2AA3
	RET	Z			; return if end of string
	CALL	LAB_3515		; chr out and buffer check ??
	INC	HL			; point to next byte
	JR	LAB_2AA1		; loop

; output space

LAB_2AAA
	LD	A,#20h		; ' '
	CALL	LAB_3515		; chr out and buffer check ??
	RET				;

; output A spaces

LAB_2AB0
	AND	A			; set the flags
	RET	Z			; exit if null string
	PUSH	AF			; save A
	LD	A,#20h		; ' ' chr
	CALL	LAB_3515		; chr out and buffer check ??
	POP	AF			; restore A
LAB_2AB9
	DEC	A			; decrement count
	JR	LAB_2AB0		; loop

; clear display & home cursor (preserves registers) 

LAB_2ABC
	PUSH	AF			; save AF
	PUSH	BC			; save BC
	PUSH	DE			; save DE
	PUSH	HL			; save HL
	PUSH	IX			; save IX
	PUSH	IY			; save IY
	CALL	LAB_1FF4		; clear display & home cursor
	POP	IY			; restore IY
	POP	IX			; restore IX
	POP	HL			; restore HL
	POP	DE			; restore DE
	POP	BC			; restore BC
	POP	AF			; restore AF
	RET				;

; clear current line ??

LAB_2AD0
	CALL	LAB_2ADC		; output [CR]
	LD	A,#14h		; 14h (20d) spaces to output (1 line)
	CALL	LAB_2AB0		; output A spaces
	CALL	LAB_2AE2		; output chr 0Ch
	RET				;

; output [CR]

LAB_2ADC
	LD	A,#0Dh		; [CR]
	CALL	LAB_3515		; chr out and buffer check ??
	RET				;

; output chr 0Ch

LAB_2AE2
	LD	A,#0Ch		; chr 0Ch
	CALL	LAB_3515		; chr out and buffer check ??
	RET				;

; output HL as decimal string

LAB_2AE8
	CALL	LAB_293B		; convert HL to string @ HL
	CALL	LAB_2AA1		; output string until 00h
	RET				;

; output A as hex pair

LAB_2AEF
	PUSH	AF			; save A
	RRCA				; rotate top nibble ...
	RRCA				; ... into lower nibble
	RRCA				;
	RRCA				;
	CALL	LAB_2B0F		; convert lower nibble A to ASCII hex ??
	CALL	LAB_3515		; chr out and buffer check ??
	POP	AF			; restore A
	CALL	LAB_2B0F		; convert lower nibble A to ASCII hex ??
	CALL	LAB_3515		; chr out and buffer check ??
	RET				;

; output HL as hex word

LAB_2B02
	PUSH	HL			; save HL
	PUSH	HL			; save HL
	LD	A,H			; copy H to A
	CALL	LAB_2AEF		; output A as hex pair
	POP	HL			; restore HL
	LD	A,L			; copy L to A
	CALL	LAB_2AEF		; output A as hex pair
	POP	HL			; restore HL
	RET				;

; convert lower nibble A to ASCII hex ??

LAB_2B0F
	AND	#0Fh			; clear high nibble
	ADD	A,#90h		;2B11:	C690
	DAA				;2B13:	27
	ADC	A,#40h		;2B14:	CE40
	DAA				;2B16:	27
	RET				;

; sets LAB_F5EE dependimg on E
; FFh - LAB_F57B - clear carry & return
; FEh - LAB_F57E - do error
; FDh - LAB_F59F - do error with ??
; FCh - LAB_F5C0 - do error with retry or mon options

LAB_2B18
	PUSH	AF		;2B18:	F5
	PUSH	BC		;2B19:	C5
	PUSH	DE		;2B1A:	D5
	PUSH	HL		;2B1B:	E5
	PUSH	IX		;2B1C:	DDE5
	PUSH	IY		;2B1E:	FDE5
	LD	A,#FFh		;2B20:	3EFF
	CP	E		;2B22:	BB
	JR	NZ,LAB_2B2A	;2B23:	2005

	LD	HL,LAB_F57B	;2B25:	217BF5
	JR	LAB_2B49	;2B28:	181F

LAB_2B2A
	LD	A,#FEh		;2B2A:	3EFE
	CP	E		;2B2C:	BB
	JR	NZ,LAB_2B34	;2B2D:	2005

	LD	HL,LAB_F57E	;2B2F:	217EF5
	JR	LAB_2B49	;2B32:	1815

LAB_2B34
	LD	A,#FDh		;2B34:	3EFD
	CP	E		;2B36:	BB
	JR	NZ,LAB_2B41	;2B37:	2008

	LD	(LAB_FDBA),HL	;2B39:	22BAFD
	LD	HL,LAB_F59F	;2B3C:	219FF5
	JR	LAB_2B49	;2B3F:	1808

LAB_2B41
	LD	A,#FCh		;2B41:	3EFC
	CP	E		;2B43:	BB
	JR	NZ,LAB_2B4C	;2B44:	2006

	LD	HL,LAB_F5C0	;2B46:	21C0F5

LAB_2B49
	LD	(LAB_F5EE),HL	;2B49:	22EEF5
LAB_2B4C
	POP	IY		;2B4C:	FDE1
	POP	IX		;2B4E:	DDE1
	POP	HL		;2B50:	E1
	POP	DE		;2B51:	D1
	POP	BC		;2B52:	C1
	POP	AF		;2B53:	F1
	RET				;

; process error (error code in A')

LAB_2B55
	EX	AF,AF'		;2B55:	08
	PUSH	AF			; save AF
	PUSH	BC			; save BC
	PUSH	DE			; save DE
	PUSH	HL			; save HL
	PUSH	IX			; save IX
	PUSH	IY			; save IY
	LD	B,#07h		; 7 entries to search
	LD	HL,LAB_2CA8		; point to fatal error code table
	LD	C,A			; copy A
LAB_2B64
	CP	(HL)			; compare with table entry
	JR	Z,LAB_2BCD		; if match; display fatal error details & wait for key
					; & RET
	INC	HL			; point to next
	DEC	B			; decrement count
	JR	NZ,LAB_2B64		; loop until all checked

	LD	B,#04h		; 4 entries to check
	LD	DE,0004h		; 4 bytes per entry
	LD	HL,LAB_2CAF		; point to peripheral fail table ??
LAB_2B73
	LD	A,(HL)		; get byte
	CP	C			; compare with error code
	JR	Z,LAB_2B7D		; jump if found

	ADD	HL,DE			; else next block
	DEC	B			; decrement count
	JR	NZ,LAB_2B73		; loop if not all done
	JR	LAB_2BC1		; all done, restore reg pairs, clear carry & swap
					; AF,AF'

; match was found, display message and return carry set for retry

LAB_2B7D
	PUSH	HL			; save pointer
	CALL	LAB_2ABC		; clear display & home cursor (preserves registers) 
	CALL	LAB_2C56		; output error type and HEX$(#)
	POP	HL			; restore pointer
	INC	HL			; +1
	PUSH	HL			; save it
	INC	HL			; +2
	LD	E,(HL)		; get low byte
	INC	HL			; point to high byte
	LD	D,(HL)		; get high byte
	EX	DE,HL			; copy new pointer to HL
	CALL	LAB_2AA1		; output string until 00h
	CALL	LAB_2A92		; output [CR][LF]
	LD	A,#00h		; clear A (could XOR A!)
	POP	HL			; restore pointer
	CP	(HL)			; is (HL)=0 (no message)
	JR	Z,LAB_2BC1		; if so restore reg pairs, clear carry & swap AF,AF' & RET
	LD	HL,2CE2h		; point to 'R for retry'
	CALL	LAB_2AA1		; output string until 00h
	CALL	LAB_2A92		; output [CR][LF]
	LD	HL,LAB_2D04		; points to 'Any key for return'
	CALL	LAB_2AA1		; output string until 00h
LAB_2BA7
	CALL	LAB_3539		; get key
	JR	Z,LAB_2BA7		; loop until key ??
	CP	#52h			; compare with 'R'
	JR	Z,LAB_2BB6		; restore reg pairs, set carry & swap AF,AF'
	CP	#2Dh			; compare with '-'
	JR	Z,LAB_2BB6		; restore reg pairs, set carry & swap AF,AF'
	JR	LAB_2BC1		; restore reg pairs, clear carry & swap AF,AF'
					; ( if this was JR NZ,xxx then the above isn't needed!)

; restore reg pairs, set carry & swap AF,AF'

LAB_2BB6
	POP	IY			; restore IY
	POP	IX			; restore IX
	POP	HL			; restore HL
	POP	DE			; restore DE
	POP	BC			; restore BC
	POP	AF			; restore AF
	SCF				; set carry
	EX	AF,AF'		;
	RET				;

; restore reg pairs, clear carry & swap AF,AF'

LAB_2BC1
	POP	IY			; restore IY
	POP	IX			; restore 
	POP	HL			; restore 
	POP	DE			; restore 
	POP	BC			; restore 
	POP	AF			; restore 
	SCF				; set carry
	CCF				; complement (clear) carry
	EX	AF,AF'		;
	RET				;

; display fatal error details & wait for key

LAB_2BCD
	CALL	LAB_2ABC	; clear display & home cursor (preserves registers) 
	CALL	LAB_2C56	; output error type and HEX$(#)
	LD	HL,LAB_2CBF	; point to '***FATAL ERROR *** Consult Dealer'
	CALL	LAB_2AA1	; output string until 00h
	CALL	LAB_2A92	; output [CR][LF]
	POP	IY		; restore IY
	POP	IX		; restore IX
	POP	HL		; restore HL
	POP	DE		; restore DE
	POP	BC		; restore BC
	POP	AF		; restore AF
	PUSH	AF		; save AF
LAB_2BE5
	CALL	LAB_3539	; get key
	JR	LAB_2BE5	; loop until key
	POP	AF		; restore AF
	JP	LAB_3513	; just does XOR A & RET

LAB_2BEE
	PUSH	AF		;2BEE:	F5
	PUSH	BC		;2BEF:	C5
	PUSH	DE		;2BF0:	D5
	PUSH	HL		;2BF1:	E5
	PUSH	IX		;2BF2:	DDE5
	PUSH	IY		;2BF4:	FDE5
	LD	(LAB_FDB9),A	;2BF6:	32B9FD
	LD	A,#FFh		;2BF9:	3EFF
	LD	(LAB_FDB8),A	;2BFB:	32B8FD
	JR	LAB_2BC1	; restore reg pairs, clear carry & swap AF,AF'

; display error & offer retry or monitor

LAB_2C00
	EX	AF,AF'		;2C00:	08
	PUSH	AF		;2C01:	F5
	PUSH	BC		;2C02:	C5
	PUSH	DE		;2C03:	D5
	PUSH	HL		;2C04:	E5
	PUSH	IX		;2C05:	DDE5
	PUSH	IY		;2C07:	FDE5
	LD	C,A		;2C09:	4F
	CALL	LAB_2ABC		; clear display & home cursor (preserves registers) 
	CALL	LAB_2C56		; output error type and HEX$(#)
	LD	HL,2CE2h		; point to 'R for retry'
	CALL	LAB_2AA1		; output string until 00h
	CALL	LAB_2A92		; output [CR][LF]
	LD	HL,LAB_2CF2		; points to 'M key for monitor'
	CALL	LAB_2AA1		; output string until 00h
	CALL	LAB_2A92		; output [CR][LF]
	LD	HL,LAB_2D04		; points to 'Any key for return'
	CALL	LAB_2AA1		; output string until 00h
LAB_2C28
	CALL	LAB_3539		; get key
	JR	Z,LAB_2C28		; loop until key
	CP	#52h			; compare with 'R'
	JR	Z,LAB_2BB6		; restore reg pairs, set carry & swap AF,AF'
	CP	#2Dh			; compare with '-'
	JR	Z,LAB_2BB6		; restore reg pairs, set carry & swap AF,AF'
	CP	#4Dh			; compare with 'M'
	JR	Z,LAB_2C3F		;2C37:	2806
	CP	#5Ah			; compare with 'Z'
	JR	Z,LAB_2C3F		;2C3B:	2802
	JR	LAB_2BC1		; restore reg pairs, clear carry & swap AF,AF'
LAB_2C3F
	POP	IY			; restore IY
	POP	IX			; restore IX
	POP	HL			; restore HL
	POP	DE			; restore DE
	POP	BC			; restore BC
	POP	AF			; restore AF
	PUSH	AF			; save AF (these two lines aren't needed!)
	LD	(LAB_FEFA),HL	;2C48:	22FAFE
	POP	HL		;2C4B:	E1
	LD	(LAB_FEF8),HL	;2C4C:	22F8FE
	CALL	LAB_3513		; just does XOR A
	SCF				; set carry
	CCF				; complement (clear) carry (the XOR A does this!)
	EX	AF,AF'		;
	RET				;

; output error type and HEX$(#)

LAB_2C56
	CALL	LAB_2C67		; output error type/#
	LD	HL,LAB_2D3D		; points to ' err '
	CALL	LAB_2AA1		; output string until 00h
	LD	A,C			; get error # back
	CALL	LAB_2AEF		; output A as hex pair
	CALL	LAB_2A92		; output [CR][LF]
	RET				;

; output error type/#

LAB_2C67
	LD	A,(LAB_FEFD)	; get error type (FFh = Bdos, else Bios)
	CP	#FFh			; compare with FFh
	JR	NZ,LAB_2C73		; jump if Bios error

	LD	HL,LAB_2D33		; else point to 'Bdos ftn '
	JR	LAB_2C87		; go do Bdos error output

LAB_2C73
	LD	HL,LAB_2D29		; points to 'Bios ftn '
	CALL	LAB_2AA1		; output string until 00h
	LD	A,(LAB_FEFC)	; get error number
	CP	#FFh			; compare with FFh
	JR	NZ,LAB_2C8D		; if not go output A as decimal string

	LD	HL,LAB_2D43		; else point to '-3'
	CALL	LAB_2AA1		; output string until 00h
	RET				;

; Bdos error message output

LAB_2C87
	CALL	LAB_2AA1		; output string until 00h
	LD	A,(LAB_FEFC)	; get error number

; output A as decimal string

LAB_2C8D
	LD	L,A			; copy A to L
	LD	H,#00h		; clear high byte
	CALL	LAB_2AE8		; output HL as decimal string
	RET				;

; setup LAB_FDB8/9/A/B

LAB_2C94
	LD	A,#00h		;2C94:	3E00
	LD	(LAB_FDB8),A	;2C96:	32B8FD
	LD	(LAB_FDB9),A	;2C99:	32B9FD
	LD	E,#FEh		;2C9C:	1EFE
	CALL	LAB_2B18		; sets LAB_F5EE dependimg on E
					; FFh - LAB_F57B - clear carry & return
					; FEh - LAB_F57E - do error
					; FDh - LAB_F59F - do error with ??
					; FCh - LAB_F5C0 - do error with retry or mon options
	LD	HL,LAB_F57E	;2CA1:	217EF5
	LD	(LAB_FDBA),HL	;2CA4:	22BAFD
	RET				;

LAB_2CA8
	DB	FEh,FDh,FCh,FBh,EAh,E9h,E0h

LAB_2CAF
	DB	EEh,FFh
	DW	LAB_2D46		; 'Peripheral Failure'
	DB	ECh,FFh
	DW	LAB_2D46		; 'Peripheral Failure'
	DB	EBh,FFh
	DW	LAB_2D46		; 'Peripheral Failure'
	DB	FAh,FFh
	DW	LAB_2D59		; 'Link inhibited -    battery low'

LAB_2CBF:
	DB	'***FATAL ERROR *** Consult Dealer',00h
LAB_2CE2
	DB	'R key for retry',00h
LAB_2CF2
	DB	'M key for monitor',00h
LAB_2D04
	DB	'Any key for return',00h
LAB_2D17
	DB	'Any key for entry',00h
LAB_2D29
	DB	'Bios ftn ',00h
LAB_2D33:
	DB	'Bdos ftn ',00h
LAB_2D3D
	DB	' err ',00h
LAB_2D43
	DB	'-3',00h
LAB_2D46
	DB	'Peripheral Failure',00h
LAB_2D59
	DB	'Link inhibited -    battery low',00h

; error # 39h return address ??
; save D @ LAB_FDBD & E @ LAB_FDBE

LAB_2D79
	LD	A,D		;2D79:	7A
	LD	(LAB_FDBD),A	;2D7A:	32BDFD
	LD	A,E		;2D7D:	7B
	LD	(LAB_FDBE),A	;2D7E:	32BEFD
	RET				;

; display error header ??

LAB_2D82
	PUSH	AF			; save A
LAB_2D83
	LD	A,(LAB_FDBE)	;2D83:	3ABEFD
LAB_2D86
	CP	#00h		;2D86:	FE00
	JR	Z,LAB_2D8F	;2D88:	2805
	LD	A,#FFh		;2D8A:	3EFF
	LD	(LAB_FEA4),A	;2D8C:	32A4FE
LAB_2D8F
	PUSH	HL			; save HL
	CALL	LAB_2ABC		; clear display & home cursor (preserves registers) 
	CALL	LAB_2C67		; output error type/#
LAB_2D96
	POP	HL			; restore HL
	POP	AF			; restore A
LAB_2D98
	CALL	LAB_2DD1		; output AC, DE & HL as hex words
	LD	HL,LAB_2D17		; points to 'Any key for entry'
	LD	A,(LAB_FDBD)	;2D9E:	3ABDFD
	AND	#02h		;2DA1:	E602
	JR	LAB_2DBE		; if z=0 display message & wait for key
					; else clear LAB_FEA4 & RET'n

; display error footer and wait for key ??

LAB_2DA5
	PUSH	AF			; save A
	LD	A,(LAB_FDBE)	;2DA6:	3ABEFD
	CP	#00h		;2DA9:	FE00
	JR	Z,LAB_2DB2	;2DAB:	2805
	LD	A,#FFh		;2DAD:	3EFF
	LD	(LAB_FEA4),A	;2DAF:	32A4FE
LAB_2DB2
	POP	AF			; restore A
	CALL	LAB_2DD1		; output AC, DE & HL as hex words
	LD	HL,LAB_2D04		; points to 'Any key for return'
	LD	A,(LAB_FDBD)	;2DB9:	3ABDFD
	AND	#04h		;2DBC:	E604

					; if z=0 display message & wait for key
					; else clear LAB_FEA4 & RET'n
LAB_2DBE
	JR	Z,LAB_2DCB		; clear LAB_FEA4 & RET'n

	CALL	LAB_2AA1		; output string until 00h
	CALL	LAB_2A92		; output [CR][LF]
LAB_2DC6
	CALL	LAB_3539		; get key
	JR	Z,LAB_2DC6		; loop until key

LAB_2DCB
	LD	A,#00h		; clear A (could XOR A here!)
	LD	(LAB_FEA4),A	;2DCD:	32A4FE
	RET				;

; output AC, DE & HL as hex words

LAB_2DD1
	PUSH	HL			; save HL
	PUSH	AF			; save A
	CALL	LAB_2A92		; output [CR][LF]
	LD	HL,LAB_2DF7		; points to 'ac'
	CALL	LAB_2AA1		; output string until 00h
	POP	AF			; restore A
	LD	H,A			; copy A to H
	LD	L,C			; copy C to L
	CALL	LAB_2B02		; output HL as hex word
LAB_2DE2
	LD	HL,LAB_2DFA		; points to ' de',00h
	CALL	LAB_2AA1		; output string until 00h
	EX	DE,HL			; DE into HL
	CALL	LAB_2B02		; output HL as hex word
	LD	HL,LAB_2DFE		; points to ' hl'
	CALL	LAB_2AA1		; output string until 00h
	POP	HL			; restore HL
	CALL	LAB_2B02		; output HL as hex word
	RET				;

LAB_2DF7
	DB	'ac',00h
LAB_2DFA
	DB	' de',00h
LAB_2DFE
	DB	' hl',00h

; error # 33h return address ??

LAB_2E02
	EX	DE,HL		;2E02:	EB
	LD	(LAB_FDBF),BC	 set ?? countdown time (seconds)
	LD	(LAB_FDC7),DE	;2E07:	ED53C7FD
	LD	(LAB_FDC5),HL	;2E0B:	22C5FD
	LD	DE,0004h	;2E0E:	110400
	ADD	HL,DE		;2E11:	19
	PUSH	HL		;2E12:	E5
	CALL	LAB_31FF		; if A<10h return HL=base+A, else return A=FDh C=1
					; where if Cb=1 base=LAB_FE83 else base=LAB_FE93, A=A-41h
	POP	DE		;2E16:	D1
	CALL	LAB_2EAB	;2E17:	CDAB2E
					; if no error returns ..
					; HL = LAB_FDEE
					; DE = LAB_FE12
	RET	C			; exit if there was an error

	PUSH	DE		;2E1B:	D5
	LD	DE,(LAB_FDC5)	;2E1C:	ED5BC5FD
	CALL	LAB_2E5A	;2E20:	CD5A2E
	POP	HL		;2E23:	E1
	LD	DE,(LAB_FDC7)	;2E24:	ED5BC7FD
	CALL	LAB_2E5A	;2E28:	CD5A2E
	LD	HL,LAB_2E85		; set vector
	CALL	LAB_2F1A	;2E2E:	CD1A2F
	RET	C			; return if error

	LD	A,(LAB_FDBF)	; get countdown time (seconds)
	CP	#00h			; is it zero (could OR A here!)
	CALL	NZ,LAB_2E43		; if not go set it
	LD	A,(LAB_FDC0)	;2E3A:	3AC0FD
	CP	#FFh		;2E3D:	FEFF
	JR	Z,LAB_2E4D	;2E3F:	280C
	XOR	A		;2E41:	AF
	RET				;

; set LAB_2E72 countdown to 64d*A

LAB_2E43
	CALL	LAB_2E9C		; multiply A by 64d, word result in LAB_FDC1
					; DE points to it
	LD	HL,LAB_2E72		; set vector
	CALL	LAB_2189		; save DE & HL in RTC interrupt table
					; return carry set if not saved
	RET				;

LAB_2E4D
	LD	C,#01h		;2E4D:	0E01
	CALL	LAB_168F	;2E4F:	CD8F16
	LD	IX,(LAB_FDC7)	;2E52:	DD2AC7FD
	LD	A,(IX+#04h)	;2E56:	DD7E04
	RET				;

LAB_2E5A
	EX	DE,HL		;2E5A:	EB
	LD	C,(HL)		;2E5B:	4E
	INC	HL			; increment pointer
	LD	B,(HL)		;2E5D:	46
	INC	HL		;2E5E:	23
	EX	DE,HL		;2E5F:	EB
LAB_2E60
	LD	(HL),C		;2E60:	71
	INC	HL			; increment pointer
	LD	(HL),B		;2E62:	70
	INC	HL		;2E63:	23
	EX	DE,HL		;2E64:	EB
	INC	HL		;2E65:	23
	INC	HL		;2E66:	23
	EX	DE,HL		;2E67:	EB
LAB_2E68
	LD	(HL),E		;2E68:	73
	INC	HL			; increment pointer
	LD	(HL),D		;2E6A:	72
	INC	HL		;2E6B:	23
	LD	(HL),#00h	;2E6C:	3600
	INC	HL		;2E6E:	23
	LD	(HL),#00h	;2E6F:	3600
	RET				;

; RTC timebase vector

LAB_2E72
	CALL	LAB_31B0	;2E72:	CDB031
	LD	IX,(LAB_FDC7)	;2E75:	DD2AC7FD
	LD	A,#EEh		;2E79:	3EEE
	LD	(IX+#04h),A	;2E7B:	DD7704
	LD	DE,FFFFh	;2E7E:	11FFFF
	CALL	LAB_30BD	;2E81:	CDBD30
	RET				;

LAB_2E85
	LD	IX,(LAB_FDC7)	;2E85:	DD2AC7FD
	LD	(IX+#02h),E	;2E89:	DD7302
	LD	(IX+#03h),D	;2E8C:	DD7203
	LD	HL,LAB_FDC1		; point to ?? count
	CALL	LAB_21BA		; search table for HL (count pointer), clear if found
					; else return carry set
	LD	A,(LAB_FDC0)	;2E95:	3AC0FD
	LD	(LAB_FDC9),A	;2E98:	32C9FD
	RET				;

; multiply A by 64d, word result in FDC1h, DE points to it.

LAB_2E9C
	LD	H,#00h		; clear H
	LD	L,A			; copy A to L
	LD	B,#06h		; *2^6
LAB_2EA1
	ADD	HL,HL			; *2
	DJNZ	LAB_2EA1		; loop until *2^B is done

	LD	(LAB_FDC1),HL	; save result
	LD	DE,LAB_FDC1		; point to it
	RET				;

; DE & HL are pointers

LAB_2EAB
	LD	A,(LAB_FDCA)	;2EAB:	3ACAFD
	OR	A			; set the flags
	JR	Z,LAB_2EB8	;2EAF:	2807
	CP	(HL)		;2EB1:	BE
	JR	Z,LAB_2EB8	;2EB2:	2804

	LD	A,#E9h		; else error E9h
	SCF				; flag error
	RET				;

LAB_2EB8
	LD	A,(HL)		;2EB8:	7E
	LD	(LAB_FDCA),A	;2EB9:	32CAFD
	EX	DE,HL		;2EBC:	EB
	LD	A,(HL)		;2EBD:	7E
	LD	(LAB_FDCB),A	;2EBE:	32CBFD
	DI				; disable interrupts
	CALL	LAB_34D2		; get Port_4A buffer, AND with 3Fh & OUT (Port_4A)
	LD	A,#04h		;2EC5:	3E04
	LD	(LAB_FDD5),A	;2EC7:	32D5FD
	EI				; enable interrupts
	LD	HL,LAB_FDEE	;2ECB:	21EEFD
	LD	DE,LAB_FE12	;2ECE:	1112FE
	XOR	A			; clear A
	RET				;

; error # 30h return address ??

LAB_2ED3
	DI			; disable interrupts
	CALL	LAB_34D2	; get  Port_4A buffer, AND with 3Fh & OUT (Port_4A)
	EI			; enable interrupts
	LD	A,(LAB_FDCA)	;2ED8:	3ACAFD
	BIT	6,A		;2EDB:	CB77
	JR	Z,LAB_2F13	;2EDD:	2834
	LD	A,(LAB_FDD5)	;2EDF:	3AD5FD
	CP	#04h		;2EE2:	FE04
	JR	NZ,LAB_2EE8	;2EE4:	2002
	XOR	A			; clear A
	RET				;

LAB_2EE8
	CP	#02h		;2EE8:	FE02
	JR	Z,LAB_2EF3	;2EEA:	2807
	LD	A,#FFh		;2EEC:	3EFF
	LD	(LAB_FDD7),A	;2EEE:	32D7FD
	XOR	A			; clear A
	RET				;

LAB_2EF3
	CALL	LAB_31AB		; make HL=LAB_FE43+((LAB_FDD4) AND 3Fh)+1
	LD	A,#02h		;2EF6:	3E02
	LD	(LAB_FDCB),A	;2EF8:	32CBFD
	LD	HL,LAB_FE3A	;2EFB:	213AFE
	LD	(HL),A		;2EFE:	77
	LD	(LAB_FDF0),HL	;2EFF:	22F0FD
	LD	HL,0006h	;2F02:	210600
	LD	(LAB_FDEE),HL	;2F05:	22EEFD
	LD	HL,0000h	;2F08:	210000
	LD	(LAB_FDF2),HL	;2F0B:	22F2FD
	CALL	LAB_2F53	;2F0E:	CD532F
	XOR	A			; clear A
	RET				;

LAB_2F13
	LD	HL,LAB_FDD7	;2F13:	21D7FD
	LD	(HL),#FFh	;2F16:	36FF
	JR	LAB_2F7D		; find A in (LAB_31F2) table, execute vector from
					; (LAB_31F7) table, values of search table 2Bh,2Ah,23h,03h

LAB_2F1A
	LD	A,(LAB_FDA2)	; get main battery terminal count flag
	OR	A			; set the flags
	JR	Z,LAB_2F24		; jump if main battery ok.

	SCF				; else flag error ??
	LD	A,#FAh		; set error # FAh
	RET				;

LAB_2F24
	PUSH	HL			; save vector
	LD	HL,LAB_FDCE		; point to ??1 countdown timer
	CALL	LAB_21BA		; search table for HL (count pointer), clear if found
					; else return carry set
	POP	HL			; restore vector
	DI				; disable interrupts
	LD	A,(LAB_FBC9)	; get interrupt flag byte
	AND	#FEh			; clear RTC alarm ?? flag, mask xxxx xxx0
	LD	(LAB_FBC9),A	; save interrupt flag byte
	EI				; enable interrupts
	LD	(LAB_FDD2),HL	; save vector
	LD	A,#FFh		;2F39:	3EFF
	LD	(LAB_FBCB),A	;2F3B:	32CBFB
	LD	A,(LAB_FDCA)	;2F3E:	3ACAFD
	LD	(LAB_FDD4),A	;2F41:	32D4FD
	BIT	6,A		;2F44:	CB77
	JR	Z,LAB_2F7D		; find A in (LAB_31F2) table, execute vector from
					; (LAB_31F7) table, values of search table 2Bh,2Ah,23h,03h
	LD	A,(LAB_FDCB)	;2F48:	3ACBFD
	CP	#00h		;2F4B:	FE00
	JR	NZ,LAB_2F53	;2F4D:	2004
	XOR	A			; clear A
	CALL	LAB_31A6		; save A @ LAB_FE43+((LAB_FDD4) AND 3Fh)
LAB_2F53
	LD	A,#01h		;2F53:	3E01
	LD	(LAB_FDD5),A	;2F55:	32D5FD
	LD	A,#32h		;2F58:	3E32
	LD	(LAB_FDD6),A	;2F5A:	32D6FD
	LD	HL,0006h	;2F5D:	210600
	LD	(LAB_FDD8),HL	; save default ??1 countdown time
	CALL	LAB_3106		; setup table (LAB_FE0E) for IR receive
	CALL	LAB_3130		; add entry to tx table @ LAB_FDEA
	EX	DE,HL		;2F69:	EB
	LD	HL,LAB_FDDE	;2F6A:	21DEFD
	LD	A,#01h		;2F6D:	3E01
	CALL	LAB_316B	;2F6F:	CD6B31
	LD	HL,LAB_FE0E		; set pointer for IR receive table (LAB_FE0E)
	LD	(LAB_FDDC),HL	; save it
	CALL	LAB_2F86	;2F78:	CD862F
	XOR	A			; clear A
	RET				;

; find A in (LAB_31F2) table, execute vector from (LAB_31F7)
; table, values of search table 2Bh,2Ah,23h,03h

LAB_2F7D
	LD	B,A			; copy ??
	LD	IX,LAB_31F5		; set pointer to table
	CALL	LAB_31C6		; find B in (LAB_31F2) table, execute vector from (IX)
					; table, values of search table 2Bh,2Ah,23h,03h
	RET				;

; RTC timebase vector

LAB_2F86
	LD	A,(LAB_FDD5)	;2F86:	3AD5FD
	CP	#02h		;2F89:	FE02
	RET	Z		;2F8B:	C8

	CP	#04h		;2F8C:	FE04
	RET	Z		;2F8E:	C8

	CALL	LAB_30FC		; check (LAB_FDD6), return Cb=1 if zero
	JR	C,LAB_2FB2	;2F92:	381E

	LD	HL,LAB_FDEA		; pointer to table ??
	LD	A,(LAB_FDD4)	;2F97:	3AD4FD
	CALL	LAB_3277		; block out to IR port ??
	LD	DE,(LAB_FDD8)	; get default ??1 countdown time
	LD	(LAB_FDCE),DE	; save count
	LD	HL,LAB_2F86		; set vector (itself!)
	LD	DE,LAB_FDCE		; set count pointer
	CALL	LAB_2189		; save DE & HL in RTC interrupt table
					; return carry set if not saved
	CALL	LAB_34BD		; get  Port_4A buffer, OR with C0h & OUT (Port_4A)
	RET				;

LAB_2FB2
	LD	A,(LAB_FDD5)	;2FB2:	3AD5FD
	CP	#01h		;2FB5:	FE01
	JP	Z,LAB_305A	;2FB7:	CA5A30
	JP	LAB_3066	;2FBA:	C36630

; receive block ?? from IR port

LAB_2FBD
	LD	HL,(LAB_FDDC)	; get pointer to receive table
	PUSH	HL			; save pointer
	CALL	LAB_3378		; receive block from IR port
	POP	HL			; restore pointer
	JR	C,LAB_3010		; jump if there was an error

	INC	HL			; increment pointer
	INC	HL			; increment pointer
	LD	A,(HL)		; get receive buffer low byte
	INC	HL			; increment pointer
	LD	H,(HL)		; get receive buffer high byte
	LD	L,A			; copy low byte to L
	CALL	LAB_30DC		; check block header count & flags ??
	JR	C,LAB_3010		; jump if there was an error

	JR	NZ,LAB_3010		; jump if there was an error

	LD	HL,LAB_FDCE		; point to ??1 countdown timer
	CALL	LAB_21BA		; search table for HL (count pointer), clear if found
					; else return carry set
	LD	A,(LAB_FDD5)	;2FDA:	3AD5FD
	CP	#03h		;2FDD:	FE03
	JR	Z,LAB_3002	;2FDF:	2821
	CP	#02h		;2FE1:	FE02
	JR	Z,LAB_2FF3	;2FE3:	280E
	LD	A,(LAB_FDE6)	; get from IR receive header block
	CP	#02h		;2FE8:	FE02
	JR	Z,LAB_302C	;2FEA:	2840

	CP	#03h		;2FEC:	FE03
	JR	Z,LAB_3014	;2FEE:	2824

	JP	LAB_3060	;2FF0:	C36030

LAB_2FF3
	LD	A,(LAB_FDE6)	; get from IR receive header block
	CP	#02h		;2FF6:	FE02
	JR	Z,LAB_302C	;2FF8:	2832

	CP	#04h		;2FFA:	FE04
	JP	Z,LAB_3084	;2FFC:	CA8430

	JP	LAB_3072	;2FFF:	C37230

LAB_3002
	LD	A,(LAB_FE3C)	;3002:	3A3CFE
	CP	#04h		;3005:	FE04
	JR	Z,LAB_3084	;3007:	287B
	CP	#02h		;3009:	FE02
	JR	Z,LAB_302C	;300B:	281F
	JP	LAB_306C	;300D:	C36C30

LAB_3010
	CALL	LAB_34BD		; get  Port_4A buffer, OR with C0h & OUT (Port_4A)
	RET				;

LAB_3014
	LD	A,(LAB_FDD7)	;3014:	3AD7FD
	AND	A		;3017:	A7
	JP	Z,LAB_3023	;3018:	CA2330
	XOR	A			; clear A
	LD	(LAB_FDD7),A	;301C:	32D7FD
	CALL	LAB_2EF3	;301F:	CDF32E
	RET				;

LAB_3023
	LD	A,#02h		;3023:	3E02
	LD	(LAB_FDD5),A	;3025:	32D5FD
	CALL	LAB_34BD		; get  Port_4A buffer, OR with C0h & OUT (Port_4A)
	RET				;

LAB_302C
	LD	HL,0000h	;302C:	210000
	LD	(LAB_FDEE),HL	;302F:	22EEFD
	LD	HL,LAB_FDDE	;3032:	21DEFD
	LD	A,#03h		;3035:	3E03
	LD	DE,0006h	;3037:	110600
	CALL	LAB_316B	;303A:	CD6B31
	LD	A,#03h		;303D:	3E03
	LD	(LAB_FDD5),A	;303F:	32D5FD
	LD	A,#14h		;3042:	3E14
	LD	(LAB_FDD6),A	;3044:	32D6FD
	LD	HL,0003h	;3047:	210300
	LD	(LAB_FDD8),HL	; save default ??1 countdown time
	LD	HL,LAB_FE32	;304D:	2132FE
	LD	(LAB_FDDC),HL	;3050:	22DCFD
	CALL	LAB_2F86	;3053:	CD862F
	CALL	LAB_34BD		; get  Port_4A buffer, OR with C0h & OUT (Port_4A)
	RET				;

LAB_305A
	LD	BC,01EEh	;305A:	01EE01
	JP	LAB_3078	;305D:	C37830

LAB_3060
	LD	BC,02E0h	;3060:	01E002
	JP	LAB_3078	;3063:	C37830

LAB_3066
	LD	BC,02EEh	;3066:	01EE02
	JP	LAB_3078	;3069:	C37830

LAB_306C
	LD	BC,04E0h	;306C:	01E004
	JP	LAB_3078	;306F:	C37830

LAB_3072
	LD	BC,05E0h	;3072:	01E005
	JP	LAB_3078	;3075:	C37830 (don't need this, here allready!)

LAB_3078
	LD	HL,(LAB_FE14)	;3078:	2A14FE
	LD	(HL),C		; save low byte
	INC	HL			; increment pointer
	LD	(HL),B		; save high byte
	LD	HL,FFFFh	;307E:	21FFFF
	JP	LAB_30AD	;3081:	C3AD30

LAB_3084
	LD	A,(LAB_FDE7)	; get from IR receive header block
	LD	B,A		;3087:	47
	CALL	LAB_31A1		; get A from LAB_FE43+((LAB_FDD4) AND 3Fh)
	CP	B		;308B:	B8
	JR	Z,LAB_30A1	;308C:	2813

	LD	C,A		;308E:	4F
	LD	A,(LAB_FDCB)	;308F:	3ACBFD
	CP	#02h		;3092:	FE02
	JR	NZ,LAB_309B	;3094:	2005
	LD	A,C		;3096:	79
	DEC	A		;3097:	3D
	CP	B		;3098:	B8
	JR	Z,LAB_30A4	;3099:	2809
LAB_309B
	LD	BC,01EFh	;309B:	01EF01
	JP	LAB_3078	;309E:	C37830
LAB_30A1
	CALL	LAB_31AB		; make HL=LAB_FE43+((LAB_FDD4) AND 3Fh)+1
LAB_30A4
	AND	A		;30A4:	A7
	LD	HL,(LAB_FDE4)	; get from IR receive header block
	LD	DE,0006h	;30A8:	110600
	SBC	HL,DE		;30AB:	ED52

LAB_30AD
	EX	DE,HL		;30AD:	EB
	LD	A,#04h		;30AE:	3E04
	LD	(LAB_FDD5),A	;30B0:	32D5FD
	CALL	LAB_34D2		; get  Port_4A buffer, AND with 3Fh & OUT (Port_4A)
	PUSH	DE			; save DE
	LD	A,#01h		;30B7:	3E01
	CALL	LAB_31A6		; save A @ LAB_FE43+((LAB_FDD4) AND 3Fh)
	POP	DE			; restore DE
LAB_30BD
	LD	A,(LAB_FBC9)	; get interrupt flag byte
	OR	#01h			; set xxxx xxx1 (keyboard interrupt ??)
	LD	(LAB_FBC9),A	; save interrupt flag byte
	XOR	A			; clear A
	LD	(LAB_FDD7),A	;30C6:	32D7FD
	LD	(LAB_FBCB),A	;30C9:	32CBFB
	LD	(LAB_FDCA),A	;30CC:	32CAFD
	LD	HL,(LAB_FE14)	;30CF:	2A14FE
	LD	A,(HL)		;30D2:	7E
	LD	HL,LAB_30DB		; set return address
	PUSH	HL			; push it on stack
	LD	HL,(LAB_FDD2)	; get vector
	JP	(HL)			; go do it
LAB_30DB
	RET				;

; check block header count & flags ??

; block header is ...
; count low byte
; count high byte
; dunno
; dunno
; expected ?? byte

LAB_30DC
	PUSH	HL			; save pointer to receive buffer
	PUSH	DE			; copy received-2 ..
	POP	HL			; .. to HL
	LD	BC,0006h		; expect at least 6 bytes
	XOR	A			; set flags for SBC
	SBC	HL,BC			; compare (received-2) with 6
	POP	HL			; restore pointer to buffer
	RET	C			; exit if <6 bytes received

	LD	C,(HL)		; get ?? low byte from buffer
	INC	HL			; increment pointer
	LD	B,(HL)		; get ?? high byte from buffer
	EX	DE,HL			; swap received-2 count to HL
	SBC	HL,BC			; subtract block byte count from received-2
	JR	NZ,LAB_30FA		; jump if counts don't tally

	EX	DE,HL			; swap pointer back to HL
	INC	HL			; increment pointer
	INC	HL			; increment pointer
	INC	HL			; increment pointer
	LD	A,(HL)		; get ?? byte
	LD	B,A			; copy to B
	LD	A,(LAB_FDD4)	; get expected ?? byte
	XOR	B			; do bitwise compare
	RET	Z			; ok. exit if same
LAB_30FA
	SCF				; flag error
	RET				;

; check (LAB_FDD6), return Cb=1 if zero

LAB_30FC
	LD	HL,LAB_FDD6		; point to tx ?? byte
	LD	A,(HL)		; get byte
	AND	A			; set the flags
	SCF				; flag error
	RET	Z			; return if zero
	DEC	(HL)			; else decrement pointer
	AND	A			; set flags
	RET				;

; setup table (LAB_FE0E) for IR receive

; header is 6 bytes @ LAB_FDE4
; footer is 3 bytes @ LAB_FE38

LAB_3106
	LD	HL,LAB_FE0E		; point to table
	LD	BC,LAB_FDE4		; set receive buffer pointer
	LD	(LAB_FE10),BC	; save receive buffer pointer
	LD	(HL),#06h		; save count low byte
	INC	HL			; increment pointer
	LD	(HL),#00h		; save count high byte
	LD	DE,0003h		; offset to next count/pointer
LAB_3118
	ADD	HL,DE			; add offset to next count
	LD	A,(HL)		; get count low byte
	INC	HL			; increment pointer
	OR	(HL)			; OR with count high byte
	JR	NZ,LAB_3118		; loop if not end marker

	XOR	A			; clear A
	DEC	HL			; pointer back one
	LD	(HL),#03h		; save count low byte
	INC	HL			; increment pointer
	LD	(HL),A		; save count high byte (KBD_R)
	LD	DE,LAB_FE38		; set receive buffer pointer
	INC	HL			; increment pointer
	LD	(HL),E		; save receive pointer low
	INC	HL			; increment pointer
	LD	(HL),D		; save receive pointer high
	INC	HL			; increment pointer
	LD	(HL),A		; save end marker low (KBD_R)
	INC	HL			; increment pointer
	LD	(HL),A		; save end marker high (KBD_R)
	RET				;

; add entry to tx table @ LAB_FDEA

LAB_3130
	LD	DE,LAB_FDDE		; set pointer to buffer
	LD	(LAB_FDEC),DE	; save pointer to buffer
	LD	IX,LAB_FDEA		; point to table ??
	LD	(IX+#00h),#06h	; set byte count low byte
	LD	(IX+#01h),#00h	; set byte count high byte
	LD	DE,0004h		; offset to next count/pointer
	LD	HL,0000h		; clear tx byte total
LAB_3149
	LD	C,(IX+#00h)		; get byte count low byte
	LD	B,(IX+#01h)		; get byte count high byte
	LD	A,B			; copy high byte
	OR	C			; OR low byte
	RET	Z			; return if count=0

	ADD	IX,DE			; add offset to next entry
	ADD	HL,BC			; add word to total ??
	JP	LAB_3149		; loop

; setup table (LAB_FE32) for IR receive

LAB_3158
	LD	HL,0009h		; set count
	LD	(LAB_FE32),HL	; save count
	LD	HL,LAB_FE3A		; set receive pointer
	LD	(LAB_FE34),HL	; save receive pointer
	LD	HL,0000h		; end marker
	LD	(LAB_FE36),HL	; save end marker
	RET				;

LAB_316B
	LD	(HL),E		;316B:	73
	INC	HL			; increment pointer
	LD	(HL),D		;316D:	72
	INC	HL			; increment pointer
	LD	(HL),A		;316F:	77
	INC	HL		;3170:	23
	PUSH	HL		;3171:	E5
	CALL	LAB_31A1		; get A from LAB_FE43+((LAB_FDD4) AND 3Fh)
	POP	HL		;3175:	E1
	LD	(HL),A		;3176:	77
	INC	HL			; increment pointer
	LD	(HL),#7Fh	;3178:	367F
	RET				;

; setup pointers & clear FE43-FE82

LAB_317B
	LD	HL,LAB_FE43		; load pointer
	LD	B,#40h		; 40h (64d) bytes to do
LAB_3180
	LD	(HL),#01h		; set byte
	INC	HL			; increment pointer
	DJNZ	LAB_3180		; loop until all done

	LD	A,#04h		;3185:	3E04
	LD	(LAB_FDD5),A	;3187:	32D5FD
	CALL	LAB_3158		; setup table (LAB_FE32) for IR receive
	XOR	A			; clear A
	LD	(LAB_FDD7),A	;318E:	32D7FD
LAB_3191
	RET				;

; make HL=LAB_FE43+((LAB_FDD4) AND 3Fh)

LAB_3192
	PUSH	AF		;3192:	F5
	LD	A,(LAB_FDD4)	;3193:	3AD4FD
	AND	#3Fh		;3196:	E63F
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	LD	DE,LAB_FE43	;319B:	1143FE
	ADD	HL,DE		;319E:	19
	POP	AF		;319F:	F1
	RET				;

; get A from LAB_FE43+((LAB_FDD4) AND 3Fh)

LAB_31A1
	CALL	LAB_3192		; make HL=LAB_FE43+((LAB_FDD4) AND 3Fh)
	LD	A,(HL)		; get A
	RET				;

; save A @ LAB_FE43+((LAB_FDD4) AND 3Fh)

LAB_31A6
	CALL	LAB_3192		; make HL=LAB_FE43+((LAB_FDD4) AND 3Fh)
	LD	(HL),A		; save A
	RET				;

; make HL=LAB_FE43+((LAB_FDD4) AND 3Fh)+1

LAB_31AB
	CALL	LAB_3192		; make HL=LAB_FE43+((LAB_FDD4) AND 3Fh)
	INC	(HL)		;31AE:	34
	RET				;

LAB_31B0
	LD	BC,03EEh	;31B0:	01EE03
	JP	LAB_3078	;31B3:	C37830

; IR port interrupt routine ??

LAB_31B6
	CALL	LAB_34D2		; get Port_4A buffer, AND with 3Fh & OUT (Port_4A)
	CALL	LAB_34E7		; get IR port input status byte and mask bit 4
	JR	Z,LAB_31C2		; jump if bit not set

	CALL	LAB_2FBD		; receive block ?? from IR port
	RET				;

LAB_31C2
	CALL	LAB_34BD		; get Port_4A buffer, OR with C0h & OUT (Port_4A)
	RET				;

; find B in (LAB_31F2) table, execute vector from (IX) table
; values of search table 2Bh,2Ah,23h,03h

LAB_31C6
	LD	A,B			; copy ??
	AND	#7Fh			; mask 0xxx xxxx
	LD	B,A			; save ??
	LD	HL,LAB_31F2		; set pointer to table
LAB_31CD
	LD	A,(HL)		; get byte
	CP	#FFh			; compare with FFh
	JR	Z,LAB_31EE		; jump if end of table

	INC	HL			; else increment pointer
	INC	IX			; increment index
	INC	IX			; 2 bytes per word
	CP	B			; compare with B
	JR	NZ,LAB_31CD		; loop if not found

	LD	L,(IX+#00h)		; else get low byte
	LD	H,(IX+#01h)		; get high byte
	LD	DE,LAB_31ED		; set final return address
	PUSH	DE			; push on stack
	PUSH	HL			; set vector as return (go) address
	LD	HL,(LAB_FDF0)	;31E5:	2AF0FD
	LD	DE,(LAB_FE14)	;31E8:	ED5B14FE
	RET				; go do it

LAB_31ED
	RET				;

LAB_31EE
	LD	A,#EEh		; set error EEh ??
	SCF				; flag error
	RET				;

LAB_31F2
	DW	2Bh,2Ah,23h
LAB_31F5				; need this as IX needs to be set two low
	DB	03h,FFh

	DW	LAB_1221
	DW	LAB_1221
	DW	LAB_1893		; do RST 28h error handling
	DW	LAB_1893		; do RST 28h error handling

LAB_31FE
	DB	FEh

; if A<10h return HL=base+A, else return A=FDh C=1
; where if Cb=1 base=LAB_FE83 else base=LAB_FE93, A=A-41h

LAB_31FF
	LD	B,C		;3200:	41
	JR	C,LAB_320B	;3201:	3808

	SUB	#41h		;3203:	D641

; if A<10h return HL=LAB_FE93+A, else return A=FDh C=1

LAB_3205
	LD	HL,LAB_FE93		; point to copied block
	JP	LAB_3212		; go test & set

; if 00h<A<11h return HL=LAB_FE83+A, else return A=FDh C=1

LAB_320B
	LD	HL,LAB_FE83		; point to copied block
	AND	A			; set the flags
	JR	Z,LAB_321C		; error exit if null

	DEC	A			; convert range (1-16d to 0-15d ??)

LAB_3212
	CP	#10h			; compare drive with max+1
	JR	NC,LAB_321C		; error exit if too large

	LD	D,#00h		; clear high byte
	LD	E,A			; copy drive # to low byte
	ADD	HL,DE			; add to pointer
	XOR	A			; clear A and flags
	RET				;

LAB_321C
	LD	A,#FDh		; set error number
	SCF				; flag error
	RET				;

; copy blocks to FE93 & FE83

LAB_3220
	LD	HL,LAB_3257		; source address
	LD	DE,LAB_FE93		; destination address
	LD	BC,0010h		; bytes to copy
	LDIR				; copy block
	LD	HL,LAB_3267		; source address
	LD	DE,LAB_FE83		; destination address
	LD	BC,0010h		; bytes to copy
	LDIR				; copy block
	RET				;

; copy 10h bytes from LAB_FE83 to (DE) page (LAB_FEFE)

LAB_3237
	LD	HL,LAB_FE83		; set source
	LD	BC,0010h		; 10h bytes to copy
	CALL	LAB_F498		; copy block to memory page (LAB_FEFE)
					; reset afterwards (LAB_39B5)
	RET				;

; copy 10h bytes from (DE) to LAB_FE83 page (LAB_FEFE)

LAB_3241
	LD	HL,LAB_FE83		; set destination
	CALL	LAB_324F		; copy 10h bytes from (DE) to (HL) page (LAB_FEFE)
	RET				;

; copy 10h bytes from (DE) to LAB_FE93 page (LAB_FEFE)

LAB_3248
	LD	HL,LAB_FE93		; set destination
	CALL	LAB_324F		; copy 10h bytes from (DE) to (HL) page (LAB_FEFE)
	RET				;

; copy 10h bytes from (DE) to (HL) page (LAB_FEFE)

LAB_324F
	LD	BC,0010h		; 10h bytes to copy
	EX	DE,HL			; swap source & dest
	CALL	LAB_F498		; copy block to memory page (LAB_FEFE)
					; reset afterwards (LAB_39B5)
	RET				;

LAB_3257				; block copied to LAB_FE93
	DB	00h,7Fh,73h,72h,00h,00h,00h,00h
	DB	00h,00h,00h,00h,00h,00h,00h,00h

LAB_3267				; block copied to LAB_FE83
	DB	80h,ABh,63h,43h,80h,2Bh,63h,43h
	DB	80h,67h,63h,43h,80h,67h,63h,43h

; block out to IR port ??

LAB_3277
	LD	C,A			; copy ??
	AND	#20h			; mask 00x0 0000
	CALL	LAB_3454		; do : mask 2Ch X xx0x
					; Z=0: mask 4A X xx0x, mask 2Ch X xx00, mask 2Ch xx0x X
					; Z=1: set  4A X xx1x, mask 2Ch X xx00, set  2Ch xx1x X
	CALL	LAB_34D2		; get Port_4A buffer, AND with 3Fh & OUT (Port_4A)
	LD	A,(LAB_F794)	; get Port_4A buffer
	AND	#FEh			; mask xxxx xxx0
	LD	(LAB_F794),A	; save Port_4A buffer
	OUT	(Port_4A),A		; out to Port_4A
	LD	A,(LAB_F794)	; get Port_4A buffer
	OR	#01h			; set  xxxx xxx1
	LD	(LAB_F794),A	; save Port_4A buffer
	OUT	(Port_4A),A		; out to Port_4A
	LD	A,(LAB_F794)	; get Port_4A buffer
	AND	#EFh			; mask xxx0 xxxx
	LD	(LAB_F794),A	; save Port_4A buffer
	OUT	(Port_4A),A		; out to Port_4A
	PUSH	BC			; save BC
	LD	B,#80h		; short delay
LAB_32A1
	DJNZ	LAB_32A1		; loop a while

	POP	BC			; restore BC
	CALL	LAB_34EC		; wait for end IR port TX ready or timeout
					; set end IR port o/p if detected ??
	JP	Z,LAB_335A		; timeout so error EBh exit

	CALL	LAB_34F8		; wait for end IR port TX ready or timeout
	JP	Z,LAB_335A		; if timeout do error EBh exit

	LD	A,C		;32B0:	79
	AND	#1Fh		;32B1:	E61F
	LD	(LAB_F797),A	;32B3:	3297F7
	OUT	(Port_4D),A		;32B6:	D34D
	LD	DE,026Ch		; set timeout count
LAB_32BB
	IN	A,(Port_4B)		; get IR port input status byte
	LD	B,A			; copy it
	CPL				; complement it
	AND	#10h			; mask 000x 0000
	JR	NZ,LAB_32C8		; jump if bit=1

	DEC	DE			; else decrement timeout count
	LD	A,D			; copy high byte
	OR	E			; OR low byte
	JR	NZ,LAB_32BB		; loop if not timed out

					; bit=1 or timeout
LAB_32C8
	LD	A,B			; get status byte back
	JP	Z,LAB_335A		; error EBh exit if count=0

	LD	A,(LAB_F794)	; get Port_4A buffer
	OR	#20h			; set xx1x xxxx
	LD	(LAB_F794),A	; save Port_4A buffer
	OUT	(Port_4A),A		; out to Port_4A
	LD	A,(LAB_F794)	; get Port_4A buffer
	OR	#10h			; set xxx1 xxxx
	LD	(LAB_F794),A	; save Port_4A buffer
	OUT	(Port_4A),A		; out to Port_4A
	PUSH	BC			; save BC
	LD	B,#20h		; short delay count
LAB_32E3
	DJNZ	LAB_32E3		; loop a while

	POP	BC			; restore BC
	LD	A,(LAB_F794)	; get Port_4A buffer
	AND	#DFh			; mask xx0x xxxx
	LD	(LAB_F794),A	; save Port_4A buffer
	OUT	(Port_4A),A		; out to Port_4A
	LD	DE,026Ch		; set timeout count
LAB_32F3
	IN	A,(Port_4B)		; get IR port input status byte
	LD	B,A			; copy it
	CPL				; complement it
	AND	#40h			; mask 0x00 0000
	JR	NZ,LAB_3300		; jump if bit=1

	DEC	DE			; decrement timeout count
	LD	A,D			; copy high byte
	OR	E			; OR low byte
	JR	NZ,LAB_32F3		; loop if not timed out

					; bit=1 or timeout
LAB_3300
	LD	A,B			; restore status byte
	JR	Z,LAB_3356		; error EEh exit if timed out

	PUSH	BC			; save BC (don't need this!)
	LD	B,#02h		; short wait
LAB_3306
	DJNZ	LAB_3306		; loop for a while

	POP	BC			; restore BC (don't need this!)
LAB_3309
	CALL	LAB_3508		; get BC and DE from HL++++
	JR	Z,LAB_332E		; jump if BC was=0

	INC	B			; correct count for loop end
	PUSH	HL		;330F:	E5
	EX	DE,HL		;3310:	EB
LAB_3311
	PUSH	BC			; save count to do
	LD	B,C			; B = count low byte (00 = 256)
	LD	C,#Port_4D		; set port 4Dh
	LD	DE,06F9h		; set timeout count
LAB_3318
	IN	A,(Port_4B)		; get IR port input status byte
	RLCA				; top bit into carry
	JR	NC,LAB_334E		; jump if bit was 0 (TX not ready)

	OUTI				; else byte out to port, increment pointer, decrement count
	LD	DE,06F9h		; set timeout count
	JP	NZ,LAB_3318		; loop if B<>0

	POP	BC			; restore BC
	LD	C,#00h		; clear C
	DJNZ	LAB_3311		; loop if B<>0

	POP	HL		;332A:	E1
	JP	LAB_3309	;332B:	C30933

LAB_332E
	CALL	LAB_34EC		; wait for end IR port TX ready or timeout
					; set end IR port o/p if detected ??
	JR	Z,LAB_3356		; error EEh exit if timeout

	LD	DE,026Ch		; set timeout count
LAB_3336
	IN	A,(Port_4B)		; get IR port status byte
	LD	B,A			; copy byte
	CPL				; invert bitwise
	AND	#40h			; mask 0x00 0000
	JR	NZ,LAB_3343		; jump if bit set

	DEC	DE			; decrement timeout count
	LD	A,D			; copy high byte
	OR	E			; OR low byte
	JR	NZ,LAB_3336		; loop if not timed out

					; bit=1 or timeout
LAB_3343
	LD	A,B			; get byte back
	JR	Z,LAB_3356		; error EEh exit timeout

	AND	#20h			; mask 00x0 0000
	JR	NZ,LAB_335E		; error ECh exit if bit set

	XOR	A			; clear A
	JP	LAB_3361		; ok. exit

LAB_334E
	DEC	DE			; decrement timeout count
	LD	A,D			; copy high byte
	OR	E			; OR low byte
	JP	NZ,LAB_3318		; loop if not timed out

	POP	HL		; dump BC
	POP	HL		; restore HL ??
LAB_3356
	LD	A,#EEh		; set error EEh
	JR	LAB_3360		; set error flag & exit

LAB_335A
	LD	A,#EBh		; set error EBh
	JR	LAB_3360		; set error flag & exit

LAB_335E
	LD	A,#ECh		; set error ECh 'Peripheral Failure'
LAB_3360
	SCF				; flag error
LAB_3361
	PUSH	AF			; save exit code
	LD	A,(LAB_F794)	; get Port_4A buffer
	AND	#EFh			; mask xxx0 xxxx
	LD	(LAB_F794),A	; save Port_4A buffer
	OUT	(Port_4A),A		; out to Port_4A
	LD	A,(LAB_F794)	; get Port_4A buffer
	AND	#FEh			; mask xxxx xxx0
	LD	(LAB_F794),A	; save Port_4A buffer
	OUT	(Port_4A),A		; out to Port_4A
	POP	AF			; restore exit code
	RET				;

; receive block from IR port

LAB_3378
	LD	A,(LAB_F794)	; get Port_4A buffer
	AND	#FEh			; mask xxxx xxx0
	LD	(LAB_F794),A	; save Port_4A buffer
	OUT	(Port_4A),A		; out to Port_4A
	LD	A,(LAB_F794)	; get Port_4A buffer
	OR	#20h			; set xx1x xxxx
	LD	(LAB_F794),A	; save Port_4A buffer
	OUT	(Port_4A),A		; out to Port_4A
	IN	A,(Port_4E)		; clear IR receive byte
	LD	A,(LAB_F794)	; get Port_4A buffer
	OR	#10h			; set xxx1 xxxx
	LD	(LAB_F794),A	; save Port_4A buffer
	OUT	(Port_4A),A		; out to Port_4A
	PUSH	BC			; save BC
	LD	B,#20h		; count for short delay
LAB_339B
	DJNZ	LAB_339B		; loop for a while

	POP	BC			; restore BC
	LD	A,(LAB_F794)	; get Port_4A buffer
	AND	#DFh			; mask xx0x xxxx
	LD	(LAB_F794),A	; save Port_4A buffer
	OUT	(Port_4A),A		; out to Port_4A
	LD	IX,0000h		; clear index count
LAB_33AC
	CALL	LAB_3508		; get BC (count) and DE (pointer) from HL++++
	JR	Z,LAB_3414		; error EDh exit if BC (count) was=0

	PUSH	HL			; save table pointer
	EX	DE,HL			; swap buffer pointer to HL
	ADD	IX,BC			; make IX = count
	XOR	A			; clear A
	OR	C			; set flags on count low byte (A=count low byte)
	JR	Z,LAB_33BE		; jump if was zero

	LD	C,#00h		; clear count low byte
	JP	LAB_33C8		;

LAB_33BE
	XOR	A			; clear A
	OR	B			; set flags on count high byte
	JR	NZ,LAB_33C6		; jump if not zero

	POP	HL			; else get table pointer back
	JP	LAB_33AC		; go do next table entry

LAB_33C6
	DEC	B			; decrement count high byte
	XOR	A			; clear A (set for 256 byte count)
LAB_33C8
	PUSH	BC			; save count
	LD	B,A			; copy this loop count to B
	LD	DE,06F9h		; set timeout count
	LD	C,#Port_4E		; point to IR receive byte

					; receive IR byte loop ??
LAB_33CF
	IN	A,(Port_4B)		; get IR port input status byte
	RRCA				; lsb into carry
	JR	NC,LAB_33E0		; jump if bit not set (idle or end ??)

	INI				; get byte from port, increment pointer & decrement count
	LD	DE,06F9h		; set timeout count
	JP	NZ,LAB_33CF		; loop if not all done

	POP	BC			; restore count
	JP	LAB_33BE		; loop

LAB_33E0
	RRCA				; bit 1 into carry
	JR	C,LAB_33F0		; jump if set

					; gets here if IR port idle ??

	DEC	DE			; decrement timeout count
	LD	A,D			; copy high byte
	OR	E			; OR low byte
	JP	NZ,LAB_33CF		; loop if not timed out

					; gets here if timeout happened

	POP	BC			; dump count
	POP	HL			; dump table pointer
	LD	A,#EEh		; error EEh
	JP	LAB_341E		; flag error & exit

LAB_33F0
	RRCA				; bit 2 into carry
	JR	NC,LAB_33F7		; jump if nothing to get

	PUSH	AF			; save flags
	INI				; get byte from port, increment pointer & decrement count
	POP	AF			; restore flags
LAB_33F7
	RRCA				; bit 3 into carry
	POP	HL			; get remaining count
	POP	DE			; get table pointer
	JR	C,LAB_341C		; error ECh exit if ?? bit set

	LD	C,B			; copy remeining bytes for this loop
	LD	B,#00h		; clear high byte
	ADD	HL,BC			; add to remaining count
	EX	DE,HL			; swap remaining to DE
	PUSH	IX			; copy expected ..
	POP	HL			; .. count to HL
	XOR	A			; set flags for SBC
	SBC	HL,DE			; subtract remaining from expected
	XOR	A			; clear flags for SBC
	LD	BC,0002h		; another 2 bytes ????
	SBC	HL,BC			; subtract from expected
	JR	C,LAB_341C		; if -ve result error ECh exit

	EX	DE,HL			; DE = received-2, HL = remaining count
	AND	A			; clear carry (A is zero here)
	JP	LAB_341F		; no error exit

LAB_3414
	LD	A,#EDh		; set error EDh 'Peripheral Failure'
	JR	LAB_341E		; flag error & finish

LAB_3418
	LD	A,#EEh		; set error EEh 'Peripheral Failure'
	JR	LAB_341E		; flag error & finish

LAB_341C
	LD	A,#ECh		; set error ECh 'Peripheral Failure'
LAB_341E
	SCF				; flag error
LAB_341F
	PUSH	AF			; save exit (error) code
	LD	A,(LAB_F794)	; get Port_4A buffer
	XOR	#02h			; toggle xxxx xxBx
	LD	(LAB_F794),A	; save Port_4A buffer
	OUT	(Port_4A),A		; out to Port_4A
	LD	A,(LAB_F794)	; get Port_4A buffer
	OR	#01h			; set xxxx xxx1
	LD	(LAB_F794),A	; save Port_4A buffer
	OUT	(Port_4A),A		; out to Port_4A
	LD	A,(LAB_F794)	; get Port_4A buffer
	AND	#FEh			; mask xxxx xxx0
	LD	(LAB_F794),A	; save Port_4A buffer
	OUT	(Port_4A),A		; out to Port_4A
	LD	A,(LAB_F794)	; get Port_4A buffer
	AND	#EFh			; mask xxx0 xxxx
	LD	(LAB_F794),A	; save Port_4A buffer
	OUT	(Port_4A),A		; out to Port_4A
	LD	A,(LAB_F794)	; get Port_4A buffer
	XOR	#02h			; toggle xxxx xxBx
	LD	(LAB_F794),A	; save Port_4A buffer
	OUT	(Port_4A),A		; out to Port_4A
	POP	AF			; restore exit (error) code
	RET				;

; mask 2Ch xxxx xx0x
; Z=0: mask 4A X xx0x, mask 2Ch X xx00, mask 2Ch xx0x X
; Z=1: set  4A X xx1x, mask 2Ch X xx00, set  2Ch xx1x X

LAB_3454
	PUSH	AF			; save AF
	LD	A,(LAB_F78B)	; get Port_2A buffer
	AND	#FDh			; mask xxxx xx0x
	LD	(LAB_F78B),A	; save Port_2A buffer
	OUT	(Port_2A),A		; out to Port_2A
	POP	AF			; restore AF
	JR	Z,LAB_3473		; jump if mask 00x0 0000 was = 0

	LD	A,(LAB_F794)	; get Port_4A buffer
	AND	#FDh			; mask xxxx xx0x
	LD	(LAB_F794),A	; save Port_4A buffer
	OUT	(Port_4A),A		; out to Port_4A
	LD	A,(LAB_F78D)	; get Port_2C buffer
	AND	#DCh			; mask xx0x xx00 V24_ADAPTER IR port data/clock = 0
	JR	LAB_3484		; save buffer, out to port & RET

LAB_3473
	LD	A,(LAB_F794)	; get Port_4A buffer
	OR	#02h			; set xxxx xx1x
	LD	(LAB_F794),A	; save Port_4A buffer
	OUT	(Port_4A),A		; out to Port_4A
	LD	A,(LAB_F78D)	; get Port_2C buffer
	AND	#FCh			; mask xxxx xx00
	OR	#20h			; set  xx1x xxxx
LAB_3484
	LD	(LAB_F78D),A	; save Port_2C buffer
	OUT	(Port_2C),A		; out to Port_2C
	RET				;

; setup ports 4F,4A & 2C (and buffers)

LAB_348A
	LD	A,#7Fh	;348A:	3E7F
	AND	#1Fh			; mask 000x xxxx
	LD	(LAB_F799),A	; save Port_4F buffer
	OUT	(Port_4F),A		; out to Port_4F
	LD	A,(LAB_F794)	; get Port_4A buffer
	AND	#DFh			; mask xx0x xxxx
	LD	(LAB_F794),A	; save Port_4A buffer
	OUT	(Port_4A),A		; out to Port_4A
	LD	A,(LAB_F794)	; get Port_4A buffer
	OR	#01h			; set xxxx xxx1
	LD	(LAB_F794),A	; save Port_4A buffer
	OUT	(Port_4A),A		; out to Port_4A
	LD	A,(LAB_F794)	; get Port_4A buffer
	AND	#FEh			; mask xxxx xxx0
	LD	(LAB_F794),A	; save Port_4A buffer
	OUT	(Port_4A),A		; out to Port_4A
	XOR	A			; clear A
	LD	(LAB_F78D),A	; clear Port_2C buffer
	OUT	(Port_2C),A		; out to Port_2C
	CALL	LAB_34D2		; get Port_4A buffer, AND with 3Fh & OUT (Port_4A)
	IN	A,(Port_4B)		; get IR port input status byte
	RET				;

; get LAB_F794, OR with C0h & OUT (Port_4A)

LAB_34BD
	LD	A,(LAB_F794)	; get Port_4A buffer
	OR	#40h			; set x1xx xxxx
	LD	(LAB_F794),A	; save Port_4A buffer
	OUT	(Port_4A),A		; out to Port_4A
	LD	A,(LAB_F794)	; get Port_4A buffer
	OR	#80h			; set 1xxx xxxx
	LD	(LAB_F794),A	; save Port_4A buffer
	OUT	(Port_4A),A		; out to Port_4A
	RET				;

; get LAB_F794, AND with 3Fh & OUT (Port_4A)

LAB_34D2
	LD	A,(LAB_F794)	; get Port_4A buffer
	AND	#BFh			; mask x0xx xxxx
	LD	(LAB_F794),A	; save Port_4A buffer
	OUT	(Port_4A),A		; out to Port_4A
	LD	A,(LAB_F794)	; get Port_4A buffer
	AND	#7Fh			; mask 0xxx xxxx
	LD	(LAB_F794),A	; save Port_4A buffer
	OUT	(Port_4A),A		; out to Port_4A
	RET				;

; get IR port input status byte and mask bit 4

LAB_34E7
	IN	A,(Port_4B)		; get IR port input status byte
	AND	#10h			; mask 000x 0000
	RET				;

; wait for end IR port TX ready or timeout
; set end IR port o/p if detected ??

LAB_34EC
	CALL	LAB_34F8		; wait for end IR port TX ready or timeout
	RET	Z			; return if timed out

	LD	A,#81h		; set ack byte ??
	LD	(LAB_F796),A	; copy to buffer (never used)
	OUT	(Port_4C),A		; out to port
	RET				;

; wait for end IR port TX ready or timeout

LAB_34F8
	LD	DE,02DAh		; set timeout count
LAB_34FB
	IN	A,(Port_4B)		; get IR port input status byte
	AND	#80h			; mask top bit (TX ready)
	JR	NZ,LAB_3507		; exit if =1 (could RET  NZ , 1 byte less)

	DEC	DE			; else decrement count
	LD	A,D			; get count high
	OR	E			; or count low
	JP	NZ,LAB_34FB		; loop until timeout

LAB_3507
	RET				;

; get BC and DE from HL++++

LAB_3508
	LD	C,(HL)		; get count low byte
	INC	HL			; increment pointer
	LD	B,(HL)		; get count high byte
	INC	HL			; increment pointer
	LD	E,(HL)		; get pointer low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get pointer high byte
	INC	HL			; increment pointer
	LD	A,B			; copy count high byte
	OR	C			; OR with count low byte (Z=(count=0))
	RET				;

; error # 36h return address ??
; just does XOR A

LAB_3513
	XOR	A			; clear A
	RET				;

; chr out and buffer check ??

LAB_3515
	PUSH	HL			; save HL
	PUSH	BC			; save BC
	PUSH	DE			; save DE
	AND	#7Fh			; mask out top bit of chr
	PUSH	AF			; save chr
	LD	A,(LAB_FEA4)	;351B:	3AA4FE
	CP	#FFh		;351E:	FEFF
	JP	Z,LAB_352A	;3520:	CA2A35
	POP	AF			; restore chr
	CALL	LAB_354C		; does CALL display_2 chr ???
	JP	LAB_352E	;3527:	C32E35

LAB_352A
	POP	AF			; restore A
	CALL	LAB_3559		; does CALL display_2 chr ??? & bell
LAB_352E
	POP	DE			; restore DE
	POP	BC			; restore BC
	POP	HL			; restore HL
	LD	A,(LAB_FEA3)	;3531:	3AA3FE
	INC	A		;3534:	3C
	LD	(LAB_FEA3),A	;3535:	32A3FE
	RET				;

; get key

LAB_3539
	LD	A,(LAB_FEA4)	;3539:	3AA4FE
	CP	#FFh		;353C:	FEFF
	JP	Z,LAB_3547	;353E:	CA4735
	CALL	LAB_3550		; get key from buffer and set flags
	JP	LAB_354A		; set flags & RET

LAB_3547
	CALL	LAB_3555		; does CALL LAB_3550 get key from buffer ?? and set flags
LAB_354A
	AND	A			; set the flags
	RET				;

; does CALL display_2 chr ???

LAB_354C
	CALL	LAB_1BEB		; display_2 chr ???
	RET				;

; get key from buffer and set flags

LAB_3550
	CALL	LAB_18C0		; get key from buffer, returns Z=true if no key
	OR	A			; set the flags (done by routine)
	RET				;

; does CALL LAB_3550	get key from buffer and set flags

LAB_3555
	CALL	LAB_3550		; get key from buffer and set flags
	RET				;

; does CALL display_2 chr ??? & bell

LAB_3559
	CALL	LAB_354C		; does CALL display_2 chr ???
	LD	A,#07h		; bell chr ??
	CALL	LAB_354C		; does CALL display_2 chr ???
	RET				;

; do (LAB_FBC8) tone for (LAB_FBC7)*6 ticks

LAB_3562
	CALL	LAB_35C3		; set tone from (LAB_FBC8)
	LD	A,(LAB_FBC7)	; get beep duration
	LD	B,A			; copy it
	ADD	A,A			; *2
	ADD	A,B			; *3
	ADD	A,A			; *6
	LD	(LAB_FEA5),A	; save count low byte
	XOR	A			; clear A
	LD	(LAB_FEA6),A	; clear count high byte
	LD	DE,LAB_FEA5		; set count pointer
	LD	HL,LAB_357D		; set vector (tone off)
	CALL	LAB_2189		; save DE & HL in RTC interrupt table
					; return carry set if not saved
	RET				;

; RTC timebase vector

; calls tone off

LAB_357D
	CALL	LAB_35C9		; tone off
	RET				;

; setup chain to double beep (using RTC)

; mid tone to Port_2B & set countdown for silence

LAB_3581
	LD	A,#08h		; set tone
	LD	(LAB_FBC8),A	; save beep tone
	CALL	LAB_35C3		; set tone from (LAB_FBC8)
	LD	HL,0006h		; set count (1/10th sec)
	LD	(LAB_FEA5),HL	; save count
	LD	HL,LAB_3599		; set vector
	LD	DE,LAB_FEA5		; set count pointer
	CALL	LAB_2189		; save DE & HL in RTC interrupt table
					; return carry set if not saved
	RET				;

; RTC timebase vector

; short silence & set countdown for next byte

LAB_3599
	CALL	LAB_35C9		; tone off
	LD	HL,0006h		; set count (1/10th sec)
	LD	(LAB_FEA5),HL	; save count
	LD	HL,LAB_35AC		; set vector
	LD	DE,LAB_FEA5		; set count pointer
	CALL	LAB_2189		; save DE & HL in RTC interrupt table
					; return carry set if not saved
	RET				;

; RTC timebase vector

; beep & set countdown for next byte

LAB_35AC
	CALL	LAB_35C3		; set tone from (LAB_FBC8)
	LD	HL,0006h		; set count (1/10th sec)
	LD	(LAB_FEA5),HL	; save count
	LD	HL,LAB_35BF		; set vector (calls tone off)
	LD	DE,LAB_FEA5		; set count pointer
	CALL	LAB_2189		; save DE & HL in RTC interrupt table
					; return carry set if not saved
	RET				;

; RTC timebase vector

; calls tone off

LAB_35BF
	CALL	LAB_35C9		; tone off
	RET				;

; set tone from (LAB_FBC8)

LAB_35C3
	LD	A,(LAB_FBC8)	; get beep tone
	OUT	(Port_2B),A		; out to port
	RET				;

; tone off

LAB_35C9
	LD	A,#00h		; clear A
	OUT	(Port_2B),A		; out to Port_2B
	RET				;

; delay of A*????

LAB_35CE
	PUSH	BC			; save BC
LAB_35CF
	LD	B,#DEh		; set unti delay count
LAB_35D1
	DEC	B			; decrement count
	NOP				; pad byte
	JP	NZ,LAB_35D1		; loop if not done
	DEC	A			; decrement multiplier
	JP	NZ,LAB_35CF		; loop if not all done
	POP	BC			; restore BC
	RET				;

; delay of 100d*A*????

LAB_35DC
	PUSH	AF			; save A
	LD	A,#64h		; 64h (100d) units of delay
	CALL	LAB_35CE		; delay of A*????
	POP	AF			; restore A
	DEC	A			; decrement count
	JP	NZ,LAB_35DC		; loop if not all done
	RET				;

; this block is copied to F180h before use
; test ram at page A, address HL, length ((D*256)-HL) Z flag set if OK

LAB_35E8
	OUT	(MEM_P),A		; set page #
	PUSH	HL			; save start address
LAB_35EB
	LD	A,H			; get address high byte
	CP	D			; compare with end address high byte
	JR	Z,LAB_35F5		; exit loop if done

	LD	(HL),B		; save test pattern high
	INC	HL			; next byte
	LD	(HL),C		; save test pattern low
	INC	HL			; next byte
	JR	LAB_35EB		; loop until done

LAB_35F5
	POP	HL			; restore start address
LAB_35F6
	LD	A,H			; get address high byte
	CP	D			; compare with end address high byte
	JR	Z,LAB_3606		; exit loop if done

	LD	A,(HL)		; get byte from memory
	CP	B			; compare with test pattern high
	JR	NZ,LAB_3606		; exit if different
	INC	HL			; next byte
	LD	A,(HL)		; get byte from memory
	CP	C			; compare with test pattern low
	JR	NZ,LAB_3606		; exit if different
	INC	HL			; next byte
	JR	LAB_35F6		; loop

LAB_3606
	LD	A,#00h		; reset page
	OUT	(MEM_P),A		; reset memory page
	RET				;

; test ram at page A, address HL, length ((D*256)-HL) Z flag set if OK

LAB_360B
	OUT	(MEM_P),A		; set memory page
	PUSH	HL			; save start address
LAB_360E
	LD	A,H			; get address high byte
	CP	D			; compare with end address high byte
	JR	Z,LAB_3618		; exit loop if done

	LD	(HL),H		; save test pattern byte
	INC	HL			; next byte
	LD	(HL),L		; save test pattern byte
	INC	HL			; next byte
	JR	LAB_360E		; loop
LAB_3618
	POP	HL			; restore start address
LAB_3619
	LD	A,H			; get address high byte
	CP	D			; compare with end address high byte
	JR	Z,LAB_3629		; exit loop if done
	LD	A,(HL)		; get byte from memory
	CP	H			; compare with test byte
	JR	NZ,LAB_3629		; exit if different
	INC	HL			; next byte
	LD	A,(HL)		; get byte from memory
	CP	L			; compare with test byte
	JR	NZ,LAB_3629		; exit if different
	INC	HL			; next byte
	JR	LAB_3619		; loop
LAB_3629
	LD	A,#00h		; reset page
	OUT	(MEM_P),A		; reset memory page
	RET				;

; test ram at page A, address HL, length ((D*256)-HL) Z flag set if OK

LAB_362E
	OUT	(MEM_P),A		; set memory page
	PUSH	HL			; save start address
LAB_3631
	LD	A,H			; get address high byte
	CP	D			; compare with end address high byte
	JR	Z,LAB_363F		; exit loop if done
	LD	A,H			; copy H
	CPL				; complement it
	LD	(HL),A		; save test pattern byte
	INC	HL			; next byte
	LD	A,L			; copy L
	CPL				; complement it
	LD	(HL),A		; save test pattern byte
	INC	HL			; next byte
	JR	LAB_3631		; loop
LAB_363F
	POP	HL			; restore start address
LAB_3640
	LD	A,H			; get address high byte
	CP	D			; compare with end address high byte
	JR	Z,LAB_3652		; exit loop if done
	LD	A,(HL)		; get byte from memory
	CPL				; complement it
	CP	H			; compare with test byte
	JR	NZ,LAB_3652		; exit if different
	INC	HL			; next byte
	LD	A,(HL)		; get byte from memory
	CPL				; complement it
	CP	L			; compare with test byte
	JR	NZ,LAB_3652		; exit if different
	INC	HL			; next byte
	JR	LAB_3640		; loop
LAB_3652
	LD	A,#00h		; reset page
	OUT	(MEM_P),A		; reset memory page
	RET				;

; get byte A from (HL) on page C

LAB_3657				; (LAB_F1EF)
	PUSH	BC			; save BC
	LD	A,C			; get page #
	OUT	(MEM_P),A		; set memory page
	LD	B,(HL)		; get byte
	LD	A,#00h		; reset page
	OUT	(MEM_P),A		; reset memory page
	LD	A,B			; copy byte
	POP	BC			; restore BC
	RET				;

; save byte A at (HL) on page C

LAB_3663				; (LAB_F1FB)
	PUSH	AF			; save A
	LD	A,C			; get page #
	OUT	(MEM_P),A		; set memory page
	POP	AF			; restore A
	LD	(HL),A		; save byte
	LD	A,#00h		; reset page
	OUT	(MEM_P),A		; reset memory page
	RET				;

; do ROM checksum. page # in A

LAB_366E				; (LAB_F206)
	OUT	(MEM_P),A		; set memory page
	LD	HL,0000h		; clear checksum
	LD	DE,0000h		; clear byte
	LD	BC,0000h		; clear pointer
LAB_3679
	LD	A,(BC)		; get byte
	LD	E,A			; copy to DE (D=00h)
	ADD	HL,DE			; add to checksum
	INC	BC			; point to next byte
	LD	A,B			; get pointer high byte
	CP	#80h			; high byte = end ?
	JR	NZ,LAB_3679		; loop if not

	PUSH	HL			; save checksum
	LD	BC,7FFEh		; point to checksum in ROM
	LD	A,(BC)		; get checksum low byte
	CP	L			; compare with calculated checksum low byte
	JR	NZ,LAB_3693		; jump if not equal

	INC	BC			; point to checksum high byte
	LD	A,(BC)		; get checksum high byte
	CP	H			; compare with calculated checksum high byte
	JR	NZ,LAB_3693		; jump if not equal

	LD	A,#00h		; else clear error code
	JR	LAB_3695		; jump

LAB_3693
	LD	A,#FFh		; set error code
LAB_3695
	PUSH	AF			; save it
	LD	A,#00h		; clear A (could XOR A!)
	OUT	(MEM_P),A		; reset memory page
	POP	AF			; restore error code
	POP	DE			; restore checksum
	RET				;

; block 369Dh - 3BA9h copied to F180h - F68Ch
; BDOS function calls
;
; C = function #
; DE = parameter

LAB_369D				; (LAB_F180)
	NOP				;
	NOP				;
	NOP				;
	LD	(LAB_FEF9),A	;
	LD	A,#FFh		; set error type
	LD	(LAB_FEFD),A	; set 'Bdos' error
	LD	A,C			; get function number
	LD	(LAB_FEFC),A	; set function number
	LD	B,#00h		; clear error high byte
	LD	A,C			; get function number (again, not needed)
	CP	#25h			; comapre with 25h
	JR	C,LAB_36E2		; branch if function # < 25h

	CP	#F3h			; comapre with F3h
	JR	NC,LAB_36E1		; branch if function # >= F3h

	CP	#2Dh			; comapre with 2Dh
	LD	HL,LAB_F55A		; set return address (LAB_3A77)
	JR	Z,LAB_36EB		; branch if error # = 2Dh

	CP	#2Eh			; comapre with 2Eh
	LD	HL,LAB_0D79		; set return address
	JR	Z,LAB_36EB		; branch if error # = 2Eh

	CP	#30h			; comapre with 30h
	LD	HL,LAB_1893		; set return address (RST 28h error handling)
	JR	Z,LAB_36EB		; branch if error # = 30h

	CP	#62h			; comapre with 62h
	LD	HL,LAB_0742		; set return address
	JR	Z,LAB_36EB		; branch if error # = 62h

	CP	#68h			; comapre with 68h
	LD	HL,LAB_115E		; set return address (just does RET)
LAB_36D8
	JR	Z,LAB_36EB		; branch if error # = 68h
LAB_36DA
	CP	#69h			; comapre with 69h
	LD	HL,LAB_115E		; set return address (just does RET)
	JR	Z,LAB_36EB		; branch if error # = 69h

					; function # (>=F3h)+(>24h & <>2Dh & <>2Eh & <>30h
					; & <>62h & <>68h & <>69h)
LAB_36E1
	DEC	B			; B=FFh

					; function  # <25h
LAB_36E2
	LD	HL,LAB_F1EB		; set pointer to table (LAB_3708)
	ADD	HL,BC			; add function #
	ADD	HL,BC			; add function #
	LD	A,(HL)		; get function address low byte
	INC	HL			; increment pointer
	LD	H,(HL)		; get function address high byte
LAB_36EA
	LD	L,A			; copy function address low byte
LAB_36EB
	JP	LAB_F382		; go do error routine (LAB_389F)

LAB_36EE				; (LAB_F1D1)
	DW	LAB_1FDF		; #F3h	just does RET
	DW	LAB_1893		; #F4h	RST 28h error handling
	DW	LAB_1877		; #F5h
	DW	LAB_15A0		; #F6h	get A from (LAB_FBC5)
	DW	LAB_15A4		; #F7h	save E to (0003h) in pages 40h-00h & LAB_FBC5
	DW	LAB_3237		; #F8h	copy 10h bytes from LAB_FE83 to (DE)
					;		page (LAB_FEFE)
	DW	LAB_15CB		; #F9h	set beep #E from table @ LAB_15E0
	DW	LAB_3241		; #FAh	copy 10h bytes from (DE) to LAB_FE83
					;		page (LAB_FEFE)
	DW	LAB_3248		; #FBh	copy 10h bytes from (DE) to LAB_FE93
					;		page (LAB_FEFE)
	DW	LAB_1150		; #FCh	copy block from (DE) & setup RTC
	DW	LAB_113E		; #FDh	read RTC & copy time/date to (DE)
	DW	LAB_1122		; #FEh	set restart count to 16*E
	DW	LAB_112D		; #FFh	set alarm if DE<>0
LAB_3708				; (LAB_F1EB)
	DW	LAB_024D		; #00h	warm start, without RAM test	
	DW	LAB_0DE9		; #01h	[console input		]
	DW	LAB_0F36		; #02h	[console output		]
	DW	LAB_1080		; #03h	[reader input		]
	DW	LAB_10D2		; #04h	[puncher output		]
	DW	LAB_1015		; #05h	[lister output		]
	DW	LAB_0FD6		; #06h	[direct console I/O	]
	DW	LAB_10FD		; #07h	just does RET [get I/O byte]
	DW	LAB_10FD		; #08h	just does RET [set I/O byte]
	DW	LAB_11FB		; #09h	display '$' terminated string from (DE)
					;		page (LAB_FEFE), return '$' address in HL
					;		[print string		]
	DW	LAB_117B		; #0Ah	[read console buffer	]
	DW	LAB_0FC5		; #0Bh	get key if (LAB_FBC9 AND 2=0, else get FFh
					;		[get console status	]
	DW	LAB_15C7		; #0Ch	set HL = 0023h  [get version number	]
					;		[v2.3!]
	DW	LAB_1893		; #0Dh	RST 28h error handling [reset disk	]
	DW	LAB_15B3		; #0Eh	[select disk		]
	DW	LAB_0877		; #0Fh	DOS function ?? [open file		]
	DW	LAB_089D		; #10h	DOS function ?? [close file		]
	DW	LAB_096C		; #11h	DOS function ?? [search first		]
	DW	LAB_09A3		; #12h	DOS function ?? [search next		]
	DW	LAB_08C0		; #13h	DOS function ?? [delete file		]
	DW	LAB_0B8F		; #14h	DOS function ?? [read sequential	]
	DW	LAB_0B09		; #15h	DOS function ?? [write sequential	]
	DW	LAB_0843		; #16h	DOS function ?? [make file		]
	DW	LAB_0910		; #17h	DOS function ?? [rename			]
	DW	LAB_1888		; #18h	set HL = FFFFh  [get login vector	]
	DW	LAB_15AF		; #19h	get A from (LAB_FBC6) [get current disk]
	DW	LAB_0CEC		; #1Ah	save DE at LAB_FFA3 [set DMA address]
	DW	LAB_188C		; #1Bh	set HL = 0000h  [allocation vector	]
	DW	LAB_1893		; #1Ch	RST 28h error handling [set to R/O disk]
	DW	LAB_188C		; #1Dh	set HL = 0000h  [get R/O vector	]
	DW	LAB_1893		; #1Eh	RST 28h error handling [set attribute]
	DW	LAB_1893		; #1Fh	RST 28h error handling [get DPA	]
	DW	LAB_1890		; #20h	set A = 00h  ?? [set user code	]
	DW	LAB_0C50		; #21h	DOS function ?? [read random		]
	DW	LAB_0BF3		; #22h	DOS function ?? [write random		]
	DW	LAB_0CF1		; #23h	DOS function ?? [compute file size	]
	DW	LAB_0CB4		; #24h	DOS function ?? [ get curr record #	]

; BIOS function jump table

LAB_3752				; (LAB_F235)
	JP	LAB_F2C4		; [BOOT]	BIOS function - cold boot	(LAB_37E1)
LAB_3755				; (LAB_F238)
	JP	LAB_F2DE		; [WBOOT]	BIOS function - warm boot	(LAB_37FB)
LAB_3758				; (LAB_F23B)
	JP	LAB_F2F8		; [CONST]	3758:	C3F8F2 (LAB_3815) error # 03h
LAB_375B				; (LAB_F23E)
	JP	LAB_F303		; [CONIN]	BIOS function - console in	(LAB_3820)
LAB_375E				; (LAB_F241)
	JP	LAB_F30E		; [CONOUT]	375E:	C30EF3 (LAB_382B) error # 09h
LAB_3761				; (LAB_F244)
	JP	LAB_F280		; [LIST]	3761:	C380F2 (LAB_379D) error # 0Ch
LAB_3764				; (LAB_F247)
	JP	LAB_F285		; [PUNCH]	3764:	C385F2 (LAB_37A2) error # 0Fh
LAB_3767				; (LAB_F24A)
	JP	LAB_F28A		; [READER]	3767:	C38AF2 (LAB_37A7) error # 12h
LAB_376A				; (LAB_F24D)
	JP	LAB_F28F		; [HOME]	376A:	C38FF2 (LAB_37AC) error # 15h
LAB_376D				; (LAB_F250)
	JP	LAB_F294		; [SELDSK]	376D:	C394F2 (LAB_37B1) error # 18h
LAB_3770				; (LAB_F253)
	JP	LAB_F299		; [SETTRK]	3770:	C399F2 (LAB_37B6) error # 1Bh
LAB_3773				; (LAB_F256)
	JP	LAB_F29E		; [SETSEC]	3773:	C39EF2 (LAB_37BB) error # 1Eh
LAB_3776				; (LAB_F259)
	JP	LAB_F319		; [SETDMA]	3776:	C319F3 (LAB_3836) error # 21h
LAB_3779				; (LAB_F25C)
	JP	LAB_F2A3		; [READ]	3779:	C3A3F2 (LAB_37C0) error # 24h
LAB_377C				; (LAB_F25F)
	JP	LAB_F2A8		; [WRITE]	377C:	C3A8F2 (LAB_37C5) error # 27h
LAB_377F				; (LAB_F262)
	JP	LAB_F2AD		; [LISTST]	377F:	C3ADF2 (LAB_37CA) error # 2Ah
LAB_3782				; (LAB_F265)
	JP	LAB_F2B2		; [SECTRAN]	3782:	C3B2F2 (LAB_37CF) error # 2Dh
LAB_3785				; (LAB_F268)
	JP	LAB_F34A		; []	3785:	C34AF3 (LAB_3867) error # 30h
LAB_3788				; (LAB_F26B)
	JP	LAB_F355		; []	3788:	C355F3 (LAB_3872) error # 33h
LAB_378B				; (LAB_F26E)
	JP	LAB_F32F		; []	378B:	C32FF3 (LAB_384C) error # 36h
LAB_378E				; (LAB_F271)
	JP	LAB_F33F		; []	378E:	C33FF3 (LAB_385C) error # 39h
LAB_3791				; (LAB_F274)
	JP	LAB_F41B		; []	set memory page A & enable interrupts (LAB_3938)
LAB_3794				; (LAB_F277)
	JP	LAB_F324		; []	3794:	C324F3 (LAB_3841) error # 3Fh
LAB_3797				; (LAB_F27A)
	JP	LAB_F360		; []	3797:	C360F3 (LAB_387D) error # 42h
LAB_379A				; (LAB_F27D)
	JP	LAB_F36B		; []	379A:	C36BF3 (LAB_3888) error # 45h

LAB_379D				; (LAB_F280)
	PUSH	AF			; save A (not needed!)
	LD	A,#0Ch		; set error # 0Ch
	JR	LAB_37D4		; set error type & No. & process it

LAB_37A2				; (LAB_F285)
	PUSH	AF			; save A (not needed!)
	LD	A,#0Fh		; set error # 0Fh
	JR	LAB_37D4		; set error type & No. & process it

LAB_37A7				; (LAB_F28A)
	PUSH	AF			; save A (not needed!)
	LD	A,#12h		; set error # 12h
	JR	LAB_37D4		; set error type & No. & process it

LAB_37AC				; (LAB_F28F)
	PUSH	AF			; save A (not needed!)
	LD	A,#15h		; set error # 15h
	JR	LAB_37D4		; set error type & No. & process it

LAB_37B1				; (LAB_F294)
	PUSH	AF			; save A (not needed!)
	LD	A,#18h		; set error # 18h
	JR	LAB_37D4		; set error type & No. & process it

LAB_37B6				; (LAB_F299)
	PUSH	AF			; save A (not needed!)
	LD	A,#1Bh		; set error # 1Bh
	JR	LAB_37D4		; set error type & No. & process it

LAB_37BB				; (LAB_F29E)
	PUSH	AF			; save A (not needed!)
	LD	A,#1Eh		; set error # 1Eh
	JR	LAB_37D4		; set error type & No. & process it

LAB_37C0				; (LAB_F2A3)
	PUSH	AF			; save A (not needed!)
	LD	A,#24h		; set error # 24h
	JR	LAB_37D4		; set error type & No. & process it

LAB_37C5				; (LAB_F2A8)
	PUSH	AF			; save A (not needed!)
	LD	A,#27h		; set error # 27h
	JR	LAB_37D4		; set error type & No. & process it

LAB_37CA				; (LAB_F2AD)
	PUSH	AF			; save A (not needed!)
	LD	A,#2Ah		; set error # 2Ah
	JR	LAB_37D4		; set error type & No. & process it

LAB_37CF				; (LAB_F2B2)
	PUSH	AF			; save A (not needed!)
	LD	A,#2Dh		; set error # 2Dh
	JR	LAB_37D4		; set error type & No. & process it (not needed!)

; set error type & No. & process it

LAB_37D4
	LD	(LAB_FEFC),A	; set error number
	LD	A,#00h		; clear A (could XOR A!)
	LD	(LAB_FEFD),A	; set error type ('Bios ftn')
	POP	AF			; restore A (not needed!)
	LD	A,#FBh		; set error code
	RST	28h			; process error code, error code is in A
	RET				;

; set error # FFh, type 00h and do cold start

LAB_37E1				; (LAB_F2C4)
	LD	A,#00h		; clear A (could XOR A!)
	LD	(LAB_FEFD),A	; set error type ('Bios ftn')
	LD	A,#FFh		; error number FFh ?? (could DEC A!)
	LD	(LAB_FEFC),A	; set error number
	DI				; disable interrupts
	PUSH	AF			; save AF (??)
	LD	A,#00h		; clear A (could XOR A!)
	LD	(LAB_F791),A	; clear current memory page
	OUT	(MEM_P),A		; set memory page
	POP	AF			; restore AF (??)
	CALL	LAB_F54E		; enable interrupts if interrupts setup ?? flag <> 0
					; (LAB_3A6B)
	JP	LAB_01A6		; go do cold start

; clear error # and type and do warm start

LAB_37FB				; (LAB_F2DE)
	LD	A,#00h		; clear A (could XOR A!)
	LD	(LAB_FEFD),A	; set error type ('Bios ftn')
	LD	A,#00h		; clear A (not needed!)
	LD	(LAB_FEFC),A	; set error number
	DI				; disable interrupts
	PUSH	AF			; save AF (??)
	LD	A,#00h		; clear A (could XOR A!)
	LD	(LAB_F791),A	; clear current memory page
	OUT	(MEM_P),A		; reset memory page
	POP	AF			; restore AF (??)
	CALL	LAB_F54E		; enable interrupts if interrupts setup ?? flag <> 0
					; (LAB_3A6B)
	JP	LAB_024D		; go do warm start

; error routines
; BIOS function routines

LAB_3815				; (LAB_F2F8)
	PUSH	AF		;3815:	F5
	LD	(LAB_FEFA),HL	;3816:	22FAFE
	LD	A,#03h		; error # 03h
	LD	HL,LAB_0FC5		; set return address
	JR	LAB_3893		; go process error

; BIOS function - console in

LAB_3820				; (LAB_F303)
	PUSH	AF		;3820:	F5
	LD	(LAB_FEFA),HL	;3821:	22FAFE
	LD	A,#06h		; error # 06h
	LD	HL,LAB_0E00		; set return address (get character from console)
	JR	LAB_3893		; go process error

LAB_382B				; (LAB_F30E)
	PUSH	AF		;382B:	F5
	LD	(LAB_FEFA),HL	;382C:	22FAFE
	LD	A,#09h		; error # 09h
	LD	HL,LAB_0F37		; set return address
	JR	LAB_3893		; go process error

LAB_3836				; (LAB_F319)
	PUSH	AF		;3836:	F5
	LD	(LAB_FEFA),HL	;3837:	22FAFE
	LD	A,#21h		; error # 21h
	LD	HL,LAB_15EA		; set return address
	JR	LAB_3893		; go process error

LAB_3841				; (LAB_F324)
	PUSH	AF		;3841:	F5
	LD	(LAB_FEFA),HL	;3842:	22FAFE
	LD	A,#3Fh		; error # 3Fh
	LD	HL,LAB_15F0		; set return address
	JR	LAB_3893		; go process error

LAB_384C				; (LAB_F32F)
	PUSH	AF		;384C:	F5
	LD	(LAB_FEFA),HL	;384D:	22FAFE
	POP	HL		;3850:	E1
	LD	(LAB_FEF8),HL	;3851:	22F8FE
	PUSH	AF		;3854:	F5
	LD	A,#36h		; error # 36h
	LD	HL,LAB_3513		; set return address ??
	JR	LAB_3893		; go process error

LAB_385C				; (LAB_F33F)
	PUSH	AF			; save A
	LD	(LAB_FEFA),HL	;385D:	22FAFE
	LD	A,#39h		; error # 39h
	LD	HL,LAB_2D79		; set return address
	JR	LAB_3893		; go process error

LAB_3867				; (LAB_F34A)
	PUSH	AF		;3867:	F5
	LD	(LAB_FEFA),HL	;3868:	22FAFE
	LD	A,#30h		; error # 30h
	LD	HL,LAB_2ED3		; set return address
	JR	LAB_3893		; go process error

LAB_3872				; (LAB_F355)
	PUSH	AF		;3872:	F5
	LD	(LAB_FEFA),HL	;3873:	22FAFE
	LD	A,#33h		; error # 33h
	LD	HL,LAB_2E02		; set return address
	JR	LAB_3893		; go process error

LAB_387D				; (LAB_F360)
	PUSH	AF		;387D:	F5
	LD	(LAB_FEFA),HL	;387E:	22FAFE
	LD	A,#42h		; error # 42h
	LD	HL,LAB_1A8B		; set return address
	JR	LAB_3893		; go process error

LAB_3888				; (LAB_F36B)
	PUSH	AF		;3888:	F5
	LD	(LAB_FEFA),HL	;3889:	22FAFE
	LD	A,#45h		; error # 45h
	LD	HL,LAB_1587		; set return address
	JR	LAB_3893		; go process error (not needed!)

LAB_3893				; (LAB_F376)
	LD	(LAB_FEFC),A	; set error number
	LD	A,#00h		; error type (could XOR A here!)
	LD	(LAB_FEFD),A	; set 'Bios' error
	POP	AF			; restore ??
	LD	(LAB_FEF9),A	;389C:	32F9FE

LAB_389F				; (LAB_F382)
	LD	(LAB_FEF6),HL	; save return address
	LD	HL,(LAB_FEFA)	; restore HL from original call
	LD	A,(LAB_F791)	; get current memory page
	LD	(LAB_FEFE),A	; save it
	DI				; disable interrupts
	PUSH	AF			; save current memory page
	LD	A,#00h		; clear A (could XOR A!)
	LD	(LAB_F791),A	; clear current memory page
	OUT	(MEM_P),A		; reset memory page
	POP	AF			; restore current memory page
	CALL	LAB_F54E		; enable interrupts if interrupts setup ?? flag <> 0
					; (LAB_3A6B)
	LD	A,(LAB_FDBD)	;38B8:	3ABDFD
	AND	#07h		;38BB:	E607
	LD	A,(LAB_FEF9)	; restore A from original call
	JR	Z,LAB_38D5	;38C0:	2813

	PUSH	AF			; save AF
	PUSH	BC			; save CB
	PUSH	DE			; save DE
	PUSH	HL			; save HL
	PUSH	IX			; save IX
	PUSH	IY			; save IY
	CALL	LAB_2D82		; display error header ??
	POP	IY			; restore IY
	POP	IX			; restore IX
	POP	HL			; restore HL
	POP	DE			; restore DE
	POP	BC			; restore BC
	POP	AF			; restore AF
LAB_38D5
	LD	HL,LAB_F3C4		; set second return address ??
	PUSH	HL			; push onto stack
	LD	HL,(LAB_FEF6)	; get saved return address
	PUSH	HL			; push onto stack
	LD	HL,(LAB_FEFA)	; restore HL from original call
	RET				; go do error code then return here ...

LAB_38E1				; (LAB_F3C4)
	LD	(LAB_FEF6),A	;38E1:	32F6FE
	LD	A,(LAB_FDBD)	;38E4:	3ABDFD
	AND	#07h		;38E7:	E607
	JR	Z,LAB_3901	;38E9:	2816

	LD	A,(LAB_FEF6)	;38EB:	3AF6FE
	PUSH	AF			; save AF
	PUSH	BC			; save CB
	PUSH	DE			; save DE
	PUSH	HL			; save HL
	PUSH	IX			; save IX
	PUSH	IY			; save IY
	CALL	LAB_2DA5		; display error footer and wait for key ??
	POP	IY			; restore IY
	POP	IX			; restore IX
	POP	HL			; restore HL
	POP	DE			; restore DE
	POP	BC			; restore BC
	POP	AF			; restore AF

LAB_3901				; (LAB_F3E4)
	LD	A,(LAB_FEFE)	; get memory page buffer
	DI				; disable interrupts
	LD	(LAB_F791),A	; save as current memory page
	OUT	(MEM_P),A		; set memory page
	CALL	LAB_F54E		; enable interrupts if interrupts setup ?? flag <> 0
					; (LAB_3A6B)
	LD	A,(LAB_FEF6)	;390D:	3AF6FE
	PUSH	HL			; save HL
	LD	HL,0000h		; clear HL
	LD	(LAB_FEF6),HL	;3914:	22F6FE
	LD	(LAB_FEFC),HL	; clear error number & type
	POP	HL			; restore HL
	PUSH	AF			; save A
	LD	A,(LAB_FDB8)	;391C:	3AB8FD
	CP	#FFh		;391F:	FEFF
	JR	Z,LAB_3925	;3921:	2802

	POP	AF			; restore A
	RET				;

LAB_3925				; (LAB_F408)
	LD	A,#00h		; clear A (could XOR A!)
	LD	(LAB_FDB8),A	;3927:	32B8FD
	LD	A,(LAB_FDB9)	;392A:	3AB9FD
	LD	C,A		;392D:	4F
	POP	AF			; restore A
	LD	HL,LAB_F41A		; set return address (does RET) (LAB_3937)
	PUSH	HL			; onto stack
	LD	HL,(LAB_FDBA)	;3933:	2ABAFD
	JP	(HL)		;3936:	E9

LAB_3937				; (LAB_F41A)
	RET				; if the return address hadn't been pushed
					; then this line wouldn't be needed!

; set memory page A & enable interrupts

LAB_3938				; (LAB_F41B)
	DI				; disable interrupts
	LD	(LAB_F791),A	; save current memory page
	OUT	(MEM_P),A		; set memory page
	CALL	LAB_F54E		; enable interrupts if interrupts setup ?? flag <> 0
					; (LAB_3A6B)
	RET				;

; BIOS setup page zero, pages 40h to 01h (LAB_3942)

LAB_3942				; (LAB_F425)
	LD	C,#41h		; set memory page 41h (40h after decrement)
LAB_3944
	DEC	C			; decrement page #
	JR	Z,LAB_3955		; when done go set warm boot vector in pages 40h to 01h

	LD	B,#00h		; 256 bytes to do
	LD	HL,0000h		; set pointer
LAB_394C
	LD	A,(HL)		; get byte
	CALL	LAB_F483		; do LD (HL),A in page C (LAB_39A0)
	INC	HL			; increment pointer
	DJNZ	LAB_394C		; loop until page done

	JR	LAB_3944		; go do next page

					; set warm boot vector in pages 40h to 01h
LAB_3955				; (LAB_F438)
	LD	C,#41h		; set memory page 41h (40h after decrement)
LAB_3957
	DEC	C			; decrement page #
	JR	Z,LAB_397C		; exit if all done

	PUSH	AF			; save A (don't need this!)
	LD	A,C			; copy page #
	DI				; disable interrupts
	LD	(LAB_F791),A	; save current memory page
	OUT	(MEM_P),A		; set memory page
	CALL	LAB_F54E		; enable interrupts if interrupts setup ?? flag <> 0
					; (LAB_3A6B)
	POP	AF			; restore A (don't need this!)
	LD	A,#C3h		; code for JP
	LD	(LAB_0000),A	; save in first byte
	LD	HL,LAB_F238		; warm boot vector (LAB_3755)
	LD	(LAB_0001),HL	; save in 2nd & 3rd bytes
	JR	LAB_3957		; loop

; reset BDOS function call vector and memory page

LAB_3973				; (LAB_F456)
	LD	(LAB_0005),A	; save JP opcode
	LD	HL,LAB_F180		; reset default jump address (BDOS function handler)
	LD	(LAB_0006),HL	; save it

; reset memory page & return

LAB_397C				; (LAB_F45F)
	DI				; disable interrupts
	PUSH	AF			; save A
	LD	A,#00h		; clear A (could XOR A!)
	LD	(LAB_F791),A	; clear current memory page
	OUT	(MEM_P),A		; reset memory page
	POP	AF			; restore A
	CALL	LAB_F54E		; enable interrupts if interrupts setup ?? flag <> 0
					; (LAB_3A6B)
	RET				;

; save E to (HL) in pages 40h-00h (LAB_398A)

LAB_398A				; (LAB_F46D)
	DI				; disable interrupts
	LD	C,#41h		; set page (40h after decrement)
LAB_398D
	DEC	C			; decrement page #
	LD	A,C			; copy it
	OUT	(MEM_P),A		; set memory page
	JR	Z,LAB_3996		; exit if page 00h

	LD	(HL),E		; set byte
	JR	LAB_398D		; loop

LAB_3996
	CALL	LAB_F54E		; enable interrupts if interrupts setup ?? flag <> 0
					; (LAB_3A6B) (could JP LAB_3A6B here!)
	RET				;

; do LD (HL),A in page (LAB_FEFE)

LAB_399A				; (LAB_F47D)
	PUSH	AF			; save A
	LD	A,(LAB_FEFE)	; get new page #
	JR	LAB_39A2		; go set page

; do LD (HL),A in page C

LAB_39A0				; (LAB_F483)
	PUSH	AF			; save A
	LD	A,C			; copy page #
LAB_39A2
	CALL	LAB_F4AF		; set current memory page from A (LAB_39CC)
	POP	AF			; restore A
	LD	(HL),A		; save A @ (HL)
	JR	LAB_39BE		; reset memory page & RET

; get byte (HL) from page (LAB_FEFE)

LAB_39A9				; (LAB_F48C)
	LD	A,(LAB_FEFE)	; get new page #
	JR	LAB_39AF		;

LAB_39AE				; (LAB_F491)
	LD	A,C		;39AE:	79
LAB_39AF
	CALL	LAB_F4AF		; set current memory page from A (LAB_39CC)
	LD	A,(HL)		; get byte from (HL)
	JR	LAB_39BE		; reset memory page & RET

; copy block to memory page (LAB_FEFE), reset afterwards

LAB_39B5				; (LAB_F498)
	LD	A,(LAB_FEFE)	; get page

; copy block to memory page (A), reset afterwards

LAB_39B8				; (LAB_F49B)
	DI				; disable interrupts (done in routine!)
	CALL	LAB_F4AF		; set current memory page from A (LAB_39CC)
	LDIR				; copy block

; reset memory page & RET

LAB_39BE				; (LAB_F4A1)
	DI				; disable interrupts
	PUSH	AF			; save A
	LD	A,#00h		; clear A (could XOR A!)
	LD	(LAB_F791),A	; clear current memory page
	OUT	(MEM_P),A		; reset memory page
	POP	AF			; restore A
	CALL	LAB_F54E		; enable interrupts if interrupts setup ?? flag <> 0
					; (LAB_3A6B) (could JP LAB_3A6B here!)
	RET				;

; set current memory page from A

LAB_39CC				; (LAB_F4AF)
	DI				; disable interrupts
	LD	(LAB_F791),A	; save current memory page
	OUT	(MEM_P),A		; set memory page
	RET				;

; jump to ROM 2 0100h

LAB_39D3				; (LAB_F4B6)
	DI				; disable interrupts
	PUSH	AF			; save AF
	LD	A,#01h		; set page #1
	LD	(LAB_F791),A	; save current memory page
	OUT	(MEM_P),A		; set memory page 01
	POP	AF			; restore AF
	CALL	LAB_F54E		; enable interrupts if interrupts setup ?? flag <> 0
					; (LAB_3A6B)
	JP	LAB_0100		; do reset (ROM 2)

; copy sector BC to/from (HL) ??
; if Cb=0=from (read) else Cb=1=to (write)

; DE is ???
; C = (BC+(DE<<LAB_F822)-(first bank#))/FEh, HL = MOD
; HL = (HL<<7)+(LAB_F8B0)
; DE = original HL

LAB_39E3				; (LAB_F4C6)
	PUSH	AF			; save carry flag
	PUSH	HL			; save buffer address
	PUSH	BC			; save sector # ??
	LD	A,(LAB_F822)	;39E6:	3A22F8
	CALL	LAB_049F		; do DE<<A. RST 28h if overflow
	POP	HL			; get sector # ??
	ADD	HL,DE			; + ??
	CALL	LAB_04C8		; calculate C=mem page, HL=sector
	EX	DE,HL			; swap sector # to DE
	LD	A,#07h		; 2^7 bytes per sector
	CALL	LAB_049F		; do DE<<A. RST 28h if overflow
	LD	HL,(LAB_F8B0)	; offset to 1st sector in page
	ADD	HL,DE			; add sector address
	POP	DE			; restore buffer address
	POP	AF			; restore C flag
	JR	NC,LAB_3A00		; jump if read

	EX	DE,HL			; else swap pointers (write)
LAB_3A00
	LD	A,C			; copy page number
	LD	BC,0080h		; 80h bytes (1 sector) to copy
	CALL	LAB_F49B		; copy block to/from memory page (A)
					; reset afterwards (LAB_39B8)
	RET				;

; copy FCB to FCB_buffer, LAB_FF7F
;
; the FCB is pointed to by DE and is copied to LAB_FF7F - LAB_FFA2
;
; returns with DE = FCB copy pointer

LAB_3A08				; (LAB_F4EB)
	EX	DE,HL			; swap FCB pointer to HL
	LD	(LAB_FFA5),HL	; save FCB pointer
	EX	DE,HL			; swap FCB pointer back to  DE
	LD	A,D			; get FCB pointer high byte
	CP	#80h			; compare with 80h (unpaged mem boundary)
	RET	NC			; exit if FCB is not in paged mem

	LD	HL,LAB_FF7F		; set destination
LAB_3A14
	EX	DE,HL			; swap source & destination
	PUSH	DE			; save destination
	LD	BC,0024h		; 24h bytes to copy
	CALL	LAB_F498		; copy block to memory page (LAB_FEFE)
					; reset afterwards (LAB_39B5)
	POP	DE			; restore destination
	RET				;

; copy FCB_buffer, LAB_FF7F, to FCB
;
; LAB_FF7F - LAB_FFA2 is copied to the FCB pointed to by (LAB_FFA5)
;
; returns with DE = FCB pointer

LAB_3A1E				; (LAB_F501)
	LD	HL,(LAB_FFA5)	; get FCB pointer for current file
	LD	A,H			; copy high byte
	CP	#80h			; compare with 80h (unpaged mem boundary)
	RET	NC			; exit if not in paged mem

	LD	HL,(LAB_FFA5)	; get FCB pointer for current file
	LD	DE,LAB_FF7F		; set source for copy
	JR	LAB_3A14		; go copy (DE) to (HL)

; copy 128 byte block from DMA address, page (LAB_FEFE) to LAB_FEFF

LAB_3A2D				; (LAB_F510)
	LD	HL,(LAB_FFA3)	; get DMA address
	LD	A,H			; copy high byte
	CP	#80h			; compare with unpaged mem
	RET	NC			; exit if pointer > 7FFFh

	LD	DE,LAB_FEFF		; set destination
	PUSH	DE			; save destination
	LD	BC,0080h		; 80h bytes to copy
	CALL	LAB_F498		; copy block from memory page (LAB_FEFE)
					; reset afterwards (LAB_39B5)
	POP	HL			; restore destination
	RET				;

; copy 128 byte block from LAB_FEFF, page (LAB_FEFE) to DMA address

LAB_3A40				; (LAB_F523)
	LD	HL,(LAB_FFA3)	; get DMA address
	LD	A,H			; copy high byte
	CP	#80h			; compare with unpaged mem
	RET	NC			; exit if pointer > 7FFFh

	LD	DE,LAB_FEFF		; set destination
	EX	DE,HL			; swap pair
	LD	BC,0080h		; 80h bytes to copy
	CALL	LAB_F498		; copy block to memory page (LAB_FEFE)
					; reset afterwards (LAB_39B5)
	RET				;

; copy 80h bytes from LAB_F8B8 to DMA address, page (LAB_FEFE)

LAB_3A52				; (LAB_F535)
	LD	HL,(LAB_FFA3)	; get DMA address
	LD	DE,LAB_F8B8		; set pointer to 80h byte area
	EX	DE,HL			; swap them
	LD	BC,0080h		; 80h bytes to copy
	CALL	LAB_F498		; copy block to memory page (LAB_FEFE)
					; reset afterwards (LAB_39B5)
	RET				;

; return Cb=1, HL=LAB_FEFF if DMA address >7FFFh

LAB_3A60				; (LAB_F543)
	LD	HL,(LAB_FFA3)	; get DMA address
	LD	A,H			; copy high byte
	CP	#80h			; compare with unpaged mem
	RET	NC			; exit if pointer > 7FFFh

	LD	HL,LAB_FEFF		;3A67:	21FFFE
	RET				;

; enable interrupts if interrupts setup ?? flag <> 0

LAB_3A6B				; (LAB_F54E)
	PUSH	AF			; save A
	LD	A,(LAB_FFA8)	; get interrupts setup ?? flag
	OR	A			; set the flags
	JP	Z,LAB_F558		; jump if zero (LAB_3A75)

	EI				; enable interrupts
	NOP				; wait
LAB_3A75
	POP	AF			; restore A
	RET				;

LAB_3A77				; (LAB_F55A)
	EX	AF,AF'		; swap to alternate pair
	LD	A,(LAB_F791)	; get current memory page
	PUSH	AF			; save current memory page
	DI				; disable interrupts
	PUSH	AF			; save current memory page
	LD	A,#00h		; clear A (could XOR A!)
	LD	(LAB_F791),A	; save current memory page
	OUT	(MEM_P),A		; reset memory page
	POP	AF			; restore current memory page
	CALL	LAB_F54E		; enable interrupts if interrupts setup ?? flag <> 0
					; (LAB_3A6B)
	CALL	LAB_2B18		; sets LAB_F5EE dependimg on E
					; FFh - LAB_F57B - clear carry & return
					; FEh - LAB_F57E - do error
					; FDh - LAB_F59F - do error with ??
					; FCh - LAB_F5C0 - do error with retry or mon options
	DI				; enable interrupts
	POP	AF			; restore current memory page
	LD	(LAB_F791),A	; save current memory page
	OUT	(MEM_P),A		; set memory page
	CALL	LAB_F54E		; enable interrupts if interrupts setup ?? flag <> 0
					; (LAB_3A6B)
	EX	AF,AF'		; swap back
	RET				;

; clear carry & return

LAB_3A98				; (LAB_F57B)
	SCF				; set carry
	CCF				; complement carry
	RET				;

; this is the RST 28 code
; process error code, error code is in A

; do error

LAB_3A9B				; (LAB_F57E)
	EX	AF,AF'		; swap to alternate pair
	LD	A,(LAB_F791)	; get current memory page
	PUSH	AF			; save current memory page
	DI				; disable interrupts
	PUSH	AF			; save current memory page
	LD	A,#00h		; clear A (could XOR A!)
	LD	(LAB_F791),A	; clear current memory page
	OUT	(MEM_P),A		; reset memory page
	POP	AF			; restore current memory page
	CALL	LAB_F54E		; enable interrupts if interrupts setup ?? flag <> 0
					; (LAB_3A6B)
	CALL	LAB_2B55		; process error (error code in A')
	DI				; disable interrupts
	POP	AF			; restore current memory page
	LD	(LAB_F791),A	; save current memory page
	OUT	(MEM_P),A		; set memory page
	CALL	LAB_F54E		; enable interrupts if interrupts setup ?? flag <> 0
					; (LAB_3A6B)
	EX	AF,AF'		; swap back
	RET				;

; do error with ??

LAB_3ABC				; (LAB_F59F)
	EX	AF,AF'		; swap alternate A
	LD	A,(LAB_F791)	; get current memory page
	PUSH	AF			; save memory page
	DI				; disable interrupts
	PUSH	AF			; save memory page
	LD	A,#00h		; clear A (could XOR A!)
	LD	(LAB_F791),A	; clear current memory page
	OUT	(MEM_P),A		; reset memory page
	POP	AF			; restore memory page
	CALL	LAB_F54E		; enable interrupts if interrupts setup ?? flag <> 0
					; (LAB_3A6B)
	CALL	LAB_2BEE	;3ACE:	CDEE2B
	DI				; disable interrupts
	POP	AF			; restore memory page
	LD	(LAB_F791),A	; save current memory page
	OUT	(MEM_P),A		; set memory page
	CALL	LAB_F54E		; enable interrupts if interrupts setup ?? flag <> 0
					; (LAB_3A6B)
	EX	AF,AF'		; swap A back
	RET				;

; do error with retry or mon options

LAB_3ADD				; (LAB_F5C0)
	EX	AF,AF'		; swap alternate A
	LD	A,(LAB_F791)	; get current memory page
	PUSH	AF			; save memory page
	DI				; disable interrupts
	PUSH	AF			; save memory page
	LD	A,#00h		; clear A (could XOR A!)
	LD	(LAB_F791),A	; clear current memory page
	OUT	(MEM_P),A		; reset memory page
	POP	AF			; restore memory page
	CALL	LAB_F54E		; enable interrupts if interrupts setup ?? flag <> 0
					; (LAB_3A6B)
	CALL	LAB_2C00		; display error & offer retry or monitor
	DI				; disable interrupts
	POP	AF			; restore memory page
	LD	(LAB_F791),A	; save current memory page
	OUT	(MEM_P),A		; set memory page
	CALL	LAB_F54E		; enable interrupts if interrupts setup ?? flag <> 0
					; (LAB_3A6B)
	EX	AF,AF'		; swap A back
	RET				;

LAB_3AFE				; RST 08 (LAB_F5E1)
	JP	LAB_F64D	;3AFE:	C34DF6 (LAB_3B6A)
LAB_3B01				; (LAB_F5E4)
	JP	LAB_F64D	;3B01:	C34DF6 (LAB_3B6A)
LAB_3B04				; (LAB_F5E7)
	JP	LAB_F64D	;3B04:	C34DF6 (LAB_3B6A)
LAB_3B07				; RST 20 (LAB_F5EA)
	JP	LAB_F64D	;3B07:	C34DF6 (LAB_3B6A)
LAB_3B0A				; RST 28 (LAB_F5ED)
	JP	LAB_F57E		; process error code, error code is in A (LAB_3A9B)

LAB_3B0D				; RST 30 (LAB_F5F0)
	JP	LAB_3513		; just does XOR A

; this becomes the IRQ vector

LAB_3B10				; (LAB_F5F3)
	JP	LAB_F64D	;3B10:	C34DF6 (LAB_3B6A)

; this is the NMI routine

LAB_3B13				; (LAB_F5F6)
	DI				; disable interrupts
	PUSH	AF			; save A
	LD	A,(LAB_FBD5)	; get sleep count ??
	OR	A			; set the flags
	JR	Z,LAB_3B27		; jump if not asleep ?

	CP	#01h			;3B1B:	FE01
	JR	Z,LAB_3B68		; restore A & RET

	LD	A,#40h		; set KBD_W buffer
	LD	(KBD_Buff),A	; save KBD_W buffer
	JP	LAB_1758		; do go to sleep loop ??

LAB_3B27
	LD	A,(LAB_FFA8)	; get interrupts setup ?? flag
	PUSH	AF			; save interrupts setup ?? flag
	LD	A,#00h		; clear A (could XOR A!)
	LD	(LAB_FFA8),A	; clear interrupts setup ?? flag
	LD	A,(LAB_F791)	; get current memory page
	PUSH	AF			; save current memory page
	DI				; disable interrupts
	PUSH	AF			; save current memory page again (don't need this!)
	LD	A,#00h		; clear A (could XOR A!)
	LD	(LAB_F791),A	; clear current memory page
	OUT	(MEM_P),A		; reset memory page
	POP	AF			; restore current memory page (don't need this!)
	CALL	LAB_F54E		; enable interrupts if interrupts setup ?? flag <> 0
					; (LAB_3A6B)
	LD	A,(KBD_Buff)	; get KBD_W buffer
	PUSH	AF			; save KBD_W buffer
	LD	A,#40h		; set new KBD_W buffer
	LD	(KBD_Buff),A	; save KBD_W buffer
	CALL	LAB_1721	;3B4A:	CD2117
	POP	AF			; restore KBD_W buffer
	LD	(KBD_Buff),A	; save KBD_W buffer
	OUT	(KBD_W),A		; out to key matrix
	DI				; disable interrupts
	POP	AF			; restore current memory page
	LD	(LAB_F791),A	; save current memory page
	OUT	(MEM_P),A		; set memory page
	CALL	LAB_F54E		; enable interrupts if interrupts setup ?? flag <> 0
					; (LAB_3A6B)
	IM	1			; set mode 1 interrupts
	POP	AF			; restore interrupts setup ?? flag
	LD	(LAB_FFA8),A	; save interrupts setup ?? flag
	OR	A			; set the flags
	JP	Z,LAB_F64B		; (JR Z,LAB_3B68 would be better!)

	EI				; enable interrupts
LAB_3B68				; (LAB_F64B)
	POP	AF			; restore A
	RET				;

; IRQ service routine

LAB_3B6A				; (LAB_F64D)
	PUSH	AF			; save AF
	PUSH	BC			; save BC
	PUSH	DE			; save DE
	PUSH	HL			; save HL
	PUSH	IX			; save IX
	PUSH	IY			; save IY
	LD	A,(LAB_FFA8)	; get interrupts setup ?? flag
	OR	A			; set the flags
	JR	NZ,LAB_3B82		; jump if interrupts setup ??

	DI				; else disable interrupts
	POP	IY			; restore IY
	POP	IX			; restore IX
	POP	HL			; restore HL
	POP	DE			; restore DE
	POP	BC			; restore BC
	POP	AF			; restore AF
	RET				;

					; interrupts were setup so service them
LAB_3B82				; (LAB_F665)
	XOR	A			; clear A
	LD	(LAB_FFA8),A	; clear interrupts setup flag
	DI				; disable interrupts
	LD	A,(LAB_F791)	; get current memory page
	PUSH	AF			; save it
	LD	A,#00h		; clear A (could XOR A!)
	LD	(LAB_F791),A	; set current memory page (monitor ROM)
	OUT	(MEM_P),A		; reset memory page
	CALL	LAB_230A		; do main interrupt service
	POP	AF			; restore current memory page
	LD	(LAB_F791),A	; save current memory page
	OUT	(MEM_P),A		; set memory page
	LD	A,#01h		; set value
	LD	(LAB_FFA8),A	; save interrupts setup flag
	POP	IY			; restore IY
	POP	IX			; restore IX
	POP	HL			; restore HL
	POP	DE			; restore DE
	POP	BC			; restore BC
	POP	AF			; restore AF
	EI				; enable interrupts
	RET				;

; copies block to RAM then executes it
; block 7030h-7241h to D681h-D892h

LAB_3BAA
	LD	HL,LAB_7030		; source address
	LD	DE,LAB_D681		; destination address
	LD	BC,0212h		; bytes to copy
	LDIR				; copy block
	JP	LAB_D681		; go execute it

; get connect status message

; stack is ..
; message #
; end.

LAB_3BB8
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6)
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		; get #
	LD	D,#00h		; clear high byte
	EX	DE,HL			; copy to HL
	ADD	HL,HL			; *2 (2 bytes per pointer)
	LD	DE,LAB_6A4A		; get pointer to message table
	ADD	HL,DE			; add to message table pointers
	LD	E,(HL)		; get message pointer low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get message pointer high byte
	EX	DE,HL			; copy to HL
	RET				;

; get C-xxx message #

; stack is ..
; message #
; end.

LAB_3BD0
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6)
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		; get #
	LD	D,#00h		; clear high byte
	EX	DE,HL			; copy to HL
	ADD	HL,HL			; *2 (two bytes per pointer)
	LD	DE,LAB_6B67		; load pointer to message table
	ADD	HL,DE			; add to message table pointer
	LD	E,(HL)		; get message pointer low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get message pointer high byte
	EX	DE,HL			; copy to HL
	RET				;

; get (byte) HL from (LAB_E22D)

LAB_3BE8
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6)
	LD	A,(LAB_E22D)	; get status message #
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	RET				;

; save (byte) at (LAB_E22D)

; stack is ..
; value
; end.

LAB_3BF5
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6)
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		; get byte
	EX	DE,HL			; swap to HL
	LD	A,L			; copy byte
	LD	(LAB_E22D),A	; save byte
	RET				;

; stack ...
; message #
; pointer
; end

LAB_3C06
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6)
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		; get message #
	LD	D,#00h		; clear high byte
	PUSH	DE			; push message #
	LD	A,(LAB_E22D)	; get mode # ??
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	LD	DE,0011h		; 11h bytes per mode
	CALL	LAB_DFCC		; does HL = HL*DE
	POP	DE			; retrieve message #
	ADD	HL,DE			; add message # to mode*11h ??
	LD	DE,LAB_692A		; point to table base
	ADD	HL,DE			; add table base
	LD	E,(HL)		; get byte from table
	EX	DE,HL			; swap to HL
	LD	A,L			; copy to A
	LD	(LAB_E3C1),A	; save status message byte
	LD	A,(LAB_E3C1)	; get status message byte !?
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	LD	DE,0080h		; set and value
	CALL	LAB_E023		; does AND HL,DE. sets Z flag
	JP	NZ,LAB_3C44		; jump if comms message (byte was 1xxx xxxx)

	LD	HL,0000h	;3C3B:	210000
	LD	(LAB_E3C2),HL	;3C3E:	22C2E3
	JP	LAB_3C88	;3C41:	C3883C

LAB_3C44
	LD	A,(LAB_E22D)	; get mode # ??
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	PUSH	HL			; push mode # ??
	CALL	LAB_3BB8		; get mode message pointer in HL
	POP	DE			; dump mode # ??
	PUSH	HL			; push line 6 message pointer
	LD	HL,LAB_6E61		; points to'    called from'
	PUSH	HL			; push line 5 message pointer
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		; get C-xxx message #
	LD	D,#00h		; clear high byte
	PUSH	DE			; push C-xxx message #
	CALL	LAB_3BD0		; get C-xxx message pointer in HL
	POP	DE			; dump C-xxx message #
	PUSH	HL			; push line 4 message pointer
	LD	HL,LAB_E22E		; pounts to null message
	PUSH	HL			; push line 3 message pointer
	CALL	LAB_4296		; print 4 line message ??
	EX	DE,HL			;
	D	HL,0008h		; 8 ..
	ADD	HL,SP			; .. + stack ..
	LD	SP,HL			; .. = dump the lot
	CALL	LAB_42EE		; wait (LAB_E6FD) seconds or do press to cont
	LD	A,(LAB_E3C1)	; get status message byte
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	LD	DE,007Fh	;3C77:	117F00
	CALL	LAB_E023		; does AND HL,DE. sets Z flag
	PUSH	HL			; push status message #
	CALL	LAB_3BF5		; save (byte) at (LAB_E22D)
	POP	DE			; dump status message #
	LD	HL,0002h	;3C82:	210200
	LD	(LAB_E3C2),HL	;3C85:	22C2E3
LAB_3C88
	LD	A,(LAB_E3C1)	; get status message byte
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	LD	DE,007Fh		; set mask byte
	CALL	LAB_E023		; does AND HL,DE. sets Z flag
	PUSH	HL			; save masked byte
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 1 before call
	LD	E,(HL)		; get pointer low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get pointer high byte
	EX	DE,HL			; swap to HL
	POP	DE			; restore masked byte
	LD	(HL),E		; save at pointer
	LD	HL,(LAB_E3C2)	;3C9F:	2AC2E3
	RET				;

; fill count bytes, from destination, with 00h

; stack is ..
; destination
; count
; end.

LAB_3CA3
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6)
	LD	HL,0000h		; set fill byte
	PUSH	HL			; push fill byte
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 1 before call
	LD	E,(HL)		; get count low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get count high byte
	PUSH	DE			; push count
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		; get destination low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get destination high byte
	PUSH	DE			; push destination
	CALL	LAB_DC07		; fill count bytes, from destination, with byte (LAB_7742)
	POP	DE			; dump destination
	POP	DE			; dump count
	POP	DE			; dump fill byte
	RET				;

; fill buffer ?? @ LAB_E3C6 & clear LAB_E446, LAB_E448 & LAB_E44A

LAB_3CC4
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6)
	LD	HL,0080h		; set count
	PUSH	HL			; push count
	LD	HL,LAB_E3C6		; set destination
	PUSH	HL			; push destination
	CALL	LAB_3CA3		; fill count bytes, from destination, with 00h
	POP	DE			; dump destination
	POP	DE			; dump count
	LD	HL,0000h	;3CD7:	210000
	LD	(LAB_E446),HL	;3CDA:	2246E4
	LD	HL,0000h	;3CDD:	210000
	LD	(LAB_E448),HL	;3CE0:	2248E4
	LD	HL,0000h	;3CE3:	210000
	LD	(LAB_E44A),HL	;3CE6:	224AE4
	RET				;

; fill buffer ?? @ LAB_E3C6 & clear LAB_E446, LAB_E448, LAB_E44A & byte @ LAB_E519

LAB_3CEA
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6)
	CALL	LAB_3CC4		; fill buffer ?? @ LAB_E3C6 & clear
					; LAB_E446, LAB_E448 & LAB_E44A
	CALL	LAB_54E5		; clears byte @ LAB_E519
	RET				;

LAB_3CF7
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6)
	CALL	LAB_3CEA		; fill buffer ?? @ LAB_E3C6 & clear LAB_E446, LAB_E448,
					; LAB_E44A & byte @ LAB_E519
	CALL	LAB_5834	;3D00:	CD3458
	RET				;

; fill buffer ?? @ LAB_E3C6 & clear LAB_E446, LAB_E448,
; LAB_E44A, byte @ LAB_E519 & set HL = 0000h

LAB_3D04
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6)
	CALL	LAB_3CEA		; fill buffer ?? @ LAB_E3C6 & clear LAB_E446, LAB_E448,
					; LAB_E44A & byte @ LAB_E519
	CALL	LAB_583E		; set HL = 0000h
	RET				;

LAB_3D11
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6)
	LD	HL,0000h	;3D17:	210000
	LD	(LAB_E3C4),HL	;3D1A:	22C4E3
	LD	HL,(LAB_E446)	;3D1D:	2A46E4
	LD	A,H			; set the flags
	OR	L			;
	JP	Z,LAB_3D38	;3D22:	CA383D

	LD	HL,(LAB_E446)	;3D25:	2A46E4
	PUSH	HL		;3D28:	E5
	LD	HL,E3C6h	;3D29:	21C6E3
	PUSH	HL		;3D2C:	E5
	CALL	LAB_5848	;3D2D:	CD4858
	POP	DE		;3D30:	D1
	POP	DE		;3D31:	D1
	LD	(LAB_E3C4),HL	;3D32:	22C4E3
	CALL	LAB_3CC4		; fill buffer ?? @ LAB_E3C6 & clear
					; LAB_E446, LAB_E448 & LAB_E44A
LAB_3D38
	LD	HL,(LAB_E3C4)	;3D38:	2AC4E3
	RET				;

LAB_3D3C
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6)
	LD	HL,(LAB_E446)	;3D42:	2A46E4
	PUSH	HL		;3D45:	E5
	LD	HL,LAB_E3C6	;3D46:	21C6E3
	PUSH	HL		;3D49:	E5
	CALL	LAB_5880	;3D4A:	CD8058
	POP	DE		;3D4D:	D1
	POP	DE		;3D4E:	D1
	LD	(LAB_E3C4),HL	;3D4F:	22C4E3
	CALL	LAB_3CC4		; fill buffer ?? @ LAB_E3C6 & clear
					; LAB_E446, LAB_E448 & LAB_E44A
	LD	HL,(LAB_E3C4)	;3D55:	2AC4E3
	RET				;

LAB_3D59
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6)
	CALL	LAB_3CC4		; fill buffer ?? @ LAB_E3C6 & clear
					; LAB_E446, LAB_E448 & LAB_E44A
	LD	HL,LAB_E448	;3D62:	2148E4
	PUSH	HL		;3D65:	E5
	LD	HL,0080h	;3D66:	218000
	PUSH	HL		;3D69:	E5
	LD	HL,LAB_E3C6	;3D6A:	21C6E3
	PUSH	HL		;3D6D:	E5
	CALL	LAB_58B8	;3D6E:	CDB858
	POP	DE		;3D71:	D1
	POP	DE		;3D72:	D1
	POP	DE		;3D73:	D1
	LD	(LAB_E3C4),HL	;3D74:	22C4E3
	LD	HL,(LAB_E3C4)	;3D77:	2AC4E3
	LD	DE,0008h	;3D7A:	110800
	CALL	LAB_E04B		; compare HL with DE, return HL=0 & Zb=1 if different
	JP	Z,LAB_3D97	;3D80:	CA973D
	LD	HL,0001h	;3D83:	210100
	LD	(LAB_E44A),HL	;3D86:	224AE4
	LD	HL,(LAB_E448)	;3D89:	2A48E4
	LD	A,H			; set the flags
	OR	L			;
	JP	Z,LAB_3D97	;3D8E:	CA973D

	LD	HL,0000h	;3D91:	210000
	LD	(LAB_E3C4),HL	;3D94:	22C4E3
LAB_3D97
	LD	HL,(LAB_E3C4)	;3D97:	2AC4E3
	RET				;

LAB_3D9B
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6)
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;3DA5:	5E
	PUSH	DE		;3DA6:	D5
	LD	HL,(LAB_E446)	;3DA7:	2A46E4
	INC	HL		;3DAA:	23
	LD	(LAB_E446),HL	;3DAB:	2246E4
	DEC	HL		;3DAE:	2B
	LD	DE,LAB_E3C6	;3DAF:	11C6E3
	ADD	HL,DE		;3DB2:	19
	POP	DE		;3DB3:	D1
	LD	(HL),E		;3DB4:	73
	LD	HL,(LAB_E446)	;3DB5:	2A46E4
	LD	DE,0080h	;3DB8:	118000
	CALL	LAB_E04B		; compare HL with DE, return HL=0 & Zb=1 if different
	JP	Z,LAB_3DC7	;3DBE:	CAC73D
	CALL	LAB_3D11	;3DC1:	CD113D
	JP	LAB_3DCA	;3DC4:	C3CA3D
LAB_3DC7
	LD	HL,0000h	;3DC7:	210000
LAB_3DCA
	RET				;

LAB_3DCB
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6)
	LD	HL,0000h	;3DD1:	210000
	LD	(LAB_E3C4),HL	;3DD4:	22C4E3
	LD	HL,(LAB_E446)	;3DD7:	2A46E4
	EX	DE,HL		;3DDA:	EB
	LD	HL,(LAB_E448)	;3DDB:	2A48E4
	CALL	LAB_E04B		; compare HL with DE, return HL=0 & Zb=1 if different
	JP	Z,LAB_3DF8	;3DE1:	CAF83D
	LD	HL,(LAB_E44A)	;3DE4:	2A4AE4
	LD	A,H			; set the flags
	OR	L			;
	JP	Z,LAB_3DF2	;3DE9:	CAF23D

	LD	HL,0008h	;3DEC:	210800
	JP	LAB_3DF5	;3DEF:	C3F53D
LAB_3DF2
	CALL	LAB_3D59	;3DF2:	CD593D
LAB_3DF5
	LD	(LAB_E3C4),HL	;3DF5:	22C4E3
LAB_3DF8
	LD	HL,(LAB_E446)	;3DF8:	2A46E4
	INC	HL		;3DFB:	23
	LD	(LAB_E446),HL	;3DFC:	2246E4
	DEC	HL		;3DFF:	2B
	LD	DE,LAB_E3C6	;3E00:	11C6E3
	ADD	HL,DE		;3E03:	19
	LD	E,(HL)		;3E04:	5E
	PUSH	DE		;3E05:	D5
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;3E0A:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;3E0C:	56
	EX	DE,HL		;3E0D:	EB
	POP	DE		;3E0E:	D1
	LD	(HL),E		;3E0F:	73
	LD	HL,(LAB_E3C4)	;3E10:	2AC4E3
	RET				;

; stack is
; ??
; end.

LAB_3E14
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6)
	LD	HL,0000h	;3E1A:	210000
	LD	(LAB_E3C4),HL	;3E1D:	22C4E3
	LD	HL,0000h	;3E20:	210000
	LD	(LAB_E44C),HL	;3E23:	224CE4
	JP	LAB_3E30	;3E26:	C3303E
LAB_3E29
	LD	HL,(LAB_E44C)	;3E29:	2A4CE4
	INC	HL		;3E2C:	23
	LD	(LAB_E44C),HL	;3E2D:	224CE4
LAB_3E30
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;3E34:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;3E36:	56
	EX	DE,HL		;3E37:	EB
	LD	E,(HL)		;3E38:	5E
	LD	D,#00h		; clear high byte
	PUSH	DE		;3E3B:	D5
	LD	HL,(LAB_E44C)	;3E3C:	2A4CE4
	POP	DE		;3E3F:	D1
	EX	DE,HL		;3E40:	EB
	CALL	LAB_E0E7		; does CP DE,HL, returns HL=0 & Zb=1 if no carry (HL<=DE)
	JP	Z,LAB_3E66	;3E44:	CA663E
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;3E4B:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;3E4D:	56
	LD	HL,(LAB_E44C)	;3E4E:	2A4CE4
	ADD	HL,DE		;3E51:	19
	INC	HL		;3E52:	23
	LD	E,(HL)		;3E53:	5E
	LD	D,#00h		; clear high byte
	PUSH	DE		;3E56:	D5
	CALL	LAB_3D9B	;3E57:	CD9B3D
	POP	DE		;3E5A:	D1
	LD	(LAB_E3C4),HL	;3E5B:	22C4E3
	LD	A,H			; set the flags
	OR	L			;
	JP	NZ,LAB_3E66	;3E60:	C2663E

	JP	LAB_3E29	;3E63:	C3293E

LAB_3E66
	LD	HL,(LAB_E3C4)	;3E66:	2AC4E3
	RET				;

LAB_3E6A
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6)
	LD	HL,0000h	;3E70:	210000
	LD	(LAB_E3C4),HL	;3E73:	22C4E3
	LD	HL,0000h	;3E76:	210000
	PUSH	HL		;3E79:	E5
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;3E7E:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;3E80:	56
	EX	DE,HL		;3E81:	EB
	POP	DE		;3E82:	D1
	LD	(HL),E		;3E83:	73
	LD	HL,0000h	;3E84:	210000
	LD	(LAB_E44E),HL	;3E87:	224EE4
	JP	LAB_3E94	;3E8A:	C3943E
LAB_3E8D
	LD	HL,(LAB_E44E)	;3E8D:	2A4EE4
	INC	HL		;3E90:	23
	LD	(LAB_E44E),HL	;3E91:	224EE4
LAB_3E94
	LD	HL,(LAB_E44E)	;3E94:	2A4EE4
	EX	DE,HL		;3E97:	EB
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	A,(HL)		;3E9C:	7E
	INC	HL			; increment pointer
	LD	H,(HL)		;3E9E:	66
	LD	L,A		;3E9F:	6F
	CALL	LAB_E085		; does signed CP DE,HL. returns HL=1 if HL>DE
	JP	Z,LAB_3ECC	;3EA3:	CACC3E
	LD	HL,LAB_E450	;3EA6:	2150E4
	PUSH	HL		;3EA9:	E5
	CALL	LAB_3DCB	;3EAA:	CDCB3D
	POP	DE		;3EAD:	D1
	LD	(LAB_E3C4),HL	;3EAE:	22C4E3
	LD	A,H			; set the flags
	OR	L			;
	JP	NZ,LAB_3ECC	;3EB3:	C2CC3E

	LD	A,(LAB_E450)	;3EB6:	3A50E4
	LD	L,A		;3EB9:	6F
	PUSH	HL		;3EBA:	E5
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;3EBF:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;3EC1:	56
	LD	HL,(LAB_E44E)	;3EC2:	2A4EE4
	ADD	HL,DE		;3EC5:	19
	INC	HL		;3EC6:	23
	POP	DE		;3EC7:	D1
	LD	(HL),E		;3EC8:	73
	JP	LAB_3E8D	;3EC9:	C38D3E
LAB_3ECC
	LD	HL,(LAB_E44E)	;3ECC:	2A4EE4
	PUSH	HL		;3ECF:	E5
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;3ED4:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;3ED6:	56
	EX	DE,HL		;3ED7:	EB
	POP	DE		;3ED8:	D1
	LD	(HL),E		;3ED9:	73
	LD	HL,(LAB_E3C4)	;3EDA:	2AC4E3
	RET				;

LAB_3EDE
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6)
	LD	HL,0000h	;3EE4:	210000
	LD	(LAB_E3C4),HL	;3EE7:	22C4E3
LAB_3EEA
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	PUSH	HL		;3EEE:	E5
	LD	A,(HL)		;3EEF:	7E
	INC	HL			; increment pointer
	LD	H,(HL)		;3EF1:	66
	LD	L,A		;3EF2:	6F
	INC	HL		;3EF3:	23
	EX	DE,HL		;3EF4:	EB
	POP	HL		;3EF5:	E1
	LD	(HL),E		;3EF6:	73
	INC	HL			; increment pointer
	LD	(HL),D		;3EF8:	72
	EX	DE,HL		;3EF9:	EB
	DEC	HL		;3EFA:	2B
	LD	E,(HL)		;3EFB:	5E
	EX	DE,HL		;3EFC:	EB
	LD	A,L		;3EFD:	7D
	LD	(LAB_E451),A	;3EFE:	3251E4
	LD	A,H			; set the flags
	OR	L			;
	JP	Z,LAB_3F1C	;3F03:	CA1C3F

	LD	A,(LAB_E451)	;3F06:	3A51E4
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	PUSH	HL		;3F0C:	E5
	CALL	LAB_3D9B	;3F0D:	CD9B3D
	POP	DE		;3F10:	D1
	LD	(LAB_E3C4),HL	;3F11:	22C4E3
	LD	A,H			; set the flags
	OR	L			;
	JP	NZ,LAB_3F1C	;3F16:	C21C3F

	JP	LAB_3EEA	;3F19:	C3EA3E

LAB_3F1C
	LD	HL,(LAB_E3C4)	;3F1C:	2AC4E3
	RET				;

; stack is ..
; ??

LAB_3F20
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6)
	CALL	LAB_3D04		; fill buffer ?? @ LAB_E3C6 & clear LAB_E446, LAB_E448,
					; LAB_E44A, byte @ LAB_E519 & set HL = 0000h
	LD	(LAB_E453),HL	;3F29:	2253E4
	LD	A,H			; set the flags
	OR	L			;
	JP	NZ,LAB_3F55	;3F2E:	C2553F

	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;3F35:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;3F37:	56
	PUSH	DE		;3F38:	D5
	LD	HL,00FFh	;3F39:	21FF00
	PUSH	HL		;3F3C:	E5
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;3F41:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;3F43:	56
	EX	DE,HL		;3F44:	EB
	INC	HL		;3F45:	23
	PUSH	HL		;3F46:	E5
	CALL	LAB_58B8	;3F47:	CDB858
	POP	DE		;3F4A:	D1
	POP	DE		;3F4B:	D1
	POP	DE		;3F4C:	D1
	LD	(LAB_E453),HL	;3F4D:	2253E4
	LD	A,H			; set the flags
	OR	L			;
	JP	Z,LAB_3F55	;3F52:	CA553F

LAB_3F55
	LD	HL,(LAB_E453)	;3F55:	2A53E4
	JP	LAB_3FEC		; search table for HL, and execute

; save 03h @ LAB_E452

LAB_3F5B
	LD	HL,0003h		; set HL
	LD	A,L			; copy low byte
	LD	(LAB_E452),A	; save byte
	JP	LAB_4003		; go get byte @ LAB_E452 & exit

LAB_3F65
	LD	HL,0003h		; set HL
	LD	A,L			; copy low byte
	LD	(LAB_E452),A	; save byte
	LD	HL,0000h		; clear HL
	LD	A,L			; copy low byte
	LD	(LAB_E455),A	; clear ?? number
	JP	LAB_3F7F		; skip increment

LAB_3F76
	LD	A,(LAB_E455)	; get ?? number
	LD	L,A			; copy to L
	INC	HL			; increment ?? number
	LD	A,L			; copy to A
	LD	(LAB_E455),A	; save ?? number
LAB_3F7F
	LD	A,(LAB_E455)	; get ?? number
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	LD	DE,0003h		; set ?? number limit
	EX	DE,HL			; swap ?? number limit to HL
	CALL	LAB_E085		; does signed CP DE,HL. returns HL=1 if HL>DE
	JP	Z,LAB_3FCB		; jump if ?? number >=limit

	LD	HL,0002h		; set byte count
	PUSH	HL			; push byte count
	LD	A,(LAB_E455)	; get ?? number
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	ADD	HL,HL			; *2
	ADD	HL,HL			; *4 (4 bytes per entry)
	LD	DE,LAB_E22F		; set pointer to table ('OK','NO','DM')
	ADD	HL,DE			; add pointer
	PUSH	HL			; push string 2 pointer
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		; get string 1 pointer low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get string 1 pointer high byte
	EX	DE,HL			; swap to HL
	INC	HL			; increment string 1 pointer
	PUSH	HL			; push string 1 pointer
	CALL	LAB_DB40		; compare string 1 & string 2 until a difference is found,
					; string 1 terminates or byte count is reached (LAB_767B)
	POP	DE			; dump string 1 pointer
	POP	DE			; dump string 2 pointer
	POP	DE			; dump byte count
	JP	NZ,LAB_3FC8		; loop if difference found (to LAB_3F76)

	LD	A,(LAB_E455)	; get ?? number
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	ADD	HL,HL			; *2
	ADD	HL,HL			; *4 (4 bytes per entry)
	LD	DE,LAB_E232		; set pointer to table (00h,01h,02h)
	ADD	HL,DE			; add to ?? number offset
	LD	E,(HL)		; get byte
	EX	DE,HL			; swap to HL
	LD	A,L			; copy to A
	LD	(LAB_E452),A	;3FC2:	3252E4
	JP	LAB_3FCB	;3FC5:	C3CB3F

LAB_3FC8
	JP	LAB_3F76	;3FC8:	C3763F

LAB_3FCB
	JP	LAB_4003		; go get byte @ LAB_E452 & exit

; save 04h @ LAB_E452

LAB_3FCE
	LD	HL,0004h		; set HL
	LD	A,L			; copy low byte
	LD	(LAB_E452),A	; save byte
	JP	LAB_4003		; go get byte @ LAB_E452 & exit

; save 05h @ LAB_E452

LAB_3FD8
	LD	HL,0005h		; set HL
	LD	A,L			; copy low byte
	LD	(LAB_E452),A	; save byte
	JP	LAB_4003		; go get byte @ LAB_E452 & exit

; save 06h @ LAB_E452

LAB_3FE2
	LD	HL,0006h		; set HL
	LD	A,L			; copy low byte
	LD	(LAB_E452),A	; save byte
	JP	LAB_4003		; go get byte @ LAB_E452 & exit

; search table for HL, and execute

LAB_3FEC
	CALL	LAB_E0B2		; search following table for HL & execute vector

	DW	0004h			; 4 entries
	DW	0000h
	DW	LAB_3F5B		; save 03h @ LAB_E452
	DW	0004h
	DW	LAB_3FCE		; save 04h @ LAB_E452
	DW	0008h
	DW	LAB_3F65
	DW	0009h
	DW	LAB_3FD8		; save 05h @ LAB_E452
	DW	LAB_3FE2		; save 06h @ LAB_E452

; get byte from LAB_E452 in HL

LAB_4003
	LD	A,(LAB_E452)	; get byte
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	RET				;

; message out to ??, continues until 00h chr found

; stack is ..
; message pointer
; end.

LAB_400A
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6)
LAB_4010
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	PUSH	HL			; save pointer
	LD	A,(HL)		; get message pointer low byte
	INC	HL			; increment pointer
	LD	H,(HL)		; get message pointer high byte
	LD	L,A			; copy message pointer low byte
	INC	HL			; increment message pointer
	EX	DE,HL			; copy to DE
	POP	HL			; get pointer back
	LD	(HL),E		; save message pointer low byte
	INC	HL			; increment pointer
	LD	(HL),D		; save message pointer high byte
	EX	DE,HL			; copy message pointer to HL
	DEC	HL			; decrement message pointer
	LD	E,(HL)		; get message byte
	EX	DE,HL			; copy to L
	LD	A,L			; copy to A
	LD	(LAB_E456),A	; save message byte
	LD	A,L			; copy to A again (!)
	OR	L			; set the flags
	JP	Z,LAB_403A		; exit if null chr (RET Z is better!)

	LD	A,(LAB_E456)	; else get message byte back
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	PUSH	HL			; onto stack
	CALL	LAB_F140	;4033:	CD40F1
	POP	DE			; dump message byte
	JP	LAB_4010		; go do it all again

LAB_403A
	RET				;

; construct null terminated decimal string at destination

; stack is ..
; number
; destination
; length
; fill character
; end.

LAB_403B
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6)
	LD	HL,0001h		; set HL
	LD	(LAB_E459),HL	; set leading zero flag
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 2 before call
	LD	E,(HL)		; get length low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get length high byte
	EX	DE,HL			; swap to HL
	DEC	HL			; -1
	LD	(LAB_E457),HL	; save offset
	JP	LAB_405D		; skip decrement

; if we put the next line at the tail of the loop we could lose the DEC, JP
; and the LD from the line above ....

LAB_4056
	LD	HL,(LAB_E457)	; get offset
	DEC	HL			; decrement it
	LD	(LAB_E457),HL	; save offset
LAB_405D
	LD	HL,(LAB_E457)	; get offset (don't need this)
	LD	DE,0000h		; set compare value
	EX	DE,HL			; swap offset & compare value
	CALL	LAB_E06A		; does signed CP DE,HL. returns HL=1 if HL<=DE
	JP	Z,LAB_40A2		; jump if offset -ve (we're done)

	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		; get number low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get number high byte
	LD	HL,000Ah		; 10d for MOD
	CALL	LAB_DF74		; does signed HL = DE MOD HL (LAB_7AAF)
	LD	DE,0030h		; = "0"
	ADD	HL,DE			; convert 1's to digit
	PUSH	HL			; save 1's digit
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 1 before call
	LD	E,(HL)		; get destination low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get destination high byte
	LD	HL,(LAB_E457)	; get offset
	ADD	HL,DE			; add offset to destination
	POP	DE			; restore 1's digit
	LD	(HL),E		; save 1's digit to destination
	LD	HL,000Ah		; divide by 10
	EX	DE,HL			; swap to DE
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	PUSH	HL			; save last pushed pointer
	LD	A,(HL)		; get number low byte
	INC	HL			; increment pointer
	LD	H,(HL)		; get number high byte
	LD	L,A			; copy number low byte to L
	EX	DE,HL			; number to DE, 10d to HL
	CALL	LAB_DF5F		; do signed HL = DE/HL (LAB_7A9A)
	EX	DE,HL			; result to DE
	POP	HL			; restore last pushed pointer
	LD	(HL),E		; save new number low byte
	INC	HL			; increment pointer
	LD	(HL),D		; save new number high byte byte
	JP	LAB_4056		; loop

LAB_40A2
	LD	HL,0000h		; clear HL
	LD	(LAB_E457),HL	; clear offset
	JP	LAB_40B2		; skip increment

LAB_40AB
	LD	HL,(LAB_E457)	; get offset
	INC	HL			; +1
	LD	(LAB_E457),HL	; save offset
LAB_40B2
	LD	HL,(LAB_E457)	; get offset
	EX	DE,HL			; swap to DE
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 2 before call
	LD	A,(HL)		; get length low byte
	INC	HL			; increment pointer
	LD	H,(HL)		; get length high byte
	LD	L,A			; copy low byte to L
	CALL	LAB_E085		; does signed CP DE,HL. returns HL=1 if HL>DE
	JP	Z,LAB_4102		; jump if length <= offset

	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 1 before call
	LD	E,(HL)		; get destination low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get destination high byte
	LD	HL,(LAB_E457)	; get offset
	ADD	HL,DE			; add destination
	LD	E,(HL)		; get byte
	LD	D,#00h		; clear high byte
	LD	HL,0030h		; compare value is "0"
	CALL	LAB_E04B		; compare HL with DE, return HL=0 & Zb=1 if different
	JP	Z,LAB_40F9		; jump if not "0"

	LD	HL,(LAB_E459)	; get leading zero flag
	LD	A,H			; set the flags
	OR	L			;
	JP	Z,LAB_40F9		; jump if not a leading zero

	LD	HL,0012h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 3 before call
	LD	E,(HL)		; get fill character
	PUSH	DE			; save fill character
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 1 before call
	LD	E,(HL)		; get destination low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get destination high byte
	LD	HL,(LAB_E457)	; get offset
	ADD	HL,DE			; add destination
	POP	DE			; restore fill character
	LD	(HL),E		; save to string
	JP	LAB_40FF		; skip the flag clear

LAB_40F9
	LD	HL,0000h		; clear HL
	LD	(LAB_E459),HL	; clear leading zero flag
LAB_40FF
	JP	LAB_40AB		; loop for next digit

LAB_4102
	LD	HL,(LAB_E459)	; get leading zero flag
	LD	A,H			; set the flags
	OR	L			;
	JP	Z,LAB_4121		; jump if non zero digits

	LD	HL,0030h		; "0"
	PUSH	HL			; save it
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 1 before call
	LD	E,(HL)		; get destination low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get destination high byte
	LD	HL,0012h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 2 before call
	LD	A,(HL)		; get length low byte
	INC	HL			; increment pointer
	LD	H,(HL)		; get length high byte
	LD	L,A			; copy low byte to L
	ADD	HL,DE			; add destination
	DEC	HL			; -1
	POP	DE			; get "0" back
	LD	(HL),E		; make string end in "0"
LAB_4121
	LD	HL,0000h		; end byte 00h
	PUSH	HL			; save end byte
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 1 before call
	LD	E,(HL)		; get destination low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get destination high byte
	LD	HL,0012h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 2 before call
	LD	A,(HL)		; get length low byte
	INC	HL			; increment pointer
	LD	H,(HL)		; get length high byte
	LD	L,A			; copy low byte to L
	ADD	HL,DE			; add destination
	POP	DE			; get end byte back
	LD	(HL),E		; terminate string
	RET				;

; build decimal string and output

; stack is ..
; number
; length
; fill character
; end.

LAB_4138
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6)
	LD	HL,000Ah		; set count
	PUSH	HL			; push count
	LD	HL,LAB_E45B		; set destination
	PUSH	HL			; push destination
	CALL	LAB_3CA3		; fill count bytes, from destination, with 00h
	POP	DE			; dump destination
	POP	DE			; dump count
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 2 before call
	LD	E,(HL)		; get fill character low byte
	LD	D,#00h		; clear high byte
	PUSH	DE			; save fill character
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 1 before call
	LD	E,(HL)		; get length low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get length high byte
	PUSH	DE			; save length
	LD	HL,LAB_E45B		; set string destination
	PUSH	HL			; save string destination
	LD	HL,0012h		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		; get number low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get number high byte
	PUSH	DE			; save number
	CALL	LAB_403B		; construct null terminated decimal string at destination
	EX	DE,HL			;
	LD	HL,0008h		; 8 ..
	ADD	HL,SP			; .. + stack ..
	LD	SP,HL			; .. = dump the lot
	LD	HL,LAB_E45B		; point to constructed string
	PUSH	HL			; push message pointer
	CALL	LAB_400A		; message out to ??, continues until 00h chr found
	POP	DE			; dump message pointer
	RET				;

; set cursor x,y

; stack is ..
; x
; y
; end.

LAB_4179
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6)
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		; get x low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get x high byte
	EX	DE,HL			; swap to HL
	DEC	HL			; decrement x
	PUSH	HL			; push x
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 1 before call
	LD	E,(HL)		; get y low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get y high byte
	EX	DE,HL			; swap y to HL
	DEC	HL			; decrement y
	PUSH	HL			; push y
	CALL	LAB_F14C		; set cursor x,y
	POP	DE			; dump y
	POP	DE			; dump x
	RET				;

; output +(LAB_E6CD)d at 10h,(LAB_E6CF)

LAB_4199
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6)
	LD	HL,(LAB_E6CD)	; get number ??
	INC	HL			; increment it
	LD	(LAB_E6CD),HL	; save number ??
	LD	A,(LAB_E6CF)	; get y
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	PUSH	HL			; push y
	LD	HL,0010h		; x = 16d
	PUSH	HL			; push x
	CALL	LAB_4179		; set cursor x,y
	POP	DE			; dump x
	POP	DE			; dump y
	LD	HL,0001h	;41B6:	210100
	PUSH	HL		;41B9:	E5
	CALL	LAB_F138	;41BA:	CD38F1
	POP	DE		;41BD:	D1
	LD	HL,0020h		; fill character is " "
	PUSH	HL			; push fill character
	LD	HL,0004h		; 4 characters long
	PUSH	HL			; push length
	LD	HL,(LAB_E6CD)	; get number ??
	PUSH	HL			; push number
	CALL	LAB_4138		; build decimal string and output
	POP	DE			; dump number
	POP	DE			; dump length
	POP	DE			; dump fill character
	LD	HL,0000h	;41D0:	210000
	PUSH	HL		;41D3:	E5
	CALL	LAB_F138	;41D4:	CD38F1
	POP	DE		;41D7:	D1
	RET				;

; print message @ line

; stack is ..
; line #
; message pointer
; end.

LAB_41D9
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6)
	LD	HL,0014h		; clear whole width
	PUSH	HL			; push x size
	LD	HL,0001h		; clear one line
	PUSH	HL			; push y size
	LD	HL,0000h		; start at x = 0
	PUSH	HL			; push x
	LD	HL,0012h		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		; get line # low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get line # high byte
	EX	DE,HL			; swap to HL
	DEC	HL			; -1 (convert 1-8 to 0-7)
	PUSH	HL			; push line #-1
	CALL	LAB_F11C		; clear screen area
	EX	DE,HL			; unused
	LD	HL,0008h		; 8 ..
	ADD	HL,SP			; .. + stack ..
	LD	SP,HL			; .. = dump the lot
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		; get line # low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get line # high byte
	PUSH	DE			; push line #
	LD	HL,0001h		; x = 1
	PUSH	HL			; push x
	CALL	LAB_4179		; set cursor x,y
	POP	DE			; dump x
	POP	DE			; dump y
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 1 before call
	LD	E,(HL)		; get message pointer low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get message pointer high byte
	PUSH	DE			; push message pointer
	CALL	LAB_400A		; message out to ??, continues until 00h chr found
	POP	DE			; dump message pointer
	RET				;

; print message @ line, with bells on

; stack is ..
; line #
; message pointer
; bell flag ??
; end.

LAB_421C
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6)
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 2 before call
	LD	A,(HL)		; get #2 low byte
	INC	HL			; increment pointer
	OR	(HL)			; OR with #2 high byte
	JP	Z,LAB_422F		; jump if null

	CALL	LAB_F118		; send BELL character to console
LAB_422F
	LD	HL,0001h	;422F:	210100
	PUSH	HL		;4232:	E5
	CALL	LAB_F138	;4233:	CD38F1
	POP	DE		;4236:	D1
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 1 before call
	LD	E,(HL)		; get message pointer low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get message pointer high byte
	PUSH	DE			; push message pointer
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		; get line # low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get line # high byte
	PUSH	DE			; push line #
	CALL	LAB_41D9		; print message @ line
	POP	DE			; dump line #
	LD	HL,0000h	; zero
	PUSH	HL		;424F:	E5
	CALL	LAB_F138	;4250:	CD38F1
	POP	DE		; dump 0000h
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 1 before call
	LD	A,(HL)		; get message pointer low byte
	INC	HL			; increment pointer
	OR	(HL)			; OR message pointer high byte
	JP	Z,LAB_4261		; exit if message pointer null (RET Z is better!)

	CALL	LAB_F118		; send BELL character to console
LAB_4261
	RET				;

; null routine

LAB_4262
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6)
	RET				; (does nothing, returns with HL as return address)

LAB_4269
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6)
	LD	HL,0014h	;426F:	211400
	PUSH	HL		;4272:	E5
	LD	HL,0008h	;4273:	210800
	PUSH	HL		;4276:	E5
	LD	HL,0000h	;4277:	210000
	PUSH	HL		;427A:	E5
	LD	HL,0000h	;427B:	210000
	PUSH	HL		;427E:	E5
	CALL	LAB_F11C		; clear screen area
	EX	DE,HL		;4282:	EB
	LD	HL,0008h		; 8 ..
	ADD	HL,SP			; .. + stack ..
	LD	SP,HL			; .. = dump the lot
	LD	HL,LAB_6E71		; points to ' Comms in progress'
	PUSH	HL			; push message pointer
	LD	HL,0001h		; line # 1
	PUSH	HL			; push line #
	CALL	LAB_41D9		; print message @ line
	POP	DE			; dump line #
	POP	DE			; dump message pointer
	RET				;

; print 4 line message ???

; stack is ..
; message pointer (line 3)
; message pointer (line 4)
; message pointer (line 5)
; message pointer (line 6)
; end.

LAB_4296
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6)
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		; get message pointer low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get message pointer high byte
	PUSH	DE			; push message pointer
	LD	HL,0003h		; line 3
	PUSH	HL			; push line #
	CALL	LAB_41D9		; print message @ line
	POP	DE			; dump line #
	POP	DE			; dump message pointer
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 1 before call
	LD	E,(HL)		; get message pointer low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get message pointer high byte
	PUSH	DE			; push message pointer
	LD	HL,0004h		; line 4
	PUSH	HL			; push line #
	CALL	LAB_41D9		; print message @ line
	POP	DE			; dump line #
	POP	DE			; dump message pointer
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 2 before call
	LD	E,(HL)		; get message pointer low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get message pointer high byte
	PUSH	DE			; push message pointer
	LD	HL,0005h		; line 5
	PUSH	HL			; push line #
	CALL	LAB_41D9		; print message @ line
	POP	DE			; dump line #
	POP	DE			; dump message pointer
	LD	HL,0012h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 3 before call
	LD	E,(HL)		; get message pointer low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get message pointer high byte
	PUSH	DE			; push message pointer
	LD	HL,0006h		; line 6
	PUSH	HL			; push line #
	CALL	LAB_41D9		; print message @ line
	POP	DE			; dump line #
	POP	DE			; dump message pointer
	LD	HL,LAB_E23B		; set message pointer
	PUSH	HL			; push message pointer
	LD	HL,0008h		; line 8
	PUSH	HL			; push line #
	CALL	LAB_41D9		; print message @ line
	POP	DE			; dump line #
	POP	DE			; dump message pointer
	RET				;

; wait (LAB_E6FD) seconds or do press to cont

LAB_42EE
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6)
	LD	HL,(LAB_E6FD)	; get delay time
	LD	A,H			; set the flags
	OR	L			;
	JP	Z,LAB_4307		; jump if no timeout

	LD	HL,(LAB_E6FD)	; else get delay
	PUSH	HL			; push elapsed seconds
	CALL	LAB_64A6		; wait for elapsed seconds
	POP	DE			; dump elapsed seconds
	JP	LAB_4332		; exit (RET would be better)

LAB_4307
	LD	HL,LAB_6E84		; points to 'Press >> to continue'
	PUSH	HL			; push message pointer
	LD	HL,0008h		; line 8
	PUSH	HL			; push line #
	CALL	LAB_41D9		; print message @ line
	POP	DE			; dump line #
	POP	DE			; dump message pointer
	CALL	LAB_F118		; send BELL character to console
LAB_4317
	CALL	LAB_65C2		; get byte from key buffer ??
	LD	DE,000Dh		; set compare byte=[ENTER]
	CALL	LAB_E05A		; compare HL with DE, return HL=0 & Zb=1 if the same
	JP	Z,LAB_4326		; exit if [ENTER] was pressed

	JP	LAB_4317		; else loop

LAB_4326
	CALL	LAB_666B		; get key status without waiting
	JP	Z,LAB_4332		; exit if no key waiting

	CALL	LAB_65C2		; get byte from key buffer ??
	JP	LAB_4326		; loop until key released

LAB_4332
	RET				;

; clear byte (LAB_E22D), word (LAB_E6C0) & word (LAB_E6E2)

LAB_4333
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6)
	CALL	LAB_42EE		; wait (LAB_E6FD) seconds or do press to cont
	LD	HL,000Dh		; set status message # = 0Dh
	PUSH	HL			; push status message #
	CALL	LAB_3BF5		; save (byte) at (LAB_E22D)
	POP	DE			; dump status message #
	LD	HL,0000h	;4344:	210000
	LD	(LAB_E6C0),HL	;4347:	22C0E6
	LD	HL,0000h	;434A:	210000
	LD	(LAB_E6E2),HL	;434D:	22E2E6
	RET				;

; do error (number)d,"(",(LAB_E701)d,"/",(LAB_E6FF)d,")"

; stack is ..
; number
; message pointer
; vector
; end.

LAB_4351
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6)
	LD	HL,0020h		; set fill character to " "
	PUSH	HL			; push fill character
	LD	HL,000Bh		; set length
	PUSH	HL			; push length
	LD	HL,LAB_E465		; set destination
	PUSH	HL			; push destination
	LD	HL,0012h		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		; get number low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get number high byte
	PUSH	DE			; push number
	CALL	LAB_403B		; construct null terminated decimal string at destination
	EX	DE,HL			;
	LD	HL,0008h		; 8 ..
	ADD	HL,SP			; .. + stack ..
	LD	SP,HL			; .. = dump the lot
	LD	HL,0030h		; set fill character to "0"
	PUSH	HL			; push fill character
	LD	HL,0003h		; set length
	PUSH	HL			; push length
	LD	HL,LAB_E480		; set destination
	PUSH	HL			; push destination
	LD	HL,(LAB_E701)	;4380:	2A01E7
	PUSH	HL			; push number
	CALL	LAB_403B		; construct null terminated decimal string at destination
	EX	DE,HL			;
	LD	HL,0008h		; 8 ..
	ADD	HL,SP			; .. + stack ..
	LD	SP,HL			; .. = dump the lot
	LD	HL,0030h		; set fill character to "0"
	PUSH	HL			; push fill character
	LD	HL,0003h		; set length
	PUSH	HL			; push length
	LD	HL,LAB_E484		; set destination
	PUSH	HL			; push destination
	LD	HL,(LAB_E6FF)	;4399:	2AFFE6
	PUSH	HL			; push number
	CALL	LAB_403B		; construct null terminated decimal string at destination
	EX	DE,HL			;
	LD	HL,0008h		; 8 ..
	ADD	HL,SP			; .. + stack ..
	LD	SP,HL			; .. = dump the lot
	LD	HL,LAB_E23C		; set source pointer to '     ('
	PUSH	HL			; push source pointer
	LD	HL,LAB_E471		; set destination pointer
	PUSH	HL			; push destination pointer
	CALL	LAB_DB6D		; copy null terminated string from
					; source to destination
	POP	DE			; dump destination pointer
	POP	DE			; dump source pointer
	LD	HL,LAB_E480		; set source pointer to decimal string from (LAB_E701)
	PUSH	HL			; push source pointer
	LD	HL,LAB_E471		; set destination pointer
	PUSH	HL			; push destination pointer
	CALL	LAB_DBB1		; append null terminated string from
					; source to destination (LAB_76EC)
	POP	DE			; dump destination pointer
	POP	DE			; dump source pointer
	LD	HL,LAB_E243		; set source pointer to '/'
	PUSH	HL			; push source pointer
	LD	HL,LAB_E471		; set destination pointer
	PUSH	HL			; push destination pointer
	CALL	LAB_DBB1		; append null terminated string from
					; source to destination (LAB_76EC)
	POP	DE			; dump destination pointer
	POP	DE			; dump source pointer
	LD	HL,LAB_E484		; set source pointer to decimal string from (LAB_E6FF)
	PUSH	HL			; push source pointer
	LD	HL,LAB_E471		; set destination pointer
	PUSH	HL			; push destination pointer
	CALL	LAB_DBB1		; append null terminated string from
					; source to destination (LAB_76EC)
	POP	DE			; dump destination pointer
	POP	DE			; dump source pointer
	LD	HL,LAB_E245		; set source pointer to ')'
	PUSH	HL			; push source pointer
	LD	HL,LAB_E471		; set destination pointer
	PUSH	HL			; push destination pointer
	CALL	LAB_DBB1		; append null terminated string from
					; source to destination (LAB_76EC)
	POP	DE			; dump destination pointer
	POP	DE			; dump source pointer
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 1 before call
	LD	E,(HL)		; get message#1 pointer low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get message#1 pointer high byte
	PUSH	DE			; push line 6 message#1 pointer
	LD	HL,LAB_E471		; point to constructed string
	PUSH	HL			; push line 5 message pointer
	LD	HL,LAB_E465		; set pointer to to decimal string from last pushed
	PUSH	HL			; push line 4 message pointer
	LD	HL,LAB_6E99		; points to '   *** ERROR ***'
	PUSH	HL			; push line 3 message pointer
	CALL	LAB_4296		; print 4 line message ???
	EX	DE,HL			;
	LD	HL,0008h		; 8 ..
	ADD	HL,SP			; .. + stack ..
	LD	SP,HL			; .. = dump the lot
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		; get number low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get number high byte
	EX	DE,HL			; copy to HL
	LD	(LAB_E6FA),HL	; save number @ LAB_E6FA
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 2 before call
	LD	E,(HL)		; get vector low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get vector high byte
	EX	DE,HL			; swap vector into HL
	CALL	LAB_D828		; does set page (if HL<ED00h) and JP (HL)
	RET				;

; do error number, message message pointer then
; do wait (LAB_E6FD) seconds or do press to cont

; stack is ..
; number
; message pointer
; end.

LAB_441B
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6)
	LD	HL,LAB_EDAC		; set vector (LAB_42EE)
					; (wait (LAB_E6FD) seconds or do press to cont)
	PUSH	HL			; push vector
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 1 before call
	LD	E,(HL)		; get message pointer low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get message pointer high byte
	PUSH	DE			; push message pointer
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		; get number low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get number high byte
	PUSH	DE			; push number
	CALL	LAB_4351		; do error (number)d,"(",(LAB_E701)d,"/",(LAB_E6FF)d,")"
	POP	DE			; dump number
	POP	DE			; dump message pointer
	POP	DE			; dump vector
	RET				;

; do error number, message message pointer then
; clear byte (LAB_E22D), word (LAB_E6C0) & word (LAB_E6E2)

; stack is ..
; number
; message pointer
; end.

LAB_443C
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6)
	LD	HL,LAB_ED70		; set vector (LAB_4333)
					; clear byte (LAB_E22D), word (LAB_E6C0) & word (LAB_E6E2)
	PUSH	HL			; push vector
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 1 before call
	LD	E,(HL)		; get message pointer low
	INC	HL			; increment pointer
	LD	D,(HL)		; get message pointer high
	PUSH	DE			; push message pointer
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		; get number low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get number high byte
	PUSH	DE			; push number
	CALL	LAB_4351		; do error (number)d,"(",(LAB_E701)d,"/",(LAB_E6FF)d,")"
	POP	DE			; dump number
	POP	DE			; dump message pointer
	POP	DE			; dump vector
	RET				;

; do 'Plinth not connected' message
; stack is ..
; number
; end.

LAB_445D
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6)
	LD	HL,LAB_6D6F		; points to 'Plinth not connected'
	PUSH	HL			; push message pointer
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		; get number low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get number high byte
	PUSH	DE			; push number
	CALL	LAB_443C		; do error number, message message pointer then ??
	POP	DE			; dump number
	POP	DE			; dump message pointer
	RET				;

; do '      Timeout' message

; stack is ..
; number
; end.

LAB_4475
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6)
	LD	HL,LAB_6E20		; points to '      Timeout'
	PUSH	HL			; push message pointer
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		; get number low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get number high byte
	PUSH	DE			; push number
	CALL	LAB_443C		; do error number, message message pointer then ??
	POP	DE			; dump number
	POP	DE			; dump message pointer
	RET				;

; do '    Link failure' message

; stack is ..
; number
; end.

LAB_448D
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6)
	LD	HL,LAB_6D5E		; points to '    Link failure'
	PUSH	HL			; push message pointer
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		; get number low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get number high byte
	PUSH	DE			; push number
	CALL	LAB_443C		; do error number, message message pointer then ??
	POP	DE			; dump number
	POP	DE			; dump message pointer
	RET				;

; do ' Failed to connect' message

; stack is ..
; number
; end.

LAB_44A5
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6)
	LD	HL,LAB_6D94		; points to ' Failed to connect'
	PUSH	HL			; push message pointer
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		; get number low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get number high byte
	PUSH	DE			; push number
	CALL	LAB_443C		; do error number, message message pointer then ??
	POP	DE			; dump number
	POP	DE			; dump message pointer
	RET				;

; do '   Invalid reply' message

; stack is ..
; number
; end.

LAB_44BD
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6)
	LD	HL,LAB_6DE9		; points to '   Invalid reply'
	PUSH	HL			; push message pointer
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		; get number low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get number high byte
	PUSH	DE			; push number
	CALL	LAB_443C		; do error number, message message pointer then ??
	POP	DE			; dump number
	POP	DE			; dump message pointer
	RET				;

; do '    Modem fault' message

; stack is ..
; number
; end.

LAB_44D5
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6)
	LD	HL,LAB_6D84		; points to '    Modem fault'
	PUSH	HL			; push message pointer
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		; get number low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get number high byte
	PUSH	DE			; push number
	CALL	LAB_443C		; do error number, message message pointer then ??
	POP	DE			; dump number
	POP	DE			; dump message pointer
	RET				;

; print empty 4 line message

LAB_44ED
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6)
	LD	HL,LAB_E274		; null message
	PUSH	HL			; push line 6 message pointer
	LD	HL,LAB_E273		; null message
	PUSH	HL			; push line 5 message pointer
	LD	HL,LAB_E272		; null message
	PUSH	HL			; push line 4 message pointer
	LD	HL,LAB_E271		; null message
	PUSH	HL			; push line 3 message pointer
	CALL	LAB_4296		; print 4 line message ??
	EX	DE,HL			;
	LD	HL,0008h		; 8 ..
	ADD	HL,SP			; .. + stack ..
	LD	SP,HL			; .. = dump the lot
	RET				;

; print logged on message

LAB_450D
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6)
	LD	HL,LAB_E277		; null message
	PUSH	HL			; push line 6 message pointer
	LD	HL,LAB_E276		; null message
	PUSH	HL			; push line 5 message pointer
	LD	HL,LAB_E275		; null message
	PUSH	HL			; push line 4 message pointer
	LD	HL,LAB_6DCA		; points to '     Logged on'
	PUSH	HL			; push line 3 message pointer
	CALL	LAB_4296		; print 4 line message ???
	EX	DE,HL			;
	LD	HL,0008h		; 8 ..
	ADD	HL,SP			; .. + stack ..
	LD	SP,HL			; .. = dump the lot
	RET				;

; stack is ..
; byte
; end.

LAB_452D
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6)
	LD	A,(LAB_E48D)	;4533:	3A8DE4
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	LD	DE,0002h	;4539:	110200
	CALL	LAB_E04B		; compare HL with DE, return HL=0 & Zb=1 if different
	JP	Z,LAB_454B	;453F:	CA4B45

	LD	HL,0000h	;4542:	210000
	LD	(LAB_E512),HL	;4545:	2212E5
	JP	LAB_455F		; exit

LAB_454B
	LD	HL,LAB_E48C		; point to status message #
	PUSH	HL			; push status message # pointer
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		; get message # ??
	LD	D,#00h		; clear high byte
	PUSH	DE			; push message #
	CALL	LAB_3C06	;4557:	CD063C
	POP	DE			; dump message #
	POP	DE			; dump pointer
	LD	(LAB_E512),HL	;455C:	2212E5
LAB_455F
	LD	HL,(LAB_E512)	;455F:	2A12E5
	RET				;

; stack is ..
; ??
; ??
; ?? byte #_2
; ??
; ??
; ?? pointer
; ?? pointer #_6
; ?? pointer
; ?? pointer
; ?? pointer

LAB_4563
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6)
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 2 before call
	LD	E,(HL)		;456D:	5E
	EX	DE,HL		;456E:	EB
	LD	A,L		;456F:	7D
	LD	(LAB_E48D),A	;4570:	328DE4
	LD	HL,0000h	;4573:	210000
	PUSH	HL		;4576:	E5
	CALL	LAB_452D	;4577:	CD2D45
	POP	DE		;457A:	D1
	LD	(LAB_E488),HL	;457B:	2288E4
	LD	A,H			; set the flags
	OR	L			;
	JP	NZ,LAB_46E5		; exit

	LD	HL,0037h	;4583:	213700
	LD	A,L		;4586:	7D
	LD	(LAB_E6FC),A	;4587:	32FCE6
	LD	HL,0000h	;458A:	210000
	LD	(LAB_E6C0),HL	;458D:	22C0E6
	LD	HL,0000h	;4590:	210000
	LD	(LAB_E6E2),HL	;4593:	22E2E6
	LD	HL,0000h	;4596:	210000
	LD	A,L		;4599:	7D
	LD	(LAB_E6CF),A	;459A:	32CFE6
	LD	HL,0000h	;459D:	210000
	LD	(LAB_E6FA),HL	;45A0:	22FAE6
	LD	HL,0000h	;45A3:	210000
	LD	(LAB_E6CD),HL	;45A6:	22CDE6
	LD	HL,0000h	;45A9:	210000
	LD	(LAB_E6C2),HL	;45AC:	22C2E6
	LD	HL,0000h	;45AF:	210000
	LD	(LAB_E6E4),HL	;45B2:	22E4E6
	LD	HL,0000h	;45B5:	210000
	LD	(LAB_E6F8),HL	;45B8:	22F8E6
	LD	HL,0000h	;45BB:	210000
	LD	(LAB_E703),HL	;45BE:	2203E7
	LD	HL,0000h	;45C1:	210000
	LD	(LAB_E701),HL	;45C4:	2201E7
	LD	HL,0000h	;45C7:	210000
	LD	(LAB_E6FF),HL	;45CA:	22FFE6

	LD	HL,0008h		; set byte count
	PUSH	HL			; push byte count
	LD	HL,0018h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 5 before call
	LD	E,(HL)		; get source pointer low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get source pointer high byte
	PUSH	DE			; push source pointer
	LD	HL,LAB_E6D0		; set destination pointer
	PUSH	HL			; push destination pointer
	CALL	LAB_DB89		; copy byte count bytes of null terminated
					; string from source to destination. pad
					; with nulls if needed (LAB_76C4)
	POP	DE			; dump destination pointer
	POP	DE			; dump source pointer
	POP	DE			; dump byte count
	LD	HL,0000h	;45E3:	210000
	LD	A,L		;45E6:	7D
	LD	(LAB_E6D8),A	;45E7:	32D8E6
	LD	HL,0006h		; set byte count
	PUSH	HL			; save byte count
	LD	HL,001Ah		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 6 before call
	LD	E,(HL)		; get source pointer low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get source pointer high byte
	PUSH	DE			; push source pointer
	LD	HL,LAB_E6E8		; set destination pointer
	PUSH	HL			; push destination pointer
	CALL	LAB_DB89		; copy byte count bytes of null terminated
					; string from source to destination. pad
					; with nulls if needed (LAB_76C4)
	POP	DE			; dump destination pointer
	POP	DE			; dump source pointer
	POP	DE			; dump byte count
	LD	HL,0000h	;4600:	210000
	LD	A,L		;4603:	7D
	LD	(LAB_E6EE),A	;4604:	32EEE6
	LD	HL,0008h		; set byte count
	PUSH	HL			; save byte count
	LD	HL,001Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 7 before call
	LD	E,(HL)		; get source pointer low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get source pointer high byte
	PUSH	DE			; push source pointer
	LD	HL,LAB_E6EF		; set destination pointer
	PUSH	HL			; push destination pointer
	CALL	LAB_DB89		; copy byte count bytes of null terminated
					; string from source to destination. pad
					; with nulls if needed (LAB_76C4)
	POP	DE			; dump destination pointer
	POP	DE			; dump source pointer
	POP	DE			; dump byte count
	LD	HL,0000h	;461D:	210000
	LD	A,L		;4620:	7D
	LD	(LAB_E6F7),A	;4621:	32F7E6
	LD	HL,0008h		; set byte count
	PUSH	HL			; save byte count
	LD	HL,001Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 8 before call
	LD	E,(HL)		; get source pointer low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get source pointer high byte
	PUSH	DE			; push source pointer
	LD	HL,LAB_E6C4		; set destination pointer
	PUSH	HL			; push destination pointer
	CALL	LAB_DB89		; copy byte count bytes of null terminated
					; string from source to destination. pad
					; with nulls if needed (LAB_76C4)
	POP	DE			; dump destination pointer
	POP	DE			; dump source pointer
	POP	DE			; dump byte count
	LD	HL,0000h	;463A:	210000
	LD	A,L		;463D:	7D
	LD	(LAB_E6CC),A	;463E:	32CCE6
	LD	HL,0008h		; set byte count
	PUSH	HL			; save byte count
	LD	HL,0020h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 9 before call
	LD	E,(HL)		; get source pointer low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get source pointer high byte
	PUSH	DE			; push source pointer
	LD	HL,LAB_E6D9		; set destination pointer
	PUSH	HL			; push destination pointer
	CALL	LAB_DB89		; copy byte count bytes of null terminated
					; string from source to destination. pad
					; with nulls if needed (LAB_76C4)
	POP	DE			; dump destination pointer
	POP	DE			; dump source pointer
	POP	DE			; dump byte count
	LD	HL,0000h	;4657:	210000
	LD	A,L		;465A:	7D
	LD	(LAB_E6E1),A	;465B:	32E1E6
	LD	HL,0000h		; set cursor flag
	PUSH	HL			; push it
	CALL	LAB_F120		; set cursor blink on/off
	POP	DE			; dump cursor flag
	CALL	LAB_4269	;4666:	CD6942
	LD	HL,0014h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 4 before call
	LD	E,(HL)		;466D:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;466F:	56
	PUSH	DE		;4670:	D5
	LD	HL,0014h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 3 before call
	LD	E,(HL)		;4675:	5E
	LD	D,#00h		; clear high byte
	PUSH	DE		;4678:	D5
	LD	HL,0012h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 1 before call
	LD	E,(HL)		;467D:	5E
	LD	D,#00h		; clear high byte
	PUSH	DE		;4680:	D5
	LD	HL,0012h		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;4685:	5E
	LD	D,#00h		; clear high byte
	PUSH	DE		;4688:	D5
	CALL	LAB_5669	;4689:	CD6956
	EX	DE,HL		;468C:	EB
	LD	HL,0008h		; 8 ..
	ADD	HL,SP			; .. + stack ..
	LD	SP,HL			; .. = dump the lot
	EX	DE,HL		;4692:	EB
	LD	(LAB_E488),HL	;4693:	2288E4
	LD	HL,(LAB_E488)	;4696:	2A88E4
	JP	LAB_46D6		; search table for HL, and execute

LAB_469C
	LD	A,(LAB_E48C)	; get status message #
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	PUSH	HL			; push status message #
	CALL	LAB_3BF5		; save (byte) at (LAB_E22D)
	POP	DE			; dump status message #
	JP	LAB_46E5	;46A7:	C3E546

; do error 8001, plinth not connected

LAB_46AA
	LD	HL,1F41h		; set error number 8001d
	PUSH	HL			; push number
	CALL	LAB_445D		; do 'Plinth not connected' message
	POP	DE			; dump number
	LD	HL,0000h		; set status message # = 0
	PUSH	HL			; push status message #
	CALL	LAB_3BF5		; save (byte) at (LAB_E22D)
	POP	DE			; dump status message #
	JP	LAB_46E5	;46BA:	C3E546

; do (LAB_E488)=0006h, error 8000, plinth not connected

LAB_46BD
	LD	HL,0006h	;46BD:	210600
	LD	(LAB_E488),HL	;46C0:	2288E4
	LD	HL,1F40h		; set error number 8000d
	PUSH	HL			; push number
	CALL	LAB_445D		; do 'Plinth not connected' message
	POP	DE			; dump number
	LD	HL,0000h		; set status message # = 0
	PUSH	HL			; push status message #
	CALL	LAB_3BF5		; save (byte) at (LAB_E22D)
	POP	DE			; dump status message #
	JP	LAB_46E5	;46D3:	C3E546

; search table for HL, and execute

LAB_46D6
	CALL	LAB_E0B2		; search following table for HL & execute vector

	DW	0002h			; 2 entries
	DW	0000h
	DW	LAB_469C
	DW	0009h
	DW	LAB_46AA
	DW	LAB_46BD

LAB_46E5
	LD	HL,(LAB_E488)	;46E5:	2A88E4
	RET				;

LAB_46E9
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6)
	LD	HL,0002h	;46EF:	210200
	LD	A,L		;46F2:	7D
	LD	(LAB_E48D),A	;46F3:	328DE4
	LD	HL,0037h	;46F6:	213700
	LD	A,L		;46F9:	7D
	LD	(LAB_E6FC),A	;46FA:	32FCE6
	LD	HL,0000h	;46FD:	210000
	LD	(LAB_E6C0),HL	;4700:	22C0E6
	LD	HL,0000h	;4703:	210000
	LD	(LAB_E6E2),HL	;4706:	22E2E6
	LD	HL,0000h	;4709:	210000
	LD	A,L		;470C:	7D
	LD	(LAB_E6CF),A	;470D:	32CFE6
	LD	HL,0000h	;4710:	210000
	LD	(LAB_E6FA),HL	;4713:	22FAE6
	LD	HL,0000h	;4716:	210000
	LD	(LAB_E6CD),HL	;4719:	22CDE6
	LD	HL,0000h	;471C:	210000
	LD	(LAB_E6C2),HL	;471F:	22C2E6
	LD	HL,0000h	;4722:	210000
	LD	(LAB_E6E4),HL	;4725:	22E4E6
	LD	HL,0000h	;4728:	210000
	LD	(LAB_E6F8),HL	;472B:	22F8E6
	LD	HL,0000h	;472E:	210000
	LD	(LAB_E703),HL	;4731:	2203E7
	LD	HL,0000h	;4734:	210000
	LD	(LAB_E701),HL	;4737:	2201E7
	LD	HL,0000h	;473A:	210000
	LD	(LAB_E6FF),HL	;473D:	22FFE6
	LD	HL,0000h	;4740:	210000
	LD	A,L		;4743:	7D
	LD	(LAB_E6D0),A	;4744:	32D0E6
	LD	HL,0000h	;4747:	210000
	LD	A,L		;474A:	7D
	LD	(LAB_E6E8),A	;474B:	32E8E6
	LD	HL,0000h	;474E:	210000
	LD	A,L		;4751:	7D
	LD	(LAB_E6EF),A	;4752:	32EFE6
	LD	HL,0000h	;4755:	210000
	LD	A,L		;4758:	7D
	LD	(LAB_E6C4),A	;4759:	32C4E6
	LD	HL,0000h	;475C:	210000
	LD	A,L		;475F:	7D
	LD	(LAB_E6D9),A	;4760:	32D9E6
	LD	HL,0000h		; set cursor flag
	PUSH	HL			; push it
	CALL	LAB_F120		; set cursor blink on/off
	POP	DE			; dump cursor flag
	CALL	LAB_4269	;476B:	CD6942
	LD	HL,0014h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 4 before call
	LD	E,(HL)		;4772:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;4774:	56
	PUSH	DE		;4775:	D5
	LD	HL,0014h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 3 before call
	LD	E,(HL)		;477A:	5E
	LD	D,#00h		; clear high byte
	PUSH	DE		;477D:	D5
	LD	HL,0014h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 2 before call
	LD	E,(HL)		;4782:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;4784:	56
	PUSH	DE		;4785:	D5
	LD	HL,0014h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 1 before call
	LD	E,(HL)		;478A:	5E
	LD	D,#00h		; clear high byte
	PUSH	DE		;478D:	D5
	LD	HL,0014h		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;4792:	5E
	LD	D,#00h		; clear high byte
	PUSH	DE		;4795:	D5
	CALL	LAB_56A4	;4796:	CDA456
	EX	DE,HL		;4799:	EB
	LD	HL,000Ah		; 10 ..
	ADD	HL,SP			; .. + stack ..
	LD	SP,HL			; .. = dump the lot
	EX	DE,HL		;479F:	EB
	LD	(LAB_E488),HL	;47A0:	2288E4
	LD	HL,(LAB_E488)	;47A3:	2A88E4
	JP	LAB_47E3		; search table for HL, and execute

LAB_47A9
	LD	A,(LAB_E48C)	; get status message #
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	PUSH	HL			; push status message #
	CALL	LAB_3BF5		; save (byte) at (LAB_E22D)
	POP	DE			; dump status message #
	JP	LAB_47F2	;47B4:	C3F247

; do error 8001, plinth not connected

LAB_47B7
	LD	HL,1F41h		; set error number 8001d
	PUSH	HL			; push number
	CALL	LAB_445D		; do 'Plinth not connected' message
	POP	DE			; dump number
	LD	HL,0000h		; set status message # = 0
	PUSH	HL			; push status message #
	CALL	LAB_3BF5		; save (byte) at (LAB_E22D)
	POP	DE			; dump status message #
	JP	LAB_47F2	;47C7:	C3F247

; do (LAB_E488)=0006h, error 8000, plinth not connected

LAB_47CA
	LD	HL,0006h	;47CA:	210600
	LD	(LAB_E488),HL	;47CD:	2288E4
	LD	HL,1F40h		; set error number 8000d
	PUSH	HL			; push number
	CALL	LAB_445D		; do 'Plinth not connected' message
	POP	DE			; dump number
	LD	HL,0000h		; set status message # = 0
	PUSH	HL			; push status message #
	CALL	LAB_3BF5		; save (byte) at (LAB_E22D)
	POP	DE			; dump status message #
	JP	LAB_47F2	;47E0:	C3F247

; search table for HL, and execute

LAB_47E3
	CALL	LAB_E0B2		; search following table for HL & execute vector

	DW	0002h			; 2 entries
	DW	0000h
	DW	LAB_47A9
	DW	0009h
	DW	LAB_47B7
	DW	LAB_47CA

LAB_47F2
	LD	HL,(LAB_E488)	;47F2:	2A88E4
	RET				;

; stack is ..
; ??
; end.

LAB_47F6
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6)
	LD	HL,0001h	;47FC:	210100
	PUSH	HL		;47FF:	E5
	CALL	LAB_452D	;4800:	CD2D45
	POP	DE		;4803:	D1
	LD	(LAB_E488),HL	;4804:	2288E4
	LD	A,H			; set the flags
	OR	L			;
	JP	NZ,LAB_48BB	;4809:	C2BB48

	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;4810:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;4812:	56
	PUSH	DE		;4813:	D5
	CALL	LAB_56E7	;4814:	CDE756
	POP	DE		;4817:	D1
	LD	(LAB_E488),HL	;4818:	2288E4
	LD	HL,(LAB_E488)	;481B:	2A88E4
	JP	LAB_4890		; search table for HL, and execute

LAB_4821
	CALL	LAB_44ED		; print empty 4 line message
	LD	A,(LAB_E48C)	; get status message #
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	PUSH	HL			; push status message #
	CALL	LAB_3BF5		; save (byte) at (LAB_E22D)
	POP	DE			; dump status message #
	JP	LAB_48BB	;482F:	C3BB48

LAB_4832
	LD	HL,000Dh		; set status message # = 0Dh
	PUSH	HL			; push status message #
	CALL	LAB_3BF5		; save (byte) at (LAB_E22D)
	POP	DE			; dump status message #
	JP	LAB_48BB	;483A:	C3BB48

; do error 8011d, timeout

LAB_483D
	LD	HL,1F4Bh		; set error number 8011d
	PUSH	HL			; push error number
	CALL	LAB_4475		; do '      Timeout' message
	POP	DE			; dump error number
	JP	LAB_48BB	;4845:	C3BB48

LAB_4848
	LD	HL,1F4Ch		; set error number 8012d
	PUSH	HL			; push error number
	CALL	LAB_44A5		; do ' Failed to connect' message
	POP	DE			; dump error number
	JP	LAB_48BB	;4850:	C3BB48

LAB_4853
	LD	HL,1F4Dh		; set error number 8013d
	PUSH	HL			; push error number
	CALL	LAB_44A5		; do ' Failed to connect' message
	POP	DE			; dump error number
	JP	LAB_48BB	;485B:	C3BB48

LAB_485E
	LD	HL,1F4Eh		; set error number 8014d
	PUSH	HL			; push error number
	CALL	LAB_44A5		; do ' Failed to connect' message
	POP	DE			; dump error number
	JP	LAB_48BB	;4866:	C3BB48

LAB_4869
	LD	HL,1F4Fh		; set error number 8015d
	PUSH	HL			; push error number
	CALL	LAB_44A5		; do ' Failed to connect' message
	POP	DE			; dump error number
	JP	LAB_48BB	;4871:	C3BB48

LAB_4874
	LD	HL,1F50h		; set error number 8016d
	PUSH	HL			; push error number
	CALL	LAB_44D5		; do '    Modem fault' message
	POP	DE			; dump error number
	JP	LAB_48BB	;487C:	C3BB48

LAB_487F
	LD	HL,0003h	;487F:	210300
	LD	(LAB_E488),HL	;4882:	2288E4
	LD	HL,1F4Ah		; set error number 8010d
	PUSH	HL			; push error number
	CALL	LAB_44A5		; do ' Failed to connect' message
	POP	DE			; dump error number
	JP	LAB_48BB	;488D:	C3BB48

; search table for HL, and execute

LAB_4890
	CALL	LAB_E0B2		; search following table for HL & execute vector

	DW	0009h			; 9 entries
	DW	0000h
	DW	LAB_4821
	DW	0001h
	DW	LAB_4874		; do '    Modem fault' message
	DW	0004h
	DW	LAB_4832
	DW	0009h
	DW	LAB_483D		; do '      Timeout' message
	DW	000Bh
	DW	LAB_4869		; do ' Failed to connect' message
	DW	000Ch
	DW	LAB_485E		; do ' Failed to connect' message
	DW	000Fh
	DW	LAB_4874		; do '    Modem fault' message
	DW	0012h
	DW	LAB_4848		; do ' Failed to connect' message
	DW	0013h
	DW	LAB_4853		; do ' Failed to connect' message
	DW	LAB_487F		; do ' Failed to connect' message

LAB_48BB
	LD	HL,(LAB_E488)	;48BB:	2A88E4
	RET				;

; stack is ..
; ??
; end.

LAB_48BF
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6)
	LD	HL,0002h	;48C5:	210200
	PUSH	HL		;48C8:	E5
	CALL	LAB_452D	;48C9:	CD2D45
	POP	DE		;48CC:	D1
	LD	(LAB_E488),HL	;48CD:	2288E4
	LD	A,H			; set the flags
	OR	L			;
	JP	NZ,LAB_4970	;48D2:	C27049

	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;48D9:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;48DB:	56
	PUSH	DE		;48DC:	D5
	CALL	LAB_573D	;48DD:	CD3D57
	POP	DE		;48E0:	D1
	LD	(LAB_E488),HL	;48E1:	2288E4
	LD	HL,(LAB_E488)	;48E4:	2A88E4
	JP	LAB_494D		; search table for HL, and execute

LAB_48EA
	CALL	LAB_44ED		; print empty 4 line message
	LD	A,(LAB_E48C)	; set status message #
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	PUSH	HL			; push status message #
	CALL	LAB_3BF5		; save (byte) at (LAB_E22D)
	POP	DE			; dump status message #
	JP	LAB_4970	;48F8:	C37049

LAB_48FB
	LD	HL,000Dh		; set status message # = 0Dh
	PUSH	HL			; push status message #
	CALL	LAB_3BF5		; save (byte) at (LAB_E22D)
	POP	DE			; dump status message #
	JP	LAB_4970	;4903:	C37049

LAB_4906
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	A,(HL)		;490A:	7E
	INC	HL			; increment pointer
	OR	(HL)		;490C:	B6
	JP	NZ,LAB_4918	;490D:	C21849

	LD	HL,1F55h		; set error 8021d
	PUSH	HL			; push error number
	CALL	LAB_4475		; do '      Timeout' message
	POP	DE			; dump error number
LAB_4918
	JP	LAB_4970	;4918:	C37049

LAB_491B
	LD	HL,1F56h		; set error 8022d
	PUSH	HL			; push error number
	CALL	LAB_44A5		; do ' Failed to connect' message
	POP	DE			; dump error number
	JP	LAB_4970	;4923:	C37049

LAB_4926
	LD	HL,1F57h		; set error 8023d
	PUSH	HL			; push error number
	CALL	LAB_44A5		; do ' Failed to connect' message
	POP	DE			; dump error number
	JP	LAB_4970	;492E:	C37049

LAB_4931
	LD	HL,1F58h		; set error 8024d
	PUSH	HL			; push error number
	CALL	LAB_44D5		; do '    Modem fault' message
	POP	DE			; dump error number
	JP	LAB_4970	;4939:	C37049

LAB_493C
	LD	HL,0006h	;493C:	210600
	LD	(LAB_E488),HL	;493F:	2288E4
	LD	HL,1F54h		; set error 8020d
	PUSH	HL			; push error number
	CALL	LAB_44A5		; do ' Failed to connect' message
	POP	DE			; dump error number
	JP	LAB_4970	;494A:	C37049

; search table for HL, and execute

LAB_494D
	CALL	LAB_E0B2		; search following table for HL & execute vector

	DW	0007h			; 7 entries
	DW	0000h
	DW	LAB_48EA
	DW	0001h
	DW	LAB_4931
	DW	0004h
	DW	LAB_48FB
	DW	0009h
	DW	LAB_4906
	DW	000Fh
	DW	LAB_4931
	DW	0012h
	DW	LAB_491B
	DW	0013h
	DW	LAB_4926
	DW	LAB_493C

LAB_4970
	LD	HL,(LAB_E488)	;4970:	2A88E4
	RET				;

LAB_4974
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6)
	LD	HL,0003h	;497A:	210300
	PUSH	HL		;497D:	E5
	CALL	LAB_452D	;497E:	CD2D45
	POP	DE		;4981:	D1
	LD	(LAB_E488),HL	;4982:	2288E4
	LD	A,H			; set the flags
	OR	L			;
	JP	NZ,LAB_4A21	;4987:	C2214A

	CALL	LAB_578F	;498A:	CD8F57
	LD	(LAB_E488),HL	;498D:	2288E4
	LD	HL,(LAB_E488)	;4990:	2A88E4
	JP	LAB_49FA		; search table for HL, and execute

LAB_4996
	CALL	LAB_44ED		; print empty 4 line message
	LD	A,(LAB_E48C)	; get status message #
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	PUSH	HL			; push status message #
	CALL	LAB_3BF5		; save (byte) at (LAB_E22D)
	POP	DE			; dump status message #
	JP	LAB_4A21	;49A4:	C3214A

LAB_49A7
	LD	HL,000Dh		; set status message # = 0Dh
	PUSH	HL			; push status message #
	CALL	LAB_3BF5		; save (byte) at (LAB_E22D)
	POP	DE			; dump status message #
	JP	LAB_4A21	;49AF:	C3214A

LAB_49B2
	LD	HL,1F5Fh		; set error number 8031d
	PUSH	HL			; push error number
	CALL	LAB_4475		; do '      Timeout' message
	POP	DE			; dump error number
	JP	LAB_4A21	;49BA:	C3214A

LAB_49BD
	LD	HL,1F60h		; set error number 8032d
	PUSH	HL			; push error number
	CALL	LAB_44A5		; do ' Failed to connect' message
	POP	DE			; dump error number
	JP	LAB_4A21	;49C5:	C3214A

LAB_49C8
	LD	HL,1F61h		; set error number 8033d
	PUSH	HL			; push error number
	CALL	LAB_44A5		; do ' Failed to connect' message
	POP	DE			; dump error number
	JP	LAB_4A21	;49D0:	C3214A

LAB_49D3
	LD	HL,1F62h		; set error number 8034d
	PUSH	HL			; push error number
	CALL	LAB_44A5		; do ' Failed to connect' message
	POP	DE			; dump error number
	JP	LAB_4A21	;49DB:	C3214A

LAB_49DE
	LD	HL,1F63h		; set error number 8035d
	PUSH	HL			; push error number
	CALL	LAB_44D5		; do '    Modem fault' message
	POP	DE			; dump error number
	JP	LAB_4A21	;49E6:	C3214A

LAB_49E9
	LD	HL,0006h	;49E9:	210600
	LD	(LAB_E488),HL	;49EC:	2288E4
	LD	HL,1F5Eh		; set error number 8030d
	PUSH	HL			; push error number
	CALL	LAB_44A5		; do ' Failed to connect' message
	POP	DE			; dump error number
	JP	LAB_4A21	;49F7:	C3214A

; search table for HL, and execute

LAB_49FA
	CALL	LAB_E0B2		; search following table for HL & execute vector

	DW	0008h			; 8 entries
	DW	0000h
	DW	LAB_4996
	DW	0001h
	DW	LAB_49DE
	DW	0004h
	DW	LAB_49A7
	DW	0009h
	DW	LAB_49B2
	DW	000Dh
	DW	LAB_49D3
	DW	000Fh
	DW	LAB_49DE
	DW	0012h
	DW	LAB_49BD
	DW	0013h
	DW	LAB_49C8
	DW	LAB_49E9

LAB_4A21
	LD	HL,(LAB_E488)	;4A21:	2A88E4
	RET				;

LAB_4A25
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6)
	LD	HL,0004h	;4A2B:	210400
	PUSH	HL		;4A2E:	E5
	CALL	LAB_452D	;4A2F:	CD2D45
	POP	DE		;4A32:	D1
	LD	(LAB_E488),HL	;4A33:	2288E4
	LD	A,H			; set the flags
	OR	L			;
	JP	NZ,LAB_4AC8	;4A38:	C2C84A

	CALL	LAB_582A	;4A3B:	CD2A58
	LD	(LAB_E488),HL	;4A3E:	2288E4
	LD	HL,(LAB_E488)	;4A41:	2A88E4
	JP	LAB_4AB1		; search table for HL, and execute

LAB_4A47
	LD	HL,(LAB_E6E2)	;4A47:	2AE2E6
	LD	A,H			; set the flags
	OR	L			;
	JP	Z,LAB_4A64	;4A4C:	CA644A

	LD	HL,0001h		; set bell flag
	PUSH	HL			; push bell flag
	LD	HL,LAB_6DA7		; points to '  Session complete'
	PUSH	HL			; push message pointer
	LD	HL,0006h		; set line 6
	PUSH	HL			; push line #
	CALL	LAB_421C		; print message @ line, with bells on
	POP	DE			; dump line #
	POP	DE			; dump message pointer
	POP	DE			; dump bell flag ??
	CALL	LAB_42EE		; wait (LAB_E6FD) seconds or do press to cont
LAB_4A64
	LD	A,(LAB_E48C)	; get status message #
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	PUSH	HL			; push status message #
	CALL	LAB_3BF5		; save (byte) at (LAB_E22D)
	POP	DE			; dump status message #
	JP	LAB_4AC8	;4A6F:	C3C84A

LAB_4A72
	LD	HL,1F69h		; set error number 8041d
	PUSH	HL			; push error number
	CALL	LAB_4475		; do '      Timeout' message
	POP	DE			; dump error number
	LD	HL,0000h		; set status message # = 0
	PUSH	HL			; push status message #
	CALL	LAB_3BF5		; save (byte) at (LAB_E22D)
	POP	DE			; dump status message #
	JP	LAB_4AC8	;4A82:	C3C84A

LAB_4A85
	LD	HL,1F6Ah		; set error number 8042d
	PUSH	HL			; push error number
	CALL	LAB_44D5		; do '    Modem fault' message
	POP	DE			; dump error number
	LD	HL,0000h		; set status message # = 0
	PUSH	HL			; push status message #
	CALL	LAB_3BF5		; save (byte) at (LAB_E22D)
	POP	DE			; dump status message #
	JP	LAB_4AC8	;4A95:	C3C84A

LAB_4A98
	LD	HL,0006h	;4A98:	210600
	LD	(LAB_E488),HL	;4A9B:	2288E4
	LD	HL,1F68h		; set error number 8040d
	PUSH	HL			; push error number
	CALL	LAB_448D		; do '    Link failure' message
	POP	DE			; dump error number
	LD	HL,0000h		; set status message # = 0
	PUSH	HL			; push status message #
	CALL	LAB_3BF5		; save (byte) at (LAB_E22D)
	POP	DE			; dump status message #
	JP	LAB_4AC8	;4AAE:	C3C84A

; search table for HL, and execute

LAB_4AB1
	CALL	LAB_E0B2		; search following table for HL & execute vector

	DW	0004h			; 4 entries
	DW	0000h
	DW	LAB_4A47
	DW	0001h
	DW	LAB_4A85
	DW	0009h
	DW	LAB_4A72
	DW	000Fh
	DW	LAB_4A85
	DW	LAB_4A98

LAB_4AC8
	LD	HL,0000h	;4AC8:	210000
	LD	(LAB_E6C0),HL	;4ACB:	22C0E6
	LD	HL,0000h	;4ACE:	210000
	LD	(LAB_E6E2),HL	;4AD1:	22E2E6
	LD	HL,0001h		; set cursor flag
	PUSH	HL			; push it
	CALL	LAB_F120		; set cursor blink on/off
	POP	DE			; dump cursor flag
	LD	HL,(LAB_E488)	;4ADC:	2A88E4
	RET				;

LAB_4AE0
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6)
	LD	HL,0005h	;4AE6:	210500
	PUSH	HL		;4AE9:	E5
	CALL	LAB_452D	;4AEA:	CD2D45
	POP	DE		;4AED:	D1
	LD	(LAB_E488),HL	;4AEE:	2288E4
	LD	A,H			; set the flags
	OR	L			;
	JP	NZ,LAB_4D25	;4AF3:	C2254D

	LD	HL,0001h	;4AF6:	210100
	LD	(LAB_E48A),HL	;4AF9:	228AE4
	LD	HL,0000h	;4AFC:	210000
	LD	(LAB_E6E2),HL	;4AFF:	22E2E6
	LD	HL,0000h	;4B02:	210000
	LD	A,L		;4B05:	7D
	LD	(LAB_E6CF),A	;4B06:	32CFE6
	LD	HL,0000h	;4B09:	210000
	LD	(LAB_E6CD),HL	;4B0C:	22CDE6
	LD	HL,0000h	;4B0F:	210000
	LD	(LAB_E6C2),HL	;4B12:	22C2E6
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;4B19:	5E
	LD	D,#00h		; clear high byte
	LD	HL,0006h	;4B1C:	210600
	CALL	LAB_DFCC		; does HL = HL*DE
	LD	DE,E247h	;4B22:	1147E2
	ADD	HL,DE		;4B25:	19
	LD	(LAB_E48F),HL	;4B26:	228FE4
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;4B2D:	5E
	LD	D,#00h		; clear high byte
	LD	HL,0006h	;4B30:	210600
	CALL	LAB_DFCC		; does HL = HL*DE
	LD	DE,E24Ch	;4B36:	114CE2
	ADD	HL,DE		;4B39:	19
	LD	E,(HL)		;4B3A:	5E
	EX	DE,HL		;4B3B:	EB
	LD	A,L		;4B3C:	7D
	LD	(LAB_E491),A	;4B3D:	3291E4
	LD	A,(LAB_E48D)	;4B40:	3A8DE4
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	LD	DE,0001h	;4B46:	110100
	CALL	LAB_E04B		; compare HL with DE, return HL=0 & Zb=1 if different
	JP	Z,LAB_4B5D	;4B4C:	CA5D4B

	LD	A,(LAB_E491)	; get status message #
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	PUSH	HL			; push status message #
	CALL	LAB_3BF5		; save (byte) at (LAB_E22D)
	POP	DE			; dump status message #
	JP	LAB_4D25	;4B5A:	C3254D

LAB_4B5D
	LD	HL,(LAB_E6C0)	;4B5D:	2AC0E6
	LD	A,H			; set the flags
	OR	L			;
	JP	NZ,LAB_4B77	;4B62:	C2774B

	LD	HL,0000h		; clear bell flag
	PUSH	HL			; push bell flag
	LD	HL,LAB_6DBA		; points to '     Logging on'
	PUSH	HL			; push message pointer
	LD	HL,0003h		; set line 3
	PUSH	HL			; push line #
	CALL	LAB_421C		; print message @ line, with bells on
	POP	DE			; dump line #
	POP	DE			; dump message pointer
	POP	DE			; dump bell flag ??
LAB_4B77
	LD	HL,0036h		; set count
	PUSH	HL			; push count
	LD	HL,LAB_E492		; set destination
	PUSH	HL			; push destination
	CALL	LAB_3CA3		; fill count bytes, from destination, with 00h
	POP	DE			; dump destination
	POP	DE			; dump count
	LD	HL,0008h		; set byte count
	PUSH	HL			; push byte count
	LD	HL,LAB_E6D0		; set source pointer
	PUSH	HL			; push source pointer
	LD	HL,LAB_E492		; set destination pointer
	PUSH	HL			; push destination pointer
	CALL	LAB_DB89		; copy byte count bytes of null terminated
					; string from source to destination. pad
					; with nulls if needed (LAB_76C4)
	POP	DE			; dump destination pointer
	POP	DE			; dump source pointer
	POP	DE			; dump byte count
	LD	HL,0006h		; set byte count
	PUSH	HL			; push byte count
	LD	HL,LAB_E6E8		; set source pointer
	PUSH	HL			; push source pointer
	LD	HL,LAB_E49A		; set destination pointer
	PUSH	HL			; push destination pointer
	CALL	LAB_DB89		; copy byte count bytes of null terminated
					; string from source to destination. pad
					; with nulls if needed (LAB_76C4)
	POP	DE			; dump destination pointer
	POP	DE			; dump source pointer
	POP	DE			; dump byte count
	LD	HL,0008h		; set byte count
	PUSH	HL			; save byte count
	LD	HL,LAB_E6EF		; set source pointer
	PUSH	HL			; push source pointer
	LD	HL,LAB_E4A4		; set destination pointer
	PUSH	HL			; push destination pointer
	CALL	LAB_DB89		; copy byte count bytes of null terminated
					; string from source to destination. pad
					; with nulls if needed (LAB_76C4)
	POP	DE			; dump destination pointer
	POP	DE			; dump source pointer
	POP	DE			; dump byte count
	LD	HL,0008h		; set byte count
	PUSH	HL			; save byte count
	LD	HL,LAB_E6C4		; set source pointer
	PUSH	HL			; push source pointer
	LD	HL,LAB_E4AC		; set destination pointer
	PUSH	HL			; push destination pointer
	CALL	LAB_DB89		; copy byte count bytes of null terminated
					; string from source to destination. pad
					; with nulls if needed (LAB_76C4)
	POP	DE			; dump destination pointer
	POP	DE			; dump source pointer
	POP	DE			; dump byte count
	LD	HL,0008h		; set byte count
	PUSH	HL			; save byte count
	LD	HL,LAB_E6D9		; set source pointer
	PUSH	HL			; push source pointer
	LD	HL,LAB_E4B4		; set destination pointer
	PUSH	HL			; push destination pointer
	CALL	LAB_DB89		; copy byte count bytes of null terminated
					; string from source to destination. pad
					; with nulls if needed (LAB_76C4)
	POP	DE			; dump destination pointer
	POP	DE			; dump source pointer
	POP	DE			; dump byte count
	LD	HL,0004h		; set byte count
	PUSH	HL			; save byte count
	LD	HL,(LAB_E48F)	; get source pointer
	PUSH	HL			; push source pointer
	LD	HL,LAB_E4A0		; set destination pointer
	PUSH	HL			; push destination pointer
	CALL	LAB_DB89		; copy byte count bytes of null terminated
					; string from source to destination. pad
					; with nulls if needed (LAB_76C4)
	POP	DE			; dump destination pointer
	POP	DE			; dump source pointer
	POP	DE			; dump byte count
	LD	HL,000Ch		; set byte count
	PUSH	HL			; save byte count
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		; get source pointer low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get source pointer high byte
	PUSH	DE			; push source pointer
	LD	HL,LAB_E4BC		; set destination pointer
	PUSH	HL			; push destination pointer
	CALL	LAB_DB89		; copy byte count bytes of null terminated
					; string from source to destination. pad
					; with nulls if needed (LAB_76C4)
	POP	DE			; dump destination pointer
	POP	DE			; dump source pointer
	POP	DE			; dump byte count
	CALL	LAB_3CF7	;4C06:	CDF73C
	LD	(LAB_E488),HL	;4C09:	2288E4
	LD	A,H			; set the flags
	OR	L			;
	JP	NZ,LAB_4C26	;4C0E:	C2264C

	LD	HL,0036h	;4C11:	213600
	PUSH	HL		;4C14:	E5
	LD	HL,E492h	;4C15:	2192E4
	PUSH	HL		;4C18:	E5
	CALL	LAB_5880	;4C19:	CD8058
	POP	DE		;4C1C:	D1
	POP	DE		;4C1D:	D1
	LD	(LAB_E488),HL	;4C1E:	2288E4
	LD	A,H			; set the flags
	OR	L			;
	JP	Z,LAB_4C26		; big duuuuh!?

LAB_4C26
	LD	HL,(LAB_E488)	;4C26:	2A88E4
	JP	LAB_4D0E		; search table for HL, and execute

LAB_4C2C
	LD	HL,0000h	;4C2C:	210000
	LD	(LAB_E488),HL	;4C2F:	2288E4
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;4C36:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;4C38:	56
	PUSH	DE		;4C39:	D5
	CALL	LAB_3F20	;4C3A:	CD203F
	POP	DE		;4C3D:	D1
	JP	LAB_4CC5		; search table for HL, and execute

LAB_4C41
	LD	HL,(LAB_E6C0)	;4C41:	2AC0E6
	LD	A,H			; set the flags
	OR	L			;
	JP	Z,LAB_4C59	;4C46:	CA594C

	LD	HL,LAB_6DCA		; points to '     Logged on'
	PUSH	HL			; push message pointer
	LD	HL,0003h		; line 3
	PUSH	HL			; push line #
	CALL	LAB_41D9		; print message @ line
	POP	DE			; dump line #
	POP	DE			; dump message pointer
	JP	LAB_4C5C	;4C56:	C35C4C

LAB_4C59
	CALL	LAB_450D		; print logged on message
LAB_4C5C
	LD	HL,0001h	;4C5C:	210100
	LD	(LAB_E6C0),HL	;4C5F:	22C0E6
	LD	A,(LAB_E491)	; get status message #
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	PUSH	HL			; push status message #
	CALL	LAB_3BF5		; save (byte) at (LAB_E22D)
	POP	DE			; dump status message #
	JP	LAB_4CE4	;4C6D:	C3E44C
LAB_4C70
	LD	HL,0005h	;4C70:	210500
	LD	(LAB_E488),HL	;4C73:	2288E4
	LD	HL,0002h		; set status message # = 2
	PUSH	HL			; push status message #
	CALL	LAB_3BF5		; save (byte) at (LAB_E22D)
	POP	DE			; dump status message #
	JP	LAB_4CE4	;4C7E:	C3E44C

LAB_4C81
	LD	HL,0006h	;4C81:	210600
	LD	(LAB_E488),HL	;4C84:	2288E4
	LD	HL,1F75h		; set error number 8053d
	PUSH	HL			; push error number
	CALL	LAB_44BD		; do '   Invalid reply' message
	POP	DE			; dump error number
	JP	LAB_4CE4	;4C8F:	C3E44C

LAB_4C92
	LD	HL,0004h	;4C92:	210400
	LD	(LAB_E488),HL	;4C95:	2288E4
	LD	HL,000Dh		; set status message # = 0Dh
	PUSH	HL			; push status message #
	CALL	LAB_3BF5		; save (byte) at (LAB_E22D)
	POP	DE			; dump status message #
	JP	LAB_4CE4	;4CA0:	C3E44C

LAB_4CA3
	LD	HL,0009h	;4CA3:	210900
	LD	(LAB_E488),HL	;4CA6:	2288E4
	LD	HL,1F77h		; set error number 8055d
	PUSH	HL			; push error number
	CALL	LAB_4475		; do '      Timeout' message
	POP	DE			; dump error number
	JP	LAB_4CE4	;4CB1:	C3E44C

LAB_4CB4
	LD	HL,0006h	;4CB4:	210600
	LD	(LAB_E488),HL	;4CB7:	2288E4
	LD	HL,1F76h		; set error number 8054d
	PUSH	HL			; push error number
	CALL	LAB_448D		; do '    Link failure' message
	POP	DE			; dump error number
	JP	LAB_4CE4	;4CC2:	C3E44C

; search table for HL, and execute

LAB_4CC5
	CALL	LAB_E0B2		; search following table for HL & execute vector

	DW	0006h			; 6 entries
	DW	0000h
	DW	LAB_4C41
	DW	0001h
	DW	LAB_4C70
	DW	0002h
	DW	LAB_4C70
	DW	0003h
	DW	LAB_4C81
	DW	0004h
	DW	LAB_4C92
	DW	0005h
	DW	LAB_4CA3
	DW	LAB_4CB4

LAB_4CE4
	JP	LAB_4D25	;4CE4:	C3254D

LAB_4CE7
	LD	HL,000Dh		; set status message # = 0Dh
	PUSH	HL			; push status message #
	CALL	LAB_3BF5		; save (byte) at (LAB_E22D)
	POP	DE			; dump status message #
	JP	LAB_4D25	;4CEF:	C3254D

LAB_4CF2
	LD	HL,1F78h		; set error number 8056d
	PUSH	HL			; push error number
	CALL	LAB_4475		; do '      Timeout' message
	POP	DE			; dump error number
	JP	LAB_4D25	;4CFA:	C3254D

LAB_4CFD
	LD	HL,0006h	;4CFD:	210600
	LD	(LAB_E488),HL	;4D00:	2288E4
	LD	HL,1F72h		; set error number 8050d
	PUSH	HL			; push error number
	CALL	LAB_448D		; do '    Link failure' message
	POP	DE			; dump error number
	JP	LAB_4D25	;4D0B:	C3254D

; search table for HL, and execute

LAB_4D0E
	CALL	LAB_E0B2		; search following table for HL & execute vector

	DW	0004h			; 4 entries
	DW	0000h
	DW	LAB_4C2C
	DW	0004h
	DW	LAB_4CE7
	DW	0008h
	DW	LAB_4C2C
	DW	0009h
	DW	LAB_4CF2
	DW	LAB_4CFD

LAB_4D25
	LD	HL,(LAB_E488)	;4D25:	2A88E4
	RET				;

; do C-RX-CMD not available message

LAB_4D29
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6)
	LD	HL,LAB_6E4F		; points to '   in Workstation'
	PUSH	HL			; push line 6 message pointer
	LD	HL,LAB_6E2E		; points to '   not available'
	PUSH	HL			; push line 5 message pointer
	LD	HL,LAB_E279		; points to '      C-RX-CMD'
	PUSH	HL			; push line 4 message pointer
	LD	HL,LAB_E278		; null message
	PUSH	HL			; push line 3 message pointer
	CALL	LAB_4296		; print 4 line message ???
	EX	DE,HL			;
	LD	HL,0008h		; 8 ..
	ADD	HL,SP			; .. + stack ..
	LD	SP,HL			; .. = dump the lot
	CALL	LAB_42EE		; wait (LAB_E6FD) seconds or do press to cont
	LD	HL,0002h	;4D4B:	210200
	RET				;

; do C-TX-REPLY not available message

LAB_4D4F
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6)
	LD	HL,LAB_6E4F		; points to '   in Workstation'
	PUSH	HL			; push line 6 message pointer
	LD	HL,LAB_6E2E		; points to '   not available'
	PUSH	HL			; push line 5 message pointer
	LD	HL,LAB_E289		; points to '     C-TX-REPLY'
	PUSH	HL			; push line 4 message pointer
	LD	HL,LAB_E288		; null message
	PUSH	HL			; push line 3 message pointer
	CALL	LAB_4296		; print 4 line message ???
	EX	DE,HL			;
	LD	HL,0008h		; 8 ..
	ADD	HL,SP			; .. + stack ..
	LD	SP,HL			; .. = dump the lot
	CALL	LAB_42EE		; wait (LAB_E6FD) seconds or do press to cont
	LD	HL,0002h	;4D71:	210200
	RET				;

LAB_4D75
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6)
	LD	HL,0008h	;4D7B:	210800
	PUSH	HL		;4D7E:	E5
	CALL	LAB_452D	;4D7F:	CD2D45
	POP	DE		;4D82:	D1
	LD	(LAB_E488),HL	;4D83:	2288E4
	LD	A,H			; set the flags
	OR	L			;
	JP	NZ,LAB_4E69	;4D88:	C2694E

	LD	HL,0000h	;4D8B:	210000
	LD	A,L		;4D8E:	7D
	LD	(LAB_E6CF),A	;4D8F:	32CFE6
	LD	A,(LAB_E48D)	;4D92:	3A8DE4
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	LD	DE,0001h	;4D98:	110100
	CALL	LAB_E04B		; compare HL with DE, return HL=0 & Zb=1 if different
	JP	Z,LAB_4DB5	;4D9E:	CAB54D

	LD	HL,0001h	;4DA1:	210100
	LD	(LAB_E6E2),HL	;4DA4:	22E2E6
	LD	A,(LAB_E48C)	; get status message #
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	PUSH	HL			; push status message #
	CALL	LAB_3BF5		; save (byte) at (LAB_E22D)
	POP	DE			; dump status message #
	JP	LAB_4E69	;4DB2:	C3694E

LAB_4DB5
	LD	HL,0004h		; set byte count
	PUSH	HL			; push byte count
	LD	HL,LAB_E299		; set source pointer to 'ENDC'
	PUSH	HL			; push source pointer
	LD	HL,LAB_E4A0		; set destination pointer
	PUSH	HL			; push destination pointer
	CALL	LAB_DB89		; copy byte count bytes of null terminated
					; string from source to destination. pad
					; with nulls if needed (LAB_76C4)
	POP	DE			; dump destination pointer
	POP	DE			; dump source pointer
	POP	DE			; dump byte count
	LD	HL,000Ch		; 0Ch bytes to clear
	PUSH	HL			; push count
	LD	HL,LAB_E4BC		; set destination
	PUSH	HL			; push destination
	CALL	LAB_3CA3		; fill count bytes, from destination, with 00h
	POP	DE			; dump destination
	POP	DE			; dump count
	CALL	LAB_3CF7	;4DD4:	CDF73C
	LD	(LAB_E488),HL	;4DD7:	2288E4
	LD	A,H			; set the flags
	OR	L			;
	JP	NZ,LAB_4DF4	;4DDC:	C2F44D

	LD	HL,0036h	;4DDF:	213600
	PUSH	HL		;4DE2:	E5
	LD	HL,E492h	;4DE3:	2192E4
	PUSH	HL		;4DE6:	E5
	CALL	LAB_5880	;4DE7:	CD8058
	POP	DE		;4DEA:	D1
	POP	DE		;4DEB:	D1
	LD	(LAB_E488),HL	;4DEC:	2288E4
	LD	A,H			; set the flags
	OR	L			;
	JP	Z,LAB_4DF4		; big duuuuuh!?

LAB_4DF4
	LD	HL,(LAB_E488)	;4DF4:	2A88E4
	JP	LAB_4E4E		; search table for HL, and execute

LAB_4DFA
	LD	HL,0000h	;4DFA:	210000
	LD	(LAB_E488),HL	;4DFD:	2288E4
	LD	HL,LAB_6DD9		; points to '     Logged off'
	PUSH	HL			; push message pointer
	LD	HL,0003h		; line 3
	PUSH	HL			; push line #
	CALL	LAB_41D9		; print message @ line
	POP	DE			; dump line #
	POP	DE			; dump message pointer
	LD	HL,0001h	;4E0D:	210100
	LD	(LAB_E6E2),HL	;4E10:	22E2E6
	LD	HL,0000h	;4E13:	210000
	LD	(LAB_E6C0),HL	;4E16:	22C0E6
	LD	A,(LAB_E48C)	; get status message #
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	PUSH	HL			; push status message #
	CALL	LAB_3BF5		; save (byte) at (LAB_E22D)
	POP	DE			; dump status message #
	JP	LAB_4E69	;4E24:	C3694E

LAB_4E27
	LD	HL,000Dh		; set status message # = 0Dh
	PUSH	HL			; push status message #
	CALL	LAB_3BF5		; save (byte) at (LAB_E22D)
	POP	DE			; dump status message #
	JP	LAB_4E69	;4E2F:	C3694E

LAB_4E32
	LD	HL,1F9Bh		; set error number 8091d
	PUSH	HL			; push error number
	CALL	LAB_4475		; do '      Timeout' message
	POP	DE			; dump error number
	JP	LAB_4E69	;4E3A:	C3694E

LAB_4E3D
	LD	HL,0006h	;4E3D:	210600
	LD	(LAB_E488),HL	;4E40:	2288E4
	LD	HL,1F9Ah		; set error number 8090d
	PUSH	HL			; push error number
	CALL	LAB_448D		; do '    Link failure' message
	POP	DE			; dump error number
	JP	LAB_4E69	;4E4B:	C3694E

; search table for HL, and execute

LAB_4E4E
	CALL	LAB_E0B2		; search following table for HL & execute vector

	DW	0005h			; 5 entries
	DW	0000h
	DW	LAB_4DFA
	DW	0004h
	DW	LAB_4E27
	DW	0006h
	DW	LAB_4DFA
	DW	0008h
	DW	LAB_4DFA
	DW	0009h
	DW	LAB_4E32
	DW	LAB_4E3D

LAB_4E69
	LD	HL,(LAB_E488)	;4E69:	2A88E4
	RET				;

LAB_4E6D
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6)
	LD	HL,0009h	;4E73:	210900
	PUSH	HL		;4E76:	E5
	CALL	LAB_452D	;4E77:	CD2D45
	POP	DE		;4E7A:	D1
	LD	(LAB_E488),HL	;4E7B:	2288E4
	LD	A,H			; set the flags
	OR	L			;
	JP	NZ,LAB_4F56	;4E80:	C2564F

	LD	HL,(LAB_E48A)	;4E83:	2A8AE4
	LD	A,H			; set the flags
	OR	L			;
	JP	Z,LAB_4EB8	;4E88:	CAB84E

	LD	HL,0000h	;4E8B:	210000
	LD	(LAB_E48A),HL	;4E8E:	228AE4
	CALL	LAB_3D04		; fill buffer ?? @ LAB_E3C6 & clear LAB_E446, LAB_E448,
					; LAB_E44A, byte @ LAB_E519 & set HL = 0000h
	LD	(LAB_E488),HL	;4E94:	2288E4
	LD	HL,(LAB_E488)	;4E97:	2A88E4
	LD	A,H			; set the flags
	OR	L			;
	JP	NZ,LAB_4EB8	;4E9C:	C2B84E

	LD	HL,0000h		; clear bell flag
	PUSH	HL			; push bell flag
	LD	HL,LAB_6CF5		; points to 'Receiving data'
	PUSH	HL			; push message pointer
	LD	HL,0005h		; set line 5
	PUSH	HL			; push line #
	CALL	LAB_421C		; print message @ line, with bells on
	POP	DE			; dump line #
	POP	DE			; dump message pointer
	POP	DE			; dump bell flag ??
	LD	HL,0005h	;4EB1:	210500
	LD	A,L		;4EB4:	7D
	LD	(LAB_E6CF),A	;4EB5:	32CFE6
LAB_4EB8
	LD	HL,(LAB_E488)	;4EB8:	2A88E4
	LD	A,H			; set the flags
	OR	L			;
	JP	NZ,LAB_4ED4	;4EBD:	C2D44E

	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;4EC4:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;4EC6:	56
	PUSH	DE		;4EC7:	D5
	CALL	LAB_5542	;4EC8:	CD4255
	POP	DE		;4ECB:	D1
	LD	(LAB_E488),HL	; save status number
	LD	A,H			; set the flags
	OR	L			;
	JP	Z,LAB_4ED4		; jump if no message huh!??

LAB_4ED4
	LD	HL,(LAB_E488)	; get status number
	JP	LAB_4F37		; search table for HL, and execute

LAB_4EDA
	LD	A,(LAB_E48C)	; get status message #
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	PUSH	HL			; push status message #
	CALL	LAB_3BF5		; save (byte) at (LAB_E22D)
	POP	DE			; dump status message #
	JP	LAB_4F56	;4EE5:	C3564F

LAB_4EE8
	LD	HL,000Dh		; set status message # = 0Dh
	PUSH	HL			; push status message #
	CALL	LAB_3BF5		; save (byte) at (LAB_E22D)
	POP	DE			; dump status message #
	JP	LAB_4F56	;4EF0:	C3564F

; do message Data received

LAB_4EF3
	LD	HL,LAB_6D3A		; points to '   Data received'
	PUSH	HL			; push message pointer
	LD	HL,0005h		; line 5
	PUSH	HL			; push line #
	CALL	LAB_41D9		; print message @ line
	POP	DE			; dump line #
	POP	DE			; dump message pointer
	LD	HL,0002h		; set status message # = 2
	PUSH	HL			; push status message #
	CALL	LAB_3BF5		; save (byte) at (LAB_E22D)
	POP	DE			; dump status message #
	JP	LAB_4F56	;4F08:	C3564F

; do error 8101d, Invalid data stream

LAB_4F0B
	LD	HL,LAB_6E0C		; points to 'Invalid data stream'
	PUSH	HL			; push message pointer
	LD	HL,1FA5h		; set error number 8101d
	PUSH	HL			; push number
	CALL	LAB_443C		; do error number, message message pointer then ??
	POP	DE			; dump number
	POP	DE			; dump message pointer
	JP	LAB_4F56		; does HL=(LAB_E488) & return

; do error 8102d, timeout

LAB_4F1B
	LD	HL,1FA6h		; set error number 8102d
	PUSH	HL			; push number
	CALL	LAB_4475		; do '      Timeout' message
	POP	DE			; dump number
	JP	LAB_4F56	;4F23:	C3564F

; do error 8100d, link faliure

LAB_4F26
	LD	HL,0006h	;4F26:	210600
	LD	(LAB_E488),HL	;4F29:	2288E4
	LD	HL,1FA4h		; set error number 8100d
	PUSH	HL			; push number
	CALL	LAB_448D		; do '    Link failure' message
	POP	DE			; dump number
	JP	LAB_4F56	;4F34:	C3564F

; search table for HL, and execute

LAB_4F37
	CALL	LAB_E0B2		; search following table for HL & execute vector

	DW	0006h			; 6 entries
	DW	0000h
	DW	LAB_4EDA
	DW	0004h
	DW	LAB_4EE8
	DW	0007h
	DW	LAB_4EDA
	DW	0008h
	DW	LAB_4EF3		; do message Data received
	DW	0009h
	DW	LAB_4F1B		; do error 8102d, timeout
	DW	000Ah
	DW	LAB_4F0B		; do error 8101d, Invalid data stream
	DW	LAB_4F26		; do error 8100d, link faliure

LAB_4F56
	LD	HL,(LAB_E488)	;4F56:	2A88E4
	RET				;

; receive program ??

LAB_4F5A
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6)
	LD	HL,000Ah	;4F60:	210A00
	PUSH	HL		;4F63:	E5
	CALL	LAB_452D	;4F64:	CD2D45
	POP	DE		;4F67:	D1
	LD	(LAB_E488),HL	;4F68:	2288E4
	LD	A,H			; set the flags
	OR	L			;
	JP	NZ,LAB_5030	;4F6D:	C23050

	LD	HL,(LAB_E48A)	;4F70:	2A8AE4
	LD	A,H			; set the flags
	OR	L			;
	JP	Z,LAB_4FA5	;4F75:	CAA54F

	LD	HL,0000h	;4F78:	210000
	LD	(LAB_E48A),HL	;4F7B:	228AE4
	CALL	LAB_3D04		; fill buffer ?? @ LAB_E3C6 & clear LAB_E446, LAB_E448,
					; LAB_E44A, byte @ LAB_E519 & set HL = 0000h
	LD	(LAB_E488),HL	;4F81:	2288E4
	LD	HL,(LAB_E488)	;4F84:	2A88E4
	LD	A,H			; set the flags
	OR	L			;
	JP	NZ,LAB_4FA5	;4F89:	C2A54F

	LD	HL,0000h		; clear bell flag
	PUSH	HL			; push bell flag
	LD	HL,LAB_6D04		; points to 'Receiving prog'
	PUSH	HL			; push message pointer
	LD	HL,0005h		; set line 5
	PUSH	HL			; push line #
	CALL	LAB_421C		; print message @ line, with bells on
	POP	DE			; dump line #
	POP	DE			; dump message pointer
	POP	DE			; dump bell flag ??
	LD	HL,0005h	;4F9E:	210500
	LD	A,L		;4FA1:	7D
	LD	(LAB_E6CF),A	;4FA2:	32CFE6
LAB_4FA5
	LD	HL,(LAB_E488)	;4FA5:	2A88E4
	LD	A,H			; set the flags
	OR	L			;
	JP	NZ,LAB_4FC6	;4FAA:	C2C64F

	LD	HL,0080h	;4FAD:	218000
	PUSH	HL		;4FB0:	E5
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;4FB5:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;4FB7:	56
	PUSH	DE		;4FB8:	D5
	CALL	LAB_3E6A	;4FB9:	CD6A3E
	POP	DE		;4FBC:	D1
	POP	DE		;4FBD:	D1
	LD	(LAB_E488),HL	;4FBE:	2288E4
	LD	A,H			; set the flags
	OR	L			;
	JP	Z,LAB_4FC6		; big duuuuuh!?

LAB_4FC6
	LD	HL,(LAB_E488)	;4FC6:	2A88E4
	JP	LAB_5019		; search table for HL, and execute

LAB_4FCC
	LD	A,(LAB_E48C)	; get status message #
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	PUSH	HL			; push status message #
	CALL	LAB_3BF5		; save (byte) at (LAB_E22D)
	POP	DE			; dump status message #
	JP	LAB_5030	;4FD7:	C33050

LAB_4FDA
	LD	HL,000Dh		; set status message # = 0Dh
	PUSH	HL			; push status message #
	CALL	LAB_3BF5		; save (byte) at (LAB_E22D)
	POP	DE			; dump status message #
	JP	LAB_5030	;4FE2:	C33050

LAB_4FE5
	LD	HL,LAB_6D4B		; points to '   Program received'
	PUSH	HL			; push message pointer
	LD	HL,0005h		; line 5
	PUSH	HL			; push line #
	CALL	LAB_41D9		; print message @ line
	POP	DE			; dump line #
	POP	DE			; dump message pointer
	LD	HL,0002h		; set status message # = 2
	PUSH	HL			; push status message #
	CALL	LAB_3BF5		; save (byte) at (LAB_E22D)
	POP	DE			; dump status message #
	JP	LAB_5030	;4FFA:	C33050

LAB_4FFD
	LD	HL,1FAFh		; set error number 8111d
	PUSH	HL			; push error number
	CALL	LAB_4475		; do '      Timeout' message
	POP	DE			; dump error number
	JP	LAB_5030	;5005:	C33050

LAB_5008
	LD	HL,0006h	;5008:	210600
	LD	(LAB_E488),HL	;500B:	2288E4
	LD	HL,1FAEh		; set error number 8110d
	PUSH	HL			; push error number
	CALL	LAB_448D		; do '    Link failure' message
	POP	DE			; dump error number
	JP	LAB_5030	;5016:	C33050

; search table for HL, and execute

LAB_5019
	CALL	LAB_E0B2		; search following table for HL & execute vector

	DW	0004h			; 4 entries
	DW	0000h
	DW	LAB_4FCC
	DW	0004h
	DW	LAB_4FDA
	DW	0008h
	DW	LAB_4FE5
	DW	0009h
	DW	LAB_4FFD
	DW	LAB_5008

LAB_5030
	LD	HL,(LAB_E488)	;5030:	2A88E4
	RET				;

; send data ??

LAB_5034
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6)
	LD	HL,000Bh	;503A:	210B00
	PUSH	HL		;503D:	E5
	CALL	LAB_452D	;503E:	CD2D45
	POP	DE		;5041:	D1
	LD	(LAB_E488),HL	;5042:	2288E4
	LD	A,H			; set the flags
	OR	L			;
	JP	NZ,LAB_50E9	;5047:	C2E950

	LD	HL,(LAB_E48A)	;504A:	2A8AE4
	LD	A,H			; set the flags
	OR	L			;
	JP	Z,LAB_507F	;504F:	CA7F50

	LD	HL,0000h	;5052:	210000
	LD	(LAB_E48A),HL	;5055:	228AE4
	CALL	LAB_3CF7	;5058:	CDF73C
	LD	(LAB_E488),HL	;505B:	2288E4
	LD	HL,(LAB_E488)	;505E:	2A88E4
	LD	A,H			; set the flags
	OR	L			;
	JP	NZ,LAB_507F	;5063:	C27F50

	LD	HL,0000h		; clear bell flag
	PUSH	HL			; push bell flag
	LD	HL,LAB_6CDB		; points to 'Sending data'
	PUSH	HL			; push message pointer
	LD	HL,0004h		; set line 4
	PUSH	HL			; push line #
	CALL	LAB_421C		; print message @ line, with bells on
	POP	DE			; dump line #
	POP	DE			; dump message pointer
	POP	DE			; dump bell flag ??
	LD	HL,0004h	;5078:	210400
	LD	A,L		;507B:	7D
	LD	(LAB_E6CF),A	;507C:	32CFE6
LAB_507F
	LD	HL,(LAB_E488)	;507F:	2A88E4
	LD	A,H			; set the flags
	OR	L			;
	JP	NZ,LAB_509B	;5084:	C29B50

	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;508B:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;508D:	56
	PUSH	DE		;508E:	D5
	CALL	LAB_3EDE	;508F:	CDDE3E
	POP	DE		;5092:	D1
	LD	(LAB_E488),HL	;5093:	2288E4
	LD	A,H			; set the flags
	OR	L			;
	JP	Z,LAB_509B	;5098:	CA9B50

LAB_509B
	LD	HL,(LAB_E488)	;509B:	2A88E4
	JP	LAB_50D6		; search table for HL, and execute

LAB_50A1
	LD	A,(LAB_E48C)	; get status message #
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	PUSH	HL			; push status message #
	CALL	LAB_3BF5		; save (byte) at (LAB_E22D)
	POP	DE			; dump status message #
	JP	LAB_50E9	;50AC:	C3E950

LAB_50AF
	LD	HL,000Dh		; set status message # = 0Dh
	PUSH	HL			; push status message #
	CALL	LAB_3BF5		; save (byte) at (LAB_E22D)
	POP	DE			; dump status message #
	JP	LAB_50E9	;50B7:	C3E950

LAB_50BA
	LD	HL,1FB9h		; set error number 8121d
	PUSH	HL			; push error number
	CALL	LAB_4475		; do '      Timeout' message
	POP	DE			; dump error number
	JP	LAB_50E9	;50C2:	C3E950

LAB_50C5
	LD	HL,0006h	;50C5:	210600
	LD	(LAB_E488),HL	;50C8:	2288E4
	LD	HL,1FB8h		; set error number 8120d
	PUSH	HL			; push error number
	CALL	LAB_448D		; do '    Link failure' message
	POP	DE			; dump error number
	JP	LAB_50E9	;50D3:	C3E950

; search table for HL, and execute

LAB_50D6
	CALL	LAB_E0B2		; search following table for HL & execute vector

	DW	0003h			; 3 entries
	DW	0000h
	DW	LAB_50A1
	DW	0004h
	DW	LAB_50AF
	DW	0009h
	DW	LAB_50BA
	DW	LAB_50C5

LAB_50E9
	LD	HL,(LAB_E488)	;50E9:	2A88E4
	RET				;

LAB_50ED
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6)
	LD	HL,000Ch	;50F3:	210C00
	PUSH	HL		;50F6:	E5
	CALL	LAB_452D	;50F7:	CD2D45
	POP	DE		;50FA:	D1
	LD	(LAB_E488),HL	;50FB:	2288E4
	LD	A,H			; set the flags
	OR	L			;
	JP	NZ,LAB_5175	;5100:	C27551

	LD	HL,001Eh	;5103:	211E00
	PUSH	HL		;5106:	E5
	CALL	LAB_3D9B	;5107:	CD9B3D
	POP	DE		;510A:	D1
	LD	(LAB_E488),HL	;510B:	2288E4
	LD	A,H			; set the flags
	OR	L			;
	JP	NZ,LAB_5127	;5110:	C22751

	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;5117:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;5119:	56
	PUSH	DE		;511A:	D5
	CALL	LAB_3E14	;511B:	CD143E
	POP	DE		;511E:	D1
	LD	(LAB_E488),HL	;511F:	2288E4
	LD	A,H			; set the flags
	OR	L			;
	JP	Z,LAB_5127		; big duuuuuh!?

LAB_5127
	LD	HL,(LAB_E488)	;5127:	2A88E4
	JP	LAB_5162		; search table for HL, and execute

LAB_512D
	LD	A,(LAB_E48C)	; get status message #
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	PUSH	HL			; push status message #
	CALL	LAB_3BF5		; save (byte) at (LAB_E22D)
	POP	DE			; dump status message #
	JP	LAB_5175	;5138:	C37551

LAB_513B
	LD	HL,000Dh		; set status message # = 0Dh
	PUSH	HL			; push status message #
	CALL	LAB_3BF5		; save (byte) at (LAB_E22D)
	POP	DE			; dump status message #
	JP	LAB_5175	;5143:	C37551

LAB_5146
	LD	HL,1FC3h		; set error number 8131d
	PUSH	HL			; push error number
	CALL	LAB_4475		; do '      Timeout' message
	POP	DE			; dump error number
	JP	LAB_5175	;514E:	C37551

LAB_5151
	LD	HL,0006h	;5151:	210600
	LD	(LAB_E488),HL	;5154:	2288E4
	LD	HL,1FC2h		; set error number 8130d
	PUSH	HL			; push error number
	CALL	LAB_448D		; do '    Link failure' message
	POP	DE			; dump error number
	JP	LAB_5175	;515F:	C37551

; search table for HL, and execute

LAB_5162
	CALL	LAB_E0B2		; search following table for HL & execute vector

	DW	0003h			; 3 entries
	DW	0000h
	DW	LAB_512D
	DW	0004h
	DW	LAB_513B
	DW	0009h
	DW	LAB_5146
	DW	LAB_5151

LAB_5175
	LD	HL,(LAB_E488)	;5175:	2A88E4
	RET				;

LAB_5179
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6)
	LD	HL,000Dh	;517F:	210D00
	PUSH	HL		;5182:	E5
	CALL	LAB_452D	;5183:	CD2D45
	POP	DE		;5186:	D1
	LD	(LAB_E488),HL	;5187:	2288E4
	LD	A,H			; set the flags
	OR	L			;
	JP	NZ,LAB_51E8	;518C:	C2E851

	LD	HL,001Ch	;518F:	211C00
	PUSH	HL		;5192:	E5
	CALL	LAB_3D9B	;5193:	CD9B3D
	POP	DE		;5196:	D1
	LD	(LAB_E488),HL	;5197:	2288E4
	LD	HL,(LAB_E488)	;519A:	2A88E4
	JP	LAB_51D5		; search table for HL, and execute

LAB_51A0
	LD	A,(LAB_E48C)	; get status message #
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	PUSH	HL			; push status message #
	CALL	LAB_3BF5		; save (byte) at (LAB_E22D)
	POP	DE			; dump status message #
	JP	LAB_51E8	;51AB:	C3E851

LAB_51AE
	LD	HL,000Dh		; set status message # = 0Dh
	PUSH	HL			; push status message #
	CALL	LAB_3BF5		; save (byte) at (LAB_E22D)
	POP	DE			; dump status message #
	JP	LAB_51E8	;51B6:	C3E851

LAB_51B9
	LD	HL,1FCDh		; set error number 8141d
	PUSH	HL			; push error number
	CALL	LAB_4475		; do '      Timeout' message
	POP	DE			; dump error number
	JP	LAB_51E8	;51C1:	C3E851

LAB_51C4
	LD	HL,0006h	;51C4:	210600
	LD	(LAB_E488),HL	;51C7:	2288E4
	LD	HL,1FCCh		; set error number 8140d
	PUSH	HL			; push error number
	CALL	LAB_448D		; do '    Link failure' message
	POP	DE			; dump error number
	JP	LAB_51E8	;51D2:	C3E851

; search table for HL, and execute

LAB_51D5
	CALL	LAB_E0B2		; search following table for HL & execute vector

	DW	0003h			; 3 entries
	DW	0000h
	DW	LAB_51A0
	DW	0004h
	DW	LAB_51AE
	DW	0009h
	DW	LAB_51B9
	DW	LAB_51C4

LAB_51E8
	LD	HL,(LAB_E488)	;51E8:	2A88E4
	RET				;

; send program ??

LAB_51EC
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6)
	LD	HL,000Eh	;51F2:	210E00
	PUSH	HL		;51F5:	E5
	CALL	LAB_452D	;51F6:	CD2D45
	POP	DE		;51F9:	D1
	LD	(LAB_E488),HL	;51FA:	2288E4
	LD	A,H			; set the flags
	OR	L			;
	JP	NZ,LAB_52A1	;51FF:	C2A152

	LD	HL,(LAB_E48A)	;5202:	2A8AE4
	LD	A,H			; set the flags
	OR	L			;
	JP	Z,LAB_5237	;5207:	CA3752

	LD	HL,0000h	;520A:	210000
	LD	(LAB_E48A),HL	;520D:	228AE4
	CALL	LAB_3CF7	;5210:	CDF73C
	LD	(LAB_E488),HL	;5213:	2288E4
	LD	HL,(LAB_E488)	;5216:	2A88E4
	LD	A,H			; set the flags
	OR	L			;
	JP	NZ,LAB_5237	;521B:	C23752

	LD	HL,0000h		; clear bell flag
	PUSH	HL			; push bell flag
	LD	HL,LAB_6CE8		; points to 'Sending prog'
	PUSH	HL			; push message pointer
	LD	HL,0004h		; set line 4
	PUSH	HL			; push line #
	CALL	LAB_421C		; print message @ line, with bells on
	POP	DE			; dump line #
	POP	DE			; dump message pointer
	POP	DE			; dump bell flag ??
	LD	HL,0004h	;5230:	210400
	LD	A,L		;5233:	7D
	LD	(LAB_E6CF),A	;5234:	32CFE6
LAB_5237
	LD	HL,(LAB_E488)	;5237:	2A88E4
	LD	A,H			; set the flags
	OR	L			;
	JP	NZ,LAB_5253	;523C:	C25352

	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;5243:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;5245:	56
	PUSH	DE		;5246:	D5
	CALL	LAB_3E14	;5247:	CD143E
	POP	DE		;524A:	D1
	LD	(LAB_E488),HL	;524B:	2288E4
	LD	A,H			; set the flags
	OR	L			;
	JP	Z,LAB_5253	;5250:	CA5352

LAB_5253
	LD	HL,(LAB_E488)	;5253:	2A88E4
	JP	LAB_528E		; search table for HL, and execute

LAB_5259
	LD	A,(LAB_E48C)	; get status message #
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	PUSH	HL			; push status message #
	CALL	LAB_3BF5		; save (byte) at (LAB_E22D)
	POP	DE			; dump status message #
	JP	LAB_52A1	;5264:	C3A152

LAB_5267
	LD	HL,000Dh		; set status message # = 0Dh
	PUSH	HL			; push status message #
	CALL	LAB_3BF5		; save (byte) at (LAB_E22D)
	POP	DE			; dump status message #
	JP	LAB_52A1	;526F:	C3A152

LAB_5272
	LD	HL,1FD7h		; set error number 8151d
	PUSH	HL			; push error number
	CALL	LAB_4475		; do '      Timeout' message
	POP	DE			; dump error number
	JP	LAB_52A1	;527A:	C3A152

LAB_527D
	LD	HL,0006h	;527D:	210600
	LD	(LAB_E488),HL	;5280:	2288E4
	LD	HL,1FD6h		; set error number 8150d
	PUSH	HL			; push error number
	CALL	LAB_448D		; do '    Link failure' message
	POP	DE			; dump error number
	JP	LAB_52A1	;528B:	C3A152

; search table for HL, and execute

LAB_528E
	CALL	LAB_E0B2		; search following table for HL & execute vector

	DW	0003h			; 3 entries
	DW	0000h
	DW	LAB_5259
	DW	0004h
	DW	LAB_5267
	DW	0009h
	DW	LAB_5272
	DW	LAB_527D

LAB_52A1
	LD	HL,(LAB_E488)	;52A1:	2A88E4
	RET				;

LAB_52A5
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6)
	CALL	LAB_3BE8		; get (byte) HL from (LAB_E22D)
	LD	A,L			; copy it
	LD	(LAB_E518),A	; save ??
	LD	A,(LAB_E518)	; get ??
	LD	L,A			; copy it
	LD	H,#00h		; clear high byte
	LD	DE,0006h	;52B8:	110600
	CALL	LAB_E04B		; compare HL with DE, return HL=0 & Zb=1 if different
	JP	NZ,LAB_52D0	;52BE:	C2D052

	LD	A,(LAB_E518)	;52C1:	3A18E5
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	LD	DE,000Bh	;52C7:	110B00
	CALL	LAB_E04B		; compare HL with DE, return HL=0 & Zb=1 if different
	JP	Z,LAB_52DF	;52CD:	CADF52

LAB_52D0
	LD	HL,LAB_6CA1		; points to 'Program transmission'
	LD	(LAB_E514),HL	;52D3:	2214E5
	LD	HL,LAB_6D26		; points to 'Program transmitted'
	LD	(LAB_E516),HL	; save message pointer
	JP	LAB_52EB	;52DC:	C3EB52

LAB_52DF
	LD	HL,LAB_6C8E		; points to ' Data Transmission'
	LD	(LAB_E514),HL	;52E2:	2214E5
	LD	HL,LAB_6D13		; points to '  Data transmitted'
	LD	(LAB_E516),HL	; save message pointer
LAB_52EB
	LD	HL,000Fh	;52EB:	210F00
	PUSH	HL		;52EE:	E5
	CALL	LAB_452D	;52EF:	CD2D45
	POP	DE		;52F2:	D1
	LD	(LAB_E488),HL	;52F3:	2288E4
	LD	A,H			; set the flags
	OR	L			;
	JP	NZ,LAB_5424		; set HL & exit

	CALL	LAB_3D3C	;52FB:	CD3C3D
	LD	(LAB_E488),HL	;52FE:	2288E4
	LD	HL,(LAB_E488)	;5301:	2A88E4
	JP	LAB_540D		; search table for HL, and execute

LAB_5307
	LD	HL,0000h	;5307:	210000
	LD	(LAB_E488),HL	;530A:	2288E4
	LD	A,(LAB_E48D)	;530D:	3A8DE4
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	LD	DE,0001h	;5313:	110100
	CALL	LAB_E04B		; compare HL with DE, return HL=0 & Zb=1 if different
	JP	Z,LAB_533E	;5319:	CA3E53

	LD	HL,(LAB_E516)	; get message pointer
	PUSH	HL			; push message pointer
	LD	HL,0004h		; line 4
	PUSH	HL			; push line #
	CALL	LAB_41D9		; print message @ line
	POP	DE			; dump line #
	POP	DE			; dump message pointer
	LD	HL,0000h	;5329:	210000
	LD	A,L		;532C:	7D
	LD	(LAB_E6CF),A	;532D:	32CFE6
	LD	A,(LAB_E48C)	; get status message #
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	PUSH	HL			; push status message #
	CALL	LAB_3BF5		; save (byte) at (LAB_E22D)
	POP	DE			; dump status message #
	JP	LAB_5424		; set HL & exit

LAB_533E
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;5342:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;5344:	56
	PUSH	DE		;5345:	D5
	CALL	LAB_3F20	;5346:	CD203F
	POP	DE		;5349:	D1
	JP	LAB_53C4		; search table for HL, and execute

LAB_534D
	LD	HL,(LAB_E516)	; get message pointer
	PUSH	HL			; push message pointer
	LD	HL,0004h		; line 4
	PUSH	HL			; push line #
	CALL	LAB_41D9		; print message @ line
	POP	DE			; dump line #
	POP	DE			; dump message pointer
	LD	HL,0000h	;535A:	210000
	LD	A,L		;535D:	7D
	LD	(LAB_E6CF),A	;535E:	32CFE6
	LD	A,(LAB_E48C)	; get status message #
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	PUSH	HL			; push status message #
	CALL	LAB_3BF5		; save (byte) at (LAB_E22D)
	POP	DE			; dump status message #
	JP	LAB_53E3	;536C:	C3E353

LAB_536F
	LD	HL,0005h	;536F:	210500
	LD	(LAB_E488),HL	;5372:	2288E4
	LD	HL,0002h		; set status message # = 2
	PUSH	HL			; push status message #
	CALL	LAB_3BF5		; save (byte) at (LAB_E22D)
	POP	DE			; dump status message #
	JP	LAB_53E3	;537D:	C3E353

LAB_5380
	LD	HL,0006h	;5380:	210600
	LD	(LAB_E488),HL	;5383:	2288E4
	LD	HL,1FE3h		; set error number 8163d
	PUSH	HL			; push error number
	CALL	LAB_44BD		; do '   Invalid reply' message
	POP	DE			; dump error number
	JP	LAB_53E3	;538E:	C3E353

LAB_5391
	LD	HL,0004h	;5391:	210400
	LD	(LAB_E488),HL	;5394:	2288E4
	LD	HL,000Dh		; set status message # = 0Dh
	PUSH	HL			; push status message #
	CALL	LAB_3BF5		; save (byte) at (LAB_E22D)
	POP	DE			; dump status message #
	JP	LAB_53E3	;539F:	C3E353

LAB_53A2
	LD	HL,0009h	;53A2:	210900
	LD	(LAB_E488),HL	;53A5:	2288E4
	LD	HL,1FE5h		; set error number 8165d
	PUSH	HL			; push error number
	CALL	LAB_4475		; do '      Timeout' message
	POP	DE			; dump error number
	JP	LAB_53E3	;53B0:	C3E353

LAB_53B3
	LD	HL,0006h	;53B3:	210600
	LD	(LAB_E488),HL	;53B6:	2288E4
	LD	HL,1FE4h		; set error number 8164d
	PUSH	HL			; push error number
	CALL	LAB_448D		; do '    Link failure' message
	POP	DE			; dump error number
	JP	LAB_53E3	;53C1:	C3E353

; search table for HL, and execute

LAB_53C4
	CALL	LAB_E0B2		; search following table for HL & execute vector

	DW	0006h			; 6 entries
	DW	0000h
	DW	LAB_534D
	DW	0001h
	DW	LAB_536F
	DW	0002h
	DW	LAB_536F
	DW	0003h
	DW	LAB_5380
	DW	0004h
	DW	LAB_5391
	DW	0005h
	DW	LAB_53A2
	DW	LAB_53B3

LAB_53E3
	JP	LAB_5424		; set HL & exit

LAB_53E6
	LD	HL,1FE6h		; set error number 8166d
	PUSH	HL			; push error number
	CALL	LAB_4475		; do '      Timeout' message
	POP	DE			; dump error number
	JP	LAB_5424		; set HL & exit

LAB_53F1
	LD	HL,000Dh		; set status message # = 0Dh
	PUSH	HL			; push status message #
	CALL	LAB_3BF5		; save (byte) at (LAB_E22D)
	POP	DE			; dump status message #
	JP	LAB_5424		; set HL & exit

LAB_53FC
	LD	HL,0006h	;53FC:	210600
	LD	(LAB_E488),HL	;53FF:	2288E4
	LD	HL,1FE0h		; set error number 8160d
	PUSH	HL			; push error number
	CALL	LAB_448D		; do '    Link failure' message
	POP	DE			; dump error number
	JP	LAB_5424		; set HL & exit

; search table for HL, and execute

LAB_540D
	CALL	LAB_E0B2		; search following table for HL & execute vector

	DW	0004h			; 4 entries
	DW	0000h
	DW	LAB_5307
	DW	0004h
	DW	LAB_53F1
	DW	0008h
	DW	LAB_5307
	DW	0009h
	DW	LAB_53E6
	DW	LAB_53FC

LAB_5424
	LD	HL,(LAB_E488)	;5424:	2A88E4
	RET				;

; stack is ..
; ??
; ??
; end.

LAB_5428
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6)
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 1 before call
	LD	E,(HL)		;5432:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;5434:	56
	PUSH	DE		;5435:	D5
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;543A:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;543C:	56
	PUSH	DE		;543D:	D5
	CALL	LAB_58F9	;543E:	CDF958
	POP	DE		;5441:	D1
	POP	DE		;5442:	D1
	RET				;

; stack is ..
; ??
; ??
; ??
; end.

LAB_5444
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6)
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 2 before call
	LD	E,(HL)		;544E:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;5450:	56
	PUSH	DE		;5451:	D5
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 1 before call
	LD	E,(HL)		;5456:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;5458:	56
	PUSH	DE		;5459:	D5
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;545E:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;5460:	56
	PUSH	DE		;5461:	D5
	CALL	LAB_5915	;5462:	CD1559
	POP	DE		;5465:	D1
	POP	DE		;5466:	D1
	POP	DE		;5467:	D1
	RET				;

LAB_5469
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6)
	LD	HL,0010h	;546F:	211000
	PUSH	HL		;5472:	E5
	CALL	LAB_452D	;5473:	CD2D45
	POP	DE		;5476:	D1
	LD	(LAB_E488),HL	;5477:	2288E4
	LD	A,H			; set the flags
	OR	L			;
	JP	NZ,LAB_54E1	;547C:	C2E154

	CALL	LAB_593A	;547F:	CD3A59
	LD	(LAB_E488),HL	;5482:	2288E4
	LD	HL,(LAB_E488)	;5485:	2A88E4
	JP	LAB_54C6		; search table for HL, and execute

LAB_548B
	LD	HL,0004h	;548B:	210400
	LD	(LAB_E488),HL	;548E:	2288E4
	LD	A,(LAB_E48C)	; get status message #
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	PUSH	HL			; push status message #
	CALL	LAB_3BF5		; save (byte) at (LAB_E22D)
	POP	DE			; dump status message #
	JP	LAB_54E1	;549C:	C3E154

; do error 8181d, timeout message

LAB_549F
	LD	HL,1FF5h		; set error number 8181d
	PUSH	HL			; push error number
	CALL	LAB_4475		; do '      Timeout' message
	POP	DE			; dump error number
	JP	LAB_54E1	;54A7:	C3E154

; do error 8182d, modem fault message

LAB_54AA
	LD	HL,1FF6h		; set error number 8182d
	PUSH	HL			; push error number
	CALL	LAB_44D5		; do '    Modem fault' message
	POP	DE			; dump error number
	JP	LAB_54E1	;54B2:	C3E154

; do error 8180d, link faliure message

LAB_54B5
	LD	HL,0006h	;54B5:	210600
	LD	(LAB_E488),HL	;54B8:	2288E4
	LD	HL,1FF4h		; set error number 8180d
	PUSH	HL			; push error number
	CALL	LAB_448D		; do '    Link failure' message
	POP	DE			; dump error number
	JP	LAB_54E1	;54C3:	C3E154

; search table for HL, and execute

LAB_54C6
	CALL	LAB_E0B2		; search following table for HL & execute vector

	DW	0005h			; 5 entries
	DW	0000h
	DW	LAB_548B		;
	DW	0001h
	DW	LAB_54AA		; do error 8182d, modem fault message
	DW	0004h
	DW	LAB_548B		;
	DW	0009h
	DW	LAB_549F		; do error 8181d, timeout message
	DW	000Fh
	DW	LAB_54AA		; do error 8182d, modem fault message
	DW	LAB_54B5		; do error 8180d, link faliure message

LAB_54E1
	LD	HL,(LAB_E488)	;54E1:	2A88E4
	RET				;

; clears byte @ LAB_E519

LAB_54E5
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6)
	LD	HL,0000h		; clear HL
	LD	A,L			; copy 00h to A
	LD	(LAB_E519),A	; clear byte
	RET				;

; stack is ..
; ??
; ??
; ??
; end.

LAB_54F3
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6)
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 2 before call
	LD	A,(HL)		;54FD:	7E
	INC	HL			; increment pointer
	OR	(HL)		;54FF:	B6
	JP	Z,LAB_551C	;5500:	CA1C55

	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 1 before call
	LD	E,(HL)		;5507:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;5509:	56
	EX	DE,HL		;550A:	EB
	LD	E,(HL)		;550B:	5E
	LD	D,#00h		; clear high byte
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 2 before call
	LD	A,(HL)		;5512:	7E
	INC	HL			; increment pointer
	LD	H,(HL)		;5514:	66
	LD	L,A		;5515:	6F
	CALL	LAB_E0E7		; does CP DE,HL, returns HL=0 & Zb=1 if no carry (HL<=DE)
	JP	Z,LAB_5541	;5519:	CA4155

LAB_551C
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;5520:	5E
	PUSH	DE		;5521:	D5
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 1 before call
	LD	E,(HL)		;5526:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;5528:	56
	EX	DE,HL		;5529:	EB
	PUSH	HL		;552A:	E5
	LD	L,(HL)		;552B:	6E
	INC	HL		;552C:	23
	EX	DE,HL		;552D:	EB
	POP	HL		;552E:	E1
	LD	(HL),E		;552F:	73
	EX	DE,HL		;5530:	EB
	DEC	HL		;5531:	2B
	LD	H,#00h		;5532:	2600
	EX	DE,HL		;5534:	EB
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 1 before call
	LD	A,(HL)		;5539:	7E
	INC	HL			; increment pointer
	LD	H,(HL)		;553B:	66
	LD	L,A		;553C:	6F
	ADD	HL,DE		;553D:	19
	INC	HL		;553E:	23
	POP	DE		;553F:	D1
	LD	(HL),E		;5540:	73
LAB_5541
	RET				;

; stack is ..
; ??
; end.

LAB_5542
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6)
	LD	HL,0000h	;5548:	210000
	PUSH	HL		;554B:	E5
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;5550:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;5552:	56
	EX	DE,HL		;5553:	EB
	POP	DE		;5554:	D1
	LD	(HL),E		;5555:	73
LAB_5556
	LD	HL,LAB_E51D	;5556:	211DE5
	PUSH	HL		;5559:	E5
	CALL	LAB_3DCB	;555A:	CDCB3D
	POP	DE		;555D:	D1
	LD	(LAB_E51B),HL	;555E:	221BE5
	LD	A,H			; set the flags
	OR	L			;
	JP	Z,LAB_5572	;5563:	CA7255

	LD	HL,(LAB_E51B)	;5566:	2A1BE5
	LD	DE,0008h	;5569:	110800
	CALL	LAB_E04B		; compare HL with DE, return HL=0 & Zb=1 if different
	JP	Z,LAB_5665	;556F:	CA6556
LAB_5572
	LD	HL,00FFh	;5572:	21FF00
	EX	DE,HL		;5575:	EB
	LD	HL,(LAB_E51D)	;5576:	2A1DE5
	CALL	LAB_E023		; does AND HL,DE. sets Z flag
	LD	(LAB_E51D),HL	;557C:	221DE5
	LD	HL,(LAB_E51B)	;557F:	2A1BE5
	LD	DE,0008h	;5582:	110800
	CALL	LAB_E04B		; compare HL with DE, return HL=0 & Zb=1 if different
	JP	Z,LAB_5595	;5588:	CA9555

	LD	HL,0000h	;558B:	210000
	LD	A,L		;558E:	7D
	LD	(LAB_E51A),A	;558F:	321AE5
	JP	LAB_55B9	;5592:	C3B955
LAB_5595
	LD	HL,(LAB_E51D)	;5595:	2A1DE5
	LD	DE,0020h	;5598:	112000
	EX	DE,HL		;559B:	EB
	CALL	LAB_E06A		; does signed CP DE,HL. returns HL=1 if HL<=DE
	JP	Z,LAB_55AC	;559F:	CAAC55

	LD	HL,0003h	;55A2:	210300
	LD	A,L		;55A5:	7D
	LD	(LAB_E51A),A	;55A6:	321AE5
	JP	LAB_55B9	;55A9:	C3B955

LAB_55AC
	LD	HL,(LAB_E51D)	;55AC:	2A1DE5
	LD	DE,LAB_6A2A		; point to ?? table
	ADD	HL,DE		;55B2:	19
	LD	E,(HL)		;55B3:	5E
	EX	DE,HL		;55B4:	EB
	LD	A,L		;55B5:	7D
	LD	(LAB_E51A),A	;55B6:	321AE5
LAB_55B9
	LD	A,(LAB_E51A)	;55B9:	3A1AE5
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	PUSH	HL		;55BF:	E5
	LD	A,(LAB_E519)	;55C0:	3A19E5
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	LD	DE,0006h		; 6 bytes per entry
	CALL	LAB_DFCC		; does HL = HL*DE
	POP	DE		;55CC:	D1
	ADD	HL,DE		;55CD:	19
	LD	DE,LAB_6A18		; point to ?? table
	ADD	HL,DE		;55D1:	19
	LD	E,(HL)		;55D2:	5E
	EX	DE,HL		;55D3:	EB
	LD	A,L		;55D4:	7D
	LD	(LAB_E51F),A	;55D5:	321FE5
	LD	A,(LAB_E51F)	;55D8:	3A1FE5
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	LD	DE,000Fh	;55DE:	110F00
	CALL	LAB_E023		; does AND HL,DE. sets Z flag
	LD	A,L		;55E4:	7D
	LD	(LAB_E519),A	;55E5:	3219E5
	LD	A,(LAB_E51F)	;55E8:	3A1FE5
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	LD	DE,0004h	;55EE:	110400
	EX	DE,HL		;55F1:	EB
	CALL	LAB_DFE4	;55F2:	CDE4DF
	LD	DE,000Fh	;55F5:	110F00
	CALL	LAB_E023		; does AND HL,DE. sets Z flag
	JP	LAB_5643		; search table for HL, and execute

LAB_55FE
	LD	HL,0000h	;55FE:	210000
	RET				;

; set HL = 0007h

LAB_5602
	LD	HL,0007h	;5602:	210700
	RET				;

; set HL = 0008h

LAB_5606
	LD	HL,0008h	;5606:	210800
	RET				;

; set error, Invalid data stream

LAB_560A
	LD	HL,000Ah		; set error, Invalid data stream
	RET				;

LAB_560E
	LD	HL,000Ch	;560E:	210C00
	PUSH	HL		;5611:	E5
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;5616:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;5618:	56
	PUSH	DE		;5619:	D5
	LD	HL,(LAB_E51D)	;561A:	2A1DE5
	PUSH	HL		;561D:	E5
	CALL	LAB_54F3	;561E:	CDF354
	POP	DE		;5621:	D1
	POP	DE		;5622:	D1
	POP	DE		;5623:	D1
	JP	LAB_5662	;5624:	C36256

LAB_5627
	LD	HL,0000h	;5627:	210000
	PUSH	HL		;562A:	E5
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;562F:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;5631:	56
	PUSH	DE		;5632:	D5
	LD	HL,(LAB_E51D)	;5633:	2A1DE5
	PUSH	HL		;5636:	E5
	CALL	LAB_54F3	;5637:	CDF354
	POP	DE		;563A:	D1
	POP	DE		;563B:	D1
	POP	DE		;563C:	D1
	JP	LAB_5662	;563D:	C36256
LAB_5640
	JP	LAB_5662	;5640:	C36256

LAB_5643
	CALL	LAB_E0B2		; search following table for HL & execute vector

	DW	0006h			; 6 entries
	DW	0000h
	DW	LAB_55FE
	DW	0001h
	DW	LAB_5602		; set HL = 0007h
	DW	0002h
	DW	LAB_5606		; set HL = 0008h
	DW	0003h
	DW	LAB_560A		; set HL = 000Ah
	DW	0004h
	DW	LAB_560E
	DW	0005h
	DW	LAB_5627
	DW	LAB_5640

LAB_5662
	JP	LAB_5556	;5662:	C35655
LAB_5665
	LD	HL,(LAB_E51B)	;5665:	2A1BE5
	RET				;

; stack is ..
; ??
; ??
; ??
; ??
; end.

LAB_5669
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6)
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 1 before call
	LD	E,(HL)		;5673:	5E
	EX	DE,HL		;5674:	EB
	LD	A,L		;5675:	7D
	LD	(LAB_E520),A	;5676:	3220E5
	LD	HL,0012h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 3 before call
	LD	E,(HL)		;567D:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;567F:	56
	PUSH	DE		;5680:	D5
	LD	HL,0012h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 2 before call
	LD	E,(HL)		;5685:	5E
	LD	D,#00h		; clear high byte
	PUSH	DE		;5688:	D5
	LD	HL,0012h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 1 before call
	LD	E,(HL)		;568D:	5E
	LD	D,#00h		; clear high byte
	PUSH	DE		;5690:	D5
	LD	HL,0012h		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;5695:	5E
	LD	D,#00h		; clear high byte
	PUSH	DE		;5698:	D5
	CALL	LAB_5BF7	;5699:	CDF75B
	EX	DE,HL		;569C:	EB
	LD	HL,0008h		; 8 ..
	ADD	HL,SP			; .. + stack ..
	LD	SP,HL			; .. = dump the lot
	EX	DE,HL		;56A2:	EB
	RET				;

; stack is ..
; ??
; ??
; ??
; ??
; ??
; end.

LAB_56A4
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6)
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 1 before call
	LD	E,(HL)		;56AE:	5E
	EX	DE,HL		;56AF:	EB
	LD	A,L		;56B0:	7D
	LD	(LAB_E520),A	;56B1:	3220E5
	LD	HL,0014h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 4 before call
	LD	E,(HL)		;56B8:	5E
	LD	D,#00h		; clear high byte
	PUSH	DE		;56BB:	D5
	LD	HL,0014h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 3 before call
	LD	E,(HL)		;56C0:	5E
	LD	D,#00h		; clear high byte
	PUSH	DE		;56C3:	D5
	LD	HL,0014h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 2 before call
	LD	E,(HL)		;56C8:	5E
	LD	D,#00h		; clear high byte
	PUSH	DE		;56CB:	D5
	LD	HL,0014h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 1 before call
	LD	E,(HL)		;56D0:	5E
	LD	D,#00h		; clear high byte
	PUSH	DE		;56D3:	D5
	LD	HL,0014h		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;56D8:	5E
	LD	D,#00h		; clear high byte
	PUSH	DE		;56DB:	D5
	CALL	LAB_5CD7	;56DC:	CDD75C
	EX	DE,HL		;56DF:	EB
	LD	HL,000Ah		; 10 ..
	ADD	HL,SP			; .. + stack ..
	LD	SP,HL			; .. = dump the lot
	EX	DE,HL		;56E5:	EB
	RET				;

LAB_56E7
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6)
	LD	A,(LAB_E520)	;56ED:	3A20E5
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	JP	LAB_572E		; search table for HL, and execute

LAB_56F6
	LD	HL,LAB_E29F		; null message
	PUSH	HL			; push line 6 message pointer
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		; get message pointer low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get message pointer high byte
	PUSH	DE			; push line 5 message pointer
	LD	HL,LAB_E29E		; null message
	PUSH	HL			; push line 4 message pointer
	LD	HL,LAB_6EAA		; points to '      Dialling'
	PUSH	HL			; push line 3 message pointer
	CALL	LAB_4296		; print 4 line message ???
	EX	DE,HL			;
	LD	HL,0008h		; 8 ..
	ADD	HL,SP			; .. + stack ..
	LD	SP,HL			; .. = dump the lot
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;5717:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;5719:	56
	PUSH	DE		;571A:	D5
	CALL	LAB_5F58	;571B:	CD585F
	POP	DE		;571E:	D1
	LD	(LAB_E521),HL	;571F:	2221E5
	JP	LAB_5739	;5722:	C33957

LAB_5725
	CALL	LAB_5DFD	;5725:	CDFD5D
	LD	(LAB_E521),HL	;5728:	2221E5
	JP	LAB_5739	;572B:	C33957

LAB_572E
	CALL	LAB_E0B2		; search following table for HL & execute vector

	DW	0001h			; 1 entry
	DW	0006h
	DW	LAB_56F6
	DW	LAB_5725

LAB_5739
	LD	HL,(LAB_E521)	;5739:	2A21E5
	RET				;

LAB_573D
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6)
	LD	A,(LAB_E520)	;5743:	3A20E5
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	JP	LAB_5780		; search table for HL, and execute

LAB_574C
	LD	HL,LAB_E2A2		; null message
	PUSH	HL			; push line 6 message pointer
	LD	HL,LAB_E2A1		; null message
	PUSH	HL			; push line 5 message pointer
	LD	HL,LAB_E2A0		; null message
	PUSH	HL			; push line 4 message pointer
	LD	HL,LAB_6EB9		; points to '   Awaiting phone'
	PUSH	HL			; push line 3 message pointer
	CALL	LAB_4296		; print 4 line message ???
	EX	DE,HL			;
	LD	HL,0008h		; 8 ..
	ADD	HL,SP			; .. + stack ..
	LD	SP,HL			; .. = dump the lot
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;5769:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;576B:	56
	PUSH	DE		;576C:	D5
	CALL	LAB_606C	;576D:	CD6C60
	POP	DE		;5770:	D1
	LD	(LAB_E523),HL	;5771:	2223E5
	JP	LAB_578B	;5774:	C38B57

LAB_5777
	CALL	LAB_5DFD	;5777:	CDFD5D
	LD	(LAB_E523),HL	;577A:	2223E5
	JP	LAB_578B	;577D:	C38B57

LAB_5780
	CALL	LAB_E0B2		; search following table for HL & execute vector

	DW	0001h			; 1 entry
	DW	0006h
	DW	LAB_574C
	DW	LAB_5777

LAB_578B
	LD	HL,(LAB_E523)	;578B:	2A23E5
	RET				;

LAB_578F
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6)
	LD	A,(LAB_E520)	;5795:	3A20E5
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	JP	LAB_581B		; search table for HL, and execute

LAB_579E
	LD	HL,LAB_6EFF		; points to '  been established.'
	PUSH	HL			; push line 6 message pointer
	LD	HL,LAB_6EED		; points to '   connection has'
	PUSH	HL			; push line 5 message pointer
	LD	HL,LAB_6EDC		; points to '   Press >> when'
	PUSH	HL			; push line 4 message pointer
	LD	HL,LAB_6ECB		; points to '    Dial number.'
	PUSH	HL			; push line 3 message pointer
	CALL	LAB_4296		; print 4 line message ???
	EX	DE,HL			;
	LD	HL,0008h		; 8 ..
	ADD	HL,SP			; .. + stack ..
	LD	SP,HL			; .. = dump the lot
	LD	HL,LAB_6F13		; points to '               >> '
	PUSH	HL			; push message pointer
	LD	HL,0008h		; line 8
	PUSH	HL			; push line #
	CALL	LAB_41D9		; print message @ line
	POP	DE			; dump line #
	POP	DE			; dump message pointer
LAB_57C4
	CALL	LAB_65C2		; get byte from key buffer ??
	LD	A,L			; copy key
	LD	(LAB_E527),A	; save key
	LD	H,#00h		; clear high byte
	LD	DE,000Dh		; set compare byte [ENTER]
	CALL	LAB_E05A		; compare HL with DE, return HL=0 & Zb=1 if the same
	JP	Z,LAB_57E8		; jump if =

	LD	A,(LAB_E527)	; get key back
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	LD	DE,0014h		; set compare byte [END]
	CALL	LAB_E05A		; compare HL with DE, return HL=0 & Zb=1 if the same
	JP	Z,LAB_57E8		; jump if =

	JP	LAB_57C4		; loop until [ENTER]/[END] pressed

LAB_57E8
	CALL	LAB_666B		; get key status without waiting
	JP	Z,LAB_57F4		; jump if no key waiting

	CALL	LAB_65C2		; else get key
	JP	LAB_57E8		; loop until no keys

LAB_57F4
	LD	A,(LAB_E527)	; get key back
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	LD	DE,000Dh		; set compare byte [ENTER]
	CALL	LAB_E04B		; compare HL with DE, return HL=0 & Zb=1 if different
	JP	Z,LAB_5809		; jump if [ENTER]

					; else was [END]
	CALL	LAB_60C2	;5803:	CDC260
	JP	LAB_580C	;5806:	C30C58

LAB_5809
	LD	HL,0004h	;5809:	210400
LAB_580C
	LD	(LAB_E525),HL	;580C:	2225E5
	JP	LAB_5826	;580F:	C32658

LAB_5812
	CALL	LAB_5DFD	;5812:	CDFD5D
	LD	(LAB_E525),HL	;5815:	2225E5
	JP	LAB_5826	;5818:	C32658

LAB_581B
	CALL	LAB_E0B2		; search following table for HL & execute vector

	DW	0001h			; 1 entry
	DW	0006h
	DW	LAB_579E
	DW	LAB_5812

LAB_5826
	LD	HL,(LAB_E525)	;5826:	2A25E5
	RET				;

LAB_582A
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6)
	CALL	LAB_60CC	;5830:	CDCC60
	RET				;

LAB_5834
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6)
	CALL	LAB_60D6	;583A:	CDD660
	RET				;

; set HL = 0000h

LAB_583E
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6)
	CALL	LAB_6120		; set HL = 0000h
	RET				;

; stack is ..
; ??
; ??
; end.

LAB_5848
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6)
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 1 before call
	LD	E,(HL)		; get ?? low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get ?? high byte
	PUSH	DE			; push ??
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		; get ?? low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get ?? high byte
	PUSH	DE			; push ??
	CALL	LAB_6181	;585E:	CD8161
	POP	DE			; dump ??
	POP	DE			; dump ??
	LD	(LAB_E528),HL	;5863:	2228E5
	LD	A,(LAB_E6CF)	;5866:	3ACFE6
	OR	A		;5869:	B7
	JP	Z,LAB_587C	;586A:	CA7C58

	LD	HL,(LAB_E528)	;586D:	2A28E5
	LD	DE,0004h	;5870:	110400
	CALL	LAB_E05A		; compare HL with DE, return HL=0 & Zb=1 if the same
	JP	Z,LAB_587C	;5876:	CA7C58

	CALL	LAB_4199		; output +(LAB_E6CD)d at 10h,(LAB_E6CF)
LAB_587C
	LD	HL,(LAB_E528)	;587C:	2A28E5
	RET				;

; stack is ..
; ??
; ??
; end.

LAB_5880
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6)
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 1 before call
	LD	E,(HL)		;588A:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;588C:	56
	PUSH	DE		;588D:	D5
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;5892:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;5894:	56
	PUSH	DE		;5895:	D5
	CALL	LAB_61CC	;5896:	CDCC61
	POP	DE		;5899:	D1
	POP	DE		;589A:	D1
	LD	(LAB_E52A),HL	;589B:	222AE5
	LD	A,(LAB_E6CF)	;589E:	3ACFE6
	OR	A		;58A1:	B7
	JP	Z,LAB_58B4	;58A2:	CAB458

	LD	HL,(LAB_E52A)	;58A5:	2A2AE5
	LD	DE,0004h	;58A8:	110400
	CALL	LAB_E05A		; compare HL with DE, return HL=0 & Zb=1 if the same
	JP	Z,LAB_58B4	;58AE:	CAB458

	CALL	LAB_4199		; output +(LAB_E6CD)d at 10h,(LAB_E6CF)
LAB_58B4
	LD	HL,(LAB_E52A)	;58B4:	2A2AE5
	RET				;

; stack is ..
; ??
; ??
; ??
; end.

LAB_58B8
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6)
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 2 before call
	LD	E,(HL)		;58C2:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;58C4:	56
	PUSH	DE		;58C5:	D5
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 1 before call
	LD	E,(HL)		;58CA:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;58CC:	56
	PUSH	DE		;58CD:	D5
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;58D2:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;58D4:	56
	PUSH	DE		;58D5:	D5
	CALL	LAB_620B	;58D6:	CD0B62
	POP	DE		;58D9:	D1
	POP	DE		;58DA:	D1
	POP	DE		;58DB:	D1
	LD	(LAB_E52C),HL	;58DC:	222CE5
	LD	A,(LAB_E6CF)	;58DF:	3ACFE6
	OR	A		;58E2:	B7
	JP	Z,LAB_58F5	;58E3:	CAF558

	LD	HL,(LAB_E52C)	;58E6:	2A2CE5
	LD	DE,0004h	;58E9:	110400
	CALL	LAB_E05A		; compare HL with DE, return HL=0 & Zb=1 if the same
	JP	Z,LAB_58F5	;58EF:	CAF558

	CALL	LAB_4199		; output +(LAB_E6CD)d at 10h,(LAB_E6CF)
LAB_58F5
	LD	HL,(LAB_E52C)	;58F5:	2A2CE5
	RET				;

; stack is ..
; ??
; ??
; end.

LAB_58F9
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6)
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 1 before call
	LD	E,(HL)		;5903:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;5905:	56
	PUSH	DE		;5906:	D5
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;590B:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;590D:	56
	PUSH	DE		;590E:	D5
	CALL	LAB_63CA	;590F:	CDCA63
	POP	DE		;5912:	D1
	POP	DE		;5913:	D1
	RET				;

; stack is ..
; ??
; ??
; ??
; end.

LAB_5915
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6)
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 2 before call
	LD	E,(HL)		;591F:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;5921:	56
	PUSH	DE		;5922:	D5
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 1 before call
	LD	E,(HL)		;5927:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;5929:	56
	PUSH	DE		;592A:	D5
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;592F:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;5931:	56
	PUSH	DE		;5932:	D5
	CALL	LAB_62C7	;5933:	CDC762
	POP	DE		;5936:	D1
	POP	DE		;5937:	D1
	POP	DE		;5938:	D1
	RET				;

LAB_593A
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6)
	CALL	LAB_5BA6	;5940:	CDA65B
	RET				;

; returns smaller of #1 & #2

; stack is ..
; #1
; #2
; end.

LAB_5944
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6)
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		; get #1 low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get #1 high byte
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 1 before call
	LD	A,(HL)		; get #2 low byte
	INC	HL			; increment pointer
	LD	H,(HL)		; get #2 high byte
	LD	L,A			; copy low byte to L
	CALL	LAB_E085		; does signed CP DE,HL. returns HL=1 if HL>DE
	JP	Z,LAB_596A		; jump if #2<=#1

	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		; get #1 low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get #1 high byte
	EX	DE,HL			; swap to HL
	JP	LAB_5972		; go exit (RET here would be better!)

LAB_596A
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 1 before call
	LD	E,(HL)		; get #2 low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get #2 high byte
	EX	DE,HL			; swap to HL
LAB_5972
	RET				;

; setup ?? from stack

; stack is ..
; ?? byte -> (LAB_E534)
; ?? word -> (LAB_E530)
; ?? word -> (LAB_E5BA)
; ?? word -> (LAB_E538)
; ?? byte -> (LAB_E536)
; end.

; could be shorter!

LAB_5973
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6)
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)	;597D:	5E
	INC	HL			; increment pointer
	LD	D,(HL)	;597F:	56
	EX	DE,HL			; swap to HL
	LD	A,L		;5981:	7D
	LD	(LAB_E534),A	;5982:	3234E5
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 1 before call
	LD	E,(HL)	;5989:	5E
	INC	HL			; increment pointer
	LD	D,(HL)	;598B:	56
	EX	DE,HL			; swap to HL
	LD	(LAB_E530),HL	;598D:	2230E5
	LD	HL,0012h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 3 before call
	LD	E,(HL)	;5994:	5E
	INC	HL			; increment pointer
	LD	D,(HL)	;5996:	56
	EX	DE,HL			; swap to HL
	LD	(LAB_E538),HL	;5998:	2238E5
	LD	HL,0014h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 4 before call
	LD	E,(HL)	;599F:	5E
	INC	HL			; increment pointer
	LD	D,(HL)	;59A1:	56
	EX	DE,HL			; swap to HL
	LD	A,L		;59A3:	7D
	LD	(LAB_E536),A	;59A4:	3236E5
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 2 before call
	LD	E,(HL)	;59AB:	5E
	INC	HL			; increment pointer
	LD	D,(HL)	;59AD:	56
	EX	DE,HL			; swap to HL
	LD	(LAB_E5BA),HL	;59AF:	22BAE5
	RET				;

LAB_59B3
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6)
	LD	HL,(LAB_E52E)	; get AF
	PUSH	HL			; push AF
	LD	HL,0000h		; set BC
	PUSH	HL			; push BC
	LD	HL,LAB_E530		; set DE
	PUSH	HL			; push DE
	LD	HL,LAB_E5BA		; set HL
	PUSH	HL			; push HL
	LD	HL,0033h		; set offset to jump to LAB_F355 (LAB_3872)
	PUSH	HL			; push offset
	CALL	LAB_D893		; set registers & execute routine @ warm+offset
	EX	DE,HL			;
	LD	HL,000Ah		; 10 ..
	ADD	HL,SP			; .. + stack ..
	LD	SP,HL			; .. = dump the lot
	RET				;

LAB_59D7
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6)
	LD	HL,(LAB_E52E)	; get AF
	PUSH	HL			; push AF
	LD	HL,0000h		; set BC
	PUSH	HL			; push BC
	LD	HL,LAB_E530		; set DE
	PUSH	HL			; push DE
	LD	HL,LAB_E5BA		; set HL
	PUSH	HL			; push HL
	LD	HL,0030h		; set offset to jump to LAB_F34A (LAB_3867)
	PUSH	HL			; push offset
	CALL	LAB_D893		; set registers & execute routine @ warm+offset
	EX	DE,HL		;59F4:	EB
	LD	HL,000Ah		; 10 ..
	ADD	HL,SP			; .. + stack ..
	LD	SP,HL			; .. = dump the lot
	RET				;

LAB_59FB
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6)
	LD	HL,0000h	;5A01:	210000
	LD	(LAB_E64A),HL	;5A04:	224AE6
	LD	A,(LAB_E534)	;5A07:	3A34E5
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	LD	(LAB_E64C),HL	;5A0D:	224CE6
	CALL	LAB_6431		; get RTC seconds to (LAB_E69A)
LAB_5A13
	LD	HL,0001h		; again this ..
	LD	A,H			; .. funky code ..
	OR	L			; .. does absolutely ..
	JP	Z,LAB_5B0A		; .. fucking nothing !!

	CALL	LAB_666B		; get key status without waiting
	JP	Z,LAB_5A81		; jump if no key waiting

	CALL	LAB_65C2		; get byte from key buffer
	LD	DE,0014h		; set compare byte [END]
	CALL	LAB_E04B		; compare HL with DE, return HL=0 & Zb=1 if different
	JP	Z,LAB_5A81		; jump if was not [END]

					; key was not [END]
	LD	HL,(LAB_E64A)	;5A2D:	2A4AE6
	LD	A,H			; set the flags
	OR	L			;
	JP	NZ,LAB_5A81	;5A32:	C2815A

	LD	HL,(LAB_E64C)	;5A35:	2A4CE6
	JP	LAB_5A66		; search table for HL, and execute

LAB_5A3B
	LD	HL,LAB_E2A5		; null message
	PUSH	HL			; push line 6 message pointer
	LD	HL,LAB_E2A4		; null message
	PUSH	HL			; push line 5 message pointer
	LD	HL,LAB_E2A3		; null message
	PUSH	HL			; push line 4 message pointer
	LD	HL,LAB_6F26		; points to '   Abort pending'
	PUSH	HL			; push line 3 message pointer
	CALL	LAB_4296		; print 4 line message ???
	EX	DE,HL			;
	LD	HL,0008h		; 8 ..
	ADD	HL,SP			; .. + stack ..
	LD	SP,HL			; .. = dump the lot
	LD	HL,0001h	;5A54:	210100
	LD	(LAB_E64A),HL	;5A57:	224AE6
	CALL	LAB_59D7	;5A5A:	CDD759
	CALL	LAB_6431		; get RTC seconds to (LAB_E69A)
	JP	LAB_5A81	;5A60:	C3815A

LAB_5A63
	JP	LAB_5A81	;5A63:	C3815A

; search table for HL, and execute

LAB_5A66
	CALL	LAB_E0B2		; search following table for HL & execute vector

	DW	0005h			; 5 entries
	DW	0044h
	DW	LAB_5A3B		; do "Abort pending"
	DW	0045h
	DW	LAB_5A3B		; do "Abort pending"
	DW	0060h
	DW	LAB_5A3B		; do "Abort pending"
	DW	0061h
	DW	LAB_5A3B		; do "Abort pending"
	DW	0064h
	DW	LAB_5A3B		; do "Abort pending"
	DW	LAB_5A63

LAB_5A81
	LD	HL,(LAB_E5BC)	;5A81:	2ABCE5
	LD	(LAB_E644),HL	;5A84:	2244E6
	LD	A,(LAB_E5BE)	;5A87:	3ABEE5
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	LD	(LAB_E646),HL	;5A8D:	2246E6
	LD	A,(LAB_E5BF)	;5A90:	3ABFE5
	LD	L,A		;5A93:	6F
	LD	A,L		;5A94:	7D
	LD	(LAB_E648),A	;5A95:	3248E6
	LD	A,(LAB_E5C0)	;5A98:	3AC0E5
	LD	L,A		;5A9B:	6F
	LD	A,L		;5A9C:	7D
	LD	(LAB_E649),A	;5A9D:	3249E6
	LD	HL,(LAB_E646)	;5AA0:	2A46E6
	LD	(LAB_E701),HL	;5AA3:	2201E7
	LD	A,(LAB_E648)	;5AA6:	3A48E6
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	LD	(LAB_E6FF),HL	;5AAC:	22FFE6
	LD	HL,(LAB_E644)	;5AAF:	2A44E6
	LD	A,H			; set the flags
	OR	L			;
	JP	Z,LAB_5AF0	;5AB4:	CAF05A

	LD	HL,(LAB_E644)	;5AB7:	2A44E6
	LD	DE,0000h		; set compare value
	EX	DE,HL			; swap to HL
	CALL	LAB_E085		; does signed CP DE,HL. returns HL=1 if HL>DE
	JP	NZ,LAB_5B0A		; jump if DE -ve

	LD	HL,(LAB_E646)	;5AC4:	2A46E6
	LD	A,H			; set the flags
	OR	L			;
	JP	NZ,LAB_5B0A	;5AC9:	C20A5B

	LD	A,(LAB_E649)	;5ACC:	3A49E6
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	LD	DE,0001h	;5AD2:	110100
	CALL	LAB_E04B		; compare HL with DE, return HL=0 & Zb=1 if different
	JP	Z,LAB_5AED	;5AD8:	CAED5A

	LD	HL,(LAB_E64C)	;5ADB:	2A4CE6
	LD	DE,0044h	;5ADE:	114400
	CALL	LAB_E04B		; compare HL with DE, return HL=0 & Zb=1 if different
	JP	Z,LAB_5AED	;5AE4:	CAED5A

	LD	HL,0008h	;5AE7:	210800
	LD	(LAB_E646),HL	;5AEA:	2246E6
LAB_5AED
	JP	LAB_5B0A	;5AED:	C30A5B

LAB_5AF0
	LD	A,(LAB_E6FC)	;5AF0:	3AFCE6
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	PUSH	HL			; push elapsed time
	CALL	LAB_6443		; return HL=1 if elapsed seconds since clock read
	POP	DE			; dump elapsed time
	JP	Z,LAB_5B07	;5AFB:	CA075B

	LD	HL,0009h	;5AFE:	210900
	LD	(LAB_E646),HL	;5B01:	2246E6
	JP	LAB_5B0A	;5B04:	C30A5B

LAB_5B07
	JP	LAB_5A13	;5B07:	C3135A

LAB_5B0A
	LD	HL,(LAB_E64A)	;5B0A:	2A4AE6
	LD	A,H			; set the flags
	OR	L			;
	JP	Z,LAB_5B1E	;5B0F:	CA1E5B

	LD	HL,0001h	;5B12:	210100
	LD	(LAB_E6F8),HL	;5B15:	22F8E6
	LD	HL,0004h	;5B18:	210400
	LD	(LAB_E646),HL	;5B1B:	2246E6
LAB_5B1E
	LD	HL,(LAB_E646)	;5B1E:	2A46E6
	LD	DE,0004h	;5B21:	110400
	CALL	LAB_E04B		; compare HL with DE, return HL=0 & Zb=1 if different
	JP	Z,LAB_5B54	;5B27:	CA545B

	LD	HL,(LAB_E6F8)	;5B2A:	2AF8E6
	LD	A,H			; set the flags
	OR	L			;
	JP	NZ,LAB_5B54	;5B2F:	C2545B

	LD	HL,LAB_E2A7		; null message
	PUSH	HL			; push line 6 message pointer
	LD	HL,LAB_E2A6		; null message
	PUSH	HL			; push line 5 message pointer
	LD	HL,LAB_6F49		; points to '   by remote end'
	PUSH	HL			; push line 4 message pointer
	LD	HL,LAB_6F37		; points to '  Session aborted'
	PUSH	HL			; push line 3 message pointer
	CALL	LAB_4296		; print 4 line message ???
	EX	DE,HL			;
	LD	HL,0008h		; 8 ..
	ADD	HL,SP			; .. + stack ..
	LD	SP,HL			; .. = dump the lot
	CALL	LAB_42EE		; wait (LAB_E6FD) seconds or do press to cont
	LD	HL,0001h	;5B4E:	210100
	LD	(LAB_E703),HL	;5B51:	2203E7
LAB_5B54
	LD	HL,(LAB_E646)	;5B54:	2A46E6
	RET				;

; zero 8Ah long blocks at LAB_E530 and LAB_E5BA

LAB_5B58
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6)
	LD	HL,008Ah		; count is 8Ah
	PUSH	HL			; push count
	LD	HL,LAB_E530		; point to LAB_E530
	PUSH	HL			; push pointer
	CALL	LAB_3CA3		; fill count bytes, from destination, with 00h
	POP	DE			; dump destination
	POP	DE			; dump count   (don't need this)
	LD	HL,008Ah		; count is 8Ah (don't need this)
	PUSH	HL			; push count   (don't need this)
	LD	HL,LAB_E5BA		; point to LAB_E5BA
	PUSH	HL			; push pointer
	CALL	LAB_3CA3		; fill count bytes, from destination, with 00h
	POP	DE			; dump destination
	POP	DE			; dump count
	RET				;

LAB_5B79
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6)
	CALL	LAB_5B58		; zero 8Ah long blocks at LAB_E530 and LAB_E5BA
	LD	HL,0000h	;5B82:	210000
	PUSH	HL			; push byte for LAB_E536
	LD	HL,0000h	;5B86:	210000
	PUSH	HL			; push word for LAB_E538
	LD	HL,0006h	;5B8A:	210600
	PUSH	HL			; push word for LAB_E5BA
	LD	HL,0006h	;5B8E:	210600
	PUSH	HL			; push word for LAB_E530
	LD	HL,0000h	;5B92:	210000
	PUSH	HL			; push byte for LAB_E534
	CALL	LAB_5973		; setup ?? from stack
	EX	DE,HL		;5B99:	EB
	LD	HL,000Ah		; 10 ..
	ADD	HL,SP			; .. + stack ..
	LD	SP,HL			; .. = dump the lot
	CALL	LAB_59B3	;5B9F:	CDB359
	CALL	LAB_59FB	;5BA2:	CDFB59
	RET				;

LAB_5BA6
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6)
	CALL	LAB_5B58		; zero 8Ah long blocks at LAB_E530 and LAB_E5BA
	LD	HL,0000h	;5BAF:	210000
	PUSH	HL			; push byte for LAB_E536
	LD	HL,0000h	;5BB3:	210000
	PUSH	HL			; push word for LAB_E538
	LD	HL,0006h	;5BB7:	210600
	PUSH	HL			; push word for LAB_E5BA
	LD	HL,0006h	;5BBB:	210600
	PUSH	HL			; push word for LAB_E530
	LD	HL,0065h	;5BBF:	216500
	PUSH	HL			; push byte for LAB_E534
	CALL	LAB_5973		; setup ?? from stack
	EX	DE,HL		;5BC6:	EB
	LD	HL,000Ah		; 10 ..
	ADD	HL,SP			; .. + stack ..
	LD	SP,HL			; .. = dump the lot
	CALL	LAB_59B3	;5BCC:	CDB359
	CALL	LAB_59FB	;5BCF:	CDFB59
	RET				;

; do session aborted message with wait or cont

LAB_5BD3
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6)
	LD	HL,LAB_6F37		; points to '  Session aborted'
	PUSH	HL			; push message pointer
	LD	HL,0004h		; line 4
	PUSH	HL			; push line #
	CALL	LAB_41D9		; print message @ line
	POP	DE			; dump line #
	POP	DE			; dump message pointer
	CALL	LAB_42EE		; wait (LAB_E6FD) seconds or do press to cont
	RET				;

LAB_5BEA
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6)
	CALL	LAB_5BA6	;5BF0:	CDA65B
	CALL	LAB_5BD3		; do session aborted message with wait or cont
	RET				;

LAB_5BF7
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6)
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;5C01:	5E
	LD	D,#00h		; clear high byte
	LD	HL,0001h	;5C04:	210100
	CALL	LAB_E04B		; compare HL with DE, return HL=0 & Zb=1 if different
	JP	Z,LAB_5C13	;5C0A:	CA135C
	LD	HL,0003h	;5C0D:	210300
	JP	LAB_5C16	;5C10:	C3165C

LAB_5C13
	LD	HL,0004h	;5C13:	210400
LAB_5C16
	LD	(LAB_E52E),HL	;5C16:	222EE5
	LD	HL,0008h	;5C19:	210800
	LD	(LAB_E658),HL	;5C1C:	2258E6
	CALL	LAB_5B79	;5C1F:	CD795B
	LD	(LAB_E64E),HL	;5C22:	224EE6
	LD	A,H			; set the flags
	OR	L			;
	JP	NZ,LAB_5CD3	;5C27:	C2D35C

	CALL	LAB_5B58		; zero 8Ah long blocks at LAB_E530 and LAB_E5BA
	LD	HL,0000h	;5C2D:	210000
	LD	A,L		;5C30:	7D
	LD	(LAB_E650),A	;5C31:	3250E6
	LD	HL,004Ch	;5C34:	214C00
	LD	A,L		;5C37:	7D
	LD	(LAB_E651),A	;5C38:	3251E6
	LD	HL,0000h	;5C3B:	210000
	LD	A,L		;5C3E:	7D
	LD	(LAB_E652),A	;5C3F:	3252E6
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 1 before call
	LD	E,(HL)		;5C46:	5E
	LD	D,#00h		; clear high byte
	LD	HL,0006h	;5C49:	210600
	CALL	LAB_E04B		; compare HL with DE, return HL=0 & Zb=1 if different
	JP	Z,LAB_5C58	;5C4F:	CA585C
	LD	HL,0000h	;5C52:	210000
	JP	LAB_5C5B	;5C55:	C35B5C
LAB_5C58
	LD	HL,0001h	;5C58:	210100
LAB_5C5B
	LD	A,L		;5C5B:	7D
	LD	(LAB_E653),A	;5C5C:	3253E6
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 2 before call
	LD	E,(HL)		;5C63:	5E
	EX	DE,HL		;5C64:	EB
	LD	A,L		;5C65:	7D
	LD	(LAB_E654),A	;5C66:	3254E6
	LD	HL,0012h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 3 before call
	LD	E,(HL)		;5C6D:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;5C6F:	56
	EX	DE,HL		;5C70:	EB
	LD	A,L		;5C71:	7D
	LD	(LAB_E655),A	;5C72:	3255E6
	LD	HL,(LAB_E6E6)	;5C75:	2AE6E6
	LD	A,H			; set the flags
	OR	L			;
	JP	Z,LAB_5C83	;5C7A:	CA835C

	LD	HL,0001h	;5C7D:	210100
	JP	LAB_5C86	;5C80:	C3865C
LAB_5C83
	LD	HL,0000h	;5C83:	210000
LAB_5C86
	LD	A,L		;5C86:	7D
	LD	(LAB_E656),A	;5C87:	3256E6
	LD	HL,(LAB_E658)	; get byte count
	PUSH	HL			; push byte count
	LD	HL,LAB_E53A		; set destination
	PUSH	HL			; push destination
	LD	HL,LAB_E650		; set source
	PUSH	HL			; push source
	CALL	LAB_D9A0		; copy count bytes from source to destination
	POP	DE			; dump source
	POP	DE			; dump destination
	POP	DE			; dump byte count
	LD	HL,0005h	;5C9C:	210500
	PUSH	HL		;5C9F:	E5
	LD	HL,(LAB_E658)	;5CA0:	2A58E6
	LD	DE,E53Ah	;5CA3:	113AE5
	ADD	HL,DE		;5CA6:	19
	POP	DE		;5CA7:	D1
	LD	(HL),E		;5CA8:	73

	LD	HL,0000h	;5CA9:	210000
	PUSH	HL			; push byte for LAB_E536
	LD	HL,0080h	;5CAD:	218000
	PUSH	HL			; push word for LAB_E538
	LD	HL,0006h	;5CB1:	210600
	PUSH	HL			; push word for LAB_E5BA
	LD	HL,(LAB_E658)	;5CB5:	2A58E6
	LD	DE,0007h	;5CB8:	110700
	ADD	HL,DE		;5CBB:	19
	PUSH	HL			; push word for LAB_E530
	LD	HL,0006h	;5CBD:	210600
	PUSH	HL			; push byte for LAB_E534
	CALL	LAB_5973		; setup ?? from stack
	EX	DE,HL		;5CC4:	EB
	LD	HL,000Ah		; 10 ..
	ADD	HL,SP			; .. + stack ..
	LD	SP,HL			; .. = dump the lot
	CALL	LAB_59B3	;5CCA:	CDB359
	CALL	LAB_59FB	;5CCD:	CDFB59
	LD	(LAB_E64E),HL	;5CD0:	224EE6
LAB_5CD3
	LD	HL,(LAB_E64E)	;5CD3:	2A4EE6
	RET				;

; stack is ..
; ??
; ??
; ??
; ??
; ??
; end.

LAB_5CD7
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6)
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;5CE1:	5E
	LD	D,#00h		; clear high byte
	LD	HL,0001h	;5CE4:	210100
	CALL	LAB_E04B		; compare HL with DE, return HL=0 & Zb=1 if different
	JP	Z,LAB_5CF3	;5CEA:	CAF35C
	LD	HL,0003h	;5CED:	210300
	JP	LAB_5CF6	;5CF0:	C3F65C
LAB_5CF3
	LD	HL,0004h	;5CF3:	210400
LAB_5CF6
	LD	(LAB_E52E),HL	;5CF6:	222EE5
	LD	HL,0008h	;5CF9:	210800
	LD	(LAB_E669),HL	;5CFC:	2269E6
	LD	HL,0005h	;5CFF:	210500
	LD	(LAB_E66B),HL	;5D02:	226BE6
	CALL	LAB_5B79	;5D05:	CD795B
	LD	(LAB_E65A),HL	;5D08:	225AE6
	LD	A,H			; set the flags
	OR	L			;
	JP	NZ,LAB_5DF9	;5D0D:	C2F95D

	CALL	LAB_5B58		; zero 8Ah long blocks at LAB_E530 and LAB_E5BA
	LD	HL,0001h	;5D13:	210100
	LD	A,L		;5D16:	7D
	LD	(LAB_E65C),A	;5D17:	325CE6
	LD	HL,0014h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 4 before call
	LD	E,(HL)		;5D1E:	5E
	EX	DE,HL		;5D1F:	EB
	LD	A,L		;5D20:	7D
	LD	(LAB_E65D),A	;5D21:	325DE6
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 2 before call
	LD	E,(HL)		;5D28:	5E
	LD	D,#00h		; clear high byte
	LD	HL,0001h	;5D2B:	210100
	CALL	LAB_E023		; does AND HL,DE. sets Z flag
	JP	Z,LAB_5D3A	;5D31:	CA3A5D
	LD	HL,0002h	;5D34:	210200
	JP	LAB_5D3D	;5D37:	C33D5D
LAB_5D3A
	LD	HL,0001h	;5D3A:	210100
LAB_5D3D
	LD	A,L		;5D3D:	7D
	LD	(LAB_E65E),A	;5D3E:	325EE6
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 1 before call
	LD	E,(HL)		;5D45:	5E
	LD	D,#00h		; clear high byte
	LD	HL,0006h	;5D48:	210600
	CALL	LAB_E04B		; compare HL with DE, return HL=0 & Zb=1 if different
	JP	Z,LAB_5D57	;5D4E:	CA575D
	LD	HL,0000h	;5D51:	210000
	JP	LAB_5D5A	;5D54:	C35A5D
LAB_5D57
	LD	HL,0001h	;5D57:	210100
LAB_5D5A
	LD	A,L		;5D5A:	7D
	LD	(LAB_E65F),A	;5D5B:	325FE6
	LD	HL,0012h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 3 before call
	LD	E,(HL)		;5D62:	5E
	EX	DE,HL		;5D63:	EB
	LD	A,L		;5D64:	7D
	LD	(LAB_E660),A	;5D65:	3260E6
	LD	HL,003Ch	;5D68:	213C00
	LD	A,L		;5D6B:	7D
	LD	(LAB_E661),A	;5D6C:	3261E6
	LD	HL,(LAB_E6E6)	;5D6F:	2AE6E6
	LD	A,H			; set the flags
	OR	L			;
	JP	Z,LAB_5D7D	;5D74:	CA7D5D

	LD	HL,0001h	;5D77:	210100
	JP	LAB_5D80	;5D7A:	C3805D
LAB_5D7D
	LD	HL,0000h	;5D7D:	210000
LAB_5D80
	LD	A,L		;5D80:	7D
	LD	(LAB_E662),A	;5D81:	3262E6
	LD	HL,0000h	;5D84:	210000
	LD	(LAB_E664),HL	;5D87:	2264E6
	LD	HL,0000h	;5D8A:	210000
	LD	A,L		;5D8D:	7D
	LD	(LAB_E666),A	;5D8E:	3266E6
	LD	HL,0000h	;5D91:	210000
	LD	A,L		;5D94:	7D
	LD	(LAB_E667),A	;5D95:	3267E6
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 2 before call
	LD	E,(HL)		;5D9C:	5E
	EX	DE,HL		;5D9D:	EB
	LD	A,L		;5D9E:	7D
	LD	(LAB_E668),A	;5D9F:	3268E6
	LD	HL,(LAB_E669)	; get byte count
	PUSH	HL			; push byte count
	LD	HL,LAB_E53A		; set destination
	PUSH	HL			; push destination
	LD	HL,LAB_E65C		; set source
	PUSH	HL			; push source
	CALL	LAB_D9A0		; copy count bytes from source to destination
	POP	DE			; dump source
	POP	DE			; dump destination
	POP	DE			; dump byte count
	LD	HL,(LAB_E66B)	; get byte count
	PUSH	HL			; push byte count
	LD	HL,(LAB_E669)	; get previous byte count
	LD	DE,LAB_E53A		; set destination
	ADD	HL,DE			; add previous byte count
	PUSH	HL			; push destination
	LD	HL,LAB_E664		; set source
	PUSH	HL			; push source
	CALL	LAB_D9A0		; copy count bytes from source to destination
	POP	DE			; dump source
	POP	DE			; dump destination
	POP	DE			; dump byte count

	LD	HL,0000h	;5DCA:	210000
	PUSH	HL			; push byte for LAB_E536
	LD	HL,0080h	;5DCE:	218000
	PUSH	HL			; push word for LAB_E538
	LD	HL,0006h	;5DD2:	210600
	PUSH	HL			; push word for LAB_E5BA
	LD	HL,(LAB_E669)	;5DD6:	2A69E6
	EX	DE,HL		;5DD9:	EB
	LD	HL,(LAB_E66B)	;5DDA:	2A6BE6
	ADD	HL,DE		;5DDD:	19
	LD	DE,0006h	;5DDE:	110600
	ADD	HL,DE		;5DE1:	19
	PUSH	HL			; push word for LAB_E530
	LD	HL,0006h	;5DE3:	210600
	PUSH	HL			; push byte for LAB_E534
	CALL	LAB_5973		; setup ?? from stack
	EX	DE,HL		;5DEA:	EB
	LD	HL,000Ah		; 10 ..
	ADD	HL,SP			; .. + stack ..
	LD	SP,HL			; .. = dump the lot
	CALL	LAB_59B3	;5DF0:	CDB359
	CALL	LAB_59FB	;5DF3:	CDFB59
	LD	(LAB_E65A),HL	;5DF6:	225AE6
LAB_5DF9
	LD	HL,(LAB_E65A)	;5DF9:	2A5AE6
	RET				;

LAB_5DFD
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6)
	CALL	LAB_5B58		; zero 8Ah long blocks at LAB_E530 and LAB_E5BA
	LD	HL,0000h	;5E06:	210000
	PUSH	HL			; push byte for LAB_E536
	LD	HL,0000h	;5E0A:	210000
	PUSH	HL			; push word for LAB_E538
	LD	HL,0006h	;5E0E:	210600
	PUSH	HL			; push word for LAB_E5BA
	LD	HL,0006h	;5E12:	210600
	PUSH	HL			; push word for LAB_E530
	LD	HL,0062h	;5E16:	216200
	PUSH	HL			; push byte for LAB_E534
	CALL	LAB_5973		; setup ?? from stack
	EX	DE,HL		;5E1D:	EB
	LD	HL,000Ah		; 10 ..
	ADD	HL,SP			; .. + stack ..
	LD	SP,HL			; .. = dump the lot
	CALL	LAB_59B3	;5E23:	CDB359
	CALL	LAB_59FB	;5E26:	CDFB59
	RET				;

LAB_5E2A
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6)
	LD	HL,E53Ah	;5E30:	213AE5
	LD	(LAB_E66D),HL	;5E33:	226DE6
	LD	HL,(LAB_E66D)	;5E36:	2A6DE6
	LD	(LAB_E66F),HL	;5E39:	226FE6
	CALL	LAB_5B58		; zero 8Ah long blocks at LAB_E530 and LAB_E5BA
LAB_5E3F
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;5E43:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;5E45:	56
	EX	DE,HL		;5E46:	EB
	LD	A,(HL)		;5E47:	7E
	OR	A		;5E48:	B7
	JP	Z,LAB_5EBF	;5E49:	CABF5E
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;5E50:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;5E52:	56
	EX	DE,HL		;5E53:	EB
	LD	E,(HL)		;5E54:	5E
	LD	D,#00h		; clear high byte
	LD	HL,0030h	;5E57:	213000
	CALL	LAB_E06A		; does signed CP DE,HL. returns HL=1 if HL<=DE
	JP	Z,LAB_5E8B	;5E5D:	CA8B5E
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;5E64:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;5E66:	56
	EX	DE,HL		;5E67:	EB
	LD	E,(HL)		;5E68:	5E
	LD	D,#00h		; clear high byte
	LD	HL,0039h	;5E6B:	213900
	CALL	LAB_E06B	;5E6E:	CD6BE0
	JP	Z,LAB_5E8B	;5E71:	CA8B5E
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;5E78:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;5E7A:	56
	EX	DE,HL		;5E7B:	EB
	LD	E,(HL)		;5E7C:	5E
	PUSH	DE		;5E7D:	D5
	LD	HL,(LAB_E66D)	;5E7E:	2A6DE6
	INC	HL		;5E81:	23
	LD	(LAB_E66D),HL	;5E82:	226DE6
	DEC	HL		;5E85:	2B
	POP	DE		;5E86:	D1
	LD	(HL),E		;5E87:	73
	JP	LAB_5EAD	;5E88:	C3AD5E
LAB_5E8B
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;5E8F:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;5E91:	56
	EX	DE,HL		;5E92:	EB
	LD	E,(HL)		;5E93:	5E
	LD	D,#00h		; clear high byte
	LD	HL,002Ch	;5E96:	212C00
	CALL	LAB_E04B		; compare HL with DE, return HL=0 & Zb=1 if different
	JP	Z,LAB_5EAD	;5E9C:	CAAD5E
	LD	HL,003Ah	;5E9F:	213A00
	PUSH	HL		;5EA2:	E5
	LD	HL,(LAB_E66D)	;5EA3:	2A6DE6
	INC	HL		;5EA6:	23
	LD	(LAB_E66D),HL	;5EA7:	226DE6
	DEC	HL		;5EAA:	2B
	POP	DE		;5EAB:	D1
	LD	(HL),E		;5EAC:	73
LAB_5EAD
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	PUSH	HL		;5EB1:	E5
	LD	A,(HL)		;5EB2:	7E
	INC	HL			; increment pointer
	LD	H,(HL)		;5EB4:	66
	LD	L,A		;5EB5:	6F
	INC	HL		;5EB6:	23
	EX	DE,HL		;5EB7:	EB
	POP	HL		;5EB8:	E1
	LD	(HL),E		;5EB9:	73
	INC	HL			; increment pointer
	LD	(HL),D		;5EBB:	72
	JP	LAB_5E3F	;5EBC:	C33F5E
LAB_5EBF
	LD	HL,0000h	;5EBF:	210000
	PUSH	HL		;5EC2:	E5
	LD	HL,(LAB_E66D)	;5EC3:	2A6DE6
	POP	DE		;5EC6:	D1
	LD	(HL),E		;5EC7:	73
	LD	HL,(LAB_E66F)	;5EC8:	2A6FE6
	PUSH	HL		;5ECB:	E5
	CALL	LAB_DBEE		; search for null byte from pointer
					; returns offset to null in HL
	POP	DE		;5ECF:	D1
	LD	(LAB_E673),HL	;5ED0:	2273E6

	LD	HL,0000h	;5ED3:	210000
	PUSH	HL			; push byte for LAB_E536
	LD	HL,(LAB_E673)	;5ED7:	2A73E6
	PUSH	HL			; push word for LAB_E538
	LD	HL,0006h	;5EDB:	210600
	PUSH	HL			; push word for LAB_E5BA
	LD	HL,(LAB_E673)	;5EDF:	2A73E6
	LD	DE,0006h	;5EE2:	110600
	ADD	HL,DE		;5EE5:	19
	PUSH	HL			; push word for LAB_E530
	LD	HL,0060h	;5EE7:	216000
	PUSH	HL			; push byte for LAB_E534
	CALL	LAB_5973		; setup ?? from stack
	EX	DE,HL		;5EEE:	EB
	LD	HL,000Ah		; 10 ..
	ADD	HL,SP			; .. + stack ..
	LD	SP,HL			; .. = dump the lot
	CALL	LAB_59B3	;5EF4:	CDB359
	LD	A,(LAB_E6FC)	;5EF7:	3AFCE6
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	LD	(LAB_E675),HL	;5EFD:	2275E6
	LD	HL,002Dh	;5F00:	212D00
	LD	A,L		;5F03:	7D
	LD	(LAB_E6FC),A	;5F04:	32FCE6
	LD	HL,0000h	;5F07:	210000
	LD	(LAB_E671),HL	;5F0A:	2271E6
	JP	LAB_5F17	;5F0D:	C3175F
LAB_5F10
	LD	HL,(LAB_E671)	;5F10:	2A71E6
	INC	HL		;5F13:	23
	LD	(LAB_E671),HL	;5F14:	2271E6
LAB_5F17
	LD	HL,(LAB_E671)	;5F17:	2A71E6
	LD	DE,0002h		; set compare value
	EX	DE,HL			; swap to HL
	CALL	LAB_E085		; does signed CP DE,HL. returns HL=1 if HL>DE
	JP	Z,LAB_5F36		; jump if DE>=2

	CALL	LAB_59FB	;5F24:	CDFB59
	LD	(LAB_E677),HL	;5F27:	2277E6
	LD	DE,0009h	;5F2A:	110900
	CALL	LAB_E05A		; compare HL with DE, return HL=0 & Zb=1 if the same
	JP	NZ,LAB_5F36	;5F30:	C2365F

	JP	LAB_5F10	;5F33:	C3105F

LAB_5F36
	LD	HL,(LAB_E675)	;5F36:	2A75E6
	LD	A,L		;5F39:	7D
	LD	(LAB_E6FC),A	;5F3A:	32FCE6
	LD	HL,(LAB_E677)	;5F3D:	2A77E6
	LD	DE,0004h	;5F40:	110400
	CALL	LAB_E04B		; compare HL with DE, return HL=0 & Zb=1 if different
	JP	Z,LAB_5F54	;5F46:	CA545F

	LD	HL,(LAB_E6F8)	;5F49:	2AF8E6
	LD	A,H			; set the flags
	OR	L			;
	JP	Z,LAB_5F54	;5F4E:	CA545F

	CALL	LAB_5BEA	;5F51:	CDEA5B
LAB_5F54
	LD	HL,(LAB_E677)	;5F54:	2A77E6
	RET				;

; stack is ..
; ??
;

LAB_5F58
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6)
	LD	HL,0000h		; clear HL
	LD	(LAB_E67B),HL	; clear fail count
LAB_5F64
	LD	HL,0001h		; this clever bit ..
	LD	A,H			; .. of code will ..
	OR	L			; .. always do ..
	JP	Z,LAB_6068		; .. nothing !!

	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;5F70:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;5F72:	56
	PUSH	DE		;5F73:	D5
	CALL	LAB_5E2A	;5F74:	CD2A5E
	POP	DE		;5F77:	D1
	LD	(LAB_E679),HL	;5F78:	2279E6
	LD	HL,(LAB_E679)	;5F7B:	2A79E6
	JP	LAB_604E		; search table for HL, and execute

LAB_5F81
	JP	LAB_6068	;5F81:	C36860

LAB_5F84
	LD	HL,(LAB_E67B)	; get fail count
	INC	HL			; increment fail cloun
	LD	(LAB_E67B),HL	; save fail count
	LD	DE,0004h	;5F8B:	110400
	EX	DE,HL		;5F8E:	EB
	CALL	LAB_E06A		; does signed CP DE,HL. returns HL=1 if HL<=DE
	JP	NZ,LAB_6068	;5F92:	C26860

	LD	HL,(LAB_E67B)	; get fail count
	DEC	HL			; -1 (now 0 to 2)
	ADD	HL,HL			; *2 (2 bytes per entry)
	LD	DE,LAB_E2A8		; point to 'failed n times' table
	ADD	HL,DE			; add table pointer to offset
	LD	E,(HL)		; get fail message pointer low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get fail message pointer low byte
	PUSH	DE			; push line 6 message pointer
	LD	HL,LAB_E2AE		; null message
	PUSH	HL			; push line 5 message pointer
	LD	HL,LAB_6F9F		; points to 'Retrying in 1 minute'
	PUSH	HL			; push line 4 message pointer
	LD	HL,LAB_6F8F		; points to '    Please wait'
	PUSH	HL			; push line 3 message pointer
	CALL	LAB_4296		; print 4 line message ???
	EX	DE,HL			;
	LD	HL,0008h		; 8 ..
	ADD	HL,SP			; .. + stack ..
	LD	SP,HL			; .. = dump the lot
	LD	HL,0000h	;5FB7:	210000
	LD	(LAB_E67D),HL	;5FBA:	227DE6
	JP	LAB_5FC7	;5FBD:	C3C75F

LAB_5FC0
	LD	HL,(LAB_E67D)	;5FC0:	2A7DE6
	INC	HL		;5FC3:	23
	LD	(LAB_E67D),HL	;5FC4:	227DE6
LAB_5FC7
	LD	HL,(LAB_E67D)	;5FC7:	2A7DE6
	LD	DE,0002h		; set comapre value
	EX	DE,HL			; swap to HL
	CALL	LAB_E085		; does signed CP DE,HL. returns HL=1 if HL>DE
	JP	Z,LAB_6025		; jump if DE>=2

	CALL	LAB_6431		; get RTC seconds to (LAB_E69A)
LAB_5FD7
	LD	HL,001Fh		; set timeout to 31 seconds
	PUSH	HL			; push elapsed time
	CALL	LAB_6443		; return HL=1 if elapsed seconds since clock read
	POP	DE			; dump elapsed time
	JP	NZ,LAB_6022		; loop to LAB_5FC0 if timeout complete

	CALL	LAB_666B		; get key status without waiting
	JP	Z,LAB_601F		; loop to LAB_5FD7 if no key

	CALL	LAB_65C2		; get byte from key buffer ??
	LD	DE,0014h		; set compare byte [END]
	CALL	LAB_E04B		; compare HL with DE, return HL=0 & Zb=1 if different
	JP	Z,LAB_601F		; loop to LAB_5FD7 if not [END]

	LD	HL,LAB_E2B1		; null message
	PUSH	HL			; push line 6 message pointer
	LD	HL,LAB_E2B0		; null message
	PUSH	HL			; push line 5 message pointer
	LD	HL,LAB_E2AF		; null message
	PUSH	HL			; push line 4 message pointer
	LD	HL,LAB_6F37		; points to '  Session aborted'
	PUSH	HL			; push line 3 message pointer
	CALL	LAB_4296		; print 4 line message ???
	EX	DE,HL			;
	LD	HL,0008h		; 8 ..
	ADD	HL,SP			; .. + stack ..
	LD	SP,HL			; .. = dump the lot
	CALL	LAB_42EE		; wait (LAB_E6FD) seconds or do press to cont
	LD	HL,0001h	;6010:	210100
	LD	(LAB_E6F8),HL	;6013:	22F8E6
	LD	HL,0004h	;6016:	210400
	LD	(LAB_E679),HL	;6019:	2279E6
	JP	LAB_6068	;601C:	C36860

LAB_601F
	JP	LAB_5FD7	;601F:	C3D75F

LAB_6022
	JP	LAB_5FC0	;6022:	C3C05F

LAB_6025
	LD	HL,LAB_E2B3		; null message
	PUSH	HL			; push line 6 message pointer
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;602D:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;602F:	56
	PUSH	DE			; push line 5 message pointer
	LD	HL,LAB_E2B2		; null message
	PUSH	HL			; push line 4 message pointer
	LD	HL,LAB_6FB4		; points to '    Re-dialling'
	PUSH	HL			; push line 3 message pointer
	CALL	LAB_4296		; print 4 line message ???
	EX	DE,HL		;603C:	EB
	LD	HL,0008h		; 8 ..
	ADD	HL,SP			; .. + stack ..
	LD	SP,HL			; .. = dump the lot
	JP	LAB_6065	;6042:	C36560

LAB_6045
	LD	HL,0003h	;6045:	210300
	LD	(LAB_E679),HL	;6048:	2279E6
	JP	LAB_6068	;604B:	C36860

LAB_604E
	CALL	LAB_E0B2		; search following table for HL & execute vector

	DW	0004h			; 4 entries
	DW	0000h
	DW	LAB_5F81
	DW	0004h
	DW	LAB_5F81
	DW	0009h
	DW	LAB_5F81
	DW	000Ch
	DW	LAB_5F84
	DW	LAB_6045

LAB_6065
	JP	LAB_5F64	;6065:	C3645F

LAB_6068
	LD	HL,(LAB_E679)	;6068:	2A79E6
	RET				;

LAB_606C
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6)
	CALL	LAB_5B58		; zero 8Ah long blocks at LAB_E530 and LAB_E5BA
	LD	HL,0000h	;6075:	210000
	PUSH	HL			; push byte for LAB_E536
	LD	HL,0000h	;6079:	210000
	PUSH	HL			; push word for LAB_E538
	LD	HL,0006h	;607D:	210600
	PUSH	HL			; push word for LAB_E5BA
	LD	HL,0006h	;6081:	210600
	PUSH	HL			; push word for LAB_E530
	LD	HL,0061h	;6085:	216100
	PUSH	HL			; push byte for LAB_E534
	CALL	LAB_5973		; setup ?? from stack
	EX	DE,HL		;608C:	EB
	LD	HL,000Ah		; 10 ..
	ADD	HL,SP			; .. + stack ..
	LD	SP,HL			; .. = dump the lot
	CALL	LAB_59B3	;6092:	CDB359
LAB_6095
	CALL	LAB_59FB	;6095:	CDFB59
	LD	(LAB_E67F),HL	;6098:	227FE6
	LD	DE,0009h	;609B:	110900
	CALL	LAB_E04B		; compare HL with DE, return HL=0 & Zb=1 if different
	JP	Z,LAB_60A7	;60A1:	CAA760

	JP	LAB_6095	;60A4:	C39560

LAB_60A7
	LD	HL,(LAB_E67F)	;60A7:	2A7FE6
	LD	DE,0004h	;60AA:	110400
	CALL	LAB_E04B		; compare HL with DE, return HL=0 & Zb=1 if different
	JP	Z,LAB_60BE	;60B0:	CABE60

	LD	HL,(LAB_E6F8)	;60B3:	2AF8E6
	LD	A,H			; set the flags
	OR	L			;
	JP	Z,LAB_60BE	;60B8:	CABE60

	CALL	LAB_5BEA	;60BB:	CDEA5B
LAB_60BE
	LD	HL,(LAB_E67F)	;60BE:	2A7FE6
	RET				;

LAB_60C2
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6)
	CALL	LAB_5DFD	;60C8:	CDFD5D
	RET				;

LAB_60CC
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6)
	CALL	LAB_5B79	;60D2:	CD795B
	RET				;

LAB_60D6
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6)
	CALL	LAB_5B58		; zero 8Ah long blocks at LAB_E530 and LAB_E5BA
	LD	HL,0000h	;60DF:	210000
	PUSH	HL			; push byte for LAB_E536
	LD	HL,0000h	;60E3:	210000
	PUSH	HL			; push word for LAB_E538
	LD	HL,0006h	;60E7:	210600
	PUSH	HL			; push word for LAB_E5BA
	LD	HL,0006h	;60EB:	210600
	PUSH	HL			; push word for LAB_E530
	LD	HL,0064h	;60EF:	216400
	PUSH	HL			; push byte for LAB_E534
	CALL	LAB_5973		; setup ?? from stack
	EX	DE,HL		;60F6:	EB
	LD	HL,000Ah		; 10 ..
	ADD	HL,SP			; .. + stack ..
	LD	SP,HL			; .. = dump the lot
	CALL	LAB_59B3	;60FC:	CDB359
	CALL	LAB_59FB	;60FF:	CDFB59
	LD	(LAB_E681),HL	;6102:	2281E6
	LD	HL,(LAB_E681)	;6105:	2A81E6
	LD	DE,0004h	;6108:	110400
	CALL	LAB_E04B		; compare HL with DE, return HL=0 & Zb=1 if different
	JP	Z,LAB_611C	;610E:	CA1C61

	LD	HL,(LAB_E6F8)	;6111:	2AF8E6
	LD	A,H			; set the flags
	OR	L			;
	JP	Z,LAB_611C	;6116:	CA1C61

	CALL	LAB_5BEA	;6119:	CDEA5B
LAB_611C
	LD	HL,(LAB_E681)	;611C:	2A81E6
	RET				;

; set HL = 0000h

LAB_6120
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6)
	LD	HL,0000h		; set HL = 0000h
	RET				;

; stack is ..
; ??
; ??
; end.

LAB_612A
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6)
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 1 before call
	LD	E,(HL)		;6134:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;6136:	56
	PUSH	DE			; push byte for LAB_E536
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;613C:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;613E:	56
	PUSH	DE			; push word for LAB_E538
	LD	HL,0006h	;6140:	210600
	PUSH	HL			; push word for LAB_E5BA
	LD	HL,0012h		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;6148:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;614A:	56
	LD	HL,0006h	;614B:	210600
	ADD	HL,DE		;614E:	19
	PUSH	HL			; push word for LAB_E530
	LD	HL,0045h	;6150:	214500
	PUSH	HL			; push byte for LAB_E534
	CALL	LAB_5973		; setup ?? from stack
	EX	DE,HL		;6157:	EB
	LD	HL,000Ah		; 10 ..
	ADD	HL,SP			; .. + stack ..
	LD	SP,HL			; .. = dump the lot
	CALL	LAB_59B3	;615D:	CDB359
	CALL	LAB_59FB	;6160:	CDFB59
	LD	(LAB_E683),HL	;6163:	2283E6
	LD	HL,(LAB_E683)	;6166:	2A83E6
	LD	DE,0004h	;6169:	110400
	CALL	LAB_E04B		; compare HL with DE, return HL=0 & Zb=1 if different
	JP	Z,LAB_617D	;616F:	CA7D61

	LD	HL,(LAB_E6F8)	;6172:	2AF8E6
	LD	A,H			; set the flags
	OR	L			;
	JP	Z,LAB_617D	;6177:	CA7D61

	CALL	LAB_5BEA	;617A:	CDEA5B
LAB_617D
	LD	HL,(LAB_E683)	;617D:	2A83E6
	RET				;

; stack is ..
; source
; byte count
; ??
; end.

LAB_6181
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6)
	LD	HL,0000h	;6187:	210000
	LD	(LAB_E685),HL	;618A:	2285E6
	CALL	LAB_5B58		; zero 8Ah long blocks at LAB_E530 and LAB_E5BA
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 1 before call
	LD	A,(HL)		; get byte count low byte
	INC	HL			; increment pointer
	OR	(HL)			; OR with byte count high byte
	JP	Z,LAB_61C8		; exit if count=0

	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 1 before call
	LD	E,(HL)		; get byte count low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get byte count high byte
	PUSH	DE			; push byte count
	LD	HL,LAB_E53A		; get destination
	PUSH	HL			; push destination
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		; get source low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get source high byte
	PUSH	DE			; push source
	CALL	LAB_D9A0		; copy count bytes from source to destination
	POP	DE			; dump source
	POP	DE			; dump destination
	POP	DE			; dump byte count
	LD	HL,0000h	;61B4:	210000
	PUSH	HL		;61B7:	E5
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 2 before call
	LD	E,(HL)		;61BC:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;61BE:	56
	PUSH	DE		;61BF:	D5
	CALL	LAB_612A	;61C0:	CD2A61
	POP	DE		;61C3:	D1
	POP	DE		;61C4:	D1
	LD	(LAB_E685),HL	;61C5:	2285E6
LAB_61C8
	LD	HL,(LAB_E685)	;61C8:	2A85E6
	RET				;

; stack is ..
; source
; byte count
; end.

LAB_61CC
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6)
	CALL	LAB_5B58		; zero 8Ah long blocks at LAB_E530 and LAB_E5BA
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 1 before call
	LD	A,(HL)		; get byte count low byte
	INC	HL			; increment pointer
	OR	(HL)			; OR with byte count high byte
	JP	Z,LAB_61F9		; jump if count=0

	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 1 before call
	LD	E,(HL)		; get byte count low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get byte count high byte
	PUSH	DE			; dump byte count
	LD	HL,LAB_E53A		; set destination
	PUSH	HL			; push destination
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		; get source low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get source high byte
	PUSH	DE			; push source
	CALL	LAB_D9A0		; copy count bytes from source to destination
	POP	DE			; dump source
	POP	DE			; dump destination
	POP	DE			; dump byte count
LAB_61F9
	LD	HL,0001h	;61F9:	210100
	PUSH	HL		;61FC:	E5
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 1 before call
	LD	E,(HL)		;6201:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;6203:	56
	PUSH	DE		;6204:	D5
	CALL	LAB_612A	;6205:	CD2A61
	POP	DE		;6208:	D1
	POP	DE		;6209:	D1
	RET				;

; stack is ..
; ??
; ??
; ??
; end.

LAB_620B
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6)
	LD	HL,0000h	;6211:	210000
	PUSH	HL		;6214:	E5
	LD	HL,0012h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 2 before call
	LD	E,(HL)		;6219:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;621B:	56
	EX	DE,HL		;621C:	EB
	POP	DE		;621D:	D1
	LD	(HL),E		;621E:	73
	INC	HL			; increment pointer
	LD	(HL),D		;6220:	72
	CALL	LAB_5B58		; zero 8Ah long blocks at LAB_E530 and LAB_E5BA

	LD	HL,0000h	;6224:	210000
	PUSH	HL			; push byte for LAB_E536
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 1 before call
	LD	E,(HL)		;622C:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;622E:	56
	PUSH	DE			; push word for LAB_E538
	LD	HL,0086h	;6230:	218600
	PUSH	HL			; push word for LAB_E5BA
	LD	HL,0006h	;6234:	210600
	PUSH	HL			; push word for LAB_E530
	LD	HL,0044h	;6238:	214400
	PUSH	HL			; push byte for LAB_E534
	CALL	LAB_5973		; setup ?? from stack
	EX	DE,HL		;623F:	EB
	LD	HL,000Ah		; 10 ..
	ADD	HL,SP			; .. + stack ..
	LD	SP,HL			; .. = dump the lot
	CALL	LAB_59B3	;6245:	CDB359
	CALL	LAB_59FB	;6248:	CDFB59
	LD	(LAB_E687),HL	;624B:	2287E6
	LD	HL,(LAB_E687)	;624E:	2A87E6
	LD	A,H			; set the flags
	OR	L			;
	JP	Z,LAB_6262	;6253:	CA6262

	LD	HL,(LAB_E687)	;6256:	2A87E6
	LD	DE,0008h	;6259:	110800
	CALL	LAB_E04B		; compare HL with DE, return HL=0 & Zb=1 if different
	JP	Z,LAB_62AC	;625F:	CAAC62

LAB_6262
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;6266:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;6268:	56
	PUSH	DE		;6269:	D5
	LD	HL,(LAB_E5C2)	;626A:	2AC2E5
	PUSH	HL		;626D:	E5
	CALL	LAB_5944		; returns smaller of #1 & #2
	POP	DE			; dump #1
	POP	DE			; dump #2
	PUSH	HL			; push result
	LD	HL,0012h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;6278:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;627A:	56
	EX	DE,HL		;627B:	EB
	POP	DE		;627C:	D1
	LD	(HL),E		;627D:	73
	INC	HL			; increment pointer
	LD	(HL),D		;627F:	72
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;6284:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;6286:	56
	EX	DE,HL		;6287:	EB
	LD	A,(HL)		;6288:	7E
	INC	HL			; increment pointer
	OR	(HL)		;628A:	B6
	JP	Z,LAB_62AC	;628B:	CAAC62
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;6292:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;6294:	56
	EX	DE,HL		;6295:	EB
	LD	E,(HL)		; get byte count low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get byte count high byte
	PUSH	DE			; push byte count
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		; get destination low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get destination high byte
	PUSH	DE			; push destination
	LD	HL,LAB_E5C4		; dump source
	PUSH	HL			; push source
	CALL	LAB_D9A0		; copy count bytes from source to destination
	POP	DE			; dump source
	POP	DE			; dump destination
	POP	DE			; dump byte count
LAB_62AC
	LD	HL,(LAB_E687)	;62AC:	2A87E6
	LD	DE,0004h	;62AF:	110400
	CALL	LAB_E04B		; compare HL with DE, return HL=0 & Zb=1 if different
	JP	Z,LAB_62C3	;62B5:	CAC362

	LD	HL,(LAB_E6F8)	;62B8:	2AF8E6
	LD	A,H			; set the flags
	OR	L			;
	JP	Z,LAB_62C3	;62BD:	CAC362

	CALL	LAB_5BEA	;62C0:	CDEA5B
LAB_62C3
	LD	HL,(LAB_E687)	;62C3:	2A87E6
	RET				;

; stack is ..
; ??
; ??
; ??
; end.

LAB_62C7
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6)
	LD	HL,0000h	;62CD:	210000
	PUSH	HL		;62D0:	E5
	LD	HL,0012h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 2 before call
	LD	E,(HL)		;62D5:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;62D7:	56
	EX	DE,HL		;62D8:	EB
	POP	DE		;62D9:	D1
	LD	(HL),E		;62DA:	73
	INC	HL			; increment pointer
	LD	(HL),D		;62DC:	72
	CALL	LAB_5B58		; zero 8Ah long blocks at LAB_E530 and LAB_E5BA

	LD	HL,0000h	;62E0:	210000
	PUSH	HL			; push byte for LAB_E536
	LD	HL,0000h	;62E4:	210000
	PUSH	HL			; push word for LAB_E538
	LD	HL,000Ah	;62E8:	210A00
	PUSH	HL			; push word for LAB_E5BA
	LD	HL,0006h	;62EC:	210600
	PUSH	HL			; push word for LAB_E530
	LD	HL,0043h	;62F0:	214300
	PUSH	HL			; push byte for LAB_E534
	CALL	LAB_5973		; setup ?? from stack
	EX	DE,HL		;62F7:	EB
	LD	HL,000Ah		; 10 ..
	ADD	HL,SP			; .. + stack ..
	LD	SP,HL			; .. = dump the lot
	CALL	LAB_59B3	;62FD:	CDB359
	CALL	LAB_59FB	;6300:	CDFB59
	LD	(LAB_E689),HL	;6303:	2289E6
	LD	HL,(LAB_E689)	;6306:	2A89E6
	LD	A,H			; set the flags
	OR	L			;
	JP	Z,LAB_631A	;630B:	CA1A63

	LD	HL,(LAB_E689)	;630E:	2A89E6
	LD	DE,0008h	;6311:	110800
	CALL	LAB_E04B		; compare HL with DE, return HL=0 & Zb=1 if different
	JP	Z,LAB_63AF	;6317:	CAAF63
LAB_631A
	LD	HL,(LAB_E5C4)	;631A:	2AC4E5
	LD	(LAB_E68D),HL	;631D:	228DE6
	LD	HL,0080h		; set #2
	PUSH	HL			; push #2
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;6328:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;632A:	56
	PUSH	DE		;632B:	D5
	CALL	LAB_5944		; returns smaller of #1 & #2
	POP	DE			; dump #1
	POP	DE			; dump #2
	PUSH	HL			; push result
	LD	HL,(LAB_E68D)	;6332:	2A8DE6
	PUSH	HL		;6335:	E5
	CALL	LAB_5944		; returns smaller of #1 & #2
	POP	DE			; dump #1
	POP	DE			; dump #2
	LD	(LAB_E68D),HL	; save result
	LD	HL,(LAB_E68D)	;633E:	2A8DE6
	LD	A,H			; set the flags
	OR	L			;
	JP	NZ,LAB_634A	;6343:	C24A63

	LD	HL,(LAB_E689)	;6346:	2A89E6
	RET				;

LAB_634A
	CALL	LAB_5B58		; zero 8Ah long blocks at LAB_E530 and LAB_E5BA

	LD	HL,0000h	;634D:	210000
	PUSH	HL			; push byte for LAB_E536
	LD	HL,(LAB_E68D)	;6351:	2A8DE6
	PUSH	HL			; push word for LAB_E538
	LD	HL,0086h	;6355:	218600
	PUSH	HL			; push word for LAB_E5BA
	LD	HL,0006h	;6359:	210600
	PUSH	HL			; push word for LAB_E530
	LD	HL,0044h	;635D:	214400
	PUSH	HL			; push byte for LAB_E534
	CALL	LAB_5973		; setup ?? from stack
	EX	DE,HL		;6364:	EB
	LD	HL,000Ah		; 10 ..
	ADD	HL,SP			; .. + stack ..
	LD	SP,HL			; .. = dump the lot
	CALL	LAB_59B3	;636A:	CDB359
	CALL	LAB_59FB	;636D:	CDFB59
	LD	(LAB_E689),HL	;6370:	2289E6
	LD	HL,(LAB_E5C2)	;6373:	2AC2E5
	PUSH	HL		;6376:	E5
	LD	HL,0012h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;637B:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;637D:	56
	EX	DE,HL		;637E:	EB
	POP	DE		;637F:	D1
	LD	(HL),E		;6380:	73
	INC	HL			; increment pointer
	LD	(HL),D		;6382:	72
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;6387:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;6389:	56
	EX	DE,HL		;638A:	EB
	LD	A,(HL)		;638B:	7E
	INC	HL			; increment pointer
	OR	(HL)		;638D:	B6
	JP	Z,LAB_63AF	;638E:	CAAF63
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		;6395:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;6397:	56
	EX	DE,HL		;6398:	EB
	LD	E,(HL)		; get byte count low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get byte count high byte
	PUSH	DE			; dump byte count
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but X before call
	LD	E,(HL)		; get destination low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get destination high byte
	PUSH	DE			; dump destination
	LD	HL,LAB_E5C4		; dump source
	PUSH	HL			; dump source
	CALL	LAB_D9A0		; copy count bytes from source to destination
	POP	DE			; dump source
	POP	DE			; dump destination
	POP	DE			; dump byte count
LAB_63AF
	LD	HL,(LAB_E689)	;63AF:	2A89E6
	LD	DE,0004h	;63B2:	110400
	CALL	LAB_E04B		; compare HL with DE, return HL=0 & Zb=1 if different
	JP	Z,LAB_63C6	;63B8:	CAC663

	LD	HL,(LAB_E6F8)	;63BB:	2AF8E6
	LD	A,H			; set the flags
	OR	L			;
	JP	Z,LAB_63C6	;63C0:	CAC663

	CALL	LAB_5BEA	;63C3:	CDEA5B
LAB_63C6
	LD	HL,(LAB_E689)	;63C6:	2A89E6
	RET				;

; zero 8Ah long blocks at LAB_E530 and LAB_E5BA then
; copy count bytes to LAB_E53A from source and then
; ...

; stack is ..
; source
; count
; end.

LAB_63CA
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6)
	LD	HL,0000h	;63D0:	210000
	LD	(LAB_E68F),HL	;63D3:	228FE6
	CALL	LAB_5B58		; zero 8Ah long blocks at LAB_E530 and LAB_E5BA
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 1 before call
	LD	A,(HL)		; get byte count low byte
	INC	HL			; increment pointer
	OR	(HL)			; OR with byte count high byte
	JP	Z,LAB_6411		; exit if count=0

	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 1 before call
	LD	E,(HL)		; get byte count low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get byte count high byte
	PUSH	DE			; push byte count
	LD	HL,LAB_E53A		; set destination
	PUSH	HL			; push destination
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		; get source low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get source high byte
	PUSH	DE			; push source
	CALL	LAB_D9A0		; copy count bytes from source to destination
	POP	DE			; dump source
	POP	DE			; dump destination
	POP	DE			; dump byte count
	LD	HL,0000h	;63FD:	210000
	PUSH	HL		;6400:	E5
	LD	HL,0010h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 1 before call
	LD	E,(HL)		;6405:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;6407:	56
	PUSH	DE		;6408:	D5
	CALL	LAB_612A	;6409:	CD2A61
	POP	DE		;640C:	D1
	POP	DE		;640D:	D1
	LD	(LAB_E68F),HL	;640E:	228FE6
LAB_6411
	LD	HL,(LAB_E68F)	;6411:	2A8FE6
	RET				;

; get RTC date time

LAB_6415
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6)
	LD	HL,LAB_E691		; date/time pointer
	PUSH	HL			; push parameter
	LD	HL,00FDh		; read RTC
	PUSH	HL			; push function #
	CALL	LAB_DA13		; do BDOS function call
	POP	DE			; dump function #
	POP	DE			; dump parameter
	LD	A,(LAB_E697)	; get seconds
	LD	L,A			; copy to L
	LD	A,L			; duh?!
	LD	(LAB_E699),A	; save seconds
	RET				;

; get RTC seconds to (LAB_E69A)

LAB_6431
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6)
	CALL	LAB_6415		; get RTC date time
	LD	A,(LAB_E699)	; get saved seconds
	LD	L,A			; huh?
	LD	A,L			; ?!
	LD	(LAB_E69A),A	; save seconds (again)
	RET				;

; return HL=1 if elapsed seconds since clock read

; stack is ..
; elapsed
; end.

LAB_6443
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6)
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	A,(HL)		; get elapsed byte
	OR	A			; set the flags
	JP	NZ,LAB_6456		; jump if elapsed <> 0

	LD	HL,0000h		; else clear HL and exit
	RET				;

					; elapsed > 0
LAB_6456
	CALL	LAB_6415		; get RTC date time
	LD	A,(LAB_E69A)	; get saved seconds
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	PUSH	HL			; push saved seconds
	LD	A,(LAB_E699)	; get RTC seconds
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	POP	DE			; restore saved seconds
	EX	DE,HL			; swap RTC & saved seconds
	CALL	LAB_E085		; does signed CP DE,HL. returns HL=1 if HL>DE
	JP	Z,LAB_647D		; jump if saved <= RTC seconds

					; minute toggle happened so add 60 to RTC seconds
	LD	HL,003Ch		; 60d
	EX	DE,HL			; swap RTC seconds & 60d
	LD	A,(LAB_E699)	; get RTC seconds
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	ADD	HL,DE			; +60d
	LD	A,L			; copy to A
	LD	(LAB_E699),A	; save 'new' RTC seconds
LAB_647D
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		; get elapsed
	LD	D,#00h		; clear high byte
	PUSH	DE			; push elapsed
	LD	A,(LAB_E69A)	; get saved seconds
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	POP	DE			; restore elapsed
	ADD	HL,DE			; add to saved
	PUSH	HL			; save end time (seconds)
	LD	A,(LAB_E699)	; get RTC seconds
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	POP	DE			; restore end time
	EX	DE,HL			; swap RTC seconds & end time
	CALL	LAB_E06A		; does signed CP DE,HL. returns HL=1 if HL<=DE
	JP	Z,LAB_64A2		; jump if (end time)>(RTC time)

	LD	HL,0001h		; flag done
	JP	LAB_64A5		;

LAB_64A2
	LD	HL,0000h		; flag not done
LAB_64A5
	RET				;

; wait for elapsed seconds

; stack is ..
; elapsed
; end.

LAB_64A6
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6)
	CALL	LAB_6431		; get RTC seconds to (LAB_E69A)
LAB_64AF
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		; get elapsed low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get elapsed high byte
	PUSH	DE			; push elapsed time
	CALL	LAB_6443		; return HL=1 if elapsed seconds since clock read
	POP	DE			; dump elapsed time
	JP	NZ,LAB_64C1		; jump if timeout

	JP	LAB_64AF		; loop until timeout

LAB_64C1
	RET				;

; set HL=0001h, OR A with 01h

LAB_64C2
	LD	HL,0001h	;64C2:	210100
	OR	L		;64C5:	B5
	RET				;

; setup table @ pointer, in EExx

; stack is ..
; pointer
; end.

LAB_64C7
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6)
	LD	HL,LAB_E2B4		; point to EExxh table
	LD	(LAB_E69B),HL	; save EExxh table pointer
	JP	LAB_64F3		; go do setup

					; increment pointers to next
LAB_64D6
	LD	HL,(LAB_E69B)	; get table pointer back
	INC	HL			; +1
	INC	HL			; +2
	LD	(LAB_E69B),HL	; save new table pointer
	DEC	HL			; -1 don't need either ..
	DEC	HL			; -2 .. of these two lines
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	PUSH	HL			; save last pushed pointer
	LD	A,(HL)		; get last pushed low byte
	INC	HL			; increment pointer
	LD	H,(HL)		; get last pushed high byte
	LD	L,A			; copy low byte to L
	INC	HL			; +1
	INC	HL			; +2
	EX	DE,HL			; swap to DE
	POP	HL			; restore last pushed pointer
	LD	(HL),E		; save new low byte
	INC	HL			; increment pointer
	LD	(HL),D		; save new high byte
	EX	DE,HL			; swap pointer back (huh?! don't need this either)
	DEC	HL			; -1 don't need either ..
	DEC	HL			; -2 .. of these two lines
LAB_64F3
	LD	HL,(LAB_E69B)	; get EExx table pointer
	LD	A,(HL)		; get low byte from table
	INC	HL			; increment pointer
	OR	(HL)			; OR with high byte from table
	JP	Z,LAB_6525		; exit if null (end of EExx table)

	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		; get last pushed low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get last pushed high byte
	EX	DE,HL			; swap to HL
	LD	A,(HL)		; get low byte from pointer
	INC	HL			; increment pointer
	OR	(HL)			; OR with high byte from pointer
	JP	Z,LAB_6525		; exit if null (end of vector table)

	LD	HL,(LAB_E69B)	; get EExx table pointer
	LD	E,(HL)		; get low byte from table
	INC	HL			; increment pointer
	LD	D,(HL)		; get high byte from table
	PUSH	DE			; push EExxh value
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		; get last pushed low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get last pushed high byte
	EX	DE,HL			; swap pointer to HL
	LD	E,(HL)		; get pointer table low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get pointer table high byte
	PUSH	DE			; push pointer table value
	CALL	LAB_D7FE		; setup vector @ EExx
	POP	DE			; dump pointer
	POP	DE			; dump pointer
	JP	LAB_64D6		; loop

LAB_6525
	RET				;

; setup LAB_E69D & LAB_E6A9 to LAB_E6AD
; this could be shorter!

LAB_6526
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6)
	LD	HL,0000h		; clear HL
	LD	(LAB_E69D),HL	; clear console status
	LD	HL,0000h		; clear HL again
	LD	(LAB_E6A9),HL	; clear ?? buffer offset
	LD	HL,0000h	;6538:	210000
	LD	A,L		;653B:	7D
	LD	(LAB_E6AB),A	;653C:	32ABE6
	LD	HL,0006h	;653F:	210600
	LD	A,L		;6542:	7D
	LD	(LAB_E6AC),A	;6543:	32ACE6
	LD	HL,0000h	;6546:	210000
	LD	A,L		;6549:	7D
	LD	(LAB_E6AD),A	;654A:	32ADE6
	RET				;

; copy (byte) last into LAB_E6AB and last but 1 into LAB_E6AC

; stack is ..
; value
; value
; end.

LAB_654E
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6)
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;6558:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;655A:	56
	EX	DE,HL		;655B:	EB
	LD	A,L		;655C:	7D
	LD	(LAB_E6AB),A	;655D:	32ABE6
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 1 before call
	LD	E,(HL)		;6564:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;6566:	56
	EX	DE,HL		;6567:	EB
	LD	A,L		;6568:	7D
	LD	(LAB_E6AC),A	;6569:	32ACE6
	RET				;

LAB_656D
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6)
LAB_6573
	LD	HL,(LAB_E69D)	; get console status
	LD	A,H			; set the flags
	OR	L			;
	JP	NZ,LAB_6589		; jump if ready

	LD	HL,0003h		; function #3 [CONST]
	PUSH	HL			; push function #
	CALL	LAB_DA27		; do BIOS function, result in HL (LAB_7562)
	POP	DE			; dump function #
	LD	(LAB_E69D),HL	; save console status
	JP	LAB_6573		; loop

LAB_6589
	LD	A,(LAB_E6AE)	;6589:	3AAEE6
	OR	A		;658C:	B7
	JP	Z,LAB_65B2	;658D:	CAB265

	LD	HL,(LAB_E69D)	; get console status
	LD	DE,00FFh		; set comapre byte
	CALL	LAB_E04B		; compare HL with DE, return HL=0 & Zb=1 if different
	JP	Z,LAB_65B2		; jump if no character to read

	LD	HL,0000h	;659C:	210000
	PUSH	HL		;659F:	E5
	CALL	LAB_66E4	;65A0:	CDE466
	POP	DE		;65A3:	D1
	CALL	LAB_F118		; send BELL character to console
	LD	HL,0003h		; function #3 [CONST]
	PUSH	HL			; push function #
	CALL	LAB_DA27		; do BIOS function, result in HL (LAB_7562)
	POP	DE			; dump function #
	LD	(LAB_E69D),HL	; save console status
LAB_65B2
	LD	HL,(LAB_E69D)	; get console status
	LD	(LAB_E6AF),HL	;65B5:	22AFE6
	LD	HL,0000h		; clear HL
	LD	(LAB_E69D),HL	; clear console status
	LD	HL,(LAB_E6AF)	;65BE:	2AAFE6
	RET				;

; get byte from key buffer ??

LAB_65C2
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6)
	LD	HL,(LAB_E6A9)	; get ?? buffer offset
	LD	A,H			; set the flags
	OR	L			;
	JP	Z,LAB_65E0		; jump if 00

	LD	HL,(LAB_E6A9)	; get ?? buffer offset
	DEC	HL			; decrement it
	LD	(LAB_E6A9),HL	; save ?? buffer offset
	LD	DE,LAB_E69F		; set ?? buffer pointer
	ADD	HL,DE			; add to offset
	LD	E,(HL)		; get ?? byte
	LD	D,#00h		; clear high byte
	EX	DE,HL			; swap byte to HL
	RET				;

LAB_65E0
	LD	A,(LAB_E6AD)	;65E0:	3AADE6
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	LD	DE,0001h	;65E6:	110100
	CALL	LAB_E04B		; compare HL with DE, return HL=0 & Zb=1 if different
	JP	Z,LAB_660B		; jump if were different

	LD	HL,0000h	;65EF:	210000
	LD	A,L		;65F2:	7D
	LD	(LAB_E6AD),A	;65F3:	32ADE6
	LD	A,(LAB_E6AE)	;65F6:	3AAEE6
	OR	A		;65F9:	B7
	JP	Z,LAB_660B	;65FA:	CA0B66

	LD	A,(LAB_E6AC)	;65FD:	3AACE6
	OR	A		;6600:	B7
	JP	Z,LAB_660B	;6601:	CA0B66

	LD	A,(LAB_E6AC)	;6604:	3AACE6
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	RET				;

LAB_660B
	CALL	LAB_656D	;660B:	CD6D65
	LD	A,L		;660E:	7D
	LD	(LAB_E6B1),A	;660F:	32B1E6
	LD	A,(LAB_E6AD)	;6612:	3AADE6
	OR	A		;6615:	B7
	JP	Z,LAB_6629	;6616:	CA2966

	LD	A,(LAB_E6AD)	;6619:	3AADE6
	LD	L,A		;661C:	6F
	DEC	HL		;661D:	2B
	LD	A,L		;661E:	7D
	LD	(LAB_E6AD),A	;661F:	32ADE6
	LD	A,(LAB_E6B1)	;6622:	3AB1E6
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	RET				;

LAB_6629
	LD	A,(LAB_E6B1)	;6629:	3AB1E6
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	LD	DE,001Bh	;662F:	111B00
	CALL	LAB_E04B		; compare HL with DE, return HL=0 & Zb=1 if different
	JP	Z,LAB_6664	;6635:	CA6466

	CALL	LAB_656D	;6638:	CD6D65
	INC	HL		;663B:	23
	LD	A,L		;663C:	7D
	LD	(LAB_E6AD),A	;663D:	32ADE6
	LD	A,(LAB_E6AE)	;6640:	3AAEE6
	OR	A		;6643:	B7
	JP	Z,LAB_6655	;6644:	CA5566

	LD	A,(LAB_E6AB)	;6647:	3AABE6
	OR	A		;664A:	B7
	JP	Z,LAB_6655	;664B:	CA5566

	LD	A,(LAB_E6AB)	;664E:	3AABE6
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	RET				;

LAB_6655
	LD	A,(LAB_E6AD)	;6655:	3AADE6
	LD	L,A		;6658:	6F
	DEC	HL		;6659:	2B
	LD	A,L		;665A:	7D
	LD	(LAB_E6AD),A	;665B:	32ADE6
	CALL	LAB_656D	;665E:	CD6D65
	LD	H,#00h		;6661:	2600
	RET				;

LAB_6664
	LD	A,(LAB_E6B1)	;6664:	3AB1E6
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	RET				;

; get key status without waiting

LAB_666B
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6)
	LD	HL,(LAB_E6A9)	; get ?? buffer offset
	LD	A,H			; set the flags
	OR	L			;
	JP	Z,LAB_667D		; jump if offset = 00

	LD	HL,0001h		; there is a key so set HL
	RET				;

LAB_667D
	LD	HL,(LAB_E69D)	; get console status
	LD	A,H			; set the flags
	OR	L			;
	JP	NZ,LAB_669A		; jump if character to read

	LD	HL,00FFh		; do console get
	PUSH	HL			; push parameter
	LD	HL,0006h		; BDOS function 6 - direct console I/O
	PUSH	HL			; push function #
	CALL	LAB_DA13		; do BDOS function call
	POP	DE			; dump function #
	POP	DE			; dump parameter
	LD	(LAB_E69D),HL	; save character
	LD	A,H			; set the flags
	OR	L			;
	JP	Z,LAB_669E		; jump if there was no key

LAB_669A
	LD	HL,0001h		; there is a key so set HL
	RET				;

LAB_669E
	LD	HL,0000h		; there is no key so clear HL
	RET				;

; wait for key, no echo ??

LAB_66A2
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6)
LAB_66A8
	LD	HL,00FFh		; do console get
	PUSH	HL			; push parameter
	LD	HL,0006h		; BDOS function 6 - direct console I/O
	PUSH	HL			; push function #
	CALL	LAB_DA13		; do BDOS function call
	POP	DE			; dump function #
	POP	DE			; dump parameter
	JP	Z,LAB_66BB		; exit if key got

	JP	LAB_66A8		; loop if no key

LAB_66BB
	RET				;

; save byte in ?? buffer

; stack is ..
; ?? byte
; end.

LAB_66BC
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6)
	LD	HL,(LAB_E6A9)	; get ?? buffer offset
	LD	DE,000Ah		; set limit
	EX	DE,HL			; swap limit to HL
	CALL	LAB_E085		; does signed CP DE,HL. returns HL=1 if HL>DE
	JP	Z,LAB_66E3		; exit if >=limit

	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		; get ?? byte
	PUSH	DE			; save DE
	LD	HL,(LAB_E6A9)	; get ?? buffer offset
	INC	HL			; increment offset
	LD	(LAB_E6A9),HL	; save ?? buffer offset
	DEC	HL			; decrement offset
	LD	DE,LAB_E69F		; set ?? buffer pointer
	ADD	HL,DE			; add offset
	POP	DE			; restore DE
	LD	(HL),E		; save byte
LAB_66E3
	RET				;

; stack is ..
; ??

LAB_66E4
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6)
	LD	A,(LAB_E6AE)	;66EA:	3AAEE6
	OR	A		;66ED:	B7
	JP	Z,LAB_6715	;66EE:	CA1567

	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	A,(HL)		; get #0 low byte
	INC	HL			; increment pointer
	OR	(HL)			; OR #0 high byte
	JP	NZ,LAB_6715		; jump if not null

LAB_66FB
	LD	A,(LAB_E6AD)	;66FB:	3AADE6
	OR	A		;66FE:	B7
	JP	Z,LAB_6715	;66FF:	CA1567

	LD	HL,0001h		; character = 01h
	PUSH	HL			; push parameter
	LD	HL,0006h		; BDOS function 6 - direct console I/O
	PUSH	HL			; push function #
	CALL	LAB_DA13		; do BDOS function call
	POP	DE			; dump function #
	POP	DE			; dump parameter
	JP	Z,LAB_6715	;670F:	CA1567

	JP	LAB_66FB		; loop

LAB_6715
	LD	HL,00F6h		; get A from (LAB_FBC5)
	PUSH	HL			; push function #
	CALL	LAB_DA13		; do BDOS function call
	POP	DE			; dump function #
	LD	(LAB_E6B2),HL	;671D:	22B2E6
	LD	HL,(LAB_E6B2)	;6720:	2AB2E6
	LD	DE,0003h	;6723:	110300
	CALL	LAB_E023		; does AND HL,DE. sets Z flag
	LD	DE,0001h	;6729:	110100
	EX	DE,HL		;672C:	EB
	CALL	LAB_E086		; does signed CP HL,DE. returns HL=1 if DE>HL (LAB_7BC1)
	JP	Z,LAB_6734	;6730:	CA3467

	RET				;

LAB_6734
	LD	HL,LAB_FFFC	;6734:	21FCFF
	EX	DE,HL		;6737:	EB
	LD	HL,(LAB_E6B2)	;6738:	2AB2E6
	CALL	LAB_E023		; does AND HL,DE. sets Z flag
	LD	(LAB_E6B2),HL	;673E:	22B2E6
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	A,(HL)		;6745:	7E
	INC	HL			; increment pointer
	OR	(HL)		;6747:	B6
	JP	Z,LAB_6758	;6748:	CA5867

	LD	HL,0001h	;674B:	210100
	EX	DE,HL		;674E:	EB
	LD	HL,(LAB_E6B2)	;674F:	2AB2E6
	CALL	LAB_E033	;6752:	CD33E0
	LD	(LAB_E6B2),HL	;6755:	22B2E6
LAB_6758
	LD	HL,(LAB_E6B2)	;6758:	2AB2E6
	PUSH	HL			; push parameter
	LD	HL,00F7h		; save parameter something something something ......
	PUSH	HL			; push function #
	CALL	LAB_DA13		; do BDOS function call
	POP	DE			; dump function #
	POP	DE			; dump parameter
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;6769:	5E
	INC	HL			; increment pointer
	LD	D,(HL)		;676B:	56
	EX	DE,HL		;676C:	EB
	LD	A,L		;676D:	7D
	LD	(LAB_E6AE),A	;676E:	32AEE6
	RET				;

; set cursor on/off

; stack is ..
; flag
; end.

LAB_6772
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6)
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		; get flag low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get flag high byte
	PUSH	DE			; push flag
	CALL	LAB_F13C		; set cursor on/off
	POP	DE			; dump flag
	RET				;

; do BDOS function 2Dh

LAB_6785
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6)
	LD	HL,00FFh	;678B:	21FF00
	PUSH	HL			; push parameter
	LD	HL,002Dh	;678F:	212D00
	PUSH	HL			; push function #
	CALL	LAB_DA13		; do BDOS function call
	POP	DE			; dump function #
	POP	DE			; dump parameter
	RET				;

; set HL = 0001h

LAB_6799
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6)
	LD	HL,0001h		; set HL = 0001h
	RET				;

; set RTC hours & minutes

; stack is ..
; hour/minute
; end.

LAB_67A3
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6)
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	(LAB_E6BC),HL	; save pointer to last pushed
	LD	HL,LAB_E6B4		; RTC date time buffer pointer
	PUSH	HL			; push parameter
	LD	HL,00FDh		; read RTC date time to buffer
	PUSH	HL			; push function #
	CALL	LAB_DA13		; do BDOS function call
	POP	DE			; dump function #
	POP	DE			; dump parameter
	LD	HL,(LAB_E6BC)	; restore last pushed pointer
	INC	HL			; point to high byte
	LD	E,(HL)		; get high byte
	EX	DE,HL			; swap to HL
	LD	A,L			; copy to A
	LD	(LAB_E6B8),A	; save to RTC buffer hour
	LD	HL,(LAB_E6BC)	; restore last pushed pointer
	LD	E,(HL)		; get low byte
	EX	DE,HL			; swap to HL
	LD	A,L			; copy to A
	LD	(LAB_E6B9),A	; save to RTC buffer minute
	LD	HL,LAB_E6B4		; RTC date time buffer pointer
	PUSH	HL			; push parameter
	LD	HL,00FCh		; set RTC date time from buffer
	PUSH	HL			; push function #
	CALL	LAB_DA13		; do BDOS function call
	POP	DE			; dump function #
	POP	DE			; dump parameter
	RET				;

; save RTC hour/minute word at pointer

; stack is ..
; pointer
; end.

LAB_67DE
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6)
	LD	HL,LAB_E6B4		; RTC date time buffer pointer
	PUSH	HL			; push parameter
	LD	HL,00FDh		; read RTC date time to buffer
	PUSH	HL			; push function #
	CALL	LAB_DA13		; do BDOS function call
	POP	DE			; dump function #
	POP	DE			; dump parameter
	LD	A,(LAB_E6B8)	; get RTC buffer hour
	LD	L,A			; copy to L
	PUSH	HL			; save it
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		; get high byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get low byte
	EX	DE,HL			; swap to HL
	INC	HL			; increment it
	POP	DE			; pop RTC hour
	LD	(HL),E		; save hour
	LD	A,(LAB_E6B9)	; get RTC buffer minute
	LD	L,A			; copy to L
	PUSH	HL			; save RTC minute
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		; get low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get high byte
	EX	DE,HL			; swap to HL
	POP	DE			; restore RTC minute
	LD	(HL),E		; save it
	RET				;

; set RTC date, month & year

; stack is ..
; month/date
; year
; end.

LAB_6811
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6)
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	(LAB_E6BE),HL	; save last pushed before call pointer
	LD	HL,LAB_E6B4		; RTC date time buffer pointer
	PUSH	HL			; push parameter
	LD	HL,00FDh		; read RTC date time to buffer
	PUSH	HL			; push function #
	CALL	LAB_DA13		; do BDOS function call
	POP	DE			; dump function #
	POP	DE			; dump parameter
	LD	HL,(LAB_E6BE)	; get last pushed before call pointer
	INC	HL			; increment pointer
	INC	HL			; increment pointer
	LD	E,(HL)		; get year low byte (last pushed +1)
	INC	HL			; increment pointer
	LD	D,(HL)		; get year high byte (last pushed +1)
	LD	HL,0064h		; 100d
	CALL	LAB_DF6D		; does HL=DE/HL
	LD	A,L			; copy century
	LD	(LAB_E6B4),A	; save century
	LD	HL,(LAB_E6BE)	; get last pushed before call pointer
	INC	HL			; increment pointer
	INC	HL			; increment pointer
	LD	E,(HL)		; get year low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get year high byte
	LD	HL,0064h		; 100d
	CALL	LAB_DF97		; does HL = DE MOD HL
	LD	A,L			; copy year
	LD	(LAB_E6B5),A	; save year
	LD	HL,(LAB_E6BE)	; get last pushed before call pointer
	INC	HL			; point to month
	LD	E,(HL)		; get month
	EX	DE,HL			; swap to HL
	LD	A,L			; copy to A
	LD	(LAB_E6B6),A	; save month
	LD	HL,(LAB_E6BE)	; get last pushed before call pointer
	LD	E,(HL)		; get day of month
	EX	DE,HL			; swap to HL
	LD	A,L			; copy to A
	LD	(LAB_E6B7),A	; save day of month
	LD	HL,LAB_E6B4		; RTC date time buffer pointer
	PUSH	HL			; push parameter
	LD	HL,00FCh		; set RTC date time from buffer
	PUSH	HL			; push function #
	CALL	LAB_DA13		; do BDOS function call
	POP	DE			; dump function #
	POP	DE			; dump parameter
	RET				;

; get RTC date, month & year to bytes starting at pointer

; stack is ..
; pointer
; end.

LAB_6870
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6)
	LD	HL,LAB_E6B4		; RTC date time buffer pointer
	PUSH	HL			; push parameter
	LD	HL,00FDh		; read RTC date time to buffer
	PUSH	HL			; push function #
	CALL	LAB_DA13		; do BDOS function call
	POP	DE			; dump function #
	POP	DE			; dump parameter
	LD	A,(LAB_E6B4)	; get centuary
	LD	L,A			; copy to L
	LD	H,#00h		; save century
	LD	DE,0064h		; 100d
	CALL	LAB_DFCC		; does HL = HL*DE
	PUSH	HL			; save result
	LD	A,(LAB_E6B5)	; get year
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	POP	DE			; pop century
	ADD	HL,DE			; add to year
	PUSH	HL			; save it
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		; get pointer low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get pointer high byte
	EX	DE,HL			; swap to HL
	INC	HL			; +1
	INC	HL			; +2
	POP	DE			; restore year
	LD	(HL),E		; save year low byte
	INC	HL			; increment pointer
	LD	(HL),D		; save year high byte
	LD	A,(LAB_E6B6)	; get month
	LD	L,A			; copy to L
	PUSH	HL			; push month
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		; get pointer low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get pointer high byte
	EX	DE,HL			; swap to HL
	INC	HL			; point to low byte
	POP	DE			; restore month
	LD	(HL),E		; save at pointer
	LD	A,(LAB_E6B7)	; get day of month
	LD	L,A			; copy to L
	PUSH	HL			; save day of month
	LD	HL,000Eh		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		; get pointer low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get pointer high byte
	EX	DE,HL			; swap to HL
	POP	DE			; restore DOM
	LD	(HL),E		; save it to pointer
	RET				;

; do BIOS function 19

LAB_68C7
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6)
	LD	HL,(LAB_E2F8)	;68CD:	2AF8E2
	PUSH	HL		;68D0:	E5
	LD	HL,0000h	;68D1:	210000
	PUSH	HL		;68D4:	E5
	LD	HL,0013h		; BIOS function #19
	PUSH	HL			; push function #
	CALL	LAB_DA27		; do BIOS function, result in HL (LAB_7562)
	POP	DE			; dump function #
	POP	DE		;68DD:	D1
	POP	DE		;68DE:	D1
	RET				;

; set LAB_E2F8 depending on flag

; stack is ..
; flag
; end.

LAB_68E0
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6)
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	A,(HL)		; get last pushed low byte
	INC	HL			; increment pointer
	OR	(HL)			; OR last pushed high byte
	JP	Z,LAB_68F6		; jump if null

	LD	HL,0004h	;68F0:	210400
	JP	LAB_68F9		; save & exit

LAB_68F6
	LD	HL,0003h	;68F6:	210300
LAB_68F9
	LD	(LAB_E2F8),HL	;68F9:	22F8E2
	RET				;

; quit program
;
; stack is ..
; resident
; end.
;
; if resident=1 on calling the program memory is not deallocated (not supported)

LAB_68FD
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6)
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		; get resident flag low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get resident flag high byte
	PUSH	DE			; push parameter
	LD	HL,0000h		; BDOS function 0 - quit program
	PUSH	HL			; push function #
	CALL	LAB_DA13		; do BDOS function call
	POP	DE			; dump function #
	POP	DE			; dump parameter
	RET				;

; null routine

LAB_6915
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6)
	RET				; (does nothing, returns with HL as return address)

; null routine

LAB_691C
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6)
	RET				; (does nothing, returns with HL as return address)

; null routine

LAB_6923
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z (LAB_71E6)
	RET				; (does nothing, returns with HL as return address)

; some sort of table, 11h bytes per entry

LAB_692A
	DB	01h,80h,80h,80h,00h,80h,80h,80h,80h,80h,80h,80h,80h,80h,80h,80h,80h
	DB	81h,02h,02h,02h,00h,81h,81h,81h,81h,81h,81h,81h,81h,81h,81h,81h,0Dh
	DB	8Dh,8Dh,8Dh,8Dh,00h,03h,8Dh,8Dh,0Ch,8Dh,8Dh,8Dh,8Dh,8Dh,8Dh,8Dh,0Dh
	DB	8Dh,8Dh,8Dh,8Dh,00h,8Dh,8Dh,8Dh,8Dh,07h,8Dh,8Dh,8Dh,8Dh,8Dh,8Dh,0Dh
	DB	8Dh,8Dh,8Dh,8Dh,00h,8Dh,8Dh,8Dh,8Dh,8Dh,08h,8Dh,8Dh,8Dh,8Dh,8Dh,0Dh
	DB	8Dh,8Dh,8Dh,8Dh,00h,8Dh,8Dh,8Dh,8Dh,8Dh,8Dh,09h,8Dh,8Dh,8Dh,02h,0Dh
	DB	8Dh,8Dh,8Dh,8Dh,00h,8Dh,8Dh,8Dh,8Dh,8Dh,8Dh,8Dh,8Dh,8Dh,0Bh,02h,0Dh
	DB	8Dh,8Dh,8Dh,8Dh,00h,8Dh,8Dh,8Dh,8Dh,07h,8Dh,8Dh,8Dh,8Dh,8Dh,8Dh,0Dh
	DB	8Dh,8Dh,8Dh,8Dh,00h,8Dh,8Dh,8Dh,8Dh,8Dh,08h,8Dh,8Dh,8Dh,8Dh,8Dh,0Dh
	DB	8Dh,8Dh,8Dh,8Dh,00h,8Dh,8Dh,8Dh,8Dh,8Dh,8Dh,8Dh,09h,0Ah,8Dh,8Dh,0Dh
	DB	8Dh,8Dh,8Dh,8Dh,00h,8Dh,8Dh,8Dh,8Dh,8Dh,8Dh,09h,8Dh,8Dh,8Dh,02h,0Dh
	DB	8Dh,8Dh,8Dh,8Dh,00h,8Dh,8Dh,8Dh,8Dh,8Dh,8Dh,8Dh,8Dh,8Dh,0Bh,02h,0Dh
	DB	8Dh,8Dh,8Dh,8Dh,00h,8Dh,8Dh,8Dh,8Dh,8Dh,8Dh,8Dh,8Dh,8Dh,8Dh,8Dh,0Dh
	DB	8Dh,8Dh,8Dh,8Dh,00h,8Dh,8Dh,8Dh,8Dh,8Dh,8Dh,8Dh,8Dh,8Dh,8Dh,8Dh,8Dh

; some sort of table, 6 bytes per entry

LAB_6A18
	DB	20h,12h,30h,41h,30h,30h
	DB	30h,12h,10h,41h,30h,30h
	DB	30h,02h,00h,52h,52h,30h

LAB_6A2A
	DB	04h,05h,05h,00h,05h,05h
	DB	05h,04h,04h,04h,04h,04h
	DB	04h,04h,04h,04h,05h,04h
	DB	04h,04h,04h,05h,05h,05h
	DB	04h,04h,04h,04h,02h,04h
	DB	01h,04h

; message table accessesd by routine @ LAB_3BB8

LAB_6A4A
	DW	LAB_6A6A		;'    NOT-STARTED'
	DW	LAB_6A7A		;'    DISCONNECTED'
	DW	LAB_6A8B		;'     CONNECTED'
	DW	LAB_6A9A		;'   READY-RX-DATA'
	DW	LAB_6AAB		;'   READY-RX-PROG'
	DW	LAB_6ABC		;'   READY-TX-DATA'
	DW	LAB_6ACD		;'   READY-TX-PROG'
	DW	LAB_6ADE		;'     RECORD-RX'
	DW	LAB_6AED		;'      BLOCK-RX'
	DW	LAB_6AFC		;'     RECORD-TX'
	DW	LAB_6B0B		;'    DATA-SET-TX'
	DW	LAB_6B1B		;'      BLOCK-TX'
	DW	LAB_6B2A		;'     TERMINATED'
	DW	LAB_6B3A		;'      CRASHED'
	DW	LAB_6B48		;'    REPLY-START'
	DW	LAB_6B58		;'     REPLY-END'

LAB_6A6A
	DB	'    NOT-STARTED',00h
LAB_6A7A
	DB	'    DISCONNECTED',00h
LAB_6A8B
	DB	'     CONNECTED',00h
LAB_6A9A
	DB	'   READY-RX-DATA',00h
LAB_6AAB
	DB	'   READY-RX-PROG',00h
LAB_6ABC
	DB	'   READY-TX-DATA',00h
LAB_6ACD
	DB	'   READY-TX-PROG',00h
LAB_6ADE
	DB	'     RECORD-RX',00h
LAB_6AED
	DB	'      BLOCK-RX',00h
LAB_6AFC
	DB	'     RECORD-TX',00h
LAB_6B0B
	DB	'    DATA-SET-TX',00h
LAB_6B1B
	DB	'      BLOCK-TX',00h
LAB_6B2A
	DB	'     TERMINATED',00h
LAB_6B3A
	DB	'      CRASHED',00h
LAB_6B48
	DB	'    REPLY-START',00h
LAB_6B58
	DB	'     REPLY-END',0h

; message table accessesd by routine @ LAB_3BD0

LAB_6B67
	DW	LAB_6B89		;'    C-INIT-COMMS'
	DW	LAB_6B9A		;'       C-DIAL'
	DW	LAB_6BA8		;'      C-ANSWER'
	DW	LAB_6BB7		;'      C-MANUAL'
	DW	LAB_6BC6		;'    C-DROP-LINE'
	DW	LAB_6BD6		;'     C-COMMAND'
	DW	LAB_6BE5		;'      C-RX-CMD'
	DW	LAB_6BF4		;'     C-TX-REPLY'
	DW	LAB_6C04		;'    C-SHUT-DOWN'
	DW	LAB_6C14		;'      C-RX-REC'
	DW	LAB_6C23		;'      C-RX-BLK'
	DW	LAB_6C32		;'    C-BEGIN-FILE'
	DW	LAB_6C43		;'      C-TX-REC'
	DW	LAB_6C52		;'     C-END-FILE'
	DW	LAB_6C62		;'      C-TX-BLK'
	DW	LAB_6C71		;'      C-END-TX'
	DW	LAB_6C80		;'      C_ABORT'

LAB_6B89
	DB	'    C-INIT-COMMS',00h
LAB_6B9A
	DB	'       C-DIAL',00h
LAB_6BA8
	DB	'      C-ANSWER',00h
LAB_6BB7
	DB	'      C-MANUAL',00h
LAB_6BC6
	DB	'    C-DROP-LINE',00h
LAB_6BD6
	DB	'     C-COMMAND',00h
LAB_6BE5
	DB	'      C-RX-CMD',00h
LAB_6BF4	
	DB	'     C-TX-REPLY',00h
LAB_6C04
	DB	'    C-SHUT-DOWN',00h
LAB_6C14
	DB	'      C-RX-REC',00h
LAB_6C23
	DB	'      C-RX-BLK',00h
LAB_6C32
	DB	'    C-BEGIN-FILE',00h
LAB_6C43
	DB	'      C-TX-REC',00h
LAB_6C52
	DB	'     C-END-FILE',00h
LAB_6C62
	DB	'      C-TX-BLK',00h
LAB_6C71
	DB	'      C-END-TX',00h
LAB_6C80
	DB	'      C_ABORT',00h

; misc comms messages

LAB_6C8E:
	DB	' Data Transmission',00h
LAB_6CA1:
	DB	'Program transmission',00h
LAB_6CB6
	DB	'   Data reception',00h
LAB_6CCA
	DB	' Program reception',00h
LAB_6CDB:
	DB	'Sending data',00h
LAB_6CE8:
	DB	'Sending prog',00h
LAB_6CF5
	DB	'Receiving data',00h
LAB_6D04:
	DB	'Receiving prog',00h
LAB_6D13:
	DB	'  Data transmitted',00h
LAB_6D26:
	DB	'Program transmitted',00h
LAB_6D3A:
	DB	'   Data received',00h
LAB_6D4B:
	DB	'   Program received',00h
LAB_6D5E:
	DB	'    Line failure',00h			; error 8040 (238/001)
LAB_6D6F:
	DB	'Plinth not connected',00h		; error 8000 (238/001)
LAB_6D84:
	DB	'    Modem fault',00h
LAB_6D94:
	DB	' Failed to connect',00h
LAB_6DA7:
	DB	'  Session complete',00h
LAB_6DBA:
	DB	'     Logging on',00h
LAB_6DCA:
	DB	'     Logged on',00h
LAB_6DD9:
	DB	'     Logged off',00h
LAB_6DE9:   
	DB	'   Invalid reply',00h
LAB_6DFA
	DB	'  Invalid command',00h
LAB_6E0C:
	DB	'Invalid data stream',00h
LAB_6E20:
	DB	'      Timeout',00h
LAB_6E2E:
	DB	'   not available',00h
LAB_6E3F
	DB	'    in Commstar',00h
LAB_6E4F:
	DB	'   in Workstation',00h
LAB_6E61:
	DB	'    called from',00h
LAB_6E71:
	DB	' Comms in progress',00h
LAB_6E84:
	DB	'Press >> to continue',00h
LAB_6E99:
	DB	'   *** ERROR ***',00h
LAB_6EAA:
	DB	'      Dialling',00h
LAB_6EB9:
	DB	'   Awaiting phone',00h
LAB_6ECB:
	DB	'    Dial number.',00h
LAB_6EDC:
	DB	'   Press >> when',00h
LAB_6EED:
	DB	'   connection has',00h
LAB_6EFF:
	DB	'  been established.',00h
LAB_6F13:
	DB	'               >> ',00h
LAB_6F26:
	DB	'   Abort pending',00h
LAB_6F37:
	DB	'  Session aborted',00h
LAB_6F49:
	DB	'   by remote end',00h
LAB_6F5A
	DB	'    Failed once',00h
LAB_6F6A
	DB	'    Failed twice',00h
LAB_6F7B
	DB	' Failed three times',00h
LAB_6F8F:
	DB	'    Please wait',00h
LAB_6F9F:
	DB	'Retrying in 1 minute',00h
LAB_6FB4:
	DB	'    Re-dialling',00h

LAB_6FC4
	DB	00h,'AB',00h,' ',7Fh,'CDEFWYGHIJX'

LAB_6FD5
	LD	BC,4C4Bh	;6FD5:	014B4C
LAB_6FD8
	LD	C,L		;6FD8:	4D
	LD	C,(HL)	;6FD9:	4E
	DEC	C		;6FDA:	0D
	LD	B,#4Fh	;6FDB:	064F
LAB_6FDD
	LD	D,B		;6FDD:	50
	LD	D,D		;6FDE:	52
	LD	D,E		;6FDF:	53
	NOP			;6FE0:	00
	NOP			;6FE1:	00
	LD	D,H		;6FE2:	54
	LD	D,L		;6FE3:	55
	LD	D,(HL)	;6FE4:	56
	INC	D		;6FE5:	14
	NOP			;6FE6:	00
	NOP			;6FE7:	00
	NOP			;6FE8:	00
	LD	DE,0012h	;6FE9:	111200
	JR	NZ,LAB_706D	;6FEC:	207F
	DEC	HL		;6FEE:	2B
	LD	C,#0Fh	;6FEF:	0E0F
	LD	D,C		;6FF1:	51
	JR	NC,LAB_704E	;6FF2:	305A
	DEC	L		;6FF4:	2D
	INC	C		;6FF5:	0C
	DEC	BC		;6FF6:	0B
	CPL			;6FF7:	2F
LAB_6FF8
	LD	L,#01h	;6FF8:	2E01
	SCF			;6FFA:	37
	JR	C,LAB_7036	;6FFB:	3839
	IN	A,(0Dh)	;6FFD:	DB0D
	LD	B,#34h	;6FFF:	0634
	DEC	(HL)		;7001:	35
	LD	(HL),#1Ah	;7002:	361A
	NOP			;7004:	00
	NOP			;7005:	00
	LD	SP,3332h	;7006:	313233
	INC	D		;7009:	14
	NOP			;700A:	00
	NOP			;700B:	00
	NOP			;700C:	00
	NOP			;700D:	00
	NOP			;700E:	00
	NOP			;700F:	00
	NOP			;7010:	00
	LD	A,(DE)	;7011:	1A
LAB_7012
	NOP			;7012:	00
	NOP			;7013:	00
	NOP			;7014:	00
	NOP			;7015:	00
	NOP			;7016:	00
	NOP			;7017:	00
	NOP			;7018:	00
	NOP			;7019:	00
	NOP			;701A:	00
LAB_701B
	NOP			;701B:	00
	INC	C		;701C:	0C
	LD	DE,0000h	;701D:	110000
	NOP			;7020:	00
	IN	A,(0Bh)	;7021:	DB0B
	LD	(DE),A	;7023:	12
	NOP			;7024:	00
	NOP			;7025:	00
	NOP			;7026:	00
	INC	DE		;7027:	13
	NOP			;7028:	00
	NOP			;7029:	00
	NOP			;702A:	00
	NOP			;702B:	00
	NOP			;702C:	00
	NOP			;702D:	00
	NOP			;702E:	00
	NOP			;702F:	00

; this bit executed @ D681h
; the code gets here from the system reset ...

LAB_7030				; (LAB_D681)
	DB	C3h			; jump opcode
LAB_7030				; (LAB_D682)
	DW	LAB_D686		; default jump over pointer

LAB_7033				; (LAB_D684)
	DW	LAB_ED1C		; default pointer

LAB_7035				; (LAB_D686)
	LD	HL,LAB_D681		; point to block start
	LD	SP,HL			; set the stack (down from LAB_D681)
	CALL	LAB_D6C0		; fill block from LAB_ED1C to LAB_F17F (LAB_706F)
	LD	HL,(LAB_7FFC)	; HL = LAB_7D58, ROM 1
	CALL	LAB_D6DB		; execute copy fill & make functions (LAB_708A)
	LD	A,#01h		; set to 2nd ROM!
	CALL	LAB_D771		; page in 2nd ROM (LAB_7120)
	LD	HL,(LAB_7FFC)	; HL = LAB_7E15, ROM 2
	CALL	LAB_D6DB		; execute copy fill & make functions (LAB_708A)
	LD	A,#00h		; set to 1st ROM
	CALL	LAB_D6B5		; save address of #_1 @ LAB_E36F & set mem page A
					; (LAB_7064)
	LD	HL,LAB_D081		;7052:	2181D0 (LAB_7BCB ROM 2)
	LD	(LAB_E3BD),HL	;7055:	22BDE3
	CALL	LAB_EF88		;7058:	CD88EF [LAB_06A5 ROM 2]

LAB_705B				; (LAB_D6AC)
	LD	BC,0000h		; BDOS function 0 - System Reset
	CALL	LAB_0005		; call BDOS function (should never return)
	JP	LAB_D6AC		; if it does, call it again (LAB_705B)

; save address of #_1 @ LAB_E36F & set mem page A

LAB_7064				; (LAB_D6B5)
	PUSH	HL			; save HL
	LD	HL,LAB_E3B1		; get address of #_1
	LD	(LAB_E36F),HL	; save address of #_1
	POP	HL			; restore HL
	JP	LAB_D771		; page in 1st ROM & return (LAB_7120)

; setup block from ED1C to F17F

LAB_706F				; (LAB_D6C0)
	LD	HL,LAB_D6D7		; source pointer
	LD	DE,LAB_ED1C		; destination pointer
	LD	BC,0004h		; 04h bytes to copy
	LDIR				; copy block
	LD	HL,LAB_ED1C		; source pointer
	LD	DE,LAB_ED20		; destination pointer
	LD	BC,0460h		; 0460h bytes to copy
	LDIR				; copy block
	RET				;

; this block copied to LAB_ED1C

LAB_7086				; (LAB_D6D7)
	LD	HL,0001h		;7086:	210100
	RET				;

; end of block


LAB_708A				; (LAB_D6DB)
	PUSH	BC			; save BC
	PUSH	DE			; save DE
	PUSH	AF			; save AF

; get vector from LAB_D6F4 + HL*2

LAB_708D				; (LAB_D6DE)
	LD	E,(HL)		; get # low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get # high byte
	INC	HL			; increment pointer
	PUSH	HL			; save pointer
	LD	HL,LAB_D6F4		; set pointer to table
	ADD	HL,DE			; + #
	ADD	HL,DE			; + # (two bytes per entry)
	LD	A,(HL)		; get vector low byte
	INC	HL			; increment pointer
	LD	H,(HL)		; get vector high byte
	LD	L,A			; copy low byte
	EX	(SP),HL		; restore HL and push vector
	RET				; effectively JP (HL)

LAB_709D				; (LAB_D6EE)
	POP	AF			; restore AF
	POP	DE			; restore DE
	POP	BC			; restore BC
	RET				;

LAB_70A1				; (LAB_D6F2)
	DW	LAB_D6EE		; (LAB_709D) restore registers and exit
LAB_70A3				; (LAB_D6F4)
	DW	LAB_D6FA		; (LAB_70A9) zero block @ (HL), length (HL+2)
	DW	LAB_D713		; (LAB_70C2) copy block @ (HL) to (HL+2), length (HL+4)
	DW	LAB_D727		; (LAB_70D6) copy (HL) words from (HL+2)..(HL+n)

LAB_70A9				; (LAB_D6FA)
	LD	E,(HL)		; get block pointer low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get block pointer high byte
	INC	HL			; increment pointer
	LD	C,(HL)		; get count low byte
	INC	HL			; increment pointer
	LD	B,(HL)		; get count high byte
	INC	HL			; increment pointer
	PUSH	HL			; save pointer
	LD	H,D			; copy DE ..
	LD	L,E			; .. to HL
	SUB	A			; clear A
	LD	(HL),A		; clear byte
	LDI				; copy byte (HL)+ to (DE)+, BC-
					; easy way to DEC BC and INC DE
	JP	PO,LAB_D70F		; exit if all done (LAB_70BE)

	DEC	HL			; point source back to zeroed byte
	LDIR				; copy block
LAB_70BE				; (LAB_D70F)
	POP	HL			; restore pointer
	JP	LAB_D6DE		; go do next (LAB_708D)

; copy block @ (HL) to (HL+2), length (HL+4)

LAB_70C2				; (LAB_D713)
	LD	E,(HL)		; get source address low
	INC	HL			; point to next
	LD	D,(HL)		; get source address high
	INC	HL			; point to next
	PUSH	DE			; save source address
	LD	E,(HL)		; get destination address low
	INC	HL			; point to next
	LD	D,(HL)		; get destination address high
	INC	HL			; point to next
	LD	C,(HL)		; get count low
	INC	HL			; point to next
	LD	B,(HL)		; get count high
	INC	HL			; point to next
	EX	(SP),HL		; swap source & pointer
	LDIR				; copy block
	POP	HL			; restore pointer
	JP	LAB_D6DE		; go do next (LAB_708D)

; copy (HL) words from (HL+2)..(HL+n)

LAB_70D6				; (LAB_D727)
	LD	E,(HL)		; get word count low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get word count high byte
	INC	HL			; increment pointer
	EX	DE,HL			; swap to HL
	ADD	HL,HL			; *2
	LD	B,H			; copy HL ..
	LD	C,L			; .. to BC
	LD	HL,(LAB_D684)	; get destination
	EX	DE,HL			; swap pointer back
LAB_70E2				; (LAB_D733)
	LD	A,#D7h		; RST 10h byte
	LD	(DE),A		; save to table
	INC	DE			; increment destination
	LD	A,(LAB_F791)	; get memory page buffer
	LD	(DE),A		; save to table
	INC	DE			; increment destination
	LDI				; copy vector low byte from table
	LDI				; copy vector high byte from table
	JP	PE,LAB_D733		; loop if not all done (LAB_70E2)

	EX	DE,HL			; swap destination to HL
	LD	(LAB_D684),HL	; save next destination
	EX	DE,HL			; swap pointer back to HL
	JP	LAB_D6DE		; go do next (LAB_708D)

; gets here if RST 10h page was not correct
; (subroutine called is in another page)

LAB_70FA				; (LAB_D74B)
	POP	DE			; pop call routine address
	PUSH	HL			; save pointer to subroutine page/address
	LD	HL,(LAB_E36F)	; get page call stack pointer
	DEC	HL			; decrement page call stack pointer
	LD	(HL),A		; save call page
	DEC	HL			; decrement page call stack pointer
	LD	(HL),D		; save return address high byte
	DEC	HL			; decrement page call stack pointer
	LD	(HL),E		; save return address low byte
	LD	(LAB_E36F),HL	; save page call stack pointer
	POP	HL			; restore pointer to subroutine page/address
	LD	A,(HL)		; get page #
	INC	HL			; increment pointer
	LD	E,(HL)		; get subroutine address low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get subroutine address high byte
	CALL	LAB_D770	;710E:	CD70D7
	PUSH	HL		;7111:	E5
	LD	HL,(LAB_E36F)	; get page call stack pointer
	LD	E,(HL)		; restore return address low byte
	INC	HL			; increment page call stack pointer
	LD	D,(HL)		; restore return address high byte
	INC	HL			; increment page call stack pointer
	LD	A,(HL)		; restore call page
	INC	HL			; increment page call stack pointer
	LD	(LAB_E36F),HL	; save page call stack pointer
	POP	HL		;711E:	E1


; Arrrrrrrooooooooooooogah! self modifying code ahead!

LAB_711F				; (LAB_D770)
	PUSH	DE		;711F:	D5
LAB_7120				; (LAB_D771)
	DB	C3h			; jump opcode
LAB_7121				; (LAB_D772)
	DW	LAB_D774		; default jump address (LAB_7123)

LAB_7123				; (LAB_D774)
	PUSH	AF			; save AF [page]
	PUSH	HL			; save HL
	PUSH	DE			; save DE
	LD	HL,(LAB_0001)	; get reset jump address
					; LAB_0103 ROM 1, LAB_F238 ROM 2
	LD	DE,003Ch		; offset to set memory page A & enable interrupts
					; LAB_013F ROM 1, LAB_F274 ROM 2
	ADD	HL,DE			; add offset
	LD	(LAB_D772),HL	; save new jump address [LAB_013F]
	LD	A,#01h		; page 01h
	CALL	LAB_D771		; go call new jump (LAB_7120)

					; return comes back here
	LD	HL,(LAB_0001)	; get reset jump address
					; LAB_0103 ROM 1, LAB_F238 ROM 2
	LD	DE,003Ch		; offset to set memory page A & enable interrupts
					; LAB_013F ROM 1, LAB_F274 ROM 2
	ADD	HL,DE			; add offset
	LD	(LAB_D772),HL	; save new jump address [LAB_F274]
	LD	HL,(LAB_0006)	; get BDOS vector from ROM 2 [LAB_F180]
	LD	(LAB_D682),HL	; save it so next time LAB_D681 called it goes
					; to the BDOS handler
	POP	DE			; restore DE
	POP	HL			; restore HL
	POP	AF			; restore AF [page]
	JP	LAB_D771		; go set memory page A & enable interrupts then return
					; (LAB_7120)

; set page 00h & reset

LAB_714B				; (LAB_D79C)
	RST	10h			; go do set page & jump
LAB_714C				; (LAB_D79D)
	DB	00h			; default page 
LAB_714D				; (LAB_D79E)
	DW	LAB_0000		; default call address

	NOP			;714F:	00
	NOP			;7150:	00

; sets call address (HL) & page

; stack
; page
; end.

LAB_7151				; (LAB_D7A2)
	LD	(LAB_D79E),HL	; set call address
	POP	HL			; pop return address
	LD	(LAB_D7A0),HL	; save return address
	POP	HL			; get page ??
	LD	A,L			; copy page byte
	LD	(LAB_D79D),A	; save page byte
	CALL	LAB_D79C		; set page & call
	PUSH	HL		;7160:	E5
	PUSH	HL		;7161:	E5
	LD	HL,(LAB_D7A0)	; restore return address
	EX	(SP),HL		; swap onto stack
	RET				;

LAB_7167				; (LAB_D7B8)
	LD	HL,LAB_D7BE		; set call address (LAB_716D)
	JP	LAB_D7A2		; sets call address (HL) & page (LAB_7151)

LAB_716D				; (LAB_D7BE)
	LD	HL,LAB_D681		; (was LAB_7030)
	LD	(LAB_0006),HL	;7170:	220600
	RET				;

LAB_7174				; (LAB_D7C5)
	LD	HL,LAB_D9A0		; set call address (LAB_734F ??)
	JP	LAB_D7A2		; sets call address (HL) & page (LAB_7151)

LAB_717A				; (LAB_D7CB)
	LD	HL,LAB_D7D1		; set call address (LAB_7180)
	JP	LAB_D7A2		; sets call address (HL) & page (LAB_7151)

LAB_7180				; (LAB_D7D1)
	PUSH	BC			; save BC
	LD	HL,0007h		; offset to last pushed but 1 H
	ADD	HL,SP			; add stack pointer
	LD	B,(HL)		; get count high byte
	DEC	HL			; decrement pointer
	LD	C,(HL)		; get count low byte
	DEC	HL			; decrement pointer
	LD	A,(HL)		; get ?? pointer high byte
	DEC	HL			; decrement pointer
	LD	L,(HL)		; get ?? pointer low byte
	LD	H,A			; copy to H
	LD	D,#00h		; clear total high byte
	LD	A,#00h		; clear total low byte
LAB_7191
	ADD	A,(HL)		; add byte to total
	JP	NC,LAB_D7E7		; jump if no carry (LAB_7196)

	INC	D			; else increment total high byte
LAB_7196
	CPI				; inc HL, dec BC
	JP	PE,LAB_D7E2		; loop if not all done

	LD	H,D			; copy total high byte
	LD	L,A			; copy total low byte
	POP	BC			; restore BC
	RET				;

LAB_719F				; (LAB_D7F0)
	POP	HL		;719F:	E1
	POP	HL		;71A0:	E1
	LD	A,L		;71A1:	7D
	LD	(LAB_D833),A	;71A2:	3233D8
	CALL	LAB_D6B5	;71A5:	CDB5D6 (LAB_7064)
	POP	HL		;71A8:	E1
	LD	SP,LAB_D681	;71A9:	3181D6
	JP	(HL)		;71AC:	E9

; setup vector @ EExx

; stack is ..
; vector
; EExx pointer
; end.

LAB_71AD				; (LAB_D7FE)
	POP	HL			; get return address
	POP	DE			; get word from passed pointer
	EX	(SP),HL		; swap return address with word from EExx table
	EX	DE,HL			; EExx word in DE, passed word in HL
	LD	A,H			; copy passed word high byte
	CP	#80h			; compare with 80h
	JP	C,LAB_D818		; jump if <80h (in paged memory) (LAB_71C7)

					; word is in unpaged memory
	LD	A,(HL)		; get byte @ passed word
	CP	#D7h			; is it D7h (RST 10) ?
	JP	NZ,LAB_D818		; jump if not (LAB_71C7)

	PUSH	BC			; else save BC
	LD	BC,0004h		; 04h bytes to copy
	LDIR				; copy block
	POP	BC			; restore BC
	JP	LAB_D825		; restore stack & exit (LAB_71D4)

					; was in paged mem or 1st byte not D7h
LAB_71C7				; (LAB_D818)
	EX	DE,HL			; swap pointers
	LD	A,#D7h		; byte = RST 10
	LD	(HL),A		; save byte to EExx
	INC	HL			; increment pointer
	LD	A,(LAB_D833)	; get current code page
	LD	(HL),A		; save page to EExx +1
	INC	HL			; increment pointer
	LD	(HL),E		; save address low byte to EExx +2
	INC	HL			; increment pointer
	LD	(HL),D		; save address high byte to EExx +3
LAB_71D4				; (LAB_D825)
	EX	(SP),HL		; return address to HL
	PUSH	DE			; push other parameter
	JP	(HL)			; return (effectively)

; does set page (if HL<ED00h) and JP (HL)

LAB_71D7				; (LAB_D828)
	LD	A,H			; get high byte
	CP	#EDh			; compare with EDh
	JP	C,LAB_D82F		; jump if A<EDh (LAB_71DE)

	JP	(HL)			; else jump to address HL

					; HL was <ED00h
LAB_71DE				; (LAB_D82F)
	LD	(LAB_D834),HL	; save address as restart address
	RST	10h			; go do set page & jump
	DB	01h			; set page 01h
; (LAB_D834)
	DW	LAB_0000		; restart address

; just does JP (HL)

LAB_71E5				; (LAB_D836)
	JP	(HL)			;

; calls rest of subroutine then does RET after putting (HL=0) in Z

LAB_71E6				; (LAB_D837)
	POP	HL			; get return address
	PUSH	BC			; save BC
	LD	B,H			; copy return ..
	LD	C,L			; .. address to BC
	LD	HL,0000h		; zero offset
	ADD	HL,SP			; stack pointer to HL
	EX	DE,HL			; stack pointer to DE
	ADD	HL,SP			; stack to HL (DE is always 0000h)
	LD	SP,HL			; copy it back!
	PUSH	DE			; save old stack pointer
	PUSH	IX			; save IY
	PUSH	IY			; save IX
	LD	H,B			; get return address ..
	LD	L,C			; .. back into HL
	CALL	LAB_D836		; just does JP (HL)
LAB_71FB
	POP	IY			; restore IY
	POP	IX			; restore IX
LAB_71FF
	EX	DE,HL			; copy HL for now
	POP	HL			; restore old stack pointer
	LD	SP,HL			; reset stack
	POP	BC			; restore BC
	EX	DE,HL			; get HL back
	LD	A,H			; set the flags
	OR	L			;
	RET				;

; calls rest of subroutine then does RET after putting (HL=0) in Z

LAB_7207				; (LAB_D858)
	POP	HL			; get return address
	PUSH	BC			; save BC
	LD	B,H			; copy return ..
	LD	C,L			; .. address to BC
	LD	HL,0000h		; no offset
	ADD	HL,SP			; copy stack pointer to HL
	EX	DE,HL			; swap to DE
	ADD	HL,SP			; add stack to HL
	LD	SP,HL			; set new stack pointer
	PUSH	DE			; save old stack pointer
	LD	HL,LAB_D850		; set new return address (LAB_71FF)
	PUSH	HL			; push new return address
	LD	H,B			; copy old return ..
	LD	L,C			; .. address back to HL
	JP	(HL)			; go do it

LAB_721A				; (LAB_D86B)
	LDIR			;721A:	EDB0
	RET				;

; copies last 3 words from stack to LAB_E0FE, calls rest
; of subroutine then does RET after putting (HL=0) in Z 

LAB_721D				; (LAB_D86E)
	POP	DE			; pop return address
	LD	HL,0002h		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	PUSH	IX			; save IX
	PUSH	IY			; save IY
	PUSH	BC			; save BC
	PUSH	DE			; save return address
	LD	DE,LAB_E0FE		; point to ?? buffer area
	LD	B,#06h		; six bytes (3 words) to copy
LAB_722D
	LD	A,(HL)		; get source byte
	LD	(DE),A		; save to destination
	INC	HL			; next source
	INC	DE			; next destination
	DEC	B			; decrement byte count
	JP	NZ,LAB_D87E		; loop if not all done (LAB_722D)

	LD	HL,LAB_D88B		; set new return address (LAB_723A)
	EX	(SP),HL		; swap with old return address
	JP	(HL)			; jump to rest of routine

; after executing the rest of the routine program flow returns here

LAB_723A				; (LAB_D88B)
	POP	BC			; restore BC
	POP	IY			; restore IY
	POP	IX			; restore IX
	LD	A,H			; set the flags
	OR	L			;
	RET				;

; **** end of cpoied block ****

; block copied to LAB_E0F4

LAB_7242				; (LAB_E0F4)
	DB	00h,00h,00h,00h,00h,00h,00h,00h
	DB	FFh,FFh,00h,00h,00h,00h,00h,00h

LAB_7252
	DB	00h,00h,00h,00h,00h,00h,00h,00h
	DB	00h,00h,00h,00h,00h,00h,00h,00h
	DB	00h,00h,00h,00h,00h,00h,00h,00h
	DB	00h,00h,00h,00h,00h,00h,00h,00h
	DB	00h,00h,00h,00h,00h,00h,00h,00h
	DB	00h,00h,00h,00h,00h,00h,00h,00h
	DB	00h,00h,00h,00h,00h,00h,00h,00h
	DB	00h,00h,00h,00h,00h,00h,00h,00h
	DB	00h,00h,00h,00h,00h,00h,00h,00h
	DB	00h,00h,00h,00h,00h,00h,00h,00h
	DB	00h,00h,00h,00h,00h,00h,00h,00h
	DB	00h,00h,00h,00h,00h,00h,00h,00h
	DB	00h,00h,00h,00h,00h,00h,00h,00h
	DB	00h,00h,00h,00h,00h,00h,00h,00h
	DB	00h,00h,00h,00h,00h,00h,00h,00h
	DB	00h,00h,00h,00h,00h,00h,00h,00h
	DB	00h,00h,00h,00h,00h,00h,00h,00h
	DB	00h,00h,00h,00h,00h,00h,00h,00h
	DB	00h,00h,00h,00h,00h,00h,00h,00h
	DB	00h,00h,00h,00h,00h,00h,00h,00h
	DB	00h,00h,00h,00h,00h,00h,00h,00h
	DB	00h,00h,00h,00h,00h,00h,00h

; block copied to LAB_E22D

LAB_7301				; (LAB_E22D)
	DB	00h,00h
LAB_7303				; (LAB_E22F)
	DB	'OK',00h
	DB	00h
LAB_7307
	DB	'NO',00h
	DB	01h
LAB_730B				; (LAB_E237)
	DB	'DM',00h
	DB	02h
LAB_730F				; (LAB_E23B)
	DB	00h
LAB_7310				; (LAB_E23C)
	DB	'     (',00h
LAB_7317				; (LAB_E243)
	DB	'/',00h
LAB_7319				; (LAB_E245)
	DB	')',00h
	DB	'RCV1',00h,03h
	DB	'RCV2',00h,03h
	DB	'SEND',00h,05h
	DB	'LOAD',00h,04h
	DB	'PROG',00h,06h
	DB	'TIME',00h,02h
	DB	'ENDC',00h,0Ch
	DB	00h,00h,00h,00h,00h,00h,00h,00h
	DB	'      '
	DB	'C-RX-CMD',00h,00h
	DB	'     '
	DB	'C-TX-REPLY',00h
	DB	'ENDC',00h
	DB	00h,00h,00h,00h,00h,00h,00h,00h
	DB	00h,00h,5Ah,6Fh,6Ah,6Fh,7Bh,6Fh
	DB	00h,00h,00h,00h,00h,00h
LAB_7388				;(LAB_E2B4)
	DW	EE50h
	DW	EE54h
	DW	EE58h
	DW	EE5Ch
	DW	EE60h
	DW	EE64h
	DW	EE68h
	DW	EE6Ch
	DW	EE70h
	DW	EE74h
	DW	EE78h
	DW	EE7Ch
	DW	EE80h
	DW	EE84h
	DW	EE88h
	DW	EE8Ch
	DW	EE90h
	DW	EE98h
	DW	EE9Ch
	DW	EEA0h
	DW	EEA4h
	DW	EEA8h
	DW	EEACh
	DW	EEB0h
	DW	EEB4h
	DW	EEB8h
	DW	EEBCh
	DW	EEC0h
	DW	EEC4h
	DW	EEC8h
	DW	EECCh
	DW	EED0h
	DW	EED4h
	DW	0000h
	DW	0004h

; this block (to LAB_7C2E) copied to LAB_D893

; set registers & execute routine @ warm+offset

; stack is ..
; ?? offset to routine
; ?? HL
; ?? DE
; ?? BC
; ?? AF
; end.

LAB_73CE				; (LAB_D893)
	PUSH	IX			; save IX
	PUSH	IY			; save IY
	PUSH	BC			; save BC
	LD	IX,0008h		; offset past junk & return address
	ADD	IX,SP			; add stack pointer
	LD	HL,LAB_D8C8		; set return address (LAB_7403)
	PUSH	HL			; put on stack
	LD	HL,(LAB_0001)	; get warm start jump vector
	LD	E,(IX+#00h)		; get last pushed low byte
	LD	D,(IX+#01h)		; get last pushed high byte
	ADD	HL,DE			; add to warm start vector
	PUSH	HL			; on stack as jump address
	LD	C,(IX+#09h)		; get last pushed but 4 high byte
	LD	B,(IX+#08h)		; get last pushed but 4 low byte
	PUSH	BC			; on stack
	POP	AF			; copy to AF
	LD	B,(IX+#07h)		; get last pushed but 3 high byte
	LD	C,(IX+#06h)		; get last pushed but 3 low byte
	LD	D,(IX+#05h)		; get last pushed but 2 high byte
	LD	E,(IX+#04h)		; get last pushed but 2 low byte
	LD	H,(IX+#03h)		; get last pushed but 1 high byte
	LD	L,(IX+#02h)		; get last pushed but 1 low byte
	RET				; jump to warm start vector + last pushed

LAB_7403				; (LAB_D8C8)
	POP	BC			; restore BC
	POP	IY			; restore IY
	POP	IX			; restore IX
	RET				;

; stack is ..
; ??
; end.

LAB_7409				; (LAB_D8CE)
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)	;7413:	5E
	LD	D,#00h		; clear high byte
	LD	HL,LAB_E104		; point to ?? table
	ADD	HL,DE		;7419:	19
	INC	HL		;741A:	23
	LD	E,(HL)		;741B:	5E
	LD	D,#00h		; clear high byte
	LD	HL,0002h	;741E:	210200
	CALL	LAB_E023		; does AND HL,DE. sets Z flag (LAB_7B5E)
	JP	Z,LAB_D92E	;7424:	CA2ED9 (LAB_7469)

	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)	;742B:	5E
	LD	D,#00h		; clear high byte
	LD	HL,0080h	;742E:	218000
	CALL	LAB_E0E7		; does CP DE,HL, returns HL=0 & Zb=1 if no carry (HL<=DE)
					; (LAB_7C22)
	JP	Z,LAB_D90A	;7434:	CA0AD9 (LAB_7445)

	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)	;743B:	5E
	LD	D,#00h		; clear high byte
	LD	HL,FFE0h	;743E:	21E0FF
	ADD	HL,DE		;7441:	19
	LD	H,#00h	;7442:	2600
	RET				;

LAB_7445				; (LAB_D90A)
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;7449:	5E
	LD	D,#00h		; clear high byte
	LD	HL,00A8h	;744C:	21A800
	CALL	LAB_E0E7		; does CP DE,HL, returns HL=0 & Zb=1 if no carry (HL<=DE)
					; (LAB_7C22)
	JP	Z,LAB_D92E	;7452:	CA2ED9 (LAB_7469)

	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)	;7459:	5E
	LD	D,#00h		; clear high byte
	LD	HL,LAB_E205		; point to ?? table
	ADD	HL,DE			; add #1 offset ??
	LD	DE,LAB_FF80		; -128d
	ADD	HL,DE			; subtract 80h
	LD	E,(HL)		; get byte
	LD	D,#00h		; clear high byte
	EX	DE,HL			; swap to HL
	RET				;

LAB_7469				; (LAB_D92E)
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)	;746D:	5E
	LD	D,#00h		; clear high byte
	EX	DE,HL		;7470:	EB
	RET				;

; stack is ..
; ??
; end.

LAB_7472				; (LAB_D937)
	LD	DE,0000h		; needed for routine
	CALL	LAB_D837		; calls rest of subroutine then does RET after putting
					; (HL=0) in Z
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;747C:	5E
	LD	D,#00h		; clear high byte
	LD	HL,LAB_E104	;747F:	2104E1
	ADD	HL,DE		;7482:	19
	INC	HL		;7483:	23
	LD	E,(HL)		;7484:	5E
	LD	D,#00h		; clear high byte
	LD	HL,0001h	;7487:	210100
	CALL	LAB_E023		; does AND HL,DE. sets Z flag
	JP	Z,LAB_D997	;748D:	CA97D9 (LAB_74D2)

	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;7494:	5E
	LD	D,#00h		; clear high byte
	LD	HL,0080h	;7497:	218000
	CALL	LAB_E0E7		; does CP DE,HL, returns HL=0 & Zb=1 if no carry (HL<=DE)
	JP	Z,LAB_D973	;749D:	CA73D9 (LAB_74AE)

	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;74A4:	5E
	LD	D,#00h		; clear high byte
	LD	HL,0020h	;74A7:	212000
	ADD	HL,DE		;74AA:	19
	LD	H,#00h		;74AB:	2600
	RET				;

LAB_74AE				; (LAB_D973)
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;74B2:	5E
	LD	D,#00h		; clear high byte
	LD	HL,00A8h	;74B5:	21A800
	CALL	LAB_E0E7		; does CP DE,HL, returns HL=0 & Zb=1 if no carry (HL<=DE)
					; (LAB_7C22)
	JP	Z,LAB_D997	;74BB:	CA97D9 (LAB_74D2)

	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;74C2:	5E
	LD	D,#00h		; clear high byte
	LD	HL,LAB_E205	;74C5:	2105E2
	ADD	HL,DE		;74C8:	19
	LD	DE,LAB_FF80	;74C9:	1180FF
	ADD	HL,DE		;74CC:	19
	LD	E,(HL)		;74CD:	5E
	LD	D,#00h		; clear high byte
	EX	DE,HL		;74D0:	EB
	RET				;

LAB_74D2				; (LAB_D997)
	LD	HL,000Ch		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		;74D6:	5E
	LD	D,#00h		; clear high byte
	EX	DE,HL		;74D9:	EB
	RET				;

; copy count bytes from source to destination

; stack is ..
; source
; destination
; byte count
; end.

LAB_74DB				; (LAB_D9A0)
	PUSH	BC			; save BC
	LD	HL,0009h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 3 before call
	LD	B,(HL)		; get byte count high byte
	DEC	HL			; decrement pointer
	LD	C,(HL)		; get byte count low byte
	DEC	HL			; decrement pointer
	LD	A,B			; copy high byte
	OR	C			; OR low byte
	JP	NZ,LAB_D9B0		; jump if count not zero (LAB_74EB)

	POP	BC			; restore BC
	RET				;

LAB_74EB				; (LAB_D9B0)
	LD	D,(HL)		; get destination high byte
	DEC	HL			; decrement pointer
	LD	E,(HL)		; get destination low byte
	DEC	HL			; decrement pointer
	LD	A,(HL)		; get source high byte
	DEC	HL			; decrement pointer
	LD	L,(HL)		; get source low byte
	LD	H,A			; copy source high byte to H
	CP	D			; compare source high byte with destination high byte
	JP	C,LAB_D9DD		; jump if destination > source (LAB_7518)

	JP	NZ,LAB_D9C7		; jump if destination = source (LAB_7502)

					; destination < source
	LD	A,L		;74FA:	7D
	CP	E		;74FB:	BB
	JP	C,LAB_D9DD	;74FC:	DADDD9 (LAB_7518)

	JP	Z,LAB_D9F7	;74FF:	CAF7D9 (LAB_7532)

LAB_7502
	XOR	A		;7502:	AF
	ADD	A,#03h		;7503:	C603
	JP	PE,LAB_D9D1	;7505:	EAD1D9 (LAB_750C)

	LDIR			;7508:	EDB0
	POP	BC			; restore BC
	RET				;

LAB_750C				; (LAB_D9D1)
	LD	A,(HL)		; get byte from source
	LD	(DE),A		; copy to destination
	INC	DE			; increment destination pointer
	INC	HL			; increment source pointer
	DEC	BC			; decrement byte count
	LD	A,B			; copy high byte
	OR	C			; OR low byte
	JP	NZ,LAB_D9D1		; loop if not all done (LAB_750C)

	POP	BC			; restore BC
	RET				;

; destination > source

LAB_7518				; (LAB_D9DD)
	ADD	HL,BC			; add byte count to source
	EX	DE,HL			; swap source & destination
	ADD	HL,BC			; add byte count to source
	XOR	A		;751B:	AF
	ADD	A,#03h		;751C:	C603
	JP	PE,LAB_D9ED	;751E:	EAEDD9 (LAB_7528)

	EX	DE,HL		;7521:	EB
	DEC	DE		;7522:	1B
	DEC	HL		;7523:	2B
	LDDR			;7524:	EDB8
	POP	BC			; restore BC
	RET				;

LAB_7528				; (LAB_D9ED)
	DEC	DE		;7528:	1B
	DEC	HL		;7529:	2B
	LD	A,(DE)		;752A:	1A
	LD	(HL),A		;752B:	77
	DEC	BC		;752C:	0B
	LD	A,B		;752D:	78
	OR	C		;752E:	B1
	JP	NZ,LAB_D9ED	;752F:	C2EDD9 (LAB_7528)

LAB_7532				; (LAB_D9F7)
	POP	BC			; restore BC
	RET				;

LAB_7534				; (LAB_D9F9)
	POP	DE		;7534:	D1
	EX	(SP),HL		;7535:	E3
	PUSH	DE		;7536:	D5
	LD	A,(HL)		;7537:	7E
	LD	(HL),E		;7538:	73
	LD	E,A		;7539:	5F
	INC	HL		;753A:	23
	LD	A,(HL)		;753B:	7E
	LD	(HL),D		;753C:	72
	LD	D,A		;753D:	57
	OR	E		;753E:	B3
	EX	DE,HL		;753F:	EB
	RET	Z		;7540:	C8
	EX	(SP),HL		;7541:	E3
	LD	HL,0001h	;7542:	210100
	RET				;

; do BDOS function call
;
; stack is ..
;
; word function number
; word parameter (if any)
; end.
;
; returns 16 bit result in HL, 8 bit result in E (D=0)

LAB_7546				; (LAB_DA0B)
	CALL	LAB_D86E		; copies last 3 words from stack to LAB_E0FE,
					; calls rest of subroutine then does RET
					; after putting (HL=0) in Z (LAB_721D)
	CALL	LAB_DA16		; go do BDOS call (LAB_7551)
	EX	DE,HL			; swap DE & HL
	RET				;

; do BDOS function call
;
; stack is ..
;
; word function number
; word parameter (if any)
; end.
;
; returns 16 bit result in DE, 8 bit result in L (H=0)

LAB_754E				; (LAB_DA13)*
	CALL	LAB_D86E		; copies last 3 words from stack to LAB_E0FE,
					; calls rest of subroutine then does RET
					; after putting (HL=0) in Z (LAB_721D)
LAB_7551				; (LAB_DA16)
	LD	HL,(LAB_E0FE)	; get last pushed word
	LD	B,H			; copy word ...
	LD	C,L			; ... to BC
	LD	HL,(LAB_E100)	; get last pushed but 1
	EX	DE,HL			; swap into DE
	CALL	LAB_0005		; do BDOS function call
	EX	DE,HL			; exchange 16 bit result to DE
	LD	L,A			; copy 8 bit result to L
	XOR	A			; clear A
	LD	H,A			; clear H
	RET				;

; do BIOS function, result in HL

; stack is ..
; function #
; value #1 (BC)
; value #2 (DE)
; end.

LAB_7562				; (LAB_DA27)
	CALL	LAB_D86E		; copies last 3 words from stack to LAB_E0FE,
					; calls rest of subroutine then does RET
					; after putting (HL=0) in Z (LAB_721D)
	CALL	LAB_DA34		; do BIOS function (LAB_756F)
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	RET				;

; do BIOS function

; stack is ..
; function #
; value #1 (BC)
; value #2 (DE)
; end.

LAB_756C				; (LAB_DA31)
	CALL	LAB_D86E		; copies last 3 words from stack to LAB_E0FE,
					; calls rest of subroutine then does RET
					; after putting (HL=0) in Z (LAB_721D)
LAB_756F				; (LAB_DA34)
	LD	HL,(LAB_E0FE)	; get last pushed
	EX	DE,HL			; swap to DE
	LD	HL,(LAB_0001)	; get reset jump address
	DEC	HL			; -1
	DEC	HL			; -2
	DEC	HL			; -3 (now at start of jump table)
	ADD	HL,DE			; +DE
	ADD	HL,DE			; +DE
	ADD	HL,DE			; +DE (now points to start +3DE)
	EX	DE,HL			; swap function #DE addr to DE
	LD	HL,(LAB_E100)	; get last pushed but 1
	LD	B,H			; copy to ..
	LD	C,L			; .. BC
	LD	HL,(LAB_E102)	; get last pushed but 2
	EX	DE,HL			; swap to DE
	JP	(HL)			; jump to function #DE

; stack is ..
; ?? pointer0
; ?? pointer1
; end.

					; clear first byte (@ pointer1)

LAB_7587				; (LAB_DA4C)
	PUSH	BC			; save BC
	LD	HL,0004h		; offset to return addr-1
	ADD	HL,SP			; point to return-1
	LD	C,(HL)		; get last pushed (low) before call
	INC	HL			; increment pointer
	LD	B,(HL)		; get last pushed (high) before call
	INC	HL			; increment pointer
	LD	E,(HL)		; get last pushed-1 (low) before call
	INC	HL			; increment pointer
	LD	D,(HL)		; get last pushed-1 (high) before call
	LD	L,E			; copy DE ..
	LD	H,D			; .. to HL
	LD	(HL),#00h		; clear byte
	INC	HL			; increment pointer1

					; set next 0Bh bytes to ' '
	LD	A,#0Bh		; 0Bh spaces to do
LAB_759A
	LD	(HL),#20h		; save ' '
	INC	HL			; increment pointer1
	DEC	A			; decrement count
	JP	NZ,LAB_DA5F		; loop if not all done (LAB_759A)

					; clear next 04h bytes
	LD	A,#04h		; 04 bytes to do
LAB_75A3
	LD	(HL),#00h		; clear byte
	INC	HL			; increment pointer1
	DEC	A			; decrement count
	JP	NZ,LAB_DA68		; loop if not all done (LAB_75A3)

	EX	DE,HL			; swap pointer1+ to DE, original pointer1 to HL
	LD	A,C			; get pointer0 low
	OR	B			; OR with pointer0 high
	JP	Z,LAB_DB10		; jump if null (LAB_764B)

					; pointer0 wasn't null
LAB_75B0
	LD	A,(BC)		; get byte from pointer0
	CP	#20h			; compare with ' '
	JP	Z,LAB_DA80		; skip if space (LAB_75BB)

	CP	#09h			; compare with [TAB]
	JP	NZ,LAB_DA84		; go do convert if not [TAB] (LAB_75BF)

LAB_75BB				; (LAB_DA80)
	INC	BC			; increment pointer0
	JP	LAB_DA75		; loop (LAB_75B0)

LAB_75BF				; (LAB_DA84)
	PUSH	BC			; save pointer0
	LD	D,#00h		; clear total so far
LAB_75C2
	LD	A,(BC)		; get byte (again)
	CALL	LAB_DB29		; return carry clear if A is '0' to '9' (LAB_7664)
	JP	C,LAB_DA9D		; jump if not number (LAB_75D8)

	SUB	#30h			; convert to 0 - 9
	LD	E,A			; copy to E
	LD	A,D			; copy last digit
	ADD	A,A			; *2
	ADD	A,A			; *4
	ADD	A,A			; *8
	ADD	A,D			; *9
	ADD	A,D			; *10

; (this is 1 byte shorter!)

;	ADD	A,A			; *2
;	ADD	A,A			; *4
;	ADD	A,D			; *5
;	ADD	A,A			; *10

	ADD	A,E			; add this digit
	LD	D,A			; copy to D
	INC	BC			; increment pointer0
	JP	LAB_DA87		; loop for next (LAB_75C2)

					; found end of number
LAB_75D8				; (LAB_DA9D)
	CP	#2Fh			; compare with '/'
	JP	NZ,LAB_DAA7		; jump if not '/' (LAB_75E2)

					; chr was '/'
	INC	BC			; increment pointer0
	POP	AF			; dump saved pointer0
	JP	LAB_DAAA	;75DF:	C3AADA (LAB_75E5)

LAB_75E2				; (LAB_DAA7)
	POP	BC			; restore pointer0
	LD	D,#FFh		; set total=-1 ??
LAB_75E5				; (LAB_DAAA)
	INC	BC			; increment pointer0
	LD	A,(BC)		; get next chr
	CP	#3Ah			; compare with ':'
	DEC	BC			; decrement pointer0
	LD	A,#00h		; clear A
	JP	NZ,LAB_DAD5		; jump if not ':' (LAB_7610)

					; get chr before ':'
	LD	A,(BC)		; get chr
	AND	#7Fh			; clear top bit
	CP	#41h			; compare with 'A'
	JP	C,LAB_DB10		; jump if less (LAB_764B)

	CP	#5Bh			; compare with ('Z'+1)
	JP	NC,LAB_DAC6		; jump if >= (LAB_7601)

	SUB	#40h			; else convert 'A'-'Z' to 1-26
	JP	LAB_DAD2		; jump (LAB_760D)

LAB_7601				; (LAB_DAC6)
	CP	#61h			; compare with 'a'
	JP	C,LAB_DB10		; jump if less (LAB_764B)
	CP	#7Bh			; compare with ('z'+1)
	JP	NC,LAB_DB10		; jump if >= (LAB_764B)
	SUB	#60h			; else convert 'a'-'z' to 1-26
LAB_760D				; (LAB_DAD2)
	LD	(HL),A		;760D:	77
	INC	BC		;760E:	03
	INC	BC		;760F:	03
LAB_7610				; (LAB_DAD5)
	INC	HL		;7610:	23
	LD	E,#08h		;7611:	1E08
LAB_7613				; (LAB_DAD8)
	INC	E		;7613:	1C
LAB_7614				; (LAB_DAD9)
	LD	A,(BC)		; get chr
	INC	BC			; increment pointer0
	CP	#2Eh			; compare with '.'
	JP	Z,LAB_DAF0		; jump if '.' (LAB_762B)

	OR	A			; set the flags
	JP	Z,LAB_DB09		; jump if null (LAB_7644)

	DEC	E		;761F:	1D
	JP	Z,LAB_DAD8	;7620:	CAD8DA (LAB_7613)

	CALL	LAB_DB17		; convert to [UC] else make '*' = '?' & dec BC (LAB_7652)
	LD	(HL),A		;7626:	77
	INC	HL		;7627:	23
	JP	LAB_DAD9	;7628:	C3D9DA (LAB_7614)

LAB_762B				; (LAB_DAF0)
	DEC	E		;762B:	1D
	LD	A,E			; copy E
	ADD	A,L			; add to L
	LD	L,A			; result to L
	LD	A,H			; copy H
	ADC	A,#00h		; add cary in
	LD	H,A			; result to H
	LD	E,#03h		;7633:	1E03
LAB_7635				; (LAB_DAFA)
	LD	A,(BC)		; get byte
	INC	BC			; increment pointer
	OR	A			; set the flags
	JP	Z,LAB_DB09		; jump if zero (LAB_7644)

	CALL	LAB_DB17		; convert to [UC] else make '*' = '?' & dec BC (LAB_7652)
	LD	(HL),A		; save result
	INC	HL			; increment pointer
	DEC	E			; decrement count
	JP	NZ,LAB_DAFA		; loop until all done (LAB_7635)

LAB_7644				; (LAB_DB09)
	LD	H,#00h		;7644:	2600
	LD	L,D		;7646:	6A
	LD	A,D		;7647:	7A
	OR	A			; set the flags
	POP	BC			; restore BC
	RET				;

LAB_764B				; (LAB_DB10)
	LD	HL,FFFFh		; set HL
	LD	A,H			; set A
	OR	A			; set the flags
	POP	BC			; restore BC
	RET				;

; convert to [UC] else make '*' = '?' & dec BC

LAB_7652				; (LAB_DB17)
	CP	#2Ah			; compare with '*'
	JP	NZ,LAB_DB20		; jump if not '*' (LAB_765B)

	DEC	BC			;7657:	0B
	LD	A,#3Fh		; make A = '?'
	RET				;

LAB_765B				; (LAB_DB20)
	CP	#61h			; compare with 'a'
	RET	C			; return if less

	CP	#7Bh			; compare with ('z'+1)
	RET	NC			; return if >=

	SUB	#20h			; convert to upper case
	RET				;

; return carry clear if A is '0' to '9'

LAB_7664				; (LAB_DB29)
	CP	#30h			; compare with '0'
	RET	C			; return if less
	CP	#3Ah			; compare with ('9'+1)
	JP	NC,LAB_DB33		; jump if >= (LAB_766E)
	OR	A			; else clear carry (not needed!)
	RET				;

LAB_766E				; (LAB_DB33)
	SCF				; set carry
	RET				;

; compare string 1 & string 2 until a difference is found
; or string 1 terminates

; stack is ..
; string 1 pointer
; string 2 pointer
; end.

LAB_7670				; (LAB_DB35)
	LD	HL,0005h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 1 before call
	PUSH	BC			; save BC
	LD	BC,7FFFh		; set count to max
	JP	LAB_DB49	;7678:	C349DB (LAB_7684)

; compare string 1 & string 2 until a difference is found,
; string 1 terminates or byte count is reached

; stack is ..
; string 1 pointer
; string 2 pointer
; byte count
; end.

LAB_767B				; (LAB_DB40)
	LD	HL,0007h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 1 before call
	PUSH	BC			; save BC
	LD	B,(HL)		; get byte count high byte
	DEC	HL			; decrement pointer
	LD	C,(HL)		; get byte count low byte
	DEC	HL			; decrement pointer
LAB_7684				; (LAB_DB49)
	LD	D,(HL)		; get string 2 pointer high byte
	DEC	HL			; decrement pointer
	LD	E,(HL)		; get string 2 pointer low byte
	DEC	HL			; decrement pointer
	LD	A,(HL)		; get string 1 pointer high byte
	DEC	HL			; decrement pointer
	LD	L,(HL)		; get string 1 pointer low byte
	LD	H,A			; copy high byte to H
	EX	DE,HL			; swap pointer 1 & 2
LAB_768D				; (LAB_DB52)
	LD	A,B			; get byte count high
	OR	C			; OR with byte count low
	JP	Z,LAB_DB67		; exit if at end (LAB_76A2)

	LD	A,(DE)		; get string 1 byte
	SUB	(HL)			; compare with string 2 byte
	JP	NZ,LAB_DB67		; exit if different (LAB_76A2)

	LD	A,(DE)		; get string 1 byte
	OR	A			; set the flags
	JP	Z,LAB_DB67		; exit if at end (LAB_76A2)

	INC	DE			; else increment string 1 pointer
	INC	HL			; increment string 2 pointer
	DEC	BC			; decrement byte count
	JP	LAB_DB52		; go do next (LAB_768D)

LAB_76A2				; (LAB_DB67)
	POP	BC			; restore BC
	LD	L,A			; copy result byte to L
	SBC	A,A			; clear A
	LD	H,A			; clear H
	OR	L			; result to A & set the flags
	RET				;

; copy null terminated string from source to destination

; stack is ..
; destination pointer
; source pointer
; end

LAB_76A8				; (LAB_DB6D)
	LD	HL,0005h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 1 before call
	LD	D,(HL)		; get source pointer high byte
	DEC	HL			; decrement pointer
	LD	E,(HL)		; get source pointer low byte
	DEC	HL			; decrement pointer
	LD	A,(HL)		; get destination pointer high byte
	DEC	HL			; decrement pointer
	LD	L,(HL)		; get destination pointer low byte
	LD	H,A			; copy destination pointer high byte to H
	PUSH	HL			; save destination pointer
LAB_76B5
	LD	A,(DE)		; get byte from source
	LD	(HL),A		; copy to destination
	OR	A			; set the flags
	JP	Z,LAB_DB85		; jump if null (treminator) (LAB_76C0)

	INC	DE			; else increment source pointer
	INC	HL			; increment destination pointer
	JP	LAB_DB7A		; go do next (LAB_76B5)

LAB_76C0
	POP	HL			; restore destination start pointer
	LD	A,H			; set the flags
	OR	L			;
	RET				;

; copy byte count bytes of null terminated string
; from source to destination. pad with nulls if needed

; stack is ..
; destination pointer
; source pointer
; byte count
; end.

LAB_76C4				; (LAB_DB89)
	LD	HL,0007h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 2 before call
	PUSH	BC			; save BC
	LD	B,(HL)		; get byte count high byte
	DEC	HL			; decrement pointer
	LD	C,(HL)		; get byte count low byte
	DEC	HL			; decrement pointer
	LD	D,(HL)		; get source pointer high byte
	DEC	HL			; decrement pointer
	LD	E,(HL)		; get source pointer low byte
	DEC	HL			; decrement pointer
	LD	A,(HL)		; get destination pointer high byte
	DEC	HL			; decrement pointer
	LD	L,(HL)		; get destination pointer low byte
	LD	H,A			; copy high byte to H
	PUSH	HL			; save destination pointer
LAB_76D6				; (LAB_DB9B)
	LD	A,B			; get byte count high byte
	OR	C			; OR with low byte
	JP	Z,LAB_DBAC		; jump if all done (LAB_76E7)

	LD	A,(DE)		; get byte from source
	LD	(HL),A		; copy to destination 
	OR	A			; set the flags
	JP	Z,LAB_DBA7		; skip if end marker (null) (LAB_76E2)
					; (doesn't copy past end)
	INC	DE			; increment source pointer
LAB_76E2				; (LAB_DBA7)
	INC	HL			; increment destination pointer
	DEC	BC			; decrement byte count
	JP	LAB_DB9B		; go do next (LAB_76D6)

LAB_76E7				; (LAB_DBAC)
	POP	HL			; restore destination pointer
	POP	BC			; restore BC
	LD	A,H			; set the flags
	OR	L			;
	RET				;

; append null terminated string from
; source to destination

; stack is ..
; destination pointer
; source pointer
; end.

LAB_76EC				; (LAB_DBB1)
	LD	HL,0005h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 1 before call
	PUSH	BC			; save BC
	LD	BC,7FFFh		; set BC to max count
	JP	LAB_DBC5		; go do rest (LAB_7700)

; copy byte count bytes of null terminated string
; from source to next free destination

; stack is ..
; destination pointer
; source pointer
; byte count
; end.

LAB_76F7				; (LAB_DBBC)
	LD	HL,0007h		; pointer past junk from above
	ADD	HL,SP			; get last pushed but 2 before call
	PUSH	BC			; save BC
	LD	B,(HL)		; get byte count high byte
	DEC	HL			; decrement pointer
	LD	C,(HL)		; get byte count low byte
	DEC	HL			; decrement pointer
LAB_7700				; (LAB_DBC5)
	LD	D,(HL)		; get source pointer high byte
	DEC	HL			; decrement pointer
	LD	E,(HL)		; get source pointer low byte
	DEC	HL			; decrement pointer
	LD	A,(HL)		; get destination pointer high byte
	DEC	HL			; decrement pointer
	LD	L,(HL)		; get destination pointer low byte
	LD	H,A			; copy high byte to H
	PUSH	HL			; save destination pointer
	XOR	A			; clear A
LAB_770A				; (LAB_DBCF)
	CP	(HL)			; compare with destination byte
	JP	Z,LAB_DBD7		; jump if empty (LAB_7712)

	INC	HL			; else increment destination pointer
	JP	LAB_DBCF		; go check next byte (LAB_770A)

LAB_7712				; (LAB_DBD7)
	LD	A,B			; get byte count low byte
	OR	C			; OR with high byte
	JP	Z,LAB_DBE8		; exit if done (LAB_7723)

	LD	A,(DE)		; get source byte
	LD	(HL),A		; copy to destination
	OR	A			; set the flags
	JP	Z,LAB_DBE8		; exit if end marker (null) (LAB_7723)

	INC	DE			; else increment source pointer
	INC	HL			; increment destination pointer
	DEC	BC			; decrement byte count
	JP	LAB_DBD7		; go do next (LAB_7712)

LAB_7723				; (LAB_DBE8)
	LD	(HL),A		; ensure null end is saved
	POP	HL			; restore destination pointer
	POP	BC			; restore BC
	LD	A,H			; set the flags
	OR	L			;
	RET				;

; search for null byte from pointer
; returns offset to null in HL

; stack is
; pointer
; end.

LAB_7729				; (LAB_DBEE)
	LD	HL,0002h		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	A,(HL)		; get pointer low byte
	INC	HL			; increment pointer
	LD	H,(HL)		; get pointer high byte
	LD	L,A			; copy low byte to L
	LD	DE,0000h		; clear count
	XOR	A			; set compare byte
LAB_7735				; (LAB_DFBA)
	CP	(HL)			; is byte null
	JP	Z,LAB_DC03		; exit if so (LAB_773E)

	INC	DE			; else increment count
	INC	HL			; increment pointer
	JP	LAB_DBFA		; loop (LAB_7735)

LAB_773E				; (LAB_DC03)
	EX	DE,HL			; swap count to HL
	LD	A,L			; copy low byte
	OR	H			; OR with high byte
	RET				;

; fill count bytes, from destination, with byte

; stack is ..
; destination
; count
; fill byte (byte)
; end.

LAB_7742				; (LAB_DC07)
	PUSH	BC			; save BC
	LD	HL,0004h		; pointer past junk from above
	ADD	HL,SP			; get last pushed before call
	LD	E,(HL)		; get destination low byte
	INC	HL			; increment pointer
	LD	D,(HL)		; get destination high byte
	INC	HL			; increment pointer
	LD	C,(HL)		; get byte count low byte
	INC	HL			; increment pointer
	LD	B,(HL)		; get byte count high byte
	INC	HL			; increment pointer
	LD	L,(HL)		; get fill byte
	EX	DE,HL			; swap destination to HL
LAB_7751				; (LAB_DC16)
	LD	A,B			; get byte count high byte
	OR	C			; OR with byte count high byte
	JP	Z,LAB_DC21		; exit if all done (LAB_775C)

	LD	(HL),E		; else fill byte
	INC	HL			; increment pointer
	DEC	BC			; decrement byte count
	JP	LAB_DC16		; go do next (LAB_7751)

LAB_775C				; (LAB_DC21)
	POP	BC			; restore BC
	RET				;

; copies next four bytes after the call to LAB_E3B9
; returns to instruction after the bytes

LAB_775E				; (LAB_DC23)
	POP	DE			; pop return address
	LD	HL,0004h		; offset to add
	ADD	HL,DE			; add to return address
	PUSH	HL			; save new return address
	EX	DE,HL			; swap old return address to HL

; copies four bytes from (HL) to LAB_E3B9

LAB_7765				; (LAB_DC2A)
	LD	DE,LAB_E3B9		; set destination pointer
	JP	LAB_DC3A		; jump (LAB_7775)

; copies next four bytes after the call to LAB_E3B1 (#_1)
; returns to instruction after the bytes

LAB_776B				; (LAB_DC30)
	POP	DE			; pop return address
	LD	HL,0004h		; offset to add
	ADD	HL,DE			; add to return address
	PUSH	HL			; save new return address
	EX	DE,HL			; swap old return address to HL
	LD	DE,LAB_E3B1		; set destination pointer

; copies four bytes from (HL) to (DE)

LAB_7775				; (LAB_DC3A)
	LD	A,(HL)		; get byte from source
	LD	(DE),A		; copy to destination
	INC	DE			; increment destination pointer
	INC	HL			; increment source pointer
	LD	A,(HL)		; get byte from source
	LD	(DE),A		; copy to destination
	INC	DE			; increment destination pointer
	INC	HL			; increment source pointer
	LD	A,(HL)		; get byte from source
	LD	(DE),A		; copy to destination
	INC	DE			; increment destination pointer
	INC	HL			; increment source pointer
	LD	A,(HL)		; get byte from source
	LD	(DE),A		; copy to destination
	RET				;

; copies four bytes from LAB_E3B1 (#_1) to (HL)

LAB_7784				; (LAB_DC49)
	LD	DE,LAB_E3B1		; set source pointer
	LD	A,(DE)		; get byte from source
	LD	(HL),A		; copy to destination
	INC	HL			; increment destination pointer
	INC	DE			; increment source pointer
	LD	A,(DE)		; get byte from source
	LD	(HL),A		; copy to destination
	INC	HL			; increment destination pointer
	INC	DE			; increment source pointer
	LD	A,(DE)		; get byte from source
	LD	(HL),A		; copy to destination
	INC	HL			; increment destination pointer
	INC	DE			; increment source pointer
	LD	A,(DE)		; get byte from source
	LD	(HL),A		; copy to destination
	RET				;

; does push (LAB_E3B1).L

LAB_7796				; (LAB_DC5B)
	POP	DE			; pop return address
	LD	HL,LAB_E3B4		; dunno ???
	LD	HL,(LAB_E3B3)	; get #1 high word
	PUSH	HL			; push on stack
	LD	HL,(LAB_E3B1)	; get #_1 low word
	PUSH	HL			; push on stack
	EX	DE,HL			; swap return address to HL
	JP	(HL)			; do RET

; does pop (LAB_E3B9).L

LAB_77A4				; (LAB_DC69)
	POP	DE			; pop return address
	POP	HL			; pop low word
	LD	(LAB_E3B9),HL	; save to #2 low word
	POP	HL			; pop high word
	LD	(LAB_E3BB),HL	; save to #2 high word
	EX	DE,HL			; swap return address to HL
	JP	(HL)			; do RET

; swap (LAB_E3B1) with (LAB_E3B9)

LAB_77AF				; (LAB_DC74)
	LD	HL,(LAB_E3B9)	; get low word #2
	EX	DE,HL			; swap to DE
	LD	HL,(LAB_E3B1)	; get low word #1
	LD	(LAB_E3B9),HL	; save as low word #2
	EX	DE,HL			; get low word #2 back
	LD	(LAB_E3B1),HL	; save as low word #1
	LD	HL,(LAB_E3BB)	; get high word #2
	EX	DE,HL			; swap to DE
	LD	HL,(LAB_E3B3)	; get high word #1
	LD	(LAB_E3BB),HL	; save as high word #2
	EX	DE,HL			; get high word #2 back
	LD	(LAB_E3B3),HL	; save as high word #1
	RET				;

; does NEG.L (LAB_E3B1) #_1

LAB_77CC				; (LAB_DC91)
	LD	HL,LAB_E3B1		; point to #_1

; does NEG.L (HL)

LAB_77CF				; (LAB_DC94)
	XOR	A			; clear A & flags
	LD	D,#04h		; set count
LAB_77D2				; (LAB_DC97)
	LD	A,#00h		; clear A
	SBC	A,(HL)		; sub byte from number
	LD	(HL),A		; save result
	INC	HL			; increment pointer
	DEC	D			; decrement count
	JP	NZ,LAB_DC97		; loop until all done (LAB_77D2)

	RET				;

; does IF.L (LAB_E3B1)<>0

LAB_77DE				; (LAB_DCA3)
	LD	HL,LAB_E3B1		; point to #_1
	LD	D,#04h		; set count
LAB_77E1				; (LAB_DCA6)
	LD	A,(HL)		; get byte
	OR	A			; set the flags
	JP	NZ,LAB_DEE8		; set HL=0001h, flags to match & exit (LAB_7A23)
	INC	HL			; increment pointer
	DEC	D			; decrement count
	JP	NZ,LAB_DCA6		; loop until all done (LAB_77E1)

	JP	LAB_DEDD		; set HL=0000h, flags to match & exit (LAB_7A18)

LAB_77EE				; (LAB_DCB3)
	XOR	A			; clear A
	DEC	A			; set flags for CP result <
	POP	BC			; restore BC
	RET				;

LAB_77F2				; (LAB_DCB7)
	XOR	A			; clear A
	INC	A			; set flags for CP result >
	POP	BC			; restore BC
	RET				;

; do CP.L (LAB_E3B1),(LAB_E3B9) for -VE numbers

LAB_77F6				; (LAB_DCBB)
	PUSH	BC			; save BC
	LD	DE,LAB_E3B4		; point to #_1
	LD	HL,LAB_E3BC		; point to #_2
	LD	A,(HL)		; get byte from #_2
	XOR	#80h			; toggle top bit
	LD	C,A			; copy result
	LD	A,(DE)		; get byte from #_1
	XOR	#80h			; toggle top bit
	CP	C			; compare result with #_2
	LD	B,#04h		; set count
	JP	LAB_DCDA		; (LAB_7815)

; do CP.L (LAB_E3B1),(LAB_E3B9)

LAB_780A				; (LAB_DCCF)
	PUSH	BC			; save BC
	LD	DE,LAB_E3B4		; point to #_1
	LD	HL,LAB_E3BC		; point to #_2
	LD	B,#04h		; set count
LAB_7813				; (LAB_DCD8)
	LD	A,(DE)		; get byte from #_1
	CP	(HL)			; compare with byte in #_2
LAB_7815
	JP	C,LAB_DCB3		; if C go do CP result < (LAB_77EE)

	JP	NZ,LAB_DCB7		; if NZ go do CP result > (LAB_77F2)

	DEC	HL			; decrement pointer
	DEC	DE			; decrement pointer
	DEC	B			; decrement count
	JP	NZ,LAB_DCD8		; loop until done (LAB_7813)

	XOR	A			; clear A & set flags for CP result =
	POP	BC			; restore BC
	RET				;

; does ADC.L (LAB_E3B1),(LAB_E3B9)

LAB_7824				; (LAB_DCE9)
	PUSH	BC			; save BC
	LD	DE,LAB_E3B1		; point to #_1
	LD	HL,LAB_E3B9		; point to #_2
	XOR	A			; clear A & flags
	LD	B,#04h		; do 4 times
LAB_782E				; (LAB_DCF3)
	LD	A,(DE)		; get byte from #_1
	ADC	A,(HL)		; add byte from #_2
	LD	(DE),A		; save byte to #_1
	INC	HL			; increment pointer
	INC	DE			; increment pointer
	DEC	B			; decrement count
	JP	NZ,LAB_DCF3		; loop until done (LAB_782E) (could DJNZ !)

	POP	BC			; restore BC
	RET				;

; does SBC.L (LAB_E3B1),(LAB_E3B9)

LAB_7839				; (LAB_DCFE)
	PUSH	BC			; save BC
	LD	DE,LAB_E3B1		; point to #_1
	LD	HL,LAB_E3B9		; point to #_2
	XOR	A			; clear A & flags
	LD	B,#04h		; do 4 times
LAB_7843				; (LAB_DD08)
	LD	A,(DE)		; get byte from #_1
	SBC	A,(HL)		; sub byte from #_2
	LD	(DE),A		; save byte to #_1
	INC	HL			; increment pointer
	INC	DE			; increment pointer
	DEC	B			; decrement count
	JP	NZ,LAB_DD08		; loop until done (LAB_7843) (could DJNZ !)
	POP	BC			; restore BC
	RET				;

; does AND.L (LAB_E3B1),(LAB_E3B9)

LAB_784E				; (LAB_DD13)
	PUSH	BC			; save BC
	LD	DE,LAB_E3B1		; point to #_1
	LD	HL,LAB_E3B9		; point to #_2
	LD	B,#04h		; do 4 times
LAB_7857				; (LAB_DD1C)
	LD	A,(DE)		; get byte from #_1
	AND	(HL)			; AND byte from #_2
	LD	(DE),A		; save byte to #_1
	INC	HL			; increment pointer
	INC	DE			; increment pointer
	DEC	B			; decrement count
	JP	NZ,LAB_DD1C		; loop until done (LAB_7857) (could DJNZ !)
	POP	BC			; restore BC
	RET				;

; does OR.L (LAB_E3B1),(LAB_E3B9)

LAB_7862				; (LAB_DD27)
	PUSH	BC			; save BC
	LD	DE,LAB_E3B1		; point to #_1
	LD	HL,LAB_E3B9		; point to #_2
	LD	B,#04h		; do 4 times
LAB_786B				; (LAB_DD30)
	LD	A,(DE)		; get byte from #_1
	OR	(HL)			; OR byte from #_2
	LD	(DE),A		; save byte to #_1
	INC	HL			; increment pointer
	INC	DE			; increment pointer
	DEC	B			; decrement count
	JP	NZ,LAB_DD30		; loop until done (LAB_786B) (could DJNZ !)
	POP	BC			; restore BC
	RET				;

; does XOR.L (LAB_E3B1),(LAB_E3B9)

LAB_7876				; (LAB_DD3B)
	PUSH	BC			; save BC
	LD	DE,LAB_E3B1		; point to #_1
	LD	HL,LAB_E3B9		; point to #_2
	LD	B,#04h		; do 4 times
LAB_787F				; (LAB_DD44)
	LD	A,(DE)		; get byte from #_1
	XOR	(HL)			; XOR byte from #_2
	LD	(DE),A		; save byte to #_1
	INC	HL			; increment pointer
	INC	DE			; increment pointer
	DEC	B			; decrement count
	JP	NZ,LAB_DD44		; loop until done (LAB_787F) (could DJNZ !)
	POP	BC			; restore BC
	RET				;

; does CPL.L (LAB_E3B1)

LAB_788A				; (LAB_DD4F)
	LD	HL,LAB_E3B1		; point to #_1
	LD	D,#04h		; do 4 times
LAB_788F				; (LAB_DD54)
	LD	A,(HL)		; get byte from #_1
	CPL				; complement byte
	LD	(HL),A		; save byte to #_1
	INC	HL			; increment pointer
	DEC	D			; decrement count
	JP	NZ,LAB_DD54		; loop until done (LAB_788F)
	RET				;

; does (LAB_E3B1)<<(LAB_E3B9)

LAB_7898				; (LAB_DD5D)
	LD	A,(LAB_E3B9)	; get #_2 LSB
	AND	#3Fh			; mask max ??
	RET	Z			; RET if no shift to do

	LD	HL,(LAB_E3B1)	; get #_1 low word
	EX	DE,HL			; swap to DE
	LD	HL,(LAB_E3B3)	; get #_1 high word
LAB_78A5
	ADD	HL,HL			; do << high word
	EX	DE,HL			; swap high word <> low word
	ADD	HL,HL			; do << low word
	EX	DE,HL			; swap high word <> low word
	JP	NC,LAB_DD72		; skip increment high if Cb=0 (LAB_78AD)

	INC	L			; increment high word
LAB_78AD
	DEC	A			; decrement << count
	JP	NZ,LAB_DD6A		; loop if not done (LAB_78A5)

	LD	(LAB_E3B3),HL	; save #_1 high word
	EX	DE,HL			; swap low word to HL
	LD	(LAB_E3B1),HL	; save #_1 low word
	RET				;

; does #_1 >> #_2

LAB_78B9				; (LAB_DD7E)
	JP	LAB_DD85	;78B9:	C385DD (LAB_78C0)

; does #_1 >> #_2

LAB_78BC				; (LAB_DD81)
	LD	A,(LAB_E3B4)	; get high byte #_1
	RLA				; copy top bit into carry
LAB_78C0				; (LAB_DD85)
	PUSH	AF			; save A
	LD	A,(LAB_E3B9)	; get #_2 low byte
	AND	#3Fh			; max mask ??
	JP	Z,LAB_DDA2		; exit if no ?? (LAB_78DD)
	LD	D,A			; copy ?? #
	LD	HL,LAB_E3B4		; point to high byte #_1
	LD	E,#04h		; 4 bytes to do
	POP	AF			; get #_1 byte back
	PUSH	AF			; copy it
LAB_78D1
	LD	A,(HL)		; get #_1 byte
	RRA				; >>
	LD	(HL),A		; save #_1 byte
	DEC	HL			; decrement to next byte
	DEC	E			; decrement byte count
	JP	NZ,LAB_DD96		; loo if not all done (LAB_78D1)

	DEC	D			; decrement >> count
	JP	NZ,LAB_DD8F		; loop if not all done (LAB_78CA)

LAB_78DD
	POP	AF			; restore A
	RET				;

; does ABS (DE)

LAB_78DF				; (LAB_DDA4)
	LD	HL,0003h		; offset to high byte
	ADD	HL,DE			; add to pointer
	LD	C,(HL)		; get high byte
	LD	A,C			; copy it
	OR	A			; set the flags
	RET	P			; exit if +ve

	EX	DE,HL			; else swap pointer to HL
	JP	LAB_DC94		; go do NEG.L (HL) (LAB_77CF)

LAB_78EB				; (LAB_DDB0)
	PUSH	BC			; save BC
	LD	DE,LAB_E3B1	;78EC:	11B1E3
	CALL	LAB_DDA4	;78EF:	CDA4DD (LAB_78DF)
	PUSH	BC			; save BC
	LD	DE,LAB_E3B9	;78F3:	11B9E3
	CALL	LAB_DDA4	;78F6:	CDA4DD (LAB_78DF)
	LD	A,C		;78F9:	79
	POP	BC			; restore BC
	XOR	C		;78FB:	A9
	PUSH	AF			; save AF
	CALL	LAB_DE10	;78FD:	CD10DE (LAB_794B)
	POP	AF			; restore AF
	POP	BC			; restore BC
	JP	M,LAB_DC91	;7902:	FA91DC (LAB_77CC); NEG.L #_1
	RET				;

LAB_7906				; (LAB_DDCB)
	PUSH	BC		;7906:	C5
	LD	DE,LAB_E3B1	;7907:	11B1E3
	CALL	LAB_DDA4	;790A:	CDA4DD (LAB_78DF)
	LD	A,C		;790D:	79
	OR	A		;790E:	B7
	PUSH	AF		;790F:	F5
	LD	DE,LAB_E3B9	;7910:	11B9E3
	CALL	LAB_DDA4	;7913:	CDA4DD (LAB_78DF)
	CALL	LAB_DE10	;7916:	CD10DE (LAB_794B)
	LD	DE,LAB_E3B5	;7919:	11B5E3
	LD	HL,LAB_E3B1		; point to #1
	LD	B,#04h		;791F:	0604
LAB_7921				; (LAB_DDE6)
	LD	A,(DE)		;7921:	1A
	LD	(HL),A		;7922:	77
	INC	DE		;7923:	13
	INC	HL		;7924:	23
	DEC	B		;7925:	05
	JP	NZ,LAB_DDE6	;7926:	C2E6DD (LAB_7921)

	POP	AF		;7929:	F1
	POP	BC		;792A:	C1
	JP	M,LAB_DC91	;792B:	FA91DC (LAB_77CC)
	RET				;

LAB_792F				; (LAB_DDF4)
	PUSH	BC		;792F:	C5
	CALL	LAB_DE10	;7930:	CD10DE (LAB_794B)
	POP	BC		;7933:	C1
	RET				;

LAB_7935				; (LAB_DDFA)
	PUSH	BC		;7935:	C5
	CALL	LAB_DE10	;7936:	CD10DE (LAB_794B)
	LD	DE,LAB_E3B5		; point to #2
	LD	HL,LAB_E3B1		; point to #1
	LD	B,#04h		;793F:	0604
LAB_7941				; (LAB_DE06)
	LD	A,(DE)		;7941:	1A
	LD	(HL),A		;7942:	77
	INC	DE		;7943:	13
	INC	HL		;7944:	23
	DEC	B		;7945:	05
	JP	NZ,LAB_DE06	;7946:	C206DE (LAB_7941)

	POP	BC		;7949:	C1
	RET				;

LAB_794B				; (LAB_DE10)
	LD	B,#04h		; 4 bytes to do
	LD	HL,LAB_E3B5		; point to #2
	XOR	A			; clear A
LAB_7951				; (LAB_DE16)
	LD	(HL),A		; clear byte
	INC	HL			; increment pointer
	DEC	B			; decrement count
	JP	NZ,LAB_DE16		; loop if not all done (LAB_7951)

	LD	A,#20h		;7957:	3E20
LAB_7959				; (LAB_DE1E)
	PUSH	AF		;7959:	F5
	LD	HL,LAB_E3B1		; point to #1
	LD	B,#08h		;795D:	0608
	OR	A		;795F:	B7
LAB_7960				; (LAB_DE25)
	LD	A,(HL)		;7960:	7E
	ADC	A,A		;7961:	8F
	LD	(HL),A		;7962:	77
	INC	HL		;7963:	23
	DEC	B		;7964:	05
	JP	NZ,LAB_DE25	;7965:	C225DE (LAB_7960)

	SBC	A,A		;7968:	9F
	AND	#01h		;7969:	E601
	LD	C,A		;796B:	4F
	LD	B,#04h		;796C:	0604
	LD	DE,LAB_E3B5		; point to #2
	LD	HL,LAB_E3B9	;7971:	21B9E3
	OR	A		;7974:	B7
LAB_7975				; (LAB_DE3A)
	LD	A,(DE)		;7975:	1A
	SBC	A,(HL)		;7976:	9E
	LD	(DE),A		;7977:	12
	INC	DE		;7978:	13
	INC	HL		;7979:	23
	DEC	B		;797A:	05
	JP	NZ,LAB_DE3A	;797B:	C23ADE (LAB_7975)

	LD	A,C		;797E:	79
	SBC	A,#00h		;797F:	DE00
	JP	NZ,LAB_DE53	;7981:	C253DE (LAB_798E)

	LD	HL,LAB_E3B1		; point to #1
	INC	(HL)		;7987:	34
	POP	AF		;7988:	F1
	DEC	A		;7989:	3D
	JP	NZ,LAB_DE1E	;798A:	C21EDE (LAB_7959)
	RET				;

LAB_798E				; (LAB_DE53)
	POP	AF		;798E:	F1
	DEC	A		;798F:	3D
	JP	Z,LAB_DE84	;7990:	CA84DE (LAB_79BF)

	PUSH	AF		;7993:	F5
	LD	HL,LAB_E3B1		; point to #1
	LD	B,#08h		;7997:	0608
	OR	A		;7999:	B7
LAB_799A				; (LAB_DE5F)
	LD	A,(HL)		;799A:	7E
	ADC	A,A		;799B:	8F
	LD	(HL),A		;799C:	77
	INC	HL		;799D:	23
	DEC	B		;799E:	05
	JP	NZ,LAB_DE5F	;799F:	C25FDE (LAB_799A)

	SBC	A,A		;79A2:	9F
	LD	C,A		;79A3:	4F
	LD	B,#04h		;79A4:	0604
	LD	DE,LAB_E3B5		; point to #2
	LD	HL,LAB_E3B9	;79A9:	21B9E3
	OR	A		;79AC:	B7
LAB_79AD				; (LAB_DE72)
	LD	A,(DE)		;79AD:	1A
	ADC	A,(HL)		;79AE:	8E
	LD	(DE),A		;79AF:	12
	INC	DE		;79B0:	13
	INC	HL		;79B1:	23
	DEC	B		;79B2:	05
	JP	NZ,LAB_DE72	;79B3:	C272DE (LAB_79AD)

	LD	A,C		;79B6:	79
	ADC	A,#00h		;79B7:	CE00
	JP	NZ,LAB_DE53	;79B9:	C253DE (LAB_978E)

	JP	LAB_DE49	;79BC:	C349DE (LAB_7984)

LAB_79BF				; (LAB_DE84)
	LD	B,#04h		;79BF:	0604
	LD	DE,LAB_E3B5		; point to #2
	LD	HL,LAB_E3B9	;79C4:	21B9E3
	OR	A		;79C7:	B7
LAB_79C8				; (LAB_DE8D)
	LD	A,(DE)		;79C8:	1A
	ADC	A,(HL)		;79C9:	8E
	LD	(DE),A		;79CA:	12
	INC	DE		;79CB:	13
	INC	HL		;79CC:	23
	DEC	B		;79CD:	05
	JP	NZ,LAB_DE8D		; loop until all done (LAB_79C8)

	RET				;

LAB_79D2				; (LAB_DE97)
	PUSH	BC			; save BC
	LD	HL,LAB_E3B1		; point to #1
	LD	B,#04h		; 4 bytes to do
	LD	DE,LAB_E3B5		; point to #2
LAB_79DB				; (LAB_DEA0)
	LD	A,(HL)		; get byte from #1
	LD	(DE),A		; save byte to #2
	LD	(HL),#00h		; clear byte #1
	INC	HL			; increment #1 pointer
	INC	DE			; increment #2 pointer
	DEC	B			; decrement count
	JP	NZ,LAB_DEA0		; loop if not all done (LAB_79DB)

	LD	A,#20h		;79E5:	3E20
LAB_79E7				; (LAB_DEAC)
	PUSH	AF		;79E7:	F5
	LD	HL,LAB_E3B1		; point to #1
	LD	B,#08h		;79EB:	0608
	OR	A		;79ED:	B7
LAB_79EE				; (LAB_DEB3)
	LD	A,(HL)		;79EE:	7E
	ADC	A,A		;79EF:	8F
	LD	(HL),A		;79F0:	77
	INC	HL		;79F1:	23
	DEC	B		;79F2:	05
	JP	NZ,LAB_DEB3	;79F3:	C2B3DE (LAB_79EE)
	JP	NC,LAB_DED0	;79F6:	D2D0DE (LAB_7A0B)
	LD	B,#04h		;79F9:	0604
	LD	DE,LAB_E3B1	;79FB:	11B1E3
	LD	HL,LAB_E3B9	;79FE:	21B9E3
	OR	A		;7A01:	B7
	LD	A,(DE)		;7A02:	1A
	ADC	A,(HL)		;7A03:	8E
	LD	(DE),A		;7A04:	12
	INC	DE		;7A05:	13
	INC	HL		;7A06:	23
	DEC	B		;7A07:	05
	JP	NZ,LAB_DEC7	;7A08:	C2C7DE (LAB_7A02)

LAB_7A0B				; (LAB_DED0)
	POP	AF		;7A0B:	F1
	DEC	A		;7A0C:	3D
	JP	NZ,LAB_DEAC	;7A0D:	C2ACDE (LAB_79E7)

	POP	BC		;7A10:	C1
	RET				;

; do signed IF (LAB_E3B1)=(LAB_E3B9)

LAB_7A12				; (LAB_DED7)
	CALL	LAB_DCBB		; do CP.L (LAB_E3B1),(LAB_E3B9) for -VE numbers (LAB_77F6)
	JP	Z,LAB_DEE8		; set HL=0001h, flags to match & exit (LAB_7A23)

; set HL=0000h, flags to match & exit

LAB_7A18				; (LAB_DEDD)
	LD	HL,0000h		; clear HL
	XOR	A			; clear A
	RET				;

; do signed IF (LAB_E3B1)<>(LAB_E3B9)

LAB_7A1D				; (LAB_DEE2)
	CALL	LAB_DCBB		; do CP.L (LAB_E3B1),(LAB_E3B9) for -VE numbers (LAB_77F6)
	JP	Z,LAB_DEDD		; set HL=0000h, flags to match & exit (LAB_7A18)

; set HL=0001h, flags to match & exit

LAB_7A23				; (LAB_DEE8)
	LD	HL,0001h		; set HL
	XOR	A			; clear A
	INC	A			; inc A & set flags
	RET				;

; do signed IF (LAB_E3B1)<(LAB_E3B9)

LAB_7A29				; (LAB_DEEE)
	CALL	LAB_DCBB		; do CP.L (LAB_E3B1),(LAB_E3B9) for -VE numbers (LAB_77F6)
	JP	M,LAB_DEE8		; set HL=0001h, flags to match & exit (LAB_7A23)
	JP	LAB_DEDD		; set HL=0000h, flags to match & exit (LAB_7A18)

; do signed IF (LAB_E3B1)<=(LAB_E3B9)

LAB_7A32				; (LAB_DEF7)
	CALL	LAB_DCBB		; do CP.L (LAB_E3B1),(LAB_E3B9) for -VE numbers (LAB_77F6)
	JP	M,LAB_DEE8		; set HL=0001h, flags to match & exit (LAB_7A23)
	JP	Z,LAB_DEE8		; set HL=0001h, flags to match & exit (LAB_7A23)
	JP	LAB_DEDD		; set HL=0000h, flags to match & exit (LAB_7A18)

; do signed IF (LAB_E3B1)>(LAB_E3B9)

LAB_7A3E				; (LAB_DF03)
	CALL	LAB_DCBB		; do CP.L (LAB_E3B1),(LAB_E3B9) for -VE numbers (LAB_77F6)
	JP	M,LAB_DEDD		; set HL=0000h, flags to match & exit (LAB_7A18)
	JP	LAB_DEE8		; set HL=0001h, flags to match & exit (LAB_7A23)

; do signed IF (LAB_E3B1)>=(LAB_E3B9)

LAB_7A47				; (LAB_DF0C)
	CALL	LAB_DCBB		; do CP.L (LAB_E3B1),(LAB_E3B9) for -VE numbers (LAB_77F6)
	JP	M,LAB_DEDD		; set HL=0000h, flags to match & exit (LAB_7A18)
	JP	Z,LAB_DEDD		; set HL=0000h, flags to match & exit (LAB_7A18)
	JP	LAB_DEE8		; set HL=0001h, flags to match & exit (LAB_7A23)

; do IF (LAB_E3B1)<(LAB_E3B9)

LAB_7A53				; (LAB_DF18)
	CALL	LAB_DCCF		; do CP.L (LAB_E3B1),(LAB_E3B9)	(LAB_780A)
	JP	M,LAB_DEE8		; set HL=0001h, flags to match & exit (LAB_7A23)
	JP	LAB_DEDD		; set HL=0000h, flags to match & exit (LAB_7A18)

; do IF (LAB_E3B1)<=(LAB_E3B9)

LAB_7A59				; (LAB_DF1E)
	CALL	LAB_DCCF		; do CP.L (LAB_E3B1),(LAB_E3B9)	(LAB_780A)
	JP	M,LAB_DEE8		; set HL=0001h, flags to match & exit (LAB_7A23)
	JP	Z,LAB_DEE8		; set HL=0001h, flags to match & exit (LAB_7A23)
	JP	LAB_DEDD		; set HL=0000h, flags to match & exit (LAB_7A18)

; do IF (LAB_E3B1)>(LAB_E3B9)

LAB_7A68				; (LAB_DF2D)
	CALL	LAB_DCCF		; do CP.L (LAB_E3B1),(LAB_E3B9)	(LAB_780A)
	JP	M,LAB_DEDD		; set HL=0000h, flags to match & exit (LAB_7A18)
	JP	LAB_DEE8		; set HL=0001h, flags to match & exit (LAB_7A23)

; do IF (LAB_E3B1)>=(LAB_E3B9)

LAB_7A71				; (LAB_DF36)
	CALL	LAB_DCCF		; do CP.L (LAB_E3B1),(LAB_E3B9)	(LAB_780A)
	JP	M,LAB_DEDD		; set HL=0000h, flags to match & exit (LAB_7A18)
	JP	Z,LAB_DEDD		; set HL=0000h, flags to match & exit (LAB_7A18)
	JP	LAB_DEE8		; set HL=0001h, flags to match & exit (LAB_7A23)

; save HL as unsigned integer @  LAB_E3B1

LAB_7A7D				; (LAB_DF42)
	LD	(LAB_E3B1),HL	; save HL as low word
LAB_7A80				; (LAB_DF45)
	LD	HL,0000h		; set HL
	LD	(LAB_E3B3),HL	; clear high word
	RET				;

; sign extend HL into LAB_E3B1

LAB_7A87				; (LAB_DF4C)
	LD	(LAB_E3B1),HL	; save HL as low word
	LD	A,H			; get high byte
	OR	A			; set the flags
	JP	P,LAB_DF45		; jump if +ve

	LD	HL,FFFFh		; else set HL to -1
	LD	(LAB_E3B3),HL	; set high word
	RET				;

; get unsigned integer from LAB_E3B1

LAB_7A96				; (LAB_DF5B)
	LD	HL,(LAB_E3B1)	;7A96:	2AB1E3
	RET				;

; do signed HL = DE/HL

LAB_7A9A				; (LAB_DF5F)
	LD	A,D			; get DE high byte
	XOR	H			; XOR HL high byte
	PUSH	AF			; save sign compare
	CALL	LAB_DF81		; do HL = ABS(DE) MOD ABS(HL), DE = ABS(DE)/ABS(HL)
					; (LAB_7ABC)
	EX	DE,HL			; div into HL
	POP	AF			; get sign compare
	JP	M,LAB_E09F		; if -ve do NEG HL & RET

	LD	A,L			; set the flags on div
	OR	H			;
	RET				;

; does HL = DE/HL, DE = DE MOD HL

LAB_7AA8				; (LAB_DF6D)
	CALL	LAB_DF97		; does HL = DE MOD HL, DE = DE/HL (LAB_7AD2)
	EX	DE,HL			; swap mod & div
	LD	A,L			; set the flags on div
	OR	H			;
	RET				;

; does signed HL = DE MOD HL

LAB_7AAF				; (LAB_DF74)
	LD	A,D			; get DE high byte
	PUSH	AF			; save it
	CALL	LAB_DF81		; do HL = ABS(DE) MOD ABS(HL), DE = ABS(DE)/ABS(HL)
					; (LAB_7ABC)
	POP	AF			; get DE high byte back
	OR	A			; set the flags
	JP	M,LAB_E09F		; if DE was -ve do NEG HL & RET

	LD	A,H			; else just set the flags
	OR	L			; for mod
	RET				;

; does HL = ABS(DE) MOD ABS(HL), DE = ABS(DE)/ABS(HL)

LAB_7ABC				;(LAB_DF81)
	LD	A,H			; get H
	OR	A			; set the flags
	JP	P,LAB_DF8C		; jump if HL is +ve (LAB_7AC7)

					; else twos complement HL
	CPL				; else complement high byte
	LD	H,A			; save it back
	LD	A,L			; copy low byte
	CPL				; complement it
	LD	L,A			; save it back
	INC	HL			; increment it

LAB_7AC7				; (LAB_DF8C)
	LD	A,D			; get D
	OR	A			; set the flags
	JP	P,LAB_DF97		; if +ve go do HL = DE MOD HL, DE = DE/HL (LAB_7AD2)

					; else twos complement DE
	CPL				; else complement high byte
	LD	D,A			; save it back
	LD	A,E			; copy low byte
	CPL				; complement it
	LD	E,A			; save it back
	INC	DE			; increment it

; does HL = DE MOD HL, DE = DE/HL

LAB_7AD2				; (LAB_DF97)
	PUSH	BC			; save BC
	LD	C,L			; copy L to C
	LD	B,H			; copy H to B
	LD	HL,0000h		; clear HL
	CALL	LAB_DFA4		; does HL = DE mod BC, DE = DE/BC (LAB_7ADF)
	POP	BC			; restore BC
	LD	A,L			; set the flags on mod
	OR	H			;
	RET				;

; does HL = DE mod BC, DE = DE/BC

LAB_7ADF				; (LAB_DFA4)
	LD	A,C			; copy C
	CPL				; complement it
	LD	C,A			; save C
	LD	A,B			; copy B
	CPL				; complement it
	LD	B,A			; save B
	INC	BC			; increment BC (BC = -BC)

	LD	A,#10h		; do 16d times
LAB_7AE8				; (LAB_DFAD)
	ADD	HL,HL			; shift remainder <<
	EX	DE,HL			; swap remainder and result/dividend
	ADD	HL,HL			; shift result/dividend <<
	EX	DE,HL			; swap result and result/dividend back
	JP	NC,LAB_DFB5		; jump if no overflow (LAB_7AF0)

	INC	L			; increment remainder
LAB_7AF0				; (LAB_DFB5)
	ADD	HL,BC			; subtract divisor
	JP	C,LAB_DFC6		; jump if result +ve (LAB_7B01)

	PUSH	AF			; else save count
	LD	A,L			; get remainder low byte
	SUB	C			; add divisor low byte
	LD	L,A			; save remainder low byte
	LD	A,H			; get remainder high byte
	SBC	A,B			; add divisor high byte
	LD	H,A			; save remainder high byte
	POP	AF			; restore count
	DEC	A			; decrement count
	JP	NZ,LAB_DFAD		; loop if not all done (LAB_7AE8)

	RET				;

LAB_7B01				; (LAB_DFC6)
	INC	E			; increment result
	DEC	A			; decrement count
	JP	NZ,LAB_DFAD		; loop if not all done (LAB_7AE8)

	RET				;

; does HL = HL*DE

LAB_7B07				; (LAB_DFCC)
	PUSH	BC			; save BC
	LD	B,H			; copy HL ..
	LD	C,L			; .. to BC
	LD	HL,0000h		; clear product
	LD	A,#10h		; do 16d times
LAB_7B0F				; (LAB_DFD4)
	ADD	HL,HL			; product *2
	EX	DE,HL			; swap opperand to HL
	ADD	HL,HL			; opperand *2
	EX	DE,HL			; swap opperand back to DE
	JP	NC,LAB_DFDC		; if no carry don`t add original product (LAB_7B17)

	ADD	HL,BC			; add original product
LAB_7B17				; (LAB_DFDC)
	DEC	A			; decrement count
	JP	NZ,LAB_DFD4		; loop if not all done (LAB_7B0F)

	POP	BC			; restore BC
	LD	A,L			; get HL low byte
	OR	H			; OR high byte
	RET				;

; does signed HL = DE>>HL (HL=0 to 1Fh)

LAB_7B1F				; (LAB_DFE4)
	EX	DE,HL			; swap count to DE
	LD	A,E			; get count low byte
	AND	#1Fh			; mask 000x xxxx
	LD	E,A			; save it back
	JP	Z,LAB_E00B		; set flags and exit if zero (LAB_7B46)

	LD	A,H			; get # high byte
	OR	H			; set the flags
	JP	P,LAB_E016		; jump if +ve (LAB_7B51)

LAB_7B2C				; (LAB_DFF1)
	LD	A,H			; get high byte
	SCF				; set carry
	RRA				; >> 1
	LD	H,A			; save it back
	LD	A,L			; get low byte
	RRA				; >> 1
	LD	L,A			; save it back
	DEC	E			; decrement count
	JP	NZ,LAB_DFF1		; loop if not all done (LAB_7B2C)
	OR	H			; OR with high byte
	RET				;

; does HL = DE<<HL (HL=0 to 1Fh)

LAB_7B39				; (LAB_DFFE)
	EX	DE,HL			; swap count to DE
	LD	A,E			; get count low byte
	AND	#1Fh			; mask 000x xxxx
	LD	E,A			; save it back
	JP	Z,LAB_E00B		; set flags and exit if zero (LAB_7B46)

LAB_7B41				; (LAB_E006)
	ADD	HL,HL			; << 1
	DEC	E			; decrement count
	JP	NZ,LAB_E006		; loop if not all done (LAB_7B41)

LAB_7B46				; (LAB_E00B)
	LD	A,L			; get low byte
	OR	H			; OR with high byte
	RET				;

; does HL = DE>>HL (HL=0 to 1Fh)

LAB_7B49				; (LAB_E00E)
	EX	DE,HL			; swap count to DE
	LD	A,E			; get count low byte
	AND	#1Fh			; mask 000x xxxx
	LD	E,A			; save it back
	JP	Z,LAB_E00B		; set flags and exit if zero (LAB_7B46)

LAB_7B51				; (LAB_E016)
	LD	A,H			; get high byte
	OR	A			; clear carry
	RRA				; >> 1
	LD	H,A			; save it back
	LD	A,L			; get low byte
	RRA				; >> 1
	LD	L,A			; save it back
	DEC	E			; decrement count
	JP	NZ,LAB_E016		; loop if not all done (LAB_7B51)

	OR	H			; set the flags
	RET				;

; does AND HL,DE. sets Z flag

LAB_7B5E				; (LAB_E023)
	LD	A,H			; copy H
	AND	D			; AND D
	LD	H,A			; save back
	LD	A,L			; copy L
	AND	E			; AND E
	LD	L,A			; save back
	OR	H			; set Z flag
	RET				;

; does CPL HL. sets Z flag

LAB_7B66				; (LAB_E02B)
	LD	A,H			; copy H
	CPL				; complement byte
	LD	H,A			; save back
	LD	A,L			; copy L
	CPL				; complement byte
	LD	L,A			; save back
	OR	H			; set Z flag
	RET				;

; does OR HL,DE. sets Z flag

LAB_7B6E				; (LAB_E033)
	LD	A,H			; copy H
	OR	D			; OR D
	LD	H,A			; save back
	LD	A,L			; copy L
	OR	E			; OR E
	LD	L,A			; save back
	OR	H			; set Z flag
	RET				;

; does XOR HL,DE. sets Z flag

LAB_7B76				; (LAB_E03B)
	LD	A,H			; copy H
	XOR	D			; XOR D
	LD	H,A			; save back
	LD	A,L			; copy L
	XOR	E			; XOR E
	LD	L,A			; save back
	OR	H			; set Z flag
	RET				;

; test HL, return HL=1 & Zb=0 if HL<>0

LAB_7B7E				; (LAB_E043)
	LD	A,L			; get HL low byte
	OR	H			; OR with HL high byte
	JP	Z,LAB_E064		; jump if HL=0 (LAB_7B9F)

	JP	LAB_E055		; else jump (LAB_7B90)

; compare HL with DE, return HL=0 & Zb=1 if different

LAB_7B86				; (LAB_E04B)
	LD	A,L			; get HL low byte
	SUB	E			; subtract DE low byte
	JP	NZ,LAB_E055		; jump if different (LAB_7B90)

	LD	A,H			; get HL high byte
	SUB	D			; subtract DE high byte
	JP	Z,LAB_E064		; jump if the same (LAB_7B9F)

LAB_7B90				; (LAB_E055)
	LD	HL,0000h		; set HL
	XOR	A			; set the flags
	RET				;

; compare HL with DE, return HL=0 & Zb=1 if the same

LAB_7B95				; (LAB_E05A)
	LD	A,L			; get HL low byte
	SUB	E			; subtract DE low byte
	JP	NZ,LAB_E064		; jump if different (LAB_7B9F)

	LD	A,H			; get HL high byte
	SUB	D			; subtract DE high byte
	JP	Z,LAB_E055		; jump if the same (LAB_7B90)

LAB_7B9F				; (LAB_E064)
	LD	HL,0001h		; set HL
	LD	A,L			; get HL low byte
	OR	H			; OR with HL high byte
	RET				;

; does signed CP DE,HL. returns HL=1 if HL<=DE

LAB_7BA5				; (LAB_E06A)
	EX	DE,HL			; swap DE and HL

; does signed CP HL,DE. returns HL=1 if DE<=HL

LAB_7BA6				; (LAB_E06B)
	LD	A,H			; get HL high byte
	XOR	D			; XOR with DE high byte
	JP	M,LAB_E07D		; jump if signs different (LAB_7BB8)

	LD	A,L			; get HL low byte
	SUB	E			; subtract DE low byte (set carry)
	LD	A,H			; get HL high byte
	SBC	A,D			; subtract, with carry, DE high byte (set carry)
	CCF				; invert carry
	LD	A,#00h		; clear A (not flags)
	ADC	A,#00h		; add carry
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	RET				;

LAB_7BB8				; (LAB_E07D)
	LD	A,D			; get DE high byte
	RLCA				; sign bit into bit 0
	AND	#01h			; clear other bits, mask 0000 000x
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	RET				;

; does signed CP DE,HL. returns HL=1 if HL>DE

LAB_7BC0				; (LAB_E085)
	EX	DE,HL			; swap HL to DE

; does signed CP HL,DE. returns HL=1 if DE>HL

LAB_7BC1				; (LAB_E086)
	LD	A,H			; get HL high byte
	XOR	D			; XOR with DE high byte
	JP	M,LAB_E097		; jump if signs are different (LAB_7BD2)

	LD	A,L			; get HL low byte
	SUB	E			; subtract DE low byte (set carry)
	LD	A,H			; get HL high byte
	SBC	A,D			; subtract, with carry, DE high byte (set carry)
	LD	A,#00h		; clear A (not flags)
	ADC	A,#00h		; add carry
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	RET				;

; does SGN HL & RET

LAB_7BD2				; (LAB_E097)
	LD	A,H			; get HL high byte
	RLCA				; sign bit into bit 0
	AND	#01h			; clear other bits, mask 0000 000x
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	RET				;

; does NEG HL & RET

LAB_7BDA				; (LAB_E09F)
	LD	A,L			; copy L
	CPL				; complement it
	LD	L,A			; save L
	LD	A,H			; copy H
	CPL				; complement it
	LD	H,A			; save H
	INC	HL			; +1
	LD	A,L			; get HL low byte
	OR	H			; OR with high byte
	RET				;

; does CP DE,HL. returns Zb=1 if equal

LAB_7BE4				; (LAB_E0A9)
	EX	DE,HL			; swap HL to DE
	LD	A,L			; get HL low byte
	SUB	E			; subtract DE low byte
	LD	L,A			; save back to L
	LD	A,H			; get HL high byte
	SBC	A,D			; subtract, with carry, DE high byte
	LD	H,A			; save back to H
	OR	L			; set the flags
	RET				;

; search following table for HL & execute vector

LAB_7BED				; (LAB_E0B2)
	EX	DE,HL			; swap compare word to DE
	POP	HL			; pop return address
	PUSH	BC			; save BC
	LD	B,D			; copy compare word high byte
	LD	C,E			; copy compare word low byte
	LD	E,(HL)		; get count low byte after call
	INC	HL			; increment pointer
	LD	D,(HL)		; get count high byte after call
LAB_7BF5				; (LAB_E0BA)
	DEC	DE			; decrement count
	LD	A,D			; copy high byte
	OR	A			; set the flags
	JP	M,LAB_E0D2		; exit if count -ve (LAB_7C0D)

	INC	HL			; point to next byte
	LD	A,C			; get compare word low byte
	CP	(HL)			; compare with table
	JP	Z,LAB_E0CC		; if = go do high byte (LAB_7C07)

	INC	HL			; else skip next byte
LAB_7C02				; (LAB_E0C7)
	INC	HL			; skip vector low byte
	INC	HL			; skip vector high byte
	JP	LAB_E0BA		; go do next (LAB_7BF5)

LAB_7C07				; (LAB_E0CC)
	INC	HL			; point to next byte
	LD	A,B			; get compare word high byte
	CP	(HL)			; compare with table
	JP	NZ,LAB_E0C7		; go do next if <> (LAB_7C02)

LAB_7C0D				; (LAB_E0D2)
	INC	HL			; point to vector
	LD	A,(HL)		; get return address low byte
	INC	HL			; increment pointer
	LD	H,(HL)		; get return address high byte
	LD	L,A			; copy to L
	POP	BC			; restore BC
	JP	(HL)			; return

; does CP DE,HL, returns HL=1 if HL<=DE

LAB_7C14				; (LAB_E0D9)
	EX	DE,HL			; swap DE to HL

; does CP HL,DE, returns HL=1 if DE<=HL

LAB_7C15				; (LAB_E0DA)
	LD	A,L			; get HL low byte
	SUB	E			; subtract DE low byte (set carry)
	LD	A,H			; get HL high byte
	SBC	A,D			; subtract,with carry, DE high byte (set carry)
	LD	A,#00h		; clear A (not flags)
	CCF				; invert carry flag
	ADC	A,#00h		; add carry
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	RET				;

; does CP DE,HL, returns HL=0 & Zb=1 if no carry (HL<=DE)

LAB_7C22				; (LAB_E0E7)
	EX	DE,HL			; swap DE to HL

; does CP HL,DE, returns HL=0 if DE<=HL

LAB_7C23				; (LAB_E0E8)
	LD	A,L			; get HL low byte
	SUB	E			; subtract DE low byte (set carry)
	LD	A,H			; get HL high byte
	SBC	A,D			; subtract,with carry, DE high byte (set carry)
	LD	A,#00h		; clear A (not flags)
	ADC	A,#00h		; add carry
	LD	L,A			; copy to L
	LD	H,#00h		; clear high byte
	RET				;

; end of block copied to LAB_D893 - LAB_E0F3

LAB_7C2F				; (LAB_E104)
	NOP			;7C2F:	00
	JR	NZ,LAB_7C52	;7C30:	2020
	JR	NZ,LAB_7C54	;7C32:	2020
	JR	NZ,LAB_7C56	;7C34:	2020
	JR	NZ,LAB_7C58	;7C36:	2020
	DB	20
LAB_7C39				; (LAB_E10E)
	DB	30
	JR	NC,LAB_7C6C	;7C3A:	3030
	JR	NC,LAB_7C6E	;7C3C:	3030
	JR	NZ,LAB_7C60	;7C3E:	2020
	JR	NZ,LAB_7C62	;7C40:	2020
	JR	NZ,LAB_7C64	;7C42:	2020
	JR	NZ,LAB_7C66	;7C44:	2020
	JR	NZ,LAB_7C68	;7C46:	2020
	JR	NZ,LAB_7C6A	;7C48:	2020
	JR	NZ,LAB_7C6C	;7C4A:	2020
	JR	NZ,LAB_7C6E	;7C4C:	2020
	JR	NZ,LAB_7C70	;7C4E:	2020
	SUB	B		;7C50:	90
	LD	B,B		;7C51:	40
LAB_7C52
	LD	B,B		;7C52:	40
	LD	B,B		;7C53:	40
LAB_7C54
	LD	B,B		;7C54:	40
	LD	B,B		;7C55:	40
LAB_7C56
	LD	B,B		;7C56:	40
	LD	B,B		;7C57:	40
LAB_7C58
	LD	B,B		;7C58:	40
	LD	B,B		;7C59:	40
	LD	B,B		;7C5A:	40
	LD	B,B		;7C5B:	40
	LD	B,B		;7C5C:	40
	LD	B,B		;7C5D:	40
	LD	B,B		;7C5E:	40
	LD	B,B		;7C5F:	40
LAB_7C60
	INC	C		;7C60:	0C
	INC	C		;7C61:	0C
LAB_7C62
	INC	C		;7C62:	0C
	INC	C		;7C63:	0C
LAB_7C64
	INC	C		;7C64:	0C
	INC	C		;7C65:	0C
LAB_7C66
	INC	C		;7C66:	0C
	INC	C		;7C67:	0C
LAB_7C68
	INC	C		;7C68:	0C
	INC	C		;7C69:	0C
LAB_7C6A
	LD	B,B		;7C6A:	40
	LD	B,B		;7C6B:	40
LAB_7C6C
	LD	B,B		;7C6C:	40
	LD	B,B		;7C6D:	40
LAB_7C6E
	LD	B,B		;7C6E:	40
	LD	B,B		;7C6F:	40
LAB_7C70
	LD	B,B		;7C70:	40
	ADD	HL,BC		;7C71:	09
	ADD	HL,BC		;7C72:	09
	ADD	HL,BC		;7C73:	09
	ADD	HL,BC		;7C74:	09
	ADD	HL,BC		;7C75:	09
	ADD	HL,BC		;7C76:	09
	LD	BC,0101h	;7C77:	010101
	LD	BC,0101h	;7C7A:	010101
	LD	BC,0101h	;7C7D:	010101
	LD	BC,0101h	;7C80:	010101
	LD	BC,0101h	;7C83:	010101
	LD	BC,0101h	;7C86:	010101
	LD	BC,4001h	;7C89:	010140
	LD	B,B		;7C8C:	40
	LD	B,B		;7C8D:	40
	LD	B,B		;7C8E:	40
	LD	B,B		;7C8F:	40
	LD	B,B		;7C90:	40
	LD	A,(BC)		;7C91:	0A
	LD	A,(BC)		;7C92:	0A
	LD	A,(BC)		;7C93:	0A
	LD	A,(BC)		;7C94:	0A
	LD	A,(BC)		;7C95:	0A
	LD	A,(BC)		;7C96:	0A
	LD	(BC),A		;7C97:	02
	LD	(BC),A		;7C98:	02
	LD	(BC),A		;7C99:	02
	LD	(BC),A		;7C9A:	02
	LD	(BC),A		;7C9B:	02
	LD	(BC),A		;7C9C:	02
	LD	(BC),A		;7C9D:	02
	LD	(BC),A		;7C9E:	02
	LD	(BC),A		;7C9F:	02
	LD	(BC),A		;7CA0:	02
	LD	(BC),A		;7CA1:	02
	LD	(BC),A		;7CA2:	02
	LD	(BC),A		;7CA3:	02
	LD	(BC),A		;7CA4:	02
	LD	(BC),A		;7CA5:	02
	LD	(BC),A		;7CA6:	02
	LD	(BC),A		;7CA7:	02
	LD	(BC),A		;7CA8:	02
	LD	(BC),A		;7CA9:	02
	LD	(BC),A		;7CAA:	02
	LD	B,B		;7CAB:	40
	LD	B,B		;7CAC:	40
	LD	B,B		;7CAD:	40
	LD	B,B		;7CAE:	40
	JR	NZ,LAB_7CB2	;7CAF:	2001
	LD	(BC),A		;7CB1:	02
LAB_7CB2
	LD	(BC),A		;7CB2:	02
	INC	BC		;7CB3:	03
	LD	(BC),A		;7CB4:	02
	INC	BC		;7CB5:	03
	LD	(BC),A		;7CB6:	02
	LD	(BC),A		;7CB7:	02
	INC	BC		;7CB8:	03
	INC	BC		;7CB9:	03
	INC	BC		;7CBA:	03
	INC	BC		;7CBB:	03
	INC	BC		;7CBC:	03
	INC	BC		;7CBD:	03
	LD	BC,0101h	;7CBE:	010101
	LD	(BC),A		;7CC1:	02
	LD	BC,0203h	;7CC2:	010302
	INC	BC		;7CC5:	03
	INC	BC		;7CC6:	03
	INC	BC		;7CC7:	03
	INC	BC		;7CC8:	03
	LD	BC,4001h	;7CC9:	010140
	LD	B,B		;7CCC:	40
	LD	B,B		;7CCD:	40
	LD	B,B		;7CCE:	40
	LD	B,B		;7CCF:	40
	INC	BC		;7CD0:	03
	INC	BC		;7CD1:	03
	INC	BC		;7CD2:	03
	INC	BC		;7CD3:	03
	LD	(BC),A		;7CD4:	02
	LD	BC,0303h	;7CD5:	010303
	LD	B,B		;7CD8:	40
	LD	B,B		;7CD9:	40
	LD	B,B		;7CDA:	40
	LD	B,B		;7CDB:	40
	LD	B,B		;7CDC:	40
	LD	B,B		;7CDD:	40
	LD	B,B		;7CDE:	40
	LD	B,B		;7CDF:	40
LAB_7CE0
	DB	00h,00h,00h,00h,00h,00h,00h,00h
	DB	00h,00h,00h,00h,00h,00h,00h,00h
	DB	00h,00h,00h,00h,00h,00h,00h,00h
	DB	00h,00h,00h,00h,00h,00h,00h,00h
	DB	00h,00h,00h,00h,00h,00h,00h,00h
	DB	00h,00h,00h,00h,00h,00h,00h,00h

	LD	(BC),A		;7D10:	02
	INC	BC		;7D11:	03
	LD	BC,0102h	;7D12:	010201
	LD	(BC),A		;7D15:	02
	LD	(BC),A		;7D16:	02
	LD	(BC),A		;7D17:	02
	LD	BC,0102h	;7D18:	010201
	LD	BC,0300h	;7D1B:	010003
	NOP			;7D1E:	00
	NOP			;7D1F:	00

LAB_7D20
	DB	00h,00h,00h,00h,00h,00h,00h,00h
	DB	00h,00h,00h,00h,00h,00h,00h,00h

	ADD	A,A		;7D30:	87
	SBC	A,D		;7D31:	9A
	SUB	B		;7D32:	90
	ADD	A,E		;7D33:	83
	ADC	A,(HL)		;7D34:	8E
	ADD	A,L		;7D35:	85
	ADC	A,A		;7D36:	8F
	ADD	A,B		;7D37:	80
	ADC	A,B		;7D38:	88
	ADC	A,C		;7D39:	89
	ADC	A,D		;7D3A:	8A
	ADC	A,E		;7D3B:	8B
	ADC	A,H		;7D3C:	8C
	ADC	A,L		;7D3D:	8D
	ADD	A,H		;7D3E:	84
	ADD	A,(HL)		;7D3F:	86
	ADD	A,D		;7D40:	82
	SUB	D		;7D41:	92
	SUB	C		;7D42:	91
	SUB	E		;7D43:	93
	SBC	A,C		;7D44:	99
	SUB	L		;7D45:	95
	SUB	(HL)		;7D46:	96
	SUB	A		;7D47:	97
	SBC	A,B		;7D48:	98
	SUB	H		;7D49:	94
	ADD	A,C		;7D4A:	81
	NOP			;7D4B:	00
	NOP			;7D4C:	00
	NOP			;7D4D:	00
	NOP			;7D4E:	00
	NOP			;7D4F:	00
	AND	B		;7D50:	A0
	AND	C		;7D51:	A1
	AND	D		;7D52:	A2
	AND	E		;7D53:	A3
	AND	L		;7D54:	A5
	AND	H		;7D55:	A4
	AND	(HL)		;7D56:	A6
	AND	A		;7D57:	A7

LAB_7D58
	DW	0001h			; copy block

	DW	LAB_7242		; source pointer
	DW	LAB_E0F4		; destination pointer
	DW	0010h			; length

	DW	0000h			; zero block

	DW	LAB_E36F		; pointer
	DW	0052h			; length

	DW	0001h			; copy block

	DW	LAB_7301		; source pointer
	DW	LAB_E22D		; destination pointer
	DW	00CDh			; length

	DW	0000h			; zero block

	DW	LAB_E3C1		; pointer
	DW	0344h			; length

	DW	0001h			; copy block

	DW	LAB_73CE		; source pointer
	DW	LAB_D893		; destination pointer
	DW	0861h			; length

	DW	0001h			; copy block

	DW	LAB_7C2F		; source pointer
	DW	LAB_E104		; destination pointer
	DW	0129h			; length

	DW	0002h			; make table

	DW	0086h			; word count

; this table is constructed at LAB_ED1C onward

	DW	LAB_3BAA		; copies block to RAM then executes it		[LAB_ED1C]
					; block 7030h-7241h to D681h-D892h 
	DW	LAB_62C7		; *								[LAB_ED20]
	DW	LAB_63CA		; *
	DW	LAB_5BA6		; *
	DW	LAB_5DFD		; *
	DW	LAB_6120		; set HL = 0000h						[LAB_ED30]
	DW	LAB_620B		; *
	DW	LAB_5BF7		; *
	DW	LAB_5CD7		; *
	DW	LAB_60CC		; *								[LAB_ED40]
	DW	LAB_60D6		; *
	DW	LAB_6181		; *
	DW	LAB_61CC		; *
	DW	LAB_593A		; *								[LAB_ED50]
	DW	LAB_421C		; print message @ line, with bells on
	DW	LAB_573D		; *
	DW	LAB_56E7		; *
	DW	LAB_3CA3		; fill count bytes, from destination, with 00h	[LAB_ED60]
	DW	LAB_400A		; message out to ??, continues until null		[LAB_ED64]
	DW	LAB_4199		; output +(LAB_E6CD)d at 10h,(LAB_E6CF)
	DW	LAB_54E5		; clears byte @ LAB_E519				[LAB_ED6C]
	DW	LAB_4333		; clear b(LAB_E22D), w(LAB_E6C0) & w(LAB_E6E2)	[LAB_ED70]
	DW	LAB_64A6		; wait for elapsed seconds				[LAB_ED74]
	DW	LAB_3D11		; *
	DW	LAB_3D3C		; *
	DW	LAB_3E6A		; *								[LAB_ED80]
	DW	LAB_3DCB		; *
	DW	LAB_3F20		; *
	DW	LAB_3BE8		; get (byte) HL from (LAB_E22D)			[LAB_ED8C]
	DW	LAB_3D04		; fill buffer ?? @ LAB_E3C6 & clear LAB_E446, LAB_E448,
					; LAB_E44A, byte @ LAB_E519 & set HL = 0000h	[LAB_ED90]
	DW	LAB_3CF7		; *
	DW	LAB_403B		; construct null terminated decimal string at destination
					;								[LAB_ED98]
	DW	LAB_41D9		; print message @ line
	DW	LAB_578F		; *								[LAB_EDA0]
	DW	LAB_6431		; get RTC seconds to (LAB_E69A)			[LAB_EDA4]
	DW	LAB_4138		; build decimal string and output			[LAB_EDA8]
	DW	LAB_42EE		; wait (LAB_E6FD) seconds or do press to cont	[LAB_EDAC]
	DW	LAB_3E14		; *								[LAB_EDB0]
	DW	LAB_3D9B		; *
	DW	LAB_3EDE		; *
	DW	LAB_5542		; *
	DW	LAB_4351		; do error (number)d,"(",(LAB_E701)d,"/",(LAB_E6FF)d,")"
					;								[LAB_EDC0]
	DW	LAB_583E		; set HL = 0000h
	DW	LAB_5915		; *
	DW	LAB_58B8		; *
	DW	LAB_4269		; *								[LAB_EDD0]
	DW	LAB_5669		; *
	DW	LAB_56A4		; *
	DW	LAB_4296		; print 4 line message ??				[LAB_EDDC]
	DW	LAB_582A		; *								[LAB_EDE0]
	DW	LAB_3C06		; *
	DW	LAB_3BF5		; save (byte) at (LAB_E22D)				[LAB_EDE8]
	DW	LAB_6443		; return HL=1 if elapsed seconds since clock read
					;								[LAB_EDEC]
	DW	LAB_5834		; *								[LAB_EDF0]
	DW	LAB_58F9		; *
	DW	LAB_5848		; *
	DW	LAB_5880		; *
	DW	LAB_5469		; *								[LAB_EE00]
	DW	LAB_48BF		; *
	DW	LAB_5034		; send data ??
	DW	LAB_4AE0		; *
	DW	LAB_47F6		; *								[LAB_EE10]
	DW	LAB_4A25		; *
	DW	LAB_5179		; *
	DW	LAB_52A5		; *
	DW	LAB_4563		; *								[LAB_EE20]
	DW	LAB_46E9		; *
	DW	LAB_4974		; *
	DW	LAB_4F5A		; receive program ??
	DW	LAB_4D29		; do C-RX-CMD not available message			[LAB_EE30]
	DW	LAB_4E6D		; *
	DW	LAB_5444		; *
	DW	LAB_4D75		; *
	DW	LAB_51EC		; send program ??						[LAB_EE40]
	DW	LAB_50ED		; *
	DW	LAB_4D4F		; do C-TX-REPLY not available message		[LAB_EE48]
	DW	LAB_5428		; *
	DW	LAB_64C2		; set HL=0001h, OR A with 01h				[LAB_EE50]
	DW	LAB_64C2		; set HL=0001h, OR A with 01h
	DW	LAB_64C2		; set HL=0001h, OR A with 01h
	DW	LAB_64C2		; set HL=0001h, OR A with 01h
	DW	LAB_64C2		; set HL=0001h, OR A with 01h				[LAB_EE60]
	DW	LAB_64C2		; set HL=0001h, OR A with 01h
	DW	LAB_64C2		; set HL=0001h, OR A with 01h
	DW	LAB_64C2		; set HL=0001h, OR A with 01h
	DW	LAB_64C2		; set HL=0001h, OR A with 01h				[LAB_EE70]
	DW	LAB_64C2		; set HL=0001h, OR A with 01h
	DW	LAB_64C2		; set HL=0001h, OR A with 01h
	DW	LAB_64C2		; set HL=0001h, OR A with 01h
	DW	LAB_64C2		; set HL=0001h, OR A with 01h				[LAB_EE80]
	DW	LAB_64C2		; set HL=0001h, OR A with 01h
	DW	LAB_64C2		; set HL=0001h, OR A with 01h
	DW	LAB_64C2		; set HL=0001h, OR A with 01h
	DW	LAB_64C2		; set HL=0001h, OR A with 01h				[LAB_EE90]
	DW	LAB_64C7		; setup table @ pointer, in EExx			[LAB_EE94]
	DW	LAB_64C2		; set HL=0001h, OR A with 01h
	DW	LAB_64C2		; set HL=0001h, OR A with 01h
	DW	LAB_64C2		; set HL=0001h, OR A with 01h				[LAB_EEA0]
	DW	LAB_64C2		; set HL=0001h, OR A with 01h
	DW	LAB_64C2		; set HL=0001h, OR A with 01h
	DW	LAB_64C2		; set HL=0001h, OR A with 01h
	DW	LAB_64C2		; set HL=0001h, OR A with 01h				[LAB_EEB0]
	DW	LAB_64C2		; set HL=0001h, OR A with 01h
	DW	LAB_64C2		; set HL=0001h, OR A with 01h
	DW	LAB_64C2		; set HL=0001h, OR A with 01h
	DW	LAB_64C2		; set HL=0001h, OR A with 01h				[LAB_EEC0]
	DW	LAB_64C2		; set HL=0001h, OR A with 01h
	DW	LAB_64C2		; set HL=0001h, OR A with 01h
	DW	LAB_64C2		; set HL=0001h, OR A with 01h
	DW	LAB_64C2		; set HL=0001h, OR A with 01h				[LAB_EED0]
	DW	LAB_64C2		; set HL=0001h, OR A with 01h
	DW	LAB_68FD		; quit program						[LAB_EED8]
	DW	LAB_66E4		; *
	DW	LAB_654E		; copy (byte) last into LAB_E6AB and last but 1 into
					; LAB_E6AC							[LAB_EEE0]
	DW	LAB_66A2		; wait for key, no echo ??				[LAB_EEE4]
	DW	LAB_65C2		; get byte from key buffer ??				[LAB_EEE8]
	DW	LAB_6526		; setup LAB_E69D & LAB_E6A9 to LAB_E6AD		[LAB_EEEC]
	DW	LAB_6772		; set cursor on/off					[LAB_EEF0]
	DW	LAB_66BC		; save byte in ?? buffer
	DW	LAB_666B		; get key status without waiting			[LAB_EEF8]
	DW	LAB_606C		; *
	DW	LAB_5F58		; *								[LAB_EF00]
	DW	LAB_60C2		; *
	DW	LAB_6870		; get RTC date, month & year to bytes starting at
					; pointer							[LAB_EF08]
	DW	LAB_67DE		; save RTC hour/minute word at pointer		[LAB_EF0C]
	DW	LAB_6799		; set HL = 0001h						[LAB_EF10]
	DW	LAB_6785		; do BDOS function 2Dh					[LAB_EF14]
	DW	LAB_68E0		; set LAB_E2F8 depending on flag
	DW	LAB_6811		; set RTC date, month & year				[LAB_EF1C]
	DW	LAB_67A3		; set RTC hours & minutes				[LAB_EF20]
	DW	LAB_68C7		; do BIOS function 19					[LAB_EF24]
	DW	LAB_6915		; null routine						[LAB_EF28]
	DW	LAB_691C		; null routine
	DW	LAB_6923		; null routine						[LAB_EF30]

	DW	FFFFh			; exit

	NOP				;7E96:	00
	NOP				;7E97:	00
LAB_7E98
	DB	00h,00h,00h,00h,00h,00h,00h,00h
	DB	00h,00h,00h,00h,00h,00h,00h,00h
	DB	00h,00h,00h,00h,00h,00h,00h,00h
	DB	00h,00h,00h,00h,00h,00h,00h,00h
	DB	00h,00h,00h,00h,00h,00h,00h,00h
	DB	00h,00h,00h,00h,00h,00h,00h,00h
	DB	00h,00h,00h,00h,00h,00h,00h,00h
	DB	00h,00h,00h,00h,00h,00h,00h,00h
	DB	00h,00h,00h,00h,00h,00h,00h,00h
	DB	00h,00h,00h,00h,00h,00h,00h,00h
	DB	00h,00h,00h,00h,00h,00h,00h,00h
	DB	00h,00h,00h,00h,00h,00h,00h,00h
	DB	00h,00h,00h,00h,00h,00h,00h,00h
	DB	00h,00h,00h,00h,00h,00h,00h,00h
	DB	00h,00h,00h,00h,00h,00h,00h,00h
	DB	00h,00h,00h,00h,00h,00h,00h,00h
	DB	00h,00h,00h,00h,00h,00h,00h,00h
	DB	00h,00h,00h,00h,00h,00h,00h,00h
	DB	00h,00h,00h,00h,00h,00h,00h,00h
	DB	00h,00h,00h,00h,00h,00h,00h,00h
	DB	00h,00h,00h,00h,00h,00h,00h,00h
	DB	00h,00h,00h,00h,00h,00h,00h,00h
	DB	00h,00h,00h,00h,00h,00h,00h,00h
	DB	00h,00h,00h,00h,00h,00h,00h,00h
	DB	00h,00h,00h,00h,00h,00h,00h,00h
	DB	00h,00h,00h,00h,00h,00h,00h,00h
	DB	00h,00h,00h,00h,00h,00h,00h,00h
	DB	00h,00h,00h,00h,00h,00h,00h,00h
	DB	00h,00h,00h,00h,00h,00h,00h,00h
	DB	00h,00h,00h,00h,00h,00h,00h,00h
	DB	00h,00h,00h,00h,00h,00h,00h,00h
	DB	00h,00h,00h,00h,00h,00h,00h,00h
	DB	00h,00h,00h,00h,00h,00h,00h,00h
	DB	00h,00h,00h,00h,00h,00h,00h,00h
	DB	00h,00h,00h,00h,00h,00h,00h,00h
	DB	00h,00h,00h,00h,00h,00h,00h,00h
	DB	00h,00h,00h,00h,00h,00h,00h,00h
	DB	00h,00h,00h,00h,00h,00h,00h,00h
	DB	00h,00h,00h,00h,00h,00h,00h,00h
	DB	00h,00h,00h,00h,00h,00h,00h,00h
	DB	00h,00h,00h,00h,00h,00h,00h,00h
	DB	00h,00h,00h,00h,00h,00h,00h,00h
	DB	00h,00h,00h,00h,00h,00h,00h,00h
	DB	00h,00h,00h,00h,00h,00h,00h,00h
	NOP			;7FF8:	00
	NOP			;7FF9:	00
	RLCA			;7FFA:	07
	LD	D,E		;7FFB:	53
LAB_7FFC
	DW	LAB_7D58
	DW	ACF8h		; checksum

LAB_00CD	EQU	00CDh
LAB_0658	EQU	0658h
LAB_0B6A	EQU	0B6Ah
LAB_10E0	EQU	10E0h
LAB_13D6	EQU	13D6h
LAB_202A	EQU	202Ah
LAB_2665	EQU	2665h
LAB_3A61	EQU	3A61h
LAB_4E66	EQU	4E66h
LAB_A663	EQU	A663h
LAB_C264	EQU	C264h
LAB_C764	EQU	C764h
LAB_D660	EQU	D660h
LAB_D682	EQU	D682h
LAB_D684	EQU	D684h
LAB_D686	EQU	D686h
LAB_D6DE	EQU	D6DEh
LAB_D70F	EQU	D70Fh
LAB_D733	EQU	D733h
LAB_D74B	EQU	D74Bh
LAB_D79D	EQU	D79Dh
LAB_D79E	EQU	D79Eh
LAB_D7A0	EQU	D7A0h
LAB_D7E2	EQU	D7E2h
LAB_D7E7	EQU	D7E7h
LAB_D7FE	EQU	D7FEh
LAB_D818	EQU	D818h
LAB_D833	EQU	D833h
LAB_D834	EQU	D834h
LAB_D87E	EQU	D87Eh
LAB_D893	EQU	D893h
LAB_D90A	EQU	D90Ah
LAB_D92E	EQU	D92Eh
LAB_D973	EQU	D973h
LAB_D997	EQU	D997h
LAB_D9B0	EQU	D9B0h
LAB_D9C7	EQU	D9C7h
LAB_D9D1	EQU	D9D1h
LAB_D9DD	EQU	D9DDh
LAB_D9ED	EQU	D9EDh
LAB_D9F7	EQU	D9F7h
LAB_DA13	EQU	DA13h
LAB_DA16	EQU	DA16h
LAB_DA34	EQU	DA34h
LAB_DA5F	EQU	DA5Fh
LAB_DA68	EQU	DA68h
LAB_DA75	EQU	DA75h
LAB_DA80	EQU	DA80h
LAB_DA87	EQU	DA87h
LAB_DA9D	EQU	DA9Dh
LAB_DAA7	EQU	DAA7h
LAB_DAAA	EQU	DAAAh
LAB_DAC6	EQU	DAC6h
LAB_DAD2	EQU	DAD2h
LAB_DAD5	EQU	DAD5h
LAB_DAD8	EQU	DAD8h
LAB_DAD9	EQU	DAD9h
LAB_DAF0	EQU	DAF0h
LAB_DAFA	EQU	DAFAh
LAB_DB09	EQU	DB09h
LAB_DB33	EQU	DB33h
LAB_DB49	EQU	DB49h
LAB_DB52	EQU	DB52h
LAB_DB67	EQU	DB67h
LAB_DB7A	EQU	DB7Ah
LAB_DB85	EQU	DB85h
LAB_DB9B	EQU	DB9Bh
LAB_DBA7	EQU	DBA7h
LAB_DBAC	EQU	DBACh
LAB_DBC5	EQU	DBC5h
LAB_DBCF	EQU	DBCFh
LAB_DBD7	EQU	DBD7h
LAB_DBE8	EQU	DBE8h
LAB_DBFA	EQU	DBFAh
LAB_DC03	EQU	DC03h
LAB_DC16	EQU	DC16h
LAB_DC21	EQU	DC21h
LAB_DC3A	EQU	DC3Ah
LAB_DCA6	EQU	DCA6h
LAB_DCB3	EQU	DCB3h
LAB_DCB7	EQU	DCB7h
LAB_DCD8	EQU	DCD8h
LAB_DCDA	EQU	DCDAh
LAB_DCF3	EQU	DCF3h
LAB_DD1C	EQU	DD1Ch
LAB_DD30	EQU	DD30h
LAB_DD44	EQU	DD44h
LAB_DD54	EQU	DD54h
LAB_DD6A	EQU	DD6Ah
LAB_DD72	EQU	DD72h
LAB_DD85	EQU	DD85h
LAB_DD8F	EQU	DD8Fh
LAB_DD96	EQU	DD96h
LAB_DDA2	EQU	DDA2h
LAB_DDA4	EQU	DDA4h
LAB_DDE6	EQU	DDE6h
LAB_DE06	EQU	DE06h
LAB_DE10	EQU	DE10h
LAB_DE16	EQU	DE16h
LAB_DE1E	EQU	DE1Eh
LAB_DE25	EQU	DE25h
LAB_DE3A	EQU	DE3Ah
LAB_DE49	EQU	DE49h
LAB_DE53	EQU	DE53h
LAB_DE5F	EQU	DE5Fh
LAB_DE6A	EQU	DE6Ah
LAB_DE72	EQU	DE72h
LAB_DE84	EQU	DE84h
LAB_DE8D	EQU	DE8Dh
LAB_DEA0	EQU	DEA0h
LAB_DEAC	EQU	DEACh
LAB_DEB3	EQU	DEB3h
LAB_DEC7	EQU	DEC7h
LAB_DED0	EQU	DED0h
LAB_DF45	EQU	DF45h
LAB_DF6D	EQU	DF6Dh
LAB_DF8C	EQU	DF8Ch
LAB_DFA4	EQU	DFA4h
LAB_DFAD	EQU	DFADh
LAB_DFB5	EQU	DFB5h
LAB_DFC6	EQU	DFC6h
LAB_DFD4	EQU	DFD4h
LAB_DFDC	EQU	DFDCh
LAB_DFE4	EQU	DFE4h
LAB_DFF1	EQU	DFF1h
LAB_E006	EQU	E006h
LAB_E00B	EQU	E00Bh
LAB_E016	EQU	E016h
LAB_E033	EQU	E033h
LAB_E055	EQU	E055h
LAB_E064	EQU	E064h
LAB_E06A	EQU	E06Ah
LAB_E0BA	EQU	E0BAh
LAB_E0D2	EQU	E0D2h
LAB_E0FE	EQU	E0FEh

LAB_ED51	EQU	ED51h

	END

